// python wrapper for vtkComputeMoments
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkComputeMoments.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkComputeMoments(PyObject *dict); }
extern "C" { PyObject *PyvtkComputeMoments_ClassNew(); }


static PyObject *
PyvtkComputeMoments_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkComputeMoments::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkComputeMoments::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkComputeMoments *tempr = vtkComputeMoments::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkComputeMoments *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkComputeMoments::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkComputeMoments::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkComputeMoments::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetFieldData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFieldData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  vtkDataObject *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->SetFieldData(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetFieldData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetFieldConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFieldConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  vtkAlgorithmOutput *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetFieldConnection(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetFieldConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetGridData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGridData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  vtkDataObject *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->SetGridData(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetGridData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetGridConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGridConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  vtkAlgorithmOutput *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetGridConnection(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetGridConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOrder(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetOrder(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOrder() :
      op->vtkComputeMoments::GetOrder());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetNumberOfIntegrationSteps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfIntegrationSteps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfIntegrationSteps(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetNumberOfIntegrationSteps(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetNumberOfIntegrationSteps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfIntegrationSteps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfIntegrationSteps() :
      op->vtkComputeMoments::GetNumberOfIntegrationSteps());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetNumberOfBasisFunctions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfBasisFunctions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfBasisFunctions() :
      op->vtkComputeMoments::GetNumberOfBasisFunctions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetNumberOfDifferentBasisFunctions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfDifferentBasisFunctions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfDifferentBasisFunctions() :
      op->vtkComputeMoments::GetNumberOfDifferentBasisFunctions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetNameOfPointData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNameOfPointData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNameOfPointData(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetNameOfPointData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetNameOfPointData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNameOfPointData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNameOfPointData() :
      op->vtkComputeMoments::GetNameOfPointData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetUseFFT(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseFFT");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseFFT(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetUseFFT(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetUseFFT(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseFFT");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseFFT() :
      op->vtkComputeMoments::GetUseFFT());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetUseGPU(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseGPU");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseGPU(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetUseGPU(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetUseGPU(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseGPU");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseGPU() :
      op->vtkComputeMoments::GetUseGPU());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetUseOriginalResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseOriginalResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseOriginalResolution(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetUseOriginalResolution(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetUseOriginalResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseOriginalResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseOriginalResolution() :
      op->vtkComputeMoments::GetUseOriginalResolution());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetCoarseningFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCoarseningFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCoarseningFactor(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetCoarseningFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetCoarseningFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCoarseningFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCoarseningFactor() :
      op->vtkComputeMoments::GetCoarseningFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetRadii(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRadii");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  std::vector<double> temp0(ap.GetArgSize(0));
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0.data(), temp0.size()))
  {
    if (ap.IsBound())
    {
      op->SetRadii(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetRadii(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetRadii(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRadii");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::vector<double> tempr = (ap.IsBound() ?
      op->GetRadii() :
      op->vtkComputeMoments::GetRadii());

    if (!ap.ErrorOccurred())
    {
      if (tempr.empty())
      {
        result = PyTuple_New(0);
      }
      else
      {
        result = vtkPythonArgs::BuildTuple(tempr.data(), tempr.size());
      }
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRadius(temp0) :
      op->vtkComputeMoments::GetRadius(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetRadiiArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRadiiArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  const size_t size0 = 10;
  double temp0[10];
  double save0[10];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetRadiiArray(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetRadiiArray(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetRadiiArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRadiiArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  const size_t size0 = 10;
  double temp0[10];
  double save0[10];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetRadiiArray(temp0);
    }
    else
    {
      op->vtkComputeMoments::GetRadiiArray(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetRelativeRadii(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRelativeRadii");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  std::vector<double> temp0(ap.GetArgSize(0));
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0.data(), temp0.size()))
  {
    if (ap.IsBound())
    {
      op->SetRelativeRadii(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetRelativeRadii(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetRelativeRadii(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRelativeRadii");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::vector<double> tempr = (ap.IsBound() ?
      op->GetRelativeRadii() :
      op->vtkComputeMoments::GetRelativeRadii());

    if (!ap.ErrorOccurred())
    {
      if (tempr.empty())
      {
        result = PyTuple_New(0);
      }
      else
      {
        result = vtkPythonArgs::BuildTuple(tempr.data(), tempr.size());
      }
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetRelativeRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRelativeRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRelativeRadius(temp0) :
      op->vtkComputeMoments::GetRelativeRadius(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_SetRelativeRadiiArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRelativeRadiiArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  const size_t size0 = 10;
  double temp0[10];
  double save0[10];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetRelativeRadiiArray(temp0);
    }
    else
    {
      op->vtkComputeMoments::SetRelativeRadiiArray(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetRelativeRadiiArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRelativeRadiiArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  const size_t size0 = 10;
  double temp0[10];
  double save0[10];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetRelativeRadiiArray(temp0);
    }
    else
    {
      op->vtkComputeMoments::GetRelativeRadiiArray(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetNumberOfRadii(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfRadii");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfRadii() :
      op->vtkComputeMoments::GetNumberOfRadii());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_GetStringRadii(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStringRadii");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetStringRadii(temp0) :
      op->vtkComputeMoments::GetStringRadii(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkComputeMoments_normalizeMomentsImageData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "normalizeMomentsImageData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkComputeMoments *op = static_cast<vtkComputeMoments *>(vp);

  int temp0;
  vtkImageData *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkImageData"))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->normalizeMomentsImageData(temp0, temp1) :
      op->vtkComputeMoments::normalizeMomentsImageData(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkComputeMoments_Methods[] = {
  {"IsTypeOf", PyvtkComputeMoments_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkComputeMoments_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkComputeMoments_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkComputeMoments\nC++: static vtkComputeMoments *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkComputeMoments_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkComputeMoments\nC++: vtkComputeMoments *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkComputeMoments_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkComputeMoments_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetFieldData", PyvtkComputeMoments_SetFieldData, METH_VARARGS,
   "SetFieldData(self, input:vtkDataObject) -> None\nC++: void SetFieldData(vtkDataObject *input)\n\nSet the field of which the moments are calculated.\n"},
  {"SetFieldConnection", PyvtkComputeMoments_SetFieldConnection, METH_VARARGS,
   "SetFieldConnection(self, algOutput:vtkAlgorithmOutput) -> None\nC++: void SetFieldConnection(vtkAlgorithmOutput *algOutput)\n\nSet the field of which the moments are calculated.\n"},
  {"SetGridData", PyvtkComputeMoments_SetGridData, METH_VARARGS,
   "SetGridData(self, input:vtkDataObject) -> None\nC++: void SetGridData(vtkDataObject *input)\n\nSet the locations at which the moments are calculated.\n"},
  {"SetGridConnection", PyvtkComputeMoments_SetGridConnection, METH_VARARGS,
   "SetGridConnection(self, algOutput:vtkAlgorithmOutput) -> None\nC++: void SetGridConnection(vtkAlgorithmOutput *algOutput)\n\nSet the locations at which the moments are calculated.\n"},
  {"SetOrder", PyvtkComputeMoments_SetOrder, METH_VARARGS,
   "SetOrder(self, _arg:int) -> None\nC++: virtual void SetOrder(int _arg)\n\nSet/Get the maximal order up to which the moments are computed.\n"},
  {"GetOrder", PyvtkComputeMoments_GetOrder, METH_VARARGS,
   "GetOrder(self) -> int\nC++: virtual int GetOrder()\n\nSet/Get the maximal order up to which the moments are computed.\n"},
  {"SetNumberOfIntegrationSteps", PyvtkComputeMoments_SetNumberOfIntegrationSteps, METH_VARARGS,
   "SetNumberOfIntegrationSteps(self, _arg:int) -> None\nC++: virtual void SetNumberOfIntegrationSteps(int _arg)\n\nSet/Get the resolution of the integration.\n"},
  {"GetNumberOfIntegrationSteps", PyvtkComputeMoments_GetNumberOfIntegrationSteps, METH_VARARGS,
   "GetNumberOfIntegrationSteps(self) -> int\nC++: virtual int GetNumberOfIntegrationSteps()\n\nSet/Get the resolution of the integration.\n"},
  {"GetNumberOfBasisFunctions", PyvtkComputeMoments_GetNumberOfBasisFunctions, METH_VARARGS,
   "GetNumberOfBasisFunctions(self) -> int\nC++: virtual int GetNumberOfBasisFunctions()\n\nGet the number of basis functions in the field equals\n\\sum_{o=0}^{order+1} dimension^(o+fieldRank)\n"},
  {"GetNumberOfDifferentBasisFunctions", PyvtkComputeMoments_GetNumberOfDifferentBasisFunctions, METH_VARARGS,
   "GetNumberOfDifferentBasisFunctions(self) -> int\nC++: virtual int GetNumberOfDifferentBasisFunctions()\n\nGet the number of basis functions in the field for 2D equals\n\\sum_{o=0}^order (o+1) for 3D equals \\sum_{o=0}^order\n1./2*(o+1)*(o+2)\n"},
  {"SetNameOfPointData", PyvtkComputeMoments_SetNameOfPointData, METH_VARARGS,
   "SetNameOfPointData(self, _arg:str) -> None\nC++: virtual void SetNameOfPointData(std::string _arg)\n\nSet/Get the name of the array in the point data of which the\nmomens are computed.\n"},
  {"GetNameOfPointData", PyvtkComputeMoments_GetNameOfPointData, METH_VARARGS,
   "GetNameOfPointData(self) -> str\nC++: virtual std::string GetNameOfPointData()\n\nSet/Get the name of the array in the point data of which the\nmomens are computed.\n"},
  {"SetUseFFT", PyvtkComputeMoments_SetUseFFT, METH_VARARGS,
   "SetUseFFT(self, _arg:bool) -> None\nC++: virtual void SetUseFFT(bool _arg)\n\nSet/Get the flag of UseFFT.\n"},
  {"GetUseFFT", PyvtkComputeMoments_GetUseFFT, METH_VARARGS,
   "GetUseFFT(self) -> bool\nC++: virtual bool GetUseFFT()\n\nSet/Get the flag of UseFFT.\n"},
  {"SetUseGPU", PyvtkComputeMoments_SetUseGPU, METH_VARARGS,
   "SetUseGPU(self, _arg:bool) -> None\nC++: virtual void SetUseGPU(bool _arg)\n\nSet/Get the flag of UseGPU.\n"},
  {"GetUseGPU", PyvtkComputeMoments_GetUseGPU, METH_VARARGS,
   "GetUseGPU(self) -> bool\nC++: virtual bool GetUseGPU()\n\nSet/Get the flag of UseGPU.\n"},
  {"SetUseOriginalResolution", PyvtkComputeMoments_SetUseOriginalResolution, METH_VARARGS,
   "SetUseOriginalResolution(self, _arg:bool) -> None\nC++: virtual void SetUseOriginalResolution(bool _arg)\n\nSet/Get the flag of using the original resolution of the field\nfor the integration.\n"},
  {"GetUseOriginalResolution", PyvtkComputeMoments_GetUseOriginalResolution, METH_VARARGS,
   "GetUseOriginalResolution(self) -> bool\nC++: virtual bool GetUseOriginalResolution()\n\nSet/Get the flag of using the original resolution of the field\nfor the integration.\n"},
  {"SetCoarseningFactor", PyvtkComputeMoments_SetCoarseningFactor, METH_VARARGS,
   "SetCoarseningFactor(self, _arg:int) -> None\nC++: virtual void SetCoarseningFactor(int _arg)\n\nSet/Get the factor of how coarse the moments shall be computed.\n"},
  {"GetCoarseningFactor", PyvtkComputeMoments_GetCoarseningFactor, METH_VARARGS,
   "GetCoarseningFactor(self) -> int\nC++: virtual int GetCoarseningFactor()\n\nSet/Get the factor of how coarse the moments shall be computed.\n"},
  {"SetRadii", PyvtkComputeMoments_SetRadii, METH_VARARGS,
   "SetRadii(self, radii:(float, ...)) -> None\nC++: void SetRadii(const std::vector<double> &radii)\n\nSet the radii of the integration.\n"},
  {"GetRadii", PyvtkComputeMoments_GetRadii, METH_VARARGS,
   "GetRadii(self) -> (float, ...)\nC++: std::vector<double> GetRadii()\n\nGet the radii of the integration.\n"},
  {"GetRadius", PyvtkComputeMoments_GetRadius, METH_VARARGS,
   "GetRadius(self, i:int) -> float\nC++: double GetRadius(int i)\n\nGet the radius of the integration.\n"},
  {"SetRadiiArray", PyvtkComputeMoments_SetRadiiArray, METH_VARARGS,
   "SetRadiiArray(self, radiiArray:[float, float, float, float, float,\n     float, float, float, float, float]) -> None\nC++: void SetRadiiArray(double radiiArray[10])\n\nSet the different integration radii from the field as constant\nlength array for python wrapping\n@param radiiArray: array of size 10 containing the radii. if less\nradii\nare desired, fill the remaining entries with zeros\n"},
  {"GetRadiiArray", PyvtkComputeMoments_GetRadiiArray, METH_VARARGS,
   "GetRadiiArray(self, radiiArray:[float, float, float, float, float,\n     float, float, float, float, float]) -> None\nC++: void GetRadiiArray(double radiiArray[10])\n\nGet the different integration radii from the field as constant\nlength array for python wrapping\n@param radiiArray: array of size 10 containing the radii. if less\nradii\nare desired, fill the remaining entries with zeros\n"},
  {"SetRelativeRadii", PyvtkComputeMoments_SetRelativeRadii, METH_VARARGS,
   "SetRelativeRadii(self, radii:(float, ...)) -> None\nC++: void SetRelativeRadii(const std::vector<double> &radii)\n\nSet the relative radii of the integration, i.e. radius / min\nextent of the dataset.\n"},
  {"GetRelativeRadii", PyvtkComputeMoments_GetRelativeRadii, METH_VARARGS,
   "GetRelativeRadii(self) -> (float, ...)\nC++: std::vector<double> GetRelativeRadii()\n\nGet the relative radii of the integration, i.e. radius / min\nextent of the dataset.\n"},
  {"GetRelativeRadius", PyvtkComputeMoments_GetRelativeRadius, METH_VARARGS,
   "GetRelativeRadius(self, i:int) -> float\nC++: double GetRelativeRadius(int i)\n\nGet the relative radii of the integration, i.e. radius / min\nextent of the dataset.\n"},
  {"SetRelativeRadiiArray", PyvtkComputeMoments_SetRelativeRadiiArray, METH_VARARGS,
   "SetRelativeRadiiArray(self, relativeRadiiArray:[float, float,\n    float, float, float, float, float, float, float, float])\n    -> None\nC++: void SetRelativeRadiiArray(double relativeRadiiArray[10])\n\nSet the different relative integration radii from the field as\nconstant length array for python wrapping\n@param radiiArray: array of size 10 containing the radii. if less\nradii\nare desired, fill the remaining entries with zeros\n"},
  {"GetRelativeRadiiArray", PyvtkComputeMoments_GetRelativeRadiiArray, METH_VARARGS,
   "GetRelativeRadiiArray(self, relativeRadiiArray:[float, float,\n    float, float, float, float, float, float, float, float])\n    -> None\nC++: void GetRelativeRadiiArray(double relativeRadiiArray[10])\n\nGet the different relative integration radii from the field as\nconstant length array for python wrapping\n@param radiiArray: array of size 10 containing the radii. if less\nradii\nare desired, fill the remaining entries with zeros\n"},
  {"GetNumberOfRadii", PyvtkComputeMoments_GetNumberOfRadii, METH_VARARGS,
   "GetNumberOfRadii(self) -> int\nC++: int GetNumberOfRadii()\n\nGet the number of the different integration radii from the field\n"},
  {"GetStringRadii", PyvtkComputeMoments_GetStringRadii, METH_VARARGS,
   "GetStringRadii(self, i:int) -> str\nC++: std::string GetStringRadii(int i)\n\nGet the different integration radii from the field as string.\nConvenience function.\n"},
  {"normalizeMomentsImageData", PyvtkComputeMoments_normalizeMomentsImageData, METH_VARARGS,
   "normalizeMomentsImageData(self, radiusIndex:int,\n    input:vtkImageData) -> vtkImageData\nC++: vtkImageData *normalizeMomentsImageData(int radiusIndex,\n    vtkImageData *input)\n\nThis function normalizes the moments stored as vtkImageData\n@param input moments\n@return normalized moments\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkComputeMoments_Doc =
  "vtkComputeMoments - rotation invariant pattern detetction\n\n"
  "Superclass: vtkDataSetAlgorithm\n\n"
  "vtkComputeMoments is a filter that computes moments for 2D or 3D\n"
  "datasets (field) that contain scalars, vectors or matrices in their\n"
  "pointdata. The moments are evaluated at the points in grid. The\n"
  "output contains scalar fields at the points of grid. Each scalar\n"
  "field corresponds to a different component of the moment tensor up to\n"
  "Order. The respective indices that identify each scalar field are\n"
  "stored in their respective information the theory and the algorithm\n"
  "is described in Roxana Bujack and Hans Hagen: \"Moment Invariants for Multi-Dimensional\n"
  "Data\"\n"
  "http://www.informatik.uni-leipzig.de/~bujack/2017TensorDagstuhl.pdf@pa\n"
  "r Thanks: Developed by Roxana Bujack and Karen Tsai at Los Alamos\n"
  "National Laboratory.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkComputeMoments_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MomentInvariants.vtkComputeMoments", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkComputeMoments_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkComputeMoments_StaticNew()
{
  return vtkComputeMoments::New();
}

PyObject *PyvtkComputeMoments_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkComputeMoments_Type, PyvtkComputeMoments_Methods,
    "vtkComputeMoments",
 &PyvtkComputeMoments_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkDataSetAlgorithm");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkComputeMoments(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkComputeMoments_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkComputeMoments", o) != 0)
  {
    Py_DECREF(o);
  }

}

