// python wrapper for vtkMomentInvariants
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMomentInvariants.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMomentInvariants(PyObject *dict); }
extern "C" { PyObject *PyvtkMomentInvariants_ClassNew(); }


static PyObject *
PyvtkMomentInvariants_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMomentInvariants::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMomentInvariants::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMomentInvariants *tempr = vtkMomentInvariants::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMomentInvariants *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMomentInvariants::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkMomentInvariants::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkMomentInvariants::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetPatternData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPatternData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  vtkDataObject *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->SetPatternData(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetPatternData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetPatternConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPatternConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  vtkAlgorithmOutput *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetPatternConnection(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetPatternConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetMomentData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMomentData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  vtkDataObject *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->SetMomentData(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetMomentData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetMomentConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMomentConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  vtkAlgorithmOutput *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetMomentConnection(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetMomentConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetNumberOfIntegrationSteps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfIntegrationSteps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfIntegrationSteps(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetNumberOfIntegrationSteps(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetNumberOfIntegrationSteps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfIntegrationSteps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfIntegrationSteps() :
      op->vtkMomentInvariants::GetNumberOfIntegrationSteps());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetUseOriginalResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseOriginalResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseOriginalResolution(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetUseOriginalResolution(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetUseOriginalResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseOriginalResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseOriginalResolution() :
      op->vtkMomentInvariants::GetUseOriginalResolution());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetAngleResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAngleResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAngleResolution(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetAngleResolution(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetAngleResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAngleResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAngleResolution() :
      op->vtkMomentInvariants::GetAngleResolution());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetEps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEps(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetEps(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetEps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetEps() :
      op->vtkMomentInvariants::GetEps());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetNameOfPointData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNameOfPointData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNameOfPointData(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetNameOfPointData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetNameOfPointData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNameOfPointData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetNameOfPointData() :
      op->vtkMomentInvariants::GetNameOfPointData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetIsTranslation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIsTranslation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIsTranslation(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetIsTranslation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetIsTranslation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIsTranslation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetIsTranslation() :
      op->vtkMomentInvariants::GetIsTranslation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetIsScaling(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIsScaling");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIsScaling(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetIsScaling(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetIsScaling(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIsScaling");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetIsScaling() :
      op->vtkMomentInvariants::GetIsScaling());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetIsRotation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIsRotation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIsRotation(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetIsRotation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetIsRotation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIsRotation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetIsRotation() :
      op->vtkMomentInvariants::GetIsRotation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetIsReflection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIsReflection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIsReflection(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetIsReflection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetIsReflection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIsReflection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetIsReflection() :
      op->vtkMomentInvariants::GetIsReflection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetNumberOfBasisFunctions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfBasisFunctions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfBasisFunctions() :
      op->vtkMomentInvariants::GetNumberOfBasisFunctions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetRadii(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRadii");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::vector<double> tempr = (ap.IsBound() ?
      op->GetRadii() :
      op->vtkMomentInvariants::GetRadii());

    if (!ap.ErrorOccurred())
    {
      if (tempr.empty())
      {
        result = PyTuple_New(0);
      }
      else
      {
        result = vtkPythonArgs::BuildTuple(tempr.data(), tempr.size());
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetRadiiArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRadiiArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  const size_t size0 = 10;
  double temp0[10];
  double save0[10];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetRadiiArray(temp0);
    }
    else
    {
      op->vtkMomentInvariants::GetRadiiArray(temp0);
    }

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetNumberOfRadii(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfRadii");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfRadii() :
      op->vtkMomentInvariants::GetNumberOfRadii());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetStringRadii(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStringRadii");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetStringRadii(temp0) :
      op->vtkMomentInvariants::GetStringRadii(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_GetTranslationFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTranslationFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  int temp0;
  int temp1;
  int temp2;
  int temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    double tempr = (ap.IsBound() ?
      op->GetTranslationFactor(temp0, temp1, temp2, temp3) :
      op->vtkMomentInvariants::GetTranslationFactor(temp0, temp1, temp2, temp3));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetTranslationFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTranslationFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  int temp0;
  int temp1;
  int temp2;
  int temp3;
  double temp4;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4))
  {
    if (ap.IsBound())
    {
      op->SetTranslationFactor(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkMomentInvariants::SetTranslationFactor(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMomentInvariants_SetInvariantMethod(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInvariantMethod");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMomentInvariants *op = static_cast<vtkMomentInvariants *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetInvariantMethod(temp0);
    }
    else
    {
      op->vtkMomentInvariants::SetInvariantMethod(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMomentInvariants_Methods[] = {
  {"IsTypeOf", PyvtkMomentInvariants_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkMomentInvariants_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkMomentInvariants_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkMomentInvariants\nC++: static vtkMomentInvariants *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMomentInvariants_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkMomentInvariants\nC++: vtkMomentInvariants *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkMomentInvariants_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkMomentInvariants_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetPatternData", PyvtkMomentInvariants_SetPatternData, METH_VARARGS,
   "SetPatternData(self, input:vtkDataObject) -> None\nC++: void SetPatternData(vtkDataObject *input)\n\nstandard pipeline input for port 1 This is the pattern, a\nvtkDataSet of scalar, vector, or matrix type.\n"},
  {"SetPatternConnection", PyvtkMomentInvariants_SetPatternConnection, METH_VARARGS,
   "SetPatternConnection(self, algOutput:vtkAlgorithmOutput) -> None\nC++: void SetPatternConnection(vtkAlgorithmOutput *algOutput)\n\nstandard pipeline input for port 1 This is the pattern, a\nvtkDataSet of scalar, vector, or matrix type.\n"},
  {"SetMomentData", PyvtkMomentInvariants_SetMomentData, METH_VARARGS,
   "SetMomentData(self, input:vtkDataObject) -> None\nC++: void SetMomentData(vtkDataObject *input)\n\nstandard pipeline input for port 1 This is the vtkImageData field\nof which the moments are calculated. The locations at which the\nmoments are calculated are the points of the grid in input.\n"},
  {"SetMomentConnection", PyvtkMomentInvariants_SetMomentConnection, METH_VARARGS,
   "SetMomentConnection(self, algOutput:vtkAlgorithmOutput) -> None\nC++: void SetMomentConnection(vtkAlgorithmOutput *algOutput)\n\nstandard pipeline input for port 1 This is the vtkImageData field\nof which the moments are calculated. The locations at which the\nmoments are calculated are the points of the grid in input.\n"},
  {"SetNumberOfIntegrationSteps", PyvtkMomentInvariants_SetNumberOfIntegrationSteps, METH_VARARGS,
   "SetNumberOfIntegrationSteps(self, _arg:int) -> None\nC++: virtual void SetNumberOfIntegrationSteps(int _arg)\n\nSet/Get the resolution of the integration.\n"},
  {"GetNumberOfIntegrationSteps", PyvtkMomentInvariants_GetNumberOfIntegrationSteps, METH_VARARGS,
   "GetNumberOfIntegrationSteps(self) -> int\nC++: virtual int GetNumberOfIntegrationSteps()\n\nSet/Get the resolution of the integration.\n"},
  {"SetUseOriginalResolution", PyvtkMomentInvariants_SetUseOriginalResolution, METH_VARARGS,
   "SetUseOriginalResolution(self, _arg:bool) -> None\nC++: virtual void SetUseOriginalResolution(bool _arg)\n\nSet/Get the flag of using the original resolution of the field\nfor the integration.\n"},
  {"GetUseOriginalResolution", PyvtkMomentInvariants_GetUseOriginalResolution, METH_VARARGS,
   "GetUseOriginalResolution(self) -> bool\nC++: virtual bool GetUseOriginalResolution()\n\nSet/Get the flag of using the original resolution of the field\nfor the integration.\n"},
  {"SetAngleResolution", PyvtkMomentInvariants_SetAngleResolution, METH_VARARGS,
   "SetAngleResolution(self, _arg:int) -> None\nC++: virtual void SetAngleResolution(int _arg)\n\nSet/Get the resolution of the integration.\n"},
  {"GetAngleResolution", PyvtkMomentInvariants_GetAngleResolution, METH_VARARGS,
   "GetAngleResolution(self) -> int\nC++: virtual int GetAngleResolution()\n\nSet/Get the resolution of the integration.\n"},
  {"SetEps", PyvtkMomentInvariants_SetEps, METH_VARARGS,
   "SetEps(self, _arg:float) -> None\nC++: virtual void SetEps(double _arg)\n\nSet/Get the resolution of the integration.\n"},
  {"GetEps", PyvtkMomentInvariants_GetEps, METH_VARARGS,
   "GetEps(self) -> float\nC++: virtual double GetEps()\n\nSet/Get the resolution of the integration.\n"},
  {"SetNameOfPointData", PyvtkMomentInvariants_SetNameOfPointData, METH_VARARGS,
   "SetNameOfPointData(self, _arg:str) -> None\nC++: virtual void SetNameOfPointData(std::string _arg)\n\nSet/Get the index of the array in the point data of which the\nmomens are computed.\n"},
  {"GetNameOfPointData", PyvtkMomentInvariants_GetNameOfPointData, METH_VARARGS,
   "GetNameOfPointData(self) -> str\nC++: virtual std::string GetNameOfPointData()\n\nSet/Get the index of the array in the point data of which the\nmomens are computed.\n"},
  {"SetIsTranslation", PyvtkMomentInvariants_SetIsTranslation, METH_VARARGS,
   "SetIsTranslation(self, _arg:bool) -> None\nC++: virtual void SetIsTranslation(bool _arg)\n\nSet/Get if the user wants invariance w.r.t. outer translation\nthat is addition of a constant\n"},
  {"GetIsTranslation", PyvtkMomentInvariants_GetIsTranslation, METH_VARARGS,
   "GetIsTranslation(self) -> bool\nC++: virtual bool GetIsTranslation()\n\nSet/Get if the user wants invariance w.r.t. outer translation\nthat is addition of a constant\n"},
  {"SetIsScaling", PyvtkMomentInvariants_SetIsScaling, METH_VARARGS,
   "SetIsScaling(self, _arg:bool) -> None\nC++: virtual void SetIsScaling(bool _arg)\n\nSet/Get if the user wants invariance w.r.t. outer translation\nthat is addition of a constant\n"},
  {"GetIsScaling", PyvtkMomentInvariants_GetIsScaling, METH_VARARGS,
   "GetIsScaling(self) -> bool\nC++: virtual bool GetIsScaling()\n\nSet/Get if the user wants invariance w.r.t. outer translation\nthat is addition of a constant\n"},
  {"SetIsRotation", PyvtkMomentInvariants_SetIsRotation, METH_VARARGS,
   "SetIsRotation(self, _arg:bool) -> None\nC++: virtual void SetIsRotation(bool _arg)\n\nSet/Get if the user wants invariance w.r.t. total rotation\n"},
  {"GetIsRotation", PyvtkMomentInvariants_GetIsRotation, METH_VARARGS,
   "GetIsRotation(self) -> bool\nC++: virtual bool GetIsRotation()\n\nSet/Get if the user wants invariance w.r.t. total rotation\n"},
  {"SetIsReflection", PyvtkMomentInvariants_SetIsReflection, METH_VARARGS,
   "SetIsReflection(self, _arg:bool) -> None\nC++: virtual void SetIsReflection(bool _arg)\n\nSet/Get if the user wants invariance w.r.t. total reflection\n"},
  {"GetIsReflection", PyvtkMomentInvariants_GetIsReflection, METH_VARARGS,
   "GetIsReflection(self) -> bool\nC++: virtual bool GetIsReflection()\n\nSet/Get if the user wants invariance w.r.t. total reflection\n"},
  {"GetNumberOfBasisFunctions", PyvtkMomentInvariants_GetNumberOfBasisFunctions, METH_VARARGS,
   "GetNumberOfBasisFunctions(self) -> int\nC++: virtual int GetNumberOfBasisFunctions()\n\nGet the number of basis functions in the momentData equals\n\\sum_{i=0}^order dimension^o\n"},
  {"GetRadii", PyvtkMomentInvariants_GetRadii, METH_VARARGS,
   "GetRadii(self) -> (float, ...)\nC++: std::vector<double> GetRadii()\n\nGet the different integration radii from the momentData\n"},
  {"GetRadiiArray", PyvtkMomentInvariants_GetRadiiArray, METH_VARARGS,
   "GetRadiiArray(self, radiiArray:[float, float, float, float, float,\n     float, float, float, float, float]) -> None\nC++: void GetRadiiArray(double radiiArray[10])\n\nGet the different integration radii from the momentData as\nconstant length array for python wrapping\n"},
  {"GetNumberOfRadii", PyvtkMomentInvariants_GetNumberOfRadii, METH_VARARGS,
   "GetNumberOfRadii(self) -> int\nC++: int GetNumberOfRadii()\n\nGet the number of the different integration radii from the\nmomentData\n"},
  {"GetStringRadii", PyvtkMomentInvariants_GetStringRadii, METH_VARARGS,
   "GetStringRadii(self, i:int) -> str\nC++: std::string GetStringRadii(int i)\n\nGet the different integration radii from the momentData as\nstring. Convenience function.\n"},
  {"GetTranslationFactor", PyvtkMomentInvariants_GetTranslationFactor, METH_VARARGS,
   "GetTranslationFactor(self, radius:int, p:int, q:int, r:int)\n    -> float\nC++: double GetTranslationFactor(int radius, int p, int q, int r)\n\nGet the translation factor\n"},
  {"SetTranslationFactor", PyvtkMomentInvariants_SetTranslationFactor, METH_VARARGS,
   "SetTranslationFactor(self, radius:int, p:int, q:int, r:int,\n    value:float) -> None\nC++: void SetTranslationFactor(int radius, int p, int q, int r,\n    double value)\n\nGet the translation factor\n"},
  {"SetInvariantMethod", PyvtkMomentInvariants_SetInvariantMethod, METH_VARARGS,
   "SetInvariantMethod(self, name:str) -> None\nC++: void SetInvariantMethod(std::string name)\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkMomentInvariants_Doc =
  "vtkMomentInvariants - rotation invariant pattern detetction\n\n"
  "Superclass: vtkDataSetAlgorithm\n\n"
  "vtkMomentInvariants is a filter that performs pattern detection it is\n"
  "able to determine the similarity independent from the orientation of\n"
  "the template it takes the moments (momentData) as produced by\n"
  "computeMoments and a pattern as inputs\n"
  "0. it produces a scalar field as output. Each point in this field\n"
  "   contains the similarity between the pattern and that point. it\n"
  "   also puts out the following things\n"
  "1. the normalized moments of the field\n"
  "2. the moments of the pattern\n"
  "1. the normalized moments of the pattern the theory and the algorithm\n"
  "is described in Roxana Bujack and Hans Hagen: \"Moment Invariants for Multi-Dimensional\n"
  "   Data\"\n"
  "   http://www.informatik.uni-leipzig.de/~bujack/2017TensorDagstuhl.pdf\n"
  "   @par Thanks: Developed by Roxana Bujack at Los Alamos National\n"
  "   Laboratory.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkMomentInvariants_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "MomentInvariants.vtkMomentInvariants", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkMomentInvariants_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMomentInvariants_StaticNew()
{
  return vtkMomentInvariants::New();
}

PyObject *PyvtkMomentInvariants_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkMomentInvariants_Type, PyvtkMomentInvariants_Methods,
    "vtkMomentInvariants",
 &PyvtkMomentInvariants_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkDataSetAlgorithm");

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 2; c++)
  {
    static const struct { const char *name; int value; }
      constants[2] = {
        { "PatternPort", 1 },
        { "MomentPort", 0 },
      };

    o = PyLong_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkMomentInvariants(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMomentInvariants_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMomentInvariants", o) != 0)
  {
    Py_DECREF(o);
  }

}

