// python wrapper for vtkDICOMCTRectifier
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMCTRectifier.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMCTRectifier(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMCTRectifier_ClassNew(); }

#ifndef DECLARED_PyvtkDICOMAlgorithm_ClassNew
extern "C" { PyObject *PyvtkDICOMAlgorithm_ClassNew(); }
#define DECLARED_PyvtkDICOMAlgorithm_ClassNew
#endif

static PyObject *
PyvtkDICOMCTRectifier_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMCTRectifier::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMCTRectifier::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMCTRectifier *tempr = vtkDICOMCTRectifier::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMCTRectifier *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMCTRectifier::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMCTRectifier::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMCTRectifier::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_SetReverse(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReverse");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetReverse(temp0);
    }
    else
    {
      op->vtkDICOMCTRectifier::SetReverse(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_ReverseOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReverseOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReverseOn();
    }
    else
    {
      op->vtkDICOMCTRectifier::ReverseOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_ReverseOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReverseOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReverseOff();
    }
    else
    {
      op->vtkDICOMCTRectifier::ReverseOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_GetReverse(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReverse");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetReverse() :
      op->vtkDICOMCTRectifier::GetReverse());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_SetVolumeMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVolumeMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetVolumeMatrix(temp0);
    }
    else
    {
      op->vtkDICOMCTRectifier::SetVolumeMatrix(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_GetVolumeMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVolumeMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetVolumeMatrix() :
      op->vtkDICOMCTRectifier::GetVolumeMatrix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_SetInterpolationMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInterpolationMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetInterpolationMode(temp0);
    }
    else
    {
      op->vtkDICOMCTRectifier::SetInterpolationMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_SetInterpolationModeToNearest(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInterpolationModeToNearest");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetInterpolationModeToNearest();
    }
    else
    {
      op->vtkDICOMCTRectifier::SetInterpolationModeToNearest();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_SetInterpolationModeToLinear(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInterpolationModeToLinear");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetInterpolationModeToLinear();
    }
    else
    {
      op->vtkDICOMCTRectifier::SetInterpolationModeToLinear();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_SetInterpolationModeToCubic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInterpolationModeToCubic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetInterpolationModeToCubic();
    }
    else
    {
      op->vtkDICOMCTRectifier::SetInterpolationModeToCubic();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_SetInterpolationModeToWindowedSinc(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInterpolationModeToWindowedSinc");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetInterpolationModeToWindowedSinc();
    }
    else
    {
      op->vtkDICOMCTRectifier::SetInterpolationModeToWindowedSinc();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_GetInterpolationMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInterpolationMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetInterpolationMode() :
      op->vtkDICOMCTRectifier::GetInterpolationMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_GetRectifiedMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRectifiedMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetRectifiedMatrix() :
      op->vtkDICOMCTRectifier::GetRectifiedMatrix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_UpdateMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMCTRectifier *op = static_cast<vtkDICOMCTRectifier *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateMatrix();
    }
    else
    {
      op->vtkDICOMCTRectifier::UpdateMatrix();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCTRectifier_GetGantryDetectorTilt(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetGantryDetectorTilt");

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    double tempr = vtkDICOMCTRectifier::GetGantryDetectorTilt(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMCTRectifier_Methods[] = {
  {"IsTypeOf", PyvtkDICOMCTRectifier_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMCTRectifier_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMCTRectifier_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMCTRectifier\nC++: static vtkDICOMCTRectifier *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMCTRectifier_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMCTRectifier\nC++: vtkDICOMCTRectifier *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMCTRectifier_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMCTRectifier_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetReverse", PyvtkDICOMCTRectifier_SetReverse, METH_VARARGS,
   "SetReverse(self, v:int) -> None\nC++: void SetReverse(int v)\n\nReverse the default operation.\n\nWhen this option is set, the filter takes a rectangular volume as\ninput, and produces a volume whose geometry matches the\nVolumeMatrix.\n"},
  {"ReverseOn", PyvtkDICOMCTRectifier_ReverseOn, METH_VARARGS,
   "ReverseOn(self) -> None\nC++: void ReverseOn()\n\nReverse the default operation.\n\nWhen this option is set, the filter takes a rectangular volume as\ninput, and produces a volume whose geometry matches the\nVolumeMatrix.\n"},
  {"ReverseOff", PyvtkDICOMCTRectifier_ReverseOff, METH_VARARGS,
   "ReverseOff(self) -> None\nC++: void ReverseOff()\n\nReverse the default operation.\n\nWhen this option is set, the filter takes a rectangular volume as\ninput, and produces a volume whose geometry matches the\nVolumeMatrix.\n"},
  {"GetReverse", PyvtkDICOMCTRectifier_GetReverse, METH_VARARGS,
   "GetReverse(self) -> int\nC++: int GetReverse()\n\nReverse the default operation.\n\nWhen this option is set, the filter takes a rectangular volume as\ninput, and produces a volume whose geometry matches the\nVolumeMatrix.\n"},
  {"SetVolumeMatrix", PyvtkDICOMCTRectifier_SetVolumeMatrix, METH_VARARGS,
   "SetVolumeMatrix(self, matrix:vtkMatrix4x4) -> None\nC++: void SetVolumeMatrix(vtkMatrix4x4 *matrix)\n\nSet the matrix that describes the CT volume geometry.\n\nThis should be set to the PatientMatrix that comes from the\nvtkDICOMReader.\n"},
  {"GetVolumeMatrix", PyvtkDICOMCTRectifier_GetVolumeMatrix, METH_VARARGS,
   "GetVolumeMatrix(self) -> vtkMatrix4x4\nC++: vtkMatrix4x4 *GetVolumeMatrix()\n\nSet the matrix that describes the CT volume geometry.\n\nThis should be set to the PatientMatrix that comes from the\nvtkDICOMReader.\n"},
  {"SetInterpolationMode", PyvtkDICOMCTRectifier_SetInterpolationMode, METH_VARARGS,
   "SetInterpolationMode(self, t:int) -> None\nC++: void SetInterpolationMode(int t)\n\nSet the interpolation method for resampling the data.\n\nThe default interpolation method is WindowedSinc, which gives the\nhighest quality output.  Linear interpolation is much faster and\nwill give satisfactory results in most situations.\n"},
  {"SetInterpolationModeToNearest", PyvtkDICOMCTRectifier_SetInterpolationModeToNearest, METH_VARARGS,
   "SetInterpolationModeToNearest(self) -> None\nC++: void SetInterpolationModeToNearest()\n\nSet the interpolation method for resampling the data.\n\nThe default interpolation method is WindowedSinc, which gives the\nhighest quality output.  Linear interpolation is much faster and\nwill give satisfactory results in most situations.\n"},
  {"SetInterpolationModeToLinear", PyvtkDICOMCTRectifier_SetInterpolationModeToLinear, METH_VARARGS,
   "SetInterpolationModeToLinear(self) -> None\nC++: void SetInterpolationModeToLinear()\n\nSet the interpolation method for resampling the data.\n\nThe default interpolation method is WindowedSinc, which gives the\nhighest quality output.  Linear interpolation is much faster and\nwill give satisfactory results in most situations.\n"},
  {"SetInterpolationModeToCubic", PyvtkDICOMCTRectifier_SetInterpolationModeToCubic, METH_VARARGS,
   "SetInterpolationModeToCubic(self) -> None\nC++: void SetInterpolationModeToCubic()\n\nSet the interpolation method for resampling the data.\n\nThe default interpolation method is WindowedSinc, which gives the\nhighest quality output.  Linear interpolation is much faster and\nwill give satisfactory results in most situations.\n"},
  {"SetInterpolationModeToWindowedSinc", PyvtkDICOMCTRectifier_SetInterpolationModeToWindowedSinc, METH_VARARGS,
   "SetInterpolationModeToWindowedSinc(self) -> None\nC++: void SetInterpolationModeToWindowedSinc()\n\nSet the interpolation method for resampling the data.\n\nThe default interpolation method is WindowedSinc, which gives the\nhighest quality output.  Linear interpolation is much faster and\nwill give satisfactory results in most situations.\n"},
  {"GetInterpolationMode", PyvtkDICOMCTRectifier_GetInterpolationMode, METH_VARARGS,
   "GetInterpolationMode(self) -> int\nC++: int GetInterpolationMode()\n\nSet the interpolation method for resampling the data.\n\nThe default interpolation method is WindowedSinc, which gives the\nhighest quality output.  Linear interpolation is much faster and\nwill give satisfactory results in most situations.\n"},
  {"GetRectifiedMatrix", PyvtkDICOMCTRectifier_GetRectifiedMatrix, METH_VARARGS,
   "GetRectifiedMatrix(self) -> vtkMatrix4x4\nC++: vtkMatrix4x4 *GetRectifiedMatrix()\n\nGet the matrix that describes the rectified geometry.\n\nThis matrix is generated when any of these methods is called:\nUpdate(), UpdateInformation(), or UpdateMatrix().\n"},
  {"UpdateMatrix", PyvtkDICOMCTRectifier_UpdateMatrix, METH_VARARGS,
   "UpdateMatrix(self) -> None\nC++: void UpdateMatrix()\n\nUpdate the RectifiedMatrix without updating the output data.\n\nThe input data must be set before this is called.\n"},
  {"GetGantryDetectorTilt", PyvtkDICOMCTRectifier_GetGantryDetectorTilt, METH_VARARGS,
   "GetGantryDetectorTilt(volumeMatrix:vtkMatrix4x4) -> float\nC++: static double GetGantryDetectorTilt(\n    vtkMatrix4x4 *volumeMatrix)\n\nA static method to measure the tilt from a matrix.\n\nThis can be used to see whether it is necessary to rectify the\nvolume.  It returns the Gantry Detector Tilt angle, in degrees,\nas computed from the shear in the volume matrix.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMCTRectifier_Doc =
  "vtkDICOMCTRectifier - Prepare a CT for 3D processing\n\n"
  "Superclass: vtkDICOMAlgorithm\n\n"
  "This class will identify gantry-tilted CT images and resample them\n"
  "into a rectangular volume.  This is often a necessary step prior to\n"
  "volume rendering or other forms of 3D rendering.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMCTRectifier_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMCTRectifier", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMCTRectifier_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMCTRectifier_StaticNew()
{
  return vtkDICOMCTRectifier::New();
}

PyObject *PyvtkDICOMCTRectifier_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMCTRectifier_Type, PyvtkDICOMCTRectifier_Methods,
    "vtkDICOMCTRectifier",
 &PyvtkDICOMCTRectifier_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = (PyTypeObject *)PyvtkDICOMAlgorithm_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 4; c++)
  {
    static const struct { const char *name; int value; }
      constants[4] = {
        { "Nearest", vtkDICOMCTRectifier::Nearest },
        { "Linear", vtkDICOMCTRectifier::Linear },
        { "Cubic", vtkDICOMCTRectifier::Cubic },
        { "WindowedSinc", vtkDICOMCTRectifier::WindowedSinc },
      };

    o = PyLong_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMCTRectifier(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMCTRectifier_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMCTRectifier", o) != 0)
  {
    Py_DECREF(o);
  }

}

