// python wrapper for vtkDICOMCharacterSet
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMCharacterSet.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMCharacterSet(PyObject *dict); }
#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMCharacterSet_EnumType_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMCharacterSet.EnumType", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMCharacterSet_EnumType_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMCharacterSet_EnumType_Type, static_cast<int>(val));
}


static PyObject *
PyvtkDICOMCharacterSet_SetGlobalDefault(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SetGlobalDefault");

  vtkDICOMCharacterSet *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMCharacterSet"))
  {
    vtkDICOMCharacterSet::SetGlobalDefault(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_GetGlobalDefault(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetGlobalDefault");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMCharacterSet tempr = vtkDICOMCharacterSet::GetGlobalDefault();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMCharacterSet");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_SetGlobalOverride(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SetGlobalOverride");

  bool temp0 = false;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMCharacterSet::SetGlobalOverride(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_GlobalOverrideOn(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GlobalOverrideOn");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMCharacterSet::GlobalOverrideOn();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_GlobalOverrideOff(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GlobalOverrideOff");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMCharacterSet::GlobalOverrideOff();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_GetGlobalOverride(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetGlobalOverride");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    bool tempr = vtkDICOMCharacterSet::GetGlobalOverride();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_GetCharacterSetString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCharacterSetString");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = op->GetCharacterSetString();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_GetKey(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetKey");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned char tempr = op->GetKey();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_FromUTF8_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FromUTF8");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  const char *temp0 = nullptr;
  size_t temp1;
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<size_t> store2(2*size2);
  size_t *temp2 = store2.Data();
  size_t *save2 = (size2 == 0 ? nullptr : temp2 + size2);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetArray(temp2, size2)))
  {
    vtkPythonArgs::Save(temp2, save2, size2);

    std::string tempr = op->FromUTF8(temp0, temp1, temp2);

    if (vtkPythonArgs::HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_FromUTF8_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FromUTF8");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = op->FromUTF8(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_FromUTF8(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
    case 3:
      return PyvtkDICOMCharacterSet_FromUTF8_s1(self, args);
    case 1:
      return PyvtkDICOMCharacterSet_FromUTF8_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "FromUTF8");
  return nullptr;
}


static PyObject *
PyvtkDICOMCharacterSet_ToUTF8_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToUTF8");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  const char *temp0 = nullptr;
  size_t temp1;
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<size_t> store2(2*size2);
  size_t *temp2 = store2.Data();
  size_t *save2 = (size2 == 0 ? nullptr : temp2 + size2);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetArray(temp2, size2)))
  {
    vtkPythonArgs::Save(temp2, save2, size2);

    std::string tempr = op->ToUTF8(temp0, temp1, temp2);

    if (vtkPythonArgs::HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_ToUTF8_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToUTF8");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = op->ToUTF8(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_ToUTF8(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
    case 3:
      return PyvtkDICOMCharacterSet_ToUTF8_s1(self, args);
    case 1:
      return PyvtkDICOMCharacterSet_ToUTF8_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "ToUTF8");
  return nullptr;
}


static PyObject *
PyvtkDICOMCharacterSet_ConvertToUTF8(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ConvertToUTF8");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  const char *temp0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = op->ConvertToUTF8(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_ToSafeUTF8_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToSafeUTF8");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  const char *temp0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = op->ToSafeUTF8(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_ToSafeUTF8_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToSafeUTF8");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = op->ToSafeUTF8(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_ToSafeUTF8(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return PyvtkDICOMCharacterSet_ToSafeUTF8_s1(self, args);
    case 1:
      return PyvtkDICOMCharacterSet_ToSafeUTF8_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "ToSafeUTF8");
  return nullptr;
}


static PyObject *
PyvtkDICOMCharacterSet_CaseFoldedUTF8_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CaseFoldedUTF8");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  const char *temp0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = op->CaseFoldedUTF8(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_CaseFoldedUTF8_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CaseFoldedUTF8");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = op->CaseFoldedUTF8(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_CaseFoldedUTF8(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return PyvtkDICOMCharacterSet_CaseFoldedUTF8_s1(self, args);
    case 1:
      return PyvtkDICOMCharacterSet_CaseFoldedUTF8_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "CaseFoldedUTF8");
  return nullptr;
}


static PyObject *
PyvtkDICOMCharacterSet_IsISO2022(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsISO2022");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsISO2022();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_IsISO8859(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsISO8859");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsISO8859();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_IsBiDirectional(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsBiDirectional");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsBiDirectional();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_CountBackslashes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CountBackslashes");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  const char *temp0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    unsigned int tempr = op->CountBackslashes(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMCharacterSet_NextBackslash(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NextBackslash");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMCharacterSet *op = static_cast<vtkDICOMCharacterSet *>(vp);

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    size_t tempr = op->NextBackslash(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMCharacterSet_Methods[] = {
  {"SetGlobalDefault", PyvtkDICOMCharacterSet_SetGlobalDefault, METH_VARARGS,
   "SetGlobalDefault(cs:vtkDICOMCharacterSet) -> None\nC++: static void SetGlobalDefault(vtkDICOMCharacterSet cs)\n\nSet the character set to use if SpecificCharacterSet is missing.\n\nSome DICOM files do not list a SpecificCharacterSet attribute,\nbut nevertheless use a non-ASCII character encoding.  This method\ncan be used to specify the character set in absence of\nSpecificCharacterSet. If SpecificCharacterSet is present, the\ndefault will not override it unless OverrideCharacterSet is true.\n"},
  {"GetGlobalDefault", PyvtkDICOMCharacterSet_GetGlobalDefault, METH_VARARGS,
   "GetGlobalDefault() -> vtkDICOMCharacterSet\nC++: static vtkDICOMCharacterSet GetGlobalDefault()\n\nSet the character set to use if SpecificCharacterSet is missing.\n\nSome DICOM files do not list a SpecificCharacterSet attribute,\nbut nevertheless use a non-ASCII character encoding.  This method\ncan be used to specify the character set in absence of\nSpecificCharacterSet. If SpecificCharacterSet is present, the\ndefault will not override it unless OverrideCharacterSet is true.\n"},
  {"SetGlobalOverride", PyvtkDICOMCharacterSet_SetGlobalOverride, METH_VARARGS,
   "SetGlobalOverride(b:bool) -> None\nC++: static void SetGlobalOverride(bool b)\n\nOverride the value stored in SpecificCharacterSet with the\ndefault.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It forces the use of the character set that\nwas set with SetGlobalDefault.\n"},
  {"GlobalOverrideOn", PyvtkDICOMCharacterSet_GlobalOverrideOn, METH_VARARGS,
   "GlobalOverrideOn() -> None\nC++: static void GlobalOverrideOn()\n\nOverride the value stored in SpecificCharacterSet with the\ndefault.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It forces the use of the character set that\nwas set with SetGlobalDefault.\n"},
  {"GlobalOverrideOff", PyvtkDICOMCharacterSet_GlobalOverrideOff, METH_VARARGS,
   "GlobalOverrideOff() -> None\nC++: static void GlobalOverrideOff()\n\nOverride the value stored in SpecificCharacterSet with the\ndefault.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It forces the use of the character set that\nwas set with SetGlobalDefault.\n"},
  {"GetGlobalOverride", PyvtkDICOMCharacterSet_GetGlobalOverride, METH_VARARGS,
   "GetGlobalOverride() -> bool\nC++: static bool GetGlobalOverride()\n\nOverride the value stored in SpecificCharacterSet with the\ndefault.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It forces the use of the character set that\nwas set with SetGlobalDefault.\n"},
  {"GetCharacterSetString", PyvtkDICOMCharacterSet_GetCharacterSetString, METH_VARARGS,
   "GetCharacterSetString(self) -> str\nC++: std::string GetCharacterSetString()\n\nGenerate SpecificCharacterSet code values (diagnostic only).\n\nAttempt to generate SpecificCharacterSet code values.  If ISO\n2022 encoding is not used, then a single code value is returned. \nIf ISO 2022 encoding is used with the single-byte character sets,\nthen only the code value for first character set will be returned\n(due to limitations in the way this class stores the\ninformation).  However, if ISO 2022 encoding is used with the\nmulti-byte character sets, the result is a set of\nbackslash-separated code values, where the first value will be\nempty if the initial coding is ASCII.\n"},
  {"GetKey", PyvtkDICOMCharacterSet_GetKey, METH_VARARGS,
   "GetKey(self) -> int\nC++: unsigned char GetKey()\n\nGet the numerical code for this character set object.\n"},
  {"FromUTF8", PyvtkDICOMCharacterSet_FromUTF8, METH_VARARGS,
   "FromUTF8(self, text:str, l:int, lp:[int, ...]=...) -> str\nC++: std::string FromUTF8(const char *text, size_t l,\n    size_t *lp=0)\nFromUTF8(self, text:str) -> str\nC++: std::string FromUTF8(const std::string &text)\n\nConvert text from UTF-8 to this encoding.\n\nAttempt to convert from UTF-8 to this character set.  Every\nnon-convertible character will be replaced with '?'.  If you pass\na non-null value for the \"lp\" parameter, it will return the\nposition in the input UTF-8 string where the first conversion\nerror occurred.  If a successful conversion was returned, then lp\nwill be set to the length of the input string.\n"},
  {"ToUTF8", PyvtkDICOMCharacterSet_ToUTF8, METH_VARARGS,
   "ToUTF8(self, text:str, l:int, lp:[int, ...]=...) -> str\nC++: std::string ToUTF8(const char *text, size_t l, size_t *lp=0)\nToUTF8(self, text:str) -> str\nC++: std::string ToUTF8(const std::string &text)\n\nConvert text from this encoding to UTF-8.\n\nThis will convert text to UTF-8, which is generally a lossless\nprocess for western languages but not for the CJK languages.\nCharacters that cannot be mapped to unicode, or whose place in\nunicode is not known, will be printed as unicode U+FFFD which\nappears as a question mark in a diamond.  If you pass a non-null\nvalue for the \"lp\" parameter, it will return the position in the\ninput string where the first conversion error occurred.  If a\nsuccessful conversion was returned, then lp will be set to the\nlength of the input string.\n"},
  {"ConvertToUTF8", PyvtkDICOMCharacterSet_ConvertToUTF8, METH_VARARGS,
   "ConvertToUTF8(self, text:str, l:int) -> str\nC++: std::string ConvertToUTF8(const char *text, size_t l)\n\nObsolete method for converting to UTF8.\n"},
  {"ToSafeUTF8", PyvtkDICOMCharacterSet_ToSafeUTF8, METH_VARARGS,
   "ToSafeUTF8(self, text:str, l:int) -> str\nC++: std::string ToSafeUTF8(const char *text, size_t l)\nToSafeUTF8(self, text:str) -> str\nC++: std::string ToSafeUTF8(const std::string &text)\n\nConvert text to UTF-8 that is safe to print to the console.\n\nAll control characters or unconvertible characters will be\nreplaced by four-byte octal codes, e.g. '\\033'.  Backslashes will\nbe replaced by '\\134' to avoid any potential ambiguity.\n"},
  {"CaseFoldedUTF8", PyvtkDICOMCharacterSet_CaseFoldedUTF8, METH_VARARGS,
   "CaseFoldedUTF8(self, text:str, l:int) -> str\nC++: std::string CaseFoldedUTF8(const char *text, size_t l)\nCaseFoldedUTF8(self, text:str) -> str\nC++: std::string CaseFoldedUTF8(const std::string &text)\n\nConvert text into a form suitable for case-insensitive matching.\n\nThis function will perform case normalization on a string by\nconverting it to lowercase, and by normalizing the forms of\nlowercase characters that do not have an exact uppercase\nequivalent.  In some cases, it might increase the length of the\nstring.  It covers modern European scripts (including Greek and\nCyrillic) and latin characters used in East Asian languages.\n"},
  {"IsISO2022", PyvtkDICOMCharacterSet_IsISO2022, METH_VARARGS,
   "IsISO2022(self) -> bool\nC++: bool IsISO2022()\n\nReturns true if ISO 2022 escape codes are used.\n\nIf this method returns true, then escape codes can be used to\nswitch between character sets.\n"},
  {"IsISO8859", PyvtkDICOMCharacterSet_IsISO8859, METH_VARARGS,
   "IsISO8859(self) -> bool\nC++: bool IsISO8859()\n\nReturns true if this uses an ISO 8859 code page.\n"},
  {"IsBiDirectional", PyvtkDICOMCharacterSet_IsBiDirectional, METH_VARARGS,
   "IsBiDirectional(self) -> bool\nC++: bool IsBiDirectional()\n\nCheck for bidirectional character sets.\n\nThis is used to check for character sets that are likely to\ncontain characters that print right-to-left, specifically Hebrew\nand Arabic.  Note that even though some parts of unicode fall\ninto this category, this flag is off for unicode and GB18030/GBK.\n"},
  {"CountBackslashes", PyvtkDICOMCharacterSet_CountBackslashes, METH_VARARGS,
   "CountBackslashes(self, text:str, l:int) -> int\nC++: unsigned int CountBackslashes(const char *text, size_t l)\n\nCount the number of backslashes in an encoded string.\n\nThe backslash byte is sometimes present as half of a multibyte\ncharacter in the Japanese and Chinese encodings.  This method\nskips these false backslashes and counts only real backslashes.\n"},
  {"NextBackslash", PyvtkDICOMCharacterSet_NextBackslash, METH_VARARGS,
   "NextBackslash(self, text:str, end:str) -> int\nC++: size_t NextBackslash(const char *text, const char *end)\n\nGet the offset to the next backslash, or to the end of the\nstring.\n\nIn order to work properly, this method requires that its input is\neither at the beginning of the string or just after a backslash.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMCharacterSet");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMCharacterSet *op = new vtkDICOMCharacterSet();

    result = PyVTKSpecialObject_New("vtkDICOMCharacterSet", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMCharacterSet");

  int temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMCharacterSet *op = new vtkDICOMCharacterSet(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMCharacterSet", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMCharacterSet");

  std::string temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMCharacterSet *op = new vtkDICOMCharacterSet(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMCharacterSet", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s4(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMCharacterSet");

  const char *temp0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkDICOMCharacterSet *op = new vtkDICOMCharacterSet(temp0, temp1);

    result = PyVTKSpecialObject_New("vtkDICOMCharacterSet", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s5(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMCharacterSet");

  vtkDICOMCharacterSet *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMCharacterSet"))
  {
    vtkDICOMCharacterSet *op = new vtkDICOMCharacterSet(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMCharacterSet", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_Methods[] = {
  {"vtkDICOMCharacterSet", PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s2, METH_VARARGS,
   "@i"},
  {"vtkDICOMCharacterSet", PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s3, METH_VARARGS,
   "-@s"},
  {"vtkDICOMCharacterSet", PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s5, METH_VARARGS,
   "@W vtkDICOMCharacterSet"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMCharacterSet_vtkDICOMCharacterSet(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s1(self, args);
    case 2:
      return PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_s4(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMCharacterSet");
  return nullptr;
}


static const char *PyvtkDICOMCharacterSet_Doc =

  "vtkDICOMCharacterSet() -> vtkDICOMCharacterSet\nC++: vtkDICOMCharacterSet()\nvtkDICOMCharacterSet(k:int) -> vtkDICOMCharacterSet\nC++: vtkDICOMCharacterSet(int k)\nvtkDICOMCharacterSet(name:str) -> vtkDICOMCharacterSet\nC++: explicit vtkDICOMCharacterSet(const std::string &name)\nvtkDICOMCharacterSet(name:str, nl:int) -> vtkDICOMCharacterSet\nC++: vtkDICOMCharacterSet(const char *name, size_t nl)\nvtkDICOMCharacterSet(__a:vtkDICOMCharacterSet) -> vtkDICOMCharacterSet\nC++: vtkDICOMCharacterSet(const &vtkDICOMCharacterSet)\n""\n"
  "vtkDICOMCharacterSet - Character sets.\n\n"
  "This class provides the means to convert the various international\n"
  "text encodings used by DICOM to UTF-8 and back again.\n\n\n"
  " During conversion to UTF-8, any codes from the original encoding\n"
  "that\n"
  " can't be converted are replaced by Unicode's \"REPLACEMENT\n"
  "CHARACTER\",\n"
  " which is a question mark in a black diamond.  For instance, if the\n"
  " original encoding is ISO_IR_6 (ASCII), any octets outside of the\n"
  " valid ASCII range of 0 to 127 will become \"REPLACEMENT CHARACTER\".\n\n\n"
  " DICOM supports a fairly small number of single-byte and multi-byte\n"
  " character sets.  The only VRs that support these character sets are\n"
  " PN, LO, SH, ST, LT, and ST (all other text VRs must be ASCII). In\n"
  " addition to ASCII, there are twelve 8-bit single-byte encodings,\n"
  " three iso-2022 multi-byte encodings, and three variable-length\n"
  " encodings (UTF-8, GB18030, GBK).\n\n\n"
  " In some DICOM data sets, especially old ones, the\n"
  "SpecificCharacterSet\n"
  " attribute will be missing and it might be necessary to manually\n"
  "specify\n"
  " a character set for the application to use.  Use SetGlobalDefault()\n"
  "to\n"
  " do so.  The vtkDICOMCharacterSet constructor can take the desired\n"
  " character encoding as a string, where the following encodings are\n"
  " allowed: 'ascii', 'latin1', 'latin2', 'latin3', 'latin4', 'latin5'\n"
  " 'latin7', 'latin9', 'cyrillic' (iso-8859-5), 'arabic' (iso-8859-6),\n"
  " 'greek' (iso-8859-7), 'hebrew' (iso-8859-8), 'tis-620', 'shift-jis',\n"
  " 'euc-jp', 'iso-2022-jp', 'korean' (euc-kr), 'chinese' (gbk),\n"
  "'gb18030',\n"
  " 'big5', 'cp1250', 'cp1251', 'cp1252', 'cp1253', 'cp1254', 'cp1255',\n"
  " 'cp1256', 'cp1257', 'cp1258', and 'utf-8'.  Common aliases of these\n"
  " character sets can also be used.\n\n";

static PyObject *
PyvtkDICOMCharacterSet_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMCharacterSet_vtkDICOMCharacterSet(nullptr, args);
}

static void PyvtkDICOMCharacterSet_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMCharacterSet *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkDICOMCharacterSet_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkDICOMCharacterSet *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyUnicode_FromStringAndSize(s.data(), s.size());
}

static int PyvtkDICOMCharacterSet_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMCharacterSet_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMCharacterSet *so1 = nullptr;
  const vtkDICOMCharacterSet *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMCharacterSet_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMCharacterSet *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMCharacterSet *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMCharacterSet", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMCharacterSet_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMCharacterSet *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMCharacterSet *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMCharacterSet", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      result = ((*so1) < (*so2));
      break;
    case Py_LE:
      result = ((*so1) <= (*so2));
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      result = ((*so1) > (*so2));
      break;
    case Py_GE:
      result = ((*so1) >= (*so2));
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMCharacterSet_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMCharacterSet_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMCharacterSet", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMCharacterSet_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMCharacterSet_Hash, // tp_hash
  nullptr, // tp_call
  PyvtkDICOMCharacterSet_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMCharacterSet_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMCharacterSet_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMCharacterSet_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMCharacterSet_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMCharacterSet_Type);
}

static void *PyvtkDICOMCharacterSet_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMCharacterSet(*static_cast<const vtkDICOMCharacterSet*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMCharacterSet_TypeNew
extern "C" { PyObject *PyvtkDICOMCharacterSet_TypeNew(); }
#define DECLARED_PyvtkDICOMCharacterSet_TypeNew
#endif

PyObject *PyvtkDICOMCharacterSet_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMCharacterSet_Type,
    PyvtkDICOMCharacterSet_Methods,
    PyvtkDICOMCharacterSet_vtkDICOMCharacterSet_Methods,
    &PyvtkDICOMCharacterSet_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkDICOMCharacterSet_EnumType_Type);
  PyVTKEnum_Add(&PyvtkDICOMCharacterSet_EnumType_Type, "vtkDICOMCharacterSet.EnumType");

  o = (PyObject *)&PyvtkDICOMCharacterSet_EnumType_Type;
  if (PyDict_SetItemString(d, "EnumType", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 55; c++)
  {
    typedef vtkDICOMCharacterSet::EnumType cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[55] = {
        { "ISO_IR_6", vtkDICOMCharacterSet::ISO_IR_6 },
        { "ISO_IR_13", vtkDICOMCharacterSet::ISO_IR_13 },
        { "ISO_IR_100", vtkDICOMCharacterSet::ISO_IR_100 },
        { "ISO_IR_101", vtkDICOMCharacterSet::ISO_IR_101 },
        { "ISO_IR_109", vtkDICOMCharacterSet::ISO_IR_109 },
        { "ISO_IR_110", vtkDICOMCharacterSet::ISO_IR_110 },
        { "ISO_IR_144", vtkDICOMCharacterSet::ISO_IR_144 },
        { "ISO_IR_127", vtkDICOMCharacterSet::ISO_IR_127 },
        { "ISO_IR_126", vtkDICOMCharacterSet::ISO_IR_126 },
        { "ISO_IR_138", vtkDICOMCharacterSet::ISO_IR_138 },
        { "ISO_IR_148", vtkDICOMCharacterSet::ISO_IR_148 },
        { "X_LATIN6", vtkDICOMCharacterSet::X_LATIN6 },
        { "ISO_IR_166", vtkDICOMCharacterSet::ISO_IR_166 },
        { "X_LATIN7", vtkDICOMCharacterSet::X_LATIN7 },
        { "X_LATIN8", vtkDICOMCharacterSet::X_LATIN8 },
        { "ISO_IR_203", vtkDICOMCharacterSet::ISO_IR_203 },
        { "X_LATIN9", vtkDICOMCharacterSet::X_LATIN9 },
        { "X_LATIN10", vtkDICOMCharacterSet::X_LATIN10 },
        { "X_EUCKR", vtkDICOMCharacterSet::X_EUCKR },
        { "X_GB2312", vtkDICOMCharacterSet::X_GB2312 },
        { "ISO_2022_IR_6", vtkDICOMCharacterSet::ISO_2022_IR_6 },
        { "ISO_2022_IR_13", vtkDICOMCharacterSet::ISO_2022_IR_13 },
        { "ISO_2022_IR_87", vtkDICOMCharacterSet::ISO_2022_IR_87 },
        { "ISO_2022_IR_159", vtkDICOMCharacterSet::ISO_2022_IR_159 },
        { "ISO_2022_IR_100", vtkDICOMCharacterSet::ISO_2022_IR_100 },
        { "ISO_2022_IR_101", vtkDICOMCharacterSet::ISO_2022_IR_101 },
        { "ISO_2022_IR_109", vtkDICOMCharacterSet::ISO_2022_IR_109 },
        { "ISO_2022_IR_110", vtkDICOMCharacterSet::ISO_2022_IR_110 },
        { "ISO_2022_IR_144", vtkDICOMCharacterSet::ISO_2022_IR_144 },
        { "ISO_2022_IR_127", vtkDICOMCharacterSet::ISO_2022_IR_127 },
        { "ISO_2022_IR_126", vtkDICOMCharacterSet::ISO_2022_IR_126 },
        { "ISO_2022_IR_138", vtkDICOMCharacterSet::ISO_2022_IR_138 },
        { "ISO_2022_IR_148", vtkDICOMCharacterSet::ISO_2022_IR_148 },
        { "ISO_2022_IR_166", vtkDICOMCharacterSet::ISO_2022_IR_166 },
        { "ISO_2022_IR_203", vtkDICOMCharacterSet::ISO_2022_IR_203 },
        { "ISO_2022_IR_149", vtkDICOMCharacterSet::ISO_2022_IR_149 },
        { "ISO_2022_IR_58", vtkDICOMCharacterSet::ISO_2022_IR_58 },
        { "ISO_IR_192", vtkDICOMCharacterSet::ISO_IR_192 },
        { "GB18030", vtkDICOMCharacterSet::GB18030 },
        { "GBK", vtkDICOMCharacterSet::GBK },
        { "X_BIG5", vtkDICOMCharacterSet::X_BIG5 },
        { "X_EUCJP", vtkDICOMCharacterSet::X_EUCJP },
        { "X_SJIS", vtkDICOMCharacterSet::X_SJIS },
        { "X_CP874", vtkDICOMCharacterSet::X_CP874 },
        { "X_CP1250", vtkDICOMCharacterSet::X_CP1250 },
        { "X_CP1251", vtkDICOMCharacterSet::X_CP1251 },
        { "X_CP1252", vtkDICOMCharacterSet::X_CP1252 },
        { "X_CP1253", vtkDICOMCharacterSet::X_CP1253 },
        { "X_CP1254", vtkDICOMCharacterSet::X_CP1254 },
        { "X_CP1255", vtkDICOMCharacterSet::X_CP1255 },
        { "X_CP1256", vtkDICOMCharacterSet::X_CP1256 },
        { "X_CP1257", vtkDICOMCharacterSet::X_CP1257 },
        { "X_CP1258", vtkDICOMCharacterSet::X_CP1258 },
        { "X_KOI8", vtkDICOMCharacterSet::X_KOI8 },
        { "Unknown", vtkDICOMCharacterSet::Unknown },
      };

    o = PyvtkDICOMCharacterSet_EnumType_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMCharacterSet(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMCharacterSet_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMCharacterSet", o) != 0)
  {
    Py_DECREF(o);
  }

}

