// python wrapper for vtkDICOMDataElement
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMVR.h"
#include "vtkDICOMDataElement.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMDataElement(PyObject *dict); }

static PyObject *
PyvtkDICOMDataElement_GetTag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTag");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDataElement *op = static_cast<vtkDICOMDataElement *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMTag tempr = op->GetTag();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDataElement_GetVR(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVR");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDataElement *op = static_cast<vtkDICOMDataElement *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMVR tempr = op->GetVR();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMVR");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDataElement_IsPerInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsPerInstance");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDataElement *op = static_cast<vtkDICOMDataElement *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsPerInstance();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDataElement_GetNumberOfInstances(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfInstances");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDataElement *op = static_cast<vtkDICOMDataElement *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetNumberOfInstances();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDataElement_GetValue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDataElement *op = static_cast<vtkDICOMDataElement *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const vtkDICOMValue *tempr = &op->GetValue();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMDataElement_GetValue_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDataElement *op = static_cast<vtkDICOMDataElement *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const vtkDICOMValue *tempr = &op->GetValue(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMDataElement_GetValue(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMDataElement_GetValue_s1(self, args);
    case 1:
      return PyvtkDICOMDataElement_GetValue_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetValue");
  return nullptr;
}

static PyMethodDef PyvtkDICOMDataElement_Methods[] = {
  {"GetTag", PyvtkDICOMDataElement_GetTag, METH_VARARGS,
   "GetTag(self) -> vtkDICOMTag\nC++: vtkDICOMTag GetTag()\n\nGet the tag for this data element.\n"},
  {"GetVR", PyvtkDICOMDataElement_GetVR, METH_VARARGS,
   "GetVR(self) -> vtkDICOMVR\nC++: vtkDICOMVR GetVR()\n\nGet the VR for this data element.\n"},
  {"IsPerInstance", PyvtkDICOMDataElement_IsPerInstance, METH_VARARGS,
   "IsPerInstance(self) -> bool\nC++: bool IsPerInstance()\n\nCheck whether this data element carries per-instance values.\n"},
  {"GetNumberOfInstances", PyvtkDICOMDataElement_GetNumberOfInstances, METH_VARARGS,
   "GetNumberOfInstances(self) -> int\nC++: int GetNumberOfInstances()\n\nGet the number of value instances in this data element.\n"},
  {"GetValue", PyvtkDICOMDataElement_GetValue, METH_VARARGS,
   "GetValue(self) -> vtkDICOMValue\nC++: const vtkDICOMValue &GetValue()\nGetValue(self, i:int) -> vtkDICOMValue\nC++: const vtkDICOMValue &GetValue(int i)\n\nGet the value of the data element, if not multi-valued.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMDataElement_vtkDICOMDataElement_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDataElement");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMDataElement *op = new vtkDICOMDataElement();

    result = PyVTKSpecialObject_New("vtkDICOMDataElement", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMDataElement_vtkDICOMDataElement_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDataElement");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMValue *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMValue"))
  {
    vtkDICOMDataElement *op = new vtkDICOMDataElement(*temp0, *temp1);

    result = PyVTKSpecialObject_New("vtkDICOMDataElement", op);
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMDataElement_vtkDICOMDataElement_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDataElement");

  vtkDICOMDataElement *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMDataElement"))
  {
    vtkDICOMDataElement *op = new vtkDICOMDataElement(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMDataElement", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMDataElement_vtkDICOMDataElement_Methods[] = {
  {"vtkDICOMDataElement", PyvtkDICOMDataElement_vtkDICOMDataElement_s3, METH_VARARGS,
   "@W vtkDICOMDataElement"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMDataElement_vtkDICOMDataElement(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMDataElement_vtkDICOMDataElement_s1(self, args);
    case 2:
      return PyvtkDICOMDataElement_vtkDICOMDataElement_s2(self, args);
    case 1:
      return PyvtkDICOMDataElement_vtkDICOMDataElement_s3(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMDataElement");
  return nullptr;
}


static const char *PyvtkDICOMDataElement_Doc =

  "vtkDICOMDataElement() -> vtkDICOMDataElement\nC++: vtkDICOMDataElement()\nvtkDICOMDataElement(t:vtkDICOMTag, v:vtkDICOMValue)\n    -> vtkDICOMDataElement\nC++: vtkDICOMDataElement(const vtkDICOMTag &t, const vtkDICOMValue &v)\nvtkDICOMDataElement(__a:vtkDICOMDataElement) -> vtkDICOMDataElement\nC++: vtkDICOMDataElement(const &vtkDICOMDataElement)\n""\n"
  "vtkDICOMDataElement - A data element in a DICOM data set.\n\n"
  "The DataElement contains an encoded attribute value, along with the\n"
  "tag that identifies the attribute.  The data elements in a\n"
  "vtkDICOMMetaData object can be per-instance, with a different value\n"
  "for each data set instance used to build the the meta data for the\n"
  "image series.\n\n";

static PyObject *
PyvtkDICOMDataElement_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMDataElement_vtkDICOMDataElement(nullptr, args);
}

static void PyvtkDICOMDataElement_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMDataElement *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkDICOMDataElement_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkDICOMDataElement *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyUnicode_FromStringAndSize(s.data(), s.size());
}

static int PyvtkDICOMDataElement_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMDataElement_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMDataElement *so1 = nullptr;
  const vtkDICOMDataElement *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMDataElement_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMDataElement *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMDataElement *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMDataElement", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMDataElement_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMDataElement *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMDataElement *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMDataElement", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      break;
    case Py_LE:
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      break;
    case Py_GE:
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMDataElement_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMDataElement_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMDataElement", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMDataElement_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMDataElement_Hash, // tp_hash
  nullptr, // tp_call
  PyvtkDICOMDataElement_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMDataElement_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMDataElement_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMDataElement_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMDataElement_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMDataElement_Type);
}

static void *PyvtkDICOMDataElement_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMDataElement(*static_cast<const vtkDICOMDataElement*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMDataElement_TypeNew
extern "C" { PyObject *PyvtkDICOMDataElement_TypeNew(); }
#define DECLARED_PyvtkDICOMDataElement_TypeNew
#endif

PyObject *PyvtkDICOMDataElement_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMDataElement_Type,
    PyvtkDICOMDataElement_Methods,
    PyvtkDICOMDataElement_vtkDICOMDataElement_Methods,
    &PyvtkDICOMDataElement_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

static PyMethodDef PyvtkDICOMDataElementIterator_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMDataElementIterator_vtkDICOMDataElementIterator_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDataElementIterator");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMDataElementIterator *op = new vtkDICOMDataElementIterator();

    result = PyVTKSpecialObject_New("vtkDICOMDataElementIterator", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMDataElementIterator_vtkDICOMDataElementIterator_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDataElementIterator");

  vtkDICOMDataElementIterator *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMDataElementIterator"))
  {
    vtkDICOMDataElementIterator *op = new vtkDICOMDataElementIterator(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMDataElementIterator", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMDataElementIterator_vtkDICOMDataElementIterator_Methods[] = {
  {"vtkDICOMDataElementIterator", PyvtkDICOMDataElementIterator_vtkDICOMDataElementIterator_s2, METH_VARARGS,
   "@W vtkDICOMDataElementIterator"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMDataElementIterator_vtkDICOMDataElementIterator(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMDataElementIterator_vtkDICOMDataElementIterator_s1(self, args);
    case 1:
      return PyvtkDICOMDataElementIterator_vtkDICOMDataElementIterator_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMDataElementIterator");
  return nullptr;
}


static const char *PyvtkDICOMDataElementIterator_Doc =

  "vtkDICOMDataElementIterator() -> vtkDICOMDataElementIterator\nC++: vtkDICOMDataElementIterator()\nvtkDICOMDataElementIterator(__a:vtkDICOMDataElementIterator)\n    -> vtkDICOMDataElementIterator\nC++: vtkDICOMDataElementIterator(const &vtkDICOMDataElementIterator)\n""\n"
  "vtkDICOMDataElementIterator - A const iterator for a vtkDataElement\nlist.\n\n"
;

static PyObject *
PyvtkDICOMDataElementIterator_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMDataElementIterator_vtkDICOMDataElementIterator(nullptr, args);
}

static void PyvtkDICOMDataElementIterator_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMDataElementIterator *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static int PyvtkDICOMDataElementIterator_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMDataElementIterator_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMDataElementIterator *so1 = nullptr;
  const vtkDICOMDataElementIterator *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMDataElementIterator_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMDataElementIterator *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMDataElementIterator *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMDataElementIterator", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMDataElementIterator_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMDataElementIterator *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMDataElementIterator *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMDataElementIterator", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      break;
    case Py_LE:
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      break;
    case Py_GE:
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMDataElementIterator_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMDataElementIterator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMDataElementIterator", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMDataElementIterator_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMDataElementIterator_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMDataElementIterator_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMDataElementIterator_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMDataElementIterator_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMDataElementIterator_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMDataElementIterator_Type);
}

static void *PyvtkDICOMDataElementIterator_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMDataElementIterator(*static_cast<const vtkDICOMDataElementIterator*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMDataElementIterator_TypeNew
extern "C" { PyObject *PyvtkDICOMDataElementIterator_TypeNew(); }
#define DECLARED_PyvtkDICOMDataElementIterator_TypeNew
#endif

PyObject *PyvtkDICOMDataElementIterator_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMDataElementIterator_Type,
    PyvtkDICOMDataElementIterator_Methods,
    PyvtkDICOMDataElementIterator_vtkDICOMDataElementIterator_Methods,
    &PyvtkDICOMDataElementIterator_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMDataElement(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMDataElement_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMDataElement", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyvtkDICOMDataElementIterator_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMDataElementIterator", o) != 0)
  {
    Py_DECREF(o);
  }

}

