// python wrapper for vtkDICOMDictEntry
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMVR.h"
#include "vtkDICOMVM.h"
#include "vtkDICOMDictEntry.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMDictEntry(PyObject *dict); }

static PyObject *
PyvtkDICOMDictEntry_IsValid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsValid");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDictEntry *op = static_cast<vtkDICOMDictEntry *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsValid();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDictEntry_GetTag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTag");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDictEntry *op = static_cast<vtkDICOMDictEntry *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMTag tempr = op->GetTag();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDictEntry_GetVR(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVR");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDictEntry *op = static_cast<vtkDICOMDictEntry *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMVR tempr = op->GetVR();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMVR");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDictEntry_GetVM(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVM");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDictEntry *op = static_cast<vtkDICOMDictEntry *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMVM tempr = op->GetVM();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMVM");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDictEntry_GetName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetName");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDictEntry *op = static_cast<vtkDICOMDictEntry *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = op->GetName();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDictEntry_IsRetired(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsRetired");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMDictEntry *op = static_cast<vtkDICOMDictEntry *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsRetired();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMDictEntry_Methods[] = {
  {"IsValid", PyvtkDICOMDictEntry_IsValid, METH_VARARGS,
   "IsValid(self) -> bool\nC++: bool IsValid()\n\nCheck whether the returned entry is valid.\n"},
  {"GetTag", PyvtkDICOMDictEntry_GetTag, METH_VARARGS,
   "GetTag(self) -> vtkDICOMTag\nC++: vtkDICOMTag GetTag()\n\nGet the DICOM tag for this dictionary entry.\n"},
  {"GetVR", PyvtkDICOMDictEntry_GetVR, METH_VARARGS,
   "GetVR(self) -> vtkDICOMVR\nC++: vtkDICOMVR GetVR()\n\nGet the VR for this dictionary entry.\n"},
  {"GetVM", PyvtkDICOMDictEntry_GetVM, METH_VARARGS,
   "GetVM(self) -> vtkDICOMVM\nC++: vtkDICOMVM GetVM()\n\nGet the VM for this dictionary entry.\n"},
  {"GetName", PyvtkDICOMDictEntry_GetName, METH_VARARGS,
   "GetName(self) -> str\nC++: const char *GetName()\n\nGet a human-readable name for this dictionary entry.\n"},
  {"IsRetired", PyvtkDICOMDictEntry_IsRetired, METH_VARARGS,
   "IsRetired(self) -> bool\nC++: bool IsRetired()\n\nCheck whether this entry has been retired from the DICOM\nstandard.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMDictEntry_vtkDICOMDictEntry_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDictEntry");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMDictEntry *op = new vtkDICOMDictEntry();

    result = PyVTKSpecialObject_New("vtkDICOMDictEntry", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMDictEntry_vtkDICOMDictEntry_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDictEntry");

  vtkDICOMDictEntry *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMDictEntry"))
  {
    vtkDICOMDictEntry *op = new vtkDICOMDictEntry(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMDictEntry", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMDictEntry_vtkDICOMDictEntry_Methods[] = {
  {"vtkDICOMDictEntry", PyvtkDICOMDictEntry_vtkDICOMDictEntry_s2, METH_VARARGS,
   "@W vtkDICOMDictEntry"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMDictEntry_vtkDICOMDictEntry(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMDictEntry_vtkDICOMDictEntry_s1(self, args);
    case 1:
      return PyvtkDICOMDictEntry_vtkDICOMDictEntry_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMDictEntry");
  return nullptr;
}


static const char *PyvtkDICOMDictEntry_Doc =

  "vtkDICOMDictEntry() -> vtkDICOMDictEntry\nC++: vtkDICOMDictEntry()\nvtkDICOMDictEntry(__a:vtkDICOMDictEntry) -> vtkDICOMDictEntry\nC++: vtkDICOMDictEntry(const &vtkDICOMDictEntry)\n""\n"
  "vtkDICOMDictEntry - An entry in the DICOM dictionary.\n\n"
;

static PyObject *
PyvtkDICOMDictEntry_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMDictEntry_vtkDICOMDictEntry(nullptr, args);
}

static void PyvtkDICOMDictEntry_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMDictEntry *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkDICOMDictEntry_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkDICOMDictEntry *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyUnicode_FromStringAndSize(s.data(), s.size());
}

static Py_hash_t PyvtkDICOMDictEntry_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMDictEntry_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMDictEntry", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMDictEntry_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMDictEntry_Hash, // tp_hash
  nullptr, // tp_call
  PyvtkDICOMDictEntry_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMDictEntry_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMDictEntry_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkDICOMDictEntry_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMDictEntry(*static_cast<const vtkDICOMDictEntry*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMDictEntry_TypeNew
extern "C" { PyObject *PyvtkDICOMDictEntry_TypeNew(); }
#define DECLARED_PyvtkDICOMDictEntry_TypeNew
#endif

PyObject *PyvtkDICOMDictEntry_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMDictEntry_Type,
    PyvtkDICOMDictEntry_Methods,
    PyvtkDICOMDictEntry_vtkDICOMDictEntry_Methods,
    &PyvtkDICOMDictEntry_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMDictEntry(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMDictEntry_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMDictEntry", o) != 0)
  {
    Py_DECREF(o);
  }

}

