// python wrapper for vtkDICOMDictionary
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMDictEntry.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMDictionary.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMDictionary(PyObject *dict); }

static PyObject *
PyvtkDICOMDictionary_FindDictEntry_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "FindDictEntry");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    vtkDICOMDictEntry tempr = vtkDICOMDictionary::FindDictEntry(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDictEntry");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMDictionary_FindDictEntry_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "FindDictEntry");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMDictEntry tempr = vtkDICOMDictionary::FindDictEntry(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDictEntry");
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMDictionary_FindDictEntry_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "FindDictEntry");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    vtkDICOMDictEntry tempr = vtkDICOMDictionary::FindDictEntry(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDictEntry");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMDictionary_FindDictEntry_s4(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "FindDictEntry");

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkDICOMDictEntry tempr = vtkDICOMDictionary::FindDictEntry(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDictEntry");
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMDictionary_FindDictEntry_Methods[] = {
  {"FindDictEntry", PyvtkDICOMDictionary_FindDictEntry_s1, METH_VARARGS | METH_STATIC,
   "W vtkDICOMTag"},
  {"FindDictEntry", PyvtkDICOMDictionary_FindDictEntry_s2, METH_VARARGS | METH_STATIC,
   "z"},
  {"FindDictEntry", PyvtkDICOMDictionary_FindDictEntry_s3, METH_VARARGS | METH_STATIC,
   "Wz vtkDICOMTag"},
  {"FindDictEntry", PyvtkDICOMDictionary_FindDictEntry_s4, METH_VARARGS | METH_STATIC,
   "zz"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMDictionary_FindDictEntry(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMDictionary_FindDictEntry_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "FindDictEntry");
  return nullptr;
}


static PyObject *
PyvtkDICOMDictionary_RemovePrivateDictionary(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "RemovePrivateDictionary");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMDictionary::RemovePrivateDictionary(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMDictionary_Methods[] = {
  {"FindDictEntry", PyvtkDICOMDictionary_FindDictEntry, METH_VARARGS,
   "FindDictEntry(tag:vtkDICOMTag) -> vtkDICOMDictEntry\nC++: static vtkDICOMDictEntry FindDictEntry(const vtkDICOMTag tag)\nFindDictEntry(key:str) -> vtkDICOMDictEntry\nC++: static vtkDICOMDictEntry FindDictEntry(const char *key)\nFindDictEntry(tag:vtkDICOMTag, privateDict:str)\n    -> vtkDICOMDictEntry\nC++: static vtkDICOMDictEntry FindDictEntry(const vtkDICOMTag tag,\n     const char *privateDict)\nFindDictEntry(key:str, privateDict:str) -> vtkDICOMDictEntry\nC++: static vtkDICOMDictEntry FindDictEntry(const char *key,\n    const char *privateDict)\n\nFind the dictionary entry for the given tag.\n"},
  {"RemovePrivateDictionary", PyvtkDICOMDictionary_RemovePrivateDictionary, METH_VARARGS,
   "RemovePrivateDictionary(name:str) -> None\nC++: static void RemovePrivateDictionary(const char *name)\n\nRemove a private dictionary.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMDictionary_vtkDICOMDictionary_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDictionary");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMDictionary *op = new vtkDICOMDictionary();

    result = PyVTKSpecialObject_New("vtkDICOMDictionary", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMDictionary_vtkDICOMDictionary_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDictionary");

  vtkDICOMDictionary *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMDictionary"))
  {
    vtkDICOMDictionary *op = new vtkDICOMDictionary(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMDictionary", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMDictionary_vtkDICOMDictionary_Methods[] = {
  {"vtkDICOMDictionary", PyvtkDICOMDictionary_vtkDICOMDictionary_s2, METH_VARARGS,
   "@W vtkDICOMDictionary"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMDictionary_vtkDICOMDictionary(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMDictionary_vtkDICOMDictionary_s1(self, args);
    case 1:
      return PyvtkDICOMDictionary_vtkDICOMDictionary_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMDictionary");
  return nullptr;
}


static const char *PyvtkDICOMDictionary_Doc =

  "vtkDICOMDictionary() -> vtkDICOMDictionary\nC++: vtkDICOMDictionary()\nvtkDICOMDictionary(__a:vtkDICOMDictionary) -> vtkDICOMDictionary\nC++: vtkDICOMDictionary(const &vtkDICOMDictionary)\n""\n"
  "vtkDICOMDictionary - Provide access to the DICOM tag dictionary.\n\n"
;

static PyObject *
PyvtkDICOMDictionary_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMDictionary_vtkDICOMDictionary(nullptr, args);
}

static void PyvtkDICOMDictionary_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMDictionary *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDICOMDictionary_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMDictionary_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMDictionary", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMDictionary_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMDictionary_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMDictionary_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMDictionary_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkDICOMDictionary_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMDictionary(*static_cast<const vtkDICOMDictionary*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMDictionary_TypeNew
extern "C" { PyObject *PyvtkDICOMDictionary_TypeNew(); }
#define DECLARED_PyvtkDICOMDictionary_TypeNew
#endif

PyObject *PyvtkDICOMDictionary_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMDictionary_Type,
    PyvtkDICOMDictionary_Methods,
    PyvtkDICOMDictionary_vtkDICOMDictionary_Methods,
    &PyvtkDICOMDictionary_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

static PyMethodDef PyvtkDICOMDictionaryInitializer_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMDictionaryInitializer_vtkDICOMDictionaryInitializer(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMDictionaryInitializer");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMDictionaryInitializer *op = new vtkDICOMDictionaryInitializer();

    result = PyVTKSpecialObject_New("vtkDICOMDictionaryInitializer", op);
  }

  return result;
}

static PyMethodDef PyvtkDICOMDictionaryInitializer_vtkDICOMDictionaryInitializer_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static const char *PyvtkDICOMDictionaryInitializer_Doc =

  "vtkDICOMDictionaryInitializer() -> vtkDICOMDictionaryInitializer\nC++: vtkDICOMDictionaryInitializer()\n""\n"
  "vtkDICOMDictionaryInitializer - @cond\n\n"
  "Initializer (Schwarz counter).\n\n"
  "This ensures that the vtkDICOMDictionary module is initialized before\n"
  "any other module that includes this header file.\n\n";

static PyObject *
PyvtkDICOMDictionaryInitializer_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMDictionaryInitializer_vtkDICOMDictionaryInitializer(nullptr, args);
}

static void PyvtkDICOMDictionaryInitializer_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMDictionaryInitializer *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDICOMDictionaryInitializer_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMDictionaryInitializer_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMDictionaryInitializer", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMDictionaryInitializer_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMDictionaryInitializer_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMDictionaryInitializer_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMDictionaryInitializer_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

#ifndef DECLARED_PyvtkDICOMDictionaryInitializer_TypeNew
extern "C" { PyObject *PyvtkDICOMDictionaryInitializer_TypeNew(); }
#define DECLARED_PyvtkDICOMDictionaryInitializer_TypeNew
#endif

PyObject *PyvtkDICOMDictionaryInitializer_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMDictionaryInitializer_Type,
    PyvtkDICOMDictionaryInitializer_Methods,
    PyvtkDICOMDictionaryInitializer_vtkDICOMDictionaryInitializer_Methods,
    nullptr);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMDictionary(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMDictionary_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMDictionary", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyvtkDICOMDictionaryInitializer_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMDictionaryInitializer", o) != 0)
  {
    Py_DECREF(o);
  }

}

