// python wrapper for vtkDICOMDirectory
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMCharacterSet.h"
#include "vtkDICOMDirectory.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMDirectory(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMDirectory_ClassNew(); }


static PyObject *
PyvtkDICOMDirectory_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMDirectory::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMDirectory::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMDirectory *tempr = vtkDICOMDirectory::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMDirectory *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMDirectory::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMDirectory::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMDirectory::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetDirectoryName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDirectoryName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetFilePath(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDirectoryName(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetDirectoryName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetDirectoryName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDirectoryName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDirectoryName() :
      op->vtkDICOMDirectory::GetDirectoryName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetInputFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  vtkStringArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkStringArray"))
  {
    if (ap.IsBound())
    {
      op->SetInputFileNames(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetInputFileNames(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetInputFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInputFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetInputFileNames() :
      op->vtkDICOMDirectory::GetInputFileNames());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_AddInputFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddInputFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  vtkStringArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkStringArray"))
  {
    if (ap.IsBound())
    {
      op->AddInputFileNames(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::AddInputFileNames(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetFilePattern(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFilePattern");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFilePattern(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetFilePattern(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetFilePattern(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFilePattern");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFilePattern() :
      op->vtkDICOMDirectory::GetFilePattern());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetScanDepth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScanDepth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScanDepth(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetScanDepth(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetScanDepth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScanDepth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetScanDepth() :
      op->vtkDICOMDirectory::GetScanDepth());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetFindQuery(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFindQuery");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  vtkDICOMItem *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMItem"))
  {
    if (ap.IsBound())
    {
      op->SetFindQuery(*temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetFindQuery(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetFindLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFindLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFindLevel(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetFindLevel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetFindLevelToImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFindLevelToImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFindLevelToImage();
    }
    else
    {
      op->vtkDICOMDirectory::SetFindLevelToImage();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetFindLevelToSeries(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFindLevelToSeries");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFindLevelToSeries();
    }
    else
    {
      op->vtkDICOMDirectory::SetFindLevelToSeries();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetFindLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFindLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFindLevel() :
      op->vtkDICOMDirectory::GetFindLevel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_Update_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkDICOMDirectory::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMDirectory_Update_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->Update(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::Update(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMDirectory_Update_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  vtkInformation *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkInformation"))
  {
    int tempr = (ap.IsBound() ?
      op->Update(temp0) :
      op->vtkDICOMDirectory::Update(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMDirectory_Update_s4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  vtkInformationVector *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkInformationVector"))
  {
    int tempr = (ap.IsBound() ?
      op->Update(temp0, temp1) :
      op->vtkDICOMDirectory::Update(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMDirectory_Update_Methods[] = {
  {"Update", PyvtkDICOMDirectory_Update_s2, METH_VARARGS,
   "@i"},
  {"Update", PyvtkDICOMDirectory_Update_s3, METH_VARARGS,
   "@V *vtkInformation"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMDirectory_Update(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMDirectory_Update_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMDirectory_Update_s1(self, args);
    case 2:
      return PyvtkDICOMDirectory_Update_s4(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Update");
  return nullptr;
}


static PyObject *
PyvtkDICOMDirectory_GetNumberOfSeries(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfSeries");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfSeries() :
      op->vtkDICOMDirectory::GetNumberOfSeries());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetSeriesRecord(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSeriesRecord");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const vtkDICOMItem *tempr = (ap.IsBound() ?
      &op->GetSeriesRecord(temp0) :
      &op->vtkDICOMDirectory::GetSeriesRecord(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMItem");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetNumberOfStudies(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfStudies");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfStudies() :
      op->vtkDICOMDirectory::GetNumberOfStudies());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetStudyRecord(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStudyRecord");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const vtkDICOMItem *tempr = (ap.IsBound() ?
      &op->GetStudyRecord(temp0) :
      &op->vtkDICOMDirectory::GetStudyRecord(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMItem");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetPatientRecordForStudy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPatientRecordForStudy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const vtkDICOMItem *tempr = (ap.IsBound() ?
      &op->GetPatientRecordForStudy(temp0) :
      &op->vtkDICOMDirectory::GetPatientRecordForStudy(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMItem");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetNumberOfPatients(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPatients");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfPatients() :
      op->vtkDICOMDirectory::GetNumberOfPatients());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetPatientRecord(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPatientRecord");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const vtkDICOMItem *tempr = (ap.IsBound() ?
      &op->GetPatientRecord(temp0) :
      &op->vtkDICOMDirectory::GetPatientRecord(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMItem");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetStudiesForPatient(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStudiesForPatient");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetStudiesForPatient(temp0) :
      op->vtkDICOMDirectory::GetStudiesForPatient(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetFirstSeriesForStudy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFirstSeriesForStudy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFirstSeriesForStudy(temp0) :
      op->vtkDICOMDirectory::GetFirstSeriesForStudy(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetLastSeriesForStudy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastSeriesForStudy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLastSeriesForStudy(temp0) :
      op->vtkDICOMDirectory::GetLastSeriesForStudy(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetFileNamesForSeries(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileNamesForSeries");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetFileNamesForSeries(temp0) :
      op->vtkDICOMDirectory::GetFileNamesForSeries(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetMetaDataForSeries(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMetaDataForSeries");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMMetaData *tempr = (ap.IsBound() ?
      op->GetMetaDataForSeries(temp0) :
      op->vtkDICOMDirectory::GetMetaDataForSeries(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetQueryFilesToAlways(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQueryFilesToAlways");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetQueryFilesToAlways();
    }
    else
    {
      op->vtkDICOMDirectory::SetQueryFilesToAlways();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetQueryFilesToNever(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQueryFilesToNever");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetQueryFilesToNever();
    }
    else
    {
      op->vtkDICOMDirectory::SetQueryFilesToNever();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetQueryFilesToDefault(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQueryFilesToDefault");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetQueryFilesToDefault();
    }
    else
    {
      op->vtkDICOMDirectory::SetQueryFilesToDefault();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetQueryFiles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQueryFiles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQueryFiles(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetQueryFiles(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetQueryFiles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQueryFiles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetQueryFiles() :
      op->vtkDICOMDirectory::GetQueryFiles());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetFileSetID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileSetID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFileSetID() :
      op->vtkDICOMDirectory::GetFileSetID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetInternalFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInternalFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetInternalFileName() :
      op->vtkDICOMDirectory::GetInternalFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetIgnoreDicomdir(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIgnoreDicomdir");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIgnoreDicomdir(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetIgnoreDicomdir(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_IgnoreDicomdirOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IgnoreDicomdirOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->IgnoreDicomdirOn();
    }
    else
    {
      op->vtkDICOMDirectory::IgnoreDicomdirOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_IgnoreDicomdirOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IgnoreDicomdirOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->IgnoreDicomdirOff();
    }
    else
    {
      op->vtkDICOMDirectory::IgnoreDicomdirOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetIgnoreDicomdir(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIgnoreDicomdir");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetIgnoreDicomdir() :
      op->vtkDICOMDirectory::GetIgnoreDicomdir());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetRequirePixelData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRequirePixelData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRequirePixelData(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetRequirePixelData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_RequirePixelDataOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RequirePixelDataOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RequirePixelDataOn();
    }
    else
    {
      op->vtkDICOMDirectory::RequirePixelDataOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_RequirePixelDataOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RequirePixelDataOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RequirePixelDataOff();
    }
    else
    {
      op->vtkDICOMDirectory::RequirePixelDataOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetRequirePixelData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRequirePixelData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRequirePixelData() :
      op->vtkDICOMDirectory::GetRequirePixelData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetFollowSymlinks(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFollowSymlinks");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFollowSymlinks(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetFollowSymlinks(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_FollowSymlinksOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FollowSymlinksOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->FollowSymlinksOn();
    }
    else
    {
      op->vtkDICOMDirectory::FollowSymlinksOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_FollowSymlinksOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FollowSymlinksOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->FollowSymlinksOff();
    }
    else
    {
      op->vtkDICOMDirectory::FollowSymlinksOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetFollowSymlinks(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFollowSymlinks");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFollowSymlinks() :
      op->vtkDICOMDirectory::GetFollowSymlinks());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetShowHidden(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShowHidden");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetShowHidden(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetShowHidden(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_ShowHiddenOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ShowHiddenOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ShowHiddenOn();
    }
    else
    {
      op->vtkDICOMDirectory::ShowHiddenOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_ShowHiddenOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ShowHiddenOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ShowHiddenOff();
    }
    else
    {
      op->vtkDICOMDirectory::ShowHiddenOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetShowHidden(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShowHidden");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetShowHidden() :
      op->vtkDICOMDirectory::GetShowHidden());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetDefaultCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDefaultCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  vtkDICOMCharacterSet *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMCharacterSet"))
  {
    if (ap.IsBound())
    {
      op->SetDefaultCharacterSet(*temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetDefaultCharacterSet(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetDefaultCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMCharacterSet tempr = (ap.IsBound() ?
      op->GetDefaultCharacterSet() :
      op->vtkDICOMDirectory::GetDefaultCharacterSet());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMCharacterSet");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_SetOverrideCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverrideCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOverrideCharacterSet(temp0);
    }
    else
    {
      op->vtkDICOMDirectory::SetOverrideCharacterSet(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_OverrideCharacterSetOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OverrideCharacterSetOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OverrideCharacterSetOn();
    }
    else
    {
      op->vtkDICOMDirectory::OverrideCharacterSetOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_OverrideCharacterSetOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OverrideCharacterSetOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OverrideCharacterSetOff();
    }
    else
    {
      op->vtkDICOMDirectory::OverrideCharacterSetOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMDirectory_GetOverrideCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverrideCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMDirectory *op = static_cast<vtkDICOMDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetOverrideCharacterSet() :
      op->vtkDICOMDirectory::GetOverrideCharacterSet());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMDirectory_Methods[] = {
  {"IsTypeOf", PyvtkDICOMDirectory_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMDirectory_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMDirectory_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMDirectory\nC++: static vtkDICOMDirectory *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMDirectory_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMDirectory\nC++: vtkDICOMDirectory *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMDirectory_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMDirectory_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetDirectoryName", PyvtkDICOMDirectory_SetDirectoryName, METH_VARARGS,
   "SetDirectoryName(self, name:str) -> None\nC++: void SetDirectoryName(const char *name)\n\nSet the input directory.\n\nIf the directory has a DICOMDIR file, then that file will be\nscanned to get information about the DICOM files in the\ndirectory.  Otherwise, the directory will be scanned for DICOM\nfiles.  The depth of the scan (how many subdirectories deep) can\nbe controlled with the SetScanDepth() method.\n"},
  {"GetDirectoryName", PyvtkDICOMDirectory_GetDirectoryName, METH_VARARGS,
   "GetDirectoryName(self) -> str\nC++: const char *GetDirectoryName()\n\nSet the input directory.\n\nIf the directory has a DICOMDIR file, then that file will be\nscanned to get information about the DICOM files in the\ndirectory.  Otherwise, the directory will be scanned for DICOM\nfiles.  The depth of the scan (how many subdirectories deep) can\nbe controlled with the SetScanDepth() method.\n"},
  {"SetInputFileNames", PyvtkDICOMDirectory_SetInputFileNames, METH_VARARGS,
   "SetInputFileNames(self, sa:vtkStringArray) -> None\nC++: void SetInputFileNames(vtkStringArray *sa)\n\nSet a list of filenames (or files and directories) to read.\n\nThis can be used as alternative to setting a single input\ndirectory.\n"},
  {"GetInputFileNames", PyvtkDICOMDirectory_GetInputFileNames, METH_VARARGS,
   "GetInputFileNames(self) -> vtkStringArray\nC++: vtkStringArray *GetInputFileNames()\n\nSet a list of filenames (or files and directories) to read.\n\nThis can be used as alternative to setting a single input\ndirectory.\n"},
  {"AddInputFileNames", PyvtkDICOMDirectory_AddInputFileNames, METH_VARARGS,
   "AddInputFileNames(self, sa:vtkStringArray) -> None\nC++: void AddInputFileNames(vtkStringArray *sa)\n\nAdd more filenames to be read.\n\nThis allows the directory to be updated.  The new files can\nbelong to an existing series or a new series.  If any of the new\nfiles are already present in the directory, then nothing will be\ndone for those files.\n"},
  {"SetFilePattern", PyvtkDICOMDirectory_SetFilePattern, METH_VARARGS,
   "SetFilePattern(self, pattern:str) -> None\nC++: void SetFilePattern(const char *pattern)\n\nSet a pattern to match for the filenames.\n\nFor example \"*.dcm\" will match files ending with \".dcm\".  The two\nwildcards that are supported are \"*\" and \"?\".\n"},
  {"GetFilePattern", PyvtkDICOMDirectory_GetFilePattern, METH_VARARGS,
   "GetFilePattern(self) -> str\nC++: const char *GetFilePattern()\n\nSet a pattern to match for the filenames.\n\nFor example \"*.dcm\" will match files ending with \".dcm\".  The two\nwildcards that are supported are \"*\" and \"?\".\n"},
  {"SetScanDepth", PyvtkDICOMDirectory_SetScanDepth, METH_VARARGS,
   "SetScanDepth(self, _arg:int) -> None\nC++: virtual void SetScanDepth(int _arg)\n\nSet the scan depth to use when no DICOMDIR is found.\n\nThe default scan depth is 1, which scans only the given directory\nand no subdirectories.  A scan depth of zero means that the\ndirectory will not be scanned unless it contains a DICOMDIR file.\n"},
  {"GetScanDepth", PyvtkDICOMDirectory_GetScanDepth, METH_VARARGS,
   "GetScanDepth(self) -> int\nC++: int GetScanDepth()\n\nSet the scan depth to use when no DICOMDIR is found.\n\nThe default scan depth is 1, which scans only the given directory\nand no subdirectories.  A scan depth of zero means that the\ndirectory will not be scanned unless it contains a DICOMDIR file.\n"},
  {"SetFindQuery", PyvtkDICOMDirectory_SetFindQuery, METH_VARARGS,
   "SetFindQuery(self, query:vtkDICOMItem) -> None\nC++: void SetFindQuery(const vtkDICOMItem &query)\n\nSpecify a find query.\n"},
  {"SetFindLevel", PyvtkDICOMDirectory_SetFindLevel, METH_VARARGS,
   "SetFindLevel(self, level:int) -> None\nC++: void SetFindLevel(int level)\n\nSpecify the find level.\n\nIf this is Series, then the whole series will be found if a\nsingle file in the series matches the query.  Only IMAGE and\nSERIES are allowed.  Note that IMAGE is inclusive of any single\nfile, whether or not the contained data is an image.\n"},
  {"SetFindLevelToImage", PyvtkDICOMDirectory_SetFindLevelToImage, METH_VARARGS,
   "SetFindLevelToImage(self) -> None\nC++: void SetFindLevelToImage()\n\nSpecify the find level.\n\nIf this is Series, then the whole series will be found if a\nsingle file in the series matches the query.  Only IMAGE and\nSERIES are allowed.  Note that IMAGE is inclusive of any single\nfile, whether or not the contained data is an image.\n"},
  {"SetFindLevelToSeries", PyvtkDICOMDirectory_SetFindLevelToSeries, METH_VARARGS,
   "SetFindLevelToSeries(self) -> None\nC++: void SetFindLevelToSeries()\n\nSpecify the find level.\n\nIf this is Series, then the whole series will be found if a\nsingle file in the series matches the query.  Only IMAGE and\nSERIES are allowed.  Note that IMAGE is inclusive of any single\nfile, whether or not the contained data is an image.\n"},
  {"GetFindLevel", PyvtkDICOMDirectory_GetFindLevel, METH_VARARGS,
   "GetFindLevel(self) -> int\nC++: int GetFindLevel()\n\nSpecify the find level.\n\nIf this is Series, then the whole series will be found if a\nsingle file in the series matches the query.  Only IMAGE and\nSERIES are allowed.  Note that IMAGE is inclusive of any single\nfile, whether or not the contained data is an image.\n"},
  {"Update", PyvtkDICOMDirectory_Update, METH_VARARGS,
   "Update(self) -> None\nC++: void Update() override;\nUpdate(self, __a:int) -> None\nC++: void Update(int) override;\nUpdate(self, __a:vtkInformation) -> int\nC++: vtkTypeBool Update(vtkInformation *) override;\nUpdate(self, i:int, __b:vtkInformationVector) -> int\nC++: vtkTypeBool Update(int i, vtkInformationVector *) override;\n\nUpdate the information about the files.\n\nThis method causes the directory to be read.  It must be called\nbefore any of the Get methods.\n"},
  {"GetNumberOfSeries", PyvtkDICOMDirectory_GetNumberOfSeries, METH_VARARGS,
   "GetNumberOfSeries(self) -> int\nC++: int GetNumberOfSeries()\n\nGet the total number of series that were found.\n"},
  {"GetSeriesRecord", PyvtkDICOMDirectory_GetSeriesRecord, METH_VARARGS,
   "GetSeriesRecord(self, series:int) -> vtkDICOMItem\nC++: const vtkDICOMItem &GetSeriesRecord(int series)\n\nGet the directory attributes for a series.\n"},
  {"GetNumberOfStudies", PyvtkDICOMDirectory_GetNumberOfStudies, METH_VARARGS,
   "GetNumberOfStudies(self) -> int\nC++: int GetNumberOfStudies()\n\nGet the number of studies that were found.\n"},
  {"GetStudyRecord", PyvtkDICOMDirectory_GetStudyRecord, METH_VARARGS,
   "GetStudyRecord(self, study:int) -> vtkDICOMItem\nC++: const vtkDICOMItem &GetStudyRecord(int study)\n\nGet the directory attributes for a study.\n"},
  {"GetPatientRecordForStudy", PyvtkDICOMDirectory_GetPatientRecordForStudy, METH_VARARGS,
   "GetPatientRecordForStudy(self, study:int) -> vtkDICOMItem\nC++: const vtkDICOMItem &GetPatientRecordForStudy(int study)\n\nGet the patient-related attributes for a specific study.\n\nThis returns a patient record, the same as GetPatientRecord(),\nexcept that it returns the patient information as recorded at the\ntime of the study.\n"},
  {"GetNumberOfPatients", PyvtkDICOMDirectory_GetNumberOfPatients, METH_VARARGS,
   "GetNumberOfPatients(self) -> int\nC++: int GetNumberOfPatients()\n\nGet the number of patients that were found.\n"},
  {"GetPatientRecord", PyvtkDICOMDirectory_GetPatientRecord, METH_VARARGS,
   "GetPatientRecord(self, patient:int) -> vtkDICOMItem\nC++: const vtkDICOMItem &GetPatientRecord(int patient)\n\nGet the directory attributes for a patient.\n"},
  {"GetStudiesForPatient", PyvtkDICOMDirectory_GetStudiesForPatient, METH_VARARGS,
   "GetStudiesForPatient(self, patient:int) -> vtkIntArray\nC++: vtkIntArray *GetStudiesForPatient(int patient)\n\nGet the studies for this patient.\n"},
  {"GetFirstSeriesForStudy", PyvtkDICOMDirectory_GetFirstSeriesForStudy, METH_VARARGS,
   "GetFirstSeriesForStudy(self, study:int) -> int\nC++: int GetFirstSeriesForStudy(int study)\n\nGet the first series in a particular study.\n"},
  {"GetLastSeriesForStudy", PyvtkDICOMDirectory_GetLastSeriesForStudy, METH_VARARGS,
   "GetLastSeriesForStudy(self, study:int) -> int\nC++: int GetLastSeriesForStudy(int study)\n\nGet the last series in a particular study.\n"},
  {"GetFileNamesForSeries", PyvtkDICOMDirectory_GetFileNamesForSeries, METH_VARARGS,
   "GetFileNamesForSeries(self, i:int) -> vtkStringArray\nC++: vtkStringArray *GetFileNamesForSeries(int i)\n\nGet the file names for a specific series.\n"},
  {"GetMetaDataForSeries", PyvtkDICOMDirectory_GetMetaDataForSeries, METH_VARARGS,
   "GetMetaDataForSeries(self, i:int) -> vtkDICOMMetaData\nC++: vtkDICOMMetaData *GetMetaDataForSeries(int i)\n\nGet the meta data for a specific series.\n\nThis provides a subset of the meta data of each file in the\nseries. To be specific, it contains all the information from the\npatient, study, and, at the very minimum, the SOPClassUID,\nSOPInstanceUID, and InstanceNumber for each file.\n"},
  {"SetQueryFilesToAlways", PyvtkDICOMDirectory_SetQueryFilesToAlways, METH_VARARGS,
   "SetQueryFilesToAlways(self) -> None\nC++: void SetQueryFilesToAlways()\n\nSet when to query the files, rather than just the DICOMDIR index.\n\nIf a DICOMDIR file is present, the default behavior is to only\nquery the other files in the directory if the Query contains\nelements that cannot be elucidated from the DICOMDIR file. For\nAlways, the data returned by GetMetaDataForSeries() will always\nbe data from the file, not the DICOMDIR (though the data returned\nby GetSeriesRecord() etc. will be from DICOMDIR). For Never, the\nfiles will never be scanned if a DICOMDIR is present, which means\nthat any Query that is applied can only check attributes that are\npresent in the DICOMDIR.\n"},
  {"SetQueryFilesToNever", PyvtkDICOMDirectory_SetQueryFilesToNever, METH_VARARGS,
   "SetQueryFilesToNever(self) -> None\nC++: void SetQueryFilesToNever()\n\n"},
  {"SetQueryFilesToDefault", PyvtkDICOMDirectory_SetQueryFilesToDefault, METH_VARARGS,
   "SetQueryFilesToDefault(self) -> None\nC++: void SetQueryFilesToDefault()\n\n"},
  {"SetQueryFiles", PyvtkDICOMDirectory_SetQueryFiles, METH_VARARGS,
   "SetQueryFiles(self, _arg:int) -> None\nC++: virtual void SetQueryFiles(int _arg)\n\n"},
  {"GetQueryFiles", PyvtkDICOMDirectory_GetQueryFiles, METH_VARARGS,
   "GetQueryFiles(self) -> int\nC++: int GetQueryFiles()\n\n"},
  {"GetFileSetID", PyvtkDICOMDirectory_GetFileSetID, METH_VARARGS,
   "GetFileSetID(self) -> str\nC++: const char *GetFileSetID()\n\nGet the file set ID.  This will be NULL unless a DICOMDIR was\nfound.\n"},
  {"GetInternalFileName", PyvtkDICOMDirectory_GetInternalFileName, METH_VARARGS,
   "GetInternalFileName(self) -> str\nC++: const char *GetInternalFileName()\n\nGet the filename associated with the error code.\n"},
  {"SetIgnoreDicomdir", PyvtkDICOMDirectory_SetIgnoreDicomdir, METH_VARARGS,
   "SetIgnoreDicomdir(self, _arg:int) -> None\nC++: virtual void SetIgnoreDicomdir(int _arg)\n\nIf On, the DICOMDIR file will be ignored.\n\nThis method can be used to ignore the DICOMDIR file if it is\npresent, instead of using the DICOMDIR file as an index.\n"},
  {"IgnoreDicomdirOn", PyvtkDICOMDirectory_IgnoreDicomdirOn, METH_VARARGS,
   "IgnoreDicomdirOn(self) -> None\nC++: virtual void IgnoreDicomdirOn()\n\nIf On, the DICOMDIR file will be ignored.\n\nThis method can be used to ignore the DICOMDIR file if it is\npresent, instead of using the DICOMDIR file as an index.\n"},
  {"IgnoreDicomdirOff", PyvtkDICOMDirectory_IgnoreDicomdirOff, METH_VARARGS,
   "IgnoreDicomdirOff(self) -> None\nC++: virtual void IgnoreDicomdirOff()\n\nIf On, the DICOMDIR file will be ignored.\n\nThis method can be used to ignore the DICOMDIR file if it is\npresent, instead of using the DICOMDIR file as an index.\n"},
  {"GetIgnoreDicomdir", PyvtkDICOMDirectory_GetIgnoreDicomdir, METH_VARARGS,
   "GetIgnoreDicomdir(self) -> int\nC++: int GetIgnoreDicomdir()\n\nIf On, the DICOMDIR file will be ignored.\n\nThis method can be used to ignore the DICOMDIR file if it is\npresent, instead of using the DICOMDIR file as an index.\n"},
  {"SetRequirePixelData", PyvtkDICOMDirectory_SetRequirePixelData, METH_VARARGS,
   "SetRequirePixelData(self, _arg:int) -> None\nC++: virtual void SetRequirePixelData(int _arg)\n\nIf this is On, files with no pixel data will be skipped.\n\nThis is On by default.  Some files, such as dicom directory\nfiles, have metadata but have no images.  Usually we want to skip\nthese.\n"},
  {"RequirePixelDataOn", PyvtkDICOMDirectory_RequirePixelDataOn, METH_VARARGS,
   "RequirePixelDataOn(self) -> None\nC++: virtual void RequirePixelDataOn()\n\nIf this is On, files with no pixel data will be skipped.\n\nThis is On by default.  Some files, such as dicom directory\nfiles, have metadata but have no images.  Usually we want to skip\nthese.\n"},
  {"RequirePixelDataOff", PyvtkDICOMDirectory_RequirePixelDataOff, METH_VARARGS,
   "RequirePixelDataOff(self) -> None\nC++: virtual void RequirePixelDataOff()\n\nIf this is On, files with no pixel data will be skipped.\n\nThis is On by default.  Some files, such as dicom directory\nfiles, have metadata but have no images.  Usually we want to skip\nthese.\n"},
  {"GetRequirePixelData", PyvtkDICOMDirectory_GetRequirePixelData, METH_VARARGS,
   "GetRequirePixelData(self) -> int\nC++: int GetRequirePixelData()\n\nIf this is On, files with no pixel data will be skipped.\n\nThis is On by default.  Some files, such as dicom directory\nfiles, have metadata but have no images.  Usually we want to skip\nthese.\n"},
  {"SetFollowSymlinks", PyvtkDICOMDirectory_SetFollowSymlinks, METH_VARARGS,
   "SetFollowSymlinks(self, _arg:int) -> None\nC++: virtual void SetFollowSymlinks(int _arg)\n\nIf On (the default), symbolic links will be followed.\n"},
  {"FollowSymlinksOn", PyvtkDICOMDirectory_FollowSymlinksOn, METH_VARARGS,
   "FollowSymlinksOn(self) -> None\nC++: virtual void FollowSymlinksOn()\n\nIf On (the default), symbolic links will be followed.\n"},
  {"FollowSymlinksOff", PyvtkDICOMDirectory_FollowSymlinksOff, METH_VARARGS,
   "FollowSymlinksOff(self) -> None\nC++: virtual void FollowSymlinksOff()\n\nIf On (the default), symbolic links will be followed.\n"},
  {"GetFollowSymlinks", PyvtkDICOMDirectory_GetFollowSymlinks, METH_VARARGS,
   "GetFollowSymlinks(self) -> int\nC++: int GetFollowSymlinks()\n\nIf On (the default), symbolic links will be followed.\n"},
  {"SetShowHidden", PyvtkDICOMDirectory_SetShowHidden, METH_VARARGS,
   "SetShowHidden(self, _arg:int) -> None\nC++: virtual void SetShowHidden(int _arg)\n\nIf On (the default), hidden files will be listed.\n\nA file is hidden if it has a \"hidden\" attribute set.  On Linux\nand OS X, any file that begins with \".\" will also be considered\n\"hidden\".\n"},
  {"ShowHiddenOn", PyvtkDICOMDirectory_ShowHiddenOn, METH_VARARGS,
   "ShowHiddenOn(self) -> None\nC++: virtual void ShowHiddenOn()\n\nIf On (the default), hidden files will be listed.\n\nA file is hidden if it has a \"hidden\" attribute set.  On Linux\nand OS X, any file that begins with \".\" will also be considered\n\"hidden\".\n"},
  {"ShowHiddenOff", PyvtkDICOMDirectory_ShowHiddenOff, METH_VARARGS,
   "ShowHiddenOff(self) -> None\nC++: virtual void ShowHiddenOff()\n\nIf On (the default), hidden files will be listed.\n\nA file is hidden if it has a \"hidden\" attribute set.  On Linux\nand OS X, any file that begins with \".\" will also be considered\n\"hidden\".\n"},
  {"GetShowHidden", PyvtkDICOMDirectory_GetShowHidden, METH_VARARGS,
   "GetShowHidden(self) -> int\nC++: int GetShowHidden()\n\nIf On (the default), hidden files will be listed.\n\nA file is hidden if it has a \"hidden\" attribute set.  On Linux\nand OS X, any file that begins with \".\" will also be considered\n\"hidden\".\n"},
  {"SetDefaultCharacterSet", PyvtkDICOMDirectory_SetDefaultCharacterSet, METH_VARARGS,
   "SetDefaultCharacterSet(self, cs:vtkDICOMCharacterSet) -> None\nC++: void SetDefaultCharacterSet(vtkDICOMCharacterSet cs)\n\nSet the character set to use if SpecificCharacterSet is missing.\n\nSome DICOM files do not list a SpecificCharacterSet attribute,\nbut nevertheless use a non-ASCII character encoding.  This method\ncan be used to specify the character set in absence of\nSpecificCharacterSet. If SpecificCharacterSet is present, the\ndefault will not override it unless OverrideCharacterSet is true.\n"},
  {"GetDefaultCharacterSet", PyvtkDICOMDirectory_GetDefaultCharacterSet, METH_VARARGS,
   "GetDefaultCharacterSet(self) -> vtkDICOMCharacterSet\nC++: vtkDICOMCharacterSet GetDefaultCharacterSet()\n\nSet the character set to use if SpecificCharacterSet is missing.\n\nSome DICOM files do not list a SpecificCharacterSet attribute,\nbut nevertheless use a non-ASCII character encoding.  This method\ncan be used to specify the character set in absence of\nSpecificCharacterSet. If SpecificCharacterSet is present, the\ndefault will not override it unless OverrideCharacterSet is true.\n"},
  {"SetOverrideCharacterSet", PyvtkDICOMDirectory_SetOverrideCharacterSet, METH_VARARGS,
   "SetOverrideCharacterSet(self, _arg:bool) -> None\nC++: virtual void SetOverrideCharacterSet(bool _arg)\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"OverrideCharacterSetOn", PyvtkDICOMDirectory_OverrideCharacterSetOn, METH_VARARGS,
   "OverrideCharacterSetOn(self) -> None\nC++: virtual void OverrideCharacterSetOn()\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"OverrideCharacterSetOff", PyvtkDICOMDirectory_OverrideCharacterSetOff, METH_VARARGS,
   "OverrideCharacterSetOff(self) -> None\nC++: virtual void OverrideCharacterSetOff()\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"GetOverrideCharacterSet", PyvtkDICOMDirectory_GetOverrideCharacterSet, METH_VARARGS,
   "GetOverrideCharacterSet(self) -> bool\nC++: bool GetOverrideCharacterSet()\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMDirectory_Doc =
  "vtkDICOMDirectory - Get information about all DICOM files within a\ndirectory.\n\n"
  "Superclass: vtkAlgorithm\n\n"
  "Given a directory, search for a DICOMDIR file, and if no DICOMDIR is\n"
  "found, directly search for DICOM files within the directory.  Provide\n"
  "a list of DICOM file names as output, sorted by patient, study,\n"
  "series, and image.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMDirectory_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMDirectory", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMDirectory_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMDirectory_StaticNew()
{
  return vtkDICOMDirectory::New();
}

PyObject *PyvtkDICOMDirectory_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMDirectory_Type, PyvtkDICOMDirectory_Methods,
    "vtkDICOMDirectory",
 &PyvtkDICOMDirectory_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkAlgorithm");

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 5; c++)
  {
    static const struct { const char *name; int value; }
      constants[5] = {
        { "PATIENT", vtkDICOMDirectory::PATIENT },
        { "STUDY", vtkDICOMDirectory::STUDY },
        { "SERIES", vtkDICOMDirectory::SERIES },
        { "IMAGE", vtkDICOMDirectory::IMAGE },
        { "FRAME", vtkDICOMDirectory::FRAME },
      };

    o = PyLong_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMDirectory(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMDirectory_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMDirectory", o) != 0)
  {
    Py_DECREF(o);
  }

}

