// python wrapper for vtkDICOMFileDirectory
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMFileDirectory.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMFileDirectory(PyObject *dict); }
#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMFileDirectory_Mode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMFileDirectory.Mode", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMFileDirectory_Mode_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMFileDirectory_Mode_Type, static_cast<int>(val));
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMFileDirectory_Code_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMFileDirectory.Code", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMFileDirectory_Code_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMFileDirectory_Code_Type, static_cast<int>(val));
}


static PyObject *
PyvtkDICOMFileDirectory_GetError(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetError");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFileDirectory *op = static_cast<vtkDICOMFileDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetError();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileDirectory_GetNumberOfEntries(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfEntries");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFileDirectory *op = static_cast<vtkDICOMFileDirectory *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetNumberOfEntries();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileDirectory_GetEntry(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEntry");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFileDirectory *op = static_cast<vtkDICOMFileDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = op->GetEntry(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileDirectory_IsDirectory(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsDirectory");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFileDirectory *op = static_cast<vtkDICOMFileDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = op->IsDirectory(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileDirectory_IsSpecial(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsSpecial");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFileDirectory *op = static_cast<vtkDICOMFileDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = op->IsSpecial(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileDirectory_IsSymlink(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsSymlink");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFileDirectory *op = static_cast<vtkDICOMFileDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = op->IsSymlink(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileDirectory_IsBroken(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsBroken");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFileDirectory *op = static_cast<vtkDICOMFileDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = op->IsBroken(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileDirectory_IsHidden(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsHidden");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFileDirectory *op = static_cast<vtkDICOMFileDirectory *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = op->IsHidden(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileDirectory_Access(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "Access");

  const char *temp0 = nullptr;
  typedef vtkDICOMFileDirectory::Mode temp1_type;
  temp1_type temp1;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetEnumValue(temp1, "vtkDICOMFileDirectory.Mode"))
  {
    int tempr = vtkDICOMFileDirectory::Access(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileDirectory_Create(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "Create");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMFileDirectory::Create(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMFileDirectory_Methods[] = {
  {"GetError", PyvtkDICOMFileDirectory_GetError, METH_VARARGS,
   "GetError(self) -> int\nC++: int GetError()\n\nReturn an error indicator (zero if no error).\n"},
  {"GetNumberOfEntries", PyvtkDICOMFileDirectory_GetNumberOfEntries, METH_VARARGS,
   "GetNumberOfEntries(self) -> int\nC++: int GetNumberOfEntries()\n\nGet the number of files and subdirectories in the directory.\n"},
  {"GetEntry", PyvtkDICOMFileDirectory_GetEntry, METH_VARARGS,
   "GetEntry(self, i:int) -> str\nC++: const char *GetEntry(int i)\n\nGet the name of the ith file or subdirectory.\n\nThe entries do not include \".\" or \"..\".\n"},
  {"IsDirectory", PyvtkDICOMFileDirectory_IsDirectory, METH_VARARGS,
   "IsDirectory(self, i:int) -> bool\nC++: bool IsDirectory(int i)\n\nCheck if the list entry is a directory.\n"},
  {"IsSpecial", PyvtkDICOMFileDirectory_IsSpecial, METH_VARARGS,
   "IsSpecial(self, i:int) -> bool\nC++: bool IsSpecial(int i)\n\nCheck if the list entry is special (a device, socket, or pipe).\n"},
  {"IsSymlink", PyvtkDICOMFileDirectory_IsSymlink, METH_VARARGS,
   "IsSymlink(self, i:int) -> bool\nC++: bool IsSymlink(int i)\n\nCheck if the list entry is a symbolic link.\n"},
  {"IsBroken", PyvtkDICOMFileDirectory_IsBroken, METH_VARARGS,
   "IsBroken(self, i:int) -> bool\nC++: bool IsBroken(int i)\n\nCheck if the list entry is a symbolic link that is broken.\n\nA link is broken if it points to a location that does not exist,\nor to a location that is in a directory that cannot be accessed.\nIsSymlink() will always be true if IsBroken() is true.\n"},
  {"IsHidden", PyvtkDICOMFileDirectory_IsHidden, METH_VARARGS,
   "IsHidden(self, i:int) -> bool\nC++: bool IsHidden(int i)\n\nCheck if the list entry has an attribute that marks it as hidden.\n"},
  {"Access", PyvtkDICOMFileDirectory_Access, METH_VARARGS,
   "Access(dirname:str, mode:Mode) -> int\nC++: static int Access(const char *dirname, Mode mode)\n\nTest a directory for accessibility (static method).\n\nThe mode should be \"In\" or \"Out\" to indicate whether you intend\nto read from or write to the directory.  A return value of zero\nmeans the directory can be accessed, otherwise an error code will\nbe returned.\n"},
  {"Create", PyvtkDICOMFileDirectory_Create, METH_VARARGS,
   "Create(dirname:str) -> int\nC++: static int Create(const char *dirname)\n\nCreate a new directory with default permissions (static method).\n\nThis will create any intermediate directories, as well.  The\nreturn value is zero for success.  Otherwise, one of the error\ncodes is returned.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMFileDirectory_vtkDICOMFileDirectory_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMFileDirectory");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMFileDirectory *op = new vtkDICOMFileDirectory(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMFileDirectory", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMFileDirectory_vtkDICOMFileDirectory_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMFileDirectory");

  vtkDICOMFileDirectory *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMFileDirectory"))
  {
    vtkDICOMFileDirectory *op = new vtkDICOMFileDirectory(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMFileDirectory", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMFileDirectory_vtkDICOMFileDirectory_Methods[] = {
  {"vtkDICOMFileDirectory", PyvtkDICOMFileDirectory_vtkDICOMFileDirectory_s1, METH_VARARGS,
   "@z"},
  {"vtkDICOMFileDirectory", PyvtkDICOMFileDirectory_vtkDICOMFileDirectory_s2, METH_VARARGS,
   "@W vtkDICOMFileDirectory"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMFileDirectory_vtkDICOMFileDirectory(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMFileDirectory_vtkDICOMFileDirectory_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMFileDirectory");
  return nullptr;
}


static const char *PyvtkDICOMFileDirectory_Doc =

  "vtkDICOMFileDirectory(dirname:str) -> vtkDICOMFileDirectory\nC++: vtkDICOMFileDirectory(const char *dirname)\nvtkDICOMFileDirectory(__a:vtkDICOMFileDirectory)\n    -> vtkDICOMFileDirectory\nC++: vtkDICOMFileDirectory(const vtkDICOMFileDirectory &)\n""\n"
  "vtkDICOMFileDirectory - A class that provides directory listings.\n\n"
;

static PyObject *
PyvtkDICOMFileDirectory_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMFileDirectory_vtkDICOMFileDirectory(nullptr, args);
}

static void PyvtkDICOMFileDirectory_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMFileDirectory *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDICOMFileDirectory_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMFileDirectory_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMFileDirectory", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMFileDirectory_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMFileDirectory_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMFileDirectory_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMFileDirectory_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkDICOMFileDirectory_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMFileDirectory(*static_cast<const vtkDICOMFileDirectory*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMFileDirectory_TypeNew
extern "C" { PyObject *PyvtkDICOMFileDirectory_TypeNew(); }
#define DECLARED_PyvtkDICOMFileDirectory_TypeNew
#endif

PyObject *PyvtkDICOMFileDirectory_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMFileDirectory_Type,
    PyvtkDICOMFileDirectory_Methods,
    PyvtkDICOMFileDirectory_vtkDICOMFileDirectory_Methods,
    &PyvtkDICOMFileDirectory_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkDICOMFileDirectory_Mode_Type);
  PyVTKEnum_Add(&PyvtkDICOMFileDirectory_Mode_Type, "vtkDICOMFileDirectory.Mode");

  o = (PyObject *)&PyvtkDICOMFileDirectory_Mode_Type;
  if (PyDict_SetItemString(d, "Mode", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkDICOMFileDirectory_Code_Type);
  PyVTKEnum_Add(&PyvtkDICOMFileDirectory_Code_Type, "vtkDICOMFileDirectory.Code");

  o = (PyObject *)&PyvtkDICOMFileDirectory_Code_Type;
  if (PyDict_SetItemString(d, "Code", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkDICOMFileDirectory::Mode cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "In", vtkDICOMFileDirectory::In },
        { "Out", vtkDICOMFileDirectory::Out },
      };

    o = PyvtkDICOMFileDirectory_Mode_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 7; c++)
  {
    typedef vtkDICOMFileDirectory::Code cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[7] = {
        { "Good", vtkDICOMFileDirectory::Good },
        { "UnknownError", vtkDICOMFileDirectory::UnknownError },
        { "AccessDenied", vtkDICOMFileDirectory::AccessDenied },
        { "Reserved", vtkDICOMFileDirectory::Reserved },
        { "ImpossiblePath", vtkDICOMFileDirectory::ImpossiblePath },
        { "FileNotFound", vtkDICOMFileDirectory::FileNotFound },
        { "OutOfSpace", vtkDICOMFileDirectory::OutOfSpace },
      };

    o = PyvtkDICOMFileDirectory_Code_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMFileDirectory(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMFileDirectory_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMFileDirectory", o) != 0)
  {
    Py_DECREF(o);
  }

}

