// python wrapper for vtkDICOMFilePath
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMFilePath.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMFilePath(PyObject *dict); }

static PyObject *
PyvtkDICOMFilePath_AsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsString");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const std::string *tempr = &op->AsString();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(*tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_IsEmpty(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsEmpty");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsEmpty();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_IsRoot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsRoot");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsRoot();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_IsDirectory(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsDirectory");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsDirectory();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_IsSpecial(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsSpecial");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsSpecial();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_IsSymlink(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsSymlink");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsSymlink();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_Join(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Join");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = op->Join(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_GetBack(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = op->GetBack();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_PopBack(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PopBack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    op->PopBack();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_PushBack(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PushBack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->PushBack(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_GetExtension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetExtension");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = op->GetExtension();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_PopExtension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PopExtension");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    op->PopExtension();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_PushExtension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PushExtension");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->PushExtension(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFilePath_GetRealPath(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRealPath");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFilePath *op = static_cast<vtkDICOMFilePath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = op->GetRealPath();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMFilePath_Methods[] = {
  {"AsString", PyvtkDICOMFilePath_AsString, METH_VARARGS,
   "AsString(self) -> str\nC++: const std::string &AsString()\n\nGet the path as a string.\n"},
  {"IsEmpty", PyvtkDICOMFilePath_IsEmpty, METH_VARARGS,
   "IsEmpty(self) -> bool\nC++: bool IsEmpty()\n\nCheck if the path is empty.\n"},
  {"IsRoot", PyvtkDICOMFilePath_IsRoot, METH_VARARGS,
   "IsRoot(self) -> bool\nC++: bool IsRoot()\n\nCheck if the path is a root path.\n"},
  {"IsDirectory", PyvtkDICOMFilePath_IsDirectory, METH_VARARGS,
   "IsDirectory(self) -> bool\nC++: bool IsDirectory()\n\nCheck whether the path is an existing directory.\n"},
  {"IsSpecial", PyvtkDICOMFilePath_IsSpecial, METH_VARARGS,
   "IsSpecial(self) -> bool\nC++: bool IsSpecial()\n\nCheck whether the path goes to a device, socket, or pipe.\n"},
  {"IsSymlink", PyvtkDICOMFilePath_IsSymlink, METH_VARARGS,
   "IsSymlink(self) -> bool\nC++: bool IsSymlink()\n\nCheck whether the path is a symbolic link.\n"},
  {"Join", PyvtkDICOMFilePath_Join, METH_VARARGS,
   "Join(self, second:str) -> str\nC++: std::string Join(const std::string &second)\n\nReturn the path joined with the given extra component.\n"},
  {"GetBack", PyvtkDICOMFilePath_GetBack, METH_VARARGS,
   "GetBack(self) -> str\nC++: std::string GetBack()\n\nGet the final component of the path.\n"},
  {"PopBack", PyvtkDICOMFilePath_PopBack, METH_VARARGS,
   "PopBack(self) -> None\nC++: void PopBack()\n\nRemove a component from the path.\n"},
  {"PushBack", PyvtkDICOMFilePath_PushBack, METH_VARARGS,
   "PushBack(self, path:str) -> None\nC++: void PushBack(const std::string &path)\n\nAdd a new component (or components) to the path.\n"},
  {"GetExtension", PyvtkDICOMFilePath_GetExtension, METH_VARARGS,
   "GetExtension(self) -> str\nC++: std::string GetExtension()\n\nGet the file extension (the final dot and everything after).\n"},
  {"PopExtension", PyvtkDICOMFilePath_PopExtension, METH_VARARGS,
   "PopExtension(self) -> None\nC++: void PopExtension()\n\nRemove the current file extension, including the dot.\n"},
  {"PushExtension", PyvtkDICOMFilePath_PushExtension, METH_VARARGS,
   "PushExtension(self, path:str) -> None\nC++: void PushExtension(const std::string &path)\n\nAdd a new file extension to the current file path.\n"},
  {"GetRealPath", PyvtkDICOMFilePath_GetRealPath, METH_VARARGS,
   "GetRealPath(self) -> str\nC++: std::string GetRealPath()\n\nGet the full absolute path (or empty string if file doesn't\nexist).\n\nThis will go to the file system to find the true path to a file,\nincluding exactly the same case as used by the file system.  On\nWindows, all forward slashes will be converted to back slashes,\nand the returned file name will have a \\?\\ prefix to indicate\nthat extended path processing should be used.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMFilePath_vtkDICOMFilePath_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMFilePath");

  std::string temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMFilePath *op = new vtkDICOMFilePath(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMFilePath", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMFilePath_vtkDICOMFilePath_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMFilePath");

  vtkDICOMFilePath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMFilePath"))
  {
    vtkDICOMFilePath *op = new vtkDICOMFilePath(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMFilePath", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMFilePath_vtkDICOMFilePath_Methods[] = {
  {"vtkDICOMFilePath", PyvtkDICOMFilePath_vtkDICOMFilePath_s1, METH_VARARGS,
   "@s"},
  {"vtkDICOMFilePath", PyvtkDICOMFilePath_vtkDICOMFilePath_s2, METH_VARARGS,
   "@W vtkDICOMFilePath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMFilePath_vtkDICOMFilePath(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMFilePath_vtkDICOMFilePath_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMFilePath");
  return nullptr;
}


static const char *PyvtkDICOMFilePath_Doc =

  "vtkDICOMFilePath(path:str) -> vtkDICOMFilePath\nC++: vtkDICOMFilePath(const std::string &path)\nvtkDICOMFilePath(__a:vtkDICOMFilePath) -> vtkDICOMFilePath\nC++: vtkDICOMFilePath(const vtkDICOMFilePath &)\n""\n"
  "vtkDICOMFilePath - A class that provides path manipulation.\n\n"
;

static PyObject *
PyvtkDICOMFilePath_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMFilePath_vtkDICOMFilePath(nullptr, args);
}

static void PyvtkDICOMFilePath_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMFilePath *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDICOMFilePath_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMFilePath_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMFilePath", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMFilePath_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMFilePath_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMFilePath_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMFilePath_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkDICOMFilePath_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMFilePath(*static_cast<const vtkDICOMFilePath*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMFilePath_TypeNew
extern "C" { PyObject *PyvtkDICOMFilePath_TypeNew(); }
#define DECLARED_PyvtkDICOMFilePath_TypeNew
#endif

PyObject *PyvtkDICOMFilePath_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMFilePath_Type,
    PyvtkDICOMFilePath_Methods,
    PyvtkDICOMFilePath_vtkDICOMFilePath_Methods,
    &PyvtkDICOMFilePath_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMFilePath(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMFilePath_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMFilePath", o) != 0)
  {
    Py_DECREF(o);
  }

}

