// python wrapper for vtkDICOMFile
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMFile.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMFile(PyObject *dict); }
#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMFile_Mode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMFile.Mode", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMFile_Mode_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMFile_Mode_Type, static_cast<int>(val));
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMFile_Code_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMFile.Code", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMFile_Code_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMFile_Code_Type, static_cast<int>(val));
}


static PyObject *
PyvtkDICOMFile_Close(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Close");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFile *op = static_cast<vtkDICOMFile *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    op->Close();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFile_Read(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Read");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFile *op = static_cast<vtkDICOMFile *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<unsigned char> store0(2*size0);
  unsigned char *temp0 = store0.Data();
  unsigned char *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    size_t tempr = op->Read(temp0, temp1);

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFile_Write(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Write");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFile *op = static_cast<vtkDICOMFile *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<unsigned char> store0(size0);
  unsigned char *temp0 = store0.Data();
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1))
  {
    size_t tempr = op->Write(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFile_SetPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFile *op = static_cast<vtkDICOMFile *>(vp);

  unsigned long long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = op->SetPosition(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFile_GetSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSize");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFile *op = static_cast<vtkDICOMFile *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long long tempr = op->GetSize();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFile_EndOfFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndOfFile");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFile *op = static_cast<vtkDICOMFile *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->EndOfFile();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFile_GetError(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetError");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMFile *op = static_cast<vtkDICOMFile *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetError();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFile_Access(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "Access");

  const char *temp0 = nullptr;
  typedef vtkDICOMFile::Mode temp1_type;
  temp1_type temp1;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetEnumValue(temp1, "vtkDICOMFile.Mode"))
  {
    int tempr = vtkDICOMFile::Access(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFile_Remove(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "Remove");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMFile::Remove(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFile_SameFile(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SameFile");

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = vtkDICOMFile::SameFile(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMFile_Methods[] = {
  {"Close", PyvtkDICOMFile_Close, METH_VARARGS,
   "Close(self) -> None\nC++: void Close()\n\nClose a file.\n"},
  {"Read", PyvtkDICOMFile_Read, METH_VARARGS,
   "Read(self, data:[int, ...], size:int) -> int\nC++: size_t Read(unsigned char *data, size_t size)\n\nRead data from the file.\n\nThe number of bytes read will be returned. A return value of zero\nindicates an error.\n"},
  {"Write", PyvtkDICOMFile_Write, METH_VARARGS,
   "Write(self, data:(int, ...), size:int) -> int\nC++: size_t Write(const unsigned char *data, size_t size)\n\nWrite data to a file.\n\nThe number of bytes written will be returned. If it is less than\nthe size requested, an error occurred.\n"},
  {"SetPosition", PyvtkDICOMFile_SetPosition, METH_VARARGS,
   "SetPosition(self, offset:int) -> bool\nC++: bool SetPosition(Size offset)\n\nGo to a specific location in the file.\n\nThe return value is false if an error occurred.\n"},
  {"GetSize", PyvtkDICOMFile_GetSize, METH_VARARGS,
   "GetSize(self) -> int\nC++: Size GetSize()\n\nCheck the size of the file, returns ULLONG_MAX on error.\n"},
  {"EndOfFile", PyvtkDICOMFile_EndOfFile, METH_VARARGS,
   "EndOfFile(self) -> bool\nC++: bool EndOfFile()\n\nCheck for the end-of-file indicator.\n"},
  {"GetError", PyvtkDICOMFile_GetError, METH_VARARGS,
   "GetError(self) -> int\nC++: int GetError()\n\nReturn an error indicator (zero if no error).\n"},
  {"Access", PyvtkDICOMFile_Access, METH_VARARGS,
   "Access(filename:str, mode:Mode) -> int\nC++: static int Access(const char *filename, Mode mode)\n\nTest the specified file for accessibility (static method).\n\nThe mode should be \"In\" or \"Out\" to indicate how you intend to\nuse the file.  The return value will be zero (for an ordinary\nfile) or one of the codes returned by GetError.\n"},
  {"Remove", PyvtkDICOMFile_Remove, METH_VARARGS,
   "Remove(filename:str) -> int\nC++: static int Remove(const char *filename)\n\nDelete the specified file (static method).\n\nThe return value is zero if successful, otherwise an error code\nis returned.  This can be called on a file that is still open, in\nwhich case the file will be deleted when closed.\n"},
  {"SameFile", PyvtkDICOMFile_SameFile, METH_VARARGS,
   "SameFile(file1:str, file2:str) -> bool\nC++: static bool SameFile(const char *file1, const char *file2)\n\nCheck if two files are the same.\n\nThis does not check that the filenames are the same.  Instead, it\nchecks to see if the two filenames point to the same actual disk\nfile.  If either file does not exist or is otherwise not\naccessible, then it returns false.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMFile_vtkDICOMFile_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMFile");

  const char *temp0 = nullptr;
  typedef vtkDICOMFile::Mode temp1_type;
  temp1_type temp1;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetEnumValue(temp1, "vtkDICOMFile.Mode"))
  {
    vtkDICOMFile *op = new vtkDICOMFile(temp0, temp1);

    result = PyVTKSpecialObject_New("vtkDICOMFile", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMFile_vtkDICOMFile_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMFile");

  vtkDICOMFile *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMFile"))
  {
    vtkDICOMFile *op = new vtkDICOMFile(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMFile", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMFile_vtkDICOMFile_Methods[] = {
  {"vtkDICOMFile", PyvtkDICOMFile_vtkDICOMFile_s2, METH_VARARGS,
   "@W vtkDICOMFile"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMFile_vtkDICOMFile(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return PyvtkDICOMFile_vtkDICOMFile_s1(self, args);
    case 1:
      return PyvtkDICOMFile_vtkDICOMFile_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMFile");
  return nullptr;
}


static const char *PyvtkDICOMFile_Doc =

  "vtkDICOMFile(filename:str, mode:Mode) -> vtkDICOMFile\nC++: vtkDICOMFile(const char *filename, Mode mode)\nvtkDICOMFile(__a:vtkDICOMFile) -> vtkDICOMFile\nC++: vtkDICOMFile(const vtkDICOMFile &)\n""\n"
  "vtkDICOMFile - A class that provides basic input/output operations.\n\n"
  "The purpose of this class is to centralize all of the I/O operations.\n"
  "It uses system-level I/O calls so that it can eventually be used not\n"
  "only on files, but on sockets as well.\n\n";

static PyObject *
PyvtkDICOMFile_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMFile_vtkDICOMFile(nullptr, args);
}

static void PyvtkDICOMFile_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMFile *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDICOMFile_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMFile_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMFile", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMFile_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMFile_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMFile_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMFile_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkDICOMFile_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMFile(*static_cast<const vtkDICOMFile*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMFile_TypeNew
extern "C" { PyObject *PyvtkDICOMFile_TypeNew(); }
#define DECLARED_PyvtkDICOMFile_TypeNew
#endif

PyObject *PyvtkDICOMFile_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMFile_Type,
    PyvtkDICOMFile_Methods,
    PyvtkDICOMFile_vtkDICOMFile_Methods,
    &PyvtkDICOMFile_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkDICOMFile_Mode_Type);
  PyVTKEnum_Add(&PyvtkDICOMFile_Mode_Type, "vtkDICOMFile.Mode");

  o = (PyObject *)&PyvtkDICOMFile_Mode_Type;
  if (PyDict_SetItemString(d, "Mode", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkDICOMFile_Code_Type);
  PyVTKEnum_Add(&PyvtkDICOMFile_Code_Type, "vtkDICOMFile.Code");

  o = (PyObject *)&PyvtkDICOMFile_Code_Type;
  if (PyDict_SetItemString(d, "Code", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkDICOMFile::Mode cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "In", vtkDICOMFile::In },
        { "Out", vtkDICOMFile::Out },
      };

    o = PyvtkDICOMFile_Mode_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 7; c++)
  {
    typedef vtkDICOMFile::Code cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[7] = {
        { "Good", vtkDICOMFile::Good },
        { "UnknownError", vtkDICOMFile::UnknownError },
        { "AccessDenied", vtkDICOMFile::AccessDenied },
        { "FileIsDirectory", vtkDICOMFile::FileIsDirectory },
        { "ImpossiblePath", vtkDICOMFile::ImpossiblePath },
        { "FileNotFound", vtkDICOMFile::FileNotFound },
        { "OutOfSpace", vtkDICOMFile::OutOfSpace },
      };

    o = PyvtkDICOMFile_Code_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMFile(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMFile_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMFile", o) != 0)
  {
    Py_DECREF(o);
  }

}

