// python wrapper for vtkDICOMFileSorter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMFileSorter.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMFileSorter(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMFileSorter_ClassNew(); }


static PyObject *
PyvtkDICOMFileSorter_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMFileSorter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMFileSorter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMFileSorter *tempr = vtkDICOMFileSorter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMFileSorter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMFileSorter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMFileSorter::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMFileSorter::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_SetInputFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetFilePath(temp0))
  {
    if (ap.IsBound())
    {
      op->SetInputFileName(temp0);
    }
    else
    {
      op->vtkDICOMFileSorter::SetInputFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetInputFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInputFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetInputFileName() :
      op->vtkDICOMFileSorter::GetInputFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_SetInputFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  vtkStringArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkStringArray"))
  {
    if (ap.IsBound())
    {
      op->SetInputFileNames(temp0);
    }
    else
    {
      op->vtkDICOMFileSorter::SetInputFileNames(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetInputFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInputFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetInputFileNames() :
      op->vtkDICOMFileSorter::GetInputFileNames());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkDICOMFileSorter::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetNumberOfSeries(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfSeries");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfSeries() :
      op->vtkDICOMFileSorter::GetNumberOfSeries());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetNumberOfStudies(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfStudies");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfStudies() :
      op->vtkDICOMFileSorter::GetNumberOfStudies());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetFirstSeriesForStudy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFirstSeriesForStudy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFirstSeriesForStudy(temp0) :
      op->vtkDICOMFileSorter::GetFirstSeriesForStudy(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetLastSeriesForStudy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastSeriesForStudy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLastSeriesForStudy(temp0) :
      op->vtkDICOMFileSorter::GetLastSeriesForStudy(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetOutputFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetOutputFileNames() :
      op->vtkDICOMFileSorter::GetOutputFileNames());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetFileNamesForSeries(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileNamesForSeries");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetFileNamesForSeries(temp0) :
      op->vtkDICOMFileSorter::GetFileNamesForSeries(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetErrorCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetErrorCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetErrorCode() :
      op->vtkDICOMFileSorter::GetErrorCode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetInternalFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInternalFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetInternalFileName() :
      op->vtkDICOMFileSorter::GetInternalFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_SetRequirePixelData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRequirePixelData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRequirePixelData(temp0);
    }
    else
    {
      op->vtkDICOMFileSorter::SetRequirePixelData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_RequirePixelDataOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RequirePixelDataOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RequirePixelDataOn();
    }
    else
    {
      op->vtkDICOMFileSorter::RequirePixelDataOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_RequirePixelDataOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RequirePixelDataOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RequirePixelDataOff();
    }
    else
    {
      op->vtkDICOMFileSorter::RequirePixelDataOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMFileSorter_GetRequirePixelData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRequirePixelData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMFileSorter *op = static_cast<vtkDICOMFileSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRequirePixelData() :
      op->vtkDICOMFileSorter::GetRequirePixelData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMFileSorter_Methods[] = {
  {"IsTypeOf", PyvtkDICOMFileSorter_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMFileSorter_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMFileSorter_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMFileSorter\nC++: static vtkDICOMFileSorter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMFileSorter_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMFileSorter\nC++: vtkDICOMFileSorter *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMFileSorter_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMFileSorter_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetInputFileName", PyvtkDICOMFileSorter_SetInputFileName, METH_VARARGS,
   "SetInputFileName(self, name:str) -> None\nC++: void SetInputFileName(const char *name)\n\nSet one file from the desired series.\n\nWhen Update() is called, all files that belong to the same series\nas the specified file will be identified and can be retrieved by\ncalling GetOutputFileNames().\n"},
  {"GetInputFileName", PyvtkDICOMFileSorter_GetInputFileName, METH_VARARGS,
   "GetInputFileName(self) -> str\nC++: const char *GetInputFileName()\n\nSet one file from the desired series.\n\nWhen Update() is called, all files that belong to the same series\nas the specified file will be identified and can be retrieved by\ncalling GetOutputFileNames().\n"},
  {"SetInputFileNames", PyvtkDICOMFileSorter_SetInputFileNames, METH_VARARGS,
   "SetInputFileNames(self, input:vtkStringArray) -> None\nC++: void SetInputFileNames(vtkStringArray *input)\n\nSet a list of file names to group and sort.\n\nThis method is mutually exclusive with SetInputFileName(). If you\ncall this method, then InputFileName will be set to NULL and vice\nversa.\n"},
  {"GetInputFileNames", PyvtkDICOMFileSorter_GetInputFileNames, METH_VARARGS,
   "GetInputFileNames(self) -> vtkStringArray\nC++: vtkStringArray *GetInputFileNames()\n\nSet a list of file names to group and sort.\n\nThis method is mutually exclusive with SetInputFileName(). If you\ncall this method, then InputFileName will be set to NULL and vice\nversa.\n"},
  {"Update", PyvtkDICOMFileSorter_Update, METH_VARARGS,
   "Update(self) -> None\nC++: virtual void Update()\n\nUpdate the information about the files.\n\nThis method must be called before any of the Get methods.\n"},
  {"GetNumberOfSeries", PyvtkDICOMFileSorter_GetNumberOfSeries, METH_VARARGS,
   "GetNumberOfSeries(self) -> int\nC++: int GetNumberOfSeries()\n\nGet the total number of series that were found.\n"},
  {"GetNumberOfStudies", PyvtkDICOMFileSorter_GetNumberOfStudies, METH_VARARGS,
   "GetNumberOfStudies(self) -> int\nC++: int GetNumberOfStudies()\n\nGet the number of studies that were found.\n"},
  {"GetFirstSeriesForStudy", PyvtkDICOMFileSorter_GetFirstSeriesForStudy, METH_VARARGS,
   "GetFirstSeriesForStudy(self, study:int) -> int\nC++: int GetFirstSeriesForStudy(int study)\n\nGet the first series for a particular study.\n"},
  {"GetLastSeriesForStudy", PyvtkDICOMFileSorter_GetLastSeriesForStudy, METH_VARARGS,
   "GetLastSeriesForStudy(self, study:int) -> int\nC++: int GetLastSeriesForStudy(int study)\n\nGet the last series (inclusive) for a particular study.\n"},
  {"GetOutputFileNames", PyvtkDICOMFileSorter_GetOutputFileNames, METH_VARARGS,
   "GetOutputFileNames(self) -> vtkStringArray\nC++: vtkStringArray *GetOutputFileNames()\n\nGet the full list of sorted filenames.\n"},
  {"GetFileNamesForSeries", PyvtkDICOMFileSorter_GetFileNamesForSeries, METH_VARARGS,
   "GetFileNamesForSeries(self, i:int) -> vtkStringArray\nC++: vtkStringArray *GetFileNamesForSeries(int i)\n\nGet the file names for a specific series.\n"},
  {"GetErrorCode", PyvtkDICOMFileSorter_GetErrorCode, METH_VARARGS,
   "GetErrorCode(self) -> int\nC++: unsigned long GetErrorCode()\n\nGet the error code.\n"},
  {"GetInternalFileName", PyvtkDICOMFileSorter_GetInternalFileName, METH_VARARGS,
   "GetInternalFileName(self) -> str\nC++: const char *GetInternalFileName()\n\nGet the filename associated with the error code.\n"},
  {"SetRequirePixelData", PyvtkDICOMFileSorter_SetRequirePixelData, METH_VARARGS,
   "SetRequirePixelData(self, _arg:int) -> None\nC++: virtual void SetRequirePixelData(int _arg)\n\nIf this is On, files with no pixel data will be skipped.\n\nThis is On by default.  Some files, such as dicom directory\nfiles, have metadata but have no images.  Usually we want to skip\nthese.\n"},
  {"RequirePixelDataOn", PyvtkDICOMFileSorter_RequirePixelDataOn, METH_VARARGS,
   "RequirePixelDataOn(self) -> None\nC++: virtual void RequirePixelDataOn()\n\nIf this is On, files with no pixel data will be skipped.\n\nThis is On by default.  Some files, such as dicom directory\nfiles, have metadata but have no images.  Usually we want to skip\nthese.\n"},
  {"RequirePixelDataOff", PyvtkDICOMFileSorter_RequirePixelDataOff, METH_VARARGS,
   "RequirePixelDataOff(self) -> None\nC++: virtual void RequirePixelDataOff()\n\nIf this is On, files with no pixel data will be skipped.\n\nThis is On by default.  Some files, such as dicom directory\nfiles, have metadata but have no images.  Usually we want to skip\nthese.\n"},
  {"GetRequirePixelData", PyvtkDICOMFileSorter_GetRequirePixelData, METH_VARARGS,
   "GetRequirePixelData(self) -> int\nC++: int GetRequirePixelData()\n\nIf this is On, files with no pixel data will be skipped.\n\nThis is On by default.  Some files, such as dicom directory\nfiles, have metadata but have no images.  Usually we want to skip\nthese.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMFileSorter_Doc =
  "vtkDICOMFileSorter - Sort DICOM files and group them by study and\nseries.\n\n"
  "Superclass: vtkObject\n\n"
  "If a list of input files is provided via SetInputFileNames(), then\n"
  "the files will be grouped by study and series, and each series will\n"
  "be sorted by InstanceNumber.  If a single input file is provided via\n"
  "SetInputFileName(), then other files in the same series will be\n"
  "found, and the series will be sorted by InstanceNumber.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMFileSorter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMFileSorter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMFileSorter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMFileSorter_StaticNew()
{
  return vtkDICOMFileSorter::New();
}

PyObject *PyvtkDICOMFileSorter_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMFileSorter_Type, PyvtkDICOMFileSorter_Methods,
    "vtkDICOMFileSorter",
 &PyvtkDICOMFileSorter_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMFileSorter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMFileSorter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMFileSorter", o) != 0)
  {
    Py_DECREF(o);
  }

}

