// python wrapper for vtkDICOMGenerator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMGenerator.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMGenerator(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMGenerator_ClassNew(); }


static PyObject *
PyvtkDICOMGenerator_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMGenerator::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMGenerator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMGenerator *tempr = vtkDICOMGenerator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMGenerator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMGenerator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMGenerator::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMGenerator::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GenerateInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GenerateInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  vtkInformation *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkInformation"))
  {
    bool tempr = (ap.IsBound() ?
      op->GenerateInstance(temp0) :
      op->vtkDICOMGenerator::GenerateInstance(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMMetaData *tempr = (ap.IsBound() ?
      op->GetMetaData() :
      op->vtkDICOMGenerator::GetMetaData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetExtended(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetExtended");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetExtended(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetExtended(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_ExtendedOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ExtendedOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ExtendedOn();
    }
    else
    {
      op->vtkDICOMGenerator::ExtendedOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_ExtendedOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ExtendedOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ExtendedOff();
    }
    else
    {
      op->vtkDICOMGenerator::ExtendedOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetExtended(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetExtended");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetExtended() :
      op->vtkDICOMGenerator::GetExtended());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetMultiFrame(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMultiFrame");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMultiFrame(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetMultiFrame(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_MultiFrameOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MultiFrameOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MultiFrameOn();
    }
    else
    {
      op->vtkDICOMGenerator::MultiFrameOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_MultiFrameOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MultiFrameOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MultiFrameOff();
    }
    else
    {
      op->vtkDICOMGenerator::MultiFrameOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetMultiFrame(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMultiFrame");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMultiFrame() :
      op->vtkDICOMGenerator::GetMultiFrame());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetTimeAsVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeAsVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeAsVector(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetTimeAsVector(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_TimeAsVectorOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TimeAsVectorOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->TimeAsVectorOn();
    }
    else
    {
      op->vtkDICOMGenerator::TimeAsVectorOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_TimeAsVectorOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TimeAsVectorOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->TimeAsVectorOff();
    }
    else
    {
      op->vtkDICOMGenerator::TimeAsVectorOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetTimeAsVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeAsVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeAsVector() :
      op->vtkDICOMGenerator::GetTimeAsVector());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetTimeDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeDimension(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetTimeDimension(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetTimeDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeDimension() :
      op->vtkDICOMGenerator::GetTimeDimension());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetTimeSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeSpacing(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetTimeSpacing(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetTimeSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeSpacing() :
      op->vtkDICOMGenerator::GetTimeSpacing());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetRescaleIntercept(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRescaleIntercept");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRescaleIntercept(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetRescaleIntercept(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetRescaleIntercept(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleIntercept");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRescaleIntercept() :
      op->vtkDICOMGenerator::GetRescaleIntercept());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetRescaleSlope(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRescaleSlope");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRescaleSlope(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetRescaleSlope(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetRescaleSlope(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleSlope");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRescaleSlope() :
      op->vtkDICOMGenerator::GetRescaleSlope());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetNumberOfOverlays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfOverlays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfOverlays(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetNumberOfOverlays(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetNumberOfOverlays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfOverlays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfOverlays() :
      op->vtkDICOMGenerator::GetNumberOfOverlays());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetPatientMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPatientMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetPatientMatrix(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetPatientMatrix(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetPatientMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPatientMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetPatientMatrix() :
      op->vtkDICOMGenerator::GetPatientMatrix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetOriginAtBottom(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOriginAtBottom");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOriginAtBottom(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetOriginAtBottom(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetOriginAtBottom(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOriginAtBottom");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOriginAtBottom() :
      op->vtkDICOMGenerator::GetOriginAtBottom());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetReverseSliceOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReverseSliceOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetReverseSliceOrder(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetReverseSliceOrder(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetReverseSliceOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReverseSliceOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetReverseSliceOrder() :
      op->vtkDICOMGenerator::GetReverseSliceOrder());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetSourceMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSourceMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  vtkDICOMMetaData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMMetaData"))
  {
    if (ap.IsBound())
    {
      op->SetSourceMetaData(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetSourceMetaData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetSourceMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSourceMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMMetaData *tempr = (ap.IsBound() ?
      op->GetSourceMetaData() :
      op->vtkDICOMGenerator::GetSourceMetaData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_SetUIDGenerator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUIDGenerator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  vtkDICOMUIDGenerator *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMUIDGenerator"))
  {
    if (ap.IsBound())
    {
      op->SetUIDGenerator(temp0);
    }
    else
    {
      op->vtkDICOMGenerator::SetUIDGenerator(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetUIDGenerator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUIDGenerator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMUIDGenerator *tempr = (ap.IsBound() ?
      op->GetUIDGenerator() :
      op->vtkDICOMGenerator::GetUIDGenerator());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetSliceIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetSliceIndexArray() :
      op->vtkDICOMGenerator::GetSliceIndexArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMGenerator_GetComponentIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetComponentIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMGenerator *op = static_cast<vtkDICOMGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetComponentIndexArray() :
      op->vtkDICOMGenerator::GetComponentIndexArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMGenerator_Methods[] = {
  {"IsTypeOf", PyvtkDICOMGenerator_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMGenerator_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMGenerator_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMGenerator\nC++: static vtkDICOMGenerator *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMGenerator_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMGenerator\nC++: vtkDICOMGenerator *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMGenerator_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMGenerator_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GenerateInstance", PyvtkDICOMGenerator_GenerateInstance, METH_VARARGS,
   "GenerateInstance(self, __a:vtkInformation) -> bool\nC++: virtual bool GenerateInstance(vtkInformation *)\n\nGenerate an instance of one of the supported classes.\n\nThis is the primary interface method of this class.  Given the\ninformation for a vtkImageData object, it will populate the\nattributes of the supplied vtkDICOMMetaData object.\n"},
  {"GetMetaData", PyvtkDICOMGenerator_GetMetaData, METH_VARARGS,
   "GetMetaData(self) -> vtkDICOMMetaData\nC++: vtkDICOMMetaData *GetMetaData()\n\nGet the generated meta data.\n\nEvery time GenerateInstance() is called, it will generate a new\nmeta data object that can be retrieved with this method.\n"},
  {"SetExtended", PyvtkDICOMGenerator_SetExtended, METH_VARARGS,
   "SetExtended(self, _arg:int) -> None\nC++: virtual void SetExtended(int _arg)\n\nCopy extended attributes from source (default: Off).\n\nIf this is off (the default), then only attributes that are part\nof the base SOP class will be copied from the source.  Otherwise,\nall attributes (standard and private) will be copied.  No\nvalidation is performed on attributes that aren't part of the\nbase SOP class.\n"},
  {"ExtendedOn", PyvtkDICOMGenerator_ExtendedOn, METH_VARARGS,
   "ExtendedOn(self) -> None\nC++: virtual void ExtendedOn()\n\nCopy extended attributes from source (default: Off).\n\nIf this is off (the default), then only attributes that are part\nof the base SOP class will be copied from the source.  Otherwise,\nall attributes (standard and private) will be copied.  No\nvalidation is performed on attributes that aren't part of the\nbase SOP class.\n"},
  {"ExtendedOff", PyvtkDICOMGenerator_ExtendedOff, METH_VARARGS,
   "ExtendedOff(self) -> None\nC++: virtual void ExtendedOff()\n\nCopy extended attributes from source (default: Off).\n\nIf this is off (the default), then only attributes that are part\nof the base SOP class will be copied from the source.  Otherwise,\nall attributes (standard and private) will be copied.  No\nvalidation is performed on attributes that aren't part of the\nbase SOP class.\n"},
  {"GetExtended", PyvtkDICOMGenerator_GetExtended, METH_VARARGS,
   "GetExtended(self) -> int\nC++: virtual int GetExtended()\n\nCopy extended attributes from source (default: Off).\n\nIf this is off (the default), then only attributes that are part\nof the base SOP class will be copied from the source.  Otherwise,\nall attributes (standard and private) will be copied.  No\nvalidation is performed on attributes that aren't part of the\nbase SOP class.\n"},
  {"SetMultiFrame", PyvtkDICOMGenerator_SetMultiFrame, METH_VARARGS,
   "SetMultiFrame(self, _arg:int) -> None\nC++: virtual void SetMultiFrame(int _arg)\n\nCreate a multi-frame object (default: Off).\n\nIf this is on, the one multi-frame data set will be created.  If\nthis is off, then each slice will be put into a different data\nset. The latter is more likely to be compatible with older\nsoftware.\n"},
  {"MultiFrameOn", PyvtkDICOMGenerator_MultiFrameOn, METH_VARARGS,
   "MultiFrameOn(self) -> None\nC++: virtual void MultiFrameOn()\n\nCreate a multi-frame object (default: Off).\n\nIf this is on, the one multi-frame data set will be created.  If\nthis is off, then each slice will be put into a different data\nset. The latter is more likely to be compatible with older\nsoftware.\n"},
  {"MultiFrameOff", PyvtkDICOMGenerator_MultiFrameOff, METH_VARARGS,
   "MultiFrameOff(self) -> None\nC++: virtual void MultiFrameOff()\n\nCreate a multi-frame object (default: Off).\n\nIf this is on, the one multi-frame data set will be created.  If\nthis is off, then each slice will be put into a different data\nset. The latter is more likely to be compatible with older\nsoftware.\n"},
  {"GetMultiFrame", PyvtkDICOMGenerator_GetMultiFrame, METH_VARARGS,
   "GetMultiFrame(self) -> int\nC++: virtual int GetMultiFrame()\n\nCreate a multi-frame object (default: Off).\n\nIf this is on, the one multi-frame data set will be created.  If\nthis is off, then each slice will be put into a different data\nset. The latter is more likely to be compatible with older\nsoftware.\n"},
  {"SetTimeAsVector", PyvtkDICOMGenerator_SetTimeAsVector, METH_VARARGS,
   "SetTimeAsVector(self, _arg:int) -> None\nC++: virtual void SetTimeAsVector(int _arg)\n\nWrite scalar components as the time dimension (default: Off).\n\nIf this is on, then each time slot is stored in a different\nscalar component of the image data.  If it is off, then each\nblock of N adjacent slices correspond to the N time slots of the\ntime dimension.\n"},
  {"TimeAsVectorOn", PyvtkDICOMGenerator_TimeAsVectorOn, METH_VARARGS,
   "TimeAsVectorOn(self) -> None\nC++: virtual void TimeAsVectorOn()\n\nWrite scalar components as the time dimension (default: Off).\n\nIf this is on, then each time slot is stored in a different\nscalar component of the image data.  If it is off, then each\nblock of N adjacent slices correspond to the N time slots of the\ntime dimension.\n"},
  {"TimeAsVectorOff", PyvtkDICOMGenerator_TimeAsVectorOff, METH_VARARGS,
   "TimeAsVectorOff(self) -> None\nC++: virtual void TimeAsVectorOff()\n\nWrite scalar components as the time dimension (default: Off).\n\nIf this is on, then each time slot is stored in a different\nscalar component of the image data.  If it is off, then each\nblock of N adjacent slices correspond to the N time slots of the\ntime dimension.\n"},
  {"GetTimeAsVector", PyvtkDICOMGenerator_GetTimeAsVector, METH_VARARGS,
   "GetTimeAsVector(self) -> int\nC++: virtual int GetTimeAsVector()\n\nWrite scalar components as the time dimension (default: Off).\n\nIf this is on, then each time slot is stored in a different\nscalar component of the image data.  If it is off, then each\nblock of N adjacent slices correspond to the N time slots of the\ntime dimension.\n"},
  {"SetTimeDimension", PyvtkDICOMGenerator_SetTimeDimension, METH_VARARGS,
   "SetTimeDimension(self, _arg:int) -> None\nC++: virtual void SetTimeDimension(int _arg)\n\nSet the time dimension to use in the DICOM file (or zero if\nnone).\n\nThe number of components of the input data must be divisible by\nthe time dimension if the time dimension is not set to zero.  The\nvector dimension will be set to the number of components divided\nby the time dimension.  This will be ignored if the SOP Class IOD\ndoes not permit a time dimension.\n"},
  {"GetTimeDimension", PyvtkDICOMGenerator_GetTimeDimension, METH_VARARGS,
   "GetTimeDimension(self) -> int\nC++: virtual int GetTimeDimension()\n\nSet the time dimension to use in the DICOM file (or zero if\nnone).\n\nThe number of components of the input data must be divisible by\nthe time dimension if the time dimension is not set to zero.  The\nvector dimension will be set to the number of components divided\nby the time dimension.  This will be ignored if the SOP Class IOD\ndoes not permit a time dimension.\n"},
  {"SetTimeSpacing", PyvtkDICOMGenerator_SetTimeSpacing, METH_VARARGS,
   "SetTimeSpacing(self, _arg:float) -> None\nC++: virtual void SetTimeSpacing(double _arg)\n\nSet the time dimension to use in the DICOM file (or zero if\nnone).\n\nThe number of components of the input data must be divisible by\nthe time dimension if the time dimension is not set to zero.  The\nvector dimension will be set to the number of components divided\nby the time dimension.  This will be ignored if the SOP Class IOD\ndoes not permit a time dimension.\n"},
  {"GetTimeSpacing", PyvtkDICOMGenerator_GetTimeSpacing, METH_VARARGS,
   "GetTimeSpacing(self) -> float\nC++: virtual double GetTimeSpacing()\n\nSet the time dimension to use in the DICOM file (or zero if\nnone).\n\nThe number of components of the input data must be divisible by\nthe time dimension if the time dimension is not set to zero.  The\nvector dimension will be set to the number of components divided\nby the time dimension.  This will be ignored if the SOP Class IOD\ndoes not permit a time dimension.\n"},
  {"SetRescaleIntercept", PyvtkDICOMGenerator_SetRescaleIntercept, METH_VARARGS,
   "SetRescaleIntercept(self, _arg:float) -> None\nC++: virtual void SetRescaleIntercept(double _arg)\n\nSet the rescaling parameters, for example for CT.\n\nCT, PET, and some other modalities require rescaling parameters\nso that the integer pixel values can be converted into physical\nunits.\n"},
  {"GetRescaleIntercept", PyvtkDICOMGenerator_GetRescaleIntercept, METH_VARARGS,
   "GetRescaleIntercept(self) -> float\nC++: virtual double GetRescaleIntercept()\n\nSet the rescaling parameters, for example for CT.\n\nCT, PET, and some other modalities require rescaling parameters\nso that the integer pixel values can be converted into physical\nunits.\n"},
  {"SetRescaleSlope", PyvtkDICOMGenerator_SetRescaleSlope, METH_VARARGS,
   "SetRescaleSlope(self, _arg:float) -> None\nC++: virtual void SetRescaleSlope(double _arg)\n\nSet the rescaling parameters, for example for CT.\n\nCT, PET, and some other modalities require rescaling parameters\nso that the integer pixel values can be converted into physical\nunits.\n"},
  {"GetRescaleSlope", PyvtkDICOMGenerator_GetRescaleSlope, METH_VARARGS,
   "GetRescaleSlope(self) -> float\nC++: virtual double GetRescaleSlope()\n\nSet the rescaling parameters, for example for CT.\n\nCT, PET, and some other modalities require rescaling parameters\nso that the integer pixel values can be converted into physical\nunits.\n"},
  {"SetNumberOfOverlays", PyvtkDICOMGenerator_SetNumberOfOverlays, METH_VARARGS,
   "SetNumberOfOverlays(self, _arg:int) -> None\nC++: virtual void SetNumberOfOverlays(int _arg)\n\nSet the number of overlays to generate.\n\nThis will cause overlay attributes to be copied from the source\nmeta data to the output meta data.  It is up to the writer to\nensure that the values are consistent with each other.\n"},
  {"GetNumberOfOverlays", PyvtkDICOMGenerator_GetNumberOfOverlays, METH_VARARGS,
   "GetNumberOfOverlays(self) -> int\nC++: virtual int GetNumberOfOverlays()\n\nSet the number of overlays to generate.\n\nThis will cause overlay attributes to be copied from the source\nmeta data to the output meta data.  It is up to the writer to\nensure that the values are consistent with each other.\n"},
  {"SetPatientMatrix", PyvtkDICOMGenerator_SetPatientMatrix, METH_VARARGS,
   "SetPatientMatrix(self, __a:vtkMatrix4x4) -> None\nC++: void SetPatientMatrix(vtkMatrix4x4 *)\n\nSet the matrix that places the image in DICOM patient coords.\n\nThe 3x3 portion of the matrix must be orthonormal, and the last\ncolumn of the matrix is understood to be in millimetres.\n"},
  {"GetPatientMatrix", PyvtkDICOMGenerator_GetPatientMatrix, METH_VARARGS,
   "GetPatientMatrix(self) -> vtkMatrix4x4\nC++: vtkMatrix4x4 *GetPatientMatrix()\n\nSet the matrix that places the image in DICOM patient coords.\n\nThe 3x3 portion of the matrix must be orthonormal, and the last\ncolumn of the matrix is understood to be in millimetres.\n"},
  {"SetOriginAtBottom", PyvtkDICOMGenerator_SetOriginAtBottom, METH_VARARGS,
   "SetOriginAtBottom(self, _arg:int) -> None\nC++: virtual void SetOriginAtBottom(int _arg)\n\nLet the generator know how the image is arranged in memory.\n\nThe generator needs to know how to interpret the geometry of the\nimage that is described in the vtkInformation object that\naccompanies the image.  For example, VTK display coordinates\nplace the Origin at the lower left corner of the screen, while\nDICOM assumes that images will be displayed with the \"origin\" at\nthe top left corner.  By default, OriginAtBottom is On.\n"},
  {"GetOriginAtBottom", PyvtkDICOMGenerator_GetOriginAtBottom, METH_VARARGS,
   "GetOriginAtBottom(self) -> int\nC++: virtual int GetOriginAtBottom()\n\nLet the generator know how the image is arranged in memory.\n\nThe generator needs to know how to interpret the geometry of the\nimage that is described in the vtkInformation object that\naccompanies the image.  For example, VTK display coordinates\nplace the Origin at the lower left corner of the screen, while\nDICOM assumes that images will be displayed with the \"origin\" at\nthe top left corner.  By default, OriginAtBottom is On.\n"},
  {"SetReverseSliceOrder", PyvtkDICOMGenerator_SetReverseSliceOrder, METH_VARARGS,
   "SetReverseSliceOrder(self, _arg:int) -> None\nC++: virtual void SetReverseSliceOrder(int _arg)\n\nLet the generator know how to order the slices.\n\nBy default, the generator will try to keep the same slice order\nas the meta data set by SetSourceMetaData(), but if no ordering\ncan be discerned from the meta data, then the slices will be\nordered according to this flag.\n"},
  {"GetReverseSliceOrder", PyvtkDICOMGenerator_GetReverseSliceOrder, METH_VARARGS,
   "GetReverseSliceOrder(self) -> int\nC++: virtual int GetReverseSliceOrder()\n\nLet the generator know how to order the slices.\n\nBy default, the generator will try to keep the same slice order\nas the meta data set by SetSourceMetaData(), but if no ordering\ncan be discerned from the meta data, then the slices will be\nordered according to this flag.\n"},
  {"SetSourceMetaData", PyvtkDICOMGenerator_SetSourceMetaData, METH_VARARGS,
   "SetSourceMetaData(self, __a:vtkDICOMMetaData) -> None\nC++: void SetSourceMetaData(vtkDICOMMetaData *)\n\nSet some meta data for the constructor to use as a source.\n\nThe supplied meta data can provide some general properties of the\ndata set, such as the patient information and study information. \nOnly portions of the meta data that are permitted by the\ngenerated IOD will be included.\n"},
  {"GetSourceMetaData", PyvtkDICOMGenerator_GetSourceMetaData, METH_VARARGS,
   "GetSourceMetaData(self) -> vtkDICOMMetaData\nC++: vtkDICOMMetaData *GetSourceMetaData()\n\nSet some meta data for the constructor to use as a source.\n\nThe supplied meta data can provide some general properties of the\ndata set, such as the patient information and study information. \nOnly portions of the meta data that are permitted by the\ngenerated IOD will be included.\n"},
  {"SetUIDGenerator", PyvtkDICOMGenerator_SetUIDGenerator, METH_VARARGS,
   "SetUIDGenerator(self, __a:vtkDICOMUIDGenerator) -> None\nC++: void SetUIDGenerator(vtkDICOMUIDGenerator *)\n\nSet the UID generator, for generating unique IDs.\n\nIf no UID generator is supplied, then the default UID generator\nwill be used.\n"},
  {"GetUIDGenerator", PyvtkDICOMGenerator_GetUIDGenerator, METH_VARARGS,
   "GetUIDGenerator(self) -> vtkDICOMUIDGenerator\nC++: vtkDICOMUIDGenerator *GetUIDGenerator()\n\nSet the UID generator, for generating unique IDs.\n\nIf no UID generator is supplied, then the default UID generator\nwill be used.\n"},
  {"GetSliceIndexArray", PyvtkDICOMGenerator_GetSliceIndexArray, METH_VARARGS,
   "GetSliceIndexArray(self) -> vtkIntArray\nC++: vtkIntArray *GetSliceIndexArray()\n\nGet an array that maps file and frame to slice.\n\nOnce the generator has created the metadata, this array lets the\nwriter know which slice to write out as which frame in which\nfile. This will be a 2D array, with the file as the first index\nand the frame as the second index.\n"},
  {"GetComponentIndexArray", PyvtkDICOMGenerator_GetComponentIndexArray, METH_VARARGS,
   "GetComponentIndexArray(self) -> vtkIntArray\nC++: vtkIntArray *GetComponentIndexArray()\n\nGet an array that maps file and frame to component.\n\nOnce the generator has created the metadata, this array lets the\nwriter know which component to write out as which frame in which\nfile. This will be a 2D array, with the file as the first index\nand the frame as the second index.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMGenerator_Doc =
  "vtkDICOMGenerator - Generate DICOM data series for specific IOD\nclasses.\n\n"
  "Superclass: vtkObject\n\n"
  "Every DICOM data set must conform to a specific class, where the\n"
  "properties of all the classes are defined in the DICOM standard.\n"
  "There are specific IOD classes for MR, CT, ultrasound X-ray, etc., in\n"
  "fact there are several dozen classes in total.  IOD is the acronym\n"
  "for Information Object Description, and refers to the attributes that\n"
  "a data set belonging to a particular IOD class can or must have.  The\n"
  "vtkDICOMGenerator is an abstract base class that provides support for\n"
  "most of the common modules in the DICOM standard (i.e. modules that\n"
  "are shared between modalities).  Subclasses of vtkDICOMGenerator are\n"
  "concrete classes that provide generation of data sets belonging to\n"
  "specific modalities.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMGenerator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMGenerator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMGenerator_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMGenerator_StaticNew()
{
  return vtkDICOMGenerator::New();
}

PyObject *PyvtkDICOMGenerator_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMGenerator_Type, PyvtkDICOMGenerator_Methods,
    "vtkDICOMGenerator",
 &PyvtkDICOMGenerator_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMGenerator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMGenerator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMGenerator", o) != 0)
  {
    Py_DECREF(o);
  }

}

