// python wrapper for vtkDICOMImageCodec
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMImageCodec.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMImageCodec(PyObject *dict); }
#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMImageCodec_EnumType_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMImageCodec.EnumType", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMImageCodec_EnumType_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMImageCodec_EnumType_Type, static_cast<int>(val));
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMImageCodec_ErrorCode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMImageCodec.ErrorCode", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMImageCodec_ErrorCode_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMImageCodec_ErrorCode_Type, static_cast<int>(val));
}


static PyObject *
PyvtkDICOMImageCodec_GetTransferSyntaxUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTransferSyntaxUID");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMImageCodec *op = static_cast<vtkDICOMImageCodec *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = op->GetTransferSyntaxUID();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMImageCodec_GetKey(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetKey");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMImageCodec *op = static_cast<vtkDICOMImageCodec *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned char tempr = op->GetKey();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMImageCodec_Methods[] = {
  {"GetTransferSyntaxUID", PyvtkDICOMImageCodec_GetTransferSyntaxUID, METH_VARARGS,
   "GetTransferSyntaxUID(self) -> str\nC++: std::string GetTransferSyntaxUID()\n\nGet the transfer syntax for this codec.\n\nIf the object is invalid, then an empty string is returned.\n"},
  {"GetKey", PyvtkDICOMImageCodec_GetKey, METH_VARARGS,
   "GetKey(self) -> int\nC++: unsigned char GetKey()\n\nGet the numerical identifier for this codec.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMImageCodec_vtkDICOMImageCodec_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMImageCodec");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMImageCodec *op = new vtkDICOMImageCodec();

    result = PyVTKSpecialObject_New("vtkDICOMImageCodec", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMImageCodec_vtkDICOMImageCodec_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMImageCodec");

  int temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMImageCodec *op = new vtkDICOMImageCodec(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMImageCodec", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMImageCodec_vtkDICOMImageCodec_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMImageCodec");

  std::string temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMImageCodec *op = new vtkDICOMImageCodec(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMImageCodec", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMImageCodec_vtkDICOMImageCodec_s4(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMImageCodec");

  vtkDICOMImageCodec *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMImageCodec"))
  {
    vtkDICOMImageCodec *op = new vtkDICOMImageCodec(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMImageCodec", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMImageCodec_vtkDICOMImageCodec_Methods[] = {
  {"vtkDICOMImageCodec", PyvtkDICOMImageCodec_vtkDICOMImageCodec_s2, METH_VARARGS,
   "@i"},
  {"vtkDICOMImageCodec", PyvtkDICOMImageCodec_vtkDICOMImageCodec_s3, METH_VARARGS,
   "-@s"},
  {"vtkDICOMImageCodec", PyvtkDICOMImageCodec_vtkDICOMImageCodec_s4, METH_VARARGS,
   "@W vtkDICOMImageCodec"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMImageCodec_vtkDICOMImageCodec(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMImageCodec_vtkDICOMImageCodec_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMImageCodec_vtkDICOMImageCodec_s1(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMImageCodec");
  return nullptr;
}


static const char *PyvtkDICOMImageCodec_Doc =

  "vtkDICOMImageCodec() -> vtkDICOMImageCodec\nC++: vtkDICOMImageCodec()\nvtkDICOMImageCodec(k:int) -> vtkDICOMImageCodec\nC++: vtkDICOMImageCodec(int k)\nvtkDICOMImageCodec(syntax:str) -> vtkDICOMImageCodec\nC++: explicit vtkDICOMImageCodec(const std::string &syntax)\nvtkDICOMImageCodec(__a:vtkDICOMImageCodec) -> vtkDICOMImageCodec\nC++: vtkDICOMImageCodec(const &vtkDICOMImageCodec)\n""\n"
  "vtkDICOMImageCodec - Codecs for encapsulated images.\n\n"
  "DICOM supports a wide variety of image compression methods.\n\n";

static PyObject *
PyvtkDICOMImageCodec_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMImageCodec_vtkDICOMImageCodec(nullptr, args);
}

static void PyvtkDICOMImageCodec_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMImageCodec *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkDICOMImageCodec_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkDICOMImageCodec *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyUnicode_FromStringAndSize(s.data(), s.size());
}

static int PyvtkDICOMImageCodec_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMImageCodec_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMImageCodec *so1 = nullptr;
  const vtkDICOMImageCodec *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMImageCodec_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMImageCodec *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMImageCodec *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMImageCodec", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMImageCodec_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMImageCodec *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMImageCodec *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMImageCodec", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      result = ((*so1) < (*so2));
      break;
    case Py_LE:
      result = ((*so1) <= (*so2));
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      result = ((*so1) > (*so2));
      break;
    case Py_GE:
      result = ((*so1) >= (*so2));
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMImageCodec_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMImageCodec_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMImageCodec", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMImageCodec_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMImageCodec_Hash, // tp_hash
  nullptr, // tp_call
  PyvtkDICOMImageCodec_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMImageCodec_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMImageCodec_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMImageCodec_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMImageCodec_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMImageCodec_Type);
}

static void *PyvtkDICOMImageCodec_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMImageCodec(*static_cast<const vtkDICOMImageCodec*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMImageCodec_TypeNew
extern "C" { PyObject *PyvtkDICOMImageCodec_TypeNew(); }
#define DECLARED_PyvtkDICOMImageCodec_TypeNew
#endif

PyObject *PyvtkDICOMImageCodec_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMImageCodec_Type,
    PyvtkDICOMImageCodec_Methods,
    PyvtkDICOMImageCodec_vtkDICOMImageCodec_Methods,
    &PyvtkDICOMImageCodec_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkDICOMImageCodec_EnumType_Type);
  PyVTKEnum_Add(&PyvtkDICOMImageCodec_EnumType_Type, "vtkDICOMImageCodec.EnumType");

  o = (PyObject *)&PyvtkDICOMImageCodec_EnumType_Type;
  if (PyDict_SetItemString(d, "EnumType", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkDICOMImageCodec_ErrorCode_Type);
  PyVTKEnum_Add(&PyvtkDICOMImageCodec_ErrorCode_Type, "vtkDICOMImageCodec.ErrorCode");

  o = (PyObject *)&PyvtkDICOMImageCodec_ErrorCode_Type;
  if (PyDict_SetItemString(d, "ErrorCode", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 21; c++)
  {
    typedef vtkDICOMImageCodec::EnumType cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[21] = {
        { "LittleEndian", vtkDICOMImageCodec::LittleEndian },
        { "BigEndian", vtkDICOMImageCodec::BigEndian },
        { "RLE", vtkDICOMImageCodec::RLE },
        { "JPEGBaseline", vtkDICOMImageCodec::JPEGBaseline },
        { "JPEGExtended", vtkDICOMImageCodec::JPEGExtended },
        { "JPEGLossless", vtkDICOMImageCodec::JPEGLossless },
        { "JPEGPrediction", vtkDICOMImageCodec::JPEGPrediction },
        { "JPEGLS", vtkDICOMImageCodec::JPEGLS },
        { "JPEGLSConstrained", vtkDICOMImageCodec::JPEGLSConstrained },
        { "JPEG2K", vtkDICOMImageCodec::JPEG2K },
        { "JPEG2KLossless", vtkDICOMImageCodec::JPEG2KLossless },
        { "MPEG2ML", vtkDICOMImageCodec::MPEG2ML },
        { "MPEG2HL", vtkDICOMImageCodec::MPEG2HL },
        { "MPEG4HPL41", vtkDICOMImageCodec::MPEG4HPL41 },
        { "MPEG4HPL41BD", vtkDICOMImageCodec::MPEG4HPL41BD },
        { "MPEG4HPL42V2D", vtkDICOMImageCodec::MPEG4HPL42V2D },
        { "MPEG4HPL42V3D", vtkDICOMImageCodec::MPEG4HPL42V3D },
        { "MPEG4HPL42Stereo", vtkDICOMImageCodec::MPEG4HPL42Stereo },
        { "HEVCMPL51", vtkDICOMImageCodec::HEVCMPL51 },
        { "HEVCM10PL51", vtkDICOMImageCodec::HEVCM10PL51 },
        { "NumberOfCodecs", vtkDICOMImageCodec::NumberOfCodecs },
      };

    o = PyvtkDICOMImageCodec_EnumType_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 5; c++)
  {
    typedef vtkDICOMImageCodec::ErrorCode cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[5] = {
        { "NoError", vtkDICOMImageCodec::NoError },
        { "MissingCodec", vtkDICOMImageCodec::MissingCodec },
        { "BadPixelFormat", vtkDICOMImageCodec::BadPixelFormat },
        { "MissingData", vtkDICOMImageCodec::MissingData },
        { "UnknownError", vtkDICOMImageCodec::UnknownError },
      };

    o = PyvtkDICOMImageCodec_ErrorCode_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMImageCodec(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMImageCodec_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMImageCodec", o) != 0)
  {
    Py_DECREF(o);
  }

}

