// python wrapper for vtkDICOMItem
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMCharacterSet.h"
#include "vtkDICOMVR.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMDataElement.h"
#include "vtkDICOMDictEntry.h"
#include "vtkDICOMItem.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMItem(PyObject *dict); }

static PyObject *
PyvtkDICOMItem_Clear(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Clear");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    op->Clear();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMItem_IsEmpty(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsEmpty");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsEmpty();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMItem_IsDelimited(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsDelimited");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsDelimited();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMItem_Set_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMValue *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMValue"))
  {
    op->Set(*temp0, *temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMItem_Set_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    op->Set(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMItem_Set_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    op->Set(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMItem_Set_s4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMValue *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMValue"))
  {
    op->Set(*temp0, *temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMItem_Set_s5(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetValue(temp1))
  {
    op->Set(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMItem_Set_s6(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetValue(temp1))
  {
    op->Set(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMItem_Set_Methods[] = {
  {"Set", PyvtkDICOMItem_Set_s1, METH_VARARGS,
   "@WW vtkDICOMTag vtkDICOMValue"},
  {"Set", PyvtkDICOMItem_Set_s2, METH_VARARGS,
   "@Wd vtkDICOMTag"},
  {"Set", PyvtkDICOMItem_Set_s3, METH_VARARGS,
   "@Ws vtkDICOMTag"},
  {"Set", PyvtkDICOMItem_Set_s4, METH_VARARGS,
   "@WW vtkDICOMTagPath vtkDICOMValue"},
  {"Set", PyvtkDICOMItem_Set_s5, METH_VARARGS,
   "@Wd vtkDICOMTagPath"},
  {"Set", PyvtkDICOMItem_Set_s6, METH_VARARGS,
   "@Ws vtkDICOMTagPath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMItem_Set(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMItem_Set_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Set");
  return nullptr;
}


static PyObject *
PyvtkDICOMItem_SetAttributeValue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMValue *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMValue"))
  {
    op->SetAttributeValue(*temp0, *temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMItem_SetAttributeValue_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    op->SetAttributeValue(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMItem_SetAttributeValue_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    op->SetAttributeValue(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMItem_SetAttributeValue_s4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMValue *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMValue"))
  {
    op->SetAttributeValue(*temp0, *temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMItem_SetAttributeValue_s5(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetValue(temp1))
  {
    op->SetAttributeValue(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMItem_SetAttributeValue_s6(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetValue(temp1))
  {
    op->SetAttributeValue(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMItem_SetAttributeValue_Methods[] = {
  {"SetAttributeValue", PyvtkDICOMItem_SetAttributeValue_s1, METH_VARARGS,
   "@WW vtkDICOMTag vtkDICOMValue"},
  {"SetAttributeValue", PyvtkDICOMItem_SetAttributeValue_s2, METH_VARARGS,
   "@Wd vtkDICOMTag"},
  {"SetAttributeValue", PyvtkDICOMItem_SetAttributeValue_s3, METH_VARARGS,
   "@Ws vtkDICOMTag"},
  {"SetAttributeValue", PyvtkDICOMItem_SetAttributeValue_s4, METH_VARARGS,
   "@WW vtkDICOMTagPath vtkDICOMValue"},
  {"SetAttributeValue", PyvtkDICOMItem_SetAttributeValue_s5, METH_VARARGS,
   "@Wd vtkDICOMTagPath"},
  {"SetAttributeValue", PyvtkDICOMItem_SetAttributeValue_s6, METH_VARARGS,
   "@Ws vtkDICOMTagPath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMItem_SetAttributeValue(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMItem_SetAttributeValue_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetAttributeValue");
  return nullptr;
}


static PyObject *
PyvtkDICOMItem_Get_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = &op->Get(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMItem_Get_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath"))
  {
    const vtkDICOMValue *tempr = &op->Get(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMItem_Get_Methods[] = {
  {"Get", PyvtkDICOMItem_Get_s1, METH_VARARGS,
   "@W vtkDICOMTag"},
  {"Get", PyvtkDICOMItem_Get_s2, METH_VARARGS,
   "@W vtkDICOMTagPath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMItem_Get(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMItem_Get_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Get");
  return nullptr;
}


static PyObject *
PyvtkDICOMItem_GetAttributeValue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = &op->GetAttributeValue(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMItem_GetAttributeValue_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath"))
  {
    const vtkDICOMValue *tempr = &op->GetAttributeValue(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMItem_GetAttributeValue_Methods[] = {
  {"GetAttributeValue", PyvtkDICOMItem_GetAttributeValue_s1, METH_VARARGS,
   "@W vtkDICOMTag"},
  {"GetAttributeValue", PyvtkDICOMItem_GetAttributeValue_s2, METH_VARARGS,
   "@W vtkDICOMTagPath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMItem_GetAttributeValue(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMItem_GetAttributeValue_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetAttributeValue");
  return nullptr;
}


static PyObject *
PyvtkDICOMItem_GetByteOffset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetByteOffset");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = op->GetByteOffset();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMItem_GetNumberOfDataElements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfDataElements");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetNumberOfDataElements();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMItem_Begin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Begin");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMDataElementIterator tempr = op->Begin();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDataElementIterator");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMItem_End(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "End");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMDataElementIterator tempr = op->End();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDataElementIterator");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMItem_ResolvePrivateTag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResolvePrivateTag");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    vtkDICOMTag tempr = op->ResolvePrivateTag(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMItem_ResolvePrivateTagForWriting(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResolvePrivateTagForWriting");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    vtkDICOMTag tempr = op->ResolvePrivateTagForWriting(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMItem_FindDictEntry(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FindDictEntry");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    vtkDICOMDictEntry tempr = op->FindDictEntry(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDictEntry");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMItem_FindDictVR(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FindDictVR");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMItem *op = static_cast<vtkDICOMItem *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    vtkDICOMVR tempr = op->FindDictVR(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMVR");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMItem_Methods[] = {
  {"Clear", PyvtkDICOMItem_Clear, METH_VARARGS,
   "Clear(self) -> None\nC++: void Clear()\n\nClear the data.\n"},
  {"IsEmpty", PyvtkDICOMItem_IsEmpty, METH_VARARGS,
   "IsEmpty(self) -> bool\nC++: bool IsEmpty()\n\nCheck if empty.\n"},
  {"IsDelimited", PyvtkDICOMItem_IsDelimited, METH_VARARGS,
   "IsDelimited(self) -> bool\nC++: bool IsDelimited()\n\nCheck if this was read as a delimited item.\n"},
  {"Set", PyvtkDICOMItem_Set, METH_VARARGS,
   "Set(self, tag:vtkDICOMTag, v:vtkDICOMValue) -> None\nC++: void Set(vtkDICOMTag tag, const vtkDICOMValue &v)\nSet(self, tag:vtkDICOMTag, v:float) -> None\nC++: void Set(vtkDICOMTag tag, double v)\nSet(self, tag:vtkDICOMTag, v:str) -> None\nC++: void Set(vtkDICOMTag tag, const std::string &v)\nSet(self, tag:vtkDICOMTagPath, v:vtkDICOMValue) -> None\nC++: void Set(const vtkDICOMTagPath &tag, const vtkDICOMValue &v)\nSet(self, tag:vtkDICOMTagPath, v:float) -> None\nC++: void Set(const vtkDICOMTagPath &tag, double v)\nSet(self, tag:vtkDICOMTagPath, v:str) -> None\nC++: void Set(const vtkDICOMTagPath &tag, const std::string &v)\n\nAdd a data element to this item.\n\nIf you specify a string, it must either be an ASCII string, or it\nmust be encoded in the SpecificCharacterSet for this item.\n"},
  {"SetAttributeValue", PyvtkDICOMItem_SetAttributeValue, METH_VARARGS,
   "SetAttributeValue(self, tag:vtkDICOMTag, v:vtkDICOMValue) -> None\nC++: void SetAttributeValue(vtkDICOMTag tag,\n    const vtkDICOMValue &v)\nSetAttributeValue(self, tag:vtkDICOMTag, v:float) -> None\nC++: void SetAttributeValue(vtkDICOMTag tag, double v)\nSetAttributeValue(self, tag:vtkDICOMTag, v:str) -> None\nC++: void SetAttributeValue(vtkDICOMTag tag, const std::string &v)\nSetAttributeValue(self, tag:vtkDICOMTagPath, v:vtkDICOMValue)\n    -> None\nC++: void SetAttributeValue(const vtkDICOMTagPath &tag,\n    const vtkDICOMValue &v)\nSetAttributeValue(self, tag:vtkDICOMTagPath, v:float) -> None\nC++: void SetAttributeValue(const vtkDICOMTagPath &tag, double v)\nSetAttributeValue(self, tag:vtkDICOMTagPath, v:str) -> None\nC++: void SetAttributeValue(const vtkDICOMTagPath &tag,\n    const std::string &v)\n\nAdd a data element to this item.\n\nIf you specify a string, it must either be an ASCII string, or it\nmust be encoded in the SpecificCharacterSet for this item.\n"},
  {"Get", PyvtkDICOMItem_Get, METH_VARARGS,
   "Get(self, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(vtkDICOMTag tag)\nGet(self, tag:vtkDICOMTagPath) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(const vtkDICOMTagPath &tag)\n\nGet a data element from this item.\n"},
  {"GetAttributeValue", PyvtkDICOMItem_GetAttributeValue, METH_VARARGS,
   "GetAttributeValue(self, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(vtkDICOMTag tag)\nGetAttributeValue(self, tag:vtkDICOMTagPath) -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(\n    const vtkDICOMTagPath &tag)\n\nGet a data element from this item.\n"},
  {"GetByteOffset", PyvtkDICOMItem_GetByteOffset, METH_VARARGS,
   "GetByteOffset(self) -> int\nC++: unsigned int GetByteOffset()\n\nGet the offset of this item from the beginning of the file.\n\nSome DICOM files, such as DICOMDIR files, index into sequences\nvia byte offsets into the file.  Because of this, it is necessary\nto know the byte offset of each item in the sequence.\n"},
  {"GetNumberOfDataElements", PyvtkDICOMItem_GetNumberOfDataElements, METH_VARARGS,
   "GetNumberOfDataElements(self) -> int\nC++: int GetNumberOfDataElements()\n\nGet the number of data elements.\n"},
  {"Begin", PyvtkDICOMItem_Begin, METH_VARARGS,
   "Begin(self) -> vtkDICOMDataElementIterator\nC++: vtkDICOMDataElementIterator Begin()\n\nGet an iterator for the list of data elements.\n"},
  {"End", PyvtkDICOMItem_End, METH_VARARGS,
   "End(self) -> vtkDICOMDataElementIterator\nC++: vtkDICOMDataElementIterator End()\n\nGet an end iterator for the list of data elements.\n"},
  {"ResolvePrivateTag", PyvtkDICOMItem_ResolvePrivateTag, METH_VARARGS,
   "ResolvePrivateTag(self, ptag:vtkDICOMTag, creator:str)\n    -> vtkDICOMTag\nC++: vtkDICOMTag ResolvePrivateTag(vtkDICOMTag ptag,\n    const std::string &creator)\n\nResolve a private tag, or return (ffff,ffff) if not resolved.\n\nPrivate data elements are mobile, which means that different data\nsets might store them at different locations.  Given a private\ndata element which has a tag of (gggg,xxee) according to its\ndictionary, the first two element digits \"xx\" can change from one\ndata set to the next, and the data set must have a \"Creator\nElement\" at (gggg,00xx) to allow the digits of \"xx\" to be\nresolved.  Please read DICOM Part 5 Section 7.8 for additional\ninformation.\n"},
  {"ResolvePrivateTagForWriting", PyvtkDICOMItem_ResolvePrivateTagForWriting, METH_VARARGS,
   "ResolvePrivateTagForWriting(self, ptag:vtkDICOMTag, creator:str)\n    -> vtkDICOMTag\nC++: vtkDICOMTag ResolvePrivateTagForWriting(vtkDICOMTag ptag,\n    const std::string &creator)\n\nResolve a private tag, and add the creator to the data set.\n\nThis method works like ResolvePrivateTag, except that if the\ncreator is not found in the data set, it will be added.  It\nshould be used to resolve private tags that you plan to write to\nthe data set.  The returned tag will be (ffff,ffff) if there are\nno empty slots available for the creator.  Every private group\nhas 240 available slots.\n"},
  {"FindDictEntry", PyvtkDICOMItem_FindDictEntry, METH_VARARGS,
   "FindDictEntry(self, tag:vtkDICOMTag) -> vtkDICOMDictEntry\nC++: vtkDICOMDictEntry FindDictEntry(vtkDICOMTag tag)\n\nLook up a tag in the DICOM dictionary.\n\nUnlike the method in vtkDICOMDictionary, this method can identify\nthe implementor of a private tag and look it up in the\nimplementor's dictionary.\n"},
  {"FindDictVR", PyvtkDICOMItem_FindDictVR, METH_VARARGS,
   "FindDictVR(self, tag:vtkDICOMTag) -> vtkDICOMVR\nC++: vtkDICOMVR FindDictVR(vtkDICOMTag tag)\n\nUse the dictionary to get the VR, returns UN on failure.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMItem_vtkDICOMItem_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMItem");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMItem *op = new vtkDICOMItem();

    result = PyVTKSpecialObject_New("vtkDICOMItem", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMItem_vtkDICOMItem_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMItem");

  vtkDICOMMetaData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMMetaData"))
  {
    vtkDICOMItem *op = new vtkDICOMItem(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMItem", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMItem_vtkDICOMItem_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMItem");

  vtkDICOMCharacterSet *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMVR *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  int temp2 = 0;
  unsigned int temp3 = 0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2, 4) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMCharacterSet") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMVR") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)))
  {
    vtkDICOMItem *op = new vtkDICOMItem(*temp0, *temp1, temp2, temp3);

    result = PyVTKSpecialObject_New("vtkDICOMItem", op);
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMItem_vtkDICOMItem_s4(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMItem");

  vtkDICOMItem *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMItem"))
  {
    vtkDICOMItem *op = new vtkDICOMItem(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMItem", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMItem_vtkDICOMItem_Methods[] = {
  {"vtkDICOMItem", PyvtkDICOMItem_vtkDICOMItem_s2, METH_VARARGS,
   "-@V *vtkDICOMMetaData"},
  {"vtkDICOMItem", PyvtkDICOMItem_vtkDICOMItem_s4, METH_VARARGS,
   "@W vtkDICOMItem"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMItem_vtkDICOMItem(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMItem_vtkDICOMItem_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMItem_vtkDICOMItem_s1(self, args);
    case 2:
    case 3:
    case 4:
      return PyvtkDICOMItem_vtkDICOMItem_s3(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMItem");
  return nullptr;
}


static const char *PyvtkDICOMItem_Doc =

  "vtkDICOMItem() -> vtkDICOMItem\nC++: vtkDICOMItem()\nvtkDICOMItem(meta:vtkDICOMMetaData) -> vtkDICOMItem\nC++: explicit vtkDICOMItem(vtkDICOMMetaData *meta)\nvtkDICOMItem(cs:vtkDICOMCharacterSet, vrForXS:vtkDICOMVR,\n    delimited:int=0, byteOffset:int=0) -> vtkDICOMItem\nC++: explicit vtkDICOMItem(vtkDICOMCharacterSet cs,\n    vtkDICOMVR vrForXS, int delimited=0, unsigned int byteOffset=0)\nvtkDICOMItem(o:vtkDICOMItem) -> vtkDICOMItem\nC++: vtkDICOMItem(const vtkDICOMItem &o)\n""\n"
  "vtkDICOMItem - An item in a DICOM sequence (type SQ).\n\n"
  "A DICOM sequence is a list of items, where each item is essentially a\n"
  "data set of its own.  An item consists of zero or more data elements,\n"
  "each with a tag and value.\n\n";

static PyObject *
PyvtkDICOMItem_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMItem_vtkDICOMItem(nullptr, args);
}

static void PyvtkDICOMItem_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMItem *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static int PyvtkDICOMItem_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMItem_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMItem *so1 = nullptr;
  const vtkDICOMItem *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMItem_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMItem *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMItem *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMItem", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMItem_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMItem *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMItem *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMItem", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      break;
    case Py_LE:
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      break;
    case Py_GE:
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMItem_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMItem_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMItem", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMItem_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMItem_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMItem_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMItem_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMItem_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMItem_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMItem_Type);
}

static void *PyvtkDICOMItem_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMItem(*static_cast<const vtkDICOMItem*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMItem_TypeNew
extern "C" { PyObject *PyvtkDICOMItem_TypeNew(); }
#define DECLARED_PyvtkDICOMItem_TypeNew
#endif

PyObject *PyvtkDICOMItem_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMItem_Type,
    PyvtkDICOMItem_Methods,
    PyvtkDICOMItem_vtkDICOMItem_Methods,
    &PyvtkDICOMItem_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMItem(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMItem_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMItem", o) != 0)
  {
    Py_DECREF(o);
  }

}

