// python wrapper for vtkDICOMMetaDataAdapter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMMetaDataAdapter.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMMetaDataAdapter(PyObject *dict); }

static PyObject *
PyvtkDICOMMetaDataAdapter_GetNumberOfInstances(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfInstances");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMMetaDataAdapter *op = static_cast<vtkDICOMMetaDataAdapter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetNumberOfInstances();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaDataAdapter_Has(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Has");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMMetaDataAdapter *op = static_cast<vtkDICOMMetaDataAdapter *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    bool tempr = op->Has(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMMetaDataAdapter_HasAttribute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasAttribute");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMMetaDataAdapter *op = static_cast<vtkDICOMMetaDataAdapter *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    bool tempr = op->HasAttribute(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMMetaDataAdapter_Get_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMMetaDataAdapter *op = static_cast<vtkDICOMMetaDataAdapter *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = &op->Get(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaDataAdapter_Get_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMMetaDataAdapter *op = static_cast<vtkDICOMMetaDataAdapter *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = &op->Get(temp0, *temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaDataAdapter_Get(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return PyvtkDICOMMetaDataAdapter_Get_s1(self, args);
    case 2:
      return PyvtkDICOMMetaDataAdapter_Get_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Get");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaDataAdapter_GetAttributeValue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMMetaDataAdapter *op = static_cast<vtkDICOMMetaDataAdapter *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = &op->GetAttributeValue(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaDataAdapter_GetAttributeValue_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMMetaDataAdapter *op = static_cast<vtkDICOMMetaDataAdapter *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = &op->GetAttributeValue(temp0, *temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaDataAdapter_GetAttributeValue(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return PyvtkDICOMMetaDataAdapter_GetAttributeValue_s1(self, args);
    case 2:
      return PyvtkDICOMMetaDataAdapter_GetAttributeValue_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetAttributeValue");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaDataAdapter_ResolvePrivateTag_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResolvePrivateTag");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMMetaDataAdapter *op = static_cast<vtkDICOMMetaDataAdapter *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    vtkDICOMTag tempr = op->ResolvePrivateTag(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaDataAdapter_ResolvePrivateTag_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResolvePrivateTag");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMMetaDataAdapter *op = static_cast<vtkDICOMMetaDataAdapter *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag") &&
      ap.GetValue(temp2))
  {
    vtkDICOMTag tempr = op->ResolvePrivateTag(temp0, *temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaDataAdapter_ResolvePrivateTag(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return PyvtkDICOMMetaDataAdapter_ResolvePrivateTag_s1(self, args);
    case 3:
      return PyvtkDICOMMetaDataAdapter_ResolvePrivateTag_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "ResolvePrivateTag");
  return nullptr;
}

static PyMethodDef PyvtkDICOMMetaDataAdapter_Methods[] = {
  {"GetNumberOfInstances", PyvtkDICOMMetaDataAdapter_GetNumberOfInstances, METH_VARARGS,
   "GetNumberOfInstances(self) -> int\nC++: int GetNumberOfInstances()\n\nGet the number of instances (i.e. files).\n\nFor an enhanced multi-frame data set, this will return the number\nof frames.  For a non-enhanced data set, it returns the number of\ninstances in the series.\n"},
  {"Has", PyvtkDICOMMetaDataAdapter_Has, METH_VARARGS,
   "Has(self, tag:vtkDICOMTag) -> bool\nC++: bool Has(vtkDICOMTag tag)\n\nCheck whether an attribute is present in the metadata.\n\nFor an enhanced multi-frame data set, this will search the Shared\nand PerFrameFunctionGroupSequence in addition to searching the\nbasic data set attributes.\n"},
  {"HasAttribute", PyvtkDICOMMetaDataAdapter_HasAttribute, METH_VARARGS,
   "HasAttribute(self, tag:vtkDICOMTag) -> bool\nC++: bool HasAttribute(vtkDICOMTag tag)\n\nCheck whether an attribute is present in the metadata.\n\nFor an enhanced multi-frame data set, this will search the Shared\nand PerFrameFunctionGroupSequence in addition to searching the\nbasic data set attributes.\n"},
  {"Get", PyvtkDICOMMetaDataAdapter_Get, METH_VARARGS,
   "Get(self, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(vtkDICOMTag tag)\nGet(self, idx:int, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(int idx, vtkDICOMTag tag)\n\nGet an attribute value.\n\nFor an enhanced multi-frame data set, this will first try to\nretrieve the attribute from the SharedFunctionalGroupSequence.\n"},
  {"GetAttributeValue", PyvtkDICOMMetaDataAdapter_GetAttributeValue, METH_VARARGS,
   "GetAttributeValue(self, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(vtkDICOMTag tag)\nGetAttributeValue(self, idx:int, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(int idx,\n    vtkDICOMTag tag)\n\nGet an attribute value.\n\nFor an enhanced multi-frame data set, this will first try to\nretrieve the attribute from the SharedFunctionalGroupSequence.\n"},
  {"ResolvePrivateTag", PyvtkDICOMMetaDataAdapter_ResolvePrivateTag, METH_VARARGS,
   "ResolvePrivateTag(self, ptag:vtkDICOMTag, creator:str)\n    -> vtkDICOMTag\nC++: vtkDICOMTag ResolvePrivateTag(vtkDICOMTag ptag,\n    const std::string &creator)\nResolvePrivateTag(self, idx:int, ptag:vtkDICOMTag, creator:str)\n    -> vtkDICOMTag\nC++: vtkDICOMTag ResolvePrivateTag(int idx, vtkDICOMTag ptag,\n    const std::string &creator)\n\nResolve a private tag.\n\nFor an enhanced multi-frame data set, this will search the\nPerFrame attributes, then the Shared attributes, and finally the\nbasic data set attributes.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMMetaDataAdapter");

  vtkDICOMMetaData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMMetaData"))
  {
    vtkDICOMMetaDataAdapter *op = new vtkDICOMMetaDataAdapter(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMMetaDataAdapter", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMMetaDataAdapter");

  vtkDICOMMetaData *temp0 = nullptr;
  int temp1;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkDICOMMetaData") &&
      ap.GetValue(temp1))
  {
    vtkDICOMMetaDataAdapter *op = new vtkDICOMMetaDataAdapter(temp0, temp1);

    result = PyVTKSpecialObject_New("vtkDICOMMetaDataAdapter", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMMetaDataAdapter");

  vtkDICOMMetaDataAdapter *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMMetaDataAdapter"))
  {
    vtkDICOMMetaDataAdapter *op = new vtkDICOMMetaDataAdapter(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMMetaDataAdapter", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter_Methods[] = {
  {"vtkDICOMMetaDataAdapter", PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter_s1, METH_VARARGS,
   "@V *vtkDICOMMetaData"},
  {"vtkDICOMMetaDataAdapter", PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter_s3, METH_VARARGS,
   "@W vtkDICOMMetaDataAdapter"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter_s2(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMMetaDataAdapter");
  return nullptr;
}


static const char *PyvtkDICOMMetaDataAdapter_Doc =

  "vtkDICOMMetaDataAdapter(meta:vtkDICOMMetaData)\n    -> vtkDICOMMetaDataAdapter\nC++: vtkDICOMMetaDataAdapter(vtkDICOMMetaData *meta)\nvtkDICOMMetaDataAdapter(meta:vtkDICOMMetaData, i:int)\n    -> vtkDICOMMetaDataAdapter\nC++: vtkDICOMMetaDataAdapter(vtkDICOMMetaData *meta, int i)\nvtkDICOMMetaDataAdapter(__a:vtkDICOMMetaDataAdapter)\n    -> vtkDICOMMetaDataAdapter\nC++: vtkDICOMMetaDataAdapter(const vtkDICOMMetaDataAdapter &)\n""\n"
  "vtkDICOMMetaDataAdapter - An adapter to make multi-frame data look\nlike multi-file data.\n\n"
  "The vtkDICOMMetaDataAdapter object makes an enhanced multi-frame\n"
  "DICOM data set appear to be a series of data sets.  Whenever the\n"
  "caller requests and attribute from a specific instance, the attribute\n"
  "is instead pulled from the PerFrame item for a specific frame. If\n"
  "constructed from a metadata object that is not an enhanced\n"
  "multi-frame dataset, it simply acts as a pass-through.\n\n";

static PyObject *
PyvtkDICOMMetaDataAdapter_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter(nullptr, args);
}

static void PyvtkDICOMMetaDataAdapter_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMMetaDataAdapter *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDICOMMetaDataAdapter_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMMetaDataAdapter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMMetaDataAdapter", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMMetaDataAdapter_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMMetaDataAdapter_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMMetaDataAdapter_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMMetaDataAdapter_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkDICOMMetaDataAdapter_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMMetaDataAdapter(*static_cast<const vtkDICOMMetaDataAdapter*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMMetaDataAdapter_TypeNew
extern "C" { PyObject *PyvtkDICOMMetaDataAdapter_TypeNew(); }
#define DECLARED_PyvtkDICOMMetaDataAdapter_TypeNew
#endif

PyObject *PyvtkDICOMMetaDataAdapter_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMMetaDataAdapter_Type,
    PyvtkDICOMMetaDataAdapter_Methods,
    PyvtkDICOMMetaDataAdapter_vtkDICOMMetaDataAdapter_Methods,
    &PyvtkDICOMMetaDataAdapter_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMMetaDataAdapter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMMetaDataAdapter_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMMetaDataAdapter", o) != 0)
  {
    Py_DECREF(o);
  }

}

