// python wrapper for vtkDICOMMetaData
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMDataElement.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMDictEntry.h"
#include "vtkDICOMVR.h"
#include "vtkDICOMValue.h"
#include "vtkDICOMMetaData.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMMetaData(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMMetaData_ClassNew(); }


static PyObject *
PyvtkDICOMMetaData_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMMetaData::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMMetaData::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMMetaData *tempr = vtkDICOMMetaData::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMMetaData *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMMetaData::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMMetaData::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMMetaData::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_GetNumberOfInstances(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfInstances");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfInstances() :
      op->vtkDICOMMetaData::GetNumberOfInstances());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_SetNumberOfInstances(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfInstances");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfInstances(temp0);
    }
    else
    {
      op->vtkDICOMMetaData::SetNumberOfInstances(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_Clear(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Clear");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Clear();
    }
    else
    {
      op->vtkDICOMMetaData::Clear();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Initialize();
    }
    else
    {
      op->vtkDICOMMetaData::Initialize();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_GetNumberOfDataElements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfDataElements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfDataElements() :
      op->vtkDICOMMetaData::GetNumberOfDataElements());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_Begin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Begin");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMDataElementIterator tempr = (ap.IsBound() ?
      op->Begin() :
      op->vtkDICOMMetaData::Begin());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDataElementIterator");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_End(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "End");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMDataElementIterator tempr = (ap.IsBound() ?
      op->End() :
      op->vtkDICOMMetaData::End());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDataElementIterator");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_Find(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Find");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    vtkDICOMDataElementIterator tempr = (ap.IsBound() ?
      op->Find(*temp0) :
      op->vtkDICOMMetaData::Find(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDataElementIterator");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMMetaData_Has(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Has");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    bool tempr = (ap.IsBound() ?
      op->Has(*temp0) :
      op->vtkDICOMMetaData::Has(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMMetaData_HasAttribute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasAttribute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    bool tempr = (ap.IsBound() ?
      op->HasAttribute(*temp0) :
      op->vtkDICOMMetaData::HasAttribute(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMMetaData_Erase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Erase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    if (ap.IsBound())
    {
      op->Erase(*temp0);
    }
    else
    {
      op->vtkDICOMMetaData::Erase(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMMetaData_RemoveAttribute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAttribute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    if (ap.IsBound())
    {
      op->RemoveAttribute(*temp0);
    }
    else
    {
      op->vtkDICOMMetaData::RemoveAttribute(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMMetaData_Get_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->Get(*temp0) :
      &op->vtkDICOMMetaData::Get(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Get_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->Get(*temp0) :
      &op->vtkDICOMMetaData::Get(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Get_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->Get(temp0, *temp1) :
      &op->vtkDICOMMetaData::Get(temp0, *temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Get_s4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTagPath *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTagPath"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->Get(temp0, *temp1) :
      &op->vtkDICOMMetaData::Get(temp0, *temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Get_s5(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  int temp1;
  vtkDICOMTag *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->Get(temp0, temp1, *temp2) :
      &op->vtkDICOMMetaData::Get(temp0, temp1, *temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj2);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Get_s6(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Get");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  int temp1;
  vtkDICOMTagPath *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMTagPath"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->Get(temp0, temp1, *temp2) :
      &op->vtkDICOMMetaData::Get(temp0, temp1, *temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj2);

  return result;
}

static PyMethodDef PyvtkDICOMMetaData_Get_Methods[] = {
  {"Get", PyvtkDICOMMetaData_Get_s1, METH_VARARGS,
   "@W vtkDICOMTag"},
  {"Get", PyvtkDICOMMetaData_Get_s2, METH_VARARGS,
   "@W vtkDICOMTagPath"},
  {"Get", PyvtkDICOMMetaData_Get_s3, METH_VARARGS,
   "@iW vtkDICOMTag"},
  {"Get", PyvtkDICOMMetaData_Get_s4, METH_VARARGS,
   "@iW vtkDICOMTagPath"},
  {"Get", PyvtkDICOMMetaData_Get_s5, METH_VARARGS,
   "@iiW vtkDICOMTag"},
  {"Get", PyvtkDICOMMetaData_Get_s6, METH_VARARGS,
   "@iiW vtkDICOMTagPath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMMetaData_Get(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMMetaData_Get_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
    case 2:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Get");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaData_GetAttributeValue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->GetAttributeValue(*temp0) :
      &op->vtkDICOMMetaData::GetAttributeValue(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_GetAttributeValue_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->GetAttributeValue(*temp0) :
      &op->vtkDICOMMetaData::GetAttributeValue(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_GetAttributeValue_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->GetAttributeValue(temp0, *temp1) :
      &op->vtkDICOMMetaData::GetAttributeValue(temp0, *temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_GetAttributeValue_s4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTagPath *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTagPath"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->GetAttributeValue(temp0, *temp1) :
      &op->vtkDICOMMetaData::GetAttributeValue(temp0, *temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_GetAttributeValue_s5(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  int temp1;
  vtkDICOMTag *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMTag"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->GetAttributeValue(temp0, temp1, *temp2) :
      &op->vtkDICOMMetaData::GetAttributeValue(temp0, temp1, *temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj2);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_GetAttributeValue_s6(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  int temp1;
  vtkDICOMTagPath *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMTagPath"))
  {
    const vtkDICOMValue *tempr = (ap.IsBound() ?
      &op->GetAttributeValue(temp0, temp1, *temp2) :
      &op->vtkDICOMMetaData::GetAttributeValue(temp0, temp1, *temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj2);

  return result;
}

static PyMethodDef PyvtkDICOMMetaData_GetAttributeValue_Methods[] = {
  {"GetAttributeValue", PyvtkDICOMMetaData_GetAttributeValue_s1, METH_VARARGS,
   "@W vtkDICOMTag"},
  {"GetAttributeValue", PyvtkDICOMMetaData_GetAttributeValue_s2, METH_VARARGS,
   "@W vtkDICOMTagPath"},
  {"GetAttributeValue", PyvtkDICOMMetaData_GetAttributeValue_s3, METH_VARARGS,
   "@iW vtkDICOMTag"},
  {"GetAttributeValue", PyvtkDICOMMetaData_GetAttributeValue_s4, METH_VARARGS,
   "@iW vtkDICOMTagPath"},
  {"GetAttributeValue", PyvtkDICOMMetaData_GetAttributeValue_s5, METH_VARARGS,
   "@iiW vtkDICOMTag"},
  {"GetAttributeValue", PyvtkDICOMMetaData_GetAttributeValue_s6, METH_VARARGS,
   "@iiW vtkDICOMTagPath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMMetaData_GetAttributeValue(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMMetaData_GetAttributeValue_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
    case 2:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetAttributeValue");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaData_GetFileIndex_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->GetFileIndex(temp0, temp1, temp2) :
      op->vtkDICOMMetaData::GetFileIndex(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMMetaData_GetFileIndex_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFileIndex(temp0) :
      op->vtkDICOMMetaData::GetFileIndex(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMMetaData_GetFileIndex(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkDICOMMetaData_GetFileIndex_s1(self, args);
    case 1:
      return PyvtkDICOMMetaData_GetFileIndex_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetFileIndex");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaData_GetFrameIndex_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFrameIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->GetFrameIndex(temp0, temp1, temp2) :
      op->vtkDICOMMetaData::GetFrameIndex(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMMetaData_GetFrameIndex_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFrameIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFrameIndex(temp0) :
      op->vtkDICOMMetaData::GetFrameIndex(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMMetaData_GetFrameIndex(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkDICOMMetaData_GetFrameIndex_s1(self, args);
    case 1:
      return PyvtkDICOMMetaData_GetFrameIndex_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetFrameIndex");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaData_Set_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  vtkDICOMValue *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag") &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMValue"))
  {
    if (ap.IsBound())
    {
      op->Set(temp0, *temp1, *temp2);
    }
    else
    {
      op->vtkDICOMMetaData::Set(temp0, *temp1, *temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);
  Py_XDECREF(pobj2);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag") &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->Set(temp0, *temp1, temp2);
    }
    else
    {
      op->vtkDICOMMetaData::Set(temp0, *temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag") &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->Set(temp0, *temp1, temp2);
    }
    else
    {
      op->vtkDICOMMetaData::Set(temp0, *temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMValue *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMValue"))
  {
    if (ap.IsBound())
    {
      op->Set(*temp0, *temp1);
    }
    else
    {
      op->vtkDICOMMetaData::Set(*temp0, *temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s5(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->Set(*temp0, temp1);
    }
    else
    {
      op->vtkDICOMMetaData::Set(*temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s6(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->Set(*temp0, temp1);
    }
    else
    {
      op->vtkDICOMMetaData::Set(*temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s7(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTagPath *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  vtkDICOMValue *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTagPath") &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMValue"))
  {
    if (ap.IsBound())
    {
      op->Set(temp0, *temp1, *temp2);
    }
    else
    {
      op->vtkDICOMMetaData::Set(temp0, *temp1, *temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);
  Py_XDECREF(pobj2);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s8(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTagPath *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTagPath") &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->Set(temp0, *temp1, temp2);
    }
    else
    {
      op->vtkDICOMMetaData::Set(temp0, *temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s9(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTagPath *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTagPath") &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->Set(temp0, *temp1, temp2);
    }
    else
    {
      op->vtkDICOMMetaData::Set(temp0, *temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s10(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMValue *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMValue"))
  {
    if (ap.IsBound())
    {
      op->Set(*temp0, *temp1);
    }
    else
    {
      op->vtkDICOMMetaData::Set(*temp0, *temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s11(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->Set(*temp0, temp1);
    }
    else
    {
      op->vtkDICOMMetaData::Set(*temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_Set_s12(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Set");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->Set(*temp0, temp1);
    }
    else
    {
      op->vtkDICOMMetaData::Set(*temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMMetaData_Set_Methods[] = {
  {"Set", PyvtkDICOMMetaData_Set_s1, METH_VARARGS,
   "@iWW vtkDICOMTag vtkDICOMValue"},
  {"Set", PyvtkDICOMMetaData_Set_s2, METH_VARARGS,
   "@iWd vtkDICOMTag"},
  {"Set", PyvtkDICOMMetaData_Set_s3, METH_VARARGS,
   "@iWs vtkDICOMTag"},
  {"Set", PyvtkDICOMMetaData_Set_s4, METH_VARARGS,
   "@WW vtkDICOMTag vtkDICOMValue"},
  {"Set", PyvtkDICOMMetaData_Set_s5, METH_VARARGS,
   "@Wd vtkDICOMTag"},
  {"Set", PyvtkDICOMMetaData_Set_s6, METH_VARARGS,
   "@Ws vtkDICOMTag"},
  {"Set", PyvtkDICOMMetaData_Set_s7, METH_VARARGS,
   "@iWW vtkDICOMTagPath vtkDICOMValue"},
  {"Set", PyvtkDICOMMetaData_Set_s8, METH_VARARGS,
   "@iWd vtkDICOMTagPath"},
  {"Set", PyvtkDICOMMetaData_Set_s9, METH_VARARGS,
   "@iWs vtkDICOMTagPath"},
  {"Set", PyvtkDICOMMetaData_Set_s10, METH_VARARGS,
   "@WW vtkDICOMTagPath vtkDICOMValue"},
  {"Set", PyvtkDICOMMetaData_Set_s11, METH_VARARGS,
   "@Wd vtkDICOMTagPath"},
  {"Set", PyvtkDICOMMetaData_Set_s12, METH_VARARGS,
   "@Ws vtkDICOMTagPath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMMetaData_Set(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMMetaData_Set_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Set");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  vtkDICOMValue *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag") &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMValue"))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(temp0, *temp1, *temp2);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(temp0, *temp1, *temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);
  Py_XDECREF(pobj2);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag") &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(temp0, *temp1, temp2);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(temp0, *temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag") &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(temp0, *temp1, temp2);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(temp0, *temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMValue *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMValue"))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(*temp0, *temp1);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(*temp0, *temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s5(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(*temp0, temp1);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(*temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s6(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(*temp0, temp1);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(*temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s7(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTagPath *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  vtkDICOMValue *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTagPath") &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMValue"))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(temp0, *temp1, *temp2);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(temp0, *temp1, *temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);
  Py_XDECREF(pobj2);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s8(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTagPath *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  double temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTagPath") &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(temp0, *temp1, temp2);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(temp0, *temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s9(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTagPath *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTagPath") &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(temp0, *temp1, temp2);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(temp0, *temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s10(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMValue *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMValue"))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(*temp0, *temp1);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(*temp0, *temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s11(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(*temp0, temp1);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(*temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue_s12(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributeValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetAttributeValue(*temp0, temp1);
    }
    else
    {
      op->vtkDICOMMetaData::SetAttributeValue(*temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMMetaData_SetAttributeValue_Methods[] = {
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s1, METH_VARARGS,
   "@iWW vtkDICOMTag vtkDICOMValue"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s2, METH_VARARGS,
   "@iWd vtkDICOMTag"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s3, METH_VARARGS,
   "@iWs vtkDICOMTag"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s4, METH_VARARGS,
   "@WW vtkDICOMTag vtkDICOMValue"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s5, METH_VARARGS,
   "@Wd vtkDICOMTag"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s6, METH_VARARGS,
   "@Ws vtkDICOMTag"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s7, METH_VARARGS,
   "@iWW vtkDICOMTagPath vtkDICOMValue"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s8, METH_VARARGS,
   "@iWd vtkDICOMTagPath"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s9, METH_VARARGS,
   "@iWs vtkDICOMTagPath"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s10, METH_VARARGS,
   "@WW vtkDICOMTagPath vtkDICOMValue"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s11, METH_VARARGS,
   "@Wd vtkDICOMTagPath"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue_s12, METH_VARARGS,
   "@Ws vtkDICOMTagPath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMMetaData_SetAttributeValue(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMMetaData_SetAttributeValue_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetAttributeValue");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaData_ResolvePrivateTag_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResolvePrivateTag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    vtkDICOMTag tempr = (ap.IsBound() ?
      op->ResolvePrivateTag(*temp0, temp1) :
      op->vtkDICOMMetaData::ResolvePrivateTag(*temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_ResolvePrivateTag_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResolvePrivateTag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag") &&
      ap.GetValue(temp2))
  {
    vtkDICOMTag tempr = (ap.IsBound() ?
      op->ResolvePrivateTag(temp0, *temp1, temp2) :
      op->vtkDICOMMetaData::ResolvePrivateTag(temp0, *temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_ResolvePrivateTag(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkDICOMMetaData_ResolvePrivateTag_s1(self, args);
    case 3:
      return PyvtkDICOMMetaData_ResolvePrivateTag_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "ResolvePrivateTag");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaData_ResolvePrivateTagForWriting_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResolvePrivateTagForWriting");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1))
  {
    vtkDICOMTag tempr = (ap.IsBound() ?
      op->ResolvePrivateTagForWriting(*temp0, temp1) :
      op->vtkDICOMMetaData::ResolvePrivateTagForWriting(*temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_ResolvePrivateTagForWriting_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResolvePrivateTagForWriting");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag") &&
      ap.GetValue(temp2))
  {
    vtkDICOMTag tempr = (ap.IsBound() ?
      op->ResolvePrivateTagForWriting(temp0, *temp1, temp2) :
      op->vtkDICOMMetaData::ResolvePrivateTagForWriting(temp0, *temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMMetaData_ResolvePrivateTagForWriting(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkDICOMMetaData_ResolvePrivateTagForWriting_s1(self, args);
    case 3:
      return PyvtkDICOMMetaData_ResolvePrivateTagForWriting_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "ResolvePrivateTagForWriting");
  return nullptr;
}


static PyObject *
PyvtkDICOMMetaData_FindDictEntry(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FindDictEntry");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    vtkDICOMDictEntry tempr = (ap.IsBound() ?
      op->FindDictEntry(*temp0) :
      op->vtkDICOMMetaData::FindDictEntry(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMDictEntry");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMMetaData_FindDictVR(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FindDictVR");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  int temp0;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag"))
  {
    vtkDICOMVR tempr = (ap.IsBound() ?
      op->FindDictVR(temp0, *temp1) :
      op->vtkDICOMMetaData::FindDictVR(temp0, *temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMVR");
    }
  }

  Py_XDECREF(pobj1);

  return result;
}


static PyObject *
PyvtkDICOMMetaData_MakeValueWithSpecificCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MakeValueWithSpecificCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    vtkDICOMValue tempr = (ap.IsBound() ?
      op->MakeValueWithSpecificCharacterSet(*temp0, temp1) :
      op->vtkDICOMMetaData::MakeValueWithSpecificCharacterSet(*temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMMetaData_SetFileIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkIntArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkIntArray"))
  {
    if (ap.IsBound())
    {
      op->SetFileIndexArray(temp0);
    }
    else
    {
      op->vtkDICOMMetaData::SetFileIndexArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_GetFileIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetFileIndexArray() :
      op->vtkDICOMMetaData::GetFileIndexArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_SetFrameIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFrameIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkIntArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkIntArray"))
  {
    if (ap.IsBound())
    {
      op->SetFrameIndexArray(temp0);
    }
    else
    {
      op->vtkDICOMMetaData::SetFrameIndexArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_GetFrameIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFrameIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetFrameIndexArray() :
      op->vtkDICOMMetaData::GetFrameIndexArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_CopyAttributes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyAttributes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDICOMMetaData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMMetaData"))
  {
    if (ap.IsBound())
    {
      op->CopyAttributes(temp0);
    }
    else
    {
      op->vtkDICOMMetaData::CopyAttributes(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_ShallowCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ShallowCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDataObject *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->ShallowCopy(temp0);
    }
    else
    {
      op->vtkDICOMMetaData::ShallowCopy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMMetaData_DeepCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeepCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMMetaData *op = static_cast<vtkDICOMMetaData *>(vp);

  vtkDataObject *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->DeepCopy(temp0);
    }
    else
    {
      op->vtkDICOMMetaData::DeepCopy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMMetaData_Methods[] = {
  {"IsTypeOf", PyvtkDICOMMetaData_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMMetaData_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMMetaData_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMMetaData\nC++: static vtkDICOMMetaData *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMMetaData_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMMetaData\nC++: vtkDICOMMetaData *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMMetaData_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMMetaData_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfInstances", PyvtkDICOMMetaData_GetNumberOfInstances, METH_VARARGS,
   "GetNumberOfInstances(self) -> int\nC++: int GetNumberOfInstances()\n\nGet the number of instances (i.e. files).\n\nWe want to track the metadata from all of the files that make up\nthe image volume that we have loaded into VTK. This method gives\nthe number of files used to construct this meta data.  All the\nfiles should be from the same series.\n"},
  {"SetNumberOfInstances", PyvtkDICOMMetaData_SetNumberOfInstances, METH_VARARGS,
   "SetNumberOfInstances(self, n:int) -> None\nC++: void SetNumberOfInstances(int n)\n\nGet the number of instances (i.e. files).\n\nWe want to track the metadata from all of the files that make up\nthe image volume that we have loaded into VTK. This method gives\nthe number of files used to construct this meta data.  All the\nfiles should be from the same series.\n"},
  {"Clear", PyvtkDICOMMetaData_Clear, METH_VARARGS,
   "Clear(self) -> None\nC++: void Clear()\n\nRemove all data elements.\n"},
  {"Initialize", PyvtkDICOMMetaData_Initialize, METH_VARARGS,
   "Initialize(self) -> None\nC++: void Initialize() override;\n\nRemove all data elements and initialize all members.\n"},
  {"GetNumberOfDataElements", PyvtkDICOMMetaData_GetNumberOfDataElements, METH_VARARGS,
   "GetNumberOfDataElements(self) -> int\nC++: int GetNumberOfDataElements()\n\nGet the number of data elements that are present.\n"},
  {"Begin", PyvtkDICOMMetaData_Begin, METH_VARARGS,
   "Begin(self) -> vtkDICOMDataElementIterator\nC++: vtkDICOMDataElementIterator Begin()\n\nGet an iterator for the list of data elements.\n"},
  {"End", PyvtkDICOMMetaData_End, METH_VARARGS,
   "End(self) -> vtkDICOMDataElementIterator\nC++: vtkDICOMDataElementIterator End()\n\nGet an end iterator for the list of data elements.\n"},
  {"Find", PyvtkDICOMMetaData_Find, METH_VARARGS,
   "Find(self, tag:vtkDICOMTag) -> vtkDICOMDataElementIterator\nC++: vtkDICOMDataElementIterator Find(vtkDICOMTag tag)\n\nGet the iterator for a specific data element.\n\nIf the element was not found, then End() will be returned.\n"},
  {"Has", PyvtkDICOMMetaData_Has, METH_VARARGS,
   "Has(self, tag:vtkDICOMTag) -> bool\nC++: bool Has(vtkDICOMTag tag)\n\nCheck whether an attribute is present in the metadata.\n"},
  {"HasAttribute", PyvtkDICOMMetaData_HasAttribute, METH_VARARGS,
   "HasAttribute(self, tag:vtkDICOMTag) -> bool\nC++: bool HasAttribute(vtkDICOMTag tag)\n\nCheck whether an attribute is present in the metadata.\n"},
  {"Erase", PyvtkDICOMMetaData_Erase, METH_VARARGS,
   "Erase(self, tag:vtkDICOMTag) -> None\nC++: void Erase(vtkDICOMTag tag)\n\nErase an attribute.\n"},
  {"RemoveAttribute", PyvtkDICOMMetaData_RemoveAttribute, METH_VARARGS,
   "RemoveAttribute(self, tag:vtkDICOMTag) -> None\nC++: void RemoveAttribute(vtkDICOMTag tag)\n\nErase an attribute.\n"},
  {"Get", PyvtkDICOMMetaData_Get, METH_VARARGS,
   "Get(self, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(vtkDICOMTag tag)\nGet(self, p:vtkDICOMTagPath) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(const vtkDICOMTagPath &p)\nGet(self, idx:int, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(int idx, vtkDICOMTag tag)\nGet(self, idx:int, p:vtkDICOMTagPath) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(int idx, const vtkDICOMTagPath &p)\nGet(self, idx:int, frame:int, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(int idx, int frame, vtkDICOMTag tag)\nGet(self, idx:int, frame:int, p:vtkDICOMTagPath) -> vtkDICOMValue\nC++: const vtkDICOMValue &Get(int idx, int frame,\n    const vtkDICOMTagPath &p)\n\nGet an attribute value.\n\nThe tag will usually be specified in one of these two ways:\nGet(vtkDICOMTag(0x0008,0x1030)) or, using the dictionary enum\ntype, Get(DC::StudyDescription).  If the attribute is not\npresent, then the returned value will be invalid, i.e.\nv.IsValid() will be false.\n"},
  {"GetAttributeValue", PyvtkDICOMMetaData_GetAttributeValue, METH_VARARGS,
   "GetAttributeValue(self, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(vtkDICOMTag tag)\nGetAttributeValue(self, p:vtkDICOMTagPath) -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(\n    const vtkDICOMTagPath &p)\nGetAttributeValue(self, idx:int, tag:vtkDICOMTag) -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(int idx,\n    vtkDICOMTag tag)\nGetAttributeValue(self, idx:int, p:vtkDICOMTagPath)\n    -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(int idx,\n    const vtkDICOMTagPath &p)\nGetAttributeValue(self, idx:int, frame:int, tag:vtkDICOMTag)\n    -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(int idx, int frame,\n    vtkDICOMTag tag)\nGetAttributeValue(self, idx:int, frame:int, p:vtkDICOMTagPath)\n    -> vtkDICOMValue\nC++: const vtkDICOMValue &GetAttributeValue(int idx, int frame,\n    const vtkDICOMTagPath &p)\n\nGet an attribute value.\n\nThe tag will usually be specified in one of these two ways:\nGet(vtkDICOMTag(0x0008,0x1030)) or, using the dictionary enum\ntype, Get(DC::StudyDescription).  If the attribute is not\npresent, then the returned value will be invalid, i.e.\nv.IsValid() will be false.\n"},
  {"GetFileIndex", PyvtkDICOMMetaData_GetFileIndex, METH_VARARGS,
   "GetFileIndex(self, sliceIdx:int, compIdx:int, numComps:int) -> int\nC++: int GetFileIndex(int sliceIdx, int compIdx, int numComps)\nGetFileIndex(self, sliceIdx:int) -> int\nC++: int GetFileIndex(int sliceIdx)\n\nGet the file index for the given image slice and component.\n\nThis takes into account the way the files were sorted to create\nthe volume (as given by the FileIndexArray).  For multi-component\nimages, supply both the component of interest, and the total\nnumber of components.  The return value will be -1 if an index is\nout of range.\n"},
  {"GetFrameIndex", PyvtkDICOMMetaData_GetFrameIndex, METH_VARARGS,
   "GetFrameIndex(self, sliceIdx:int, compIdx:int, numComps:int)\n    -> int\nC++: int GetFrameIndex(int sliceIdx, int compIdx, int numComps)\nGetFrameIndex(self, sliceIdx:int) -> int\nC++: int GetFrameIndex(int sliceIdx)\n\nGet the frame index for the given image slice and component.\n\nThis takes into account the way the frames were sorted to create\nthe volume (as given by the FileIndexArray).  For multi-component\nimages, supply both the component of interest, and the total\nnumber of components.  The return value will be -1 if an index is\nout of range.\n"},
  {"Set", PyvtkDICOMMetaData_Set, METH_VARARGS,
   "Set(self, idx:int, tag:vtkDICOMTag, v:vtkDICOMValue) -> None\nC++: void Set(int idx, vtkDICOMTag tag, const vtkDICOMValue &v)\nSet(self, idx:int, tag:vtkDICOMTag, v:float) -> None\nC++: void Set(int idx, vtkDICOMTag tag, double v)\nSet(self, idx:int, tag:vtkDICOMTag, v:str) -> None\nC++: void Set(int idx, vtkDICOMTag tag, const std::string &v)\nSet(self, tag:vtkDICOMTag, v:vtkDICOMValue) -> None\nC++: void Set(vtkDICOMTag tag, const vtkDICOMValue &v)\nSet(self, tag:vtkDICOMTag, v:float) -> None\nC++: void Set(vtkDICOMTag tag, double v)\nSet(self, tag:vtkDICOMTag, v:str) -> None\nC++: void Set(vtkDICOMTag tag, const std::string &v)\nSet(self, idx:int, tag:vtkDICOMTagPath, v:vtkDICOMValue) -> None\nC++: void Set(int idx, const vtkDICOMTagPath &tag,\n    const vtkDICOMValue &v)\nSet(self, idx:int, tag:vtkDICOMTagPath, v:float) -> None\nC++: void Set(int idx, const vtkDICOMTagPath &tag, double v)\nSet(self, idx:int, tag:vtkDICOMTagPath, v:str) -> None\nC++: void Set(int idx, const vtkDICOMTagPath &tag,\n    const std::string &v)\nSet(self, tag:vtkDICOMTagPath, v:vtkDICOMValue) -> None\nC++: void Set(const vtkDICOMTagPath &tag, const vtkDICOMValue &v)\nSet(self, tag:vtkDICOMTagPath, v:float) -> None\nC++: void Set(const vtkDICOMTagPath &tag, double v)\nSet(self, tag:vtkDICOMTagPath, v:str) -> None\nC++: void Set(const vtkDICOMTagPath &tag, const std::string &v)\n\nSet an attribute value for the image at file index \"idx\".\n\nExcept for the method that takes a vtkDICOMValue, these methods\nwill use the dictionary to find the VR for the attribute, and\nwill attempt to convert the input data to the correct VR. \nStrings and doubles will be converted to integer values where\nnecessary, and numeric values will be converted to strings where\nnecessary. Note that if you specify a string value, it must\neither be an ASCII string, or it must be encoded in the\nSpecificCharacterSet for this data set.\n"},
  {"SetAttributeValue", PyvtkDICOMMetaData_SetAttributeValue, METH_VARARGS,
   "SetAttributeValue(self, idx:int, tag:vtkDICOMTag, v:vtkDICOMValue)\n     -> None\nC++: void SetAttributeValue(int idx, vtkDICOMTag tag,\n    const vtkDICOMValue &v)\nSetAttributeValue(self, idx:int, tag:vtkDICOMTag, v:float) -> None\nC++: void SetAttributeValue(int idx, vtkDICOMTag tag, double v)\nSetAttributeValue(self, idx:int, tag:vtkDICOMTag, v:str) -> None\nC++: void SetAttributeValue(int idx, vtkDICOMTag tag,\n    const std::string &v)\nSetAttributeValue(self, tag:vtkDICOMTag, v:vtkDICOMValue) -> None\nC++: void SetAttributeValue(vtkDICOMTag tag,\n    const vtkDICOMValue &v)\nSetAttributeValue(self, tag:vtkDICOMTag, v:float) -> None\nC++: void SetAttributeValue(vtkDICOMTag tag, double v)\nSetAttributeValue(self, tag:vtkDICOMTag, v:str) -> None\nC++: void SetAttributeValue(vtkDICOMTag tag, const std::string &v)\nSetAttributeValue(self, idx:int, tag:vtkDICOMTagPath,\n    v:vtkDICOMValue) -> None\nC++: void SetAttributeValue(int idx, const vtkDICOMTagPath &tag,\n    const vtkDICOMValue &v)\nSetAttributeValue(self, idx:int, tag:vtkDICOMTagPath, v:float)\n    -> None\nC++: void SetAttributeValue(int idx, const vtkDICOMTagPath &tag,\n    double v)\nSetAttributeValue(self, idx:int, tag:vtkDICOMTagPath, v:str)\n    -> None\nC++: void SetAttributeValue(int idx, const vtkDICOMTagPath &tag,\n    const std::string &v)\nSetAttributeValue(self, tag:vtkDICOMTagPath, v:vtkDICOMValue)\n    -> None\nC++: void SetAttributeValue(const vtkDICOMTagPath &tag,\n    const vtkDICOMValue &v)\nSetAttributeValue(self, tag:vtkDICOMTagPath, v:float) -> None\nC++: void SetAttributeValue(const vtkDICOMTagPath &tag, double v)\nSetAttributeValue(self, tag:vtkDICOMTagPath, v:str) -> None\nC++: void SetAttributeValue(const vtkDICOMTagPath &tag,\n    const std::string &v)\n\nSet an attribute value for the image at file index \"idx\".\n\nExcept for the method that takes a vtkDICOMValue, these methods\nwill use the dictionary to find the VR for the attribute, and\nwill attempt to convert the input data to the correct VR.  ...\n [Truncated]\n"},
  {"ResolvePrivateTag", PyvtkDICOMMetaData_ResolvePrivateTag, METH_VARARGS,
   "ResolvePrivateTag(self, ptag:vtkDICOMTag, creator:str)\n    -> vtkDICOMTag\nC++: vtkDICOMTag ResolvePrivateTag(vtkDICOMTag ptag,\n    const std::string &creator)\nResolvePrivateTag(self, idx:int, ptag:vtkDICOMTag, creator:str)\n    -> vtkDICOMTag\nC++: vtkDICOMTag ResolvePrivateTag(int idx, vtkDICOMTag ptag,\n    const std::string &creator)\n\nResolve a private tag, or return (ffff,ffff) if not resolved.\n\nPrivate data elements are mobile, which means that different data\nsets might store them at different locations.  Given a private\ndata element which has a tag of (gggg,xxee) according to its\ndictionary, the first two element digits \"xx\" can change from one\ndata set to the next, and the data set must have a \"Creator\nElement\" at (gggg,00xx) to allow the digits of \"xx\" to be\nresolved.  Please read DICOM Part 5 Section 7.8 for additional\ninformation.\n"},
  {"ResolvePrivateTagForWriting", PyvtkDICOMMetaData_ResolvePrivateTagForWriting, METH_VARARGS,
   "ResolvePrivateTagForWriting(self, ptag:vtkDICOMTag, creator:str)\n    -> vtkDICOMTag\nC++: vtkDICOMTag ResolvePrivateTagForWriting(vtkDICOMTag ptag,\n    const std::string &creator)\nResolvePrivateTagForWriting(self, idx:int, ptag:vtkDICOMTag,\n    creator:str) -> vtkDICOMTag\nC++: vtkDICOMTag ResolvePrivateTagForWriting(int idx,\n    vtkDICOMTag ptag, const std::string &creator)\n\nResolve a private tag, and add the creator to the data set.\n\nThis method works like ResolvePrivateTag, except that if the\ncreator is not found in the data set, it will be added.  It\nshould be used to resolve private tags that you plan to write to\nthe data set.  The returned tag will be (ffff,ffff) if there are\nno empty slots available for the creator.  Every private group\nhas 240 available slots.\n"},
  {"FindDictEntry", PyvtkDICOMMetaData_FindDictEntry, METH_VARARGS,
   "FindDictEntry(self, tag:vtkDICOMTag) -> vtkDICOMDictEntry\nC++: vtkDICOMDictEntry FindDictEntry(vtkDICOMTag tag)\n\nLook up a tag in the DICOM dictionary.\n\nUnlike the method in vtkDICOMDictionary, this method can identify\nthe implementor of a private tag and look it up in the\nimplementor's dictionary.\n"},
  {"FindDictVR", PyvtkDICOMMetaData_FindDictVR, METH_VARARGS,
   "FindDictVR(self, idx:int, tag:vtkDICOMTag) -> vtkDICOMVR\nC++: vtkDICOMVR FindDictVR(int idx, vtkDICOMTag tag)\n\nUse the dictionary to get the VR, return UN if not found.\n"},
  {"MakeValueWithSpecificCharacterSet", PyvtkDICOMMetaData_MakeValueWithSpecificCharacterSet, METH_VARARGS,
   "MakeValueWithSpecificCharacterSet(self, vr:vtkDICOMVR, v:str)\n    -> vtkDICOMValue\nC++: vtkDICOMValue MakeValueWithSpecificCharacterSet(\n    vtkDICOMVR vr, const std::string &v)\n\nCreate a value from text in a specific character set.\n"},
  {"SetFileIndexArray", PyvtkDICOMMetaData_SetFileIndexArray, METH_VARARGS,
   "SetFileIndexArray(self, fileArray:vtkIntArray) -> None\nC++: void SetFileIndexArray(vtkIntArray *fileArray)\n\nSet the array to convert slice, component indices to file index.\n"},
  {"GetFileIndexArray", PyvtkDICOMMetaData_GetFileIndexArray, METH_VARARGS,
   "GetFileIndexArray(self) -> vtkIntArray\nC++: vtkIntArray *GetFileIndexArray()\n\nSet the array to convert slice, component indices to file index.\n"},
  {"SetFrameIndexArray", PyvtkDICOMMetaData_SetFrameIndexArray, METH_VARARGS,
   "SetFrameIndexArray(self, frameArray:vtkIntArray) -> None\nC++: void SetFrameIndexArray(vtkIntArray *frameArray)\n\nSet the array to convert slice, component indices to frame index.\n"},
  {"GetFrameIndexArray", PyvtkDICOMMetaData_GetFrameIndexArray, METH_VARARGS,
   "GetFrameIndexArray(self) -> vtkIntArray\nC++: vtkIntArray *GetFrameIndexArray()\n\nSet the array to convert slice, component indices to frame index.\n"},
  {"CopyAttributes", PyvtkDICOMMetaData_CopyAttributes, METH_VARARGS,
   "CopyAttributes(self, source:vtkDICOMMetaData) -> None\nC++: void CopyAttributes(vtkDICOMMetaData *source)\n\nCopy all the attributes from another MetaData object.\n\nCopy attributes from the source meta data object into this one.\nIf the source has the same NumberOfInstances as this, then the\nattributes are copied on an instance-by-instance basis. \nOtherwise, attributes are only copied from the source if they\nhave the same value for all instances.\n"},
  {"ShallowCopy", PyvtkDICOMMetaData_ShallowCopy, METH_VARARGS,
   "ShallowCopy(self, source:vtkDataObject) -> None\nC++: void ShallowCopy(vtkDataObject *source) override;\n\nDataObject interface function.\n"},
  {"DeepCopy", PyvtkDICOMMetaData_DeepCopy, METH_VARARGS,
   "DeepCopy(self, source:vtkDataObject) -> None\nC++: void DeepCopy(vtkDataObject *source) override;\n\nDataObject interface function.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMMetaData_Doc =
  "vtkDICOMMetaData - A container class for DICOM metadata.\n\n"
  "Superclass: vtkDataObject\n\n"
  "The vtkDICOMMetaData object stores DICOM metadata in a hash table for\n"
  "efficient access.  One vtkDICOMMetaData object can store the metadata\n"
  "for a series of DICOM images.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMMetaData_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMMetaData", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMMetaData_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMMetaData_StaticNew()
{
  return vtkDICOMMetaData::New();
}

PyObject *PyvtkDICOMMetaData_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMMetaData_Type, PyvtkDICOMMetaData_Methods,
    "vtkDICOMMetaData",
 &PyvtkDICOMMetaData_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkDataObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMMetaData(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMMetaData_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMMetaData", o) != 0)
  {
    Py_DECREF(o);
  }

}

