// python wrapper for vtkDICOMParser
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMCharacterSet.h"
#include "vtkDICOMParser.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMParser(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMParser_ClassNew(); }


static PyObject *
PyvtkDICOMParser_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMParser::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMParser::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMParser *tempr = vtkDICOMParser::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMParser *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMParser::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMParser::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMParser::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetFilePath(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkDICOMParser::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkDICOMParser::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_SetMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  vtkDICOMMetaData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMMetaData"))
  {
    if (ap.IsBound())
    {
      op->SetMetaData(temp0);
    }
    else
    {
      op->vtkDICOMParser::SetMetaData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMMetaData *tempr = (ap.IsBound() ?
      op->GetMetaData() :
      op->vtkDICOMParser::GetMetaData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_SetIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIndex(temp0);
    }
    else
    {
      op->vtkDICOMParser::SetIndex(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetIndex() :
      op->vtkDICOMParser::GetIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_SetDefaultCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDefaultCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  vtkDICOMCharacterSet *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMCharacterSet"))
  {
    if (ap.IsBound())
    {
      op->SetDefaultCharacterSet(*temp0);
    }
    else
    {
      op->vtkDICOMParser::SetDefaultCharacterSet(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMParser_GetDefaultCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMCharacterSet tempr = (ap.IsBound() ?
      op->GetDefaultCharacterSet() :
      op->vtkDICOMParser::GetDefaultCharacterSet());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMCharacterSet");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_SetOverrideCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverrideCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOverrideCharacterSet(temp0);
    }
    else
    {
      op->vtkDICOMParser::SetOverrideCharacterSet(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_OverrideCharacterSetOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OverrideCharacterSetOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OverrideCharacterSetOn();
    }
    else
    {
      op->vtkDICOMParser::OverrideCharacterSetOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_OverrideCharacterSetOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OverrideCharacterSetOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OverrideCharacterSetOff();
    }
    else
    {
      op->vtkDICOMParser::OverrideCharacterSetOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetOverrideCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverrideCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetOverrideCharacterSet() :
      op->vtkDICOMParser::GetOverrideCharacterSet());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_SetQuery(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQuery");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  vtkDICOMMetaData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMMetaData"))
  {
    if (ap.IsBound())
    {
      op->SetQuery(temp0);
    }
    else
    {
      op->vtkDICOMParser::SetQuery(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetQuery(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQuery");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMMetaData *tempr = (ap.IsBound() ?
      op->GetQuery() :
      op->vtkDICOMParser::GetQuery());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_SetQueryItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQueryItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  vtkDICOMItem *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMItem"))
  {
    if (ap.IsBound())
    {
      op->SetQueryItem(*temp0);
    }
    else
    {
      op->vtkDICOMParser::SetQueryItem(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMParser_SetGroups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGroups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  vtkUnsignedShortArray *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkUnsignedShortArray"))
  {
    if (ap.IsBound())
    {
      op->SetGroups(temp0);
    }
    else
    {
      op->vtkDICOMParser::SetGroups(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetGroups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGroups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkUnsignedShortArray *tempr = (ap.IsBound() ?
      op->GetGroups() :
      op->vtkDICOMParser::GetGroups());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetQueryMatched(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQueryMatched");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetQueryMatched() :
      op->vtkDICOMParser::GetQueryMatched());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetPixelDataFound(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPixelDataFound");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetPixelDataFound() :
      op->vtkDICOMParser::GetPixelDataFound());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetPixelDataVL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPixelDataVL");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetPixelDataVL() :
      op->vtkDICOMParser::GetPixelDataVL());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetFileOffset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileOffset");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetFileOffset() :
      op->vtkDICOMParser::GetFileOffset());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetFileSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetFileSize() :
      op->vtkDICOMParser::GetFileSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_SetBufferSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBufferSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetBufferSize(temp0);
    }
    else
    {
      op->vtkDICOMParser::SetBufferSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetBufferSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBufferSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetBufferSize() :
      op->vtkDICOMParser::GetBufferSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkDICOMParser::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMParser_GetErrorCode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetErrorCode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMParser *op = static_cast<vtkDICOMParser *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetErrorCode() :
      op->vtkDICOMParser::GetErrorCode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMParser_Methods[] = {
  {"IsTypeOf", PyvtkDICOMParser_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMParser_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMParser_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMParser\nC++: static vtkDICOMParser *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMParser_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMParser\nC++: vtkDICOMParser *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMParser_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMParser_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetFileName", PyvtkDICOMParser_SetFileName, METH_VARARGS,
   "SetFileName(self, _arg:str) -> None\nC++: virtual void SetFileName(const char *_arg)\n\nSet the file name.\n"},
  {"GetFileName", PyvtkDICOMParser_GetFileName, METH_VARARGS,
   "GetFileName(self) -> str\nC++: virtual char *GetFileName()\n\nSet the file name.\n"},
  {"SetMetaData", PyvtkDICOMParser_SetMetaData, METH_VARARGS,
   "SetMetaData(self, __a:vtkDICOMMetaData) -> None\nC++: void SetMetaData(vtkDICOMMetaData *)\n\nSet the metadata object for storing the data elements.\n"},
  {"GetMetaData", PyvtkDICOMParser_GetMetaData, METH_VARARGS,
   "GetMetaData(self) -> vtkDICOMMetaData\nC++: vtkDICOMMetaData *GetMetaData()\n\nSet the metadata object for storing the data elements.\n"},
  {"SetIndex", PyvtkDICOMParser_SetIndex, METH_VARARGS,
   "SetIndex(self, _arg:int) -> None\nC++: virtual void SetIndex(int _arg)\n\nSet the instance index to use when storing metadata.\n"},
  {"GetIndex", PyvtkDICOMParser_GetIndex, METH_VARARGS,
   "GetIndex(self) -> int\nC++: int GetIndex()\n\nSet the instance index to use when storing metadata.\n"},
  {"SetDefaultCharacterSet", PyvtkDICOMParser_SetDefaultCharacterSet, METH_VARARGS,
   "SetDefaultCharacterSet(self, cs:vtkDICOMCharacterSet) -> None\nC++: void SetDefaultCharacterSet(vtkDICOMCharacterSet cs)\n\nSet the character set to use if SpecificCharacterSet is missing.\n\nSome DICOM files do not list a SpecificCharacterSet attribute,\nbut nevertheless use a non-ASCII character encoding.  This method\ncan be used to specify the character set in absence of\nSpecificCharacterSet. If SpecificCharacterSet is present, the\ndefault will not override it unless OverrideCharacterSet is true.\n"},
  {"GetDefaultCharacterSet", PyvtkDICOMParser_GetDefaultCharacterSet, METH_VARARGS,
   "GetDefaultCharacterSet(self) -> vtkDICOMCharacterSet\nC++: vtkDICOMCharacterSet GetDefaultCharacterSet()\n\nSet the character set to use if SpecificCharacterSet is missing.\n\nSome DICOM files do not list a SpecificCharacterSet attribute,\nbut nevertheless use a non-ASCII character encoding.  This method\ncan be used to specify the character set in absence of\nSpecificCharacterSet. If SpecificCharacterSet is present, the\ndefault will not override it unless OverrideCharacterSet is true.\n"},
  {"SetOverrideCharacterSet", PyvtkDICOMParser_SetOverrideCharacterSet, METH_VARARGS,
   "SetOverrideCharacterSet(self, b:bool) -> None\nC++: void SetOverrideCharacterSet(bool b)\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"OverrideCharacterSetOn", PyvtkDICOMParser_OverrideCharacterSetOn, METH_VARARGS,
   "OverrideCharacterSetOn(self) -> None\nC++: void OverrideCharacterSetOn()\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"OverrideCharacterSetOff", PyvtkDICOMParser_OverrideCharacterSetOff, METH_VARARGS,
   "OverrideCharacterSetOff(self) -> None\nC++: void OverrideCharacterSetOff()\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"GetOverrideCharacterSet", PyvtkDICOMParser_GetOverrideCharacterSet, METH_VARARGS,
   "GetOverrideCharacterSet(self) -> bool\nC++: bool GetOverrideCharacterSet()\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"SetQuery", PyvtkDICOMParser_SetQuery, METH_VARARGS,
   "SetQuery(self, query:vtkDICOMMetaData) -> None\nC++: void SetQuery(vtkDICOMMetaData *query)\n\nSet a query. Only matching data will be retrieved.\n\nThis can be used to scan a file for data that matches a given\nquery.  For more information on how matching is done, see the\nvtkDICOMValue::Matches() method.\n"},
  {"GetQuery", PyvtkDICOMParser_GetQuery, METH_VARARGS,
   "GetQuery(self) -> vtkDICOMMetaData\nC++: vtkDICOMMetaData *GetQuery()\n\nSet a query. Only matching data will be retrieved.\n\nThis can be used to scan a file for data that matches a given\nquery.  For more information on how matching is done, see the\nvtkDICOMValue::Matches() method.\n"},
  {"SetQueryItem", PyvtkDICOMParser_SetQueryItem, METH_VARARGS,
   "SetQueryItem(self, query:vtkDICOMItem) -> None\nC++: void SetQueryItem(const vtkDICOMItem &query)\n\nSet a query, using an item instead of vtkDICOMMetaData.\n\nThis can be used to scan a file for data that matches a given\nquery.  For more information on how matching is done, see the\nvtkDICOMValue::Matches() method.  To clear the query, pass an\nempty item.\n"},
  {"SetGroups", PyvtkDICOMParser_SetGroups, METH_VARARGS,
   "SetGroups(self, groups:vtkUnsignedShortArray) -> None\nC++: void SetGroups(vtkUnsignedShortArray *groups)\n\nSet specific metadata groups to read (obsolete).\n\nThis method is obsolete, the SetQuery() method should be used\ninstead.\n"},
  {"GetGroups", PyvtkDICOMParser_GetGroups, METH_VARARGS,
   "GetGroups(self) -> vtkUnsignedShortArray\nC++: vtkUnsignedShortArray *GetGroups()\n\nSet specific metadata groups to read (obsolete).\n\nThis method is obsolete, the SetQuery() method should be used\ninstead.\n"},
  {"GetQueryMatched", PyvtkDICOMParser_GetQueryMatched, METH_VARARGS,
   "GetQueryMatched(self) -> bool\nC++: bool GetQueryMatched()\n\nThis is true only if the file matched the query.\n"},
  {"GetPixelDataFound", PyvtkDICOMParser_GetPixelDataFound, METH_VARARGS,
   "GetPixelDataFound(self) -> bool\nC++: bool GetPixelDataFound()\n\nThis is true only if PixelData was found in the file.\n"},
  {"GetPixelDataVL", PyvtkDICOMParser_GetPixelDataVL, METH_VARARGS,
   "GetPixelDataVL(self) -> int\nC++: unsigned int GetPixelDataVL()\n\nGet the VL for the PixelData, will be 0xffffffff if compressed.\n"},
  {"GetFileOffset", PyvtkDICOMParser_GetFileOffset, METH_VARARGS,
   "GetFileOffset(self) -> int\nC++: vtkTypeInt64 GetFileOffset()\n\nGet the byte offset to the end of the metadata.\n\nAfter the metadata has been read, the file offset will be set to\nthe position of the pixel data.\n"},
  {"GetFileSize", PyvtkDICOMParser_GetFileSize, METH_VARARGS,
   "GetFileSize(self) -> int\nC++: vtkTypeInt64 GetFileSize()\n\nGet the total file length (only valid after Update).\n"},
  {"SetBufferSize", PyvtkDICOMParser_SetBufferSize, METH_VARARGS,
   "SetBufferSize(self, size:int) -> None\nC++: void SetBufferSize(int size)\n\nSet the buffer size, the default is 8192 (8k).\n\nA larger buffer size results in fewer IO calls.  The minimum\nbuffer size is 256 bytes.\n"},
  {"GetBufferSize", PyvtkDICOMParser_GetBufferSize, METH_VARARGS,
   "GetBufferSize(self) -> int\nC++: int GetBufferSize()\n\nSet the buffer size, the default is 8192 (8k).\n\nA larger buffer size results in fewer IO calls.  The minimum\nbuffer size is 256 bytes.\n"},
  {"Update", PyvtkDICOMParser_Update, METH_VARARGS,
   "Update(self) -> None\nC++: virtual void Update()\n\nRead the metadata from the file.\n"},
  {"GetErrorCode", PyvtkDICOMParser_GetErrorCode, METH_VARARGS,
   "GetErrorCode(self) -> int\nC++: unsigned long GetErrorCode()\n\nGet the error code.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMParser_Doc =
  "vtkDICOMParser - A meta data reader for DICOM data.\n\n"
  "Superclass: vtkObject\n\n"
  "This class provides routines for parsing a DICOM file and creating a\n"
  "vtkDICOMMetaData object.  It stops parsing the file as soon as it\n"
  "finds the PixelData, and the byte offset of the PixelData within the\n"
  "file can be retrieved with GetFileOffset().\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMParser_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMParser", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMParser_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMParser_StaticNew()
{
  return vtkDICOMParser::New();
}

PyObject *PyvtkDICOMParser_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMParser_Type, PyvtkDICOMParser_Methods,
    "vtkDICOMParser",
 &PyvtkDICOMParser_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMParser(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMParser_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMParser", o) != 0)
  {
    Py_DECREF(o);
  }

}

