// python wrapper for vtkDICOMReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMCharacterSet.h"
#include "vtkDICOMReader.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMReader(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMReader_ClassNew(); }

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMReader_RowOrder_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMReader.RowOrder", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMReader_RowOrder_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMReader_RowOrder_Type, static_cast<int>(val));
}


static PyObject *
PyvtkDICOMReader_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMReader::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMReader *tempr = vtkDICOMReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMReader::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMReader::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetFileExtensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileExtensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFileExtensions() :
      op->vtkDICOMReader::GetFileExtensions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetDescriptiveName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDescriptiveName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDescriptiveName() :
      op->vtkDICOMReader::GetDescriptiveName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_CanReadFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CanReadFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetFilePath(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->CanReadFile(temp0) :
      op->vtkDICOMReader::CanReadFile(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetDesiredStackID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDesiredStackID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDesiredStackID(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetDesiredStackID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetDesiredStackID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDesiredStackID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDesiredStackID() :
      op->vtkDICOMReader::GetDesiredStackID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetStackIDs(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStackIDs");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetStackIDs() :
      op->vtkDICOMReader::GetStackIDs());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetFileIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetFileIndexArray() :
      op->vtkDICOMReader::GetFileIndexArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetFrameIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFrameIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetFrameIndexArray() :
      op->vtkDICOMReader::GetFrameIndexArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMMetaData *tempr = (ap.IsBound() ?
      op->GetMetaData() :
      op->vtkDICOMReader::GetMetaData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetDefaultCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDefaultCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  vtkDICOMCharacterSet *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMCharacterSet"))
  {
    if (ap.IsBound())
    {
      op->SetDefaultCharacterSet(*temp0);
    }
    else
    {
      op->vtkDICOMReader::SetDefaultCharacterSet(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMReader_GetDefaultCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMCharacterSet tempr = (ap.IsBound() ?
      op->GetDefaultCharacterSet() :
      op->vtkDICOMReader::GetDefaultCharacterSet());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMCharacterSet");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetOverrideCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverrideCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOverrideCharacterSet(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetOverrideCharacterSet(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_OverrideCharacterSetOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OverrideCharacterSetOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OverrideCharacterSetOn();
    }
    else
    {
      op->vtkDICOMReader::OverrideCharacterSetOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_OverrideCharacterSetOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OverrideCharacterSetOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OverrideCharacterSetOff();
    }
    else
    {
      op->vtkDICOMReader::OverrideCharacterSetOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetOverrideCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverrideCharacterSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetOverrideCharacterSet() :
      op->vtkDICOMReader::GetOverrideCharacterSet());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetSorting(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSorting");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSorting() :
      op->vtkDICOMReader::GetSorting());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetSorting(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSorting");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSorting(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetSorting(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SortingOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SortingOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SortingOn();
    }
    else
    {
      op->vtkDICOMReader::SortingOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SortingOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SortingOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SortingOff();
    }
    else
    {
      op->vtkDICOMReader::SortingOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetSorter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSorter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  vtkDICOMSliceSorter *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMSliceSorter"))
  {
    if (ap.IsBound())
    {
      op->SetSorter(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetSorter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetSorter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSorter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMSliceSorter *tempr = (ap.IsBound() ?
      op->GetSorter() :
      op->vtkDICOMReader::GetSorter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetTimeAsVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeAsVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeAsVector() :
      op->vtkDICOMReader::GetTimeAsVector());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetTimeAsVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeAsVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeAsVector(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetTimeAsVector(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_TimeAsVectorOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TimeAsVectorOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->TimeAsVectorOn();
    }
    else
    {
      op->vtkDICOMReader::TimeAsVectorOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_TimeAsVectorOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TimeAsVectorOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->TimeAsVectorOff();
    }
    else
    {
      op->vtkDICOMReader::TimeAsVectorOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetTimeDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeDimension() :
      op->vtkDICOMReader::GetTimeDimension());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetTimeSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeSpacing() :
      op->vtkDICOMReader::GetTimeSpacing());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetDesiredTimeIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDesiredTimeIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDesiredTimeIndex(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetDesiredTimeIndex(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetDesiredTimeIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDesiredTimeIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetDesiredTimeIndex() :
      op->vtkDICOMReader::GetDesiredTimeIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetAutoYBRToRGB(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoYBRToRGB");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAutoYBRToRGB() :
      op->vtkDICOMReader::GetAutoYBRToRGB());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetAutoYBRToRGB(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoYBRToRGB");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoYBRToRGB(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetAutoYBRToRGB(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_AutoYBRToRGBOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutoYBRToRGBOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutoYBRToRGBOn();
    }
    else
    {
      op->vtkDICOMReader::AutoYBRToRGBOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_AutoYBRToRGBOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutoYBRToRGBOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutoYBRToRGBOff();
    }
    else
    {
      op->vtkDICOMReader::AutoYBRToRGBOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetAutoRescale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoRescale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAutoRescale() :
      op->vtkDICOMReader::GetAutoRescale());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetAutoRescale(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoRescale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoRescale(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetAutoRescale(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_AutoRescaleOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutoRescaleOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutoRescaleOn();
    }
    else
    {
      op->vtkDICOMReader::AutoRescaleOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_AutoRescaleOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutoRescaleOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutoRescaleOff();
    }
    else
    {
      op->vtkDICOMReader::AutoRescaleOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetRescaleSlope(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleSlope");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRescaleSlope() :
      op->vtkDICOMReader::GetRescaleSlope());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetRescaleIntercept(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleIntercept");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRescaleIntercept() :
      op->vtkDICOMReader::GetRescaleIntercept());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetPatientMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPatientMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetPatientMatrix() :
      op->vtkDICOMReader::GetPatientMatrix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetOverlayOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlayOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetOverlayOutput() :
      op->vtkDICOMReader::GetOverlayOutput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetOverlayOutputPort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlayOutputPort");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkAlgorithmOutput *tempr = (ap.IsBound() ?
      op->GetOverlayOutputPort() :
      op->vtkDICOMReader::GetOverlayOutputPort());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetOverlayOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverlayOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  vtkImageData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetOverlayOutput(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetOverlayOutput(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_HasOverlay(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasOverlay");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasOverlay() :
      op->vtkDICOMReader::HasOverlay());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetOverlayBitfield(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlayBitfield");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned short tempr = (ap.IsBound() ?
      op->GetOverlayBitfield() :
      op->vtkDICOMReader::GetOverlayBitfield());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetMedicalImageProperties(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMedicalImageProperties");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMedicalImageProperties *tempr = (ap.IsBound() ?
      op->GetMedicalImageProperties() :
      op->vtkDICOMReader::GetMedicalImageProperties());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetMemoryRowOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMemoryRowOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMemoryRowOrder(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetMemoryRowOrder(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetMemoryRowOrderToFileNative(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMemoryRowOrderToFileNative");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetMemoryRowOrderToFileNative();
    }
    else
    {
      op->vtkDICOMReader::SetMemoryRowOrderToFileNative();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetMemoryRowOrderToTopDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMemoryRowOrderToTopDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetMemoryRowOrderToTopDown();
    }
    else
    {
      op->vtkDICOMReader::SetMemoryRowOrderToTopDown();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetMemoryRowOrderToBottomUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMemoryRowOrderToBottomUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetMemoryRowOrderToBottomUp();
    }
    else
    {
      op->vtkDICOMReader::SetMemoryRowOrderToBottomUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetMemoryRowOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMemoryRowOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMemoryRowOrder() :
      op->vtkDICOMReader::GetMemoryRowOrder());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetMemoryRowOrderAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMemoryRowOrderAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetMemoryRowOrderAsString() :
      op->vtkDICOMReader::GetMemoryRowOrderAsString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_SetOutputScalarType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputScalarType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOutputScalarType(temp0);
    }
    else
    {
      op->vtkDICOMReader::SetOutputScalarType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMReader_GetOutputScalarType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputScalarType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMReader *op = static_cast<vtkDICOMReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOutputScalarType() :
      op->vtkDICOMReader::GetOutputScalarType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMReader_Methods[] = {
  {"IsTypeOf", PyvtkDICOMReader_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMReader_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMReader_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMReader\nC++: static vtkDICOMReader *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMReader_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMReader\nC++: vtkDICOMReader *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMReader_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMReader_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetFileExtensions", PyvtkDICOMReader_GetFileExtensions, METH_VARARGS,
   "GetFileExtensions(self) -> str\nC++: const char *GetFileExtensions() override;\n\nValid extensions for this file type.\n"},
  {"GetDescriptiveName", PyvtkDICOMReader_GetDescriptiveName, METH_VARARGS,
   "GetDescriptiveName(self) -> str\nC++: const char *GetDescriptiveName() override;\n\nReturn a descriptive name that might be useful in a GUI.\n"},
  {"CanReadFile", PyvtkDICOMReader_CanReadFile, METH_VARARGS,
   "CanReadFile(self, filename:str) -> int\nC++: int CanReadFile(const char *filename) override;\n\nReturn true if this reader can read the given file.\n"},
  {"SetDesiredStackID", PyvtkDICOMReader_SetDesiredStackID, METH_VARARGS,
   "SetDesiredStackID(self, stackId:str) -> None\nC++: void SetDesiredStackID(const char *stackId)\n\nSet the Stack ID of the stack to load, for named stacks.\n\nIf the series has multiple stacks, then by default the reader\nwill only load the first stack.  This method allows you to select\na different stack, if you know the DICOM StackID for the stack.\n"},
  {"GetDesiredStackID", PyvtkDICOMReader_GetDesiredStackID, METH_VARARGS,
   "GetDesiredStackID(self) -> str\nC++: const char *GetDesiredStackID()\n\nSet the Stack ID of the stack to load, for named stacks.\n\nIf the series has multiple stacks, then by default the reader\nwill only load the first stack.  This method allows you to select\na different stack, if you know the DICOM StackID for the stack.\n"},
  {"GetStackIDs", PyvtkDICOMReader_GetStackIDs, METH_VARARGS,
   "GetStackIDs(self) -> vtkStringArray\nC++: vtkStringArray *GetStackIDs()\n\nGet a list of the stacks that are present in the input files.\n\nA stack is a contiguous array of slices that form a volume.\n"},
  {"GetFileIndexArray", PyvtkDICOMReader_GetFileIndexArray, METH_VARARGS,
   "GetFileIndexArray(self) -> vtkIntArray\nC++: vtkIntArray *GetFileIndexArray()\n\nGet an array that converts slice index to input file index.\n\nIf the reader has generated scalar components, then this will be\na two-dimensional array and calling array->GetComponent(i,j) will\nreturn the file index for slice i and scalar component j for\nmonochrome images, or for slice i and scalar component 3*j for\nRGB images (or more precisely, at scalar component N*j where N is\nthe SamplesPerPixel value from the DICOM metadata).  If the data\nhas just one component, then use j=0. If you used SetFileNames()\nto provide a list of files to the reader, then use this array to\nfind out which file provided which slice, or to index into the\nMetaData object to get the metadata for a particular slice.\n"},
  {"GetFrameIndexArray", PyvtkDICOMReader_GetFrameIndexArray, METH_VARARGS,
   "GetFrameIndexArray(self) -> vtkIntArray\nC++: vtkIntArray *GetFrameIndexArray()\n\nGet an array that converts slice index to frame index.\n\nThe purpose of this array is to identify individual frames in\nmulti-frame DICOM files.  The dimensions of this array are\nidentical to the FileIndexArray.  Use FileIndexArray to identify\nthe file, then use FrameIndexArray to identify the frame within\nthat file.\n"},
  {"GetMetaData", PyvtkDICOMReader_GetMetaData, METH_VARARGS,
   "GetMetaData(self) -> vtkDICOMMetaData\nC++: vtkDICOMMetaData *GetMetaData()\n\nGet the meta data for the DICOM files.\n\nThe Get() method of vtkDICOMMataData takes optional file and\nframe indices, which specify the file and the frame within that\nfile to get the attribute from.  If you have a slice index rather\nthan a file index and frame index, then use the FileIndexArray\nand FrameIndexArray to convert the slice index into file and\nframe indices.\n"},
  {"SetDefaultCharacterSet", PyvtkDICOMReader_SetDefaultCharacterSet, METH_VARARGS,
   "SetDefaultCharacterSet(self, cs:vtkDICOMCharacterSet) -> None\nC++: void SetDefaultCharacterSet(vtkDICOMCharacterSet cs)\n\nSet the character set to use if SpecificCharacterSet is missing.\n\nSome DICOM files do not list a SpecificCharacterSet attribute,\nbut nevertheless use a non-ASCII character encoding.  This method\ncan be used to specify the character set in absence of\nSpecificCharacterSet. This method will not take effect unless is\nis called before the image is read.  If SpecificCharacterSet is\npresent, the default will not override it unless\nOverrideCharacterSet is true.\n"},
  {"GetDefaultCharacterSet", PyvtkDICOMReader_GetDefaultCharacterSet, METH_VARARGS,
   "GetDefaultCharacterSet(self) -> vtkDICOMCharacterSet\nC++: vtkDICOMCharacterSet GetDefaultCharacterSet()\n\nSet the character set to use if SpecificCharacterSet is missing.\n\nSome DICOM files do not list a SpecificCharacterSet attribute,\nbut nevertheless use a non-ASCII character encoding.  This method\ncan be used to specify the character set in absence of\nSpecificCharacterSet. This method will not take effect unless is\nis called before the image is read.  If SpecificCharacterSet is\npresent, the default will not override it unless\nOverrideCharacterSet is true.\n"},
  {"SetOverrideCharacterSet", PyvtkDICOMReader_SetOverrideCharacterSet, METH_VARARGS,
   "SetOverrideCharacterSet(self, _arg:bool) -> None\nC++: virtual void SetOverrideCharacterSet(bool _arg)\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"OverrideCharacterSetOn", PyvtkDICOMReader_OverrideCharacterSetOn, METH_VARARGS,
   "OverrideCharacterSetOn(self) -> None\nC++: virtual void OverrideCharacterSetOn()\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"OverrideCharacterSetOff", PyvtkDICOMReader_OverrideCharacterSetOff, METH_VARARGS,
   "OverrideCharacterSetOff(self) -> None\nC++: virtual void OverrideCharacterSetOff()\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"GetOverrideCharacterSet", PyvtkDICOMReader_GetOverrideCharacterSet, METH_VARARGS,
   "GetOverrideCharacterSet(self) -> bool\nC++: bool GetOverrideCharacterSet()\n\nOverride the value stored in SpecificCharacterSet.\n\nThis method can be used if the SpecificCharacterSet attribute of\na file is incorrect.  It overrides the SpecificCharacterSet with\nthe DefaultCharacterSet.\n"},
  {"GetSorting", PyvtkDICOMReader_GetSorting, METH_VARARGS,
   "GetSorting(self) -> int\nC++: virtual int GetSorting()\n\nIf the files have been pre-sorted, the sorting can be disabled.\n"},
  {"SetSorting", PyvtkDICOMReader_SetSorting, METH_VARARGS,
   "SetSorting(self, _arg:int) -> None\nC++: virtual void SetSorting(int _arg)\n\nIf the files have been pre-sorted, the sorting can be disabled.\n"},
  {"SortingOn", PyvtkDICOMReader_SortingOn, METH_VARARGS,
   "SortingOn(self) -> None\nC++: virtual void SortingOn()\n\nIf the files have been pre-sorted, the sorting can be disabled.\n"},
  {"SortingOff", PyvtkDICOMReader_SortingOff, METH_VARARGS,
   "SortingOff(self) -> None\nC++: virtual void SortingOff()\n\nIf the files have been pre-sorted, the sorting can be disabled.\n"},
  {"SetSorter", PyvtkDICOMReader_SetSorter, METH_VARARGS,
   "SetSorter(self, sorter:vtkDICOMSliceSorter) -> None\nC++: void SetSorter(vtkDICOMSliceSorter *sorter)\n\nSet a custom sorter to be used to sort files and frames into\nslices.\n\nThe default sorter uses the attributes \"ImagePositionPatient\" and\n\"ImageOrientationPatient\" to spatially arrange the slices.\n"},
  {"GetSorter", PyvtkDICOMReader_GetSorter, METH_VARARGS,
   "GetSorter(self) -> vtkDICOMSliceSorter\nC++: vtkDICOMSliceSorter *GetSorter()\n\nSet a custom sorter to be used to sort files and frames into\nslices.\n\nThe default sorter uses the attributes \"ImagePositionPatient\" and\n\"ImageOrientationPatient\" to spatially arrange the slices.\n"},
  {"GetTimeAsVector", PyvtkDICOMReader_GetTimeAsVector, METH_VARARGS,
   "GetTimeAsVector(self) -> int\nC++: virtual int GetTimeAsVector()\n\nRead the time dimension as scalar components (default: Off).\n\nIf this is on, then each time point will be stored as a scalar\ncomponent in the image data.  If the data has both a time\ndimension and a vector dimension, then the number of components\nwill be the product of these two dimensions, i.e. the components\nwill store a sequence of vectors, one vector for each time point.\n"},
  {"SetTimeAsVector", PyvtkDICOMReader_SetTimeAsVector, METH_VARARGS,
   "SetTimeAsVector(self, _arg:int) -> None\nC++: virtual void SetTimeAsVector(int _arg)\n\nRead the time dimension as scalar components (default: Off).\n\nIf this is on, then each time point will be stored as a scalar\ncomponent in the image data.  If the data has both a time\ndimension and a vector dimension, then the number of components\nwill be the product of these two dimensions, i.e. the components\nwill store a sequence of vectors, one vector for each time point.\n"},
  {"TimeAsVectorOn", PyvtkDICOMReader_TimeAsVectorOn, METH_VARARGS,
   "TimeAsVectorOn(self) -> None\nC++: virtual void TimeAsVectorOn()\n\nRead the time dimension as scalar components (default: Off).\n\nIf this is on, then each time point will be stored as a scalar\ncomponent in the image data.  If the data has both a time\ndimension and a vector dimension, then the number of components\nwill be the product of these two dimensions, i.e. the components\nwill store a sequence of vectors, one vector for each time point.\n"},
  {"TimeAsVectorOff", PyvtkDICOMReader_TimeAsVectorOff, METH_VARARGS,
   "TimeAsVectorOff(self) -> None\nC++: virtual void TimeAsVectorOff()\n\nRead the time dimension as scalar components (default: Off).\n\nIf this is on, then each time point will be stored as a scalar\ncomponent in the image data.  If the data has both a time\ndimension and a vector dimension, then the number of components\nwill be the product of these two dimensions, i.e. the components\nwill store a sequence of vectors, one vector for each time point.\n"},
  {"GetTimeDimension", PyvtkDICOMReader_GetTimeDimension, METH_VARARGS,
   "GetTimeDimension(self) -> int\nC++: int GetTimeDimension()\n\nGet the time dimension if the DICOM series has one.\n"},
  {"GetTimeSpacing", PyvtkDICOMReader_GetTimeSpacing, METH_VARARGS,
   "GetTimeSpacing(self) -> float\nC++: double GetTimeSpacing()\n\nGet the time dimension if the DICOM series has one.\n"},
  {"SetDesiredTimeIndex", PyvtkDICOMReader_SetDesiredTimeIndex, METH_VARARGS,
   "SetDesiredTimeIndex(self, _arg:int) -> None\nC++: virtual void SetDesiredTimeIndex(int _arg)\n\nSet the desired time index (set to -1 for all).\n"},
  {"GetDesiredTimeIndex", PyvtkDICOMReader_GetDesiredTimeIndex, METH_VARARGS,
   "GetDesiredTimeIndex(self) -> int\nC++: virtual int GetDesiredTimeIndex()\n\nSet the desired time index (set to -1 for all).\n"},
  {"GetAutoYBRToRGB", PyvtkDICOMReader_GetAutoYBRToRGB, METH_VARARGS,
   "GetAutoYBRToRGB(self) -> int\nC++: virtual int GetAutoYBRToRGB()\n\nTurn off automatic conversion of YBR images to RGB.\n\nBy default, YBR images are always converted to RGB (though the\nphotometric interpretation in the metadata will remain the same).\n"},
  {"SetAutoYBRToRGB", PyvtkDICOMReader_SetAutoYBRToRGB, METH_VARARGS,
   "SetAutoYBRToRGB(self, _arg:int) -> None\nC++: virtual void SetAutoYBRToRGB(int _arg)\n\nTurn off automatic conversion of YBR images to RGB.\n\nBy default, YBR images are always converted to RGB (though the\nphotometric interpretation in the metadata will remain the same).\n"},
  {"AutoYBRToRGBOn", PyvtkDICOMReader_AutoYBRToRGBOn, METH_VARARGS,
   "AutoYBRToRGBOn(self) -> None\nC++: virtual void AutoYBRToRGBOn()\n\nTurn off automatic conversion of YBR images to RGB.\n\nBy default, YBR images are always converted to RGB (though the\nphotometric interpretation in the metadata will remain the same).\n"},
  {"AutoYBRToRGBOff", PyvtkDICOMReader_AutoYBRToRGBOff, METH_VARARGS,
   "AutoYBRToRGBOff(self) -> None\nC++: virtual void AutoYBRToRGBOff()\n\nTurn off automatic conversion of YBR images to RGB.\n\nBy default, YBR images are always converted to RGB (though the\nphotometric interpretation in the metadata will remain the same).\n"},
  {"GetAutoRescale", PyvtkDICOMReader_GetAutoRescale, METH_VARARGS,
   "GetAutoRescale(self) -> int\nC++: virtual int GetAutoRescale()\n\nTurn off automatic rescaling of stored pixel values.\n\nBy default, if the RescaleSlope and RescaleIntercept attributes\nare present in the DICOM data set, they will be used to rescale\nstored pixel values according to the DICOM modality LUT\noperation. The resulting values will be stored as 16-bit integers\nif possible, but single-precision floats will be used if the\npotential output range is greater than can be stored in 16 bits,\nor if either the RescaleSlope or the RescaleIntercept is not an\ninteger. If AutoRescale is off, then the data is not rescaled.\n"},
  {"SetAutoRescale", PyvtkDICOMReader_SetAutoRescale, METH_VARARGS,
   "SetAutoRescale(self, _arg:int) -> None\nC++: virtual void SetAutoRescale(int _arg)\n\nTurn off automatic rescaling of stored pixel values.\n\nBy default, if the RescaleSlope and RescaleIntercept attributes\nare present in the DICOM data set, they will be used to rescale\nstored pixel values according to the DICOM modality LUT\noperation. The resulting values will be stored as 16-bit integers\nif possible, but single-precision floats will be used if the\npotential output range is greater than can be stored in 16 bits,\nor if either the RescaleSlope or the RescaleIntercept is not an\ninteger. If AutoRescale is off, then the data is not rescaled.\n"},
  {"AutoRescaleOn", PyvtkDICOMReader_AutoRescaleOn, METH_VARARGS,
   "AutoRescaleOn(self) -> None\nC++: virtual void AutoRescaleOn()\n\nTurn off automatic rescaling of stored pixel values.\n\nBy default, if the RescaleSlope and RescaleIntercept attributes\nare present in the DICOM data set, they will be used to rescale\nstored pixel values according to the DICOM modality LUT\noperation. The resulting values will be stored as 16-bit integers\nif possible, but single-precision floats will be used if the\npotential output range is greater than can be stored in 16 bits,\nor if either the RescaleSlope or the RescaleIntercept is not an\ninteger. If AutoRescale is off, then the data is not rescaled.\n"},
  {"AutoRescaleOff", PyvtkDICOMReader_AutoRescaleOff, METH_VARARGS,
   "AutoRescaleOff(self) -> None\nC++: virtual void AutoRescaleOff()\n\nTurn off automatic rescaling of stored pixel values.\n\nBy default, if the RescaleSlope and RescaleIntercept attributes\nare present in the DICOM data set, they will be used to rescale\nstored pixel values according to the DICOM modality LUT\noperation. The resulting values will be stored as 16-bit integers\nif possible, but single-precision floats will be used if the\npotential output range is greater than can be stored in 16 bits,\nor if either the RescaleSlope or the RescaleIntercept is not an\ninteger. If AutoRescale is off, then the data is not rescaled.\n"},
  {"GetRescaleSlope", PyvtkDICOMReader_GetRescaleSlope, METH_VARARGS,
   "GetRescaleSlope(self) -> float\nC++: double GetRescaleSlope()\n\nGet the slope and intercept for rescaling the scalar values.\n\nIf AutoRescale in On (which is the default), then\nGetRescaleSlope() will return 1 and GetRescaleIntercept() will\nreturn zero.  Otherwise, they will return the RescaleSlope and\nRescaleIntercept for the data set. Use the equation v =\nu*RescaleSlope + RescaleIntercept.\n\n\n Note that the returned values might not be valid if these\nattributes\n are not the same for all slices in the series.  Use the meta\ndata to\n retrieve the per-slice slope and intercept.\n"},
  {"GetRescaleIntercept", PyvtkDICOMReader_GetRescaleIntercept, METH_VARARGS,
   "GetRescaleIntercept(self) -> float\nC++: double GetRescaleIntercept()\n\nGet the slope and intercept for rescaling the scalar values.\n\nIf AutoRescale in On (which is the default), then\nGetRescaleSlope() will return 1 and GetRescaleIntercept() will\nreturn zero.  Otherwise, they will return the RescaleSlope and\nRescaleIntercept for the data set. Use the equation v =\nu*RescaleSlope + RescaleIntercept.\n\n\n Note that the returned values might not be valid if these\nattributes\n are not the same for all slices in the series.  Use the meta\ndata to\n retrieve the per-slice slope and intercept.\n"},
  {"GetPatientMatrix", PyvtkDICOMReader_GetPatientMatrix, METH_VARARGS,
   "GetPatientMatrix(self) -> vtkMatrix4x4\nC++: vtkMatrix4x4 *GetPatientMatrix()\n\nGet a matrix to place the image within DICOM patient coords.\n\nThis matrix is constructed from the ImageOrientationPatient and\nImagePositionPatient meta data attributes.  See the\nSetMemoryRowOrder method for additional information.\n"},
  {"GetOverlayOutput", PyvtkDICOMReader_GetOverlayOutput, METH_VARARGS,
   "GetOverlayOutput(self) -> vtkImageData\nC++: vtkImageData *GetOverlayOutput()\n\nGet the overlay.\n\nThe extent of the overlay will be the same as the main image. For\nmultiple overlays, each overlay will be stored in a different\nbit. An 8-bit image will be used if there are eight or fewer\noverlays, and an unsigned 16-bit image will be used if there are\nmore than eight overlays.\n"},
  {"GetOverlayOutputPort", PyvtkDICOMReader_GetOverlayOutputPort, METH_VARARGS,
   "GetOverlayOutputPort(self) -> vtkAlgorithmOutput\nC++: vtkAlgorithmOutput *GetOverlayOutputPort()\n\nGet the overlay.\n\nThe extent of the overlay will be the same as the main image. For\nmultiple overlays, each overlay will be stored in a different\nbit. An 8-bit image will be used if there are eight or fewer\noverlays, and an unsigned 16-bit image will be used if there are\nmore than eight overlays.\n"},
  {"SetOverlayOutput", PyvtkDICOMReader_SetOverlayOutput, METH_VARARGS,
   "SetOverlayOutput(self, data:vtkImageData) -> None\nC++: void SetOverlayOutput(vtkImageData *data)\n\nGet the overlay.\n\nThe extent of the overlay will be the same as the main image. For\nmultiple overlays, each overlay will be stored in a different\nbit. An 8-bit image will be used if there are eight or fewer\noverlays, and an unsigned 16-bit image will be used if there are\nmore than eight overlays.\n"},
  {"HasOverlay", PyvtkDICOMReader_HasOverlay, METH_VARARGS,
   "HasOverlay(self) -> bool\nC++: bool HasOverlay()\n\nReturns true if any overlays are present.\n"},
  {"GetOverlayBitfield", PyvtkDICOMReader_GetOverlayBitfield, METH_VARARGS,
   "GetOverlayBitfield(self) -> int\nC++: unsigned short GetOverlayBitfield()\n\nReturns a bitfield that indicates which overlays are present.\n"},
  {"GetMedicalImageProperties", PyvtkDICOMReader_GetMedicalImageProperties, METH_VARARGS,
   "GetMedicalImageProperties(self) -> vtkMedicalImageProperties\nC++: vtkMedicalImageProperties *GetMedicalImageProperties()\n\nGet a MedicalImageProperties object for this file.\n"},
  {"SetMemoryRowOrder", PyvtkDICOMReader_SetMemoryRowOrder, METH_VARARGS,
   "SetMemoryRowOrder(self, order:int) -> None\nC++: void SetMemoryRowOrder(int order)\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"SetMemoryRowOrderToFileNative", PyvtkDICOMReader_SetMemoryRowOrderToFileNative, METH_VARARGS,
   "SetMemoryRowOrderToFileNative(self) -> None\nC++: void SetMemoryRowOrderToFileNative()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"SetMemoryRowOrderToTopDown", PyvtkDICOMReader_SetMemoryRowOrderToTopDown, METH_VARARGS,
   "SetMemoryRowOrderToTopDown(self) -> None\nC++: void SetMemoryRowOrderToTopDown()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"SetMemoryRowOrderToBottomUp", PyvtkDICOMReader_SetMemoryRowOrderToBottomUp, METH_VARARGS,
   "SetMemoryRowOrderToBottomUp(self) -> None\nC++: void SetMemoryRowOrderToBottomUp()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"GetMemoryRowOrder", PyvtkDICOMReader_GetMemoryRowOrder, METH_VARARGS,
   "GetMemoryRowOrder(self) -> int\nC++: int GetMemoryRowOrder()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"GetMemoryRowOrderAsString", PyvtkDICOMReader_GetMemoryRowOrderAsString, METH_VARARGS,
   "GetMemoryRowOrderAsString(self) -> str\nC++: const char *GetMemoryRowOrderAsString()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"SetOutputScalarType", PyvtkDICOMReader_SetOutputScalarType, METH_VARARGS,
   "SetOutputScalarType(self, _arg:int) -> None\nC++: virtual void SetOutputScalarType(int _arg)\n\nSet the scalar type of the output.\n\nThe default value is -1, which means that the input scalar type\nwill be used to set the output scalar type (accounting for any\ntype changes required by AutoRescale).  Allowed output scalar\ntypes are VTK_SIGNED_CHAR, VTK_UNSIGNED_CHAR, VTK_SHORT,\nVTK_UNSIGNED_SHORT, VTK_INT, VTK_UNSIGNED_INT, VTK_FLOAT, or\nVTK_DOUBLE.  The output data values will be clamped to the limits\nof the output type.\n"},
  {"GetOutputScalarType", PyvtkDICOMReader_GetOutputScalarType, METH_VARARGS,
   "GetOutputScalarType(self) -> int\nC++: virtual int GetOutputScalarType()\n\nSet the scalar type of the output.\n\nThe default value is -1, which means that the input scalar type\nwill be used to set the output scalar type (accounting for any\ntype changes required by AutoRescale).  Allowed output scalar\ntypes are VTK_SIGNED_CHAR, VTK_UNSIGNED_CHAR, VTK_SHORT,\nVTK_UNSIGNED_SHORT, VTK_INT, VTK_UNSIGNED_INT, VTK_FLOAT, or\nVTK_DOUBLE.  The output data values will be clamped to the limits\nof the output type.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMReader_Doc =
  "vtkDICOMReader - Read DICOM image files.\n\n"
  "Superclass: vtkImageReader2\n\n"
  "This class reads a series of DICOM files into a vtkImageData object,\n"
  "and also provides access to the DICOM meta data for each file.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMReader_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMReader_StaticNew()
{
  return vtkDICOMReader::New();
}

PyObject *PyvtkDICOMReader_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMReader_Type, PyvtkDICOMReader_Methods,
    "vtkDICOMReader",
 &PyvtkDICOMReader_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkImageReader2");

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkDICOMReader_RowOrder_Type);
  PyVTKEnum_Add(&PyvtkDICOMReader_RowOrder_Type, "vtkDICOMReader.RowOrder");

  o = (PyObject *)&PyvtkDICOMReader_RowOrder_Type;
  if (PyDict_SetItemString(d, "RowOrder", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 3; c++)
  {
    typedef vtkDICOMReader::RowOrder cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[3] = {
        { "FileNative", vtkDICOMReader::FileNative },
        { "TopDown", vtkDICOMReader::TopDown },
        { "BottomUp", vtkDICOMReader::BottomUp },
      };

    o = PyvtkDICOMReader_RowOrder_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

