// python wrapper for vtkDICOMReferenceCount
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMReferenceCount.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMReferenceCount(PyObject *dict); }
static PyMethodDef PyvtkDICOMReferenceCount_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMReferenceCount_vtkDICOMReferenceCount_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMReferenceCount");

  unsigned int temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMReferenceCount *op = new vtkDICOMReferenceCount(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMReferenceCount", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMReferenceCount_vtkDICOMReferenceCount_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMReferenceCount");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMReferenceCount *op = new vtkDICOMReferenceCount();

    result = PyVTKSpecialObject_New("vtkDICOMReferenceCount", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMReferenceCount_vtkDICOMReferenceCount_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMReferenceCount");

  vtkDICOMReferenceCount *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMReferenceCount"))
  {
    vtkDICOMReferenceCount *op = new vtkDICOMReferenceCount(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMReferenceCount", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMReferenceCount_vtkDICOMReferenceCount_Methods[] = {
  {"vtkDICOMReferenceCount", PyvtkDICOMReferenceCount_vtkDICOMReferenceCount_s1, METH_VARARGS,
   "@I"},
  {"vtkDICOMReferenceCount", PyvtkDICOMReferenceCount_vtkDICOMReferenceCount_s3, METH_VARARGS,
   "@W vtkDICOMReferenceCount"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMReferenceCount_vtkDICOMReferenceCount(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMReferenceCount_vtkDICOMReferenceCount_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMReferenceCount_vtkDICOMReferenceCount_s2(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMReferenceCount");
  return nullptr;
}


static const char *PyvtkDICOMReferenceCount_Doc =

  "vtkDICOMReferenceCount(i:int) -> vtkDICOMReferenceCount\nC++: vtkDICOMReferenceCount(unsigned int i)\nvtkDICOMReferenceCount() -> vtkDICOMReferenceCount\nC++: vtkDICOMReferenceCount()\nvtkDICOMReferenceCount(__a:vtkDICOMReferenceCount)\n    -> vtkDICOMReferenceCount\nC++: vtkDICOMReferenceCount(const &vtkDICOMReferenceCount)\n""\n"
  "vtkDICOMReferenceCount - An object for holding an atomic reference\ncount.\n\n"
  "The vtkDICOMValue class is a reference-counted container. In order to\n"
  "safely access values from multiple threads, all operations that\n"
  "modify the reference count must be atomic.\n\n";

static PyObject *
PyvtkDICOMReferenceCount_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMReferenceCount_vtkDICOMReferenceCount(nullptr, args);
}

static void PyvtkDICOMReferenceCount_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMReferenceCount *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDICOMReferenceCount_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMReferenceCount_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMReferenceCount", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMReferenceCount_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMReferenceCount_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMReferenceCount_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMReferenceCount_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkDICOMReferenceCount_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMReferenceCount(*static_cast<const vtkDICOMReferenceCount*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMReferenceCount_TypeNew
extern "C" { PyObject *PyvtkDICOMReferenceCount_TypeNew(); }
#define DECLARED_PyvtkDICOMReferenceCount_TypeNew
#endif

PyObject *PyvtkDICOMReferenceCount_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMReferenceCount_Type,
    PyvtkDICOMReferenceCount_Methods,
    PyvtkDICOMReferenceCount_vtkDICOMReferenceCount_Methods,
    &PyvtkDICOMReferenceCount_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMReferenceCount(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMReferenceCount_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMReferenceCount", o) != 0)
  {
    Py_DECREF(o);
  }

}

