// python wrapper for vtkDICOMSliceSorter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMSliceSorter.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMSliceSorter(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMSliceSorter_ClassNew(); }


static PyObject *
PyvtkDICOMSliceSorter_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMSliceSorter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMSliceSorter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMSliceSorter *tempr = vtkDICOMSliceSorter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMSliceSorter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMSliceSorter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMSliceSorter::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMSliceSorter::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_SetDesiredStackID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDesiredStackID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDesiredStackID(temp0);
    }
    else
    {
      op->vtkDICOMSliceSorter::SetDesiredStackID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetDesiredStackID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDesiredStackID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDesiredStackID() :
      op->vtkDICOMSliceSorter::GetDesiredStackID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetStackIDs(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStackIDs");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkStringArray *tempr = (ap.IsBound() ?
      op->GetStackIDs() :
      op->vtkDICOMSliceSorter::GetStackIDs());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetFileIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetFileIndexArray() :
      op->vtkDICOMSliceSorter::GetFileIndexArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetFrameIndexArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFrameIndexArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIntArray *tempr = (ap.IsBound() ?
      op->GetFrameIndexArray() :
      op->vtkDICOMSliceSorter::GetFrameIndexArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_SetMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  vtkDICOMMetaData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMMetaData"))
  {
    if (ap.IsBound())
    {
      op->SetMetaData(temp0);
    }
    else
    {
      op->vtkDICOMSliceSorter::SetMetaData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMMetaData *tempr = (ap.IsBound() ?
      op->GetMetaData() :
      op->vtkDICOMSliceSorter::GetMetaData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetRepeatsAsTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRepeatsAsTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRepeatsAsTime() :
      op->vtkDICOMSliceSorter::GetRepeatsAsTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_SetRepeatsAsTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRepeatsAsTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRepeatsAsTime(temp0);
    }
    else
    {
      op->vtkDICOMSliceSorter::SetRepeatsAsTime(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_RepeatsAsTimeOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RepeatsAsTimeOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RepeatsAsTimeOn();
    }
    else
    {
      op->vtkDICOMSliceSorter::RepeatsAsTimeOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_RepeatsAsTimeOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RepeatsAsTimeOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RepeatsAsTimeOff();
    }
    else
    {
      op->vtkDICOMSliceSorter::RepeatsAsTimeOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetTimeAsVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeAsVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeAsVector() :
      op->vtkDICOMSliceSorter::GetTimeAsVector());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_SetTimeAsVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeAsVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeAsVector(temp0);
    }
    else
    {
      op->vtkDICOMSliceSorter::SetTimeAsVector(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_TimeAsVectorOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TimeAsVectorOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->TimeAsVectorOn();
    }
    else
    {
      op->vtkDICOMSliceSorter::TimeAsVectorOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_TimeAsVectorOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TimeAsVectorOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->TimeAsVectorOff();
    }
    else
    {
      op->vtkDICOMSliceSorter::TimeAsVectorOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetTimeDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeDimension() :
      op->vtkDICOMSliceSorter::GetTimeDimension());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetTimeSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeSpacing() :
      op->vtkDICOMSliceSorter::GetTimeSpacing());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_SetDesiredTimeIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDesiredTimeIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDesiredTimeIndex(temp0);
    }
    else
    {
      op->vtkDICOMSliceSorter::SetDesiredTimeIndex(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetDesiredTimeIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDesiredTimeIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetDesiredTimeIndex() :
      op->vtkDICOMSliceSorter::GetDesiredTimeIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_SetTimeTag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeTag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    if (ap.IsBound())
    {
      op->SetTimeTag(*temp0);
    }
    else
    {
      op->vtkDICOMSliceSorter::SetTimeTag(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetTimeTag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeTag");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMTag tempr = (ap.IsBound() ?
      op->GetTimeTag() :
      op->vtkDICOMSliceSorter::GetTimeTag());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_SetTimeSequence(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeSequence");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    if (ap.IsBound())
    {
      op->SetTimeSequence(*temp0);
    }
    else
    {
      op->vtkDICOMSliceSorter::SetTimeSequence(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetTimeSequence(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeSequence");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMTag tempr = (ap.IsBound() ?
      op->GetTimeSequence() :
      op->vtkDICOMSliceSorter::GetTimeSequence());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetReverseSlices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReverseSlices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetReverseSlices() :
      op->vtkDICOMSliceSorter::GetReverseSlices());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_SetReverseSlices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReverseSlices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetReverseSlices(temp0);
    }
    else
    {
      op->vtkDICOMSliceSorter::SetReverseSlices(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_ReverseSlicesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReverseSlicesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReverseSlicesOn();
    }
    else
    {
      op->vtkDICOMSliceSorter::ReverseSlicesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_ReverseSlicesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReverseSlicesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReverseSlicesOff();
    }
    else
    {
      op->vtkDICOMSliceSorter::ReverseSlicesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_GetSliceSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSliceSpacing() :
      op->vtkDICOMSliceSorter::GetSliceSpacing());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMSliceSorter_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMSliceSorter *op = static_cast<vtkDICOMSliceSorter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkDICOMSliceSorter::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMSliceSorter_Methods[] = {
  {"IsTypeOf", PyvtkDICOMSliceSorter_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMSliceSorter_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMSliceSorter_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMSliceSorter\nC++: static vtkDICOMSliceSorter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMSliceSorter_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMSliceSorter\nC++: vtkDICOMSliceSorter *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMSliceSorter_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMSliceSorter_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetDesiredStackID", PyvtkDICOMSliceSorter_SetDesiredStackID, METH_VARARGS,
   "SetDesiredStackID(self, stackId:str) -> None\nC++: void SetDesiredStackID(const char *stackId)\n\nSet the Stack ID of the stack to use, for named stacks.\n\nIf the series has multiple stacks, then by default only the first\nstack will be used.  This method allows you to select a different\nstack, if you know the DICOM StackID for the stack.\n"},
  {"GetDesiredStackID", PyvtkDICOMSliceSorter_GetDesiredStackID, METH_VARARGS,
   "GetDesiredStackID(self) -> str\nC++: const char *GetDesiredStackID()\n\nSet the Stack ID of the stack to use, for named stacks.\n\nIf the series has multiple stacks, then by default only the first\nstack will be used.  This method allows you to select a different\nstack, if you know the DICOM StackID for the stack.\n"},
  {"GetStackIDs", PyvtkDICOMSliceSorter_GetStackIDs, METH_VARARGS,
   "GetStackIDs(self) -> vtkStringArray\nC++: vtkStringArray *GetStackIDs()\n\nGet a list of the stacks that are present.\n\nA stack is a contiguous array of slices that form a volume.\n"},
  {"GetFileIndexArray", PyvtkDICOMSliceSorter_GetFileIndexArray, METH_VARARGS,
   "GetFileIndexArray(self) -> vtkIntArray\nC++: vtkIntArray *GetFileIndexArray()\n\nGet an array that converts slice index to input file index.\n\nThe array can be two-dimensional and calling\narray->GetComponent(i,j) will return the file index for slice i\nand scalar component j for monochrome images, or for slice i and\nscalar component 3*j for RGB images (or more precisely, at scalar\ncomponent N*j where N is the SamplesPerPixel value from the DICOM\nmetadata).  If the data has just one component, then use j=0. \nUse this array to index into the MetaData object to get the\nmetadata for a particular slice.\n"},
  {"GetFrameIndexArray", PyvtkDICOMSliceSorter_GetFrameIndexArray, METH_VARARGS,
   "GetFrameIndexArray(self) -> vtkIntArray\nC++: vtkIntArray *GetFrameIndexArray()\n\nGet an array that converts slice index to frame index.\n\nThe purpose of this array is to identify individual frames in\nmulti-frame DICOM files.  The dimensions of this array are\nidentical to the FileIndexArray.  Use FileIndexArray to identify\nthe file, then use FrameIndexArray to identify the frame within\nthat file.\n"},
  {"SetMetaData", PyvtkDICOMSliceSorter_SetMetaData, METH_VARARGS,
   "SetMetaData(self, meta:vtkDICOMMetaData) -> None\nC++: void SetMetaData(vtkDICOMMetaData *meta)\n\nSet the meta data for the DICOM files.\n\nThe Get() method of vtkDICOMMetaData takes optional file and\nframe indices, which specify the file and the frame within that\nfile to get the attribute from.  If you have a slice index rather\nthan a file file index and frame index, then use the\nFileIndexArray and FrameIndexArray to convert the slice index\ninto file and frame indices.\n"},
  {"GetMetaData", PyvtkDICOMSliceSorter_GetMetaData, METH_VARARGS,
   "GetMetaData(self) -> vtkDICOMMetaData\nC++: vtkDICOMMetaData *GetMetaData()\n\nSet the meta data for the DICOM files.\n\nThe Get() method of vtkDICOMMetaData takes optional file and\nframe indices, which specify the file and the frame within that\nfile to get the attribute from.  If you have a slice index rather\nthan a file file index and frame index, then use the\nFileIndexArray and FrameIndexArray to convert the slice index\ninto file and frame indices.\n"},
  {"GetRepeatsAsTime", PyvtkDICOMSliceSorter_GetRepeatsAsTime, METH_VARARGS,
   "GetRepeatsAsTime(self) -> int\nC++: virtual int GetRepeatsAsTime()\n\nForce repeated slices to be at different times (default: Off).\n\nIf this is on, then repeated slices at the same spatial position\nwill always be considered to be at different time points.  If\nthis is off, then the repeated slices will either become the\ntemporal dimension or the vector dimension, depending on the\npresence of temporal attributes in the meta data.\n"},
  {"SetRepeatsAsTime", PyvtkDICOMSliceSorter_SetRepeatsAsTime, METH_VARARGS,
   "SetRepeatsAsTime(self, _arg:int) -> None\nC++: virtual void SetRepeatsAsTime(int _arg)\n\nForce repeated slices to be at different times (default: Off).\n\nIf this is on, then repeated slices at the same spatial position\nwill always be considered to be at different time points.  If\nthis is off, then the repeated slices will either become the\ntemporal dimension or the vector dimension, depending on the\npresence of temporal attributes in the meta data.\n"},
  {"RepeatsAsTimeOn", PyvtkDICOMSliceSorter_RepeatsAsTimeOn, METH_VARARGS,
   "RepeatsAsTimeOn(self) -> None\nC++: virtual void RepeatsAsTimeOn()\n\nForce repeated slices to be at different times (default: Off).\n\nIf this is on, then repeated slices at the same spatial position\nwill always be considered to be at different time points.  If\nthis is off, then the repeated slices will either become the\ntemporal dimension or the vector dimension, depending on the\npresence of temporal attributes in the meta data.\n"},
  {"RepeatsAsTimeOff", PyvtkDICOMSliceSorter_RepeatsAsTimeOff, METH_VARARGS,
   "RepeatsAsTimeOff(self) -> None\nC++: virtual void RepeatsAsTimeOff()\n\nForce repeated slices to be at different times (default: Off).\n\nIf this is on, then repeated slices at the same spatial position\nwill always be considered to be at different time points.  If\nthis is off, then the repeated slices will either become the\ntemporal dimension or the vector dimension, depending on the\npresence of temporal attributes in the meta data.\n"},
  {"GetTimeAsVector", PyvtkDICOMSliceSorter_GetTimeAsVector, METH_VARARGS,
   "GetTimeAsVector(self) -> int\nC++: virtual int GetTimeAsVector()\n\nRead the time dimension as scalar components (default: Off).\n\nIf this is on, then each time point will be stored as a scalar\ncomponent in the image data.  If the data has both a time\ndimension and a vector dimension, then the number of components\nwill be the product of these two dimensions, i.e. the components\nwill store a sequence of vectors, one vector for each time point.\n"},
  {"SetTimeAsVector", PyvtkDICOMSliceSorter_SetTimeAsVector, METH_VARARGS,
   "SetTimeAsVector(self, _arg:int) -> None\nC++: virtual void SetTimeAsVector(int _arg)\n\nRead the time dimension as scalar components (default: Off).\n\nIf this is on, then each time point will be stored as a scalar\ncomponent in the image data.  If the data has both a time\ndimension and a vector dimension, then the number of components\nwill be the product of these two dimensions, i.e. the components\nwill store a sequence of vectors, one vector for each time point.\n"},
  {"TimeAsVectorOn", PyvtkDICOMSliceSorter_TimeAsVectorOn, METH_VARARGS,
   "TimeAsVectorOn(self) -> None\nC++: virtual void TimeAsVectorOn()\n\nRead the time dimension as scalar components (default: Off).\n\nIf this is on, then each time point will be stored as a scalar\ncomponent in the image data.  If the data has both a time\ndimension and a vector dimension, then the number of components\nwill be the product of these two dimensions, i.e. the components\nwill store a sequence of vectors, one vector for each time point.\n"},
  {"TimeAsVectorOff", PyvtkDICOMSliceSorter_TimeAsVectorOff, METH_VARARGS,
   "TimeAsVectorOff(self) -> None\nC++: virtual void TimeAsVectorOff()\n\nRead the time dimension as scalar components (default: Off).\n\nIf this is on, then each time point will be stored as a scalar\ncomponent in the image data.  If the data has both a time\ndimension and a vector dimension, then the number of components\nwill be the product of these two dimensions, i.e. the components\nwill store a sequence of vectors, one vector for each time point.\n"},
  {"GetTimeDimension", PyvtkDICOMSliceSorter_GetTimeDimension, METH_VARARGS,
   "GetTimeDimension(self) -> int\nC++: int GetTimeDimension()\n\nGet the time dimension if the DICOM series has one.\n"},
  {"GetTimeSpacing", PyvtkDICOMSliceSorter_GetTimeSpacing, METH_VARARGS,
   "GetTimeSpacing(self) -> float\nC++: double GetTimeSpacing()\n\nGet the time dimension if the DICOM series has one.\n"},
  {"SetDesiredTimeIndex", PyvtkDICOMSliceSorter_SetDesiredTimeIndex, METH_VARARGS,
   "SetDesiredTimeIndex(self, _arg:int) -> None\nC++: virtual void SetDesiredTimeIndex(int _arg)\n\nSet the desired time index (set to -1 for all).\n"},
  {"GetDesiredTimeIndex", PyvtkDICOMSliceSorter_GetDesiredTimeIndex, METH_VARARGS,
   "GetDesiredTimeIndex(self) -> int\nC++: virtual int GetDesiredTimeIndex()\n\nSet the desired time index (set to -1 for all).\n"},
  {"SetTimeTag", PyvtkDICOMSliceSorter_SetTimeTag, METH_VARARGS,
   "SetTimeTag(self, tag:vtkDICOMTag) -> None\nC++: void SetTimeTag(vtkDICOMTag tag)\n\nSet the DICOM tag to use for time measurement.\n\nThis method can be used to explicitly set the tag to use for\ntemporal sorting.  By default (i.e. if this method is not used),\nthe sorter will search the meta-data for the following temporal\ntags and will automatically apply them if present:\n- TriggerTime (for cardiac images)\n- EchoTime (for relaxometry)\n- TemporalPositionIdentifier (fMRI)\n"},
  {"GetTimeTag", PyvtkDICOMSliceSorter_GetTimeTag, METH_VARARGS,
   "GetTimeTag(self) -> vtkDICOMTag\nC++: vtkDICOMTag GetTimeTag()\n\nSet the DICOM tag to use for time measurement.\n\nThis method can be used to explicitly set the tag to use for\ntemporal sorting.  By default (i.e. if this method is not used),\nthe sorter will search the meta-data for the following temporal\ntags and will automatically apply them if present:\n- TriggerTime (for cardiac images)\n- EchoTime (for relaxometry)\n- TemporalPositionIdentifier (fMRI)\n"},
  {"SetTimeSequence", PyvtkDICOMSliceSorter_SetTimeSequence, METH_VARARGS,
   "SetTimeSequence(self, tag:vtkDICOMTag) -> None\nC++: void SetTimeSequence(vtkDICOMTag tag)\n\nSet the DICOM sequence to use for timing information.\n\nThis is only used for enhanced multi-frame images.  If used, then\nSetTimeTag() must also be used to specify which tag in the\nsequence to use for temporal sorting.  By default, the following\nsequence/tag combinations are automatically detected and applied:\n- CardiacSynchronizationSequence/NominalCardiacTriggerDelayTime\n- TemporalPositionSequence/TemporalPositionTimeOffset\n- FrameContentSequence/TemporalPositionIndex\n- MREchoSequence/EffectiveEchoTime\n"},
  {"GetTimeSequence", PyvtkDICOMSliceSorter_GetTimeSequence, METH_VARARGS,
   "GetTimeSequence(self) -> vtkDICOMTag\nC++: vtkDICOMTag GetTimeSequence()\n\nSet the DICOM sequence to use for timing information.\n\nThis is only used for enhanced multi-frame images.  If used, then\nSetTimeTag() must also be used to specify which tag in the\nsequence to use for temporal sorting.  By default, the following\nsequence/tag combinations are automatically detected and applied:\n- CardiacSynchronizationSequence/NominalCardiacTriggerDelayTime\n- TemporalPositionSequence/TemporalPositionTimeOffset\n- FrameContentSequence/TemporalPositionIndex\n- MREchoSequence/EffectiveEchoTime\n"},
  {"GetReverseSlices", PyvtkDICOMSliceSorter_GetReverseSlices, METH_VARARGS,
   "GetReverseSlices(self) -> int\nC++: virtual int GetReverseSlices()\n\nSet whether to reverse the slice order.\n\nThis is desired if the images are to be flipped.\n"},
  {"SetReverseSlices", PyvtkDICOMSliceSorter_SetReverseSlices, METH_VARARGS,
   "SetReverseSlices(self, _arg:int) -> None\nC++: virtual void SetReverseSlices(int _arg)\n\nSet whether to reverse the slice order.\n\nThis is desired if the images are to be flipped.\n"},
  {"ReverseSlicesOn", PyvtkDICOMSliceSorter_ReverseSlicesOn, METH_VARARGS,
   "ReverseSlicesOn(self) -> None\nC++: virtual void ReverseSlicesOn()\n\nSet whether to reverse the slice order.\n\nThis is desired if the images are to be flipped.\n"},
  {"ReverseSlicesOff", PyvtkDICOMSliceSorter_ReverseSlicesOff, METH_VARARGS,
   "ReverseSlicesOff(self) -> None\nC++: virtual void ReverseSlicesOff()\n\nSet whether to reverse the slice order.\n\nThis is desired if the images are to be flipped.\n"},
  {"GetSliceSpacing", PyvtkDICOMSliceSorter_GetSliceSpacing, METH_VARARGS,
   "GetSliceSpacing(self) -> float\nC++: double GetSliceSpacing()\n\nGet the slice spacing for the volume.\n"},
  {"Update", PyvtkDICOMSliceSorter_Update, METH_VARARGS,
   "Update(self) -> None\nC++: void Update()\n\nUpdate the arrays.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMSliceSorter_Doc =
  "vtkDICOMSliceSorter - Index a DICOM series to allow proper\ndimensional ordering.\n\n"
  "Superclass: vtkObject\n\n"
  "Given a vtkDICOMMetaData object for a DICOM series, this class will\n"
  "index the files and frames in the series so that they can be sorted\n"
  "into a multi-dimensional volume.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMSliceSorter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMSliceSorter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMSliceSorter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMSliceSorter_StaticNew()
{
  return vtkDICOMSliceSorter::New();
}

PyObject *PyvtkDICOMSliceSorter_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMSliceSorter_Type, PyvtkDICOMSliceSorter_Methods,
    "vtkDICOMSliceSorter",
 &PyvtkDICOMSliceSorter_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMSliceSorter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMSliceSorter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMSliceSorter", o) != 0)
  {
    Py_DECREF(o);
  }

}

