// python wrapper for vtkDICOMTagPath
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMTagPath.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMTagPath(PyObject *dict); }

static PyObject *
PyvtkDICOMTagPath_HasTail(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasTail");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTagPath *op = static_cast<vtkDICOMTagPath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->HasTail();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMTagPath_GetHead(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHead");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTagPath *op = static_cast<vtkDICOMTagPath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMTag tempr = op->GetHead();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMTagPath_GetIndex_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndex");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTagPath *op = static_cast<vtkDICOMTagPath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = op->GetIndex();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMTagPath_GetIndex_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndex");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTagPath *op = static_cast<vtkDICOMTagPath *>(vp);

  unsigned int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned int tempr = op->GetIndex(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMTagPath_GetIndex(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMTagPath_GetIndex_s1(self, args);
    case 1:
      return PyvtkDICOMTagPath_GetIndex_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetIndex");
  return nullptr;
}


static PyObject *
PyvtkDICOMTagPath_GetTag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTag");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTagPath *op = static_cast<vtkDICOMTagPath *>(vp);

  unsigned int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMTag tempr = op->GetTag(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMTagPath_GetSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSize");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTagPath *op = static_cast<vtkDICOMTagPath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = op->GetSize();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMTagPath_GetTail(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTail");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTagPath *op = static_cast<vtkDICOMTagPath *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMTagPath tempr = op->GetTail();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTagPath");
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMTagPath_Methods[] = {
  {"HasTail", PyvtkDICOMTagPath_HasTail, METH_VARARGS,
   "HasTail(self) -> bool\nC++: bool HasTail()\n\nIf there is no tail, then Head is the end of the path.\n"},
  {"GetHead", PyvtkDICOMTagPath_GetHead, METH_VARARGS,
   "GetHead(self) -> vtkDICOMTag\nC++: vtkDICOMTag GetHead()\n\nGet the path head, which should be a sequence if HasTail() is\ntrue.\n"},
  {"GetIndex", PyvtkDICOMTagPath_GetIndex, METH_VARARGS,
   "GetIndex(self) -> int\nC++: unsigned int GetIndex()\nGetIndex(self, i:int) -> int\nC++: unsigned int GetIndex(unsigned int i)\n\nGet the index of the item within the sequence.\n"},
  {"GetTag", PyvtkDICOMTagPath_GetTag, METH_VARARGS,
   "GetTag(self, i:int) -> vtkDICOMTag\nC++: vtkDICOMTag GetTag(unsigned int i)\n\nGet the nth tag in the path.\n"},
  {"GetSize", PyvtkDICOMTagPath_GetSize, METH_VARARGS,
   "GetSize(self) -> int\nC++: unsigned int GetSize()\n\nGet the number of tags in the path.\n"},
  {"GetTail", PyvtkDICOMTagPath_GetTail, METH_VARARGS,
   "GetTail(self) -> vtkDICOMTagPath\nC++: vtkDICOMTagPath GetTail()\n\nGet the remainder of the path (after Head and Index).\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMTagPath_vtkDICOMTagPath_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTagPath");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMTagPath *op = new vtkDICOMTagPath();

    result = PyVTKSpecialObject_New("vtkDICOMTagPath", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMTagPath_vtkDICOMTagPath_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTagPath");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  unsigned int temp1;
  vtkDICOMTag *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(3) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1) &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMTag"))
  {
    vtkDICOMTagPath *op = new vtkDICOMTagPath(*temp0, temp1, *temp2);

    result = PyVTKSpecialObject_New("vtkDICOMTagPath", op);
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj2);

  return result;
}

static PyObject *
PyvtkDICOMTagPath_vtkDICOMTagPath_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTagPath");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  unsigned int temp1;
  vtkDICOMTag *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  unsigned int temp3;
  vtkDICOMTag *temp4 = nullptr;
  PyObject *pobj4 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(5) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetValue(temp1) &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMTag") &&
      ap.GetValue(temp3) &&
      ap.GetSpecialObject(temp4, pobj4, "vtkDICOMTag"))
  {
    vtkDICOMTagPath *op = new vtkDICOMTagPath(*temp0, temp1, *temp2, temp3, *temp4);

    result = PyVTKSpecialObject_New("vtkDICOMTagPath", op);
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj2);
  Py_XDECREF(pobj4);

  return result;
}

static PyObject *
PyvtkDICOMTagPath_vtkDICOMTagPath_s4(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTagPath");

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  unsigned int temp1;
  vtkDICOMTag *temp2 = nullptr;
  PyObject *pobj2 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(3) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath") &&
      ap.GetValue(temp1) &&
      ap.GetSpecialObject(temp2, pobj2, "vtkDICOMTag"))
  {
    vtkDICOMTagPath *op = new vtkDICOMTagPath(*temp0, temp1, *temp2);

    result = PyVTKSpecialObject_New("vtkDICOMTagPath", op);
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj2);

  return result;
}

static PyObject *
PyvtkDICOMTagPath_vtkDICOMTagPath_s5(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTagPath");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    vtkDICOMTagPath *op = new vtkDICOMTagPath(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMTagPath", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMTagPath_vtkDICOMTagPath_s6(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTagPath");

  vtkDICOMTagPath *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTagPath"))
  {
    vtkDICOMTagPath *op = new vtkDICOMTagPath(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMTagPath", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMTagPath_vtkDICOMTagPath_Methods[] = {
  {"vtkDICOMTagPath", PyvtkDICOMTagPath_vtkDICOMTagPath_s2, METH_VARARGS,
   "@WIW vtkDICOMTag vtkDICOMTag"},
  {"vtkDICOMTagPath", PyvtkDICOMTagPath_vtkDICOMTagPath_s4, METH_VARARGS,
   "@WIW vtkDICOMTagPath vtkDICOMTag"},
  {"vtkDICOMTagPath", PyvtkDICOMTagPath_vtkDICOMTagPath_s5, METH_VARARGS,
   "-@W vtkDICOMTag"},
  {"vtkDICOMTagPath", PyvtkDICOMTagPath_vtkDICOMTagPath_s6, METH_VARARGS,
   "@W vtkDICOMTagPath"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMTagPath_vtkDICOMTagPath(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMTagPath_vtkDICOMTagPath_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMTagPath_vtkDICOMTagPath_s1(self, args);
    case 5:
      return PyvtkDICOMTagPath_vtkDICOMTagPath_s3(self, args);
    case 1:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMTagPath");
  return nullptr;
}


static const char *PyvtkDICOMTagPath_Doc =

  "vtkDICOMTagPath() -> vtkDICOMTagPath\nC++: vtkDICOMTagPath()\nvtkDICOMTagPath(seqTag:vtkDICOMTag, i:int, tag:vtkDICOMTag)\n    -> vtkDICOMTagPath\nC++: vtkDICOMTagPath(vtkDICOMTag seqTag, unsigned int i,\n    vtkDICOMTag tag)\nvtkDICOMTagPath(seqTag:vtkDICOMTag, i:int, tag:vtkDICOMTag, j:int,\n    tag2:vtkDICOMTag) -> vtkDICOMTagPath\nC++: vtkDICOMTagPath(vtkDICOMTag seqTag, unsigned int i,\n    vtkDICOMTag tag, unsigned int j, vtkDICOMTag tag2)\nvtkDICOMTagPath(path:vtkDICOMTagPath, i:int, tag:vtkDICOMTag)\n    -> vtkDICOMTagPath\nC++: vtkDICOMTagPath(const vtkDICOMTagPath &path, unsigned int i,\n    vtkDICOMTag tag)\nvtkDICOMTagPath(tag:vtkDICOMTag) -> vtkDICOMTagPath\nC++: explicit vtkDICOMTagPath(vtkDICOMTag tag)\nvtkDICOMTagPath(o:vtkDICOMTagPath) -> vtkDICOMTagPath\nC++: vtkDICOMTagPath(const vtkDICOMTagPath &o)\n""\n"
  "vtkDICOMTagPath - A tag path for digging values out of sequence items.\n\n"
  "The tag path makes it easier to access data elements that are buried\n"
  "within sequences.\n\n";

static PyObject *
PyvtkDICOMTagPath_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMTagPath_vtkDICOMTagPath(nullptr, args);
}

static void PyvtkDICOMTagPath_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMTagPath *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkDICOMTagPath_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkDICOMTagPath *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyUnicode_FromStringAndSize(s.data(), s.size());
}

static int PyvtkDICOMTagPath_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMTagPath_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMTagPath *so1 = nullptr;
  const vtkDICOMTagPath *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMTagPath_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMTagPath *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMTagPath *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMTagPath", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMTagPath_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMTagPath *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMTagPath *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMTagPath", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      result = ((*so1) < (*so2));
      break;
    case Py_LE:
      result = ((*so1) <= (*so2));
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      result = ((*so1) > (*so2));
      break;
    case Py_GE:
      result = ((*so1) >= (*so2));
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMTagPath_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMTagPath_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMTagPath", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMTagPath_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMTagPath_Hash, // tp_hash
  nullptr, // tp_call
  PyvtkDICOMTagPath_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMTagPath_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMTagPath_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMTagPath_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMTagPath_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMTagPath_Type);
}

static void *PyvtkDICOMTagPath_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMTagPath(*static_cast<const vtkDICOMTagPath*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMTagPath_TypeNew
extern "C" { PyObject *PyvtkDICOMTagPath_TypeNew(); }
#define DECLARED_PyvtkDICOMTagPath_TypeNew
#endif

PyObject *PyvtkDICOMTagPath_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMTagPath_Type,
    PyvtkDICOMTagPath_Methods,
    PyvtkDICOMTagPath_vtkDICOMTagPath_Methods,
    &PyvtkDICOMTagPath_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMTagPath(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMTagPath_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMTagPath", o) != 0)
  {
    Py_DECREF(o);
  }

}

