// python wrapper for vtkDICOMTag
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMDictHash.h"
#include "vtkDICOMTag.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMTag(PyObject *dict); }

static PyObject *
PyvtkDICOMTag_GetGroup(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGroup");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTag *op = static_cast<vtkDICOMTag *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned short tempr = op->GetGroup();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMTag_GetElement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetElement");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTag *op = static_cast<vtkDICOMTag *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned short tempr = op->GetElement();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMTag_GetKey(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetKey");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTag *op = static_cast<vtkDICOMTag *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = op->GetKey();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMTag_ComputeHash(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ComputeHash");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMTag *op = static_cast<vtkDICOMTag *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = op->ComputeHash();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMTag_Methods[] = {
  {"GetGroup", PyvtkDICOMTag_GetGroup, METH_VARARGS,
   "GetGroup(self) -> int\nC++: unsigned short GetGroup()\n\nGet the 16-bit group identifier.\n"},
  {"GetElement", PyvtkDICOMTag_GetElement, METH_VARARGS,
   "GetElement(self) -> int\nC++: unsigned short GetElement()\n\nGet the 16-bit element identifier.\n"},
  {"GetKey", PyvtkDICOMTag_GetKey, METH_VARARGS,
   "GetKey(self) -> int\nC++: unsigned int GetKey()\n\nGet the tag as a 32-bit key.\n"},
  {"ComputeHash", PyvtkDICOMTag_ComputeHash, METH_VARARGS,
   "ComputeHash(self) -> int\nC++: unsigned int ComputeHash()\n\nCompute a hash value, used for accelerating lookups.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMTag_vtkDICOMTag_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTag");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMTag *op = new vtkDICOMTag();

    result = PyVTKSpecialObject_New("vtkDICOMTag", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMTag_vtkDICOMTag_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTag");

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkDICOMTag *op = new vtkDICOMTag(temp0, temp1);

    result = PyVTKSpecialObject_New("vtkDICOMTag", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMTag_vtkDICOMTag_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTag");

  DC::EnumType temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetEnumValue(temp0, "DC.EnumType"))
  {
    vtkDICOMTag *op = new vtkDICOMTag(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMTag", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMTag_vtkDICOMTag_s4(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMTag");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    vtkDICOMTag *op = new vtkDICOMTag(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMTag", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMTag_vtkDICOMTag_Methods[] = {
  {"vtkDICOMTag", PyvtkDICOMTag_vtkDICOMTag_s3, METH_VARARGS,
   "@E DC.EnumType"},
  {"vtkDICOMTag", PyvtkDICOMTag_vtkDICOMTag_s4, METH_VARARGS,
   "@W vtkDICOMTag"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMTag_vtkDICOMTag(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMTag_vtkDICOMTag_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMTag_vtkDICOMTag_s1(self, args);
    case 2:
      return PyvtkDICOMTag_vtkDICOMTag_s2(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMTag");
  return nullptr;
}


static const char *PyvtkDICOMTag_Doc =

  "vtkDICOMTag() -> vtkDICOMTag\nC++: vtkDICOMTag()\nvtkDICOMTag(group:int, element:int) -> vtkDICOMTag\nC++: vtkDICOMTag(int group, int element)\nvtkDICOMTag(tag:DC.EnumType) -> vtkDICOMTag\nC++: vtkDICOMTag(DC::EnumType tag)\nvtkDICOMTag(__a:vtkDICOMTag) -> vtkDICOMTag\nC++: vtkDICOMTag(const &vtkDICOMTag)\n""\n"
  "vtkDICOMTag - A (group,element) identifier tag for DICOM attributes.\n\n"
;

static PyObject *
PyvtkDICOMTag_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMTag_vtkDICOMTag(nullptr, args);
}

static void PyvtkDICOMTag_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMTag *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkDICOMTag_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkDICOMTag *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyUnicode_FromStringAndSize(s.data(), s.size());
}

static int PyvtkDICOMTag_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMTag_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMTag *so1 = nullptr;
  const vtkDICOMTag *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMTag_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMTag *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMTag *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMTag", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMTag_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMTag *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMTag *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMTag", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      result = ((*so1) < (*so2));
      break;
    case Py_LE:
      result = ((*so1) <= (*so2));
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      result = ((*so1) > (*so2));
      break;
    case Py_GE:
      result = ((*so1) >= (*so2));
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMTag_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMTag_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMTag", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMTag_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMTag_Hash, // tp_hash
  nullptr, // tp_call
  PyvtkDICOMTag_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMTag_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMTag_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMTag_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMTag_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMTag_Type);
}

static void *PyvtkDICOMTag_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMTag(*static_cast<const vtkDICOMTag*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMTag_TypeNew
extern "C" { PyObject *PyvtkDICOMTag_TypeNew(); }
#define DECLARED_PyvtkDICOMTag_TypeNew
#endif

PyObject *PyvtkDICOMTag_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMTag_Type,
    PyvtkDICOMTag_Methods,
    PyvtkDICOMTag_vtkDICOMTag_Methods,
    &PyvtkDICOMTag_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMTag(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMTag_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMTag", o) != 0)
  {
    Py_DECREF(o);
  }

}

