// python wrapper for vtkDICOMToRAS
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMToRAS.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMToRAS(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMToRAS_ClassNew(); }


static PyObject *
PyvtkDICOMToRAS_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMToRAS::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMToRAS::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMToRAS *tempr = vtkDICOMToRAS::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMToRAS *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMToRAS::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMToRAS::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMToRAS::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_SetRASToDICOM(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRASToDICOM");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRASToDICOM(temp0);
    }
    else
    {
      op->vtkDICOMToRAS::SetRASToDICOM(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_RASToDICOMOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RASToDICOMOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RASToDICOMOn();
    }
    else
    {
      op->vtkDICOMToRAS::RASToDICOMOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_RASToDICOMOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RASToDICOMOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RASToDICOMOff();
    }
    else
    {
      op->vtkDICOMToRAS::RASToDICOMOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_GetRASToDICOM(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRASToDICOM");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRASToDICOM() :
      op->vtkDICOMToRAS::GetRASToDICOM());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_SetPatientMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPatientMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetPatientMatrix(temp0);
    }
    else
    {
      op->vtkDICOMToRAS::SetPatientMatrix(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_GetPatientMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPatientMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetPatientMatrix() :
      op->vtkDICOMToRAS::GetPatientMatrix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_GetRASMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRASMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetRASMatrix() :
      op->vtkDICOMToRAS::GetRASMatrix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_SetRASMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRASMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetRASMatrix(temp0);
    }
    else
    {
      op->vtkDICOMToRAS::SetRASMatrix(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_UpdateMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateMatrix();
    }
    else
    {
      op->vtkDICOMToRAS::UpdateMatrix();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_SetRASMatrixHasPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRASMatrixHasPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRASMatrixHasPosition(temp0);
    }
    else
    {
      op->vtkDICOMToRAS::SetRASMatrixHasPosition(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_RASMatrixHasPositionOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RASMatrixHasPositionOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RASMatrixHasPositionOn();
    }
    else
    {
      op->vtkDICOMToRAS::RASMatrixHasPositionOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_RASMatrixHasPositionOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RASMatrixHasPositionOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RASMatrixHasPositionOff();
    }
    else
    {
      op->vtkDICOMToRAS::RASMatrixHasPositionOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_GetRASMatrixHasPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRASMatrixHasPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRASMatrixHasPosition() :
      op->vtkDICOMToRAS::GetRASMatrixHasPosition());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_SetAllowColumnReordering(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAllowColumnReordering");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAllowColumnReordering(temp0);
    }
    else
    {
      op->vtkDICOMToRAS::SetAllowColumnReordering(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_AllowColumnReorderingOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllowColumnReorderingOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AllowColumnReorderingOn();
    }
    else
    {
      op->vtkDICOMToRAS::AllowColumnReorderingOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_AllowColumnReorderingOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllowColumnReorderingOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AllowColumnReorderingOff();
    }
    else
    {
      op->vtkDICOMToRAS::AllowColumnReorderingOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_GetAllowColumnReordering(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAllowColumnReordering");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAllowColumnReordering() :
      op->vtkDICOMToRAS::GetAllowColumnReordering());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_SetAllowRowReordering(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAllowRowReordering");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAllowRowReordering(temp0);
    }
    else
    {
      op->vtkDICOMToRAS::SetAllowRowReordering(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_AllowRowReorderingOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllowRowReorderingOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AllowRowReorderingOn();
    }
    else
    {
      op->vtkDICOMToRAS::AllowRowReorderingOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_AllowRowReorderingOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllowRowReorderingOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AllowRowReorderingOff();
    }
    else
    {
      op->vtkDICOMToRAS::AllowRowReorderingOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMToRAS_GetAllowRowReordering(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAllowRowReordering");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMToRAS *op = static_cast<vtkDICOMToRAS *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAllowRowReordering() :
      op->vtkDICOMToRAS::GetAllowRowReordering());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMToRAS_Methods[] = {
  {"IsTypeOf", PyvtkDICOMToRAS_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMToRAS_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMToRAS_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMToRAS\nC++: static vtkDICOMToRAS *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMToRAS_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMToRAS\nC++: vtkDICOMToRAS *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMToRAS_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMToRAS_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetRASToDICOM", PyvtkDICOMToRAS_SetRASToDICOM, METH_VARARGS,
   "SetRASToDICOM(self, v:int) -> None\nC++: void SetRASToDICOM(int v)\n\nReverse the filter: do RAS to DICOM instead of DICOM to RAS.\n"},
  {"RASToDICOMOn", PyvtkDICOMToRAS_RASToDICOMOn, METH_VARARGS,
   "RASToDICOMOn(self) -> None\nC++: void RASToDICOMOn()\n\nReverse the filter: do RAS to DICOM instead of DICOM to RAS.\n"},
  {"RASToDICOMOff", PyvtkDICOMToRAS_RASToDICOMOff, METH_VARARGS,
   "RASToDICOMOff(self) -> None\nC++: void RASToDICOMOff()\n\nReverse the filter: do RAS to DICOM instead of DICOM to RAS.\n"},
  {"GetRASToDICOM", PyvtkDICOMToRAS_GetRASToDICOM, METH_VARARGS,
   "GetRASToDICOM(self) -> int\nC++: int GetRASToDICOM()\n\nReverse the filter: do RAS to DICOM instead of DICOM to RAS.\n"},
  {"SetPatientMatrix", PyvtkDICOMToRAS_SetPatientMatrix, METH_VARARGS,
   "SetPatientMatrix(self, matrix:vtkMatrix4x4) -> None\nC++: void SetPatientMatrix(vtkMatrix4x4 *matrix)\n\nSet a matrix that places the image in DICOM patient coords.\n\nThis matrix is constructed from the ImageOrientationPatient and\nImagePositionPatient meta data attributes.  See the\nSetMemoryRowOrder method for additional information.\n"},
  {"GetPatientMatrix", PyvtkDICOMToRAS_GetPatientMatrix, METH_VARARGS,
   "GetPatientMatrix(self) -> vtkMatrix4x4\nC++: vtkMatrix4x4 *GetPatientMatrix()\n\nSet a matrix that places the image in DICOM patient coords.\n\nThis matrix is constructed from the ImageOrientationPatient and\nImagePositionPatient meta data attributes.  See the\nSetMemoryRowOrder method for additional information.\n"},
  {"GetRASMatrix", PyvtkDICOMToRAS_GetRASMatrix, METH_VARARGS,
   "GetRASMatrix(self) -> vtkMatrix4x4\nC++: vtkMatrix4x4 *GetRASMatrix()\n\nGet a matrix that places the image in RAS coordinates.\n\nThis matrix is meant to be used with the output image (unless the\nmethod RASToDICOMOn() has been called to reverse the operation of\nthe filter).\n"},
  {"SetRASMatrix", PyvtkDICOMToRAS_SetRASMatrix, METH_VARARGS,
   "SetRASMatrix(self, matrix:vtkMatrix4x4) -> None\nC++: void SetRASMatrix(vtkMatrix4x4 *matrix)\n\nGet a matrix that places the image in RAS coordinates.\n\nThis matrix is meant to be used with the output image (unless the\nmethod RASToDICOMOn() has been called to reverse the operation of\nthe filter).\n"},
  {"UpdateMatrix", PyvtkDICOMToRAS_UpdateMatrix, METH_VARARGS,
   "UpdateMatrix(self) -> None\nC++: void UpdateMatrix()\n\nUpdate the matrix without updating the output data.\n\nThis requires that an input has been set, because the origin,\nspacing, and extent of the input data must be known in order to\ncompute the matrix.\n"},
  {"SetRASMatrixHasPosition", PyvtkDICOMToRAS_SetRASMatrixHasPosition, METH_VARARGS,
   "SetRASMatrixHasPosition(self, v:int) -> None\nC++: void SetRASMatrixHasPosition(int v)\n\nSet whether the RAS matrix should have a non-zero final column.\n\nBy default, the RAS matrix produced by this filter will have a\nposition coordinate in its final column (NIfTI style).\nAlternatively, this filter can set the final column to zero and\nuse the position to compute a new Origin for the output image. If\nthis option is On, then the Origin of the output image will be\n(0,0,0), and if it is Off, then the final column of the matrix\nwill be (0,0,0).\n"},
  {"RASMatrixHasPositionOn", PyvtkDICOMToRAS_RASMatrixHasPositionOn, METH_VARARGS,
   "RASMatrixHasPositionOn(self) -> None\nC++: void RASMatrixHasPositionOn()\n\nSet whether the RAS matrix should have a non-zero final column.\n\nBy default, the RAS matrix produced by this filter will have a\nposition coordinate in its final column (NIfTI style).\nAlternatively, this filter can set the final column to zero and\nuse the position to compute a new Origin for the output image. If\nthis option is On, then the Origin of the output image will be\n(0,0,0), and if it is Off, then the final column of the matrix\nwill be (0,0,0).\n"},
  {"RASMatrixHasPositionOff", PyvtkDICOMToRAS_RASMatrixHasPositionOff, METH_VARARGS,
   "RASMatrixHasPositionOff(self) -> None\nC++: void RASMatrixHasPositionOff()\n\nSet whether the RAS matrix should have a non-zero final column.\n\nBy default, the RAS matrix produced by this filter will have a\nposition coordinate in its final column (NIfTI style).\nAlternatively, this filter can set the final column to zero and\nuse the position to compute a new Origin for the output image. If\nthis option is On, then the Origin of the output image will be\n(0,0,0), and if it is Off, then the final column of the matrix\nwill be (0,0,0).\n"},
  {"GetRASMatrixHasPosition", PyvtkDICOMToRAS_GetRASMatrixHasPosition, METH_VARARGS,
   "GetRASMatrixHasPosition(self) -> int\nC++: int GetRASMatrixHasPosition()\n\nSet whether the RAS matrix should have a non-zero final column.\n\nBy default, the RAS matrix produced by this filter will have a\nposition coordinate in its final column (NIfTI style).\nAlternatively, this filter can set the final column to zero and\nuse the position to compute a new Origin for the output image. If\nthis option is On, then the Origin of the output image will be\n(0,0,0), and if it is Off, then the final column of the matrix\nwill be (0,0,0).\n"},
  {"SetAllowColumnReordering", PyvtkDICOMToRAS_SetAllowColumnReordering, METH_VARARGS,
   "SetAllowColumnReordering(self, v:int) -> None\nC++: void SetAllowColumnReordering(int v)\n\nAllow the columns of the image to be reordered.\n\nThe columns can be reordered so that columns with higher indices\nare further to the right or further anterior.  Note that if you\nturn this option on, then you are implicitly allowing slice\nreordering to occur as well.  If you turn both ColumnReordering\nand SliceReordering off, then the input data will be directly\npassed to the output.\n"},
  {"AllowColumnReorderingOn", PyvtkDICOMToRAS_AllowColumnReorderingOn, METH_VARARGS,
   "AllowColumnReorderingOn(self) -> None\nC++: void AllowColumnReorderingOn()\n\nAllow the columns of the image to be reordered.\n\nThe columns can be reordered so that columns with higher indices\nare further to the right or further anterior.  Note that if you\nturn this option on, then you are implicitly allowing slice\nreordering to occur as well.  If you turn both ColumnReordering\nand SliceReordering off, then the input data will be directly\npassed to the output.\n"},
  {"AllowColumnReorderingOff", PyvtkDICOMToRAS_AllowColumnReorderingOff, METH_VARARGS,
   "AllowColumnReorderingOff(self) -> None\nC++: void AllowColumnReorderingOff()\n\nAllow the columns of the image to be reordered.\n\nThe columns can be reordered so that columns with higher indices\nare further to the right or further anterior.  Note that if you\nturn this option on, then you are implicitly allowing slice\nreordering to occur as well.  If you turn both ColumnReordering\nand SliceReordering off, then the input data will be directly\npassed to the output.\n"},
  {"GetAllowColumnReordering", PyvtkDICOMToRAS_GetAllowColumnReordering, METH_VARARGS,
   "GetAllowColumnReordering(self) -> int\nC++: int GetAllowColumnReordering()\n\nAllow the columns of the image to be reordered.\n\nThe columns can be reordered so that columns with higher indices\nare further to the right or further anterior.  Note that if you\nturn this option on, then you are implicitly allowing slice\nreordering to occur as well.  If you turn both ColumnReordering\nand SliceReordering off, then the input data will be directly\npassed to the output.\n"},
  {"SetAllowRowReordering", PyvtkDICOMToRAS_SetAllowRowReordering, METH_VARARGS,
   "SetAllowRowReordering(self, v:int) -> None\nC++: void SetAllowRowReordering(int v)\n\nAllow the rows of the image to be reordered.\n\nThe rows can be reordered so that rows with higher indices are\nfurther superior or further anterior.  Note that if you turn this\noption on, then you are implicitly allowing slice reordering to\noccur as well.  If you turn both ColumnReordering and\nSliceReordering off, then the input data will be directly passed\nto the output.\n"},
  {"AllowRowReorderingOn", PyvtkDICOMToRAS_AllowRowReorderingOn, METH_VARARGS,
   "AllowRowReorderingOn(self) -> None\nC++: void AllowRowReorderingOn()\n\nAllow the rows of the image to be reordered.\n\nThe rows can be reordered so that rows with higher indices are\nfurther superior or further anterior.  Note that if you turn this\noption on, then you are implicitly allowing slice reordering to\noccur as well.  If you turn both ColumnReordering and\nSliceReordering off, then the input data will be directly passed\nto the output.\n"},
  {"AllowRowReorderingOff", PyvtkDICOMToRAS_AllowRowReorderingOff, METH_VARARGS,
   "AllowRowReorderingOff(self) -> None\nC++: void AllowRowReorderingOff()\n\nAllow the rows of the image to be reordered.\n\nThe rows can be reordered so that rows with higher indices are\nfurther superior or further anterior.  Note that if you turn this\noption on, then you are implicitly allowing slice reordering to\noccur as well.  If you turn both ColumnReordering and\nSliceReordering off, then the input data will be directly passed\nto the output.\n"},
  {"GetAllowRowReordering", PyvtkDICOMToRAS_GetAllowRowReordering, METH_VARARGS,
   "GetAllowRowReordering(self) -> int\nC++: int GetAllowRowReordering()\n\nAllow the rows of the image to be reordered.\n\nThe rows can be reordered so that rows with higher indices are\nfurther superior or further anterior.  Note that if you turn this\noption on, then you are implicitly allowing slice reordering to\noccur as well.  If you turn both ColumnReordering and\nSliceReordering off, then the input data will be directly passed\nto the output.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMToRAS_Doc =
  "vtkDICOMToRAS - Convert DICOM orientation to RAS orientation\n\n"
  "Superclass: vtkThreadedImageAlgorithm\n\n"
  "This class will modify an image and its position-and-orientation\n"
  "matrix so that the patient coordinate system follows the conventions\n"
  "of NIFTI and MINC, i.e. the x, y, and z axes will point in the right,\n"
  "anterior, and superior directions respectively.  Optionally, the row\n"
  "and column ordering of the image will also be modified so that the\n"
  "row direction preferentially points right or anterior, and the column\n"
  "direction preferentially points superior or anterior.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMToRAS_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMToRAS", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMToRAS_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMToRAS_StaticNew()
{
  return vtkDICOMToRAS::New();
}

PyObject *PyvtkDICOMToRAS_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMToRAS_Type, PyvtkDICOMToRAS_Methods,
    "vtkDICOMToRAS",
 &PyvtkDICOMToRAS_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkThreadedImageAlgorithm");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMToRAS(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMToRAS_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMToRAS", o) != 0)
  {
    Py_DECREF(o);
  }

}

