// python wrapper for vtkDICOMUIDGenerator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMUIDGenerator.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMUIDGenerator(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMUIDGenerator_ClassNew(); }


static PyObject *
PyvtkDICOMUIDGenerator_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMUIDGenerator::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUIDGenerator *op = static_cast<vtkDICOMUIDGenerator *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMUIDGenerator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMUIDGenerator *tempr = vtkDICOMUIDGenerator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUIDGenerator *op = static_cast<vtkDICOMUIDGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMUIDGenerator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMUIDGenerator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMUIDGenerator::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUIDGenerator *op = static_cast<vtkDICOMUIDGenerator *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMUIDGenerator::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_SetUIDPrefix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUIDPrefix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUIDGenerator *op = static_cast<vtkDICOMUIDGenerator *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUIDPrefix(temp0);
    }
    else
    {
      op->vtkDICOMUIDGenerator::SetUIDPrefix(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_GetUIDPrefix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUIDPrefix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUIDGenerator *op = static_cast<vtkDICOMUIDGenerator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetUIDPrefix() :
      op->vtkDICOMUIDGenerator::GetUIDPrefix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_GenerateUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GenerateUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUIDGenerator *op = static_cast<vtkDICOMUIDGenerator *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    std::string tempr = (ap.IsBound() ?
      op->GenerateUID(*temp0) :
      op->vtkDICOMUIDGenerator::GenerateUID(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_GenerateUIDs(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GenerateUIDs");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUIDGenerator *op = static_cast<vtkDICOMUIDGenerator *>(vp);

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkStringArray *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetVTKObject(temp1, "vtkStringArray"))
  {
    if (ap.IsBound())
    {
      op->GenerateUIDs(*temp0, temp1);
    }
    else
    {
      op->vtkDICOMUIDGenerator::GenerateUIDs(*temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_SetDefault(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SetDefault");

  vtkDICOMUIDGenerator *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMUIDGenerator"))
  {
    vtkDICOMUIDGenerator::SetDefault(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUIDGenerator_GetDefault(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetDefault");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMUIDGenerator *tempr = vtkDICOMUIDGenerator::GetDefault();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMUIDGenerator_Methods[] = {
  {"IsTypeOf", PyvtkDICOMUIDGenerator_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMUIDGenerator_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMUIDGenerator_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMUIDGenerator\nC++: static vtkDICOMUIDGenerator *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMUIDGenerator_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMUIDGenerator\nC++: vtkDICOMUIDGenerator *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMUIDGenerator_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMUIDGenerator_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetUIDPrefix", PyvtkDICOMUIDGenerator_SetUIDPrefix, METH_VARARGS,
   "SetUIDPrefix(self, prefix:str) -> None\nC++: void SetUIDPrefix(const char *prefix)\n\nSet a UID prefix to use when generating UIDs.\n\nIf this is not set, or if it is set to NULL, then the default\nprefix set via vtkDICOMUtilities::SetUIDPrefix() will be used.\nIts default is the 2.25. prefix.\n"},
  {"GetUIDPrefix", PyvtkDICOMUIDGenerator_GetUIDPrefix, METH_VARARGS,
   "GetUIDPrefix(self) -> str\nC++: const char *GetUIDPrefix()\n\nGet the current UID prefix.\n\nIf no prefix was set, then this will return the same value as\nvtkDICOMUtilities::GetUIDPrefix().\n"},
  {"GenerateUID", PyvtkDICOMUIDGenerator_GenerateUID, METH_VARARGS,
   "GenerateUID(self, tag:vtkDICOMTag) -> str\nC++: virtual std::string GenerateUID(vtkDICOMTag tag)\n\nGenerate a UID for the provided tag.\n"},
  {"GenerateUIDs", PyvtkDICOMUIDGenerator_GenerateUIDs, METH_VARARGS,
   "GenerateUIDs(self, tag:vtkDICOMTag, uids:vtkStringArray) -> None\nC++: virtual void GenerateUIDs(vtkDICOMTag tag,\n    vtkStringArray *uids)\n\nGenerate a series of UIDs, sorted from low to high.\n\nBefore passing the string array, call SetNumberOfValues() on the\narray to specify the number of UIDs that you want to be stored in\nit.  The stored UIDs will be sorted, low to high. Generating a\nbatch of UIDs is more efficient than calling GenerateUID()\nrepeatedly.\n"},
  {"SetDefault", PyvtkDICOMUIDGenerator_SetDefault, METH_VARARGS,
   "SetDefault(uidgen:vtkDICOMUIDGenerator) -> None\nC++: static void SetDefault(vtkDICOMUIDGenerator *uidgen)\n\nSet the default UID generator.\n\nThis can be used to set an application-wide UID generator.\n"},
  {"GetDefault", PyvtkDICOMUIDGenerator_GetDefault, METH_VARARGS,
   "GetDefault() -> vtkDICOMUIDGenerator\nC++: static vtkDICOMUIDGenerator *GetDefault()\n\nGet the default UID generator.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMUIDGenerator_Doc =
  "vtkDICOMUIDGenerator - Generate UIDs for written DICOM files.\n\n"
  "Superclass: vtkObject\n\n"
  "This class generates UIDs that begin with a specified prefix, and are\n"
  "are followed by a sequence of digits that are sufficiently random\n"
  "that the possibility of UID collisions is vanishingly small.  The\n"
  "default prefix 2.25. (which can be used by anyone) is followed by a\n"
  "128-bit random number.  Other prefixes (which can only be used by a\n"
  "designated organization) are followed by a 128-bit random number if\n"
  "the prefix is shorter than 24 chars, or a 96-bit random number if the\n"
  "prefix is 24 chars or longer.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMUIDGenerator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMUIDGenerator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMUIDGenerator_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMUIDGenerator_StaticNew()
{
  return vtkDICOMUIDGenerator::New();
}

PyObject *PyvtkDICOMUIDGenerator_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMUIDGenerator_Type, PyvtkDICOMUIDGenerator_Methods,
    "vtkDICOMUIDGenerator",
 &PyvtkDICOMUIDGenerator_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

static PyMethodDef PyvtkDICOMUIDGeneratorInitializer_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMUIDGeneratorInitializer_vtkDICOMUIDGeneratorInitializer(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMUIDGeneratorInitializer");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMUIDGeneratorInitializer *op = new vtkDICOMUIDGeneratorInitializer();

    result = PyVTKSpecialObject_New("vtkDICOMUIDGeneratorInitializer", op);
  }

  return result;
}

static PyMethodDef PyvtkDICOMUIDGeneratorInitializer_vtkDICOMUIDGeneratorInitializer_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static const char *PyvtkDICOMUIDGeneratorInitializer_Doc =

  "vtkDICOMUIDGeneratorInitializer() -> vtkDICOMUIDGeneratorInitializer\nC++: vtkDICOMUIDGeneratorInitializer()\n""\n"
  "vtkDICOMUIDGeneratorInitializer - @cond\n\n"
  "Initializer (Schwarz counter).\n\n"
  "This ensures that the vtkDICOMUIDGenerator module is initialized\n"
  "before any other module that includes this header file.\n\n";

static PyObject *
PyvtkDICOMUIDGeneratorInitializer_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMUIDGeneratorInitializer_vtkDICOMUIDGeneratorInitializer(nullptr, args);
}

static void PyvtkDICOMUIDGeneratorInitializer_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMUIDGeneratorInitializer *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDICOMUIDGeneratorInitializer_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMUIDGeneratorInitializer_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMUIDGeneratorInitializer", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMUIDGeneratorInitializer_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMUIDGeneratorInitializer_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMUIDGeneratorInitializer_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMUIDGeneratorInitializer_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

#ifndef DECLARED_PyvtkDICOMUIDGeneratorInitializer_TypeNew
extern "C" { PyObject *PyvtkDICOMUIDGeneratorInitializer_TypeNew(); }
#define DECLARED_PyvtkDICOMUIDGeneratorInitializer_TypeNew
#endif

PyObject *PyvtkDICOMUIDGeneratorInitializer_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMUIDGeneratorInitializer_Type,
    PyvtkDICOMUIDGeneratorInitializer_Methods,
    PyvtkDICOMUIDGeneratorInitializer_vtkDICOMUIDGeneratorInitializer_Methods,
    nullptr);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMUIDGenerator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMUIDGenerator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMUIDGenerator", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyvtkDICOMUIDGeneratorInitializer_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMUIDGeneratorInitializer", o) != 0)
  {
    Py_DECREF(o);
  }

}

