// python wrapper for vtkDICOMUtilities
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMUtilities.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMUtilities(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMUtilities_ClassNew(); }


static PyObject *
PyvtkDICOMUtilities_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMUtilities::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUtilities *op = static_cast<vtkDICOMUtilities *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMUtilities::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMUtilities *tempr = vtkDICOMUtilities::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUtilities *op = static_cast<vtkDICOMUtilities *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMUtilities *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMUtilities::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMUtilities::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUtilities *op = static_cast<vtkDICOMUtilities *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMUtilities::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_SetUIDPrefix(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SetUIDPrefix");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMUtilities::SetUIDPrefix(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GetUIDPrefix(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetUIDPrefix");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    const char *tempr = vtkDICOMUtilities::GetUIDPrefix();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GenerateUID(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GenerateUID");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    std::string tempr = vtkDICOMUtilities::GenerateUID(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GenerateUIDs(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GenerateUIDs");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkStringArray *temp1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag") &&
      ap.GetVTKObject(temp1, "vtkStringArray"))
  {
    vtkDICOMUtilities::GenerateUIDs(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMUtilities_CompareUIDs(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "CompareUIDs");

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = vtkDICOMUtilities::CompareUIDs(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GenerateDateTime_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GenerateDateTime");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = vtkDICOMUtilities::GenerateDateTime(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMUtilities_GenerateDateTime_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GenerateDateTime");

  long long temp0;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    std::string tempr = vtkDICOMUtilities::GenerateDateTime(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMUtilities_GenerateDateTime(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return PyvtkDICOMUtilities_GenerateDateTime_s1(self, args);
    case 2:
      return PyvtkDICOMUtilities_GenerateDateTime_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GenerateDateTime");
  return nullptr;
}


static PyObject *
PyvtkDICOMUtilities_ConvertDateTime(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "ConvertDateTime");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMUtilities::ConvertDateTime(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GetUniversalTime(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetUniversalTime");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    long long tempr = vtkDICOMUtilities::GetUniversalTime();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GetUTC(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetUTC");

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<long long> store0(2*size0);
  long long *temp0 = store0.Data();
  long long *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    long long tempr = vtkDICOMUtilities::GetUTC(temp0);

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_IsDICOMFile(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsDICOMFile");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = vtkDICOMUtilities::IsDICOMFile(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GetImplementationClassUID(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetImplementationClassUID");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    const char *tempr = vtkDICOMUtilities::GetImplementationClassUID();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_SetImplementationClassUID(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SetImplementationClassUID");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMUtilities::SetImplementationClassUID(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GetImplementationVersionName(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetImplementationVersionName");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    const char *tempr = vtkDICOMUtilities::GetImplementationVersionName();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_SetImplementationVersionName(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SetImplementationVersionName");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMUtilities::SetImplementationVersionName(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_UnpackUnsignedInt(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "UnpackUnsignedInt");

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<unsigned char> store0(size0);
  unsigned char *temp0 = store0.Data();
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    unsigned int tempr = vtkDICOMUtilities::UnpackUnsignedInt(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_PackUnsignedInt(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "PackUnsignedInt");

  unsigned int temp0;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<unsigned char> store1(2*size1);
  unsigned char *temp1 = store1.Data();
  unsigned char *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    vtkDICOMUtilities::PackUnsignedInt(temp0, temp1);

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_PatternMatches_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "PatternMatches");

  const char *temp0 = nullptr;
  const char *temp1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = vtkDICOMUtilities::PatternMatches(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMUtilities_PatternMatches_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "PatternMatches");

  const char *temp0 = nullptr;
  size_t temp1;
  const char *temp2 = nullptr;
  size_t temp3;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    bool tempr = vtkDICOMUtilities::PatternMatches(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMUtilities_PatternMatches(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return PyvtkDICOMUtilities_PatternMatches_s1(self, args);
    case 4:
      return PyvtkDICOMUtilities_PatternMatches_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "PatternMatches");
  return nullptr;
}


static PyObject *
PyvtkDICOMUtilities_IsValidUTF8(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsValidUTF8");

  const char *temp0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = vtkDICOMUtilities::IsValidUTF8(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GetUIDName(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetUIDName");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = vtkDICOMUtilities::GetUIDName(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMUtilities_GetCIDFromUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCIDFromUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMUtilities *op = static_cast<vtkDICOMUtilities *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned short tempr = (ap.IsBound() ?
      op->GetCIDFromUID(temp0) :
      op->vtkDICOMUtilities::GetCIDFromUID(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMUtilities_Methods[] = {
  {"IsTypeOf", PyvtkDICOMUtilities_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nVTK dynamic type information macro.\n"},
  {"IsA", PyvtkDICOMUtilities_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nVTK dynamic type information macro.\n"},
  {"SafeDownCast", PyvtkDICOMUtilities_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMUtilities\nC++: static vtkDICOMUtilities *SafeDownCast(vtkObjectBase *o)\n\nVTK dynamic type information macro.\n"},
  {"NewInstance", PyvtkDICOMUtilities_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMUtilities\nC++: vtkDICOMUtilities *NewInstance()\n\nVTK dynamic type information macro.\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMUtilities_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nVTK dynamic type information macro.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMUtilities_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nVTK dynamic type information macro.\n"},
  {"SetUIDPrefix", PyvtkDICOMUtilities_SetUIDPrefix, METH_VARARGS,
   "SetUIDPrefix(prefix:str) -> None\nC++: static void SetUIDPrefix(const char *prefix)\n\nSet a UID prefix to use when generating UIDs.\n\nThis is optional, if you do not own a UID prefix then the\npublicly available 2.25 prefix will be used.\n"},
  {"GetUIDPrefix", PyvtkDICOMUtilities_GetUIDPrefix, METH_VARARGS,
   "GetUIDPrefix() -> str\nC++: static const char *GetUIDPrefix()\n\nSet a UID prefix to use when generating UIDs.\n\nThis is optional, if you do not own a UID prefix then the\npublicly available 2.25 prefix will be used.\n"},
  {"GenerateUID", PyvtkDICOMUtilities_GenerateUID, METH_VARARGS,
   "GenerateUID(tag:vtkDICOMTag) -> str\nC++: static std::string GenerateUID(vtkDICOMTag tag)\n\nGenerate a UID for the provided tag.\n"},
  {"GenerateUIDs", PyvtkDICOMUtilities_GenerateUIDs, METH_VARARGS,
   "GenerateUIDs(tag:vtkDICOMTag, uids:vtkStringArray) -> None\nC++: static void GenerateUIDs(vtkDICOMTag tag,\n    vtkStringArray *uids)\n\nGenerate a series of UIDs, sorted from low to high.\n\nBefore passing the string array, call SetNumberOfValues() on the\narray to specify the number of UIDs that you want to be stored in\nit.  The stored UIDs will be sorted, low to high. Generating a\nbatch of UIDs is more efficient than calling GenerateUID()\nrepeatedly.\n"},
  {"CompareUIDs", PyvtkDICOMUtilities_CompareUIDs, METH_VARARGS,
   "CompareUIDs(u1:str, u2:str) -> int\nC++: static int CompareUIDs(const char *u1, const char *u2)\n\nNumerically compare two UIDs, returns -1, 0, or +1.\n"},
  {"GenerateDateTime", PyvtkDICOMUtilities_GenerateDateTime, METH_VARARGS,
   "GenerateDateTime(zone:str) -> str\nC++: static std::string GenerateDateTime(const char *zone)\nGenerateDateTime(microsecs:int, zone:str) -> str\nC++: static std::string GenerateDateTime(long long microsecs,\n    const char *zone)\n\nGenerate a DICOM date time string in the given timezone.\n\nThe time zone is to be given in the DICOM format of +HHMM or\n-HHMM where HH is the hour offset and MM is the minute offset. \nIf no time zone is given, then local time is used (according to\nthe computer's time zone preferences).\n"},
  {"ConvertDateTime", PyvtkDICOMUtilities_ConvertDateTime, METH_VARARGS,
   "ConvertDateTime(datetime:str) -> int\nC++: static long long ConvertDateTime(const char *datetime)\n\nConvert a DICOM data time string into a long integer.\n\nGiven a DICOM date time string, generate a long integer that\ncounts microseconds since the UNIX epoch (00:00:00 UTC on 1 Jan\n1970). If the datetime string contains a timezone offset, then\nthat timezone is used to convert the time to UTC.  Otherwise, the\nlocal timezone (according to the computer's timezone preferences)\nis used to convert the time to UTC.  The return value is always\nintended to be interpreted as a UTC time.\n"},
  {"GetUniversalTime", PyvtkDICOMUtilities_GetUniversalTime, METH_VARARGS,
   "GetUniversalTime() -> int\nC++: static long long GetUniversalTime()\n\nGet the current time in microseconds.\n\nThe time is in microseconds since the UNIX epoch (00:00:00 UTC on\n1 Jan 1970).\n"},
  {"GetUTC", PyvtkDICOMUtilities_GetUTC, METH_VARARGS,
   "GetUTC(offset:[int, ...]) -> int\nC++: static long long GetUTC(long long *offset)\n\nDeprecated method, do not use.\n"},
  {"IsDICOMFile", PyvtkDICOMUtilities_IsDICOMFile, METH_VARARGS,
   "IsDICOMFile(filename:str) -> bool\nC++: static bool IsDICOMFile(const char *filename)\n\nCheck if the specified file is a DICOM file.\n\nThis will return true if the file exists, is readable, and if it\nhas the DICM magic number or if the first few bytes of the file\nlook like DICOM data elements.\n"},
  {"GetImplementationClassUID", PyvtkDICOMUtilities_GetImplementationClassUID, METH_VARARGS,
   "GetImplementationClassUID() -> str\nC++: static const char *GetImplementationClassUID()\n\nGet the UID for this DICOM implementation.\n"},
  {"SetImplementationClassUID", PyvtkDICOMUtilities_SetImplementationClassUID, METH_VARARGS,
   "SetImplementationClassUID(uid:str) -> None\nC++: static void SetImplementationClassUID(const char *uid)\n\nSet the UID for this DICOM implementation.\n\nThe supplied UID will be copied into a static storage area, and\nused for all future calls to GetImplementationClassUID. The\nImplementationClassUID appears in the DICOM meta header.\n"},
  {"GetImplementationVersionName", PyvtkDICOMUtilities_GetImplementationVersionName, METH_VARARGS,
   "GetImplementationVersionName() -> str\nC++: static const char *GetImplementationVersionName()\n\nGet the versioned name for this DICOM implementation.\n"},
  {"SetImplementationVersionName", PyvtkDICOMUtilities_SetImplementationVersionName, METH_VARARGS,
   "SetImplementationVersionName(name:str) -> None\nC++: static void SetImplementationVersionName(const char *name)\n\nSet the versioned name for this DICOM implementation.\n\nThe supplied name will be copied into a static storage area, and\nused for all future calls to GetImplementationVersionName. The\nImplementationVersionName appears in the DICOM meta header.\n"},
  {"UnpackUnsignedInt", PyvtkDICOMUtilities_UnpackUnsignedInt, METH_VARARGS,
   "UnpackUnsignedInt(cp:(int, ...)) -> int\nC++: static unsigned int UnpackUnsignedInt(\n    const unsigned char *cp)\n\nUnpack one little-endian int from a stream of bytes.\n\nThis is a very common operation that is required in many\ndifferent classes, so the code is centralized here.\n"},
  {"PackUnsignedInt", PyvtkDICOMUtilities_PackUnsignedInt, METH_VARARGS,
   "PackUnsignedInt(i:int, cp:[int, ...]) -> None\nC++: static void PackUnsignedInt(unsigned int i,\n    unsigned char *cp)\n\nPack one little-endian int into a stream of bytes.\n\nThis is a very common operation that is required in many\ndifferent classes, so the code is centralized here.\n"},
  {"PatternMatches", PyvtkDICOMUtilities_PatternMatches, METH_VARARGS,
   "PatternMatches(pattern:str, val:str) -> bool\nC++: static bool PatternMatches(const char *pattern,\n    const char *val)\nPatternMatches(pattern:str, pl:int, val:str, vl:int) -> bool\nC++: static bool PatternMatches(const char *pattern, size_t pl,\n    const char *val, size_t vl)\n\nReturn true if the pattern matches the given string (utf-8).\n\nThis performs simple matching with \"*\" and \"?\" as the only\nwildcard. The input must either be ASCII or utf-8, and if it is\nutf-8, then matching will be done codepoint by codepoint.\n"},
  {"IsValidUTF8", PyvtkDICOMUtilities_IsValidUTF8, METH_VARARGS,
   "IsValidUTF8(text:str, l:int) -> bool\nC++: static bool IsValidUTF8(const char *text, size_t l)\n\nCheck that a string is valid utf-8.\n\nThe string is valid if it contains no NULL bytes and if it\ncontains only valid 1-byte, 2-byte, 3-byte, or 4-byte utf-8\nsequences.  Any overlength sequences or sequences that encode\nvalues above U+10FFFF or between U+D800 and U+DFFF are considered\ninvalid.\n"},
  {"GetUIDName", PyvtkDICOMUtilities_GetUIDName, METH_VARARGS,
   "GetUIDName(uid:str) -> str\nC++: static const char *GetUIDName(const char *uid)\n\nGet the name associated with the given UID.\n"},
  {"GetCIDFromUID", PyvtkDICOMUtilities_GetCIDFromUID, METH_VARARGS,
   "GetCIDFromUID(self, uid:str) -> int\nC++: unsigned short GetCIDFromUID(const char *uid)\n\nGet the CID from the UID.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMUtilities_Doc =
  "vtkDICOMUtilities - Utility functions for use with DICOM classes.\n\n"
  "Superclass: vtkObject\n\n"
;

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMUtilities_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMUtilities", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMUtilities_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMUtilities_StaticNew()
{
  return vtkDICOMUtilities::New();
}

PyObject *PyvtkDICOMUtilities_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMUtilities_Type, PyvtkDICOMUtilities_Methods,
    "vtkDICOMUtilities",
 &PyvtkDICOMUtilities_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMUtilities(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMUtilities_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMUtilities", o) != 0)
  {
    Py_DECREF(o);
  }

}

