// python wrapper for vtkDICOMVM
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMVM.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMVM(PyObject *dict); }
#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMVM_EnumType_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMVM.EnumType", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMVM_EnumType_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMVM_EnumType_Type, static_cast<int>(val));
}


static PyObject *
PyvtkDICOMVM_IsValid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsValid");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVM *op = static_cast<vtkDICOMVM *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsValid();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVM_GetMin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMin");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVM *op = static_cast<vtkDICOMVM *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetMin();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVM_GetMax(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMax");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVM *op = static_cast<vtkDICOMVM *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetMax();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMVM_GetStep(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStep");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMVM *op = static_cast<vtkDICOMVM *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetStep();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMVM_Methods[] = {
  {"IsValid", PyvtkDICOMVM_IsValid, METH_VARARGS,
   "IsValid(self) -> bool\nC++: bool IsValid()\n\nCheck validity of this VM.\n"},
  {"GetMin", PyvtkDICOMVM_GetMin, METH_VARARGS,
   "GetMin(self) -> int\nC++: int GetMin()\n\nGet the minimum allowed number of values\n"},
  {"GetMax", PyvtkDICOMVM_GetMax, METH_VARARGS,
   "GetMax(self) -> int\nC++: int GetMax()\n\nGet the maximum allowed number of values, -1 if unlimited\n"},
  {"GetStep", PyvtkDICOMVM_GetStep, METH_VARARGS,
   "GetStep(self) -> int\nC++: int GetStep()\n\nGet the step between allowed values.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMVM_vtkDICOMVM_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMVM");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMVM *op = new vtkDICOMVM();

    result = PyVTKSpecialObject_New("vtkDICOMVM", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMVM_vtkDICOMVM_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMVM");

  typedef vtkDICOMVM::EnumType temp0_type;
  temp0_type temp0;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetEnumValue(temp0, "vtkDICOMVM.EnumType"))
  {
    vtkDICOMVM *op = new vtkDICOMVM(temp0);

    result = PyVTKSpecialObject_New("vtkDICOMVM", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMVM_vtkDICOMVM_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMVM");

  vtkDICOMVM *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVM"))
  {
    vtkDICOMVM *op = new vtkDICOMVM(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMVM", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMVM_vtkDICOMVM_Methods[] = {
  {"vtkDICOMVM", PyvtkDICOMVM_vtkDICOMVM_s2, METH_VARARGS,
   "@E vtkDICOMVM.EnumType"},
  {"vtkDICOMVM", PyvtkDICOMVM_vtkDICOMVM_s3, METH_VARARGS,
   "@W vtkDICOMVM"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMVM_vtkDICOMVM(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMVM_vtkDICOMVM_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMVM_vtkDICOMVM_s1(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMVM");
  return nullptr;
}


static const char *PyvtkDICOMVM_Doc =

  "vtkDICOMVM() -> vtkDICOMVM\nC++: vtkDICOMVM()\nvtkDICOMVM(vm:EnumType) -> vtkDICOMVM\nC++: vtkDICOMVM(EnumType vm)\nvtkDICOMVM(__a:vtkDICOMVM) -> vtkDICOMVM\nC++: vtkDICOMVM(const &vtkDICOMVM)\n""\n"
  "vtkDICOMVM - VMs (Value Multiplicities)\n\n"
;

static PyObject *
PyvtkDICOMVM_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMVM_vtkDICOMVM(nullptr, args);
}

static void PyvtkDICOMVM_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMVM *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkDICOMVM_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkDICOMVM *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyUnicode_FromStringAndSize(s.data(), s.size());
}

static int PyvtkDICOMVM_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMVM_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMVM *so1 = nullptr;
  const vtkDICOMVM *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMVM_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMVM *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMVM *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMVM", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMVM_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMVM *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMVM *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMVM", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      result = ((*so1) < (*so2));
      break;
    case Py_LE:
      result = ((*so1) <= (*so2));
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      result = ((*so1) > (*so2));
      break;
    case Py_GE:
      result = ((*so1) >= (*so2));
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMVM_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMVM_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMVM", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMVM_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMVM_Hash, // tp_hash
  nullptr, // tp_call
  PyvtkDICOMVM_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMVM_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMVM_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMVM_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMVM_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMVM_Type);
}

static void *PyvtkDICOMVM_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMVM(*static_cast<const vtkDICOMVM*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMVM_TypeNew
extern "C" { PyObject *PyvtkDICOMVM_TypeNew(); }
#define DECLARED_PyvtkDICOMVM_TypeNew
#endif

PyObject *PyvtkDICOMVM_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMVM_Type,
    PyvtkDICOMVM_Methods,
    PyvtkDICOMVM_vtkDICOMVM_Methods,
    &PyvtkDICOMVM_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkDICOMVM_EnumType_Type);
  PyVTKEnum_Add(&PyvtkDICOMVM_EnumType_Type, "vtkDICOMVM.EnumType");

  o = (PyObject *)&PyvtkDICOMVM_EnumType_Type;
  if (PyDict_SetItemString(d, "EnumType", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 407; c++)
  {
    typedef vtkDICOMVM::EnumType cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[407] = {
        { "M0", vtkDICOMVM::M0 },
        { "M0T1", vtkDICOMVM::M0T1 },
        { "M0T2", vtkDICOMVM::M0T2 },
        { "M0T3", vtkDICOMVM::M0T3 },
        { "M0T4", vtkDICOMVM::M0T4 },
        { "M0T5", vtkDICOMVM::M0T5 },
        { "M0T6", vtkDICOMVM::M0T6 },
        { "M0T7", vtkDICOMVM::M0T7 },
        { "M0T8", vtkDICOMVM::M0T8 },
        { "M0T9", vtkDICOMVM::M0T9 },
        { "M0T10", vtkDICOMVM::M0T10 },
        { "M0T11", vtkDICOMVM::M0T11 },
        { "M0T12", vtkDICOMVM::M0T12 },
        { "M0T13", vtkDICOMVM::M0T13 },
        { "M0T14", vtkDICOMVM::M0T14 },
        { "M0T15", vtkDICOMVM::M0T15 },
        { "M0T16", vtkDICOMVM::M0T16 },
        { "M0T17", vtkDICOMVM::M0T17 },
        { "M0T18", vtkDICOMVM::M0T18 },
        { "M0T19", vtkDICOMVM::M0T19 },
        { "M0T20", vtkDICOMVM::M0T20 },
        { "M0T21", vtkDICOMVM::M0T21 },
        { "M0T22", vtkDICOMVM::M0T22 },
        { "M0T23", vtkDICOMVM::M0T23 },
        { "M0T24", vtkDICOMVM::M0T24 },
        { "M0T25", vtkDICOMVM::M0T25 },
        { "M0T26", vtkDICOMVM::M0T26 },
        { "M0T27", vtkDICOMVM::M0T27 },
        { "M0T28", vtkDICOMVM::M0T28 },
        { "M0T29", vtkDICOMVM::M0T29 },
        { "M0T30", vtkDICOMVM::M0T30 },
        { "M0T31", vtkDICOMVM::M0T31 },
        { "M0T32", vtkDICOMVM::M0T32 },
        { "M0T63", vtkDICOMVM::M0T63 },
        { "M0T64", vtkDICOMVM::M0T64 },
        { "M0T99", vtkDICOMVM::M0T99 },
        { "M0T4N", vtkDICOMVM::M0T4N },
        { "M0T3N", vtkDICOMVM::M0T3N },
        { "M0T2N", vtkDICOMVM::M0T2N },
        { "M0TN", vtkDICOMVM::M0TN },
        { "M1", vtkDICOMVM::M1 },
        { "M1T2", vtkDICOMVM::M1T2 },
        { "M1T3", vtkDICOMVM::M1T3 },
        { "M1T4", vtkDICOMVM::M1T4 },
        { "M1T5", vtkDICOMVM::M1T5 },
        { "M1T6", vtkDICOMVM::M1T6 },
        { "M1T7", vtkDICOMVM::M1T7 },
        { "M1T8", vtkDICOMVM::M1T8 },
        { "M1T9", vtkDICOMVM::M1T9 },
        { "M1T10", vtkDICOMVM::M1T10 },
        { "M1T11", vtkDICOMVM::M1T11 },
        { "M1T12", vtkDICOMVM::M1T12 },
        { "M1T13", vtkDICOMVM::M1T13 },
        { "M1T14", vtkDICOMVM::M1T14 },
        { "M1T15", vtkDICOMVM::M1T15 },
        { "M1T16", vtkDICOMVM::M1T16 },
        { "M1T17", vtkDICOMVM::M1T17 },
        { "M1T18", vtkDICOMVM::M1T18 },
        { "M1T19", vtkDICOMVM::M1T19 },
        { "M1T20", vtkDICOMVM::M1T20 },
        { "M1T21", vtkDICOMVM::M1T21 },
        { "M1T22", vtkDICOMVM::M1T22 },
        { "M1T23", vtkDICOMVM::M1T23 },
        { "M1T24", vtkDICOMVM::M1T24 },
        { "M1T25", vtkDICOMVM::M1T25 },
        { "M1T26", vtkDICOMVM::M1T26 },
        { "M1T27", vtkDICOMVM::M1T27 },
        { "M1T28", vtkDICOMVM::M1T28 },
        { "M1T29", vtkDICOMVM::M1T29 },
        { "M1T30", vtkDICOMVM::M1T30 },
        { "M1T31", vtkDICOMVM::M1T31 },
        { "M1T32", vtkDICOMVM::M1T32 },
        { "M1T63", vtkDICOMVM::M1T63 },
        { "M1T64", vtkDICOMVM::M1T64 },
        { "M1T99", vtkDICOMVM::M1T99 },
        { "M1TN", vtkDICOMVM::M1TN },
        { "M2", vtkDICOMVM::M2 },
        { "M2T3", vtkDICOMVM::M2T3 },
        { "M2T4", vtkDICOMVM::M2T4 },
        { "M2T5", vtkDICOMVM::M2T5 },
        { "M2T6", vtkDICOMVM::M2T6 },
        { "M2T7", vtkDICOMVM::M2T7 },
        { "M2T8", vtkDICOMVM::M2T8 },
        { "M2T9", vtkDICOMVM::M2T9 },
        { "M2T10", vtkDICOMVM::M2T10 },
        { "M2T11", vtkDICOMVM::M2T11 },
        { "M2T12", vtkDICOMVM::M2T12 },
        { "M2T13", vtkDICOMVM::M2T13 },
        { "M2T14", vtkDICOMVM::M2T14 },
        { "M2T15", vtkDICOMVM::M2T15 },
        { "M2T16", vtkDICOMVM::M2T16 },
        { "M2T17", vtkDICOMVM::M2T17 },
        { "M2T18", vtkDICOMVM::M2T18 },
        { "M2T19", vtkDICOMVM::M2T19 },
        { "M2T20", vtkDICOMVM::M2T20 },
        { "M2T21", vtkDICOMVM::M2T21 },
        { "M2T22", vtkDICOMVM::M2T22 },
        { "M2T23", vtkDICOMVM::M2T23 },
        { "M2T24", vtkDICOMVM::M2T24 },
        { "M2T25", vtkDICOMVM::M2T25 },
        { "M2T26", vtkDICOMVM::M2T26 },
        { "M2T27", vtkDICOMVM::M2T27 },
        { "M2T28", vtkDICOMVM::M2T28 },
        { "M2T29", vtkDICOMVM::M2T29 },
        { "M2T30", vtkDICOMVM::M2T30 },
        { "M2T31", vtkDICOMVM::M2T31 },
        { "M2T32", vtkDICOMVM::M2T32 },
        { "M2T63", vtkDICOMVM::M2T63 },
        { "M2T64", vtkDICOMVM::M2T64 },
        { "M2T99", vtkDICOMVM::M2T99 },
        { "M2T2N", vtkDICOMVM::M2T2N },
        { "M2TN", vtkDICOMVM::M2TN },
        { "M3", vtkDICOMVM::M3 },
        { "M3T4", vtkDICOMVM::M3T4 },
        { "M3T5", vtkDICOMVM::M3T5 },
        { "M3T6", vtkDICOMVM::M3T6 },
        { "M3T7", vtkDICOMVM::M3T7 },
        { "M3T8", vtkDICOMVM::M3T8 },
        { "M3T9", vtkDICOMVM::M3T9 },
        { "M3T10", vtkDICOMVM::M3T10 },
        { "M3T11", vtkDICOMVM::M3T11 },
        { "M3T12", vtkDICOMVM::M3T12 },
        { "M3T13", vtkDICOMVM::M3T13 },
        { "M3T14", vtkDICOMVM::M3T14 },
        { "M3T15", vtkDICOMVM::M3T15 },
        { "M3T16", vtkDICOMVM::M3T16 },
        { "M3T17", vtkDICOMVM::M3T17 },
        { "M3T18", vtkDICOMVM::M3T18 },
        { "M3T19", vtkDICOMVM::M3T19 },
        { "M3T20", vtkDICOMVM::M3T20 },
        { "M3T21", vtkDICOMVM::M3T21 },
        { "M3T22", vtkDICOMVM::M3T22 },
        { "M3T23", vtkDICOMVM::M3T23 },
        { "M3T24", vtkDICOMVM::M3T24 },
        { "M3T25", vtkDICOMVM::M3T25 },
        { "M3T26", vtkDICOMVM::M3T26 },
        { "M3T27", vtkDICOMVM::M3T27 },
        { "M3T28", vtkDICOMVM::M3T28 },
        { "M3T29", vtkDICOMVM::M3T29 },
        { "M3T30", vtkDICOMVM::M3T30 },
        { "M3T31", vtkDICOMVM::M3T31 },
        { "M3T32", vtkDICOMVM::M3T32 },
        { "M3T63", vtkDICOMVM::M3T63 },
        { "M3T64", vtkDICOMVM::M3T64 },
        { "M3T99", vtkDICOMVM::M3T99 },
        { "M3T3N", vtkDICOMVM::M3T3N },
        { "M3TN", vtkDICOMVM::M3TN },
        { "M4", vtkDICOMVM::M4 },
        { "M4T5", vtkDICOMVM::M4T5 },
        { "M4T6", vtkDICOMVM::M4T6 },
        { "M4T7", vtkDICOMVM::M4T7 },
        { "M4T8", vtkDICOMVM::M4T8 },
        { "M4T9", vtkDICOMVM::M4T9 },
        { "M4T10", vtkDICOMVM::M4T10 },
        { "M4T11", vtkDICOMVM::M4T11 },
        { "M4T12", vtkDICOMVM::M4T12 },
        { "M4T13", vtkDICOMVM::M4T13 },
        { "M4T14", vtkDICOMVM::M4T14 },
        { "M4T15", vtkDICOMVM::M4T15 },
        { "M4T16", vtkDICOMVM::M4T16 },
        { "M4T17", vtkDICOMVM::M4T17 },
        { "M4T18", vtkDICOMVM::M4T18 },
        { "M4T19", vtkDICOMVM::M4T19 },
        { "M4T20", vtkDICOMVM::M4T20 },
        { "M4T21", vtkDICOMVM::M4T21 },
        { "M4T22", vtkDICOMVM::M4T22 },
        { "M4T23", vtkDICOMVM::M4T23 },
        { "M4T24", vtkDICOMVM::M4T24 },
        { "M4T25", vtkDICOMVM::M4T25 },
        { "M4T26", vtkDICOMVM::M4T26 },
        { "M4T27", vtkDICOMVM::M4T27 },
        { "M4T28", vtkDICOMVM::M4T28 },
        { "M4T29", vtkDICOMVM::M4T29 },
        { "M4T30", vtkDICOMVM::M4T30 },
        { "M4T31", vtkDICOMVM::M4T31 },
        { "M4T32", vtkDICOMVM::M4T32 },
        { "M4T63", vtkDICOMVM::M4T63 },
        { "M4T64", vtkDICOMVM::M4T64 },
        { "M4T99", vtkDICOMVM::M4T99 },
        { "M4T4N", vtkDICOMVM::M4T4N },
        { "M4TN", vtkDICOMVM::M4TN },
        { "M5", vtkDICOMVM::M5 },
        { "M5T6", vtkDICOMVM::M5T6 },
        { "M5T7", vtkDICOMVM::M5T7 },
        { "M5T8", vtkDICOMVM::M5T8 },
        { "M5T9", vtkDICOMVM::M5T9 },
        { "M5T10", vtkDICOMVM::M5T10 },
        { "M5T11", vtkDICOMVM::M5T11 },
        { "M5T12", vtkDICOMVM::M5T12 },
        { "M5T13", vtkDICOMVM::M5T13 },
        { "M5T14", vtkDICOMVM::M5T14 },
        { "M5T15", vtkDICOMVM::M5T15 },
        { "M5T16", vtkDICOMVM::M5T16 },
        { "M5T17", vtkDICOMVM::M5T17 },
        { "M5T18", vtkDICOMVM::M5T18 },
        { "M5T19", vtkDICOMVM::M5T19 },
        { "M5T20", vtkDICOMVM::M5T20 },
        { "M5T21", vtkDICOMVM::M5T21 },
        { "M5T22", vtkDICOMVM::M5T22 },
        { "M5T23", vtkDICOMVM::M5T23 },
        { "M5T24", vtkDICOMVM::M5T24 },
        { "M5T25", vtkDICOMVM::M5T25 },
        { "M5T26", vtkDICOMVM::M5T26 },
        { "M5T27", vtkDICOMVM::M5T27 },
        { "M5T28", vtkDICOMVM::M5T28 },
        { "M5T29", vtkDICOMVM::M5T29 },
        { "M5T30", vtkDICOMVM::M5T30 },
        { "M5T31", vtkDICOMVM::M5T31 },
        { "M5T32", vtkDICOMVM::M5T32 },
        { "M5T63", vtkDICOMVM::M5T63 },
        { "M5T64", vtkDICOMVM::M5T64 },
        { "M5T99", vtkDICOMVM::M5T99 },
        { "M5T5N", vtkDICOMVM::M5T5N },
        { "M5TN", vtkDICOMVM::M5TN },
        { "M6", vtkDICOMVM::M6 },
        { "M6T7", vtkDICOMVM::M6T7 },
        { "M6T8", vtkDICOMVM::M6T8 },
        { "M6T9", vtkDICOMVM::M6T9 },
        { "M6T10", vtkDICOMVM::M6T10 },
        { "M6T11", vtkDICOMVM::M6T11 },
        { "M6T12", vtkDICOMVM::M6T12 },
        { "M6T13", vtkDICOMVM::M6T13 },
        { "M6T14", vtkDICOMVM::M6T14 },
        { "M6T15", vtkDICOMVM::M6T15 },
        { "M6T16", vtkDICOMVM::M6T16 },
        { "M6T17", vtkDICOMVM::M6T17 },
        { "M6T18", vtkDICOMVM::M6T18 },
        { "M6T19", vtkDICOMVM::M6T19 },
        { "M6T20", vtkDICOMVM::M6T20 },
        { "M6T21", vtkDICOMVM::M6T21 },
        { "M6T22", vtkDICOMVM::M6T22 },
        { "M6T23", vtkDICOMVM::M6T23 },
        { "M6T24", vtkDICOMVM::M6T24 },
        { "M6T25", vtkDICOMVM::M6T25 },
        { "M6T26", vtkDICOMVM::M6T26 },
        { "M6T27", vtkDICOMVM::M6T27 },
        { "M6T28", vtkDICOMVM::M6T28 },
        { "M6T29", vtkDICOMVM::M6T29 },
        { "M6T30", vtkDICOMVM::M6T30 },
        { "M6T31", vtkDICOMVM::M6T31 },
        { "M6T32", vtkDICOMVM::M6T32 },
        { "M6T63", vtkDICOMVM::M6T63 },
        { "M6T64", vtkDICOMVM::M6T64 },
        { "M6T99", vtkDICOMVM::M6T99 },
        { "M6T6N", vtkDICOMVM::M6T6N },
        { "M6TN", vtkDICOMVM::M6TN },
        { "M7", vtkDICOMVM::M7 },
        { "M7T8", vtkDICOMVM::M7T8 },
        { "M7T9", vtkDICOMVM::M7T9 },
        { "M7T10", vtkDICOMVM::M7T10 },
        { "M7T11", vtkDICOMVM::M7T11 },
        { "M7T12", vtkDICOMVM::M7T12 },
        { "M7T13", vtkDICOMVM::M7T13 },
        { "M7T14", vtkDICOMVM::M7T14 },
        { "M7T15", vtkDICOMVM::M7T15 },
        { "M7T16", vtkDICOMVM::M7T16 },
        { "M7T17", vtkDICOMVM::M7T17 },
        { "M7T18", vtkDICOMVM::M7T18 },
        { "M7T19", vtkDICOMVM::M7T19 },
        { "M7T20", vtkDICOMVM::M7T20 },
        { "M7T21", vtkDICOMVM::M7T21 },
        { "M7T22", vtkDICOMVM::M7T22 },
        { "M7T23", vtkDICOMVM::M7T23 },
        { "M7T24", vtkDICOMVM::M7T24 },
        { "M7T25", vtkDICOMVM::M7T25 },
        { "M7T26", vtkDICOMVM::M7T26 },
        { "M7T27", vtkDICOMVM::M7T27 },
        { "M7T28", vtkDICOMVM::M7T28 },
        { "M7T29", vtkDICOMVM::M7T29 },
        { "M7T30", vtkDICOMVM::M7T30 },
        { "M7T31", vtkDICOMVM::M7T31 },
        { "M7T32", vtkDICOMVM::M7T32 },
        { "M7T63", vtkDICOMVM::M7T63 },
        { "M7T64", vtkDICOMVM::M7T64 },
        { "M7T99", vtkDICOMVM::M7T99 },
        { "M7T7N", vtkDICOMVM::M7T7N },
        { "M7TN", vtkDICOMVM::M7TN },
        { "M8", vtkDICOMVM::M8 },
        { "M8T9", vtkDICOMVM::M8T9 },
        { "M8T10", vtkDICOMVM::M8T10 },
        { "M8T11", vtkDICOMVM::M8T11 },
        { "M8T12", vtkDICOMVM::M8T12 },
        { "M8T13", vtkDICOMVM::M8T13 },
        { "M8T14", vtkDICOMVM::M8T14 },
        { "M8T15", vtkDICOMVM::M8T15 },
        { "M8T16", vtkDICOMVM::M8T16 },
        { "M8T17", vtkDICOMVM::M8T17 },
        { "M8T18", vtkDICOMVM::M8T18 },
        { "M8T19", vtkDICOMVM::M8T19 },
        { "M8T20", vtkDICOMVM::M8T20 },
        { "M8T21", vtkDICOMVM::M8T21 },
        { "M8T22", vtkDICOMVM::M8T22 },
        { "M8T23", vtkDICOMVM::M8T23 },
        { "M8T24", vtkDICOMVM::M8T24 },
        { "M8T25", vtkDICOMVM::M8T25 },
        { "M8T26", vtkDICOMVM::M8T26 },
        { "M8T27", vtkDICOMVM::M8T27 },
        { "M8T28", vtkDICOMVM::M8T28 },
        { "M8T29", vtkDICOMVM::M8T29 },
        { "M8T30", vtkDICOMVM::M8T30 },
        { "M8T31", vtkDICOMVM::M8T31 },
        { "M8T32", vtkDICOMVM::M8T32 },
        { "M8T63", vtkDICOMVM::M8T63 },
        { "M8T64", vtkDICOMVM::M8T64 },
        { "M8T99", vtkDICOMVM::M8T99 },
        { "M8T8N", vtkDICOMVM::M8T8N },
        { "M8TN", vtkDICOMVM::M8TN },
        { "M9", vtkDICOMVM::M9 },
        { "M9T10", vtkDICOMVM::M9T10 },
        { "M9T11", vtkDICOMVM::M9T11 },
        { "M9T12", vtkDICOMVM::M9T12 },
        { "M9T13", vtkDICOMVM::M9T13 },
        { "M9T14", vtkDICOMVM::M9T14 },
        { "M9T15", vtkDICOMVM::M9T15 },
        { "M9T16", vtkDICOMVM::M9T16 },
        { "M9T17", vtkDICOMVM::M9T17 },
        { "M9T18", vtkDICOMVM::M9T18 },
        { "M9T19", vtkDICOMVM::M9T19 },
        { "M9T20", vtkDICOMVM::M9T20 },
        { "M9T21", vtkDICOMVM::M9T21 },
        { "M9T22", vtkDICOMVM::M9T22 },
        { "M9T23", vtkDICOMVM::M9T23 },
        { "M9T24", vtkDICOMVM::M9T24 },
        { "M9T25", vtkDICOMVM::M9T25 },
        { "M9T26", vtkDICOMVM::M9T26 },
        { "M9T27", vtkDICOMVM::M9T27 },
        { "M9T28", vtkDICOMVM::M9T28 },
        { "M9T29", vtkDICOMVM::M9T29 },
        { "M9T30", vtkDICOMVM::M9T30 },
        { "M9T31", vtkDICOMVM::M9T31 },
        { "M9T32", vtkDICOMVM::M9T32 },
        { "M9T63", vtkDICOMVM::M9T63 },
        { "M9T64", vtkDICOMVM::M9T64 },
        { "M9T99", vtkDICOMVM::M9T99 },
        { "M9T9N", vtkDICOMVM::M9T9N },
        { "M9TN", vtkDICOMVM::M9TN },
        { "M10", vtkDICOMVM::M10 },
        { "M10TN", vtkDICOMVM::M10TN },
        { "M11", vtkDICOMVM::M11 },
        { "M11TN", vtkDICOMVM::M11TN },
        { "M12", vtkDICOMVM::M12 },
        { "M12TN", vtkDICOMVM::M12TN },
        { "M13", vtkDICOMVM::M13 },
        { "M13TN", vtkDICOMVM::M13TN },
        { "M14", vtkDICOMVM::M14 },
        { "M14TN", vtkDICOMVM::M14TN },
        { "M15", vtkDICOMVM::M15 },
        { "M15TN", vtkDICOMVM::M15TN },
        { "M16", vtkDICOMVM::M16 },
        { "M16TN", vtkDICOMVM::M16TN },
        { "M17", vtkDICOMVM::M17 },
        { "M17TN", vtkDICOMVM::M17TN },
        { "M18", vtkDICOMVM::M18 },
        { "M18TN", vtkDICOMVM::M18TN },
        { "M19", vtkDICOMVM::M19 },
        { "M19TN", vtkDICOMVM::M19TN },
        { "M20", vtkDICOMVM::M20 },
        { "M20TN", vtkDICOMVM::M20TN },
        { "M21", vtkDICOMVM::M21 },
        { "M21TN", vtkDICOMVM::M21TN },
        { "M22", vtkDICOMVM::M22 },
        { "M22TN", vtkDICOMVM::M22TN },
        { "M23", vtkDICOMVM::M23 },
        { "M23TN", vtkDICOMVM::M23TN },
        { "M24", vtkDICOMVM::M24 },
        { "M24TN", vtkDICOMVM::M24TN },
        { "M25", vtkDICOMVM::M25 },
        { "M25TN", vtkDICOMVM::M25TN },
        { "M26", vtkDICOMVM::M26 },
        { "M26TN", vtkDICOMVM::M26TN },
        { "M27", vtkDICOMVM::M27 },
        { "M27TN", vtkDICOMVM::M27TN },
        { "M28", vtkDICOMVM::M28 },
        { "M28TN", vtkDICOMVM::M28TN },
        { "M29", vtkDICOMVM::M29 },
        { "M29TN", vtkDICOMVM::M29TN },
        { "M30", vtkDICOMVM::M30 },
        { "M30TN", vtkDICOMVM::M30TN },
        { "M30T30N", vtkDICOMVM::M30T30N },
        { "M31", vtkDICOMVM::M31 },
        { "M31TN", vtkDICOMVM::M31TN },
        { "M32", vtkDICOMVM::M32 },
        { "M32TN", vtkDICOMVM::M32TN },
        { "M35", vtkDICOMVM::M35 },
        { "M35TN", vtkDICOMVM::M35TN },
        { "M47", vtkDICOMVM::M47 },
        { "M47TN", vtkDICOMVM::M47TN },
        { "M47T47N", vtkDICOMVM::M47T47N },
        { "M63", vtkDICOMVM::M63 },
        { "M63TN", vtkDICOMVM::M63TN },
        { "M64", vtkDICOMVM::M64 },
        { "M64TN", vtkDICOMVM::M64TN },
        { "M99", vtkDICOMVM::M99 },
        { "M99TN", vtkDICOMVM::M99TN },
        { "M100", vtkDICOMVM::M100 },
        { "M110", vtkDICOMVM::M110 },
        { "M127", vtkDICOMVM::M127 },
        { "M128", vtkDICOMVM::M128 },
        { "M255", vtkDICOMVM::M255 },
        { "M256", vtkDICOMVM::M256 },
        { "M511", vtkDICOMVM::M511 },
        { "M512", vtkDICOMVM::M512 },
        { "M768", vtkDICOMVM::M768 },
        { "M1024", vtkDICOMVM::M1024 },
        { "M2048", vtkDICOMVM::M2048 },
        { "M4096", vtkDICOMVM::M4096 },
        { "M8192", vtkDICOMVM::M8192 },
      };

    o = PyvtkDICOMVM_EnumType_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMVM(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMVM_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMVM", o) != 0)
  {
    Py_DECREF(o);
  }

}

