// python wrapper for vtkDICOMValue
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMVR.h"
#include "vtkDICOMTag.h"
#include "vtkDICOMCharacterSet.h"
#include "vtkDICOMValue.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMValue(PyObject *dict); }

static PyObject *
PyvtkDICOMValue_FromUTF8String(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "FromUTF8String");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMCharacterSet *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(3) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMCharacterSet") &&
      ap.GetValue(temp2))
  {
    vtkDICOMValue tempr = vtkDICOMValue::FromUTF8String(*temp0, *temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMValue");
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}


static PyObject *
PyvtkDICOMValue_Clear(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Clear");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    op->Clear();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_IsValid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsValid");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsValid();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetVR(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVR");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMVR tempr = op->GetVR();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMVR");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetVL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVL");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = op->GetVL();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetCharacterSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCharacterSet");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMCharacterSet tempr = op->GetCharacterSet();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMCharacterSet");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetNumberOfValues(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfValues");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    size_t tempr = op->GetNumberOfValues();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetValues_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValues");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<int> store0(2*size0);
  int *temp0 = store0.Data();
  int *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  size_t temp1;
  size_t temp2 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    op->GetValues(temp0, temp1, temp2);

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMValue_GetValues_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValues");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<long long> store0(2*size0);
  long long *temp0 = store0.Data();
  long long *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  size_t temp1;
  size_t temp2 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    op->GetValues(temp0, temp1, temp2);

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMValue_GetValues_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValues");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? nullptr : temp0 + size0);
  size_t temp1;
  size_t temp2 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    vtkPythonArgs::Save(temp0, save0, size0);

    op->GetValues(temp0, temp1, temp2);

    if (vtkPythonArgs::HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMValue_GetValues_Methods[] = {
  {"GetValues", PyvtkDICOMValue_GetValues_s1, METH_VARARGS,
   "@PK|K *i"},
  {"GetValues", PyvtkDICOMValue_GetValues_s2, METH_VARARGS,
   "@PK|K *k"},
  {"GetValues", PyvtkDICOMValue_GetValues_s3, METH_VARARGS,
   "@PK|K *d"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMValue_GetValues(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMValue_GetValues_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetValues");
  return nullptr;
}


static PyObject *
PyvtkDICOMValue_GetUTF8String(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUTF8String");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = op->GetUTF8String(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetString");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = op->GetString(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetUnsignedChar(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnsignedChar");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned char tempr = op->GetUnsignedChar(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetShort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShort");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    short tempr = op->GetShort(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetUnsignedShort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnsignedShort");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned short tempr = op->GetUnsignedShort(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetInt(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInt");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = op->GetInt(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetUnsignedInt(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnsignedInt");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned int tempr = op->GetUnsignedInt(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetInt64(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInt64");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = op->GetInt64(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetUnsignedInt64(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnsignedInt64");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned long long tempr = op->GetUnsignedInt64(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetFloat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFloat");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    float tempr = op->GetFloat(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetDouble(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDouble");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double tempr = op->GetDouble(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetTag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTag");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDICOMTag tempr = op->GetTag(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetItem");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const vtkDICOMItem *tempr = &op->GetItem(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMItem");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsUTF8String(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsUTF8String");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = op->AsUTF8String();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsString");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = op->AsString();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsUnsignedChar(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsUnsignedChar");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned char tempr = op->AsUnsignedChar();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsShort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsShort");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    short tempr = op->AsShort();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsUnsignedShort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsUnsignedShort");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned short tempr = op->AsUnsignedShort();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsInt(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsInt");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->AsInt();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsUnsignedInt(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsUnsignedInt");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = op->AsUnsignedInt();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsInt64(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsInt64");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    long long tempr = op->AsInt64();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsUnsignedInt64(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsUnsignedInt64");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long long tempr = op->AsUnsignedInt64();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsFloat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsFloat");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = op->AsFloat();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsDouble(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsDouble");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = op->AsDouble();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsTag(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsTag");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMTag tempr = op->AsTag();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkDICOMTag");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AsItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AsItem");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const vtkDICOMItem *tempr = &op->AsItem();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(tempr, "vtkDICOMItem");
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetCharData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCharData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = op->GetCharData();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetUnsignedCharData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnsignedCharData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const unsigned char *tempr = op->GetUnsignedCharData();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetShortData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShortData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const short *tempr = op->GetShortData();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetUnsignedShortData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnsignedShortData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const unsigned short *tempr = op->GetUnsignedShortData();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetIntData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIntData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const int *tempr = op->GetIntData();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetUnsignedIntData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnsignedIntData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const unsigned int *tempr = op->GetUnsignedIntData();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetInt64Data(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInt64Data");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const long long *tempr = op->GetInt64Data();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetUnsignedInt64Data(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUnsignedInt64Data");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const unsigned long long *tempr = op->GetUnsignedInt64Data();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetFloatData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFloatData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const float *tempr = op->GetFloatData();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_GetDoubleData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDoubleData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const double *tempr = op->GetDoubleData();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AllocateCharData_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateCharData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    char *tempr = op->AllocateCharData(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_AllocateCharData_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateCharData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMCharacterSet *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  size_t temp2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMCharacterSet") &&
      ap.GetValue(temp2))
  {
    char *tempr = op->AllocateCharData(*temp0, *temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMValue_AllocateCharData(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return PyvtkDICOMValue_AllocateCharData_s1(self, args);
    case 3:
      return PyvtkDICOMValue_AllocateCharData_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "AllocateCharData");
  return nullptr;
}


static PyObject *
PyvtkDICOMValue_AllocateUnsignedCharData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateUnsignedCharData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    unsigned char *tempr = op->AllocateUnsignedCharData(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMValue_AllocateShortData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateShortData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    short *tempr = op->AllocateShortData(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMValue_AllocateUnsignedShortData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateUnsignedShortData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    unsigned short *tempr = op->AllocateUnsignedShortData(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMValue_AllocateIntData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateIntData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    int *tempr = op->AllocateIntData(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMValue_AllocateUnsignedIntData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateUnsignedIntData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    unsigned int *tempr = op->AllocateUnsignedIntData(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMValue_AllocateInt64Data(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateInt64Data");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    long long *tempr = op->AllocateInt64Data(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMValue_AllocateUnsignedInt64Data(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateUnsignedInt64Data");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    unsigned long long *tempr = op->AllocateUnsignedInt64Data(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMValue_AllocateFloatData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateFloatData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    float *tempr = op->AllocateFloatData(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMValue_AllocateDoubleData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AllocateDoubleData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    double *tempr = op->AllocateDoubleData(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkDICOMValue_ComputeNumberOfValuesForCharData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ComputeNumberOfValuesForCharData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    op->ComputeNumberOfValuesForCharData();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_ReallocateUnsignedCharData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReallocateUnsignedCharData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  size_t temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned char *tempr = op->ReallocateUnsignedCharData(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AppendValueToUTF8String(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AppendValueToUTF8String");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  std::string temp0;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    op->AppendValueToUTF8String(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(0, temp0);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AppendValueToSafeUTF8String(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AppendValueToSafeUTF8String");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  std::string temp0;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    op->AppendValueToSafeUTF8String(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(0, temp0);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_AppendValueToString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AppendValueToString");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  std::string temp0;
  size_t temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    op->AppendValueToString(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(0, temp0);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMValue_Matches_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Matches");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  vtkDICOMValue *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMValue"))
  {
    bool tempr = op->Matches(*temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_Matches_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Matches");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = op->Matches(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDICOMValue_Matches_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Matches");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkDICOMValue *op = static_cast<vtkDICOMValue *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = op->Matches(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMValue_Matches_Methods[] = {
  {"Matches", PyvtkDICOMValue_Matches_s1, METH_VARARGS,
   "@W vtkDICOMValue"},
  {"Matches", PyvtkDICOMValue_Matches_s2, METH_VARARGS,
   "@s"},
  {"Matches", PyvtkDICOMValue_Matches_s3, METH_VARARGS,
   "@d"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMValue_Matches(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMValue_Matches_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Matches");
  return nullptr;
}

static PyMethodDef PyvtkDICOMValue_Methods[] = {
  {"FromUTF8String", PyvtkDICOMValue_FromUTF8String, METH_VARARGS,
   "FromUTF8String(vr:vtkDICOMVR, cs:vtkDICOMCharacterSet, v:str)\n    -> vtkDICOMValue\nC++: static vtkDICOMValue FromUTF8String(vtkDICOMVR vr,\n    vtkDICOMCharacterSet cs, const std::string &v)\n\nCreate a value from a UTF8-encoded string.\n\nThis will convert a UTF-8 string to the target encoding and store\nthe result in a new value.  If the target encoding is ISO 2022,\nthen escape codes will be added before and after delimiters as\nnecessary (the delimiters are 'backslash' for multi-valued VRs,\nand '^', '=' for PN).\n"},
  {"Clear", PyvtkDICOMValue_Clear, METH_VARARGS,
   "Clear(self) -> None\nC++: void Clear()\n\nClear the value, the result is an invalid value.\n"},
  {"IsValid", PyvtkDICOMValue_IsValid, METH_VARARGS,
   "IsValid(self) -> bool\nC++: bool IsValid()\n\nCheck whether this value is valid, i.e. contains data.\n"},
  {"GetVR", PyvtkDICOMValue_GetVR, METH_VARARGS,
   "GetVR(self) -> vtkDICOMVR\nC++: vtkDICOMVR GetVR()\n\nGet the VR, the representation of the data values.\n"},
  {"GetVL", PyvtkDICOMValue_GetVL, METH_VARARGS,
   "GetVL(self) -> int\nC++: unsigned int GetVL()\n\nGet the VL, the length of the data in bytes (will always be\neven).\n"},
  {"GetCharacterSet", PyvtkDICOMValue_GetCharacterSet, METH_VARARGS,
   "GetCharacterSet(self) -> vtkDICOMCharacterSet\nC++: vtkDICOMCharacterSet GetCharacterSet()\n\nGet the character set for a text value.\n\nString values are stored with their original encoding, as given\nby the SpecificCharacterSet attribute of the data set that they\nbelong to.  This only applies to VRs of PN, SH, LO, ST, LT, and\nUT. All other string values are always stored as plain ASCII with\nno control characters.\n"},
  {"GetNumberOfValues", PyvtkDICOMValue_GetNumberOfValues, METH_VARARGS,
   "GetNumberOfValues(self) -> int\nC++: size_t GetNumberOfValues()\n\nGet the value multiplicity.\n\nThe number of values has different interpretations for for\ndifferent VRs:\n- for backslash-delimited text (AE, AS, CS, DA, DS, DT, IS, LO,\n  PN, SH, UI) it is the number of backslash-separated values.\n- for other text (LT, ST, UT) the number of values is always 1.\n- for binary numerical data (FL, FD, SS, US, SL, UL, OF, OW, OB)\n  the number of binary values will be returned.\n- for UN, the number of bytes will be returned.\n- for attribute tags (VR is AT) the number of tags will be\n  returned.\n- for sequences (SQ) the number of items in the sequence,\n  excluding any delimiters, will be returned.\n"},
  {"GetValues", PyvtkDICOMValue_GetValues, METH_VARARGS,
   "GetValues(self, vb:[int, ...], n:int, i:int=0) -> None\nC++: void GetValues(int *vb, size_t n, size_t i=0)\nGetValues(self, vb:[int, ...], n:int, i:int=0) -> None\nC++: void GetValues(long long *vb, size_t n, size_t i=0)\nGetValues(self, vb:[float, ...], n:int, i:int=0) -> None\nC++: void GetValues(double *vb, size_t n, size_t i=0)\n\nCopy \"n\" values into vb, starting at value \"i\".\n\nGet one or more values, doing conversion from the stored type to\nthe requested type.  If the VR is IS or DS (integer string or\ndecimal string) then conversion from text to a numerical value\nwill be performed.\n"},
  {"GetUTF8String", PyvtkDICOMValue_GetUTF8String, METH_VARARGS,
   "GetUTF8String(self, i:int) -> str\nC++: std::string GetUTF8String(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetString", PyvtkDICOMValue_GetString, METH_VARARGS,
   "GetString(self, i:int) -> str\nC++: std::string GetString(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetUnsignedChar", PyvtkDICOMValue_GetUnsignedChar, METH_VARARGS,
   "GetUnsignedChar(self, i:int) -> int\nC++: unsigned char GetUnsignedChar(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetShort", PyvtkDICOMValue_GetShort, METH_VARARGS,
   "GetShort(self, i:int) -> int\nC++: short GetShort(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetUnsignedShort", PyvtkDICOMValue_GetUnsignedShort, METH_VARARGS,
   "GetUnsignedShort(self, i:int) -> int\nC++: unsigned short GetUnsignedShort(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetInt", PyvtkDICOMValue_GetInt, METH_VARARGS,
   "GetInt(self, i:int) -> int\nC++: int GetInt(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetUnsignedInt", PyvtkDICOMValue_GetUnsignedInt, METH_VARARGS,
   "GetUnsignedInt(self, i:int) -> int\nC++: unsigned int GetUnsignedInt(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetInt64", PyvtkDICOMValue_GetInt64, METH_VARARGS,
   "GetInt64(self, i:int) -> int\nC++: long long GetInt64(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetUnsignedInt64", PyvtkDICOMValue_GetUnsignedInt64, METH_VARARGS,
   "GetUnsignedInt64(self, i:int) -> int\nC++: unsigned long long GetUnsignedInt64(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetFloat", PyvtkDICOMValue_GetFloat, METH_VARARGS,
   "GetFloat(self, i:int) -> float\nC++: float GetFloat(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetDouble", PyvtkDICOMValue_GetDouble, METH_VARARGS,
   "GetDouble(self, i:int) -> float\nC++: double GetDouble(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetTag", PyvtkDICOMValue_GetTag, METH_VARARGS,
   "GetTag(self, i:int) -> vtkDICOMTag\nC++: vtkDICOMTag GetTag(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"GetItem", PyvtkDICOMValue_GetItem, METH_VARARGS,
   "GetItem(self, i:int) -> vtkDICOMItem\nC++: const vtkDICOMItem &GetItem(size_t i)\n\nGet one scalar, string, tag or item from the value.\n\nConvert the i'th value to the desired type, if possible, and\nreturn it.  If the value is invalid, or conversion is not\npossible, or the index is out of range, then the return value\nwill be zero (or an empty string).  Trailing spaces are always\nremoved from strings. Leading spaces are removed unless the VR is\nST, LT, or UT.\n"},
  {"AsUTF8String", PyvtkDICOMValue_AsUTF8String, METH_VARARGS,
   "AsUTF8String(self) -> str\nC++: std::string AsUTF8String()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsString", PyvtkDICOMValue_AsString, METH_VARARGS,
   "AsString(self) -> str\nC++: std::string AsString()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsUnsignedChar", PyvtkDICOMValue_AsUnsignedChar, METH_VARARGS,
   "AsUnsignedChar(self) -> int\nC++: unsigned char AsUnsignedChar()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsShort", PyvtkDICOMValue_AsShort, METH_VARARGS,
   "AsShort(self) -> int\nC++: short AsShort()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsUnsignedShort", PyvtkDICOMValue_AsUnsignedShort, METH_VARARGS,
   "AsUnsignedShort(self) -> int\nC++: unsigned short AsUnsignedShort()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsInt", PyvtkDICOMValue_AsInt, METH_VARARGS,
   "AsInt(self) -> int\nC++: int AsInt()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsUnsignedInt", PyvtkDICOMValue_AsUnsignedInt, METH_VARARGS,
   "AsUnsignedInt(self) -> int\nC++: unsigned int AsUnsignedInt()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsInt64", PyvtkDICOMValue_AsInt64, METH_VARARGS,
   "AsInt64(self) -> int\nC++: long long AsInt64()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsUnsignedInt64", PyvtkDICOMValue_AsUnsignedInt64, METH_VARARGS,
   "AsUnsignedInt64(self) -> int\nC++: unsigned long long AsUnsignedInt64()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsFloat", PyvtkDICOMValue_AsFloat, METH_VARARGS,
   "AsFloat(self) -> float\nC++: float AsFloat()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsDouble", PyvtkDICOMValue_AsDouble, METH_VARARGS,
   "AsDouble(self) -> float\nC++: double AsDouble()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsTag", PyvtkDICOMValue_AsTag, METH_VARARGS,
   "AsTag(self) -> vtkDICOMTag\nC++: vtkDICOMTag AsTag()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"AsItem", PyvtkDICOMValue_AsItem, METH_VARARGS,
   "AsItem(self) -> vtkDICOMItem\nC++: const vtkDICOMItem &AsItem()\n\nGet the value as a scalar, string, tag, or item.\n\nThe value is converted to the desired type, if possible, and\nreturned. Otherwise the return value is zero (or an empty\nstring).  Conversion to string always produces an empty string\nfor values of type UN, SQ, OB, OW, and OF.  Trailing spaces are\nalways removed from strings. Leading spaces are removed unless\nthe VR is ST, LT, or UT.\n"},
  {"GetCharData", PyvtkDICOMValue_GetCharData, METH_VARARGS,
   "GetCharData(self) -> str\nC++: const char *GetCharData()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"GetUnsignedCharData", PyvtkDICOMValue_GetUnsignedCharData, METH_VARARGS,
   "GetUnsignedCharData(self) -> Pointer\nC++: const unsigned char *GetUnsignedCharData()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"GetShortData", PyvtkDICOMValue_GetShortData, METH_VARARGS,
   "GetShortData(self) -> Pointer\nC++: const short *GetShortData()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"GetUnsignedShortData", PyvtkDICOMValue_GetUnsignedShortData, METH_VARARGS,
   "GetUnsignedShortData(self) -> Pointer\nC++: const unsigned short *GetUnsignedShortData()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"GetIntData", PyvtkDICOMValue_GetIntData, METH_VARARGS,
   "GetIntData(self) -> Pointer\nC++: const int *GetIntData()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"GetUnsignedIntData", PyvtkDICOMValue_GetUnsignedIntData, METH_VARARGS,
   "GetUnsignedIntData(self) -> Pointer\nC++: const unsigned int *GetUnsignedIntData()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"GetInt64Data", PyvtkDICOMValue_GetInt64Data, METH_VARARGS,
   "GetInt64Data(self) -> Pointer\nC++: const long long *GetInt64Data()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"GetUnsignedInt64Data", PyvtkDICOMValue_GetUnsignedInt64Data, METH_VARARGS,
   "GetUnsignedInt64Data(self) -> Pointer\nC++: const unsigned long long *GetUnsignedInt64Data()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"GetFloatData", PyvtkDICOMValue_GetFloatData, METH_VARARGS,
   "GetFloatData(self) -> Pointer\nC++: const float *GetFloatData()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"GetDoubleData", PyvtkDICOMValue_GetDoubleData, METH_VARARGS,
   "GetDoubleData(self) -> Pointer\nC++: const double *GetDoubleData()\n\nGet a pointer to the internal data array.\n\nGetCharData will return a null-terminated string if VR is AE, AS,\nCS, DA, DS, DT, IS, LO, LT, PN, SH, ST, TM, UI, UT, with a\npossible trailing space if the VR is not UI (UID). The other\nmethods will return a valid pointer if the the requested pointer\ntype matches the VR.  To compute the size of the array, divide VL\nby the size of the requested type. Do not use NumberOfValues as\nthe array size, because for many VRs the array size is much\nlarger than the NumberOfValues, in fact for OB, OF, UT, and many\nother VRs the entire array counts as a single value, according to\nthe DICOM standard. Returns NULL if the requested pointer type\ndoes not match the VR.\n"},
  {"AllocateCharData", PyvtkDICOMValue_AllocateCharData, METH_VARARGS,
   "AllocateCharData(self, vr:vtkDICOMVR, vn:int) -> str\nC++: char *AllocateCharData(vtkDICOMVR vr, size_t vn)\nAllocateCharData(self, vr:vtkDICOMVR, cs:vtkDICOMCharacterSet,\n    vn:int) -> str\nC++: char *AllocateCharData(vtkDICOMVR vr,\n    vtkDICOMCharacterSet cs, size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"AllocateUnsignedCharData", PyvtkDICOMValue_AllocateUnsignedCharData, METH_VARARGS,
   "AllocateUnsignedCharData(self, vr:vtkDICOMVR, vn:int) -> Pointer\nC++: unsigned char *AllocateUnsignedCharData(vtkDICOMVR vr,\n    size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"AllocateShortData", PyvtkDICOMValue_AllocateShortData, METH_VARARGS,
   "AllocateShortData(self, vr:vtkDICOMVR, vn:int) -> Pointer\nC++: short *AllocateShortData(vtkDICOMVR vr, size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"AllocateUnsignedShortData", PyvtkDICOMValue_AllocateUnsignedShortData, METH_VARARGS,
   "AllocateUnsignedShortData(self, vr:vtkDICOMVR, vn:int) -> Pointer\nC++: unsigned short *AllocateUnsignedShortData(vtkDICOMVR vr,\n    size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"AllocateIntData", PyvtkDICOMValue_AllocateIntData, METH_VARARGS,
   "AllocateIntData(self, vr:vtkDICOMVR, vn:int) -> Pointer\nC++: int *AllocateIntData(vtkDICOMVR vr, size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"AllocateUnsignedIntData", PyvtkDICOMValue_AllocateUnsignedIntData, METH_VARARGS,
   "AllocateUnsignedIntData(self, vr:vtkDICOMVR, vn:int) -> Pointer\nC++: unsigned int *AllocateUnsignedIntData(vtkDICOMVR vr,\n    size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"AllocateInt64Data", PyvtkDICOMValue_AllocateInt64Data, METH_VARARGS,
   "AllocateInt64Data(self, vr:vtkDICOMVR, vn:int) -> Pointer\nC++: long long *AllocateInt64Data(vtkDICOMVR vr, size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"AllocateUnsignedInt64Data", PyvtkDICOMValue_AllocateUnsignedInt64Data, METH_VARARGS,
   "AllocateUnsignedInt64Data(self, vr:vtkDICOMVR, vn:int) -> Pointer\nC++: unsigned long long *AllocateUnsignedInt64Data(vtkDICOMVR vr,\n    size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"AllocateFloatData", PyvtkDICOMValue_AllocateFloatData, METH_VARARGS,
   "AllocateFloatData(self, vr:vtkDICOMVR, vn:int) -> Pointer\nC++: float *AllocateFloatData(vtkDICOMVR vr, size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"AllocateDoubleData", PyvtkDICOMValue_AllocateDoubleData, METH_VARARGS,
   "AllocateDoubleData(self, vr:vtkDICOMVR, vn:int) -> Pointer\nC++: double *AllocateDoubleData(vtkDICOMVR vr, size_t vn)\n\nAllocate space within a value object.\n\nAllocate an array of the specified size (number of elements)\nwithin the value object.  This method will not do any checks to\nensure that the data type matches the VR.  It is meant to be an\nefficient way for the parser to allocate a value so that the\nvalue's contents can be read in directly from a file.\n"},
  {"ComputeNumberOfValuesForCharData", PyvtkDICOMValue_ComputeNumberOfValuesForCharData, METH_VARARGS,
   "ComputeNumberOfValuesForCharData(self) -> None\nC++: void ComputeNumberOfValuesForCharData()\n\nCompute the number of backslash-separated string values.\n\nAfter calling AllocateCharData and writing text into the\nallocated space, this must be called to set the NumberOfValues\naccording to the number of backslash-separated string values that\nare present.\n"},
  {"ReallocateUnsignedCharData", PyvtkDICOMValue_ReallocateUnsignedCharData, METH_VARARGS,
   "ReallocateUnsignedCharData(self, vn:int) -> Pointer\nC++: unsigned char *ReallocateUnsignedCharData(size_t vn)\n\nReallocate data of type OB or UN.\n\nValues of type OB or UN can hold encapsulated data.  When\nbuilding these values, it is useful to be able to extend the\ninternal data as needed.  After this method is called, the\nNumberOfValues will be vn, and the VL will be 0xffffffff.\n"},
  {"AppendValueToUTF8String", PyvtkDICOMValue_AppendValueToUTF8String, METH_VARARGS,
   "AppendValueToUTF8String(self, str:str, i:int) -> None\nC++: void AppendValueToUTF8String(std::string &str, size_t i)\n\nAppend value \"i\" to the supplied UTF8 string.\n"},
  {"AppendValueToSafeUTF8String", PyvtkDICOMValue_AppendValueToSafeUTF8String, METH_VARARGS,
   "AppendValueToSafeUTF8String(self, str:str, i:int) -> None\nC++: void AppendValueToSafeUTF8String(std::string &str, size_t i)\n\nAppend value \"i\" to the supplied UTF8 string for safe printing.\n"},
  {"AppendValueToString", PyvtkDICOMValue_AppendValueToString, METH_VARARGS,
   "AppendValueToString(self, str:str, i:int) -> None\nC++: void AppendValueToString(std::string &str, size_t i)\n\nAppend value \"i\" to the supplied string.\n\nThis will convert the value to human-readable format. Be cautious\nwhen using this method for an element with VR equal to ST, LT, or\nUT, because the resulting string might be very long, and might\ncontain special (i.e. non-printable) characters.\n"},
  {"Matches", PyvtkDICOMValue_Matches, METH_VARARGS,
   "Matches(self, value:vtkDICOMValue) -> bool\nC++: bool Matches(const vtkDICOMValue &value)\nMatches(self, v:str) -> bool\nC++: bool Matches(const std::string &v)\nMatches(self, v:float) -> bool\nC++: bool Matches(double v)\n\nCheck if the value matches the specified find query value.\n\nThis method is used during \"find\" requests, according to the\nrules of DICOM Part 4 C.2.2.2 Attribute Matching.  The standard\nwildcards \"*\" and \"?\" are supported, as well as numeric ranges\n(for times and dates) through the use of two values separated by\n\"-\".  Matches are case sensitive, except when the VR is PN.  If\nthe value has multiplicity, then the match will succeed if any of\nthe values match.\n"},
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  double temp1;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, temp1);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  std::string temp1;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, temp1);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s3(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMTag *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMTag"))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, *temp1);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s4(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMItem *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMItem"))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, *temp1);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s5(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  const char *temp1 = nullptr;
  size_t temp2;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(3) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, temp1, temp2);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s6(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<int> store1(size1);
  int *temp1 = store1.Data();
  size_t temp2;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(3) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetArray(temp1, size1) &&
      ap.GetValue(temp2))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, temp1, temp2);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s7(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<long long> store1(size1);
  long long *temp1 = store1.Data();
  size_t temp2;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(3) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetArray(temp1, size1) &&
      ap.GetValue(temp2))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, temp1, temp2);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s8(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<double> store1(size1);
  double *temp1 = store1.Data();
  size_t temp2;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(3) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetArray(temp1, size1) &&
      ap.GetValue(temp2))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, temp1, temp2);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s9(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMCharacterSet *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  std::string temp2;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(3) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMCharacterSet") &&
      ap.GetValue(temp2))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, *temp1, temp2);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s10(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  vtkDICOMCharacterSet *temp1 = nullptr;
  PyObject *pobj1 = nullptr;
  const char *temp2 = nullptr;
  size_t temp3;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(4) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR") &&
      ap.GetSpecialObject(temp1, pobj1, "vtkDICOMCharacterSet") &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0, *temp1, temp2, temp3);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);
  Py_XDECREF(pobj1);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s11(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMVR *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMVR"))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s12(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMValue *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMValue"))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s13(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMTag *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMTag"))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s14(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMItem *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMItem"))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s15(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  vtkDICOMSequence *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMSequence"))
  {
    vtkDICOMValue *op = new vtkDICOMValue(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyObject *
PyvtkDICOMValue_vtkDICOMValue_s16(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValue");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMValue *op = new vtkDICOMValue();

    result = PyVTKSpecialObject_New("vtkDICOMValue", op);
  }

  return result;
}

static PyMethodDef PyvtkDICOMValue_vtkDICOMValue_Methods[] = {
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s1, METH_VARARGS,
   "@Wd vtkDICOMVR"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s2, METH_VARARGS,
   "@Ws vtkDICOMVR"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s3, METH_VARARGS,
   "@WW vtkDICOMVR vtkDICOMTag"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s4, METH_VARARGS,
   "@WW vtkDICOMVR vtkDICOMItem"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s5, METH_VARARGS,
   "@WzK vtkDICOMVR"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s6, METH_VARARGS,
   "@WPK vtkDICOMVR *i"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s7, METH_VARARGS,
   "@WPK vtkDICOMVR *k"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s8, METH_VARARGS,
   "@WPK vtkDICOMVR *d"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s9, METH_VARARGS,
   "@WWs vtkDICOMVR vtkDICOMCharacterSet"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s11, METH_VARARGS,
   "-@W vtkDICOMVR"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s12, METH_VARARGS,
   "@W vtkDICOMValue"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s13, METH_VARARGS,
   "@W vtkDICOMTag"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s14, METH_VARARGS,
   "@W vtkDICOMItem"},
  {"vtkDICOMValue", PyvtkDICOMValue_vtkDICOMValue_s15, METH_VARARGS,
   "@W vtkDICOMSequence"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMValue_vtkDICOMValue(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDICOMValue_vtkDICOMValue_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 4:
      return PyvtkDICOMValue_vtkDICOMValue_s10(self, args);
    case 0:
      return PyvtkDICOMValue_vtkDICOMValue_s16(self, args);
    case 1:
    case 2:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMValue");
  return nullptr;
}


static const char *PyvtkDICOMValue_Doc =

  "vtkDICOMValue(vr:vtkDICOMVR, v:float) -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, double v)\nvtkDICOMValue(vr:vtkDICOMVR, v:str) -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, const std::string &v)\nvtkDICOMValue(vr:vtkDICOMVR, v:vtkDICOMTag) -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, vtkDICOMTag v)\nvtkDICOMValue(vr:vtkDICOMVR, v:vtkDICOMItem) -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, const vtkDICOMItem &v)\nvtkDICOMValue(vr:vtkDICOMVR, data:str, count:int) -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, const char *data, size_t count)\nvtkDICOMValue(vr:vtkDICOMVR, data:(int, ...), count:int)\n    -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, const int *data, size_t count)\nvtkDICOMValue(vr:vtkDICOMVR, data:(int, ...), count:int)\n    -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, const long long *data, size_t count)\nvtkDICOMValue(vr:vtkDICOMVR, data:(float, ...), count:int)\n    -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, const double *data, size_t count)\nvtkDICOMValue(vr:vtkDICOMVR, cs:vtkDICOMCharacterSet, v:str)\n    -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, vtkDICOMCharacterSet cs,\n    const std::string &v)\nvtkDICOMValue(vr:vtkDICOMVR, cs:vtkDICOMCharacterSet, data:str, l:int)\n     -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMVR vr, vtkDICOMCharacterSet cs,\n    const char *data, size_t l)\nvtkDICOMValue(vr:vtkDICOMVR) -> vtkDICOMValue\nC++: explicit vtkDICOMValue(vtkDICOMVR vr)\nvtkDICOMValue(v:vtkDICOMValue) -> vtkDICOMValue\nC++: vtkDICOMValue(const vtkDICOMValue &v)\nvtkDICOMValue(v:vtkDICOMTag) -> vtkDICOMValue\nC++: vtkDICOMValue(vtkDICOMTag v)\nvtkDICOMValue(v:vtkDICOMItem) -> vtkDICOMValue\nC++: vtkDICOMValue(const vtkDICOMItem &v)\nvtkDICOMValue(v:vtkDICOMSequence) -> vtkDICOMValue\nC++: vtkDICOMValue(const vtkDICOMSequence &v)\nvtkDICOMValue() -> vtkDICOMValue\nC++: vtkDICOMValue()\n""\n"
  "vtkDICOMValue - A class to store attribute values for DICOM metadata.\n\n"
  "The vtkDICOMValue class is a container for any values that can be\n"
  "stored in a DICOM data element.  Like std::string, it is implemented\n"
  "as a pointer to a reference-counted internal data object.  To keep it\n"
  "lightweight, in terms of size, it has no virtual methods.\n\n";

static PyObject *
PyvtkDICOMValue_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMValue_vtkDICOMValue(nullptr, args);
}

static void PyvtkDICOMValue_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMValue *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkDICOMValue_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkDICOMValue *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyUnicode_FromStringAndSize(s.data(), s.size());
}

static int PyvtkDICOMValue_CheckExact(PyObject *ob);

static PyObject *PyvtkDICOMValue_RichCompare(
  PyObject *o1, PyObject *o2, int opid)
{
  PyObject *n1 = nullptr;
  PyObject *n2 = nullptr;
  const vtkDICOMValue *so1 = nullptr;
  const vtkDICOMValue *so2 = nullptr;
  int result = -1;

  if (PyvtkDICOMValue_CheckExact(o1))
  {
    PyVTKSpecialObject *s1 = (PyVTKSpecialObject *)o1;
    so1 = static_cast<const vtkDICOMValue *>(s1->vtk_ptr);
  }
  else
  {
    so1 = static_cast<const vtkDICOMValue *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o1, "vtkDICOMValue", &n1));
    if (so1 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  if (PyvtkDICOMValue_CheckExact(o2))
  {
    PyVTKSpecialObject *s2 = (PyVTKSpecialObject *)o2;
    so2 = static_cast<const vtkDICOMValue *>(s2->vtk_ptr);
  }
  else
  {
    so2 = static_cast<const vtkDICOMValue *>(
      vtkPythonUtil::GetPointerFromSpecialObject(
        o2, "vtkDICOMValue", &n2));
    if (so2 == nullptr)
    {
      PyErr_Clear();
      Py_INCREF(Py_NotImplemented);
      return Py_NotImplemented;
    }
  }

  switch (opid)
  {
    case Py_LT:
      break;
    case Py_LE:
      break;
    case Py_EQ:
      result = ((*so1) == (*so2));
      break;
    case Py_NE:
      result = ((*so1) != (*so2));
      break;
    case Py_GT:
      break;
    case Py_GE:
      break;
  }

  if (n1)
  {
    Py_DECREF(n1);
  }
  else if (n2)
  {
    Py_DECREF(n2);
  }

  if (result == -1)
  {
    PyErr_SetString(PyExc_TypeError, "operation not available");
    return nullptr;
  }

  // avoids aliasing issues with Py_INCREF(Py_False)
  return PyBool_FromLong((long)result);
}

static Py_hash_t PyvtkDICOMValue_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMValue_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMValue", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMValue_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMValue_Hash, // tp_hash
  nullptr, // tp_call
  PyvtkDICOMValue_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMValue_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  PyvtkDICOMValue_RichCompare, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMValue_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static int PyvtkDICOMValue_CheckExact(PyObject *ob)
{
  return (Py_TYPE(ob) == &PyvtkDICOMValue_Type);
}

static void *PyvtkDICOMValue_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMValue(*static_cast<const vtkDICOMValue*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMValue_TypeNew
extern "C" { PyObject *PyvtkDICOMValue_TypeNew(); }
#define DECLARED_PyvtkDICOMValue_TypeNew
#endif

PyObject *PyvtkDICOMValue_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMValue_Type,
    PyvtkDICOMValue_Methods,
    PyvtkDICOMValue_vtkDICOMValue_Methods,
    &PyvtkDICOMValue_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

static PyMethodDef PyvtkDICOMValueFriendMetaData_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkDICOMValueFriendMetaData_vtkDICOMValueFriendMetaData_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValueFriendMetaData");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkDICOMValueFriendMetaData *op = new vtkDICOMValueFriendMetaData();

    result = PyVTKSpecialObject_New("vtkDICOMValueFriendMetaData", op);
  }

  return result;
}

static PyObject *
PyvtkDICOMValueFriendMetaData_vtkDICOMValueFriendMetaData_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDICOMValueFriendMetaData");

  vtkDICOMValueFriendMetaData *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkDICOMValueFriendMetaData"))
  {
    vtkDICOMValueFriendMetaData *op = new vtkDICOMValueFriendMetaData(*temp0);

    result = PyVTKSpecialObject_New("vtkDICOMValueFriendMetaData", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkDICOMValueFriendMetaData_vtkDICOMValueFriendMetaData_Methods[] = {
  {"vtkDICOMValueFriendMetaData", PyvtkDICOMValueFriendMetaData_vtkDICOMValueFriendMetaData_s2, METH_VARARGS,
   "@W vtkDICOMValueFriendMetaData"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkDICOMValueFriendMetaData_vtkDICOMValueFriendMetaData(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkDICOMValueFriendMetaData_vtkDICOMValueFriendMetaData_s1(self, args);
    case 1:
      return PyvtkDICOMValueFriendMetaData_vtkDICOMValueFriendMetaData_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkDICOMValueFriendMetaData");
  return nullptr;
}


static const char *PyvtkDICOMValueFriendMetaData_Doc =

  "vtkDICOMValueFriendMetaData() -> vtkDICOMValueFriendMetaData\nC++: vtkDICOMValueFriendMetaData()\nvtkDICOMValueFriendMetaData(__a:vtkDICOMValueFriendMetaData)\n    -> vtkDICOMValueFriendMetaData\nC++: vtkDICOMValueFriendMetaData(const &vtkDICOMValueFriendMetaData)\n""\n"
  "vtkDICOMValueFriendMetaData - @cond\n\n"
;

static PyObject *
PyvtkDICOMValueFriendMetaData_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkDICOMValueFriendMetaData_vtkDICOMValueFriendMetaData(nullptr, args);
}

static void PyvtkDICOMValueFriendMetaData_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDICOMValueFriendMetaData *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDICOMValueFriendMetaData_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMValueFriendMetaData_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMValueFriendMetaData", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDICOMValueFriendMetaData_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkDICOMValueFriendMetaData_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkDICOMValueFriendMetaData_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkDICOMValueFriendMetaData_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkDICOMValueFriendMetaData_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkDICOMValueFriendMetaData(*static_cast<const vtkDICOMValueFriendMetaData*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkDICOMValueFriendMetaData_TypeNew
extern "C" { PyObject *PyvtkDICOMValueFriendMetaData_TypeNew(); }
#define DECLARED_PyvtkDICOMValueFriendMetaData_TypeNew
#endif

PyObject *PyvtkDICOMValueFriendMetaData_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkDICOMValueFriendMetaData_Type,
    PyvtkDICOMValueFriendMetaData_Methods,
    PyvtkDICOMValueFriendMetaData_vtkDICOMValueFriendMetaData_Methods,
    &PyvtkDICOMValueFriendMetaData_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMValue(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMValue_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMValue", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyvtkDICOMValueFriendMetaData_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMValueFriendMetaData", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 3; c++)
  {
    static const struct { const char *name; int value; }
      constants[3] = {
        { "VTK_DICOM_TAG", 13 },
        { "VTK_DICOM_ITEM", 14 },
        { "VTK_DICOM_VALUE", 15 },
      };

    o = PyLong_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(dict, constants[c].name, o);
      Py_DECREF(o);
    }
  }

}

