// python wrapper for vtkDICOMWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDICOMWriter.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMWriter(PyObject *dict); }
extern "C" { PyObject *PyvtkDICOMWriter_ClassNew(); }

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMWriter_RowOrder_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMWriter.RowOrder", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMWriter_RowOrder_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMWriter_RowOrder_Type, static_cast<int>(val));
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMWriter_SliceOrder_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMWriter.SliceOrder", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkDICOMWriter_SliceOrder_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkDICOMWriter_SliceOrder_Type, static_cast<int>(val));
}


static PyObject *
PyvtkDICOMWriter_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDICOMWriter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDICOMWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDICOMWriter *tempr = vtkDICOMWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDICOMWriter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkDICOMWriter::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkDICOMWriter::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetSeriesDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSeriesDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSeriesDescription(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetSeriesDescription(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetSeriesDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSeriesDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetSeriesDescription() :
      op->vtkDICOMWriter::GetSeriesDescription());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetImageType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetImageType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetImageType(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetImageType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetImageType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImageType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetImageType() :
      op->vtkDICOMWriter::GetImageType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetTimeAsVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeAsVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeAsVector(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetTimeAsVector(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_TimeAsVectorOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TimeAsVectorOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->TimeAsVectorOn();
    }
    else
    {
      op->vtkDICOMWriter::TimeAsVectorOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_TimeAsVectorOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TimeAsVectorOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->TimeAsVectorOff();
    }
    else
    {
      op->vtkDICOMWriter::TimeAsVectorOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetTimeAsVector(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeAsVector");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeAsVector() :
      op->vtkDICOMWriter::GetTimeAsVector());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetTimeDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeDimension(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetTimeDimension(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetTimeDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeDimension() :
      op->vtkDICOMWriter::GetTimeDimension());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetTimeSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeSpacing(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetTimeSpacing(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetTimeSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeSpacing() :
      op->vtkDICOMWriter::GetTimeSpacing());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetRescaleIntercept(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRescaleIntercept");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRescaleIntercept(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetRescaleIntercept(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetRescaleIntercept(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleIntercept");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRescaleIntercept() :
      op->vtkDICOMWriter::GetRescaleIntercept());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetRescaleSlope(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRescaleSlope");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRescaleSlope(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetRescaleSlope(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetRescaleSlope(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleSlope");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRescaleSlope() :
      op->vtkDICOMWriter::GetRescaleSlope());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetPatientMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPatientMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  vtkMatrix4x4 *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetPatientMatrix(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetPatientMatrix(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetPatientMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPatientMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMatrix4x4 *tempr = (ap.IsBound() ?
      op->GetPatientMatrix() :
      op->vtkDICOMWriter::GetPatientMatrix());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetMemoryRowOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMemoryRowOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMemoryRowOrder(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetMemoryRowOrder(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetMemoryRowOrderToFileNative(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMemoryRowOrderToFileNative");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetMemoryRowOrderToFileNative();
    }
    else
    {
      op->vtkDICOMWriter::SetMemoryRowOrderToFileNative();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetMemoryRowOrderToTopDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMemoryRowOrderToTopDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetMemoryRowOrderToTopDown();
    }
    else
    {
      op->vtkDICOMWriter::SetMemoryRowOrderToTopDown();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetMemoryRowOrderToBottomUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMemoryRowOrderToBottomUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetMemoryRowOrderToBottomUp();
    }
    else
    {
      op->vtkDICOMWriter::SetMemoryRowOrderToBottomUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetMemoryRowOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMemoryRowOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMemoryRowOrder() :
      op->vtkDICOMWriter::GetMemoryRowOrder());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetMemoryRowOrderAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMemoryRowOrderAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetMemoryRowOrderAsString() :
      op->vtkDICOMWriter::GetMemoryRowOrderAsString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetFileSliceOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileSliceOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileSliceOrder(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetFileSliceOrder(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetFileSliceOrderToRHR(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileSliceOrderToRHR");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFileSliceOrderToRHR();
    }
    else
    {
      op->vtkDICOMWriter::SetFileSliceOrderToRHR();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetFileSliceOrderToLHR(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileSliceOrderToLHR");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFileSliceOrderToLHR();
    }
    else
    {
      op->vtkDICOMWriter::SetFileSliceOrderToLHR();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetFileSliceOrderToSame(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileSliceOrderToSame");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFileSliceOrderToSame();
    }
    else
    {
      op->vtkDICOMWriter::SetFileSliceOrderToSame();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetFileSliceOrderToReverse(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileSliceOrderToReverse");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetFileSliceOrderToReverse();
    }
    else
    {
      op->vtkDICOMWriter::SetFileSliceOrderToReverse();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetFileSliceOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileSliceOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFileSliceOrder() :
      op->vtkDICOMWriter::GetFileSliceOrder());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetFileSliceOrderAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileSliceOrderAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFileSliceOrderAsString() :
      op->vtkDICOMWriter::GetFileSliceOrderAsString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  vtkDICOMMetaData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMMetaData"))
  {
    if (ap.IsBound())
    {
      op->SetMetaData(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetMetaData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMMetaData *tempr = (ap.IsBound() ?
      op->GetMetaData() :
      op->vtkDICOMWriter::GetMetaData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetGenerator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGenerator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  vtkDICOMGenerator *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDICOMGenerator"))
  {
    if (ap.IsBound())
    {
      op->SetGenerator(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetGenerator(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetGenerator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGenerator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkDICOMGenerator *tempr = (ap.IsBound() ?
      op->GetGenerator() :
      op->vtkDICOMWriter::GetGenerator());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetTransferSyntaxUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTransferSyntaxUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTransferSyntaxUID(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetTransferSyntaxUID(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetTransferSyntaxUID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTransferSyntaxUID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetTransferSyntaxUID() :
      op->vtkDICOMWriter::GetTransferSyntaxUID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetStreaming(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStreaming");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStreaming(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetStreaming(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetStreaming(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStreaming");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetStreaming() :
      op->vtkDICOMWriter::GetStreaming());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_StreamingOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StreamingOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->StreamingOn();
    }
    else
    {
      op->vtkDICOMWriter::StreamingOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_StreamingOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StreamingOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->StreamingOff();
    }
    else
    {
      op->vtkDICOMWriter::StreamingOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetOverlayInputData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverlayInputData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  vtkImageData *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetOverlayInputData(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetOverlayInputData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetOverlayInputConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverlayInputConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  vtkAlgorithmOutput *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetOverlayInputConnection(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetOverlayInputConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetOverlayInput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlayInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetOverlayInput() :
      op->vtkDICOMWriter::GetOverlayInput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetOverlayType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverlayType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOverlayType(temp0);
    }
    else
    {
      op->vtkDICOMWriter::SetOverlayType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_GetOverlayType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlayType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOverlayType() :
      op->vtkDICOMWriter::GetOverlayType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetOverlayTypeToGraphics(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverlayTypeToGraphics");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetOverlayTypeToGraphics();
    }
    else
    {
      op->vtkDICOMWriter::SetOverlayTypeToGraphics();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_SetOverlayTypeToROI(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverlayTypeToROI");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetOverlayTypeToROI();
    }
    else
    {
      op->vtkDICOMWriter::SetOverlayTypeToROI();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDICOMWriter_Write(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Write");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDICOMWriter *op = static_cast<vtkDICOMWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Write();
    }
    else
    {
      op->vtkDICOMWriter::Write();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDICOMWriter_Methods[] = {
  {"IsTypeOf", PyvtkDICOMWriter_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkDICOMWriter_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkDICOMWriter_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkDICOMWriter\nC++: static vtkDICOMWriter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDICOMWriter_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkDICOMWriter\nC++: vtkDICOMWriter *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkDICOMWriter_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkDICOMWriter_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetSeriesDescription", PyvtkDICOMWriter_SetSeriesDescription, METH_VARARGS,
   "SetSeriesDescription(self, _arg:str) -> None\nC++: virtual void SetSeriesDescription(const char *_arg)\n\nSet a short description (max 64 chars) for the DICOM series.\n\nThe default description is \"VTKX.Y\" where X.Y is the VTK version.\n"},
  {"GetSeriesDescription", PyvtkDICOMWriter_GetSeriesDescription, METH_VARARGS,
   "GetSeriesDescription(self) -> str\nC++: virtual char *GetSeriesDescription()\n\nSet a short description (max 64 chars) for the DICOM series.\n\nThe default description is \"VTKX.Y\" where X.Y is the VTK version.\n"},
  {"SetImageType", PyvtkDICOMWriter_SetImageType, METH_VARARGS,
   "SetImageType(self, _arg:str) -> None\nC++: virtual void SetImageType(const char *_arg)\n\nSet the image type, using a series of DICOM code strings.\n\nThis must follow the DICOM standard, an error will be generated\nif it doesn't.  The default value is DERIVED/SECONDARY/OTHER,\nwhere the forward-slashes will be replaced by backslashes when\nthe attribute is written.  Set this to NULL if you wish to use\nthe original ImageType.\n"},
  {"GetImageType", PyvtkDICOMWriter_GetImageType, METH_VARARGS,
   "GetImageType(self) -> str\nC++: virtual char *GetImageType()\n\nSet the image type, using a series of DICOM code strings.\n\nThis must follow the DICOM standard, an error will be generated\nif it doesn't.  The default value is DERIVED/SECONDARY/OTHER,\nwhere the forward-slashes will be replaced by backslashes when\nthe attribute is written.  Set this to NULL if you wish to use\nthe original ImageType.\n"},
  {"SetTimeAsVector", PyvtkDICOMWriter_SetTimeAsVector, METH_VARARGS,
   "SetTimeAsVector(self, _arg:int) -> None\nC++: virtual void SetTimeAsVector(int _arg)\n\nWrite scalar components as the time dimension (default: Off).\n\nIf this is on, the writer assumes that each time slot is stored\nin a different scalar component of the image data.  If it is off,\nthe writer assumes that each block of N adjacent slices\ncorrespond to the N time slots of the time dimension.\n"},
  {"TimeAsVectorOn", PyvtkDICOMWriter_TimeAsVectorOn, METH_VARARGS,
   "TimeAsVectorOn(self) -> None\nC++: virtual void TimeAsVectorOn()\n\nWrite scalar components as the time dimension (default: Off).\n\nIf this is on, the writer assumes that each time slot is stored\nin a different scalar component of the image data.  If it is off,\nthe writer assumes that each block of N adjacent slices\ncorrespond to the N time slots of the time dimension.\n"},
  {"TimeAsVectorOff", PyvtkDICOMWriter_TimeAsVectorOff, METH_VARARGS,
   "TimeAsVectorOff(self) -> None\nC++: virtual void TimeAsVectorOff()\n\nWrite scalar components as the time dimension (default: Off).\n\nIf this is on, the writer assumes that each time slot is stored\nin a different scalar component of the image data.  If it is off,\nthe writer assumes that each block of N adjacent slices\ncorrespond to the N time slots of the time dimension.\n"},
  {"GetTimeAsVector", PyvtkDICOMWriter_GetTimeAsVector, METH_VARARGS,
   "GetTimeAsVector(self) -> int\nC++: virtual int GetTimeAsVector()\n\nWrite scalar components as the time dimension (default: Off).\n\nIf this is on, the writer assumes that each time slot is stored\nin a different scalar component of the image data.  If it is off,\nthe writer assumes that each block of N adjacent slices\ncorrespond to the N time slots of the time dimension.\n"},
  {"SetTimeDimension", PyvtkDICOMWriter_SetTimeDimension, METH_VARARGS,
   "SetTimeDimension(self, _arg:int) -> None\nC++: virtual void SetTimeDimension(int _arg)\n\nSet the time dimension to use in the DICOM file (or zero if\nnone).\n\nThe number of components of the input data must be divisible by\nthe time dimension if the time dimension is not set to zero.  The\nvector dimension will be set to the number of components divided\nby the time dimension. This will be ignored if the SOP Class IOD\ndoes not permit a time dimension.\n"},
  {"GetTimeDimension", PyvtkDICOMWriter_GetTimeDimension, METH_VARARGS,
   "GetTimeDimension(self) -> int\nC++: virtual int GetTimeDimension()\n\nSet the time dimension to use in the DICOM file (or zero if\nnone).\n\nThe number of components of the input data must be divisible by\nthe time dimension if the time dimension is not set to zero.  The\nvector dimension will be set to the number of components divided\nby the time dimension. This will be ignored if the SOP Class IOD\ndoes not permit a time dimension.\n"},
  {"SetTimeSpacing", PyvtkDICOMWriter_SetTimeSpacing, METH_VARARGS,
   "SetTimeSpacing(self, _arg:float) -> None\nC++: virtual void SetTimeSpacing(double _arg)\n\nSet the time dimension to use in the DICOM file (or zero if\nnone).\n\nThe number of components of the input data must be divisible by\nthe time dimension if the time dimension is not set to zero.  The\nvector dimension will be set to the number of components divided\nby the time dimension. This will be ignored if the SOP Class IOD\ndoes not permit a time dimension.\n"},
  {"GetTimeSpacing", PyvtkDICOMWriter_GetTimeSpacing, METH_VARARGS,
   "GetTimeSpacing(self) -> float\nC++: virtual double GetTimeSpacing()\n\nSet the time dimension to use in the DICOM file (or zero if\nnone).\n\nThe number of components of the input data must be divisible by\nthe time dimension if the time dimension is not set to zero.  The\nvector dimension will be set to the number of components divided\nby the time dimension. This will be ignored if the SOP Class IOD\ndoes not permit a time dimension.\n"},
  {"SetRescaleIntercept", PyvtkDICOMWriter_SetRescaleIntercept, METH_VARARGS,
   "SetRescaleIntercept(self, _arg:float) -> None\nC++: virtual void SetRescaleIntercept(double _arg)\n\nSet the parameters to rescale integer pixel values into real\nvalues.\n\nThese parameters are the intercept and slope int the equation v =\nm*x + b that converts the stored pixel values to real units such\nas Hounsfield units.  Most modalities (including MR) ignore these\nvalues, while certain modalities (such as CT) require them.\n"},
  {"GetRescaleIntercept", PyvtkDICOMWriter_GetRescaleIntercept, METH_VARARGS,
   "GetRescaleIntercept(self) -> float\nC++: virtual double GetRescaleIntercept()\n\nSet the parameters to rescale integer pixel values into real\nvalues.\n\nThese parameters are the intercept and slope int the equation v =\nm*x + b that converts the stored pixel values to real units such\nas Hounsfield units.  Most modalities (including MR) ignore these\nvalues, while certain modalities (such as CT) require them.\n"},
  {"SetRescaleSlope", PyvtkDICOMWriter_SetRescaleSlope, METH_VARARGS,
   "SetRescaleSlope(self, _arg:float) -> None\nC++: virtual void SetRescaleSlope(double _arg)\n\nSet the parameters to rescale integer pixel values into real\nvalues.\n\nThese parameters are the intercept and slope int the equation v =\nm*x + b that converts the stored pixel values to real units such\nas Hounsfield units.  Most modalities (including MR) ignore these\nvalues, while certain modalities (such as CT) require them.\n"},
  {"GetRescaleSlope", PyvtkDICOMWriter_GetRescaleSlope, METH_VARARGS,
   "GetRescaleSlope(self) -> float\nC++: virtual double GetRescaleSlope()\n\nSet the parameters to rescale integer pixel values into real\nvalues.\n\nThese parameters are the intercept and slope int the equation v =\nm*x + b that converts the stored pixel values to real units such\nas Hounsfield units.  Most modalities (including MR) ignore these\nvalues, while certain modalities (such as CT) require them.\n"},
  {"SetPatientMatrix", PyvtkDICOMWriter_SetPatientMatrix, METH_VARARGS,
   "SetPatientMatrix(self, __a:vtkMatrix4x4) -> None\nC++: void SetPatientMatrix(vtkMatrix4x4 *)\n\nSet the matrix that places the image in DICOM patient coords.\n\nThe 3x3 portion of the matrix must be orthonormal, and the last\ncolumn of the matrix is understood to be in millimetres.\n"},
  {"GetPatientMatrix", PyvtkDICOMWriter_GetPatientMatrix, METH_VARARGS,
   "GetPatientMatrix(self) -> vtkMatrix4x4\nC++: vtkMatrix4x4 *GetPatientMatrix()\n\nSet the matrix that places the image in DICOM patient coords.\n\nThe 3x3 portion of the matrix must be orthonormal, and the last\ncolumn of the matrix is understood to be in millimetres.\n"},
  {"SetMemoryRowOrder", PyvtkDICOMWriter_SetMemoryRowOrder, METH_VARARGS,
   "SetMemoryRowOrder(self, order:int) -> None\nC++: void SetMemoryRowOrder(int order)\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"SetMemoryRowOrderToFileNative", PyvtkDICOMWriter_SetMemoryRowOrderToFileNative, METH_VARARGS,
   "SetMemoryRowOrderToFileNative(self) -> None\nC++: void SetMemoryRowOrderToFileNative()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"SetMemoryRowOrderToTopDown", PyvtkDICOMWriter_SetMemoryRowOrderToTopDown, METH_VARARGS,
   "SetMemoryRowOrderToTopDown(self) -> None\nC++: void SetMemoryRowOrderToTopDown()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"SetMemoryRowOrderToBottomUp", PyvtkDICOMWriter_SetMemoryRowOrderToBottomUp, METH_VARARGS,
   "SetMemoryRowOrderToBottomUp(self) -> None\nC++: void SetMemoryRowOrderToBottomUp()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"GetMemoryRowOrder", PyvtkDICOMWriter_GetMemoryRowOrder, METH_VARARGS,
   "GetMemoryRowOrder(self) -> int\nC++: int GetMemoryRowOrder()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"GetMemoryRowOrderAsString", PyvtkDICOMWriter_GetMemoryRowOrderAsString, METH_VARARGS,
   "GetMemoryRowOrderAsString(self) -> str\nC++: const char *GetMemoryRowOrderAsString()\n\nSet the ordering of the image rows in memory.\n\nIf the order is BottomUp (which is the default) then the images\nwill be flipped when they are read from disk. The native\norientation of DICOM images is top-to-bottom.\n"},
  {"SetFileSliceOrder", PyvtkDICOMWriter_SetFileSliceOrder, METH_VARARGS,
   "SetFileSliceOrder(self, order:int) -> None\nC++: void SetFileSliceOrder(int order)\n\nSet the slice ordering of the files to be written.\n\nThe default is RHR (right-hand-rule), which means that if your\nright thumb points along an image row, and your index finger\npoints down a row (starting at the top left of the image), then a\nbent middle finger points in the direction of increasing slice\nindex.  LHR is the reverse of this.  Same keeps files in the same\norder as VTK slices.\n"},
  {"SetFileSliceOrderToRHR", PyvtkDICOMWriter_SetFileSliceOrderToRHR, METH_VARARGS,
   "SetFileSliceOrderToRHR(self) -> None\nC++: void SetFileSliceOrderToRHR()\n\nSet the slice ordering of the files to be written.\n\nThe default is RHR (right-hand-rule), which means that if your\nright thumb points along an image row, and your index finger\npoints down a row (starting at the top left of the image), then a\nbent middle finger points in the direction of increasing slice\nindex.  LHR is the reverse of this.  Same keeps files in the same\norder as VTK slices.\n"},
  {"SetFileSliceOrderToLHR", PyvtkDICOMWriter_SetFileSliceOrderToLHR, METH_VARARGS,
   "SetFileSliceOrderToLHR(self) -> None\nC++: void SetFileSliceOrderToLHR()\n\nSet the slice ordering of the files to be written.\n\nThe default is RHR (right-hand-rule), which means that if your\nright thumb points along an image row, and your index finger\npoints down a row (starting at the top left of the image), then a\nbent middle finger points in the direction of increasing slice\nindex.  LHR is the reverse of this.  Same keeps files in the same\norder as VTK slices.\n"},
  {"SetFileSliceOrderToSame", PyvtkDICOMWriter_SetFileSliceOrderToSame, METH_VARARGS,
   "SetFileSliceOrderToSame(self) -> None\nC++: void SetFileSliceOrderToSame()\n\nSet the slice ordering of the files to be written.\n\nThe default is RHR (right-hand-rule), which means that if your\nright thumb points along an image row, and your index finger\npoints down a row (starting at the top left of the image), then a\nbent middle finger points in the direction of increasing slice\nindex.  LHR is the reverse of this.  Same keeps files in the same\norder as VTK slices.\n"},
  {"SetFileSliceOrderToReverse", PyvtkDICOMWriter_SetFileSliceOrderToReverse, METH_VARARGS,
   "SetFileSliceOrderToReverse(self) -> None\nC++: void SetFileSliceOrderToReverse()\n\nSet the slice ordering of the files to be written.\n\nThe default is RHR (right-hand-rule), which means that if your\nright thumb points along an image row, and your index finger\npoints down a row (starting at the top left of the image), then a\nbent middle finger points in the direction of increasing slice\nindex.  LHR is the reverse of this.  Same keeps files in the same\norder as VTK slices.\n"},
  {"GetFileSliceOrder", PyvtkDICOMWriter_GetFileSliceOrder, METH_VARARGS,
   "GetFileSliceOrder(self) -> int\nC++: int GetFileSliceOrder()\n\nSet the slice ordering of the files to be written.\n\nThe default is RHR (right-hand-rule), which means that if your\nright thumb points along an image row, and your index finger\npoints down a row (starting at the top left of the image), then a\nbent middle finger points in the direction of increasing slice\nindex.  LHR is the reverse of this.  Same keeps files in the same\norder as VTK slices.\n"},
  {"GetFileSliceOrderAsString", PyvtkDICOMWriter_GetFileSliceOrderAsString, METH_VARARGS,
   "GetFileSliceOrderAsString(self) -> str\nC++: const char *GetFileSliceOrderAsString()\n\nSet the slice ordering of the files to be written.\n\nThe default is RHR (right-hand-rule), which means that if your\nright thumb points along an image row, and your index finger\npoints down a row (starting at the top left of the image), then a\nbent middle finger points in the direction of increasing slice\nindex.  LHR is the reverse of this.  Same keeps files in the same\norder as VTK slices.\n"},
  {"SetMetaData", PyvtkDICOMWriter_SetMetaData, METH_VARARGS,
   "SetMetaData(self, __a:vtkDICOMMetaData) -> None\nC++: void SetMetaData(vtkDICOMMetaData *)\n\nSet the meta data to include with the file.\n\nThe supplied meta data is only used as a hint, the writer will\noverride attributes that aren't valid for the image.\n"},
  {"GetMetaData", PyvtkDICOMWriter_GetMetaData, METH_VARARGS,
   "GetMetaData(self) -> vtkDICOMMetaData\nC++: vtkDICOMMetaData *GetMetaData()\n\nSet the meta data to include with the file.\n\nThe supplied meta data is only used as a hint, the writer will\noverride attributes that aren't valid for the image.\n"},
  {"SetGenerator", PyvtkDICOMWriter_SetGenerator, METH_VARARGS,
   "SetGenerator(self, __a:vtkDICOMGenerator) -> None\nC++: void SetGenerator(vtkDICOMGenerator *)\n\nSet the generator for image modality you wish to write.\n\nThe generator combines the image information from VTK with the\nsupplied MetaData to create the DICOM data series that will be\nwritten to disk.  The default generator will write a Secondary\nCapture series, rather than a series belonging to a specific\nimaging modality.\n"},
  {"GetGenerator", PyvtkDICOMWriter_GetGenerator, METH_VARARGS,
   "GetGenerator(self) -> vtkDICOMGenerator\nC++: vtkDICOMGenerator *GetGenerator()\n\nSet the generator for image modality you wish to write.\n\nThe generator combines the image information from VTK with the\nsupplied MetaData to create the DICOM data series that will be\nwritten to disk.  The default generator will write a Secondary\nCapture series, rather than a series belonging to a specific\nimaging modality.\n"},
  {"SetTransferSyntaxUID", PyvtkDICOMWriter_SetTransferSyntaxUID, METH_VARARGS,
   "SetTransferSyntaxUID(self, _arg:str) -> None\nC++: virtual void SetTransferSyntaxUID(const char *_arg)\n\nSet the Transfer Syntax UID.\n\nSetting the transfer syntax is an experimental feature.  If not\nset, the transfer syntax will be 1.2.840.10008.1.2.1\n(uncompressed little-endian with explicit VR).\n"},
  {"GetTransferSyntaxUID", PyvtkDICOMWriter_GetTransferSyntaxUID, METH_VARARGS,
   "GetTransferSyntaxUID(self) -> str\nC++: virtual char *GetTransferSyntaxUID()\n\nSet the Transfer Syntax UID.\n\nSetting the transfer syntax is an experimental feature.  If not\nset, the transfer syntax will be 1.2.840.10008.1.2.1\n(uncompressed little-endian with explicit VR).\n"},
  {"SetStreaming", PyvtkDICOMWriter_SetStreaming, METH_VARARGS,
   "SetStreaming(self, _arg:int) -> None\nC++: virtual void SetStreaming(int _arg)\n\nTurn on streaming, to pass one slice though the pipeline at a\ntime.\n\nStreaming decreases memory usage for images with a large number\nof slices, since only one slice will have to be in memory at a\ntime. However, streaming can be slower (sometimes much slower)\nthan reading and processing all of the slices at once.\n"},
  {"GetStreaming", PyvtkDICOMWriter_GetStreaming, METH_VARARGS,
   "GetStreaming(self) -> int\nC++: virtual int GetStreaming()\n\nTurn on streaming, to pass one slice though the pipeline at a\ntime.\n\nStreaming decreases memory usage for images with a large number\nof slices, since only one slice will have to be in memory at a\ntime. However, streaming can be slower (sometimes much slower)\nthan reading and processing all of the slices at once.\n"},
  {"StreamingOn", PyvtkDICOMWriter_StreamingOn, METH_VARARGS,
   "StreamingOn(self) -> None\nC++: virtual void StreamingOn()\n\nTurn on streaming, to pass one slice though the pipeline at a\ntime.\n\nStreaming decreases memory usage for images with a large number\nof slices, since only one slice will have to be in memory at a\ntime. However, streaming can be slower (sometimes much slower)\nthan reading and processing all of the slices at once.\n"},
  {"StreamingOff", PyvtkDICOMWriter_StreamingOff, METH_VARARGS,
   "StreamingOff(self) -> None\nC++: virtual void StreamingOff()\n\nTurn on streaming, to pass one slice though the pipeline at a\ntime.\n\nStreaming decreases memory usage for images with a large number\nof slices, since only one slice will have to be in memory at a\ntime. However, streaming can be slower (sometimes much slower)\nthan reading and processing all of the slices at once.\n"},
  {"SetOverlayInputData", PyvtkDICOMWriter_SetOverlayInputData, METH_VARARGS,
   "SetOverlayInputData(self, data:vtkImageData) -> None\nC++: void SetOverlayInputData(vtkImageData *data)\n\nProvide an overlay to be written with the data.\n"},
  {"SetOverlayInputConnection", PyvtkDICOMWriter_SetOverlayInputConnection, METH_VARARGS,
   "SetOverlayInputConnection(self, data:vtkAlgorithmOutput) -> None\nC++: void SetOverlayInputConnection(vtkAlgorithmOutput *data)\n\nProvide an overlay to be written with the data.\n"},
  {"GetOverlayInput", PyvtkDICOMWriter_GetOverlayInput, METH_VARARGS,
   "GetOverlayInput(self) -> vtkImageData\nC++: vtkImageData *GetOverlayInput()\n\nProvide an overlay to be written with the data.\n"},
  {"SetOverlayType", PyvtkDICOMWriter_SetOverlayType, METH_VARARGS,
   "SetOverlayType(self, _arg:int) -> None\nC++: virtual void SetOverlayType(int _arg)\n\nSet the overlay type.\n"},
  {"GetOverlayType", PyvtkDICOMWriter_GetOverlayType, METH_VARARGS,
   "GetOverlayType(self) -> int\nC++: virtual int GetOverlayType()\n\nSet the overlay type.\n"},
  {"SetOverlayTypeToGraphics", PyvtkDICOMWriter_SetOverlayTypeToGraphics, METH_VARARGS,
   "SetOverlayTypeToGraphics(self) -> None\nC++: void SetOverlayTypeToGraphics()\n\nSet the overlay type.\n"},
  {"SetOverlayTypeToROI", PyvtkDICOMWriter_SetOverlayTypeToROI, METH_VARARGS,
   "SetOverlayTypeToROI(self) -> None\nC++: void SetOverlayTypeToROI()\n\nSet the overlay type.\n"},
  {"Write", PyvtkDICOMWriter_Write, METH_VARARGS,
   "Write(self) -> None\nC++: void Write() override;\n\nWrite the file to disk.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkDICOMWriter_Doc =
  "vtkDICOMWriter - Write DICOM image files.\n\n"
  "Superclass: vtkImageWriter\n\n"
  "This class writes a series of one or more DICOM files.  The default\n"
  "behavior is to write a series of Secondary Capture files with no\n"
  "modality-specific information.  To write other kinds of DICOM files,\n"
  "use the SetGenerator() method to supply a generator for the type of\n"
  "data set that you wish to write.  Currently, there are generators for\n"
  "MR and CT data sets.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkDICOMWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkDICOMWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkDICOMWriter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDICOMWriter_StaticNew()
{
  return vtkDICOMWriter::New();
}

PyObject *PyvtkDICOMWriter_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkDICOMWriter_Type, PyvtkDICOMWriter_Methods,
    "vtkDICOMWriter",
 &PyvtkDICOMWriter_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkImageWriter");

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkDICOMWriter_RowOrder_Type);
  PyVTKEnum_Add(&PyvtkDICOMWriter_RowOrder_Type, "vtkDICOMWriter.RowOrder");

  o = (PyObject *)&PyvtkDICOMWriter_RowOrder_Type;
  if (PyDict_SetItemString(d, "RowOrder", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkDICOMWriter_SliceOrder_Type);
  PyVTKEnum_Add(&PyvtkDICOMWriter_SliceOrder_Type, "vtkDICOMWriter.SliceOrder");

  o = (PyObject *)&PyvtkDICOMWriter_SliceOrder_Type;
  if (PyDict_SetItemString(d, "SliceOrder", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 3; c++)
  {
    typedef vtkDICOMWriter::RowOrder cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[3] = {
        { "FileNative", vtkDICOMWriter::FileNative },
        { "TopDown", vtkDICOMWriter::TopDown },
        { "BottomUp", vtkDICOMWriter::BottomUp },
      };

    o = PyvtkDICOMWriter_RowOrder_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 4; c++)
  {
    typedef vtkDICOMWriter::SliceOrder cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[4] = {
        { "RHR", vtkDICOMWriter::RHR },
        { "LHR", vtkDICOMWriter::LHR },
        { "Same", vtkDICOMWriter::Same },
        { "Reverse", vtkDICOMWriter::Reverse },
      };

    o = PyvtkDICOMWriter_SliceOrder_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkDICOMWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDICOMWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDICOMWriter", o) != 0)
  {
    Py_DECREF(o);
  }

}

