// python wrapper for vtkScancoCTReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkScancoCTReader.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkScancoCTReader(PyObject *dict); }
extern "C" { PyObject *PyvtkScancoCTReader_ClassNew(); }


static PyObject *
PyvtkScancoCTReader_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkScancoCTReader::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkScancoCTReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkScancoCTReader *tempr = vtkScancoCTReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkScancoCTReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkScancoCTReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkScancoCTReader::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkScancoCTReader::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetFileExtensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileExtensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFileExtensions() :
      op->vtkScancoCTReader::GetFileExtensions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetDescriptiveName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDescriptiveName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDescriptiveName() :
      op->vtkScancoCTReader::GetDescriptiveName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_CanReadFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CanReadFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetFilePath(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->CanReadFile(temp0) :
      op->vtkScancoCTReader::CanReadFile(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetVersion(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVersion");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetVersion() :
      op->vtkScancoCTReader::GetVersion());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetPatientIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPatientIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPatientIndex() :
      op->vtkScancoCTReader::GetPatientIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetScannerID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScannerID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetScannerID() :
      op->vtkScancoCTReader::GetScannerID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetCreationDate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCreationDate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetCreationDate() :
      op->vtkScancoCTReader::GetCreationDate());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetModificationDate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetModificationDate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetModificationDate() :
      op->vtkScancoCTReader::GetModificationDate());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetSliceThickness(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceThickness");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSliceThickness() :
      op->vtkScancoCTReader::GetSliceThickness());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetSliceIncrement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceIncrement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSliceIncrement() :
      op->vtkScancoCTReader::GetSliceIncrement());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetStartPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStartPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetStartPosition() :
      op->vtkScancoCTReader::GetStartPosition());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetEndPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEndPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetEndPosition() :
      op->vtkScancoCTReader::GetEndPosition());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetZPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetZPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetZPosition() :
      op->vtkScancoCTReader::GetZPosition());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetDataRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  size_t sizer = 2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetDataRange() :
      op->vtkScancoCTReader::GetDataRange());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetMuScaling(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMuScaling");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetMuScaling() :
      op->vtkScancoCTReader::GetMuScaling());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetNumberOfSamples(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfSamples");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfSamples() :
      op->vtkScancoCTReader::GetNumberOfSamples());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetNumberOfProjections(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfProjections");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfProjections() :
      op->vtkScancoCTReader::GetNumberOfProjections());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetScanDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScanDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetScanDistance() :
      op->vtkScancoCTReader::GetScanDistance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetScannerType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScannerType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetScannerType() :
      op->vtkScancoCTReader::GetScannerType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetSampleTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSampleTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSampleTime() :
      op->vtkScancoCTReader::GetSampleTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetMeasurementIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMeasurementIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMeasurementIndex() :
      op->vtkScancoCTReader::GetMeasurementIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetSite(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSite");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSite() :
      op->vtkScancoCTReader::GetSite());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetReferenceLine(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReferenceLine");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetReferenceLine() :
      op->vtkScancoCTReader::GetReferenceLine());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetReconstructionAlg(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReconstructionAlg");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetReconstructionAlg() :
      op->vtkScancoCTReader::GetReconstructionAlg());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetPatientName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPatientName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetPatientName() :
      op->vtkScancoCTReader::GetPatientName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetEnergy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEnergy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetEnergy() :
      op->vtkScancoCTReader::GetEnergy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetIntensity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIntensity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetIntensity() :
      op->vtkScancoCTReader::GetIntensity());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetRescaleSlope(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleSlope");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRescaleSlope() :
      op->vtkScancoCTReader::GetRescaleSlope());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetRescaleIntercept(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleIntercept");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRescaleIntercept() :
      op->vtkScancoCTReader::GetRescaleIntercept());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetRescaleType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRescaleType() :
      op->vtkScancoCTReader::GetRescaleType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetRescaleUnits(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRescaleUnits");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetRescaleUnits() :
      op->vtkScancoCTReader::GetRescaleUnits());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetMuWater(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMuWater");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetMuWater() :
      op->vtkScancoCTReader::GetMuWater());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetCalibrationData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCalibrationData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetCalibrationData() :
      op->vtkScancoCTReader::GetCalibrationData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetScanDimensionsPixels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScanDimensionsPixels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetScanDimensionsPixels() :
      op->vtkScancoCTReader::GetScanDimensionsPixels());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetScanDimensionsPhysical(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScanDimensionsPhysical");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  size_t sizer = 3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetScanDimensionsPhysical() :
      op->vtkScancoCTReader::GetScanDimensionsPhysical());

    if (!ap.ErrorOccurred())
    {
      result = vtkPythonArgs::BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkScancoCTReader_GetRawHeader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRawHeader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScancoCTReader *op = static_cast<vtkScancoCTReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    void  *tempr = (ap.IsBound() ?
      op->GetRawHeader() :
      op->vtkScancoCTReader::GetRawHeader());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkScancoCTReader_Methods[] = {
  {"IsTypeOf", PyvtkScancoCTReader_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkScancoCTReader_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkScancoCTReader_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkScancoCTReader\nC++: static vtkScancoCTReader *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkScancoCTReader_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkScancoCTReader\nC++: vtkScancoCTReader *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkScancoCTReader_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkScancoCTReader_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetFileExtensions", PyvtkScancoCTReader_GetFileExtensions, METH_VARARGS,
   "GetFileExtensions(self) -> str\nC++: const char *GetFileExtensions() override;\n\nValid extensions for this file type.\n"},
  {"GetDescriptiveName", PyvtkScancoCTReader_GetDescriptiveName, METH_VARARGS,
   "GetDescriptiveName(self) -> str\nC++: const char *GetDescriptiveName() override;\n\nReturn a descriptive name that might be useful in a GUI.\n"},
  {"CanReadFile", PyvtkScancoCTReader_CanReadFile, METH_VARARGS,
   "CanReadFile(self, filename:str) -> int\nC++: int CanReadFile(const char *filename) override;\n\nReturn true if this reader can read the given file.\n"},
  {"GetVersion", PyvtkScancoCTReader_GetVersion, METH_VARARGS,
   "GetVersion(self) -> str\nC++: const char *GetVersion()\n\nGet a string that states the version of the file header.\n"},
  {"GetPatientIndex", PyvtkScancoCTReader_GetPatientIndex, METH_VARARGS,
   "GetPatientIndex(self) -> int\nC++: int GetPatientIndex()\n\nGet the patient index from the header.\n"},
  {"GetScannerID", PyvtkScancoCTReader_GetScannerID, METH_VARARGS,
   "GetScannerID(self) -> int\nC++: int GetScannerID()\n\nGet the scanner ID from the header.\n"},
  {"GetCreationDate", PyvtkScancoCTReader_GetCreationDate, METH_VARARGS,
   "GetCreationDate(self) -> str\nC++: const char *GetCreationDate()\n\nGet the creation date as a string.\n"},
  {"GetModificationDate", PyvtkScancoCTReader_GetModificationDate, METH_VARARGS,
   "GetModificationDate(self) -> str\nC++: const char *GetModificationDate()\n\nGet the date when the data was last modified.\n"},
  {"GetSliceThickness", PyvtkScancoCTReader_GetSliceThickness, METH_VARARGS,
   "GetSliceThickness(self) -> float\nC++: double GetSliceThickness()\n\nGet the slice thickness in millimeters.\n"},
  {"GetSliceIncrement", PyvtkScancoCTReader_GetSliceIncrement, METH_VARARGS,
   "GetSliceIncrement(self) -> float\nC++: double GetSliceIncrement()\n\nGet the slice increment in millimeters.\n"},
  {"GetStartPosition", PyvtkScancoCTReader_GetStartPosition, METH_VARARGS,
   "GetStartPosition(self) -> float\nC++: double GetStartPosition()\n\nGet the position of the first slice in millimeters.\n"},
  {"GetEndPosition", PyvtkScancoCTReader_GetEndPosition, METH_VARARGS,
   "GetEndPosition(self) -> float\nC++: double GetEndPosition()\n\nGet the position of the final slice in millimeters.\n"},
  {"GetZPosition", PyvtkScancoCTReader_GetZPosition, METH_VARARGS,
   "GetZPosition(self) -> float\nC++: double GetZPosition()\n\nGet the location of the edge of a locator scan.\n"},
  {"GetDataRange", PyvtkScancoCTReader_GetDataRange, METH_VARARGS,
   "GetDataRange(self) -> (float, float)\nC++: virtual double *GetDataRange()\n\nGet the data range, as stored in the file header.\n"},
  {"GetMuScaling", PyvtkScancoCTReader_GetMuScaling, METH_VARARGS,
   "GetMuScaling(self) -> float\nC++: double GetMuScaling()\n\nGet the scaling factor from linear attenuation [1/cm] to data\nvalues.\n"},
  {"GetNumberOfSamples", PyvtkScancoCTReader_GetNumberOfSamples, METH_VARARGS,
   "GetNumberOfSamples(self) -> int\nC++: int GetNumberOfSamples()\n\nGet the number of samples.\n"},
  {"GetNumberOfProjections", PyvtkScancoCTReader_GetNumberOfProjections, METH_VARARGS,
   "GetNumberOfProjections(self) -> int\nC++: int GetNumberOfProjections()\n\nGet the number of projections.\n"},
  {"GetScanDistance", PyvtkScancoCTReader_GetScanDistance, METH_VARARGS,
   "GetScanDistance(self) -> float\nC++: double GetScanDistance()\n\nGet the scan distance (in millimeters).\n"},
  {"GetScannerType", PyvtkScancoCTReader_GetScannerType, METH_VARARGS,
   "GetScannerType(self) -> int\nC++: int GetScannerType()\n\nGet the scanner type, as an integer code.\n"},
  {"GetSampleTime", PyvtkScancoCTReader_GetSampleTime, METH_VARARGS,
   "GetSampleTime(self) -> float\nC++: double GetSampleTime()\n\nGet the sample time (in milliseconds).\n"},
  {"GetMeasurementIndex", PyvtkScancoCTReader_GetMeasurementIndex, METH_VARARGS,
   "GetMeasurementIndex(self) -> int\nC++: int GetMeasurementIndex()\n\nGet the index measurement.\n"},
  {"GetSite", PyvtkScancoCTReader_GetSite, METH_VARARGS,
   "GetSite(self) -> int\nC++: int GetSite()\n\nGet an integer value that identifies the site on the body.\n"},
  {"GetReferenceLine", PyvtkScancoCTReader_GetReferenceLine, METH_VARARGS,
   "GetReferenceLine(self) -> float\nC++: double GetReferenceLine()\n\nGet the reference line (in millimeters).\n"},
  {"GetReconstructionAlg", PyvtkScancoCTReader_GetReconstructionAlg, METH_VARARGS,
   "GetReconstructionAlg(self) -> int\nC++: int GetReconstructionAlg()\n\nGet an integer value that identifies the reconstruction\nalgorithm.\n"},
  {"GetPatientName", PyvtkScancoCTReader_GetPatientName, METH_VARARGS,
   "GetPatientName(self) -> str\nC++: const char *GetPatientName()\n\nGet a descriptive name for this scan.\n"},
  {"GetEnergy", PyvtkScancoCTReader_GetEnergy, METH_VARARGS,
   "GetEnergy(self) -> float\nC++: double GetEnergy()\n\nGet the X-ray energy (in kVp).\n"},
  {"GetIntensity", PyvtkScancoCTReader_GetIntensity, METH_VARARGS,
   "GetIntensity(self) -> float\nC++: double GetIntensity()\n\nGet the X-ray intensity (in mA).\n"},
  {"GetRescaleSlope", PyvtkScancoCTReader_GetRescaleSlope, METH_VARARGS,
   "GetRescaleSlope(self) -> float\nC++: double GetRescaleSlope()\n\nGet the slope and intercept for rescaling the scalar values.\n\nThese values allow calibration of the data to real values. Use\nthe equation v = u*RescaleSlope + RescaleIntercept.\n"},
  {"GetRescaleIntercept", PyvtkScancoCTReader_GetRescaleIntercept, METH_VARARGS,
   "GetRescaleIntercept(self) -> float\nC++: double GetRescaleIntercept()\n\nGet the slope and intercept for rescaling the scalar values.\n\nThese values allow calibration of the data to real values. Use\nthe equation v = u*RescaleSlope + RescaleIntercept.\n"},
  {"GetRescaleType", PyvtkScancoCTReader_GetRescaleType, METH_VARARGS,
   "GetRescaleType(self) -> int\nC++: int GetRescaleType()\n\nGet the rescale type as an integer code.\n"},
  {"GetRescaleUnits", PyvtkScancoCTReader_GetRescaleUnits, METH_VARARGS,
   "GetRescaleUnits(self) -> str\nC++: const char *GetRescaleUnits()\n\nGet the units of the data after rescaling with slope and\nintercept.\n"},
  {"GetMuWater", PyvtkScancoCTReader_GetMuWater, METH_VARARGS,
   "GetMuWater(self) -> float\nC++: double GetMuWater()\n\nGet the linear attenuation of water, in units of [1/cm].\n"},
  {"GetCalibrationData", PyvtkScancoCTReader_GetCalibrationData, METH_VARARGS,
   "GetCalibrationData(self) -> str\nC++: const char *GetCalibrationData()\n\nGet the calibration data (energy, filtration, etc.)\n"},
  {"GetScanDimensionsPixels", PyvtkScancoCTReader_GetScanDimensionsPixels, METH_VARARGS,
   "GetScanDimensionsPixels(self) -> (int, int, int)\nC++: virtual int *GetScanDimensionsPixels()\n\nGet the full scan dimensions in pixels.\n"},
  {"GetScanDimensionsPhysical", PyvtkScancoCTReader_GetScanDimensionsPhysical, METH_VARARGS,
   "GetScanDimensionsPhysical(self) -> (float, float, float)\nC++: virtual double *GetScanDimensionsPhysical()\n\nGet the full scan dimensions in millimeters.\n"},
  {"GetRawHeader", PyvtkScancoCTReader_GetRawHeader, METH_VARARGS,
   "GetRawHeader(self) -> Pointer\nC++: void *GetRawHeader()\n\nGet the raw header information (512 bytes) from the file.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkScancoCTReader_Doc =
  "vtkScancoCTReader - Read SCANCO ISQ and AIM medical image files\n\n"
  "Superclass: vtkImageReader2\n\n"
  "This class reads ISQ and AIM files, which are used for\n"
  "high-resolution computed tomography.  The information that it\n"
  "provides uses different units as compared to the original files: all\n"
  "distances are given in millimeters (instead of micrometers), times\n"
  "are given in milliseconds (instead of microseconds), voltage and\n"
  "current given in kV and mA (instead of volts and microamps).  If the\n"
  "scanner was calibrated, then the data values can be converted to\n"
  "calibrated units.  To convert to linear attenuation coefficients\n"
  "[cm^-1], simply divide the data values by the MuScaling.  To convert\n"
  "to density values, multiply the data values by the RescaleSlope and\n"
  "add the RescaleIntercept. To convert to Hounsfield units, multiply by\n"
  "1000/(MuScaling*MuWater) and subtract 1000.\n\n"
  "Created at the Calgary Image Processing and Analysis Centre (CIPAC).\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkScancoCTReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkDICOM.vtkScancoCTReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkScancoCTReader_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkScancoCTReader_StaticNew()
{
  return vtkScancoCTReader::New();
}

PyObject *PyvtkScancoCTReader_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkScancoCTReader_Type, PyvtkScancoCTReader_Methods,
    "vtkScancoCTReader",
 &PyvtkScancoCTReader_StaticNew);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkImageReader2");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkScancoCTReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkScancoCTReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkScancoCTReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

