// python wrapper for vtkDICOMDictHash
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDICOMDictHash.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDICOMDictHash(PyObject *dict); }
#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyDC_EnumType_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkCommonCore.DC.EnumType", // tp_name
  sizeof(PyLongObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT
#if PY_VERSION_HEX >= 0x030A0000
    | Py_TPFLAGS_DISALLOW_INSTANTIATION
#endif
  , // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyLong_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyDC_EnumType_FromEnum(T val)
{
  return PyVTKEnum_New(&PyDC_EnumType_Type, static_cast<int>(val));
}

static PyObject *PyVTKNamespace_DC()
{
  PyObject *m = PyVTKNamespace_New("DC");

  PyObject *d = PyVTKNamespace_GetDict(m);
  PyObject *o;

  PyType_Ready(&PyDC_EnumType_Type);
  PyVTKEnum_Add(&PyDC_EnumType_Type, "DC.EnumType");

  o = (PyObject *)&PyDC_EnumType_Type;
  if (PyDict_SetItemString(d, "EnumType", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 6089; c++)
  {
    typedef DC::EnumType cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[6089] = {
        { "FileMetaInformationGroupLength", DC::FileMetaInformationGroupLength },
        { "FileMetaInformationVersion", DC::FileMetaInformationVersion },
        { "MediaStorageSOPClassUID", DC::MediaStorageSOPClassUID },
        { "MediaStorageSOPInstanceUID", DC::MediaStorageSOPInstanceUID },
        { "TransferSyntaxUID", DC::TransferSyntaxUID },
        { "ImplementationClassUID", DC::ImplementationClassUID },
        { "ImplementationVersionName", DC::ImplementationVersionName },
        { "SourceApplicationEntityTitle", DC::SourceApplicationEntityTitle },
        { "SendingApplicationEntityTitle", DC::SendingApplicationEntityTitle },
        { "ReceivingApplicationEntityTitle", DC::ReceivingApplicationEntityTitle },
        { "SourcePresentationAddress", DC::SourcePresentationAddress },
        { "SendingPresentationAddress", DC::SendingPresentationAddress },
        { "ReceivingPresentationAddress", DC::ReceivingPresentationAddress },
        { "RTVMetaInformationVersion", DC::RTVMetaInformationVersion },
        { "RTVCommunicationSOPClassUID", DC::RTVCommunicationSOPClassUID },
        { "RTVCommunicationSOPInstanceUID", DC::RTVCommunicationSOPInstanceUID },
        { "RTVSourceIdentifier", DC::RTVSourceIdentifier },
        { "RTVFlowIdentifier", DC::RTVFlowIdentifier },
        { "RTVFlowRTPSamplingRate", DC::RTVFlowRTPSamplingRate },
        { "RTVFlowActualFrameDuration", DC::RTVFlowActualFrameDuration },
        { "PrivateInformationCreatorUID", DC::PrivateInformationCreatorUID },
        { "PrivateInformation", DC::PrivateInformation },
        { "FileSetID", DC::FileSetID },
        { "FileSetDescriptorFileID", DC::FileSetDescriptorFileID },
        { "SpecificCharacterSetOfFileSetDescriptorFile", DC::SpecificCharacterSetOfFileSetDescriptorFile },
        { "OffsetOfTheFirstDirectoryRecordOfTheRootDirectoryEntity", DC::OffsetOfTheFirstDirectoryRecordOfTheRootDirectoryEntity },
        { "OffsetOfTheLastDirectoryRecordOfTheRootDirectoryEntity", DC::OffsetOfTheLastDirectoryRecordOfTheRootDirectoryEntity },
        { "FileSetConsistencyFlag", DC::FileSetConsistencyFlag },
        { "DirectoryRecordSequence", DC::DirectoryRecordSequence },
        { "OffsetOfTheNextDirectoryRecord", DC::OffsetOfTheNextDirectoryRecord },
        { "RecordInUseFlag", DC::RecordInUseFlag },
        { "OffsetOfReferencedLowerLevelDirectoryEntity", DC::OffsetOfReferencedLowerLevelDirectoryEntity },
        { "DirectoryRecordType", DC::DirectoryRecordType },
        { "PrivateRecordUID", DC::PrivateRecordUID },
        { "ReferencedFileID", DC::ReferencedFileID },
        { "MRDRDirectoryRecordOffset", DC::MRDRDirectoryRecordOffset },
        { "ReferencedSOPClassUIDInFile", DC::ReferencedSOPClassUIDInFile },
        { "ReferencedSOPInstanceUIDInFile", DC::ReferencedSOPInstanceUIDInFile },
        { "ReferencedTransferSyntaxUIDInFile", DC::ReferencedTransferSyntaxUIDInFile },
        { "ReferencedRelatedGeneralSOPClassUIDInFile", DC::ReferencedRelatedGeneralSOPClassUIDInFile },
        { "NumberOfReferences", DC::NumberOfReferences },
        { "CurrentFrameFunctionalGroupsSequence", DC::CurrentFrameFunctionalGroupsSequence },
        { "LengthToEnd", DC::LengthToEnd },
        { "SpecificCharacterSet", DC::SpecificCharacterSet },
        { "LanguageCodeSequence", DC::LanguageCodeSequence },
        { "ImageType", DC::ImageType },
        { "RecognitionCode", DC::RecognitionCode },
        { "InstanceCreationDate", DC::InstanceCreationDate },
        { "InstanceCreationTime", DC::InstanceCreationTime },
        { "InstanceCreatorUID", DC::InstanceCreatorUID },
        { "InstanceCoercionDateTime", DC::InstanceCoercionDateTime },
        { "SOPClassUID", DC::SOPClassUID },
        { "AcquisitionUID", DC::AcquisitionUID },
        { "SOPInstanceUID", DC::SOPInstanceUID },
        { "PyramidUID", DC::PyramidUID },
        { "RelatedGeneralSOPClassUID", DC::RelatedGeneralSOPClassUID },
        { "OriginalSpecializedSOPClassUID", DC::OriginalSpecializedSOPClassUID },
        { "StudyDate", DC::StudyDate },
        { "SeriesDate", DC::SeriesDate },
        { "AcquisitionDate", DC::AcquisitionDate },
        { "ContentDate", DC::ContentDate },
        { "OverlayDate", DC::OverlayDate },
        { "CurveDate", DC::CurveDate },
        { "AcquisitionDateTime", DC::AcquisitionDateTime },
        { "StudyTime", DC::StudyTime },
        { "SeriesTime", DC::SeriesTime },
        { "AcquisitionTime", DC::AcquisitionTime },
        { "ContentTime", DC::ContentTime },
        { "OverlayTime", DC::OverlayTime },
        { "CurveTime", DC::CurveTime },
        { "DataSetType", DC::DataSetType },
        { "DataSetSubtype", DC::DataSetSubtype },
        { "NuclearMedicineSeriesType", DC::NuclearMedicineSeriesType },
        { "AccessionNumber", DC::AccessionNumber },
        { "IssuerOfAccessionNumberSequence", DC::IssuerOfAccessionNumberSequence },
        { "QueryRetrieveLevel", DC::QueryRetrieveLevel },
        { "QueryRetrieveView", DC::QueryRetrieveView },
        { "RetrieveAETitle", DC::RetrieveAETitle },
        { "StationAETitle", DC::StationAETitle },
        { "InstanceAvailability", DC::InstanceAvailability },
        { "FailedSOPInstanceUIDList", DC::FailedSOPInstanceUIDList },
        { "Modality", DC::Modality },
        { "ModalitiesInStudy", DC::ModalitiesInStudy },
        { "SOPClassesInStudy", DC::SOPClassesInStudy },
        { "AnatomicRegionsInStudyCodeSequence", DC::AnatomicRegionsInStudyCodeSequence },
        { "ConversionType", DC::ConversionType },
        { "PresentationIntentType", DC::PresentationIntentType },
        { "Manufacturer", DC::Manufacturer },
        { "InstitutionName", DC::InstitutionName },
        { "InstitutionAddress", DC::InstitutionAddress },
        { "InstitutionCodeSequence", DC::InstitutionCodeSequence },
        { "ReferringPhysicianName", DC::ReferringPhysicianName },
        { "ReferringPhysicianAddress", DC::ReferringPhysicianAddress },
        { "ReferringPhysicianTelephoneNumbers", DC::ReferringPhysicianTelephoneNumbers },
        { "ReferringPhysicianIdentificationSequence", DC::ReferringPhysicianIdentificationSequence },
        { "ConsultingPhysicianName", DC::ConsultingPhysicianName },
        { "ConsultingPhysicianIdentificationSequence", DC::ConsultingPhysicianIdentificationSequence },
        { "CodeValue", DC::CodeValue },
        { "ExtendedCodeValue", DC::ExtendedCodeValue },
        { "CodingSchemeDesignator", DC::CodingSchemeDesignator },
        { "CodingSchemeVersion", DC::CodingSchemeVersion },
        { "CodeMeaning", DC::CodeMeaning },
        { "MappingResource", DC::MappingResource },
        { "ContextGroupVersion", DC::ContextGroupVersion },
        { "ContextGroupLocalVersion", DC::ContextGroupLocalVersion },
        { "ExtendedCodeMeaning", DC::ExtendedCodeMeaning },
        { "CodingSchemeResourcesSequence", DC::CodingSchemeResourcesSequence },
        { "CodingSchemeURLType", DC::CodingSchemeURLType },
        { "ContextGroupExtensionFlag", DC::ContextGroupExtensionFlag },
        { "CodingSchemeUID", DC::CodingSchemeUID },
        { "ContextGroupExtensionCreatorUID", DC::ContextGroupExtensionCreatorUID },
        { "CodingSchemeURL", DC::CodingSchemeURL },
        { "ContextIdentifier", DC::ContextIdentifier },
        { "CodingSchemeIdentificationSequence", DC::CodingSchemeIdentificationSequence },
        { "CodingSchemeRegistry", DC::CodingSchemeRegistry },
        { "CodingSchemeExternalID", DC::CodingSchemeExternalID },
        { "CodingSchemeName", DC::CodingSchemeName },
        { "CodingSchemeResponsibleOrganization", DC::CodingSchemeResponsibleOrganization },
        { "ContextUID", DC::ContextUID },
        { "MappingResourceUID", DC::MappingResourceUID },
        { "LongCodeValue", DC::LongCodeValue },
        { "URNCodeValue", DC::URNCodeValue },
        { "EquivalentCodeSequence", DC::EquivalentCodeSequence },
        { "MappingResourceName", DC::MappingResourceName },
        { "ContextGroupIdentificationSequence", DC::ContextGroupIdentificationSequence },
        { "MappingResourceIdentificationSequence", DC::MappingResourceIdentificationSequence },
        { "TimezoneOffsetFromUTC", DC::TimezoneOffsetFromUTC },
        { "ResponsibleGroupCodeSequence", DC::ResponsibleGroupCodeSequence },
        { "EquipmentModality", DC::EquipmentModality },
        { "ManufacturerRelatedModelGroup", DC::ManufacturerRelatedModelGroup },
        { "PrivateDataElementCharacteristicsSequence", DC::PrivateDataElementCharacteristicsSequence },
        { "PrivateGroupReference", DC::PrivateGroupReference },
        { "PrivateCreatorReference", DC::PrivateCreatorReference },
        { "BlockIdentifyingInformationStatus", DC::BlockIdentifyingInformationStatus },
        { "NonidentifyingPrivateElements", DC::NonidentifyingPrivateElements },
        { "DeidentificationActionSequence", DC::DeidentificationActionSequence },
        { "IdentifyingPrivateElements", DC::IdentifyingPrivateElements },
        { "DeidentificationAction", DC::DeidentificationAction },
        { "PrivateDataElement", DC::PrivateDataElement },
        { "PrivateDataElementValueMultiplicity", DC::PrivateDataElementValueMultiplicity },
        { "PrivateDataElementValueRepresentation", DC::PrivateDataElementValueRepresentation },
        { "PrivateDataElementNumberOfItems", DC::PrivateDataElementNumberOfItems },
        { "PrivateDataElementName", DC::PrivateDataElementName },
        { "PrivateDataElementKeyword", DC::PrivateDataElementKeyword },
        { "PrivateDataElementDescription", DC::PrivateDataElementDescription },
        { "PrivateDataElementEncoding", DC::PrivateDataElementEncoding },
        { "PrivateDataElementDefinitionSequence", DC::PrivateDataElementDefinitionSequence },
        { "ScopeOfInventorySequence", DC::ScopeOfInventorySequence },
        { "InventoryPurpose", DC::InventoryPurpose },
        { "InventoryInstanceDescription", DC::InventoryInstanceDescription },
        { "InventoryLevel", DC::InventoryLevel },
        { "ItemInventoryDateTime", DC::ItemInventoryDateTime },
        { "RemovedFromOperationalUse", DC::RemovedFromOperationalUse },
        { "ReasonForRemovalCodeSequence", DC::ReasonForRemovalCodeSequence },
        { "StoredInstanceBaseURI", DC::StoredInstanceBaseURI },
        { "FolderAccessURI", DC::FolderAccessURI },
        { "FileAccessURI", DC::FileAccessURI },
        { "ContainerFileType", DC::ContainerFileType },
        { "FilenameInContainer", DC::FilenameInContainer },
        { "FileOffsetInContainer", DC::FileOffsetInContainer },
        { "FileLengthInContainer", DC::FileLengthInContainer },
        { "StoredInstanceTransferSyntaxUID", DC::StoredInstanceTransferSyntaxUID },
        { "ExtendedMatchingMechanisms", DC::ExtendedMatchingMechanisms },
        { "RangeMatchingSequence", DC::RangeMatchingSequence },
        { "ListOfUIDMatchingSequence", DC::ListOfUIDMatchingSequence },
        { "EmptyValueMatchingSequence", DC::EmptyValueMatchingSequence },
        { "GeneralMatchingSequence", DC::GeneralMatchingSequence },
        { "RequestedStatusInterval", DC::RequestedStatusInterval },
        { "RetainInstances", DC::RetainInstances },
        { "ExpirationDateTime", DC::ExpirationDateTime },
        { "TransactionStatus", DC::TransactionStatus },
        { "TransactionStatusComment", DC::TransactionStatusComment },
        { "FileSetAccessSequence", DC::FileSetAccessSequence },
        { "FileAccessSequence", DC::FileAccessSequence },
        { "RecordKey", DC::RecordKey },
        { "PriorRecordKey", DC::PriorRecordKey },
        { "MetadataSequence", DC::MetadataSequence },
        { "UpdatedMetadataSequence", DC::UpdatedMetadataSequence },
        { "StudyUpdateDateTime", DC::StudyUpdateDateTime },
        { "InventoryAccessEndPointsSequence", DC::InventoryAccessEndPointsSequence },
        { "StudyAccessEndPointsSequence", DC::StudyAccessEndPointsSequence },
        { "IncorporatedInventoryInstanceSequence", DC::IncorporatedInventoryInstanceSequence },
        { "InventoriedStudiesSequence", DC::InventoriedStudiesSequence },
        { "InventoriedSeriesSequence", DC::InventoriedSeriesSequence },
        { "InventoriedInstancesSequence", DC::InventoriedInstancesSequence },
        { "InventoryCompletionStatus", DC::InventoryCompletionStatus },
        { "NumberOfStudyRecordsInInstance", DC::NumberOfStudyRecordsInInstance },
        { "TotalNumberOfStudyRecords", DC::TotalNumberOfStudyRecords },
        { "MaximumNumberOfRecords", DC::MaximumNumberOfRecords },
        { "NetworkID", DC::NetworkID },
        { "StationName", DC::StationName },
        { "StudyDescription", DC::StudyDescription },
        { "ProcedureCodeSequence", DC::ProcedureCodeSequence },
        { "SeriesDescription", DC::SeriesDescription },
        { "SeriesDescriptionCodeSequence", DC::SeriesDescriptionCodeSequence },
        { "InstitutionalDepartmentName", DC::InstitutionalDepartmentName },
        { "InstitutionalDepartmentTypeCodeSequence", DC::InstitutionalDepartmentTypeCodeSequence },
        { "PhysiciansOfRecord", DC::PhysiciansOfRecord },
        { "PhysiciansOfRecordIdentificationSequence", DC::PhysiciansOfRecordIdentificationSequence },
        { "PerformingPhysicianName", DC::PerformingPhysicianName },
        { "PerformingPhysicianIdentificationSequence", DC::PerformingPhysicianIdentificationSequence },
        { "NameOfPhysiciansReadingStudy", DC::NameOfPhysiciansReadingStudy },
        { "PhysiciansReadingStudyIdentificationSequence", DC::PhysiciansReadingStudyIdentificationSequence },
        { "OperatorsName", DC::OperatorsName },
        { "OperatorIdentificationSequence", DC::OperatorIdentificationSequence },
        { "AdmittingDiagnosesDescription", DC::AdmittingDiagnosesDescription },
        { "AdmittingDiagnosesCodeSequence", DC::AdmittingDiagnosesCodeSequence },
        { "PyramidDescription", DC::PyramidDescription },
        { "ManufacturerModelName", DC::ManufacturerModelName },
        { "ReferencedResultsSequence", DC::ReferencedResultsSequence },
        { "ReferencedStudySequence", DC::ReferencedStudySequence },
        { "ReferencedPerformedProcedureStepSequence", DC::ReferencedPerformedProcedureStepSequence },
        { "ReferencedSeriesSequence", DC::ReferencedSeriesSequence },
        { "ReferencedPatientSequence", DC::ReferencedPatientSequence },
        { "ReferencedVisitSequence", DC::ReferencedVisitSequence },
        { "ReferencedOverlaySequence", DC::ReferencedOverlaySequence },
        { "ReferencedStereometricInstanceSequence", DC::ReferencedStereometricInstanceSequence },
        { "ReferencedWaveformSequence", DC::ReferencedWaveformSequence },
        { "ReferencedImageSequence", DC::ReferencedImageSequence },
        { "ReferencedCurveSequence", DC::ReferencedCurveSequence },
        { "ReferencedInstanceSequence", DC::ReferencedInstanceSequence },
        { "ReferencedRealWorldValueMappingInstanceSequence", DC::ReferencedRealWorldValueMappingInstanceSequence },
        { "ReferencedSOPClassUID", DC::ReferencedSOPClassUID },
        { "ReferencedSOPInstanceUID", DC::ReferencedSOPInstanceUID },
        { "DefinitionSourceSequence", DC::DefinitionSourceSequence },
        { "SOPClassesSupported", DC::SOPClassesSupported },
        { "ReferencedFrameNumber", DC::ReferencedFrameNumber },
        { "SimpleFrameList", DC::SimpleFrameList },
        { "CalculatedFrameList", DC::CalculatedFrameList },
        { "TimeRange", DC::TimeRange },
        { "FrameExtractionSequence", DC::FrameExtractionSequence },
        { "MultiFrameSourceSOPInstanceUID", DC::MultiFrameSourceSOPInstanceUID },
        { "RetrieveURL", DC::RetrieveURL },
        { "TransactionUID", DC::TransactionUID },
        { "WarningReason", DC::WarningReason },
        { "FailureReason", DC::FailureReason },
        { "FailedSOPSequence", DC::FailedSOPSequence },
        { "ReferencedSOPSequence", DC::ReferencedSOPSequence },
        { "OtherFailuresSequence", DC::OtherFailuresSequence },
        { "StudiesContainingOtherReferencedInstancesSequence", DC::StudiesContainingOtherReferencedInstancesSequence },
        { "RelatedSeriesSequence", DC::RelatedSeriesSequence },
        { "LossyImageCompressionRetired", DC::LossyImageCompressionRetired },
        { "DerivationDescription", DC::DerivationDescription },
        { "SourceImageSequence", DC::SourceImageSequence },
        { "StageName", DC::StageName },
        { "StageNumber", DC::StageNumber },
        { "NumberOfStages", DC::NumberOfStages },
        { "ViewName", DC::ViewName },
        { "ViewNumber", DC::ViewNumber },
        { "NumberOfEventTimers", DC::NumberOfEventTimers },
        { "NumberOfViewsInStage", DC::NumberOfViewsInStage },
        { "EventElapsedTimes", DC::EventElapsedTimes },
        { "EventTimerNames", DC::EventTimerNames },
        { "EventTimerSequence", DC::EventTimerSequence },
        { "EventTimeOffset", DC::EventTimeOffset },
        { "EventCodeSequence", DC::EventCodeSequence },
        { "StartTrim", DC::StartTrim },
        { "StopTrim", DC::StopTrim },
        { "RecommendedDisplayFrameRate", DC::RecommendedDisplayFrameRate },
        { "TransducerPosition", DC::TransducerPosition },
        { "TransducerOrientation", DC::TransducerOrientation },
        { "AnatomicStructure", DC::AnatomicStructure },
        { "AnatomicRegionSequence", DC::AnatomicRegionSequence },
        { "AnatomicRegionModifierSequence", DC::AnatomicRegionModifierSequence },
        { "PrimaryAnatomicStructureSequence", DC::PrimaryAnatomicStructureSequence },
        { "AnatomicStructureSpaceOrRegionSequence", DC::AnatomicStructureSpaceOrRegionSequence },
        { "PrimaryAnatomicStructureModifierSequence", DC::PrimaryAnatomicStructureModifierSequence },
        { "TransducerPositionSequence", DC::TransducerPositionSequence },
        { "TransducerPositionModifierSequence", DC::TransducerPositionModifierSequence },
        { "TransducerOrientationSequence", DC::TransducerOrientationSequence },
        { "TransducerOrientationModifierSequence", DC::TransducerOrientationModifierSequence },
        { "AnatomicStructureSpaceOrRegionCodeSequenceTrial", DC::AnatomicStructureSpaceOrRegionCodeSequenceTrial },
        { "AnatomicPortalOfEntranceCodeSequenceTrial", DC::AnatomicPortalOfEntranceCodeSequenceTrial },
        { "AnatomicApproachDirectionCodeSequenceTrial", DC::AnatomicApproachDirectionCodeSequenceTrial },
        { "AnatomicPerspectiveDescriptionTrial", DC::AnatomicPerspectiveDescriptionTrial },
        { "AnatomicPerspectiveCodeSequenceTrial", DC::AnatomicPerspectiveCodeSequenceTrial },
        { "AnatomicLocationOfExaminingInstrumentDescriptionTrial", DC::AnatomicLocationOfExaminingInstrumentDescriptionTrial },
        { "AnatomicLocationOfExaminingInstrumentCodeSequenceTrial", DC::AnatomicLocationOfExaminingInstrumentCodeSequenceTrial },
        { "AnatomicStructureSpaceOrRegionModifierCodeSequenceTrial", DC::AnatomicStructureSpaceOrRegionModifierCodeSequenceTrial },
        { "OnAxisBackgroundAnatomicStructureCodeSequenceTrial", DC::OnAxisBackgroundAnatomicStructureCodeSequenceTrial },
        { "AlternateRepresentationSequence", DC::AlternateRepresentationSequence },
        { "AvailableTransferSyntaxUID", DC::AvailableTransferSyntaxUID },
        { "IrradiationEventUID", DC::IrradiationEventUID },
        { "SourceIrradiationEventSequence", DC::SourceIrradiationEventSequence },
        { "RadiopharmaceuticalAdministrationEventUID", DC::RadiopharmaceuticalAdministrationEventUID },
        { "IdentifyingComments", DC::IdentifyingComments },
        { "FrameType", DC::FrameType },
        { "ReferencedImageEvidenceSequence", DC::ReferencedImageEvidenceSequence },
        { "ReferencedRawDataSequence", DC::ReferencedRawDataSequence },
        { "CreatorVersionUID", DC::CreatorVersionUID },
        { "DerivationImageSequence", DC::DerivationImageSequence },
        { "SourceImageEvidenceSequence", DC::SourceImageEvidenceSequence },
        { "PixelPresentation", DC::PixelPresentation },
        { "VolumetricProperties", DC::VolumetricProperties },
        { "VolumeBasedCalculationTechnique", DC::VolumeBasedCalculationTechnique },
        { "ComplexImageComponent", DC::ComplexImageComponent },
        { "AcquisitionContrast", DC::AcquisitionContrast },
        { "DerivationCodeSequence", DC::DerivationCodeSequence },
        { "ReferencedPresentationStateSequence", DC::ReferencedPresentationStateSequence },
        { "ReferencedOtherPlaneSequence", DC::ReferencedOtherPlaneSequence },
        { "FrameDisplaySequence", DC::FrameDisplaySequence },
        { "RecommendedDisplayFrameRateInFloat", DC::RecommendedDisplayFrameRateInFloat },
        { "SkipFrameRangeFlag", DC::SkipFrameRangeFlag },
        { "PatientName", DC::PatientName },
        { "PatientID", DC::PatientID },
        { "IssuerOfPatientID", DC::IssuerOfPatientID },
        { "TypeOfPatientID", DC::TypeOfPatientID },
        { "IssuerOfPatientIDQualifiersSequence", DC::IssuerOfPatientIDQualifiersSequence },
        { "SourcePatientGroupIdentificationSequence", DC::SourcePatientGroupIdentificationSequence },
        { "GroupOfPatientsIdentificationSequence", DC::GroupOfPatientsIdentificationSequence },
        { "SubjectRelativePositionInImage", DC::SubjectRelativePositionInImage },
        { "PatientBirthDate", DC::PatientBirthDate },
        { "PatientBirthTime", DC::PatientBirthTime },
        { "PatientBirthDateInAlternativeCalendar", DC::PatientBirthDateInAlternativeCalendar },
        { "PatientDeathDateInAlternativeCalendar", DC::PatientDeathDateInAlternativeCalendar },
        { "PatientAlternativeCalendar", DC::PatientAlternativeCalendar },
        { "PatientSex", DC::PatientSex },
        { "PatientInsurancePlanCodeSequence", DC::PatientInsurancePlanCodeSequence },
        { "PatientPrimaryLanguageCodeSequence", DC::PatientPrimaryLanguageCodeSequence },
        { "PatientPrimaryLanguageModifierCodeSequence", DC::PatientPrimaryLanguageModifierCodeSequence },
        { "QualityControlSubject", DC::QualityControlSubject },
        { "QualityControlSubjectTypeCodeSequence", DC::QualityControlSubjectTypeCodeSequence },
        { "StrainDescription", DC::StrainDescription },
        { "StrainNomenclature", DC::StrainNomenclature },
        { "StrainStockNumber", DC::StrainStockNumber },
        { "StrainSourceRegistryCodeSequence", DC::StrainSourceRegistryCodeSequence },
        { "StrainStockSequence", DC::StrainStockSequence },
        { "StrainSource", DC::StrainSource },
        { "StrainAdditionalInformation", DC::StrainAdditionalInformation },
        { "StrainCodeSequence", DC::StrainCodeSequence },
        { "GeneticModificationsSequence", DC::GeneticModificationsSequence },
        { "GeneticModificationsDescription", DC::GeneticModificationsDescription },
        { "GeneticModificationsNomenclature", DC::GeneticModificationsNomenclature },
        { "GeneticModificationsCodeSequence", DC::GeneticModificationsCodeSequence },
        { "OtherPatientIDs", DC::OtherPatientIDs },
        { "OtherPatientNames", DC::OtherPatientNames },
        { "OtherPatientIDsSequence", DC::OtherPatientIDsSequence },
        { "PatientBirthName", DC::PatientBirthName },
        { "PatientAge", DC::PatientAge },
        { "PatientSize", DC::PatientSize },
        { "PatientSizeCodeSequence", DC::PatientSizeCodeSequence },
        { "PatientBodyMassIndex", DC::PatientBodyMassIndex },
        { "MeasuredAPDimension", DC::MeasuredAPDimension },
        { "MeasuredLateralDimension", DC::MeasuredLateralDimension },
        { "PatientWeight", DC::PatientWeight },
        { "PatientAddress", DC::PatientAddress },
        { "InsurancePlanIdentification", DC::InsurancePlanIdentification },
        { "PatientMotherBirthName", DC::PatientMotherBirthName },
        { "MilitaryRank", DC::MilitaryRank },
        { "BranchOfService", DC::BranchOfService },
        { "MedicalRecordLocator", DC::MedicalRecordLocator },
        { "ReferencedPatientPhotoSequence", DC::ReferencedPatientPhotoSequence },
        { "MedicalAlerts", DC::MedicalAlerts },
        { "Allergies", DC::Allergies },
        { "CountryOfResidence", DC::CountryOfResidence },
        { "RegionOfResidence", DC::RegionOfResidence },
        { "PatientTelephoneNumbers", DC::PatientTelephoneNumbers },
        { "PatientTelecomInformation", DC::PatientTelecomInformation },
        { "EthnicGroup", DC::EthnicGroup },
        { "Occupation", DC::Occupation },
        { "SmokingStatus", DC::SmokingStatus },
        { "AdditionalPatientHistory", DC::AdditionalPatientHistory },
        { "PregnancyStatus", DC::PregnancyStatus },
        { "LastMenstrualDate", DC::LastMenstrualDate },
        { "PatientReligiousPreference", DC::PatientReligiousPreference },
        { "PatientSpeciesDescription", DC::PatientSpeciesDescription },
        { "PatientSpeciesCodeSequence", DC::PatientSpeciesCodeSequence },
        { "PatientSexNeutered", DC::PatientSexNeutered },
        { "AnatomicalOrientationType", DC::AnatomicalOrientationType },
        { "PatientBreedDescription", DC::PatientBreedDescription },
        { "PatientBreedCodeSequence", DC::PatientBreedCodeSequence },
        { "BreedRegistrationSequence", DC::BreedRegistrationSequence },
        { "BreedRegistrationNumber", DC::BreedRegistrationNumber },
        { "BreedRegistryCodeSequence", DC::BreedRegistryCodeSequence },
        { "ResponsiblePerson", DC::ResponsiblePerson },
        { "ResponsiblePersonRole", DC::ResponsiblePersonRole },
        { "ResponsibleOrganization", DC::ResponsibleOrganization },
        { "PatientComments", DC::PatientComments },
        { "ExaminedBodyThickness", DC::ExaminedBodyThickness },
        { "ClinicalTrialSponsorName", DC::ClinicalTrialSponsorName },
        { "ClinicalTrialProtocolID", DC::ClinicalTrialProtocolID },
        { "ClinicalTrialProtocolName", DC::ClinicalTrialProtocolName },
        { "ClinicalTrialSiteID", DC::ClinicalTrialSiteID },
        { "ClinicalTrialSiteName", DC::ClinicalTrialSiteName },
        { "ClinicalTrialSubjectID", DC::ClinicalTrialSubjectID },
        { "ClinicalTrialSubjectReadingID", DC::ClinicalTrialSubjectReadingID },
        { "ClinicalTrialTimePointID", DC::ClinicalTrialTimePointID },
        { "ClinicalTrialTimePointDescription", DC::ClinicalTrialTimePointDescription },
        { "LongitudinalTemporalOffsetFromEvent", DC::LongitudinalTemporalOffsetFromEvent },
        { "LongitudinalTemporalEventType", DC::LongitudinalTemporalEventType },
        { "ClinicalTrialTimePointTypeCodeSequence", DC::ClinicalTrialTimePointTypeCodeSequence },
        { "ClinicalTrialCoordinatingCenterName", DC::ClinicalTrialCoordinatingCenterName },
        { "PatientIdentityRemoved", DC::PatientIdentityRemoved },
        { "DeidentificationMethod", DC::DeidentificationMethod },
        { "DeidentificationMethodCodeSequence", DC::DeidentificationMethodCodeSequence },
        { "ClinicalTrialSeriesID", DC::ClinicalTrialSeriesID },
        { "ClinicalTrialSeriesDescription", DC::ClinicalTrialSeriesDescription },
        { "ClinicalTrialProtocolEthicsCommitteeName", DC::ClinicalTrialProtocolEthicsCommitteeName },
        { "ClinicalTrialProtocolEthicsCommitteeApprovalNumber", DC::ClinicalTrialProtocolEthicsCommitteeApprovalNumber },
        { "ConsentForClinicalTrialUseSequence", DC::ConsentForClinicalTrialUseSequence },
        { "DistributionType", DC::DistributionType },
        { "ConsentForDistributionFlag", DC::ConsentForDistributionFlag },
        { "EthicsCommitteeApprovalEffectivenessStartDate", DC::EthicsCommitteeApprovalEffectivenessStartDate },
        { "EthicsCommitteeApprovalEffectivenessEndDate", DC::EthicsCommitteeApprovalEffectivenessEndDate },
        { "CADFileFormat", DC::CADFileFormat },
        { "ComponentReferenceSystem", DC::ComponentReferenceSystem },
        { "ComponentManufacturingProcedure", DC::ComponentManufacturingProcedure },
        { "ComponentManufacturer", DC::ComponentManufacturer },
        { "MaterialThickness", DC::MaterialThickness },
        { "MaterialPipeDiameter", DC::MaterialPipeDiameter },
        { "MaterialIsolationDiameter", DC::MaterialIsolationDiameter },
        { "MaterialGrade", DC::MaterialGrade },
        { "MaterialPropertiesDescription", DC::MaterialPropertiesDescription },
        { "MaterialPropertiesFileFormatRetired", DC::MaterialPropertiesFileFormatRetired },
        { "MaterialNotes", DC::MaterialNotes },
        { "ComponentShape", DC::ComponentShape },
        { "CurvatureType", DC::CurvatureType },
        { "OuterDiameter", DC::OuterDiameter },
        { "InnerDiameter", DC::InnerDiameter },
        { "ComponentWelderIDs", DC::ComponentWelderIDs },
        { "SecondaryApprovalStatus", DC::SecondaryApprovalStatus },
        { "SecondaryReviewDate", DC::SecondaryReviewDate },
        { "SecondaryReviewTime", DC::SecondaryReviewTime },
        { "SecondaryReviewerName", DC::SecondaryReviewerName },
        { "RepairID", DC::RepairID },
        { "MultipleComponentApprovalSequence", DC::MultipleComponentApprovalSequence },
        { "OtherApprovalStatus", DC::OtherApprovalStatus },
        { "OtherSecondaryApprovalStatus", DC::OtherSecondaryApprovalStatus },
        { "DataElementLabelSequence", DC::DataElementLabelSequence },
        { "DataElementLabelItemSequence", DC::DataElementLabelItemSequence },
        { "DataElement", DC::DataElement },
        { "DataElementName", DC::DataElementName },
        { "DataElementDescription", DC::DataElementDescription },
        { "DataElementConditionality", DC::DataElementConditionality },
        { "DataElementMinimumCharacters", DC::DataElementMinimumCharacters },
        { "DataElementMaximumCharacters", DC::DataElementMaximumCharacters },
        { "ActualEnvironmentalConditions", DC::ActualEnvironmentalConditions },
        { "ExpiryDate", DC::ExpiryDate },
        { "EnvironmentalConditions", DC::EnvironmentalConditions },
        { "EvaluatorSequence", DC::EvaluatorSequence },
        { "EvaluatorNumber", DC::EvaluatorNumber },
        { "EvaluatorName", DC::EvaluatorName },
        { "EvaluationAttempt", DC::EvaluationAttempt },
        { "IndicationSequence", DC::IndicationSequence },
        { "IndicationNumber", DC::IndicationNumber },
        { "IndicationLabel", DC::IndicationLabel },
        { "IndicationDescription", DC::IndicationDescription },
        { "IndicationType", DC::IndicationType },
        { "IndicationDisposition", DC::IndicationDisposition },
        { "IndicationROISequence", DC::IndicationROISequence },
        { "IndicationPhysicalPropertySequence", DC::IndicationPhysicalPropertySequence },
        { "PropertyLabel", DC::PropertyLabel },
        { "CoordinateSystemNumberOfAxes", DC::CoordinateSystemNumberOfAxes },
        { "CoordinateSystemAxesSequence", DC::CoordinateSystemAxesSequence },
        { "CoordinateSystemAxisDescription", DC::CoordinateSystemAxisDescription },
        { "CoordinateSystemDataSetMapping", DC::CoordinateSystemDataSetMapping },
        { "CoordinateSystemAxisNumber", DC::CoordinateSystemAxisNumber },
        { "CoordinateSystemAxisType", DC::CoordinateSystemAxisType },
        { "CoordinateSystemAxisUnits", DC::CoordinateSystemAxisUnits },
        { "CoordinateSystemAxisValues", DC::CoordinateSystemAxisValues },
        { "CoordinateSystemTransformSequence", DC::CoordinateSystemTransformSequence },
        { "TransformDescription", DC::TransformDescription },
        { "TransformNumberOfAxes", DC::TransformNumberOfAxes },
        { "TransformOrderOfAxes", DC::TransformOrderOfAxes },
        { "TransformedAxisUnits", DC::TransformedAxisUnits },
        { "CoordinateSystemTransformRotationAndScaleMatrix", DC::CoordinateSystemTransformRotationAndScaleMatrix },
        { "CoordinateSystemTransformTranslationMatrix", DC::CoordinateSystemTransformTranslationMatrix },
        { "InternalDetectorFrameTime", DC::InternalDetectorFrameTime },
        { "NumberOfFramesIntegrated", DC::NumberOfFramesIntegrated },
        { "DetectorTemperatureSequence", DC::DetectorTemperatureSequence },
        { "SensorName", DC::SensorName },
        { "HorizontalOffsetOfSensor", DC::HorizontalOffsetOfSensor },
        { "VerticalOffsetOfSensor", DC::VerticalOffsetOfSensor },
        { "SensorTemperature", DC::SensorTemperature },
        { "DarkCurrentSequence", DC::DarkCurrentSequence },
        { "DarkCurrentCounts", DC::DarkCurrentCounts },
        { "GainCorrectionReferenceSequence", DC::GainCorrectionReferenceSequence },
        { "AirCounts", DC::AirCounts },
        { "KVUsedInGainCalibration", DC::KVUsedInGainCalibration },
        { "MAUsedInGainCalibration", DC::MAUsedInGainCalibration },
        { "NumberOfFramesUsedForIntegration", DC::NumberOfFramesUsedForIntegration },
        { "FilterMaterialUsedInGainCalibration", DC::FilterMaterialUsedInGainCalibration },
        { "FilterThicknessUsedInGainCalibration", DC::FilterThicknessUsedInGainCalibration },
        { "DateOfGainCalibration", DC::DateOfGainCalibration },
        { "TimeOfGainCalibration", DC::TimeOfGainCalibration },
        { "BadPixelImage", DC::BadPixelImage },
        { "CalibrationNotes", DC::CalibrationNotes },
        { "LinearityCorrectionTechnique", DC::LinearityCorrectionTechnique },
        { "BeamHardeningCorrectionTechnique", DC::BeamHardeningCorrectionTechnique },
        { "PulserEquipmentSequence", DC::PulserEquipmentSequence },
        { "PulserType", DC::PulserType },
        { "PulserNotes", DC::PulserNotes },
        { "ReceiverEquipmentSequence", DC::ReceiverEquipmentSequence },
        { "AmplifierType", DC::AmplifierType },
        { "ReceiverNotes", DC::ReceiverNotes },
        { "PreAmplifierEquipmentSequence", DC::PreAmplifierEquipmentSequence },
        { "PreAmplifierNotes", DC::PreAmplifierNotes },
        { "TransmitTransducerSequence", DC::TransmitTransducerSequence },
        { "ReceiveTransducerSequence", DC::ReceiveTransducerSequence },
        { "NumberOfElements", DC::NumberOfElements },
        { "ElementShape", DC::ElementShape },
        { "ElementDimensionA", DC::ElementDimensionA },
        { "ElementDimensionB", DC::ElementDimensionB },
        { "ElementPitchA", DC::ElementPitchA },
        { "MeasuredBeamDimensionA", DC::MeasuredBeamDimensionA },
        { "MeasuredBeamDimensionB", DC::MeasuredBeamDimensionB },
        { "LocationOfMeasuredBeamDiameter", DC::LocationOfMeasuredBeamDiameter },
        { "NominalFrequency", DC::NominalFrequency },
        { "MeasuredCenterFrequency", DC::MeasuredCenterFrequency },
        { "MeasuredBandwidth", DC::MeasuredBandwidth },
        { "ElementPitchB", DC::ElementPitchB },
        { "PulserSettingsSequence", DC::PulserSettingsSequence },
        { "PulseWidth", DC::PulseWidth },
        { "ExcitationFrequency", DC::ExcitationFrequency },
        { "ModulationType", DC::ModulationType },
        { "Damping", DC::Damping },
        { "ReceiverSettingsSequence", DC::ReceiverSettingsSequence },
        { "AcquiredSoundpathLength", DC::AcquiredSoundpathLength },
        { "AcquisitionCompressionType", DC::AcquisitionCompressionType },
        { "AcquisitionSampleSize", DC::AcquisitionSampleSize },
        { "RectifierSmoothing", DC::RectifierSmoothing },
        { "DACSequence", DC::DACSequence },
        { "DACType", DC::DACType },
        { "DACGainPoints", DC::DACGainPoints },
        { "DACTimePoints", DC::DACTimePoints },
        { "DACAmplitude", DC::DACAmplitude },
        { "PreAmplifierSettingsSequence", DC::PreAmplifierSettingsSequence },
        { "TransmitTransducerSettingsSequence", DC::TransmitTransducerSettingsSequence },
        { "ReceiveTransducerSettingsSequence", DC::ReceiveTransducerSettingsSequence },
        { "IncidentAngle", DC::IncidentAngle },
        { "CouplingTechnique", DC::CouplingTechnique },
        { "CouplingMedium", DC::CouplingMedium },
        { "CouplingVelocity", DC::CouplingVelocity },
        { "ProbeCenterLocationX", DC::ProbeCenterLocationX },
        { "ProbeCenterLocationZ", DC::ProbeCenterLocationZ },
        { "SoundPathLength", DC::SoundPathLength },
        { "DelayLawIdentifier", DC::DelayLawIdentifier },
        { "GateSettingsSequence", DC::GateSettingsSequence },
        { "GateThreshold", DC::GateThreshold },
        { "VelocityOfSound", DC::VelocityOfSound },
        { "CalibrationSettingsSequence", DC::CalibrationSettingsSequence },
        { "CalibrationProcedure", DC::CalibrationProcedure },
        { "ProcedureVersion", DC::ProcedureVersion },
        { "ProcedureCreationDate", DC::ProcedureCreationDate },
        { "ProcedureExpirationDate", DC::ProcedureExpirationDate },
        { "ProcedureLastModifiedDate", DC::ProcedureLastModifiedDate },
        { "CalibrationTime", DC::CalibrationTime },
        { "CalibrationDate", DC::CalibrationDate },
        { "ProbeDriveEquipmentSequence", DC::ProbeDriveEquipmentSequence },
        { "DriveType", DC::DriveType },
        { "ProbeDriveNotes", DC::ProbeDriveNotes },
        { "DriveProbeSequence", DC::DriveProbeSequence },
        { "ProbeInductance", DC::ProbeInductance },
        { "ProbeResistance", DC::ProbeResistance },
        { "ReceiveProbeSequence", DC::ReceiveProbeSequence },
        { "ProbeDriveSettingsSequence", DC::ProbeDriveSettingsSequence },
        { "BridgeResistors", DC::BridgeResistors },
        { "ProbeOrientationAngle", DC::ProbeOrientationAngle },
        { "UserSelectedGainY", DC::UserSelectedGainY },
        { "UserSelectedPhase", DC::UserSelectedPhase },
        { "UserSelectedOffsetX", DC::UserSelectedOffsetX },
        { "UserSelectedOffsetY", DC::UserSelectedOffsetY },
        { "ChannelSettingsSequence", DC::ChannelSettingsSequence },
        { "ChannelThreshold", DC::ChannelThreshold },
        { "ScannerSettingsSequence", DC::ScannerSettingsSequence },
        { "ScanProcedure", DC::ScanProcedure },
        { "TranslationRateX", DC::TranslationRateX },
        { "TranslationRateY", DC::TranslationRateY },
        { "ChannelOverlap", DC::ChannelOverlap },
        { "ImageQualityIndicatorType", DC::ImageQualityIndicatorType },
        { "ImageQualityIndicatorMaterial", DC::ImageQualityIndicatorMaterial },
        { "ImageQualityIndicatorSize", DC::ImageQualityIndicatorSize },
        { "LINACEnergy", DC::LINACEnergy },
        { "LINACOutput", DC::LINACOutput },
        { "ActiveAperture", DC::ActiveAperture },
        { "TotalAperture", DC::TotalAperture },
        { "ApertureElevation", DC::ApertureElevation },
        { "MainLobeAngle", DC::MainLobeAngle },
        { "MainRoofAngle", DC::MainRoofAngle },
        { "ConnectorType", DC::ConnectorType },
        { "WedgeModelNumber", DC::WedgeModelNumber },
        { "WedgeAngleFloat", DC::WedgeAngleFloat },
        { "WedgeRoofAngle", DC::WedgeRoofAngle },
        { "WedgeElement1Position", DC::WedgeElement1Position },
        { "WedgeMaterialVelocity", DC::WedgeMaterialVelocity },
        { "WedgeMaterial", DC::WedgeMaterial },
        { "WedgeOffsetZ", DC::WedgeOffsetZ },
        { "WedgeOriginOffsetX", DC::WedgeOriginOffsetX },
        { "WedgeTimeDelay", DC::WedgeTimeDelay },
        { "WedgeName", DC::WedgeName },
        { "WedgeManufacturerName", DC::WedgeManufacturerName },
        { "WedgeDescription", DC::WedgeDescription },
        { "NominalBeamAngle", DC::NominalBeamAngle },
        { "WedgeOffsetX", DC::WedgeOffsetX },
        { "WedgeOffsetY", DC::WedgeOffsetY },
        { "WedgeTotalLength", DC::WedgeTotalLength },
        { "WedgeInContactLength", DC::WedgeInContactLength },
        { "WedgeFrontGap", DC::WedgeFrontGap },
        { "WedgeTotalHeight", DC::WedgeTotalHeight },
        { "WedgeFrontHeight", DC::WedgeFrontHeight },
        { "WedgeRearHeight", DC::WedgeRearHeight },
        { "WedgeTotalWidth", DC::WedgeTotalWidth },
        { "WedgeInContactWidth", DC::WedgeInContactWidth },
        { "WedgeChamferHeight", DC::WedgeChamferHeight },
        { "WedgeCurve", DC::WedgeCurve },
        { "RadiusAlongWedge", DC::RadiusAlongWedge },
        { "WhitePoint", DC::WhitePoint },
        { "PrimaryChromaticities", DC::PrimaryChromaticities },
        { "BatteryLevel", DC::BatteryLevel },
        { "ExposureTimeInSeconds", DC::ExposureTimeInSeconds },
        { "FNumber", DC::FNumber },
        { "OECFRows", DC::OECFRows },
        { "OECFColumns", DC::OECFColumns },
        { "OECFColumnNames", DC::OECFColumnNames },
        { "OECFValues", DC::OECFValues },
        { "SpatialFrequencyResponseRows", DC::SpatialFrequencyResponseRows },
        { "SpatialFrequencyResponseColumns", DC::SpatialFrequencyResponseColumns },
        { "SpatialFrequencyResponseColumnNames", DC::SpatialFrequencyResponseColumnNames },
        { "SpatialFrequencyResponseValues", DC::SpatialFrequencyResponseValues },
        { "ColorFilterArrayPatternRows", DC::ColorFilterArrayPatternRows },
        { "ColorFilterArrayPatternColumns", DC::ColorFilterArrayPatternColumns },
        { "ColorFilterArrayPatternValues", DC::ColorFilterArrayPatternValues },
        { "FlashFiringStatus", DC::FlashFiringStatus },
        { "FlashReturnStatus", DC::FlashReturnStatus },
        { "FlashMode", DC::FlashMode },
        { "FlashFunctionPresent", DC::FlashFunctionPresent },
        { "FlashRedEyeMode", DC::FlashRedEyeMode },
        { "ExposureProgram", DC::ExposureProgram },
        { "SpectralSensitivity", DC::SpectralSensitivity },
        { "PhotographicSensitivity", DC::PhotographicSensitivity },
        { "SelfTimerMode", DC::SelfTimerMode },
        { "SensitivityType", DC::SensitivityType },
        { "StandardOutputSensitivity", DC::StandardOutputSensitivity },
        { "RecommendedExposureIndex", DC::RecommendedExposureIndex },
        { "ISOSpeed", DC::ISOSpeed },
        { "ISOSpeedLatitudeyyy", DC::ISOSpeedLatitudeyyy },
        { "ISOSpeedLatitudezzz", DC::ISOSpeedLatitudezzz },
        { "EXIFVersion", DC::EXIFVersion },
        { "ShutterSpeedValue", DC::ShutterSpeedValue },
        { "ApertureValue", DC::ApertureValue },
        { "BrightnessValue", DC::BrightnessValue },
        { "ExposureBiasValue", DC::ExposureBiasValue },
        { "MaxApertureValue", DC::MaxApertureValue },
        { "SubjectDistance", DC::SubjectDistance },
        { "MeteringMode", DC::MeteringMode },
        { "LightSource", DC::LightSource },
        { "FocalLength", DC::FocalLength },
        { "SubjectArea", DC::SubjectArea },
        { "MakerNote", DC::MakerNote },
        { "Temperature", DC::Temperature },
        { "Humidity", DC::Humidity },
        { "Pressure", DC::Pressure },
        { "WaterDepth", DC::WaterDepth },
        { "Acceleration", DC::Acceleration },
        { "CameraElevationAngle", DC::CameraElevationAngle },
        { "FlashEnergy", DC::FlashEnergy },
        { "SubjectLocation", DC::SubjectLocation },
        { "PhotographicExposureIndex", DC::PhotographicExposureIndex },
        { "SensingMethod", DC::SensingMethod },
        { "FileSource", DC::FileSource },
        { "SceneType", DC::SceneType },
        { "CustomRendered", DC::CustomRendered },
        { "ExposureMode", DC::ExposureMode },
        { "WhiteBalance", DC::WhiteBalance },
        { "DigitalZoomRatio", DC::DigitalZoomRatio },
        { "FocalLengthIn35mmFilm", DC::FocalLengthIn35mmFilm },
        { "SceneCaptureType", DC::SceneCaptureType },
        { "GainControl", DC::GainControl },
        { "Contrast", DC::Contrast },
        { "Saturation", DC::Saturation },
        { "Sharpness", DC::Sharpness },
        { "DeviceSettingDescription", DC::DeviceSettingDescription },
        { "SubjectDistanceRange", DC::SubjectDistanceRange },
        { "CameraOwnerName", DC::CameraOwnerName },
        { "LensSpecification", DC::LensSpecification },
        { "LensMake", DC::LensMake },
        { "LensModel", DC::LensModel },
        { "LensSerialNumber", DC::LensSerialNumber },
        { "InteroperabilityIndex", DC::InteroperabilityIndex },
        { "InteroperabilityVersion", DC::InteroperabilityVersion },
        { "GPSVersionID", DC::GPSVersionID },
        { "GPSLatitudeRef", DC::GPSLatitudeRef },
        { "GPSLatitude", DC::GPSLatitude },
        { "GPSLongitudeRef", DC::GPSLongitudeRef },
        { "GPSLongitude", DC::GPSLongitude },
        { "GPSAltitudeRef", DC::GPSAltitudeRef },
        { "GPSAltitude", DC::GPSAltitude },
        { "GPSTimeStamp", DC::GPSTimeStamp },
        { "GPSSatellites", DC::GPSSatellites },
        { "GPSStatus", DC::GPSStatus },
        { "GPSMeasureMode", DC::GPSMeasureMode },
        { "GPSDOP", DC::GPSDOP },
        { "GPSSpeedRef", DC::GPSSpeedRef },
        { "GPSSpeed", DC::GPSSpeed },
        { "GPSTrackRef", DC::GPSTrackRef },
        { "GPSTrack", DC::GPSTrack },
        { "GPSImgDirectionRef", DC::GPSImgDirectionRef },
        { "GPSImgDirection", DC::GPSImgDirection },
        { "GPSMapDatum", DC::GPSMapDatum },
        { "GPSDestLatitudeRef", DC::GPSDestLatitudeRef },
        { "GPSDestLatitude", DC::GPSDestLatitude },
        { "GPSDestLongitudeRef", DC::GPSDestLongitudeRef },
        { "GPSDestLongitude", DC::GPSDestLongitude },
        { "GPSDestBearingRef", DC::GPSDestBearingRef },
        { "GPSDestBearing", DC::GPSDestBearing },
        { "GPSDestDistanceRef", DC::GPSDestDistanceRef },
        { "GPSDestDistance", DC::GPSDestDistance },
        { "GPSProcessingMethod", DC::GPSProcessingMethod },
        { "GPSAreaInformation", DC::GPSAreaInformation },
        { "GPSDateStamp", DC::GPSDateStamp },
        { "GPSDifferential", DC::GPSDifferential },
        { "LightSourcePolarization", DC::LightSourcePolarization },
        { "EmitterColorTemperature", DC::EmitterColorTemperature },
        { "ContactMethod", DC::ContactMethod },
        { "ImmersionMedia", DC::ImmersionMedia },
        { "OpticalMagnificationFactor", DC::OpticalMagnificationFactor },
        { "ContrastBolusAgent", DC::ContrastBolusAgent },
        { "ContrastBolusAgentSequence", DC::ContrastBolusAgentSequence },
        { "ContrastBolusT1Relaxivity", DC::ContrastBolusT1Relaxivity },
        { "ContrastBolusAdministrationRouteSequence", DC::ContrastBolusAdministrationRouteSequence },
        { "BodyPartExamined", DC::BodyPartExamined },
        { "ScanningSequence", DC::ScanningSequence },
        { "SequenceVariant", DC::SequenceVariant },
        { "ScanOptions", DC::ScanOptions },
        { "MRAcquisitionType", DC::MRAcquisitionType },
        { "SequenceName", DC::SequenceName },
        { "AngioFlag", DC::AngioFlag },
        { "InterventionDrugInformationSequence", DC::InterventionDrugInformationSequence },
        { "InterventionDrugStopTime", DC::InterventionDrugStopTime },
        { "InterventionDrugDose", DC::InterventionDrugDose },
        { "InterventionDrugCodeSequence", DC::InterventionDrugCodeSequence },
        { "AdditionalDrugSequence", DC::AdditionalDrugSequence },
        { "Radionuclide", DC::Radionuclide },
        { "Radiopharmaceutical", DC::Radiopharmaceutical },
        { "EnergyWindowCenterline", DC::EnergyWindowCenterline },
        { "EnergyWindowTotalWidth", DC::EnergyWindowTotalWidth },
        { "InterventionDrugName", DC::InterventionDrugName },
        { "InterventionDrugStartTime", DC::InterventionDrugStartTime },
        { "InterventionSequence", DC::InterventionSequence },
        { "TherapyType", DC::TherapyType },
        { "InterventionStatus", DC::InterventionStatus },
        { "TherapyDescription", DC::TherapyDescription },
        { "InterventionDescription", DC::InterventionDescription },
        { "CineRate", DC::CineRate },
        { "InitialCineRunState", DC::InitialCineRunState },
        { "SliceThickness", DC::SliceThickness },
        { "KVP", DC::KVP },
        { "CountsAccumulated", DC::CountsAccumulated },
        { "AcquisitionTerminationCondition", DC::AcquisitionTerminationCondition },
        { "EffectiveDuration", DC::EffectiveDuration },
        { "AcquisitionStartCondition", DC::AcquisitionStartCondition },
        { "AcquisitionStartConditionData", DC::AcquisitionStartConditionData },
        { "AcquisitionTerminationConditionData", DC::AcquisitionTerminationConditionData },
        { "RepetitionTime", DC::RepetitionTime },
        { "EchoTime", DC::EchoTime },
        { "InversionTime", DC::InversionTime },
        { "NumberOfAverages", DC::NumberOfAverages },
        { "ImagingFrequency", DC::ImagingFrequency },
        { "ImagedNucleus", DC::ImagedNucleus },
        { "EchoNumbers", DC::EchoNumbers },
        { "MagneticFieldStrength", DC::MagneticFieldStrength },
        { "SpacingBetweenSlices", DC::SpacingBetweenSlices },
        { "NumberOfPhaseEncodingSteps", DC::NumberOfPhaseEncodingSteps },
        { "DataCollectionDiameter", DC::DataCollectionDiameter },
        { "EchoTrainLength", DC::EchoTrainLength },
        { "PercentSampling", DC::PercentSampling },
        { "PercentPhaseFieldOfView", DC::PercentPhaseFieldOfView },
        { "PixelBandwidth", DC::PixelBandwidth },
        { "DeviceSerialNumber", DC::DeviceSerialNumber },
        { "DeviceUID", DC::DeviceUID },
        { "DeviceID", DC::DeviceID },
        { "PlateID", DC::PlateID },
        { "GeneratorID", DC::GeneratorID },
        { "GridID", DC::GridID },
        { "CassetteID", DC::CassetteID },
        { "GantryID", DC::GantryID },
        { "UniqueDeviceIdentifier", DC::UniqueDeviceIdentifier },
        { "UDISequence", DC::UDISequence },
        { "ManufacturerDeviceClassUID", DC::ManufacturerDeviceClassUID },
        { "SecondaryCaptureDeviceID", DC::SecondaryCaptureDeviceID },
        { "HardcopyCreationDeviceID", DC::HardcopyCreationDeviceID },
        { "DateOfSecondaryCapture", DC::DateOfSecondaryCapture },
        { "TimeOfSecondaryCapture", DC::TimeOfSecondaryCapture },
        { "SecondaryCaptureDeviceManufacturer", DC::SecondaryCaptureDeviceManufacturer },
        { "HardcopyDeviceManufacturer", DC::HardcopyDeviceManufacturer },
        { "SecondaryCaptureDeviceManufacturerModelName", DC::SecondaryCaptureDeviceManufacturerModelName },
        { "SecondaryCaptureDeviceSoftwareVersions", DC::SecondaryCaptureDeviceSoftwareVersions },
        { "HardcopyDeviceSoftwareVersion", DC::HardcopyDeviceSoftwareVersion },
        { "HardcopyDeviceManufacturerModelName", DC::HardcopyDeviceManufacturerModelName },
        { "SoftwareVersions", DC::SoftwareVersions },
        { "VideoImageFormatAcquired", DC::VideoImageFormatAcquired },
        { "DigitalImageFormatAcquired", DC::DigitalImageFormatAcquired },
        { "ProtocolName", DC::ProtocolName },
        { "ContrastBolusRoute", DC::ContrastBolusRoute },
        { "ContrastBolusVolume", DC::ContrastBolusVolume },
        { "ContrastBolusStartTime", DC::ContrastBolusStartTime },
        { "ContrastBolusStopTime", DC::ContrastBolusStopTime },
        { "ContrastBolusTotalDose", DC::ContrastBolusTotalDose },
        { "SyringeCounts", DC::SyringeCounts },
        { "ContrastFlowRate", DC::ContrastFlowRate },
        { "ContrastFlowDuration", DC::ContrastFlowDuration },
        { "ContrastBolusIngredient", DC::ContrastBolusIngredient },
        { "ContrastBolusIngredientConcentration", DC::ContrastBolusIngredientConcentration },
        { "SpatialResolution", DC::SpatialResolution },
        { "TriggerTime", DC::TriggerTime },
        { "TriggerSourceOrType", DC::TriggerSourceOrType },
        { "NominalInterval", DC::NominalInterval },
        { "FrameTime", DC::FrameTime },
        { "CardiacFramingType", DC::CardiacFramingType },
        { "FrameTimeVector", DC::FrameTimeVector },
        { "FrameDelay", DC::FrameDelay },
        { "ImageTriggerDelay", DC::ImageTriggerDelay },
        { "MultiplexGroupTimeOffset", DC::MultiplexGroupTimeOffset },
        { "TriggerTimeOffset", DC::TriggerTimeOffset },
        { "SynchronizationTrigger", DC::SynchronizationTrigger },
        { "SynchronizationChannel", DC::SynchronizationChannel },
        { "TriggerSamplePosition", DC::TriggerSamplePosition },
        { "RadiopharmaceuticalRoute", DC::RadiopharmaceuticalRoute },
        { "RadiopharmaceuticalVolume", DC::RadiopharmaceuticalVolume },
        { "RadiopharmaceuticalStartTime", DC::RadiopharmaceuticalStartTime },
        { "RadiopharmaceuticalStopTime", DC::RadiopharmaceuticalStopTime },
        { "RadionuclideTotalDose", DC::RadionuclideTotalDose },
        { "RadionuclideHalfLife", DC::RadionuclideHalfLife },
        { "RadionuclidePositronFraction", DC::RadionuclidePositronFraction },
        { "RadiopharmaceuticalSpecificActivity", DC::RadiopharmaceuticalSpecificActivity },
        { "RadiopharmaceuticalStartDateTime", DC::RadiopharmaceuticalStartDateTime },
        { "RadiopharmaceuticalStopDateTime", DC::RadiopharmaceuticalStopDateTime },
        { "BeatRejectionFlag", DC::BeatRejectionFlag },
        { "LowRRValue", DC::LowRRValue },
        { "HighRRValue", DC::HighRRValue },
        { "IntervalsAcquired", DC::IntervalsAcquired },
        { "IntervalsRejected", DC::IntervalsRejected },
        { "PVCRejection", DC::PVCRejection },
        { "SkipBeats", DC::SkipBeats },
        { "HeartRate", DC::HeartRate },
        { "CardiacNumberOfImages", DC::CardiacNumberOfImages },
        { "TriggerWindow", DC::TriggerWindow },
        { "ReconstructionDiameter", DC::ReconstructionDiameter },
        { "DistanceSourceToDetector", DC::DistanceSourceToDetector },
        { "DistanceSourceToPatient", DC::DistanceSourceToPatient },
        { "EstimatedRadiographicMagnificationFactor", DC::EstimatedRadiographicMagnificationFactor },
        { "GantryDetectorTilt", DC::GantryDetectorTilt },
        { "GantryDetectorSlew", DC::GantryDetectorSlew },
        { "TableHeight", DC::TableHeight },
        { "TableTraverse", DC::TableTraverse },
        { "TableMotion", DC::TableMotion },
        { "TableVerticalIncrement", DC::TableVerticalIncrement },
        { "TableLateralIncrement", DC::TableLateralIncrement },
        { "TableLongitudinalIncrement", DC::TableLongitudinalIncrement },
        { "TableAngle", DC::TableAngle },
        { "TableType", DC::TableType },
        { "RotationDirection", DC::RotationDirection },
        { "AngularPosition", DC::AngularPosition },
        { "RadialPosition", DC::RadialPosition },
        { "ScanArc", DC::ScanArc },
        { "AngularStep", DC::AngularStep },
        { "CenterOfRotationOffset", DC::CenterOfRotationOffset },
        { "RotationOffset", DC::RotationOffset },
        { "FieldOfViewShape", DC::FieldOfViewShape },
        { "FieldOfViewDimensions", DC::FieldOfViewDimensions },
        { "ExposureTime", DC::ExposureTime },
        { "XRayTubeCurrent", DC::XRayTubeCurrent },
        { "Exposure", DC::Exposure },
        { "ExposureInuAs", DC::ExposureInuAs },
        { "AveragePulseWidth", DC::AveragePulseWidth },
        { "RadiationSetting", DC::RadiationSetting },
        { "RectificationType", DC::RectificationType },
        { "RadiationMode", DC::RadiationMode },
        { "ImageAndFluoroscopyAreaDoseProduct", DC::ImageAndFluoroscopyAreaDoseProduct },
        { "FilterType", DC::FilterType },
        { "TypeOfFilters", DC::TypeOfFilters },
        { "IntensifierSize", DC::IntensifierSize },
        { "ImagerPixelSpacing", DC::ImagerPixelSpacing },
        { "Grid", DC::Grid },
        { "GeneratorPower", DC::GeneratorPower },
        { "CollimatorGridName", DC::CollimatorGridName },
        { "CollimatorType", DC::CollimatorType },
        { "FocalDistance", DC::FocalDistance },
        { "XFocusCenter", DC::XFocusCenter },
        { "YFocusCenter", DC::YFocusCenter },
        { "FocalSpots", DC::FocalSpots },
        { "AnodeTargetMaterial", DC::AnodeTargetMaterial },
        { "BodyPartThickness", DC::BodyPartThickness },
        { "CompressionForce", DC::CompressionForce },
        { "CompressionPressure", DC::CompressionPressure },
        { "PaddleDescription", DC::PaddleDescription },
        { "CompressionContactArea", DC::CompressionContactArea },
        { "AcquisitionMode", DC::AcquisitionMode },
        { "DoseModeName", DC::DoseModeName },
        { "AcquiredSubtractionMaskFlag", DC::AcquiredSubtractionMaskFlag },
        { "FluoroscopyPersistenceFlag", DC::FluoroscopyPersistenceFlag },
        { "FluoroscopyLastImageHoldPersistenceFlag", DC::FluoroscopyLastImageHoldPersistenceFlag },
        { "UpperLimitNumberOfPersistentFluoroscopyFrames", DC::UpperLimitNumberOfPersistentFluoroscopyFrames },
        { "ContrastBolusAutoInjectionTriggerFlag", DC::ContrastBolusAutoInjectionTriggerFlag },
        { "ContrastBolusInjectionDelay", DC::ContrastBolusInjectionDelay },
        { "XAAcquisitionPhaseDetailsSequence", DC::XAAcquisitionPhaseDetailsSequence },
        { "XAAcquisitionFrameRate", DC::XAAcquisitionFrameRate },
        { "XAPlaneDetailsSequence", DC::XAPlaneDetailsSequence },
        { "AcquisitionFieldOfViewLabel", DC::AcquisitionFieldOfViewLabel },
        { "XRayFilterDetailsSequence", DC::XRayFilterDetailsSequence },
        { "XAAcquisitionDuration", DC::XAAcquisitionDuration },
        { "ReconstructionPipelineType", DC::ReconstructionPipelineType },
        { "ImageFilterDetailsSequence", DC::ImageFilterDetailsSequence },
        { "AppliedMaskSubtractionFlag", DC::AppliedMaskSubtractionFlag },
        { "RequestedSeriesDescriptionCodeSequence", DC::RequestedSeriesDescriptionCodeSequence },
        { "DateOfLastCalibration", DC::DateOfLastCalibration },
        { "TimeOfLastCalibration", DC::TimeOfLastCalibration },
        { "DateTimeOfLastCalibration", DC::DateTimeOfLastCalibration },
        { "CalibrationDateTime", DC::CalibrationDateTime },
        { "DateOfManufacture", DC::DateOfManufacture },
        { "DateOfInstallation", DC::DateOfInstallation },
        { "ConvolutionKernel", DC::ConvolutionKernel },
        { "UpperLowerPixelValues", DC::UpperLowerPixelValues },
        { "ActualFrameDuration", DC::ActualFrameDuration },
        { "CountRate", DC::CountRate },
        { "PreferredPlaybackSequencing", DC::PreferredPlaybackSequencing },
        { "ReceiveCoilName", DC::ReceiveCoilName },
        { "TransmitCoilName", DC::TransmitCoilName },
        { "PlateType", DC::PlateType },
        { "PhosphorType", DC::PhosphorType },
        { "WaterEquivalentDiameter", DC::WaterEquivalentDiameter },
        { "WaterEquivalentDiameterCalculationMethodCodeSequence", DC::WaterEquivalentDiameterCalculationMethodCodeSequence },
        { "ScanVelocity", DC::ScanVelocity },
        { "WholeBodyTechnique", DC::WholeBodyTechnique },
        { "ScanLength", DC::ScanLength },
        { "AcquisitionMatrix", DC::AcquisitionMatrix },
        { "InPlanePhaseEncodingDirection", DC::InPlanePhaseEncodingDirection },
        { "FlipAngle", DC::FlipAngle },
        { "VariableFlipAngleFlag", DC::VariableFlipAngleFlag },
        { "SAR", DC::SAR },
        { "dBdt", DC::dBdt },
        { "B1rms", DC::B1rms },
        { "AcquisitionDeviceProcessingDescription", DC::AcquisitionDeviceProcessingDescription },
        { "AcquisitionDeviceProcessingCode", DC::AcquisitionDeviceProcessingCode },
        { "CassetteOrientation", DC::CassetteOrientation },
        { "CassetteSize", DC::CassetteSize },
        { "ExposuresOnPlate", DC::ExposuresOnPlate },
        { "RelativeXRayExposure", DC::RelativeXRayExposure },
        { "ExposureIndex", DC::ExposureIndex },
        { "TargetExposureIndex", DC::TargetExposureIndex },
        { "DeviationIndex", DC::DeviationIndex },
        { "ColumnAngulation", DC::ColumnAngulation },
        { "TomoLayerHeight", DC::TomoLayerHeight },
        { "TomoAngle", DC::TomoAngle },
        { "TomoTime", DC::TomoTime },
        { "TomoType", DC::TomoType },
        { "TomoClass", DC::TomoClass },
        { "NumberOfTomosynthesisSourceImages", DC::NumberOfTomosynthesisSourceImages },
        { "PositionerMotion", DC::PositionerMotion },
        { "PositionerType", DC::PositionerType },
        { "PositionerPrimaryAngle", DC::PositionerPrimaryAngle },
        { "PositionerSecondaryAngle", DC::PositionerSecondaryAngle },
        { "PositionerPrimaryAngleIncrement", DC::PositionerPrimaryAngleIncrement },
        { "PositionerSecondaryAngleIncrement", DC::PositionerSecondaryAngleIncrement },
        { "DetectorPrimaryAngle", DC::DetectorPrimaryAngle },
        { "DetectorSecondaryAngle", DC::DetectorSecondaryAngle },
        { "ShutterShape", DC::ShutterShape },
        { "ShutterLeftVerticalEdge", DC::ShutterLeftVerticalEdge },
        { "ShutterRightVerticalEdge", DC::ShutterRightVerticalEdge },
        { "ShutterUpperHorizontalEdge", DC::ShutterUpperHorizontalEdge },
        { "ShutterLowerHorizontalEdge", DC::ShutterLowerHorizontalEdge },
        { "CenterOfCircularShutter", DC::CenterOfCircularShutter },
        { "RadiusOfCircularShutter", DC::RadiusOfCircularShutter },
        { "VerticesOfThePolygonalShutter", DC::VerticesOfThePolygonalShutter },
        { "ShutterPresentationValue", DC::ShutterPresentationValue },
        { "ShutterOverlayGroup", DC::ShutterOverlayGroup },
        { "ShutterPresentationColorCIELabValue", DC::ShutterPresentationColorCIELabValue },
        { "OutlineShapeType", DC::OutlineShapeType },
        { "OutlineLeftVerticalEdge", DC::OutlineLeftVerticalEdge },
        { "OutlineRightVerticalEdge", DC::OutlineRightVerticalEdge },
        { "OutlineUpperHorizontalEdge", DC::OutlineUpperHorizontalEdge },
        { "OutlineLowerHorizontalEdge", DC::OutlineLowerHorizontalEdge },
        { "CenterOfCircularOutline", DC::CenterOfCircularOutline },
        { "DiameterOfCircularOutline", DC::DiameterOfCircularOutline },
        { "NumberOfPolygonalVertices", DC::NumberOfPolygonalVertices },
        { "VerticesOfThePolygonalOutline", DC::VerticesOfThePolygonalOutline },
        { "CollimatorShape", DC::CollimatorShape },
        { "CollimatorLeftVerticalEdge", DC::CollimatorLeftVerticalEdge },
        { "CollimatorRightVerticalEdge", DC::CollimatorRightVerticalEdge },
        { "CollimatorUpperHorizontalEdge", DC::CollimatorUpperHorizontalEdge },
        { "CollimatorLowerHorizontalEdge", DC::CollimatorLowerHorizontalEdge },
        { "CenterOfCircularCollimator", DC::CenterOfCircularCollimator },
        { "RadiusOfCircularCollimator", DC::RadiusOfCircularCollimator },
        { "VerticesOfThePolygonalCollimator", DC::VerticesOfThePolygonalCollimator },
        { "AcquisitionTimeSynchronized", DC::AcquisitionTimeSynchronized },
        { "TimeSource", DC::TimeSource },
        { "TimeDistributionProtocol", DC::TimeDistributionProtocol },
        { "NTPSourceAddress", DC::NTPSourceAddress },
        { "PageNumberVector", DC::PageNumberVector },
        { "FrameLabelVector", DC::FrameLabelVector },
        { "FramePrimaryAngleVector", DC::FramePrimaryAngleVector },
        { "FrameSecondaryAngleVector", DC::FrameSecondaryAngleVector },
        { "SliceLocationVector", DC::SliceLocationVector },
        { "DisplayWindowLabelVector", DC::DisplayWindowLabelVector },
        { "NominalScannedPixelSpacing", DC::NominalScannedPixelSpacing },
        { "DigitizingDeviceTransportDirection", DC::DigitizingDeviceTransportDirection },
        { "RotationOfScannedFilm", DC::RotationOfScannedFilm },
        { "BiopsyTargetSequence", DC::BiopsyTargetSequence },
        { "TargetUID", DC::TargetUID },
        { "LocalizingCursorPosition", DC::LocalizingCursorPosition },
        { "CalculatedTargetPosition", DC::CalculatedTargetPosition },
        { "TargetLabel", DC::TargetLabel },
        { "DisplayedZValue", DC::DisplayedZValue },
        { "IVUSAcquisition", DC::IVUSAcquisition },
        { "IVUSPullbackRate", DC::IVUSPullbackRate },
        { "IVUSGatedRate", DC::IVUSGatedRate },
        { "IVUSPullbackStartFrameNumber", DC::IVUSPullbackStartFrameNumber },
        { "IVUSPullbackStopFrameNumber", DC::IVUSPullbackStopFrameNumber },
        { "LesionNumber", DC::LesionNumber },
        { "AcquisitionComments", DC::AcquisitionComments },
        { "OutputPower", DC::OutputPower },
        { "TransducerData", DC::TransducerData },
        { "TransducerIdentificationSequence", DC::TransducerIdentificationSequence },
        { "FocusDepth", DC::FocusDepth },
        { "ProcessingFunction", DC::ProcessingFunction },
        { "PostprocessingFunction", DC::PostprocessingFunction },
        { "MechanicalIndex", DC::MechanicalIndex },
        { "BoneThermalIndex", DC::BoneThermalIndex },
        { "CranialThermalIndex", DC::CranialThermalIndex },
        { "SoftTissueThermalIndex", DC::SoftTissueThermalIndex },
        { "SoftTissueFocusThermalIndex", DC::SoftTissueFocusThermalIndex },
        { "SoftTissueSurfaceThermalIndex", DC::SoftTissueSurfaceThermalIndex },
        { "DynamicRange", DC::DynamicRange },
        { "TotalGain", DC::TotalGain },
        { "DepthOfScanField", DC::DepthOfScanField },
        { "PatientPosition", DC::PatientPosition },
        { "ViewPosition", DC::ViewPosition },
        { "ProjectionEponymousNameCodeSequence", DC::ProjectionEponymousNameCodeSequence },
        { "ImageTransformationMatrix", DC::ImageTransformationMatrix },
        { "ImageTranslationVector", DC::ImageTranslationVector },
        { "Sensitivity", DC::Sensitivity },
        { "SequenceOfUltrasoundRegions", DC::SequenceOfUltrasoundRegions },
        { "RegionSpatialFormat", DC::RegionSpatialFormat },
        { "RegionDataType", DC::RegionDataType },
        { "RegionFlags", DC::RegionFlags },
        { "RegionLocationMinX0", DC::RegionLocationMinX0 },
        { "RegionLocationMinY0", DC::RegionLocationMinY0 },
        { "RegionLocationMaxX1", DC::RegionLocationMaxX1 },
        { "RegionLocationMaxY1", DC::RegionLocationMaxY1 },
        { "ReferencePixelX0", DC::ReferencePixelX0 },
        { "ReferencePixelY0", DC::ReferencePixelY0 },
        { "PhysicalUnitsXDirection", DC::PhysicalUnitsXDirection },
        { "PhysicalUnitsYDirection", DC::PhysicalUnitsYDirection },
        { "ReferencePixelPhysicalValueX", DC::ReferencePixelPhysicalValueX },
        { "ReferencePixelPhysicalValueY", DC::ReferencePixelPhysicalValueY },
        { "PhysicalDeltaX", DC::PhysicalDeltaX },
        { "PhysicalDeltaY", DC::PhysicalDeltaY },
        { "TransducerFrequency", DC::TransducerFrequency },
        { "TransducerType", DC::TransducerType },
        { "PulseRepetitionFrequency", DC::PulseRepetitionFrequency },
        { "DopplerCorrectionAngle", DC::DopplerCorrectionAngle },
        { "SteeringAngle", DC::SteeringAngle },
        { "DopplerSampleVolumeXPositionRetired", DC::DopplerSampleVolumeXPositionRetired },
        { "DopplerSampleVolumeXPosition", DC::DopplerSampleVolumeXPosition },
        { "DopplerSampleVolumeYPositionRetired", DC::DopplerSampleVolumeYPositionRetired },
        { "DopplerSampleVolumeYPosition", DC::DopplerSampleVolumeYPosition },
        { "TMLinePositionX0Retired", DC::TMLinePositionX0Retired },
        { "TMLinePositionX0", DC::TMLinePositionX0 },
        { "TMLinePositionY0Retired", DC::TMLinePositionY0Retired },
        { "TMLinePositionY0", DC::TMLinePositionY0 },
        { "TMLinePositionX1Retired", DC::TMLinePositionX1Retired },
        { "TMLinePositionX1", DC::TMLinePositionX1 },
        { "TMLinePositionY1Retired", DC::TMLinePositionY1Retired },
        { "TMLinePositionY1", DC::TMLinePositionY1 },
        { "PixelComponentOrganization", DC::PixelComponentOrganization },
        { "PixelComponentMask", DC::PixelComponentMask },
        { "PixelComponentRangeStart", DC::PixelComponentRangeStart },
        { "PixelComponentRangeStop", DC::PixelComponentRangeStop },
        { "PixelComponentPhysicalUnits", DC::PixelComponentPhysicalUnits },
        { "PixelComponentDataType", DC::PixelComponentDataType },
        { "NumberOfTableBreakPoints", DC::NumberOfTableBreakPoints },
        { "TableOfXBreakPoints", DC::TableOfXBreakPoints },
        { "TableOfYBreakPoints", DC::TableOfYBreakPoints },
        { "NumberOfTableEntries", DC::NumberOfTableEntries },
        { "TableOfPixelValues", DC::TableOfPixelValues },
        { "TableOfParameterValues", DC::TableOfParameterValues },
        { "RWaveTimeVector", DC::RWaveTimeVector },
        { "ActiveImageAreaOverlayGroup", DC::ActiveImageAreaOverlayGroup },
        { "DetectorConditionsNominalFlag", DC::DetectorConditionsNominalFlag },
        { "DetectorTemperature", DC::DetectorTemperature },
        { "DetectorType", DC::DetectorType },
        { "DetectorConfiguration", DC::DetectorConfiguration },
        { "DetectorDescription", DC::DetectorDescription },
        { "DetectorMode", DC::DetectorMode },
        { "DetectorID", DC::DetectorID },
        { "DateOfLastDetectorCalibration", DC::DateOfLastDetectorCalibration },
        { "TimeOfLastDetectorCalibration", DC::TimeOfLastDetectorCalibration },
        { "ExposuresOnDetectorSinceLastCalibration", DC::ExposuresOnDetectorSinceLastCalibration },
        { "ExposuresOnDetectorSinceManufactured", DC::ExposuresOnDetectorSinceManufactured },
        { "DetectorTimeSinceLastExposure", DC::DetectorTimeSinceLastExposure },
        { "DetectorActiveTime", DC::DetectorActiveTime },
        { "DetectorActivationOffsetFromExposure", DC::DetectorActivationOffsetFromExposure },
        { "DetectorBinning", DC::DetectorBinning },
        { "DetectorElementPhysicalSize", DC::DetectorElementPhysicalSize },
        { "DetectorElementSpacing", DC::DetectorElementSpacing },
        { "DetectorActiveShape", DC::DetectorActiveShape },
        { "DetectorActiveDimensions", DC::DetectorActiveDimensions },
        { "DetectorActiveOrigin", DC::DetectorActiveOrigin },
        { "DetectorManufacturerName", DC::DetectorManufacturerName },
        { "DetectorManufacturerModelName", DC::DetectorManufacturerModelName },
        { "FieldOfViewOrigin", DC::FieldOfViewOrigin },
        { "FieldOfViewRotation", DC::FieldOfViewRotation },
        { "FieldOfViewHorizontalFlip", DC::FieldOfViewHorizontalFlip },
        { "PixelDataAreaOriginRelativeToFOV", DC::PixelDataAreaOriginRelativeToFOV },
        { "PixelDataAreaRotationAngleRelativeToFOV", DC::PixelDataAreaRotationAngleRelativeToFOV },
        { "GridAbsorbingMaterial", DC::GridAbsorbingMaterial },
        { "GridSpacingMaterial", DC::GridSpacingMaterial },
        { "GridThickness", DC::GridThickness },
        { "GridPitch", DC::GridPitch },
        { "GridAspectRatio", DC::GridAspectRatio },
        { "GridPeriod", DC::GridPeriod },
        { "GridFocalDistance", DC::GridFocalDistance },
        { "FilterMaterial", DC::FilterMaterial },
        { "FilterThicknessMinimum", DC::FilterThicknessMinimum },
        { "FilterThicknessMaximum", DC::FilterThicknessMaximum },
        { "FilterBeamPathLengthMinimum", DC::FilterBeamPathLengthMinimum },
        { "FilterBeamPathLengthMaximum", DC::FilterBeamPathLengthMaximum },
        { "ExposureControlMode", DC::ExposureControlMode },
        { "ExposureControlModeDescription", DC::ExposureControlModeDescription },
        { "ExposureStatus", DC::ExposureStatus },
        { "PhototimerSetting", DC::PhototimerSetting },
        { "ExposureTimeInuS", DC::ExposureTimeInuS },
        { "XRayTubeCurrentInuA", DC::XRayTubeCurrentInuA },
        { "ContentQualification", DC::ContentQualification },
        { "PulseSequenceName", DC::PulseSequenceName },
        { "MRImagingModifierSequence", DC::MRImagingModifierSequence },
        { "EchoPulseSequence", DC::EchoPulseSequence },
        { "InversionRecovery", DC::InversionRecovery },
        { "FlowCompensation", DC::FlowCompensation },
        { "MultipleSpinEcho", DC::MultipleSpinEcho },
        { "MultiPlanarExcitation", DC::MultiPlanarExcitation },
        { "PhaseContrast", DC::PhaseContrast },
        { "TimeOfFlightContrast", DC::TimeOfFlightContrast },
        { "Spoiling", DC::Spoiling },
        { "SteadyStatePulseSequence", DC::SteadyStatePulseSequence },
        { "EchoPlanarPulseSequence", DC::EchoPlanarPulseSequence },
        { "TagAngleFirstAxis", DC::TagAngleFirstAxis },
        { "MagnetizationTransfer", DC::MagnetizationTransfer },
        { "T2Preparation", DC::T2Preparation },
        { "BloodSignalNulling", DC::BloodSignalNulling },
        { "SaturationRecovery", DC::SaturationRecovery },
        { "SpectrallySelectedSuppression", DC::SpectrallySelectedSuppression },
        { "SpectrallySelectedExcitation", DC::SpectrallySelectedExcitation },
        { "SpatialPresaturation", DC::SpatialPresaturation },
        { "Tagging", DC::Tagging },
        { "OversamplingPhase", DC::OversamplingPhase },
        { "TagSpacingFirstDimension", DC::TagSpacingFirstDimension },
        { "GeometryOfKSpaceTraversal", DC::GeometryOfKSpaceTraversal },
        { "SegmentedKSpaceTraversal", DC::SegmentedKSpaceTraversal },
        { "RectilinearPhaseEncodeReordering", DC::RectilinearPhaseEncodeReordering },
        { "TagThickness", DC::TagThickness },
        { "PartialFourierDirection", DC::PartialFourierDirection },
        { "CardiacSynchronizationTechnique", DC::CardiacSynchronizationTechnique },
        { "ReceiveCoilManufacturerName", DC::ReceiveCoilManufacturerName },
        { "MRReceiveCoilSequence", DC::MRReceiveCoilSequence },
        { "ReceiveCoilType", DC::ReceiveCoilType },
        { "QuadratureReceiveCoil", DC::QuadratureReceiveCoil },
        { "MultiCoilDefinitionSequence", DC::MultiCoilDefinitionSequence },
        { "MultiCoilConfiguration", DC::MultiCoilConfiguration },
        { "MultiCoilElementName", DC::MultiCoilElementName },
        { "MultiCoilElementUsed", DC::MultiCoilElementUsed },
        { "MRTransmitCoilSequence", DC::MRTransmitCoilSequence },
        { "TransmitCoilManufacturerName", DC::TransmitCoilManufacturerName },
        { "TransmitCoilType", DC::TransmitCoilType },
        { "SpectralWidth", DC::SpectralWidth },
        { "ChemicalShiftReference", DC::ChemicalShiftReference },
        { "VolumeLocalizationTechnique", DC::VolumeLocalizationTechnique },
        { "MRAcquisitionFrequencyEncodingSteps", DC::MRAcquisitionFrequencyEncodingSteps },
        { "Decoupling", DC::Decoupling },
        { "DecoupledNucleus", DC::DecoupledNucleus },
        { "DecouplingFrequency", DC::DecouplingFrequency },
        { "DecouplingMethod", DC::DecouplingMethod },
        { "DecouplingChemicalShiftReference", DC::DecouplingChemicalShiftReference },
        { "KSpaceFiltering", DC::KSpaceFiltering },
        { "TimeDomainFiltering", DC::TimeDomainFiltering },
        { "NumberOfZeroFills", DC::NumberOfZeroFills },
        { "BaselineCorrection", DC::BaselineCorrection },
        { "ParallelReductionFactorInPlane", DC::ParallelReductionFactorInPlane },
        { "CardiacRRIntervalSpecified", DC::CardiacRRIntervalSpecified },
        { "AcquisitionDuration", DC::AcquisitionDuration },
        { "FrameAcquisitionDateTime", DC::FrameAcquisitionDateTime },
        { "DiffusionDirectionality", DC::DiffusionDirectionality },
        { "DiffusionGradientDirectionSequence", DC::DiffusionGradientDirectionSequence },
        { "ParallelAcquisition", DC::ParallelAcquisition },
        { "ParallelAcquisitionTechnique", DC::ParallelAcquisitionTechnique },
        { "InversionTimes", DC::InversionTimes },
        { "MetaboliteMapDescription", DC::MetaboliteMapDescription },
        { "PartialFourier", DC::PartialFourier },
        { "EffectiveEchoTime", DC::EffectiveEchoTime },
        { "MetaboliteMapCodeSequence", DC::MetaboliteMapCodeSequence },
        { "ChemicalShiftSequence", DC::ChemicalShiftSequence },
        { "CardiacSignalSource", DC::CardiacSignalSource },
        { "DiffusionBValue", DC::DiffusionBValue },
        { "DiffusionGradientOrientation", DC::DiffusionGradientOrientation },
        { "VelocityEncodingDirection", DC::VelocityEncodingDirection },
        { "VelocityEncodingMinimumValue", DC::VelocityEncodingMinimumValue },
        { "VelocityEncodingAcquisitionSequence", DC::VelocityEncodingAcquisitionSequence },
        { "NumberOfKSpaceTrajectories", DC::NumberOfKSpaceTrajectories },
        { "CoverageOfKSpace", DC::CoverageOfKSpace },
        { "SpectroscopyAcquisitionPhaseRows", DC::SpectroscopyAcquisitionPhaseRows },
        { "ParallelReductionFactorInPlaneRetired", DC::ParallelReductionFactorInPlaneRetired },
        { "TransmitterFrequency", DC::TransmitterFrequency },
        { "ResonantNucleus", DC::ResonantNucleus },
        { "FrequencyCorrection", DC::FrequencyCorrection },
        { "MRSpectroscopyFOVGeometrySequence", DC::MRSpectroscopyFOVGeometrySequence },
        { "SlabThickness", DC::SlabThickness },
        { "SlabOrientation", DC::SlabOrientation },
        { "MidSlabPosition", DC::MidSlabPosition },
        { "MRSpatialSaturationSequence", DC::MRSpatialSaturationSequence },
        { "MRTimingAndRelatedParametersSequence", DC::MRTimingAndRelatedParametersSequence },
        { "MREchoSequence", DC::MREchoSequence },
        { "MRModifierSequence", DC::MRModifierSequence },
        { "MRDiffusionSequence", DC::MRDiffusionSequence },
        { "CardiacSynchronizationSequence", DC::CardiacSynchronizationSequence },
        { "MRAveragesSequence", DC::MRAveragesSequence },
        { "MRFOVGeometrySequence", DC::MRFOVGeometrySequence },
        { "VolumeLocalizationSequence", DC::VolumeLocalizationSequence },
        { "SpectroscopyAcquisitionDataColumns", DC::SpectroscopyAcquisitionDataColumns },
        { "DiffusionAnisotropyType", DC::DiffusionAnisotropyType },
        { "FrameReferenceDateTime", DC::FrameReferenceDateTime },
        { "MRMetaboliteMapSequence", DC::MRMetaboliteMapSequence },
        { "ParallelReductionFactorOutOfPlane", DC::ParallelReductionFactorOutOfPlane },
        { "SpectroscopyAcquisitionOutOfPlanePhaseSteps", DC::SpectroscopyAcquisitionOutOfPlanePhaseSteps },
        { "BulkMotionStatus", DC::BulkMotionStatus },
        { "ParallelReductionFactorSecondInPlane", DC::ParallelReductionFactorSecondInPlane },
        { "CardiacBeatRejectionTechnique", DC::CardiacBeatRejectionTechnique },
        { "RespiratoryMotionCompensationTechnique", DC::RespiratoryMotionCompensationTechnique },
        { "RespiratorySignalSource", DC::RespiratorySignalSource },
        { "BulkMotionCompensationTechnique", DC::BulkMotionCompensationTechnique },
        { "BulkMotionSignalSource", DC::BulkMotionSignalSource },
        { "ApplicableSafetyStandardAgency", DC::ApplicableSafetyStandardAgency },
        { "ApplicableSafetyStandardDescription", DC::ApplicableSafetyStandardDescription },
        { "OperatingModeSequence", DC::OperatingModeSequence },
        { "OperatingModeType", DC::OperatingModeType },
        { "OperatingMode", DC::OperatingMode },
        { "SpecificAbsorptionRateDefinition", DC::SpecificAbsorptionRateDefinition },
        { "GradientOutputType", DC::GradientOutputType },
        { "SpecificAbsorptionRateValue", DC::SpecificAbsorptionRateValue },
        { "GradientOutput", DC::GradientOutput },
        { "FlowCompensationDirection", DC::FlowCompensationDirection },
        { "TaggingDelay", DC::TaggingDelay },
        { "RespiratoryMotionCompensationTechniqueDescription", DC::RespiratoryMotionCompensationTechniqueDescription },
        { "RespiratorySignalSourceID", DC::RespiratorySignalSourceID },
        { "ChemicalShiftMinimumIntegrationLimitInHz", DC::ChemicalShiftMinimumIntegrationLimitInHz },
        { "ChemicalShiftMaximumIntegrationLimitInHz", DC::ChemicalShiftMaximumIntegrationLimitInHz },
        { "MRVelocityEncodingSequence", DC::MRVelocityEncodingSequence },
        { "FirstOrderPhaseCorrection", DC::FirstOrderPhaseCorrection },
        { "WaterReferencedPhaseCorrection", DC::WaterReferencedPhaseCorrection },
        { "MRSpectroscopyAcquisitionType", DC::MRSpectroscopyAcquisitionType },
        { "RespiratoryCyclePosition", DC::RespiratoryCyclePosition },
        { "VelocityEncodingMaximumValue", DC::VelocityEncodingMaximumValue },
        { "TagSpacingSecondDimension", DC::TagSpacingSecondDimension },
        { "TagAngleSecondAxis", DC::TagAngleSecondAxis },
        { "FrameAcquisitionDuration", DC::FrameAcquisitionDuration },
        { "MRImageFrameTypeSequence", DC::MRImageFrameTypeSequence },
        { "MRSpectroscopyFrameTypeSequence", DC::MRSpectroscopyFrameTypeSequence },
        { "MRAcquisitionPhaseEncodingStepsInPlane", DC::MRAcquisitionPhaseEncodingStepsInPlane },
        { "MRAcquisitionPhaseEncodingStepsOutOfPlane", DC::MRAcquisitionPhaseEncodingStepsOutOfPlane },
        { "SpectroscopyAcquisitionPhaseColumns", DC::SpectroscopyAcquisitionPhaseColumns },
        { "CardiacCyclePosition", DC::CardiacCyclePosition },
        { "SpecificAbsorptionRateSequence", DC::SpecificAbsorptionRateSequence },
        { "RFEchoTrainLength", DC::RFEchoTrainLength },
        { "GradientEchoTrainLength", DC::GradientEchoTrainLength },
        { "ArterialSpinLabelingContrast", DC::ArterialSpinLabelingContrast },
        { "MRArterialSpinLabelingSequence", DC::MRArterialSpinLabelingSequence },
        { "ASLTechniqueDescription", DC::ASLTechniqueDescription },
        { "ASLSlabNumber", DC::ASLSlabNumber },
        { "ASLSlabThickness", DC::ASLSlabThickness },
        { "ASLSlabOrientation", DC::ASLSlabOrientation },
        { "ASLMidSlabPosition", DC::ASLMidSlabPosition },
        { "ASLContext", DC::ASLContext },
        { "ASLPulseTrainDuration", DC::ASLPulseTrainDuration },
        { "ASLCrusherFlag", DC::ASLCrusherFlag },
        { "ASLCrusherFlowLimit", DC::ASLCrusherFlowLimit },
        { "ASLCrusherDescription", DC::ASLCrusherDescription },
        { "ASLBolusCutoffFlag", DC::ASLBolusCutoffFlag },
        { "ASLBolusCutoffTimingSequence", DC::ASLBolusCutoffTimingSequence },
        { "ASLBolusCutoffTechnique", DC::ASLBolusCutoffTechnique },
        { "ASLBolusCutoffDelayTime", DC::ASLBolusCutoffDelayTime },
        { "ASLSlabSequence", DC::ASLSlabSequence },
        { "ChemicalShiftMinimumIntegrationLimitInppm", DC::ChemicalShiftMinimumIntegrationLimitInppm },
        { "ChemicalShiftMaximumIntegrationLimitInppm", DC::ChemicalShiftMaximumIntegrationLimitInppm },
        { "WaterReferenceAcquisition", DC::WaterReferenceAcquisition },
        { "EchoPeakPosition", DC::EchoPeakPosition },
        { "CTAcquisitionTypeSequence", DC::CTAcquisitionTypeSequence },
        { "AcquisitionType", DC::AcquisitionType },
        { "TubeAngle", DC::TubeAngle },
        { "CTAcquisitionDetailsSequence", DC::CTAcquisitionDetailsSequence },
        { "RevolutionTime", DC::RevolutionTime },
        { "SingleCollimationWidth", DC::SingleCollimationWidth },
        { "TotalCollimationWidth", DC::TotalCollimationWidth },
        { "CTTableDynamicsSequence", DC::CTTableDynamicsSequence },
        { "TableSpeed", DC::TableSpeed },
        { "TableFeedPerRotation", DC::TableFeedPerRotation },
        { "SpiralPitchFactor", DC::SpiralPitchFactor },
        { "CTGeometrySequence", DC::CTGeometrySequence },
        { "DataCollectionCenterPatient", DC::DataCollectionCenterPatient },
        { "CTReconstructionSequence", DC::CTReconstructionSequence },
        { "ReconstructionAlgorithm", DC::ReconstructionAlgorithm },
        { "ConvolutionKernelGroup", DC::ConvolutionKernelGroup },
        { "ReconstructionFieldOfView", DC::ReconstructionFieldOfView },
        { "ReconstructionTargetCenterPatient", DC::ReconstructionTargetCenterPatient },
        { "ReconstructionAngle", DC::ReconstructionAngle },
        { "ImageFilter", DC::ImageFilter },
        { "CTExposureSequence", DC::CTExposureSequence },
        { "ReconstructionPixelSpacing", DC::ReconstructionPixelSpacing },
        { "ExposureModulationType", DC::ExposureModulationType },
        { "EstimatedDoseSaving", DC::EstimatedDoseSaving },
        { "CTXRayDetailsSequence", DC::CTXRayDetailsSequence },
        { "CTPositionSequence", DC::CTPositionSequence },
        { "TablePosition", DC::TablePosition },
        { "ExposureTimeInms", DC::ExposureTimeInms },
        { "CTImageFrameTypeSequence", DC::CTImageFrameTypeSequence },
        { "XRayTubeCurrentInmA", DC::XRayTubeCurrentInmA },
        { "ExposureInmAs", DC::ExposureInmAs },
        { "ConstantVolumeFlag", DC::ConstantVolumeFlag },
        { "FluoroscopyFlag", DC::FluoroscopyFlag },
        { "DistanceSourceToDataCollectionCenter", DC::DistanceSourceToDataCollectionCenter },
        { "ContrastBolusAgentNumber", DC::ContrastBolusAgentNumber },
        { "ContrastBolusIngredientCodeSequence", DC::ContrastBolusIngredientCodeSequence },
        { "ContrastAdministrationProfileSequence", DC::ContrastAdministrationProfileSequence },
        { "ContrastBolusUsageSequence", DC::ContrastBolusUsageSequence },
        { "ContrastBolusAgentAdministered", DC::ContrastBolusAgentAdministered },
        { "ContrastBolusAgentDetected", DC::ContrastBolusAgentDetected },
        { "ContrastBolusAgentPhase", DC::ContrastBolusAgentPhase },
        { "CTDIvol", DC::CTDIvol },
        { "CTDIPhantomTypeCodeSequence", DC::CTDIPhantomTypeCodeSequence },
        { "CalciumScoringMassFactorPatient", DC::CalciumScoringMassFactorPatient },
        { "CalciumScoringMassFactorDevice", DC::CalciumScoringMassFactorDevice },
        { "EnergyWeightingFactor", DC::EnergyWeightingFactor },
        { "CTAdditionalXRaySourceSequence", DC::CTAdditionalXRaySourceSequence },
        { "MultienergyCTAcquisition", DC::MultienergyCTAcquisition },
        { "MultienergyCTAcquisitionSequence", DC::MultienergyCTAcquisitionSequence },
        { "MultienergyCTProcessingSequence", DC::MultienergyCTProcessingSequence },
        { "MultienergyCTCharacteristicsSequence", DC::MultienergyCTCharacteristicsSequence },
        { "MultienergyCTXRaySourceSequence", DC::MultienergyCTXRaySourceSequence },
        { "XRaySourceIndex", DC::XRaySourceIndex },
        { "XRaySourceID", DC::XRaySourceID },
        { "MultienergySourceTechnique", DC::MultienergySourceTechnique },
        { "SourceStartDateTime", DC::SourceStartDateTime },
        { "SourceEndDateTime", DC::SourceEndDateTime },
        { "SwitchingPhaseNumber", DC::SwitchingPhaseNumber },
        { "SwitchingPhaseNominalDuration", DC::SwitchingPhaseNominalDuration },
        { "SwitchingPhaseTransitionDuration", DC::SwitchingPhaseTransitionDuration },
        { "EffectiveBinEnergy", DC::EffectiveBinEnergy },
        { "MultienergyCTXRayDetectorSequence", DC::MultienergyCTXRayDetectorSequence },
        { "XRayDetectorIndex", DC::XRayDetectorIndex },
        { "XRayDetectorID", DC::XRayDetectorID },
        { "MultienergyDetectorType", DC::MultienergyDetectorType },
        { "XRayDetectorLabel", DC::XRayDetectorLabel },
        { "NominalMaxEnergy", DC::NominalMaxEnergy },
        { "NominalMinEnergy", DC::NominalMinEnergy },
        { "ReferencedXRayDetectorIndex", DC::ReferencedXRayDetectorIndex },
        { "ReferencedXRaySourceIndex", DC::ReferencedXRaySourceIndex },
        { "ReferencedPathIndex", DC::ReferencedPathIndex },
        { "MultienergyCTPathSequence", DC::MultienergyCTPathSequence },
        { "MultienergyCTPathIndex", DC::MultienergyCTPathIndex },
        { "MultienergyAcquisitionDescription", DC::MultienergyAcquisitionDescription },
        { "MonoenergeticEnergyEquivalent", DC::MonoenergeticEnergyEquivalent },
        { "MaterialCodeSequence", DC::MaterialCodeSequence },
        { "DecompositionMethod", DC::DecompositionMethod },
        { "DecompositionDescription", DC::DecompositionDescription },
        { "DecompositionAlgorithmIdentificationSequence", DC::DecompositionAlgorithmIdentificationSequence },
        { "DecompositionMaterialSequence", DC::DecompositionMaterialSequence },
        { "MaterialAttenuationSequence", DC::MaterialAttenuationSequence },
        { "PhotonEnergy", DC::PhotonEnergy },
        { "XRayMassAttenuationCoefficient", DC::XRayMassAttenuationCoefficient },
        { "ProjectionPixelCalibrationSequence", DC::ProjectionPixelCalibrationSequence },
        { "DistanceSourceToIsocenter", DC::DistanceSourceToIsocenter },
        { "DistanceObjectToTableTop", DC::DistanceObjectToTableTop },
        { "ObjectPixelSpacingInCenterOfBeam", DC::ObjectPixelSpacingInCenterOfBeam },
        { "PositionerPositionSequence", DC::PositionerPositionSequence },
        { "TablePositionSequence", DC::TablePositionSequence },
        { "CollimatorShapeSequence", DC::CollimatorShapeSequence },
        { "PlanesInAcquisition", DC::PlanesInAcquisition },
        { "XAXRFFrameCharacteristicsSequence", DC::XAXRFFrameCharacteristicsSequence },
        { "FrameAcquisitionSequence", DC::FrameAcquisitionSequence },
        { "XRayReceptorType", DC::XRayReceptorType },
        { "AcquisitionProtocolName", DC::AcquisitionProtocolName },
        { "AcquisitionProtocolDescription", DC::AcquisitionProtocolDescription },
        { "ContrastBolusIngredientOpaque", DC::ContrastBolusIngredientOpaque },
        { "DistanceReceptorPlaneToDetectorHousing", DC::DistanceReceptorPlaneToDetectorHousing },
        { "IntensifierActiveShape", DC::IntensifierActiveShape },
        { "IntensifierActiveDimensions", DC::IntensifierActiveDimensions },
        { "PhysicalDetectorSize", DC::PhysicalDetectorSize },
        { "PositionOfIsocenterProjection", DC::PositionOfIsocenterProjection },
        { "FieldOfViewSequence", DC::FieldOfViewSequence },
        { "FieldOfViewDescription", DC::FieldOfViewDescription },
        { "ExposureControlSensingRegionsSequence", DC::ExposureControlSensingRegionsSequence },
        { "ExposureControlSensingRegionShape", DC::ExposureControlSensingRegionShape },
        { "ExposureControlSensingRegionLeftVerticalEdge", DC::ExposureControlSensingRegionLeftVerticalEdge },
        { "ExposureControlSensingRegionRightVerticalEdge", DC::ExposureControlSensingRegionRightVerticalEdge },
        { "ExposureControlSensingRegionUpperHorizontalEdge", DC::ExposureControlSensingRegionUpperHorizontalEdge },
        { "ExposureControlSensingRegionLowerHorizontalEdge", DC::ExposureControlSensingRegionLowerHorizontalEdge },
        { "CenterOfCircularExposureControlSensingRegion", DC::CenterOfCircularExposureControlSensingRegion },
        { "RadiusOfCircularExposureControlSensingRegion", DC::RadiusOfCircularExposureControlSensingRegion },
        { "VerticesOfThePolygonalExposureControlSensingRegion", DC::VerticesOfThePolygonalExposureControlSensingRegion },
        { "ColumnAngulationPatient", DC::ColumnAngulationPatient },
        { "BeamAngle", DC::BeamAngle },
        { "FrameDetectorParametersSequence", DC::FrameDetectorParametersSequence },
        { "CalculatedAnatomyThickness", DC::CalculatedAnatomyThickness },
        { "CalibrationSequence", DC::CalibrationSequence },
        { "ObjectThicknessSequence", DC::ObjectThicknessSequence },
        { "PlaneIdentification", DC::PlaneIdentification },
        { "FieldOfViewDimensionsInFloat", DC::FieldOfViewDimensionsInFloat },
        { "IsocenterReferenceSystemSequence", DC::IsocenterReferenceSystemSequence },
        { "PositionerIsocenterPrimaryAngle", DC::PositionerIsocenterPrimaryAngle },
        { "PositionerIsocenterSecondaryAngle", DC::PositionerIsocenterSecondaryAngle },
        { "PositionerIsocenterDetectorRotationAngle", DC::PositionerIsocenterDetectorRotationAngle },
        { "TableXPositionToIsocenter", DC::TableXPositionToIsocenter },
        { "TableYPositionToIsocenter", DC::TableYPositionToIsocenter },
        { "TableZPositionToIsocenter", DC::TableZPositionToIsocenter },
        { "TableHorizontalRotationAngle", DC::TableHorizontalRotationAngle },
        { "TableHeadTiltAngle", DC::TableHeadTiltAngle },
        { "TableCradleTiltAngle", DC::TableCradleTiltAngle },
        { "FrameDisplayShutterSequence", DC::FrameDisplayShutterSequence },
        { "AcquiredImageAreaDoseProduct", DC::AcquiredImageAreaDoseProduct },
        { "CArmPositionerTabletopRelationship", DC::CArmPositionerTabletopRelationship },
        { "XRayGeometrySequence", DC::XRayGeometrySequence },
        { "IrradiationEventIdentificationSequence", DC::IrradiationEventIdentificationSequence },
        { "XRay3DFrameTypeSequence", DC::XRay3DFrameTypeSequence },
        { "ContributingSourcesSequence", DC::ContributingSourcesSequence },
        { "XRay3DAcquisitionSequence", DC::XRay3DAcquisitionSequence },
        { "PrimaryPositionerScanArc", DC::PrimaryPositionerScanArc },
        { "SecondaryPositionerScanArc", DC::SecondaryPositionerScanArc },
        { "PrimaryPositionerScanStartAngle", DC::PrimaryPositionerScanStartAngle },
        { "SecondaryPositionerScanStartAngle", DC::SecondaryPositionerScanStartAngle },
        { "PrimaryPositionerIncrement", DC::PrimaryPositionerIncrement },
        { "SecondaryPositionerIncrement", DC::SecondaryPositionerIncrement },
        { "StartAcquisitionDateTime", DC::StartAcquisitionDateTime },
        { "EndAcquisitionDateTime", DC::EndAcquisitionDateTime },
        { "PrimaryPositionerIncrementSign", DC::PrimaryPositionerIncrementSign },
        { "SecondaryPositionerIncrementSign", DC::SecondaryPositionerIncrementSign },
        { "ApplicationName", DC::ApplicationName },
        { "ApplicationVersion", DC::ApplicationVersion },
        { "ApplicationManufacturer", DC::ApplicationManufacturer },
        { "AlgorithmType", DC::AlgorithmType },
        { "AlgorithmDescription", DC::AlgorithmDescription },
        { "XRay3DReconstructionSequence", DC::XRay3DReconstructionSequence },
        { "ReconstructionDescription", DC::ReconstructionDescription },
        { "PerProjectionAcquisitionSequence", DC::PerProjectionAcquisitionSequence },
        { "DetectorPositionSequence", DC::DetectorPositionSequence },
        { "XRayAcquisitionDoseSequence", DC::XRayAcquisitionDoseSequence },
        { "XRaySourceIsocenterPrimaryAngle", DC::XRaySourceIsocenterPrimaryAngle },
        { "XRaySourceIsocenterSecondaryAngle", DC::XRaySourceIsocenterSecondaryAngle },
        { "BreastSupportIsocenterPrimaryAngle", DC::BreastSupportIsocenterPrimaryAngle },
        { "BreastSupportIsocenterSecondaryAngle", DC::BreastSupportIsocenterSecondaryAngle },
        { "BreastSupportXPositionToIsocenter", DC::BreastSupportXPositionToIsocenter },
        { "BreastSupportYPositionToIsocenter", DC::BreastSupportYPositionToIsocenter },
        { "BreastSupportZPositionToIsocenter", DC::BreastSupportZPositionToIsocenter },
        { "DetectorIsocenterPrimaryAngle", DC::DetectorIsocenterPrimaryAngle },
        { "DetectorIsocenterSecondaryAngle", DC::DetectorIsocenterSecondaryAngle },
        { "DetectorXPositionToIsocenter", DC::DetectorXPositionToIsocenter },
        { "DetectorYPositionToIsocenter", DC::DetectorYPositionToIsocenter },
        { "DetectorZPositionToIsocenter", DC::DetectorZPositionToIsocenter },
        { "XRayGridSequence", DC::XRayGridSequence },
        { "XRayFilterSequence", DC::XRayFilterSequence },
        { "DetectorActiveAreaTLHCPosition", DC::DetectorActiveAreaTLHCPosition },
        { "DetectorActiveAreaOrientation", DC::DetectorActiveAreaOrientation },
        { "PositionerPrimaryAngleDirection", DC::PositionerPrimaryAngleDirection },
        { "DiffusionBMatrixSequence", DC::DiffusionBMatrixSequence },
        { "DiffusionBValueXX", DC::DiffusionBValueXX },
        { "DiffusionBValueXY", DC::DiffusionBValueXY },
        { "DiffusionBValueXZ", DC::DiffusionBValueXZ },
        { "DiffusionBValueYY", DC::DiffusionBValueYY },
        { "DiffusionBValueYZ", DC::DiffusionBValueYZ },
        { "DiffusionBValueZZ", DC::DiffusionBValueZZ },
        { "FunctionalMRSequence", DC::FunctionalMRSequence },
        { "FunctionalSettlingPhaseFramesPresent", DC::FunctionalSettlingPhaseFramesPresent },
        { "FunctionalSyncPulse", DC::FunctionalSyncPulse },
        { "SettlingPhaseFrame", DC::SettlingPhaseFrame },
        { "DecayCorrectionDateTime", DC::DecayCorrectionDateTime },
        { "StartDensityThreshold", DC::StartDensityThreshold },
        { "StartRelativeDensityDifferenceThreshold", DC::StartRelativeDensityDifferenceThreshold },
        { "StartCardiacTriggerCountThreshold", DC::StartCardiacTriggerCountThreshold },
        { "StartRespiratoryTriggerCountThreshold", DC::StartRespiratoryTriggerCountThreshold },
        { "TerminationCountsThreshold", DC::TerminationCountsThreshold },
        { "TerminationDensityThreshold", DC::TerminationDensityThreshold },
        { "TerminationRelativeDensityThreshold", DC::TerminationRelativeDensityThreshold },
        { "TerminationTimeThreshold", DC::TerminationTimeThreshold },
        { "TerminationCardiacTriggerCountThreshold", DC::TerminationCardiacTriggerCountThreshold },
        { "TerminationRespiratoryTriggerCountThreshold", DC::TerminationRespiratoryTriggerCountThreshold },
        { "DetectorGeometry", DC::DetectorGeometry },
        { "TransverseDetectorSeparation", DC::TransverseDetectorSeparation },
        { "AxialDetectorDimension", DC::AxialDetectorDimension },
        { "RadiopharmaceuticalAgentNumber", DC::RadiopharmaceuticalAgentNumber },
        { "PETFrameAcquisitionSequence", DC::PETFrameAcquisitionSequence },
        { "PETDetectorMotionDetailsSequence", DC::PETDetectorMotionDetailsSequence },
        { "PETTableDynamicsSequence", DC::PETTableDynamicsSequence },
        { "PETPositionSequence", DC::PETPositionSequence },
        { "PETFrameCorrectionFactorsSequence", DC::PETFrameCorrectionFactorsSequence },
        { "RadiopharmaceuticalUsageSequence", DC::RadiopharmaceuticalUsageSequence },
        { "AttenuationCorrectionSource", DC::AttenuationCorrectionSource },
        { "NumberOfIterations", DC::NumberOfIterations },
        { "NumberOfSubsets", DC::NumberOfSubsets },
        { "PETReconstructionSequence", DC::PETReconstructionSequence },
        { "PETFrameTypeSequence", DC::PETFrameTypeSequence },
        { "TimeOfFlightInformationUsed", DC::TimeOfFlightInformationUsed },
        { "ReconstructionType", DC::ReconstructionType },
        { "DecayCorrected", DC::DecayCorrected },
        { "AttenuationCorrected", DC::AttenuationCorrected },
        { "ScatterCorrected", DC::ScatterCorrected },
        { "DeadTimeCorrected", DC::DeadTimeCorrected },
        { "GantryMotionCorrected", DC::GantryMotionCorrected },
        { "PatientMotionCorrected", DC::PatientMotionCorrected },
        { "CountLossNormalizationCorrected", DC::CountLossNormalizationCorrected },
        { "RandomsCorrected", DC::RandomsCorrected },
        { "NonUniformRadialSamplingCorrected", DC::NonUniformRadialSamplingCorrected },
        { "SensitivityCalibrated", DC::SensitivityCalibrated },
        { "DetectorNormalizationCorrection", DC::DetectorNormalizationCorrection },
        { "IterativeReconstructionMethod", DC::IterativeReconstructionMethod },
        { "AttenuationCorrectionTemporalRelationship", DC::AttenuationCorrectionTemporalRelationship },
        { "PatientPhysiologicalStateSequence", DC::PatientPhysiologicalStateSequence },
        { "PatientPhysiologicalStateCodeSequence", DC::PatientPhysiologicalStateCodeSequence },
        { "DepthsOfFocus", DC::DepthsOfFocus },
        { "ExcludedIntervalsSequence", DC::ExcludedIntervalsSequence },
        { "ExclusionStartDateTime", DC::ExclusionStartDateTime },
        { "ExclusionDuration", DC::ExclusionDuration },
        { "USImageDescriptionSequence", DC::USImageDescriptionSequence },
        { "ImageDataTypeSequence", DC::ImageDataTypeSequence },
        { "DataType", DC::DataType },
        { "TransducerScanPatternCodeSequence", DC::TransducerScanPatternCodeSequence },
        { "AliasedDataType", DC::AliasedDataType },
        { "PositionMeasuringDeviceUsed", DC::PositionMeasuringDeviceUsed },
        { "TransducerGeometryCodeSequence", DC::TransducerGeometryCodeSequence },
        { "TransducerBeamSteeringCodeSequence", DC::TransducerBeamSteeringCodeSequence },
        { "TransducerApplicationCodeSequence", DC::TransducerApplicationCodeSequence },
        { "ZeroVelocityPixelValue", DC::ZeroVelocityPixelValue },
        { "PhotoacousticExcitationCharacteristicsSequence", DC::PhotoacousticExcitationCharacteristicsSequence },
        { "ExcitationSpectralWidth", DC::ExcitationSpectralWidth },
        { "ExcitationEnergy", DC::ExcitationEnergy },
        { "ExcitationPulseDuration", DC::ExcitationPulseDuration },
        { "ExcitationWavelengthSequence", DC::ExcitationWavelengthSequence },
        { "ExcitationWavelength", DC::ExcitationWavelength },
        { "IlluminationTranslationFlag", DC::IlluminationTranslationFlag },
        { "AcousticCouplingMediumFlag", DC::AcousticCouplingMediumFlag },
        { "AcousticCouplingMediumCodeSequence", DC::AcousticCouplingMediumCodeSequence },
        { "AcousticCouplingMediumTemperature", DC::AcousticCouplingMediumTemperature },
        { "TransducerResponseSequence", DC::TransducerResponseSequence },
        { "CenterFrequency", DC::CenterFrequency },
        { "FractionalBandwidth", DC::FractionalBandwidth },
        { "LowerCutoffFrequency", DC::LowerCutoffFrequency },
        { "UpperCutoffFrequency", DC::UpperCutoffFrequency },
        { "TransducerTechnologySequence", DC::TransducerTechnologySequence },
        { "SoundSpeedCorrectionMechanismCodeSequence", DC::SoundSpeedCorrectionMechanismCodeSequence },
        { "ObjectSoundSpeed", DC::ObjectSoundSpeed },
        { "AcousticCouplingMediumSoundSpeed", DC::AcousticCouplingMediumSoundSpeed },
        { "PhotoacousticImageFrameTypeSequence", DC::PhotoacousticImageFrameTypeSequence },
        { "ImageDataTypeCodeSequence", DC::ImageDataTypeCodeSequence },
        { "ReferenceLocationLabel", DC::ReferenceLocationLabel },
        { "ReferenceLocationDescription", DC::ReferenceLocationDescription },
        { "ReferenceBasisCodeSequence", DC::ReferenceBasisCodeSequence },
        { "ReferenceGeometryCodeSequence", DC::ReferenceGeometryCodeSequence },
        { "OffsetDistance", DC::OffsetDistance },
        { "OffsetDirection", DC::OffsetDirection },
        { "PotentialScheduledProtocolCodeSequence", DC::PotentialScheduledProtocolCodeSequence },
        { "PotentialRequestedProcedureCodeSequence", DC::PotentialRequestedProcedureCodeSequence },
        { "PotentialReasonsForProcedure", DC::PotentialReasonsForProcedure },
        { "PotentialReasonsForProcedureCodeSequence", DC::PotentialReasonsForProcedureCodeSequence },
        { "PotentialDiagnosticTasks", DC::PotentialDiagnosticTasks },
        { "ContraindicationsCodeSequence", DC::ContraindicationsCodeSequence },
        { "ReferencedDefinedProtocolSequence", DC::ReferencedDefinedProtocolSequence },
        { "ReferencedPerformedProtocolSequence", DC::ReferencedPerformedProtocolSequence },
        { "PredecessorProtocolSequence", DC::PredecessorProtocolSequence },
        { "ProtocolPlanningInformation", DC::ProtocolPlanningInformation },
        { "ProtocolDesignRationale", DC::ProtocolDesignRationale },
        { "PatientSpecificationSequence", DC::PatientSpecificationSequence },
        { "ModelSpecificationSequence", DC::ModelSpecificationSequence },
        { "ParametersSpecificationSequence", DC::ParametersSpecificationSequence },
        { "InstructionSequence", DC::InstructionSequence },
        { "InstructionIndex", DC::InstructionIndex },
        { "InstructionText", DC::InstructionText },
        { "InstructionDescription", DC::InstructionDescription },
        { "InstructionPerformedFlag", DC::InstructionPerformedFlag },
        { "InstructionPerformedDateTime", DC::InstructionPerformedDateTime },
        { "InstructionPerformanceComment", DC::InstructionPerformanceComment },
        { "PatientPositioningInstructionSequence", DC::PatientPositioningInstructionSequence },
        { "PositioningMethodCodeSequence", DC::PositioningMethodCodeSequence },
        { "PositioningLandmarkSequence", DC::PositioningLandmarkSequence },
        { "TargetFrameOfReferenceUID", DC::TargetFrameOfReferenceUID },
        { "AcquisitionProtocolElementSpecificationSequence", DC::AcquisitionProtocolElementSpecificationSequence },
        { "AcquisitionProtocolElementSequence", DC::AcquisitionProtocolElementSequence },
        { "ProtocolElementNumber", DC::ProtocolElementNumber },
        { "ProtocolElementName", DC::ProtocolElementName },
        { "ProtocolElementCharacteristicsSummary", DC::ProtocolElementCharacteristicsSummary },
        { "ProtocolElementPurpose", DC::ProtocolElementPurpose },
        { "AcquisitionMotion", DC::AcquisitionMotion },
        { "AcquisitionStartLocationSequence", DC::AcquisitionStartLocationSequence },
        { "AcquisitionEndLocationSequence", DC::AcquisitionEndLocationSequence },
        { "ReconstructionProtocolElementSpecificationSequence", DC::ReconstructionProtocolElementSpecificationSequence },
        { "ReconstructionProtocolElementSequence", DC::ReconstructionProtocolElementSequence },
        { "StorageProtocolElementSpecificationSequence", DC::StorageProtocolElementSpecificationSequence },
        { "StorageProtocolElementSequence", DC::StorageProtocolElementSequence },
        { "RequestedSeriesDescription", DC::RequestedSeriesDescription },
        { "SourceAcquisitionProtocolElementNumber", DC::SourceAcquisitionProtocolElementNumber },
        { "SourceAcquisitionBeamNumber", DC::SourceAcquisitionBeamNumber },
        { "SourceReconstructionProtocolElementNumber", DC::SourceReconstructionProtocolElementNumber },
        { "ReconstructionStartLocationSequence", DC::ReconstructionStartLocationSequence },
        { "ReconstructionEndLocationSequence", DC::ReconstructionEndLocationSequence },
        { "ReconstructionAlgorithmSequence", DC::ReconstructionAlgorithmSequence },
        { "ReconstructionTargetCenterLocationSequence", DC::ReconstructionTargetCenterLocationSequence },
        { "ImageFilterDescription", DC::ImageFilterDescription },
        { "CTDIvolNotificationTrigger", DC::CTDIvolNotificationTrigger },
        { "DLPNotificationTrigger", DC::DLPNotificationTrigger },
        { "AutoKVPSelectionType", DC::AutoKVPSelectionType },
        { "AutoKVPUpperBound", DC::AutoKVPUpperBound },
        { "AutoKVPLowerBound", DC::AutoKVPLowerBound },
        { "ProtocolDefinedPatientPosition", DC::ProtocolDefinedPatientPosition },
        { "ContributingEquipmentSequence", DC::ContributingEquipmentSequence },
        { "ContributionDateTime", DC::ContributionDateTime },
        { "ContributionDescription", DC::ContributionDescription },
        { "StudyInstanceUID", DC::StudyInstanceUID },
        { "SeriesInstanceUID", DC::SeriesInstanceUID },
        { "StudyID", DC::StudyID },
        { "SeriesNumber", DC::SeriesNumber },
        { "AcquisitionNumber", DC::AcquisitionNumber },
        { "InstanceNumber", DC::InstanceNumber },
        { "IsotopeNumber", DC::IsotopeNumber },
        { "PhaseNumber", DC::PhaseNumber },
        { "IntervalNumber", DC::IntervalNumber },
        { "TimeSlotNumber", DC::TimeSlotNumber },
        { "AngleNumber", DC::AngleNumber },
        { "ItemNumber", DC::ItemNumber },
        { "PatientOrientation", DC::PatientOrientation },
        { "OverlayNumber", DC::OverlayNumber },
        { "CurveNumber", DC::CurveNumber },
        { "LUTNumber", DC::LUTNumber },
        { "PyramidLabel", DC::PyramidLabel },
        { "ImagePosition", DC::ImagePosition },
        { "ImagePositionPatient", DC::ImagePositionPatient },
        { "ImageOrientation", DC::ImageOrientation },
        { "ImageOrientationPatient", DC::ImageOrientationPatient },
        { "Location", DC::Location },
        { "FrameOfReferenceUID", DC::FrameOfReferenceUID },
        { "Laterality", DC::Laterality },
        { "ImageLaterality", DC::ImageLaterality },
        { "ImageGeometryType", DC::ImageGeometryType },
        { "MaskingImage", DC::MaskingImage },
        { "ReportNumber", DC::ReportNumber },
        { "TemporalPositionIdentifier", DC::TemporalPositionIdentifier },
        { "NumberOfTemporalPositions", DC::NumberOfTemporalPositions },
        { "TemporalResolution", DC::TemporalResolution },
        { "SynchronizationFrameOfReferenceUID", DC::SynchronizationFrameOfReferenceUID },
        { "SOPInstanceUIDOfConcatenationSource", DC::SOPInstanceUIDOfConcatenationSource },
        { "SeriesInStudy", DC::SeriesInStudy },
        { "AcquisitionsInSeries", DC::AcquisitionsInSeries },
        { "ImagesInAcquisition", DC::ImagesInAcquisition },
        { "ImagesInSeries", DC::ImagesInSeries },
        { "AcquisitionsInStudy", DC::AcquisitionsInStudy },
        { "ImagesInStudy", DC::ImagesInStudy },
        { "Reference", DC::Reference },
        { "TargetPositionReferenceIndicator", DC::TargetPositionReferenceIndicator },
        { "PositionReferenceIndicator", DC::PositionReferenceIndicator },
        { "SliceLocation", DC::SliceLocation },
        { "OtherStudyNumbers", DC::OtherStudyNumbers },
        { "NumberOfPatientRelatedStudies", DC::NumberOfPatientRelatedStudies },
        { "NumberOfPatientRelatedSeries", DC::NumberOfPatientRelatedSeries },
        { "NumberOfPatientRelatedInstances", DC::NumberOfPatientRelatedInstances },
        { "NumberOfStudyRelatedSeries", DC::NumberOfStudyRelatedSeries },
        { "NumberOfStudyRelatedInstances", DC::NumberOfStudyRelatedInstances },
        { "NumberOfSeriesRelatedInstances", DC::NumberOfSeriesRelatedInstances },
        { "SourceImageIDs", DC::SourceImageIDs },
        { "ModifyingDeviceID", DC::ModifyingDeviceID },
        { "ModifiedImageID", DC::ModifiedImageID },
        { "ModifiedImageDate", DC::ModifiedImageDate },
        { "ModifyingDeviceManufacturer", DC::ModifyingDeviceManufacturer },
        { "ModifiedImageTime", DC::ModifiedImageTime },
        { "ModifiedImageDescription", DC::ModifiedImageDescription },
        { "ImageComments", DC::ImageComments },
        { "OriginalImageIdentification", DC::OriginalImageIdentification },
        { "OriginalImageIdentificationNomenclature", DC::OriginalImageIdentificationNomenclature },
        { "StackID", DC::StackID },
        { "InStackPositionNumber", DC::InStackPositionNumber },
        { "FrameAnatomySequence", DC::FrameAnatomySequence },
        { "FrameLaterality", DC::FrameLaterality },
        { "FrameContentSequence", DC::FrameContentSequence },
        { "PlanePositionSequence", DC::PlanePositionSequence },
        { "PlaneOrientationSequence", DC::PlaneOrientationSequence },
        { "TemporalPositionIndex", DC::TemporalPositionIndex },
        { "NominalCardiacTriggerDelayTime", DC::NominalCardiacTriggerDelayTime },
        { "NominalCardiacTriggerTimePriorToRPeak", DC::NominalCardiacTriggerTimePriorToRPeak },
        { "ActualCardiacTriggerTimePriorToRPeak", DC::ActualCardiacTriggerTimePriorToRPeak },
        { "FrameAcquisitionNumber", DC::FrameAcquisitionNumber },
        { "DimensionIndexValues", DC::DimensionIndexValues },
        { "FrameComments", DC::FrameComments },
        { "ConcatenationUID", DC::ConcatenationUID },
        { "InConcatenationNumber", DC::InConcatenationNumber },
        { "InConcatenationTotalNumber", DC::InConcatenationTotalNumber },
        { "DimensionOrganizationUID", DC::DimensionOrganizationUID },
        { "DimensionIndexPointer", DC::DimensionIndexPointer },
        { "FunctionalGroupPointer", DC::FunctionalGroupPointer },
        { "UnassignedSharedConvertedAttributesSequence", DC::UnassignedSharedConvertedAttributesSequence },
        { "UnassignedPerFrameConvertedAttributesSequence", DC::UnassignedPerFrameConvertedAttributesSequence },
        { "ConversionSourceAttributesSequence", DC::ConversionSourceAttributesSequence },
        { "DimensionIndexPrivateCreator", DC::DimensionIndexPrivateCreator },
        { "DimensionOrganizationSequence", DC::DimensionOrganizationSequence },
        { "DimensionIndexSequence", DC::DimensionIndexSequence },
        { "ConcatenationFrameOffsetNumber", DC::ConcatenationFrameOffsetNumber },
        { "FunctionalGroupPrivateCreator", DC::FunctionalGroupPrivateCreator },
        { "NominalPercentageOfCardiacPhase", DC::NominalPercentageOfCardiacPhase },
        { "NominalPercentageOfRespiratoryPhase", DC::NominalPercentageOfRespiratoryPhase },
        { "StartingRespiratoryAmplitude", DC::StartingRespiratoryAmplitude },
        { "StartingRespiratoryPhase", DC::StartingRespiratoryPhase },
        { "EndingRespiratoryAmplitude", DC::EndingRespiratoryAmplitude },
        { "EndingRespiratoryPhase", DC::EndingRespiratoryPhase },
        { "RespiratoryTriggerType", DC::RespiratoryTriggerType },
        { "RRIntervalTimeNominal", DC::RRIntervalTimeNominal },
        { "ActualCardiacTriggerDelayTime", DC::ActualCardiacTriggerDelayTime },
        { "RespiratorySynchronizationSequence", DC::RespiratorySynchronizationSequence },
        { "RespiratoryIntervalTime", DC::RespiratoryIntervalTime },
        { "NominalRespiratoryTriggerDelayTime", DC::NominalRespiratoryTriggerDelayTime },
        { "RespiratoryTriggerDelayThreshold", DC::RespiratoryTriggerDelayThreshold },
        { "ActualRespiratoryTriggerDelayTime", DC::ActualRespiratoryTriggerDelayTime },
        { "ImagePositionVolume", DC::ImagePositionVolume },
        { "ImageOrientationVolume", DC::ImageOrientationVolume },
        { "UltrasoundAcquisitionGeometry", DC::UltrasoundAcquisitionGeometry },
        { "ApexPosition", DC::ApexPosition },
        { "VolumeToTransducerMappingMatrix", DC::VolumeToTransducerMappingMatrix },
        { "VolumeToTableMappingMatrix", DC::VolumeToTableMappingMatrix },
        { "VolumeToTransducerRelationship", DC::VolumeToTransducerRelationship },
        { "PatientFrameOfReferenceSource", DC::PatientFrameOfReferenceSource },
        { "TemporalPositionTimeOffset", DC::TemporalPositionTimeOffset },
        { "PlanePositionVolumeSequence", DC::PlanePositionVolumeSequence },
        { "PlaneOrientationVolumeSequence", DC::PlaneOrientationVolumeSequence },
        { "TemporalPositionSequence", DC::TemporalPositionSequence },
        { "DimensionOrganizationType", DC::DimensionOrganizationType },
        { "VolumeFrameOfReferenceUID", DC::VolumeFrameOfReferenceUID },
        { "TableFrameOfReferenceUID", DC::TableFrameOfReferenceUID },
        { "DimensionDescriptionLabel", DC::DimensionDescriptionLabel },
        { "PatientOrientationInFrameSequence", DC::PatientOrientationInFrameSequence },
        { "FrameLabel", DC::FrameLabel },
        { "AcquisitionIndex", DC::AcquisitionIndex },
        { "ContributingSOPInstancesReferenceSequence", DC::ContributingSOPInstancesReferenceSequence },
        { "ReconstructionIndex", DC::ReconstructionIndex },
        { "LightPathFilterPassThroughWavelength", DC::LightPathFilterPassThroughWavelength },
        { "LightPathFilterPassBand", DC::LightPathFilterPassBand },
        { "ImagePathFilterPassThroughWavelength", DC::ImagePathFilterPassThroughWavelength },
        { "ImagePathFilterPassBand", DC::ImagePathFilterPassBand },
        { "PatientEyeMovementCommanded", DC::PatientEyeMovementCommanded },
        { "PatientEyeMovementCommandCodeSequence", DC::PatientEyeMovementCommandCodeSequence },
        { "SphericalLensPower", DC::SphericalLensPower },
        { "CylinderLensPower", DC::CylinderLensPower },
        { "CylinderAxis", DC::CylinderAxis },
        { "EmmetropicMagnification", DC::EmmetropicMagnification },
        { "IntraOcularPressure", DC::IntraOcularPressure },
        { "HorizontalFieldOfView", DC::HorizontalFieldOfView },
        { "PupilDilated", DC::PupilDilated },
        { "DegreeOfDilation", DC::DegreeOfDilation },
        { "StereoBaselineAngle", DC::StereoBaselineAngle },
        { "StereoBaselineDisplacement", DC::StereoBaselineDisplacement },
        { "StereoHorizontalPixelOffset", DC::StereoHorizontalPixelOffset },
        { "StereoVerticalPixelOffset", DC::StereoVerticalPixelOffset },
        { "StereoRotation", DC::StereoRotation },
        { "AcquisitionDeviceTypeCodeSequence", DC::AcquisitionDeviceTypeCodeSequence },
        { "IlluminationTypeCodeSequence", DC::IlluminationTypeCodeSequence },
        { "LightPathFilterTypeStackCodeSequence", DC::LightPathFilterTypeStackCodeSequence },
        { "ImagePathFilterTypeStackCodeSequence", DC::ImagePathFilterTypeStackCodeSequence },
        { "LensesCodeSequence", DC::LensesCodeSequence },
        { "ChannelDescriptionCodeSequence", DC::ChannelDescriptionCodeSequence },
        { "RefractiveStateSequence", DC::RefractiveStateSequence },
        { "MydriaticAgentCodeSequence", DC::MydriaticAgentCodeSequence },
        { "RelativeImagePositionCodeSequence", DC::RelativeImagePositionCodeSequence },
        { "CameraAngleOfView", DC::CameraAngleOfView },
        { "StereoPairsSequence", DC::StereoPairsSequence },
        { "LeftImageSequence", DC::LeftImageSequence },
        { "RightImageSequence", DC::RightImageSequence },
        { "StereoPairsPresent", DC::StereoPairsPresent },
        { "AxialLengthOfTheEye", DC::AxialLengthOfTheEye },
        { "OphthalmicFrameLocationSequence", DC::OphthalmicFrameLocationSequence },
        { "ReferenceCoordinates", DC::ReferenceCoordinates },
        { "DepthSpatialResolution", DC::DepthSpatialResolution },
        { "MaximumDepthDistortion", DC::MaximumDepthDistortion },
        { "AlongScanSpatialResolution", DC::AlongScanSpatialResolution },
        { "MaximumAlongScanDistortion", DC::MaximumAlongScanDistortion },
        { "OphthalmicImageOrientation", DC::OphthalmicImageOrientation },
        { "DepthOfTransverseImage", DC::DepthOfTransverseImage },
        { "MydriaticAgentConcentrationUnitsSequence", DC::MydriaticAgentConcentrationUnitsSequence },
        { "AcrossScanSpatialResolution", DC::AcrossScanSpatialResolution },
        { "MaximumAcrossScanDistortion", DC::MaximumAcrossScanDistortion },
        { "MydriaticAgentConcentration", DC::MydriaticAgentConcentration },
        { "IlluminationWaveLength", DC::IlluminationWaveLength },
        { "IlluminationPower", DC::IlluminationPower },
        { "IlluminationBandwidth", DC::IlluminationBandwidth },
        { "MydriaticAgentSequence", DC::MydriaticAgentSequence },
        { "OphthalmicAxialMeasurementsRightEyeSequence", DC::OphthalmicAxialMeasurementsRightEyeSequence },
        { "OphthalmicAxialMeasurementsLeftEyeSequence", DC::OphthalmicAxialMeasurementsLeftEyeSequence },
        { "OphthalmicAxialMeasurementsDeviceType", DC::OphthalmicAxialMeasurementsDeviceType },
        { "OphthalmicAxialLengthMeasurementsType", DC::OphthalmicAxialLengthMeasurementsType },
        { "OphthalmicAxialLengthSequence", DC::OphthalmicAxialLengthSequence },
        { "OphthalmicAxialLength", DC::OphthalmicAxialLength },
        { "LensStatusCodeSequence", DC::LensStatusCodeSequence },
        { "VitreousStatusCodeSequence", DC::VitreousStatusCodeSequence },
        { "IOLFormulaCodeSequence", DC::IOLFormulaCodeSequence },
        { "IOLFormulaDetail", DC::IOLFormulaDetail },
        { "KeratometerIndex", DC::KeratometerIndex },
        { "SourceOfOphthalmicAxialLengthCodeSequence", DC::SourceOfOphthalmicAxialLengthCodeSequence },
        { "SourceOfCornealSizeDataCodeSequence", DC::SourceOfCornealSizeDataCodeSequence },
        { "TargetRefraction", DC::TargetRefraction },
        { "RefractiveProcedureOccurred", DC::RefractiveProcedureOccurred },
        { "RefractiveSurgeryTypeCodeSequence", DC::RefractiveSurgeryTypeCodeSequence },
        { "OphthalmicUltrasoundMethodCodeSequence", DC::OphthalmicUltrasoundMethodCodeSequence },
        { "SurgicallyInducedAstigmatismSequence", DC::SurgicallyInducedAstigmatismSequence },
        { "TypeOfOpticalCorrection", DC::TypeOfOpticalCorrection },
        { "ToricIOLPowerSequence", DC::ToricIOLPowerSequence },
        { "PredictedToricErrorSequence", DC::PredictedToricErrorSequence },
        { "PreSelectedForImplantation", DC::PreSelectedForImplantation },
        { "ToricIOLPowerForExactEmmetropiaSequence", DC::ToricIOLPowerForExactEmmetropiaSequence },
        { "ToricIOLPowerForExactTargetRefractionSequence", DC::ToricIOLPowerForExactTargetRefractionSequence },
        { "OphthalmicAxialLengthMeasurementsSequence", DC::OphthalmicAxialLengthMeasurementsSequence },
        { "IOLPower", DC::IOLPower },
        { "PredictedRefractiveError", DC::PredictedRefractiveError },
        { "OphthalmicAxialLengthVelocity", DC::OphthalmicAxialLengthVelocity },
        { "LensStatusDescription", DC::LensStatusDescription },
        { "VitreousStatusDescription", DC::VitreousStatusDescription },
        { "IOLPowerSequence", DC::IOLPowerSequence },
        { "LensConstantSequence", DC::LensConstantSequence },
        { "IOLManufacturer", DC::IOLManufacturer },
        { "LensConstantDescription", DC::LensConstantDescription },
        { "ImplantName", DC::ImplantName },
        { "KeratometryMeasurementTypeCodeSequence", DC::KeratometryMeasurementTypeCodeSequence },
        { "ImplantPartNumber", DC::ImplantPartNumber },
        { "ReferencedOphthalmicAxialMeasurementsSequence", DC::ReferencedOphthalmicAxialMeasurementsSequence },
        { "OphthalmicAxialLengthMeasurementsSegmentNameCodeSequence", DC::OphthalmicAxialLengthMeasurementsSegmentNameCodeSequence },
        { "RefractiveErrorBeforeRefractiveSurgeryCodeSequence", DC::RefractiveErrorBeforeRefractiveSurgeryCodeSequence },
        { "IOLPowerForExactEmmetropia", DC::IOLPowerForExactEmmetropia },
        { "IOLPowerForExactTargetRefraction", DC::IOLPowerForExactTargetRefraction },
        { "AnteriorChamberDepthDefinitionCodeSequence", DC::AnteriorChamberDepthDefinitionCodeSequence },
        { "LensThicknessSequence", DC::LensThicknessSequence },
        { "AnteriorChamberDepthSequence", DC::AnteriorChamberDepthSequence },
        { "CalculationCommentSequence", DC::CalculationCommentSequence },
        { "CalculationCommentType", DC::CalculationCommentType },
        { "CalculationComment", DC::CalculationComment },
        { "LensThickness", DC::LensThickness },
        { "AnteriorChamberDepth", DC::AnteriorChamberDepth },
        { "SourceOfLensThicknessDataCodeSequence", DC::SourceOfLensThicknessDataCodeSequence },
        { "SourceOfAnteriorChamberDepthDataCodeSequence", DC::SourceOfAnteriorChamberDepthDataCodeSequence },
        { "SourceOfRefractiveMeasurementsSequence", DC::SourceOfRefractiveMeasurementsSequence },
        { "SourceOfRefractiveMeasurementsCodeSequence", DC::SourceOfRefractiveMeasurementsCodeSequence },
        { "OphthalmicAxialLengthMeasurementModified", DC::OphthalmicAxialLengthMeasurementModified },
        { "OphthalmicAxialLengthDataSourceCodeSequence", DC::OphthalmicAxialLengthDataSourceCodeSequence },
        { "OphthalmicAxialLengthAcquisitionMethodCodeSequence", DC::OphthalmicAxialLengthAcquisitionMethodCodeSequence },
        { "SignalToNoiseRatio", DC::SignalToNoiseRatio },
        { "OphthalmicAxialLengthDataSourceDescription", DC::OphthalmicAxialLengthDataSourceDescription },
        { "OphthalmicAxialLengthMeasurementsTotalLengthSequence", DC::OphthalmicAxialLengthMeasurementsTotalLengthSequence },
        { "OphthalmicAxialLengthMeasurementsSegmentalLengthSequence", DC::OphthalmicAxialLengthMeasurementsSegmentalLengthSequence },
        { "OphthalmicAxialLengthMeasurementsLengthSummationSequence", DC::OphthalmicAxialLengthMeasurementsLengthSummationSequence },
        { "UltrasoundOphthalmicAxialLengthMeasurementsSequence", DC::UltrasoundOphthalmicAxialLengthMeasurementsSequence },
        { "OpticalOphthalmicAxialLengthMeasurementsSequence", DC::OpticalOphthalmicAxialLengthMeasurementsSequence },
        { "UltrasoundSelectedOphthalmicAxialLengthSequence", DC::UltrasoundSelectedOphthalmicAxialLengthSequence },
        { "OphthalmicAxialLengthSelectionMethodCodeSequence", DC::OphthalmicAxialLengthSelectionMethodCodeSequence },
        { "OpticalSelectedOphthalmicAxialLengthSequence", DC::OpticalSelectedOphthalmicAxialLengthSequence },
        { "SelectedSegmentalOphthalmicAxialLengthSequence", DC::SelectedSegmentalOphthalmicAxialLengthSequence },
        { "SelectedTotalOphthalmicAxialLengthSequence", DC::SelectedTotalOphthalmicAxialLengthSequence },
        { "OphthalmicAxialLengthQualityMetricSequence", DC::OphthalmicAxialLengthQualityMetricSequence },
        { "OphthalmicAxialLengthQualityMetricTypeCodeSequence", DC::OphthalmicAxialLengthQualityMetricTypeCodeSequence },
        { "OphthalmicAxialLengthQualityMetricTypeDescription", DC::OphthalmicAxialLengthQualityMetricTypeDescription },
        { "IntraocularLensCalculationsRightEyeSequence", DC::IntraocularLensCalculationsRightEyeSequence },
        { "IntraocularLensCalculationsLeftEyeSequence", DC::IntraocularLensCalculationsLeftEyeSequence },
        { "ReferencedOphthalmicAxialLengthMeasurementQCImageSequence", DC::ReferencedOphthalmicAxialLengthMeasurementQCImageSequence },
        { "OphthalmicMappingDeviceType", DC::OphthalmicMappingDeviceType },
        { "AcquisitionMethodCodeSequence", DC::AcquisitionMethodCodeSequence },
        { "AcquisitionMethodAlgorithmSequence", DC::AcquisitionMethodAlgorithmSequence },
        { "OphthalmicThicknessMapTypeCodeSequence", DC::OphthalmicThicknessMapTypeCodeSequence },
        { "OphthalmicThicknessMappingNormalsSequence", DC::OphthalmicThicknessMappingNormalsSequence },
        { "RetinalThicknessDefinitionCodeSequence", DC::RetinalThicknessDefinitionCodeSequence },
        { "PixelValueMappingToCodedConceptSequence", DC::PixelValueMappingToCodedConceptSequence },
        { "MappedPixelValue", DC::MappedPixelValue },
        { "PixelValueMappingExplanation", DC::PixelValueMappingExplanation },
        { "OphthalmicThicknessMapQualityThresholdSequence", DC::OphthalmicThicknessMapQualityThresholdSequence },
        { "OphthalmicThicknessMapThresholdQualityRating", DC::OphthalmicThicknessMapThresholdQualityRating },
        { "AnatomicStructureReferencePoint", DC::AnatomicStructureReferencePoint },
        { "RegistrationToLocalizerSequence", DC::RegistrationToLocalizerSequence },
        { "RegisteredLocalizerUnits", DC::RegisteredLocalizerUnits },
        { "RegisteredLocalizerTopLeftHandCorner", DC::RegisteredLocalizerTopLeftHandCorner },
        { "RegisteredLocalizerBottomRightHandCorner", DC::RegisteredLocalizerBottomRightHandCorner },
        { "OphthalmicThicknessMapQualityRatingSequence", DC::OphthalmicThicknessMapQualityRatingSequence },
        { "RelevantOPTAttributesSequence", DC::RelevantOPTAttributesSequence },
        { "TransformationMethodCodeSequence", DC::TransformationMethodCodeSequence },
        { "TransformationAlgorithmSequence", DC::TransformationAlgorithmSequence },
        { "OphthalmicAxialLengthMethod", DC::OphthalmicAxialLengthMethod },
        { "OphthalmicFOV", DC::OphthalmicFOV },
        { "TwoDimensionalToThreeDimensionalMapSequence", DC::TwoDimensionalToThreeDimensionalMapSequence },
        { "WideFieldOphthalmicPhotographyQualityRatingSequence", DC::WideFieldOphthalmicPhotographyQualityRatingSequence },
        { "WideFieldOphthalmicPhotographyQualityThresholdSequence", DC::WideFieldOphthalmicPhotographyQualityThresholdSequence },
        { "WideFieldOphthalmicPhotographyThresholdQualityRating", DC::WideFieldOphthalmicPhotographyThresholdQualityRating },
        { "XCoordinatesCenterPixelViewAngle", DC::XCoordinatesCenterPixelViewAngle },
        { "YCoordinatesCenterPixelViewAngle", DC::YCoordinatesCenterPixelViewAngle },
        { "NumberOfMapPoints", DC::NumberOfMapPoints },
        { "TwoDimensionalToThreeDimensionalMapData", DC::TwoDimensionalToThreeDimensionalMapData },
        { "DerivationAlgorithmSequence", DC::DerivationAlgorithmSequence },
        { "OphthalmicImageTypeCodeSequence", DC::OphthalmicImageTypeCodeSequence },
        { "OphthalmicImageTypeDescription", DC::OphthalmicImageTypeDescription },
        { "ScanPatternTypeCodeSequence", DC::ScanPatternTypeCodeSequence },
        { "ReferencedSurfaceMeshIdentificationSequence", DC::ReferencedSurfaceMeshIdentificationSequence },
        { "OphthalmicVolumetricPropertiesFlag", DC::OphthalmicVolumetricPropertiesFlag },
        { "OphthalmicAnatomicReferencePointXCoordinate", DC::OphthalmicAnatomicReferencePointXCoordinate },
        { "OphthalmicAnatomicReferencePointYCoordinate", DC::OphthalmicAnatomicReferencePointYCoordinate },
        { "OphthalmicEnFaceImageQualityRatingSequence", DC::OphthalmicEnFaceImageQualityRatingSequence },
        { "QualityThreshold", DC::QualityThreshold },
        { "OCTBscanAnalysisAcquisitionParametersSequence", DC::OCTBscanAnalysisAcquisitionParametersSequence },
        { "NumberOfBscansPerFrame", DC::NumberOfBscansPerFrame },
        { "BscanSlabThickness", DC::BscanSlabThickness },
        { "DistanceBetweenBscanSlabs", DC::DistanceBetweenBscanSlabs },
        { "BscanCycleTime", DC::BscanCycleTime },
        { "BscanCycleTimeVector", DC::BscanCycleTimeVector },
        { "AscanRate", DC::AscanRate },
        { "BscanRate", DC::BscanRate },
        { "SurfaceMeshZPixelOffset", DC::SurfaceMeshZPixelOffset },
        { "VisualFieldHorizontalExtent", DC::VisualFieldHorizontalExtent },
        { "VisualFieldVerticalExtent", DC::VisualFieldVerticalExtent },
        { "VisualFieldShape", DC::VisualFieldShape },
        { "ScreeningTestModeCodeSequence", DC::ScreeningTestModeCodeSequence },
        { "MaximumStimulusLuminance", DC::MaximumStimulusLuminance },
        { "BackgroundLuminance", DC::BackgroundLuminance },
        { "StimulusColorCodeSequence", DC::StimulusColorCodeSequence },
        { "BackgroundIlluminationColorCodeSequence", DC::BackgroundIlluminationColorCodeSequence },
        { "StimulusArea", DC::StimulusArea },
        { "StimulusPresentationTime", DC::StimulusPresentationTime },
        { "FixationSequence", DC::FixationSequence },
        { "FixationMonitoringCodeSequence", DC::FixationMonitoringCodeSequence },
        { "VisualFieldCatchTrialSequence", DC::VisualFieldCatchTrialSequence },
        { "FixationCheckedQuantity", DC::FixationCheckedQuantity },
        { "PatientNotProperlyFixatedQuantity", DC::PatientNotProperlyFixatedQuantity },
        { "PresentedVisualStimuliDataFlag", DC::PresentedVisualStimuliDataFlag },
        { "NumberOfVisualStimuli", DC::NumberOfVisualStimuli },
        { "ExcessiveFixationLossesDataFlag", DC::ExcessiveFixationLossesDataFlag },
        { "ExcessiveFixationLosses", DC::ExcessiveFixationLosses },
        { "StimuliRetestingQuantity", DC::StimuliRetestingQuantity },
        { "CommentsOnPatientPerformanceOfVisualField", DC::CommentsOnPatientPerformanceOfVisualField },
        { "FalseNegativesEstimateFlag", DC::FalseNegativesEstimateFlag },
        { "FalseNegativesEstimate", DC::FalseNegativesEstimate },
        { "NegativeCatchTrialsQuantity", DC::NegativeCatchTrialsQuantity },
        { "FalseNegativesQuantity", DC::FalseNegativesQuantity },
        { "ExcessiveFalseNegativesDataFlag", DC::ExcessiveFalseNegativesDataFlag },
        { "ExcessiveFalseNegatives", DC::ExcessiveFalseNegatives },
        { "FalsePositivesEstimateFlag", DC::FalsePositivesEstimateFlag },
        { "FalsePositivesEstimate", DC::FalsePositivesEstimate },
        { "CatchTrialsDataFlag", DC::CatchTrialsDataFlag },
        { "PositiveCatchTrialsQuantity", DC::PositiveCatchTrialsQuantity },
        { "TestPointNormalsDataFlag", DC::TestPointNormalsDataFlag },
        { "TestPointNormalsSequence", DC::TestPointNormalsSequence },
        { "GlobalDeviationProbabilityNormalsFlag", DC::GlobalDeviationProbabilityNormalsFlag },
        { "FalsePositivesQuantity", DC::FalsePositivesQuantity },
        { "ExcessiveFalsePositivesDataFlag", DC::ExcessiveFalsePositivesDataFlag },
        { "ExcessiveFalsePositives", DC::ExcessiveFalsePositives },
        { "VisualFieldTestNormalsFlag", DC::VisualFieldTestNormalsFlag },
        { "ResultsNormalsSequence", DC::ResultsNormalsSequence },
        { "AgeCorrectedSensitivityDeviationAlgorithmSequence", DC::AgeCorrectedSensitivityDeviationAlgorithmSequence },
        { "GlobalDeviationFromNormal", DC::GlobalDeviationFromNormal },
        { "GeneralizedDefectSensitivityDeviationAlgorithmSequence", DC::GeneralizedDefectSensitivityDeviationAlgorithmSequence },
        { "LocalizedDeviationFromNormal", DC::LocalizedDeviationFromNormal },
        { "PatientReliabilityIndicator", DC::PatientReliabilityIndicator },
        { "VisualFieldMeanSensitivity", DC::VisualFieldMeanSensitivity },
        { "GlobalDeviationProbability", DC::GlobalDeviationProbability },
        { "LocalDeviationProbabilityNormalsFlag", DC::LocalDeviationProbabilityNormalsFlag },
        { "LocalizedDeviationProbability", DC::LocalizedDeviationProbability },
        { "ShortTermFluctuationCalculated", DC::ShortTermFluctuationCalculated },
        { "ShortTermFluctuation", DC::ShortTermFluctuation },
        { "ShortTermFluctuationProbabilityCalculated", DC::ShortTermFluctuationProbabilityCalculated },
        { "ShortTermFluctuationProbability", DC::ShortTermFluctuationProbability },
        { "CorrectedLocalizedDeviationFromNormalCalculated", DC::CorrectedLocalizedDeviationFromNormalCalculated },
        { "CorrectedLocalizedDeviationFromNormal", DC::CorrectedLocalizedDeviationFromNormal },
        { "CorrectedLocalizedDeviationFromNormalProbabilityCalculated", DC::CorrectedLocalizedDeviationFromNormalProbabilityCalculated },
        { "CorrectedLocalizedDeviationFromNormalProbability", DC::CorrectedLocalizedDeviationFromNormalProbability },
        { "GlobalDeviationProbabilitySequence", DC::GlobalDeviationProbabilitySequence },
        { "LocalizedDeviationProbabilitySequence", DC::LocalizedDeviationProbabilitySequence },
        { "FovealSensitivityMeasured", DC::FovealSensitivityMeasured },
        { "FovealSensitivity", DC::FovealSensitivity },
        { "VisualFieldTestDuration", DC::VisualFieldTestDuration },
        { "VisualFieldTestPointSequence", DC::VisualFieldTestPointSequence },
        { "VisualFieldTestPointXCoordinate", DC::VisualFieldTestPointXCoordinate },
        { "VisualFieldTestPointYCoordinate", DC::VisualFieldTestPointYCoordinate },
        { "AgeCorrectedSensitivityDeviationValue", DC::AgeCorrectedSensitivityDeviationValue },
        { "StimulusResults", DC::StimulusResults },
        { "SensitivityValue", DC::SensitivityValue },
        { "RetestStimulusSeen", DC::RetestStimulusSeen },
        { "RetestSensitivityValue", DC::RetestSensitivityValue },
        { "VisualFieldTestPointNormalsSequence", DC::VisualFieldTestPointNormalsSequence },
        { "QuantifiedDefect", DC::QuantifiedDefect },
        { "AgeCorrectedSensitivityDeviationProbabilityValue", DC::AgeCorrectedSensitivityDeviationProbabilityValue },
        { "GeneralizedDefectCorrectedSensitivityDeviationFlag", DC::GeneralizedDefectCorrectedSensitivityDeviationFlag },
        { "GeneralizedDefectCorrectedSensitivityDeviationValue", DC::GeneralizedDefectCorrectedSensitivityDeviationValue },
        { "GeneralizedDefectCorrectedSensitivityDeviationProbabilityValue", DC::GeneralizedDefectCorrectedSensitivityDeviationProbabilityValue },
        { "MinimumSensitivityValue", DC::MinimumSensitivityValue },
        { "BlindSpotLocalized", DC::BlindSpotLocalized },
        { "BlindSpotXCoordinate", DC::BlindSpotXCoordinate },
        { "BlindSpotYCoordinate", DC::BlindSpotYCoordinate },
        { "VisualAcuityMeasurementSequence", DC::VisualAcuityMeasurementSequence },
        { "RefractiveParametersUsedOnPatientSequence", DC::RefractiveParametersUsedOnPatientSequence },
        { "MeasurementLaterality", DC::MeasurementLaterality },
        { "OphthalmicPatientClinicalInformationLeftEyeSequence", DC::OphthalmicPatientClinicalInformationLeftEyeSequence },
        { "OphthalmicPatientClinicalInformationRightEyeSequence", DC::OphthalmicPatientClinicalInformationRightEyeSequence },
        { "FovealPointNormativeDataFlag", DC::FovealPointNormativeDataFlag },
        { "FovealPointProbabilityValue", DC::FovealPointProbabilityValue },
        { "ScreeningBaselineMeasured", DC::ScreeningBaselineMeasured },
        { "ScreeningBaselineMeasuredSequence", DC::ScreeningBaselineMeasuredSequence },
        { "ScreeningBaselineType", DC::ScreeningBaselineType },
        { "ScreeningBaselineValue", DC::ScreeningBaselineValue },
        { "AlgorithmSource", DC::AlgorithmSource },
        { "DataSetName", DC::DataSetName },
        { "DataSetVersion", DC::DataSetVersion },
        { "DataSetSource", DC::DataSetSource },
        { "DataSetDescription", DC::DataSetDescription },
        { "VisualFieldTestReliabilityGlobalIndexSequence", DC::VisualFieldTestReliabilityGlobalIndexSequence },
        { "VisualFieldGlobalResultsIndexSequence", DC::VisualFieldGlobalResultsIndexSequence },
        { "DataObservationSequence", DC::DataObservationSequence },
        { "IndexNormalsFlag", DC::IndexNormalsFlag },
        { "IndexProbability", DC::IndexProbability },
        { "IndexProbabilitySequence", DC::IndexProbabilitySequence },
        { "SamplesPerPixel", DC::SamplesPerPixel },
        { "SamplesPerPixelUsed", DC::SamplesPerPixelUsed },
        { "PhotometricInterpretation", DC::PhotometricInterpretation },
        { "ImageDimensions", DC::ImageDimensions },
        { "PlanarConfiguration", DC::PlanarConfiguration },
        { "NumberOfFrames", DC::NumberOfFrames },
        { "FrameIncrementPointer", DC::FrameIncrementPointer },
        { "FrameDimensionPointer", DC::FrameDimensionPointer },
        { "Rows", DC::Rows },
        { "Columns", DC::Columns },
        { "Planes", DC::Planes },
        { "UltrasoundColorDataPresent", DC::UltrasoundColorDataPresent },
        { "PixelSpacing", DC::PixelSpacing },
        { "ZoomFactor", DC::ZoomFactor },
        { "ZoomCenter", DC::ZoomCenter },
        { "PixelAspectRatio", DC::PixelAspectRatio },
        { "ImageFormat", DC::ImageFormat },
        { "ManipulatedImage", DC::ManipulatedImage },
        { "CorrectedImage", DC::CorrectedImage },
        { "CompressionRecognitionCode", DC::CompressionRecognitionCode },
        { "CompressionCode", DC::CompressionCode },
        { "CompressionOriginator", DC::CompressionOriginator },
        { "CompressionLabel", DC::CompressionLabel },
        { "CompressionDescription", DC::CompressionDescription },
        { "CompressionSequence", DC::CompressionSequence },
        { "CompressionStepPointers", DC::CompressionStepPointers },
        { "RepeatInterval", DC::RepeatInterval },
        { "BitsGrouped", DC::BitsGrouped },
        { "PerimeterTable", DC::PerimeterTable },
        { "PerimeterValue", DC::PerimeterValue },
        { "PredictorRows", DC::PredictorRows },
        { "PredictorColumns", DC::PredictorColumns },
        { "PredictorConstants", DC::PredictorConstants },
        { "BlockedPixels", DC::BlockedPixels },
        { "BlockRows", DC::BlockRows },
        { "BlockColumns", DC::BlockColumns },
        { "RowOverlap", DC::RowOverlap },
        { "ColumnOverlap", DC::ColumnOverlap },
        { "BitsAllocated", DC::BitsAllocated },
        { "BitsStored", DC::BitsStored },
        { "HighBit", DC::HighBit },
        { "PixelRepresentation", DC::PixelRepresentation },
        { "SmallestValidPixelValue", DC::SmallestValidPixelValue },
        { "LargestValidPixelValue", DC::LargestValidPixelValue },
        { "SmallestImagePixelValue", DC::SmallestImagePixelValue },
        { "LargestImagePixelValue", DC::LargestImagePixelValue },
        { "SmallestPixelValueInSeries", DC::SmallestPixelValueInSeries },
        { "LargestPixelValueInSeries", DC::LargestPixelValueInSeries },
        { "SmallestImagePixelValueInPlane", DC::SmallestImagePixelValueInPlane },
        { "LargestImagePixelValueInPlane", DC::LargestImagePixelValueInPlane },
        { "PixelPaddingValue", DC::PixelPaddingValue },
        { "PixelPaddingRangeLimit", DC::PixelPaddingRangeLimit },
        { "FloatPixelPaddingValue", DC::FloatPixelPaddingValue },
        { "DoubleFloatPixelPaddingValue", DC::DoubleFloatPixelPaddingValue },
        { "FloatPixelPaddingRangeLimit", DC::FloatPixelPaddingRangeLimit },
        { "DoubleFloatPixelPaddingRangeLimit", DC::DoubleFloatPixelPaddingRangeLimit },
        { "ImageLocation", DC::ImageLocation },
        { "QualityControlImage", DC::QualityControlImage },
        { "BurnedInAnnotation", DC::BurnedInAnnotation },
        { "RecognizableVisualFeatures", DC::RecognizableVisualFeatures },
        { "LongitudinalTemporalInformationModified", DC::LongitudinalTemporalInformationModified },
        { "ReferencedColorPaletteInstanceUID", DC::ReferencedColorPaletteInstanceUID },
        { "TransformLabel", DC::TransformLabel },
        { "TransformVersionNumber", DC::TransformVersionNumber },
        { "NumberOfTransformSteps", DC::NumberOfTransformSteps },
        { "SequenceOfCompressedData", DC::SequenceOfCompressedData },
        { "DetailsOfCoefficients", DC::DetailsOfCoefficients },
        { "RowsForNthOrderCoefficients", DC::RowsForNthOrderCoefficients },
        { "ColumnsForNthOrderCoefficients", DC::ColumnsForNthOrderCoefficients },
        { "CoefficientCoding", DC::CoefficientCoding },
        { "CoefficientCodingPointers", DC::CoefficientCodingPointers },
        { "DCTLabel", DC::DCTLabel },
        { "DataBlockDescription", DC::DataBlockDescription },
        { "DataBlock", DC::DataBlock },
        { "NormalizationFactorFormat", DC::NormalizationFactorFormat },
        { "ZonalMapNumberFormat", DC::ZonalMapNumberFormat },
        { "ZonalMapLocation", DC::ZonalMapLocation },
        { "ZonalMapFormat", DC::ZonalMapFormat },
        { "AdaptiveMapFormat", DC::AdaptiveMapFormat },
        { "CodeNumberFormat", DC::CodeNumberFormat },
        { "CodeLabel", DC::CodeLabel },
        { "NumberOfTables", DC::NumberOfTables },
        { "CodeTableLocation", DC::CodeTableLocation },
        { "BitsForCodeWord", DC::BitsForCodeWord },
        { "ImageDataLocation", DC::ImageDataLocation },
        { "PixelSpacingCalibrationType", DC::PixelSpacingCalibrationType },
        { "PixelSpacingCalibrationDescription", DC::PixelSpacingCalibrationDescription },
        { "PixelIntensityRelationship", DC::PixelIntensityRelationship },
        { "PixelIntensityRelationshipSign", DC::PixelIntensityRelationshipSign },
        { "WindowCenter", DC::WindowCenter },
        { "WindowWidth", DC::WindowWidth },
        { "RescaleIntercept", DC::RescaleIntercept },
        { "RescaleSlope", DC::RescaleSlope },
        { "RescaleType", DC::RescaleType },
        { "WindowCenterWidthExplanation", DC::WindowCenterWidthExplanation },
        { "VOILUTFunction", DC::VOILUTFunction },
        { "GrayScale", DC::GrayScale },
        { "RecommendedViewingMode", DC::RecommendedViewingMode },
        { "GrayLookupTableDescriptor", DC::GrayLookupTableDescriptor },
        { "RedPaletteColorLookupTableDescriptor", DC::RedPaletteColorLookupTableDescriptor },
        { "GreenPaletteColorLookupTableDescriptor", DC::GreenPaletteColorLookupTableDescriptor },
        { "BluePaletteColorLookupTableDescriptor", DC::BluePaletteColorLookupTableDescriptor },
        { "AlphaPaletteColorLookupTableDescriptor", DC::AlphaPaletteColorLookupTableDescriptor },
        { "LargeRedPaletteColorLookupTableDescriptor", DC::LargeRedPaletteColorLookupTableDescriptor },
        { "LargeGreenPaletteColorLookupTableDescriptor", DC::LargeGreenPaletteColorLookupTableDescriptor },
        { "LargeBluePaletteColorLookupTableDescriptor", DC::LargeBluePaletteColorLookupTableDescriptor },
        { "PaletteColorLookupTableUID", DC::PaletteColorLookupTableUID },
        { "GrayLookupTableData", DC::GrayLookupTableData },
        { "RedPaletteColorLookupTableData", DC::RedPaletteColorLookupTableData },
        { "GreenPaletteColorLookupTableData", DC::GreenPaletteColorLookupTableData },
        { "BluePaletteColorLookupTableData", DC::BluePaletteColorLookupTableData },
        { "AlphaPaletteColorLookupTableData", DC::AlphaPaletteColorLookupTableData },
        { "LargeRedPaletteColorLookupTableData", DC::LargeRedPaletteColorLookupTableData },
        { "LargeGreenPaletteColorLookupTableData", DC::LargeGreenPaletteColorLookupTableData },
        { "LargeBluePaletteColorLookupTableData", DC::LargeBluePaletteColorLookupTableData },
        { "LargePaletteColorLookupTableUID", DC::LargePaletteColorLookupTableUID },
        { "SegmentedRedPaletteColorLookupTableData", DC::SegmentedRedPaletteColorLookupTableData },
        { "SegmentedGreenPaletteColorLookupTableData", DC::SegmentedGreenPaletteColorLookupTableData },
        { "SegmentedBluePaletteColorLookupTableData", DC::SegmentedBluePaletteColorLookupTableData },
        { "SegmentedAlphaPaletteColorLookupTableData", DC::SegmentedAlphaPaletteColorLookupTableData },
        { "StoredValueColorRangeSequence", DC::StoredValueColorRangeSequence },
        { "MinimumStoredValueMapped", DC::MinimumStoredValueMapped },
        { "MaximumStoredValueMapped", DC::MaximumStoredValueMapped },
        { "BreastImplantPresent", DC::BreastImplantPresent },
        { "PartialView", DC::PartialView },
        { "PartialViewDescription", DC::PartialViewDescription },
        { "PartialViewCodeSequence", DC::PartialViewCodeSequence },
        { "SpatialLocationsPreserved", DC::SpatialLocationsPreserved },
        { "DataFrameAssignmentSequence", DC::DataFrameAssignmentSequence },
        { "DataPathAssignment", DC::DataPathAssignment },
        { "BitsMappedToColorLookupTable", DC::BitsMappedToColorLookupTable },
        { "BlendingLUT1Sequence", DC::BlendingLUT1Sequence },
        { "BlendingLUT1TransferFunction", DC::BlendingLUT1TransferFunction },
        { "BlendingWeightConstant", DC::BlendingWeightConstant },
        { "BlendingLookupTableDescriptor", DC::BlendingLookupTableDescriptor },
        { "BlendingLookupTableData", DC::BlendingLookupTableData },
        { "EnhancedPaletteColorLookupTableSequence", DC::EnhancedPaletteColorLookupTableSequence },
        { "BlendingLUT2Sequence", DC::BlendingLUT2Sequence },
        { "BlendingLUT2TransferFunction", DC::BlendingLUT2TransferFunction },
        { "DataPathID", DC::DataPathID },
        { "RGBLUTTransferFunction", DC::RGBLUTTransferFunction },
        { "AlphaLUTTransferFunction", DC::AlphaLUTTransferFunction },
        { "ICCProfile", DC::ICCProfile },
        { "ColorSpace", DC::ColorSpace },
        { "LossyImageCompression", DC::LossyImageCompression },
        { "LossyImageCompressionRatio", DC::LossyImageCompressionRatio },
        { "LossyImageCompressionMethod", DC::LossyImageCompressionMethod },
        { "ModalityLUTSequence", DC::ModalityLUTSequence },
        { "VariableModalityLUTSequence", DC::VariableModalityLUTSequence },
        { "LUTDescriptor", DC::LUTDescriptor },
        { "LUTExplanation", DC::LUTExplanation },
        { "ModalityLUTType", DC::ModalityLUTType },
        { "LUTData", DC::LUTData },
        { "VOILUTSequence", DC::VOILUTSequence },
        { "SoftcopyVOILUTSequence", DC::SoftcopyVOILUTSequence },
        { "ImagePresentationComments", DC::ImagePresentationComments },
        { "BiPlaneAcquisitionSequence", DC::BiPlaneAcquisitionSequence },
        { "RepresentativeFrameNumber", DC::RepresentativeFrameNumber },
        { "FrameNumbersOfInterest", DC::FrameNumbersOfInterest },
        { "FrameOfInterestDescription", DC::FrameOfInterestDescription },
        { "FrameOfInterestType", DC::FrameOfInterestType },
        { "MaskPointers", DC::MaskPointers },
        { "RWavePointer", DC::RWavePointer },
        { "MaskSubtractionSequence", DC::MaskSubtractionSequence },
        { "MaskOperation", DC::MaskOperation },
        { "ApplicableFrameRange", DC::ApplicableFrameRange },
        { "MaskFrameNumbers", DC::MaskFrameNumbers },
        { "ContrastFrameAveraging", DC::ContrastFrameAveraging },
        { "MaskSubPixelShift", DC::MaskSubPixelShift },
        { "TIDOffset", DC::TIDOffset },
        { "MaskOperationExplanation", DC::MaskOperationExplanation },
        { "EquipmentAdministratorSequence", DC::EquipmentAdministratorSequence },
        { "NumberOfDisplaySubsystems", DC::NumberOfDisplaySubsystems },
        { "CurrentConfigurationID", DC::CurrentConfigurationID },
        { "DisplaySubsystemID", DC::DisplaySubsystemID },
        { "DisplaySubsystemName", DC::DisplaySubsystemName },
        { "DisplaySubsystemDescription", DC::DisplaySubsystemDescription },
        { "SystemStatus", DC::SystemStatus },
        { "SystemStatusComment", DC::SystemStatusComment },
        { "TargetLuminanceCharacteristicsSequence", DC::TargetLuminanceCharacteristicsSequence },
        { "LuminanceCharacteristicsID", DC::LuminanceCharacteristicsID },
        { "DisplaySubsystemConfigurationSequence", DC::DisplaySubsystemConfigurationSequence },
        { "ConfigurationID", DC::ConfigurationID },
        { "ConfigurationName", DC::ConfigurationName },
        { "ConfigurationDescription", DC::ConfigurationDescription },
        { "ReferencedTargetLuminanceCharacteristicsID", DC::ReferencedTargetLuminanceCharacteristicsID },
        { "QAResultsSequence", DC::QAResultsSequence },
        { "DisplaySubsystemQAResultsSequence", DC::DisplaySubsystemQAResultsSequence },
        { "ConfigurationQAResultsSequence", DC::ConfigurationQAResultsSequence },
        { "MeasurementEquipmentSequence", DC::MeasurementEquipmentSequence },
        { "MeasurementFunctions", DC::MeasurementFunctions },
        { "MeasurementEquipmentType", DC::MeasurementEquipmentType },
        { "VisualEvaluationResultSequence", DC::VisualEvaluationResultSequence },
        { "DisplayCalibrationResultSequence", DC::DisplayCalibrationResultSequence },
        { "DDLValue", DC::DDLValue },
        { "CIExyWhitePoint", DC::CIExyWhitePoint },
        { "DisplayFunctionType", DC::DisplayFunctionType },
        { "GammaValue", DC::GammaValue },
        { "NumberOfLuminancePoints", DC::NumberOfLuminancePoints },
        { "LuminanceResponseSequence", DC::LuminanceResponseSequence },
        { "TargetMinimumLuminance", DC::TargetMinimumLuminance },
        { "TargetMaximumLuminance", DC::TargetMaximumLuminance },
        { "LuminanceValue", DC::LuminanceValue },
        { "LuminanceResponseDescription", DC::LuminanceResponseDescription },
        { "WhitePointFlag", DC::WhitePointFlag },
        { "DisplayDeviceTypeCodeSequence", DC::DisplayDeviceTypeCodeSequence },
        { "DisplaySubsystemSequence", DC::DisplaySubsystemSequence },
        { "LuminanceResultSequence", DC::LuminanceResultSequence },
        { "AmbientLightValueSource", DC::AmbientLightValueSource },
        { "MeasuredCharacteristics", DC::MeasuredCharacteristics },
        { "LuminanceUniformityResultSequence", DC::LuminanceUniformityResultSequence },
        { "VisualEvaluationTestSequence", DC::VisualEvaluationTestSequence },
        { "TestResult", DC::TestResult },
        { "TestResultComment", DC::TestResultComment },
        { "TestImageValidation", DC::TestImageValidation },
        { "TestPatternCodeSequence", DC::TestPatternCodeSequence },
        { "MeasurementPatternCodeSequence", DC::MeasurementPatternCodeSequence },
        { "VisualEvaluationMethodCodeSequence", DC::VisualEvaluationMethodCodeSequence },
        { "PixelDataProviderURL", DC::PixelDataProviderURL },
        { "DataPointRows", DC::DataPointRows },
        { "DataPointColumns", DC::DataPointColumns },
        { "SignalDomainColumns", DC::SignalDomainColumns },
        { "LargestMonochromePixelValue", DC::LargestMonochromePixelValue },
        { "DataRepresentation", DC::DataRepresentation },
        { "PixelMeasuresSequence", DC::PixelMeasuresSequence },
        { "FrameVOILUTSequence", DC::FrameVOILUTSequence },
        { "PixelValueTransformationSequence", DC::PixelValueTransformationSequence },
        { "SignalDomainRows", DC::SignalDomainRows },
        { "DisplayFilterPercentage", DC::DisplayFilterPercentage },
        { "FramePixelShiftSequence", DC::FramePixelShiftSequence },
        { "SubtractionItemID", DC::SubtractionItemID },
        { "PixelIntensityRelationshipLUTSequence", DC::PixelIntensityRelationshipLUTSequence },
        { "FramePixelDataPropertiesSequence", DC::FramePixelDataPropertiesSequence },
        { "GeometricalProperties", DC::GeometricalProperties },
        { "GeometricMaximumDistortion", DC::GeometricMaximumDistortion },
        { "ImageProcessingApplied", DC::ImageProcessingApplied },
        { "MaskSelectionMode", DC::MaskSelectionMode },
        { "LUTFunction", DC::LUTFunction },
        { "MaskVisibilityPercentage", DC::MaskVisibilityPercentage },
        { "PixelShiftSequence", DC::PixelShiftSequence },
        { "RegionPixelShiftSequence", DC::RegionPixelShiftSequence },
        { "VerticesOfTheRegion", DC::VerticesOfTheRegion },
        { "MultiFramePresentationSequence", DC::MultiFramePresentationSequence },
        { "PixelShiftFrameRange", DC::PixelShiftFrameRange },
        { "LUTFrameRange", DC::LUTFrameRange },
        { "ImageToEquipmentMappingMatrix", DC::ImageToEquipmentMappingMatrix },
        { "EquipmentCoordinateSystemIdentification", DC::EquipmentCoordinateSystemIdentification },
        { "StudyStatusID", DC::StudyStatusID },
        { "StudyPriorityID", DC::StudyPriorityID },
        { "StudyIDIssuer", DC::StudyIDIssuer },
        { "StudyVerifiedDate", DC::StudyVerifiedDate },
        { "StudyVerifiedTime", DC::StudyVerifiedTime },
        { "StudyReadDate", DC::StudyReadDate },
        { "StudyReadTime", DC::StudyReadTime },
        { "ScheduledStudyStartDate", DC::ScheduledStudyStartDate },
        { "ScheduledStudyStartTime", DC::ScheduledStudyStartTime },
        { "ScheduledStudyStopDate", DC::ScheduledStudyStopDate },
        { "ScheduledStudyStopTime", DC::ScheduledStudyStopTime },
        { "ScheduledStudyLocation", DC::ScheduledStudyLocation },
        { "ScheduledStudyLocationAETitle", DC::ScheduledStudyLocationAETitle },
        { "ReasonForStudy", DC::ReasonForStudy },
        { "RequestingPhysicianIdentificationSequence", DC::RequestingPhysicianIdentificationSequence },
        { "RequestingPhysician", DC::RequestingPhysician },
        { "RequestingService", DC::RequestingService },
        { "RequestingServiceCodeSequence", DC::RequestingServiceCodeSequence },
        { "StudyArrivalDate", DC::StudyArrivalDate },
        { "StudyArrivalTime", DC::StudyArrivalTime },
        { "StudyCompletionDate", DC::StudyCompletionDate },
        { "StudyCompletionTime", DC::StudyCompletionTime },
        { "StudyComponentStatusID", DC::StudyComponentStatusID },
        { "RequestedProcedureDescription", DC::RequestedProcedureDescription },
        { "RequestedProcedureCodeSequence", DC::RequestedProcedureCodeSequence },
        { "RequestedLateralityCodeSequence", DC::RequestedLateralityCodeSequence },
        { "ReasonForVisit", DC::ReasonForVisit },
        { "ReasonForVisitCodeSequence", DC::ReasonForVisitCodeSequence },
        { "RequestedContrastAgent", DC::RequestedContrastAgent },
        { "StudyComments", DC::StudyComments },
        { "FlowIdentifierSequence", DC::FlowIdentifierSequence },
        { "FlowIdentifier", DC::FlowIdentifier },
        { "FlowTransferSyntaxUID", DC::FlowTransferSyntaxUID },
        { "FlowRTPSamplingRate", DC::FlowRTPSamplingRate },
        { "SourceIdentifier", DC::SourceIdentifier },
        { "FrameOriginTimestamp", DC::FrameOriginTimestamp },
        { "IncludesImagingSubject", DC::IncludesImagingSubject },
        { "FrameUsefulnessGroupSequence", DC::FrameUsefulnessGroupSequence },
        { "RealTimeBulkDataFlowSequence", DC::RealTimeBulkDataFlowSequence },
        { "CameraPositionGroupSequence", DC::CameraPositionGroupSequence },
        { "IncludesInformation", DC::IncludesInformation },
        { "TimeOfFrameGroupSequence", DC::TimeOfFrameGroupSequence },
        { "ReferencedPatientAliasSequence", DC::ReferencedPatientAliasSequence },
        { "VisitStatusID", DC::VisitStatusID },
        { "AdmissionID", DC::AdmissionID },
        { "IssuerOfAdmissionID", DC::IssuerOfAdmissionID },
        { "IssuerOfAdmissionIDSequence", DC::IssuerOfAdmissionIDSequence },
        { "RouteOfAdmissions", DC::RouteOfAdmissions },
        { "ScheduledAdmissionDate", DC::ScheduledAdmissionDate },
        { "ScheduledAdmissionTime", DC::ScheduledAdmissionTime },
        { "ScheduledDischargeDate", DC::ScheduledDischargeDate },
        { "ScheduledDischargeTime", DC::ScheduledDischargeTime },
        { "ScheduledPatientInstitutionResidence", DC::ScheduledPatientInstitutionResidence },
        { "AdmittingDate", DC::AdmittingDate },
        { "AdmittingTime", DC::AdmittingTime },
        { "DischargeDate", DC::DischargeDate },
        { "DischargeTime", DC::DischargeTime },
        { "DischargeDiagnosisDescription", DC::DischargeDiagnosisDescription },
        { "DischargeDiagnosisCodeSequence", DC::DischargeDiagnosisCodeSequence },
        { "SpecialNeeds", DC::SpecialNeeds },
        { "ServiceEpisodeID", DC::ServiceEpisodeID },
        { "IssuerOfServiceEpisodeID", DC::IssuerOfServiceEpisodeID },
        { "ServiceEpisodeDescription", DC::ServiceEpisodeDescription },
        { "IssuerOfServiceEpisodeIDSequence", DC::IssuerOfServiceEpisodeIDSequence },
        { "PertinentDocumentsSequence", DC::PertinentDocumentsSequence },
        { "PertinentResourcesSequence", DC::PertinentResourcesSequence },
        { "ResourceDescription", DC::ResourceDescription },
        { "CurrentPatientLocation", DC::CurrentPatientLocation },
        { "PatientInstitutionResidence", DC::PatientInstitutionResidence },
        { "PatientState", DC::PatientState },
        { "PatientClinicalTrialParticipationSequence", DC::PatientClinicalTrialParticipationSequence },
        { "VisitComments", DC::VisitComments },
        { "WaveformOriginality", DC::WaveformOriginality },
        { "NumberOfWaveformChannels", DC::NumberOfWaveformChannels },
        { "NumberOfWaveformSamples", DC::NumberOfWaveformSamples },
        { "SamplingFrequency", DC::SamplingFrequency },
        { "MultiplexGroupLabel", DC::MultiplexGroupLabel },
        { "ChannelDefinitionSequence", DC::ChannelDefinitionSequence },
        { "WaveformChannelNumber", DC::WaveformChannelNumber },
        { "ChannelLabel", DC::ChannelLabel },
        { "ChannelStatus", DC::ChannelStatus },
        { "ChannelSourceSequence", DC::ChannelSourceSequence },
        { "ChannelSourceModifiersSequence", DC::ChannelSourceModifiersSequence },
        { "SourceWaveformSequence", DC::SourceWaveformSequence },
        { "ChannelDerivationDescription", DC::ChannelDerivationDescription },
        { "ChannelSensitivity", DC::ChannelSensitivity },
        { "ChannelSensitivityUnitsSequence", DC::ChannelSensitivityUnitsSequence },
        { "ChannelSensitivityCorrectionFactor", DC::ChannelSensitivityCorrectionFactor },
        { "ChannelBaseline", DC::ChannelBaseline },
        { "ChannelTimeSkew", DC::ChannelTimeSkew },
        { "ChannelSampleSkew", DC::ChannelSampleSkew },
        { "ChannelOffset", DC::ChannelOffset },
        { "WaveformBitsStored", DC::WaveformBitsStored },
        { "FilterLowFrequency", DC::FilterLowFrequency },
        { "FilterHighFrequency", DC::FilterHighFrequency },
        { "NotchFilterFrequency", DC::NotchFilterFrequency },
        { "NotchFilterBandwidth", DC::NotchFilterBandwidth },
        { "WaveformDataDisplayScale", DC::WaveformDataDisplayScale },
        { "WaveformDisplayBackgroundCIELabValue", DC::WaveformDisplayBackgroundCIELabValue },
        { "WaveformPresentationGroupSequence", DC::WaveformPresentationGroupSequence },
        { "PresentationGroupNumber", DC::PresentationGroupNumber },
        { "ChannelDisplaySequence", DC::ChannelDisplaySequence },
        { "ChannelRecommendedDisplayCIELabValue", DC::ChannelRecommendedDisplayCIELabValue },
        { "ChannelPosition", DC::ChannelPosition },
        { "DisplayShadingFlag", DC::DisplayShadingFlag },
        { "FractionalChannelDisplayScale", DC::FractionalChannelDisplayScale },
        { "AbsoluteChannelDisplayScale", DC::AbsoluteChannelDisplayScale },
        { "MultiplexedAudioChannelsDescriptionCodeSequence", DC::MultiplexedAudioChannelsDescriptionCodeSequence },
        { "ChannelIdentificationCode", DC::ChannelIdentificationCode },
        { "ChannelMode", DC::ChannelMode },
        { "MultiplexGroupUID", DC::MultiplexGroupUID },
        { "PowerlineFrequency", DC::PowerlineFrequency },
        { "ChannelImpedanceSequence", DC::ChannelImpedanceSequence },
        { "ImpedanceValue", DC::ImpedanceValue },
        { "ImpedanceMeasurementDateTime", DC::ImpedanceMeasurementDateTime },
        { "ImpedanceMeasurementFrequency", DC::ImpedanceMeasurementFrequency },
        { "ImpedanceMeasurementCurrentType", DC::ImpedanceMeasurementCurrentType },
        { "WaveformAmplifierType", DC::WaveformAmplifierType },
        { "FilterLowFrequencyCharacteristicsSequence", DC::FilterLowFrequencyCharacteristicsSequence },
        { "FilterHighFrequencyCharacteristicsSequence", DC::FilterHighFrequencyCharacteristicsSequence },
        { "SummarizedFilterLookupTable", DC::SummarizedFilterLookupTable },
        { "NotchFilterCharacteristicsSequence", DC::NotchFilterCharacteristicsSequence },
        { "WaveformFilterType", DC::WaveformFilterType },
        { "AnalogFilterCharacteristicsSequence", DC::AnalogFilterCharacteristicsSequence },
        { "AnalogFilterRollOff", DC::AnalogFilterRollOff },
        { "AnalogFilterType", DC::AnalogFilterType },
        { "DigitalFilterCharacteristicsSequence", DC::DigitalFilterCharacteristicsSequence },
        { "DigitalFilterOrder", DC::DigitalFilterOrder },
        { "DigitalFilterTypeCodeSequence", DC::DigitalFilterTypeCodeSequence },
        { "WaveformFilterDescription", DC::WaveformFilterDescription },
        { "FilterLookupTableSequence", DC::FilterLookupTableSequence },
        { "FilterLookupTableDescription", DC::FilterLookupTableDescription },
        { "FrequencyEncodingCodeSequence", DC::FrequencyEncodingCodeSequence },
        { "MagnitudeEncodingCodeSequence", DC::MagnitudeEncodingCodeSequence },
        { "FilterLookupTableData", DC::FilterLookupTableData },
        { "ScheduledStationAETitle", DC::ScheduledStationAETitle },
        { "ScheduledProcedureStepStartDate", DC::ScheduledProcedureStepStartDate },
        { "ScheduledProcedureStepStartTime", DC::ScheduledProcedureStepStartTime },
        { "ScheduledProcedureStepEndDate", DC::ScheduledProcedureStepEndDate },
        { "ScheduledProcedureStepEndTime", DC::ScheduledProcedureStepEndTime },
        { "ScheduledPerformingPhysicianName", DC::ScheduledPerformingPhysicianName },
        { "ScheduledProcedureStepDescription", DC::ScheduledProcedureStepDescription },
        { "ScheduledProtocolCodeSequence", DC::ScheduledProtocolCodeSequence },
        { "ScheduledProcedureStepID", DC::ScheduledProcedureStepID },
        { "StageCodeSequence", DC::StageCodeSequence },
        { "ScheduledPerformingPhysicianIdentificationSequence", DC::ScheduledPerformingPhysicianIdentificationSequence },
        { "ScheduledStationName", DC::ScheduledStationName },
        { "ScheduledProcedureStepLocation", DC::ScheduledProcedureStepLocation },
        { "PreMedication", DC::PreMedication },
        { "ScheduledProcedureStepStatus", DC::ScheduledProcedureStepStatus },
        { "OrderPlacerIdentifierSequence", DC::OrderPlacerIdentifierSequence },
        { "OrderFillerIdentifierSequence", DC::OrderFillerIdentifierSequence },
        { "LocalNamespaceEntityID", DC::LocalNamespaceEntityID },
        { "UniversalEntityID", DC::UniversalEntityID },
        { "UniversalEntityIDType", DC::UniversalEntityIDType },
        { "IdentifierTypeCode", DC::IdentifierTypeCode },
        { "AssigningFacilitySequence", DC::AssigningFacilitySequence },
        { "AssigningJurisdictionCodeSequence", DC::AssigningJurisdictionCodeSequence },
        { "AssigningAgencyOrDepartmentCodeSequence", DC::AssigningAgencyOrDepartmentCodeSequence },
        { "ScheduledProcedureStepSequence", DC::ScheduledProcedureStepSequence },
        { "ReferencedNonImageCompositeSOPInstanceSequence", DC::ReferencedNonImageCompositeSOPInstanceSequence },
        { "PerformedStationAETitle", DC::PerformedStationAETitle },
        { "PerformedStationName", DC::PerformedStationName },
        { "PerformedLocation", DC::PerformedLocation },
        { "PerformedProcedureStepStartDate", DC::PerformedProcedureStepStartDate },
        { "PerformedProcedureStepStartTime", DC::PerformedProcedureStepStartTime },
        { "PerformedProcedureStepEndDate", DC::PerformedProcedureStepEndDate },
        { "PerformedProcedureStepEndTime", DC::PerformedProcedureStepEndTime },
        { "PerformedProcedureStepStatus", DC::PerformedProcedureStepStatus },
        { "PerformedProcedureStepID", DC::PerformedProcedureStepID },
        { "PerformedProcedureStepDescription", DC::PerformedProcedureStepDescription },
        { "PerformedProcedureTypeDescription", DC::PerformedProcedureTypeDescription },
        { "PerformedProtocolCodeSequence", DC::PerformedProtocolCodeSequence },
        { "PerformedProtocolType", DC::PerformedProtocolType },
        { "ScheduledStepAttributesSequence", DC::ScheduledStepAttributesSequence },
        { "RequestAttributesSequence", DC::RequestAttributesSequence },
        { "CommentsOnThePerformedProcedureStep", DC::CommentsOnThePerformedProcedureStep },
        { "PerformedProcedureStepDiscontinuationReasonCodeSequence", DC::PerformedProcedureStepDiscontinuationReasonCodeSequence },
        { "QuantitySequence", DC::QuantitySequence },
        { "Quantity", DC::Quantity },
        { "MeasuringUnitsSequence", DC::MeasuringUnitsSequence },
        { "BillingItemSequence", DC::BillingItemSequence },
        { "TotalTimeOfFluoroscopy", DC::TotalTimeOfFluoroscopy },
        { "TotalNumberOfExposures", DC::TotalNumberOfExposures },
        { "EntranceDose", DC::EntranceDose },
        { "ExposedArea", DC::ExposedArea },
        { "DistanceSourceToEntrance", DC::DistanceSourceToEntrance },
        { "DistanceSourceToSupport", DC::DistanceSourceToSupport },
        { "ExposureDoseSequence", DC::ExposureDoseSequence },
        { "CommentsOnRadiationDose", DC::CommentsOnRadiationDose },
        { "XRayOutput", DC::XRayOutput },
        { "HalfValueLayer", DC::HalfValueLayer },
        { "OrganDose", DC::OrganDose },
        { "OrganExposed", DC::OrganExposed },
        { "BillingProcedureStepSequence", DC::BillingProcedureStepSequence },
        { "FilmConsumptionSequence", DC::FilmConsumptionSequence },
        { "BillingSuppliesAndDevicesSequence", DC::BillingSuppliesAndDevicesSequence },
        { "ReferencedProcedureStepSequence", DC::ReferencedProcedureStepSequence },
        { "PerformedSeriesSequence", DC::PerformedSeriesSequence },
        { "CommentsOnTheScheduledProcedureStep", DC::CommentsOnTheScheduledProcedureStep },
        { "ProtocolContextSequence", DC::ProtocolContextSequence },
        { "ContentItemModifierSequence", DC::ContentItemModifierSequence },
        { "ScheduledSpecimenSequence", DC::ScheduledSpecimenSequence },
        { "SpecimenAccessionNumber", DC::SpecimenAccessionNumber },
        { "ContainerIdentifier", DC::ContainerIdentifier },
        { "IssuerOfTheContainerIdentifierSequence", DC::IssuerOfTheContainerIdentifierSequence },
        { "AlternateContainerIdentifierSequence", DC::AlternateContainerIdentifierSequence },
        { "ContainerTypeCodeSequence", DC::ContainerTypeCodeSequence },
        { "ContainerDescription", DC::ContainerDescription },
        { "ContainerComponentSequence", DC::ContainerComponentSequence },
        { "SpecimenSequence", DC::SpecimenSequence },
        { "SpecimenIdentifier", DC::SpecimenIdentifier },
        { "SpecimenDescriptionSequenceTrial", DC::SpecimenDescriptionSequenceTrial },
        { "SpecimenDescriptionTrial", DC::SpecimenDescriptionTrial },
        { "SpecimenUID", DC::SpecimenUID },
        { "AcquisitionContextSequence", DC::AcquisitionContextSequence },
        { "AcquisitionContextDescription", DC::AcquisitionContextDescription },
        { "SpecimenTypeCodeSequence", DC::SpecimenTypeCodeSequence },
        { "SpecimenDescriptionSequence", DC::SpecimenDescriptionSequence },
        { "IssuerOfTheSpecimenIdentifierSequence", DC::IssuerOfTheSpecimenIdentifierSequence },
        { "SpecimenShortDescription", DC::SpecimenShortDescription },
        { "SpecimenDetailedDescription", DC::SpecimenDetailedDescription },
        { "SpecimenPreparationSequence", DC::SpecimenPreparationSequence },
        { "SpecimenPreparationStepContentItemSequence", DC::SpecimenPreparationStepContentItemSequence },
        { "SpecimenLocalizationContentItemSequence", DC::SpecimenLocalizationContentItemSequence },
        { "SlideIdentifier", DC::SlideIdentifier },
        { "WholeSlideMicroscopyImageFrameTypeSequence", DC::WholeSlideMicroscopyImageFrameTypeSequence },
        { "ImageCenterPointCoordinatesSequence", DC::ImageCenterPointCoordinatesSequence },
        { "XOffsetInSlideCoordinateSystem", DC::XOffsetInSlideCoordinateSystem },
        { "YOffsetInSlideCoordinateSystem", DC::YOffsetInSlideCoordinateSystem },
        { "ZOffsetInSlideCoordinateSystem", DC::ZOffsetInSlideCoordinateSystem },
        { "PixelSpacingSequence", DC::PixelSpacingSequence },
        { "CoordinateSystemAxisCodeSequence", DC::CoordinateSystemAxisCodeSequence },
        { "MeasurementUnitsCodeSequence", DC::MeasurementUnitsCodeSequence },
        { "VitalStainCodeSequenceTrial", DC::VitalStainCodeSequenceTrial },
        { "RequestedProcedureID", DC::RequestedProcedureID },
        { "ReasonForTheRequestedProcedure", DC::ReasonForTheRequestedProcedure },
        { "RequestedProcedurePriority", DC::RequestedProcedurePriority },
        { "PatientTransportArrangements", DC::PatientTransportArrangements },
        { "RequestedProcedureLocation", DC::RequestedProcedureLocation },
        { "PlacerOrderNumberProcedure", DC::PlacerOrderNumberProcedure },
        { "FillerOrderNumberProcedure", DC::FillerOrderNumberProcedure },
        { "ConfidentialityCode", DC::ConfidentialityCode },
        { "ReportingPriority", DC::ReportingPriority },
        { "ReasonForRequestedProcedureCodeSequence", DC::ReasonForRequestedProcedureCodeSequence },
        { "NamesOfIntendedRecipientsOfResults", DC::NamesOfIntendedRecipientsOfResults },
        { "IntendedRecipientsOfResultsIdentificationSequence", DC::IntendedRecipientsOfResultsIdentificationSequence },
        { "ReasonForPerformedProcedureCodeSequence", DC::ReasonForPerformedProcedureCodeSequence },
        { "RequestedProcedureDescriptionTrial", DC::RequestedProcedureDescriptionTrial },
        { "PersonIdentificationCodeSequence", DC::PersonIdentificationCodeSequence },
        { "PersonAddress", DC::PersonAddress },
        { "PersonTelephoneNumbers", DC::PersonTelephoneNumbers },
        { "PersonTelecomInformation", DC::PersonTelecomInformation },
        { "RequestedProcedureComments", DC::RequestedProcedureComments },
        { "ReasonForTheImagingServiceRequest", DC::ReasonForTheImagingServiceRequest },
        { "IssueDateOfImagingServiceRequest", DC::IssueDateOfImagingServiceRequest },
        { "IssueTimeOfImagingServiceRequest", DC::IssueTimeOfImagingServiceRequest },
        { "PlacerOrderNumberImagingServiceRequestRetired", DC::PlacerOrderNumberImagingServiceRequestRetired },
        { "FillerOrderNumberImagingServiceRequestRetired", DC::FillerOrderNumberImagingServiceRequestRetired },
        { "OrderEnteredBy", DC::OrderEnteredBy },
        { "OrderEntererLocation", DC::OrderEntererLocation },
        { "OrderCallbackPhoneNumber", DC::OrderCallbackPhoneNumber },
        { "OrderCallbackTelecomInformation", DC::OrderCallbackTelecomInformation },
        { "PlacerOrderNumberImagingServiceRequest", DC::PlacerOrderNumberImagingServiceRequest },
        { "FillerOrderNumberImagingServiceRequest", DC::FillerOrderNumberImagingServiceRequest },
        { "ImagingServiceRequestComments", DC::ImagingServiceRequestComments },
        { "ConfidentialityConstraintOnPatientDataDescription", DC::ConfidentialityConstraintOnPatientDataDescription },
        { "GeneralPurposeScheduledProcedureStepStatus", DC::GeneralPurposeScheduledProcedureStepStatus },
        { "GeneralPurposePerformedProcedureStepStatus", DC::GeneralPurposePerformedProcedureStepStatus },
        { "GeneralPurposeScheduledProcedureStepPriority", DC::GeneralPurposeScheduledProcedureStepPriority },
        { "ScheduledProcessingApplicationsCodeSequence", DC::ScheduledProcessingApplicationsCodeSequence },
        { "ScheduledProcedureStepStartDateTime", DC::ScheduledProcedureStepStartDateTime },
        { "MultipleCopiesFlag", DC::MultipleCopiesFlag },
        { "PerformedProcessingApplicationsCodeSequence", DC::PerformedProcessingApplicationsCodeSequence },
        { "ScheduledProcedureStepExpirationDateTime", DC::ScheduledProcedureStepExpirationDateTime },
        { "HumanPerformerCodeSequence", DC::HumanPerformerCodeSequence },
        { "ScheduledProcedureStepModificationDateTime", DC::ScheduledProcedureStepModificationDateTime },
        { "ExpectedCompletionDateTime", DC::ExpectedCompletionDateTime },
        { "ResultingGeneralPurposePerformedProcedureStepsSequence", DC::ResultingGeneralPurposePerformedProcedureStepsSequence },
        { "ReferencedGeneralPurposeScheduledProcedureStepSequence", DC::ReferencedGeneralPurposeScheduledProcedureStepSequence },
        { "ScheduledWorkitemCodeSequence", DC::ScheduledWorkitemCodeSequence },
        { "PerformedWorkitemCodeSequence", DC::PerformedWorkitemCodeSequence },
        { "InputAvailabilityFlag", DC::InputAvailabilityFlag },
        { "InputInformationSequence", DC::InputInformationSequence },
        { "RelevantInformationSequence", DC::RelevantInformationSequence },
        { "ReferencedGeneralPurposeScheduledProcedureStepTransactionUID", DC::ReferencedGeneralPurposeScheduledProcedureStepTransactionUID },
        { "ScheduledStationNameCodeSequence", DC::ScheduledStationNameCodeSequence },
        { "ScheduledStationClassCodeSequence", DC::ScheduledStationClassCodeSequence },
        { "ScheduledStationGeographicLocationCodeSequence", DC::ScheduledStationGeographicLocationCodeSequence },
        { "PerformedStationNameCodeSequence", DC::PerformedStationNameCodeSequence },
        { "PerformedStationClassCodeSequence", DC::PerformedStationClassCodeSequence },
        { "PerformedStationGeographicLocationCodeSequence", DC::PerformedStationGeographicLocationCodeSequence },
        { "RequestedSubsequentWorkitemCodeSequence", DC::RequestedSubsequentWorkitemCodeSequence },
        { "NonDICOMOutputCodeSequence", DC::NonDICOMOutputCodeSequence },
        { "OutputInformationSequence", DC::OutputInformationSequence },
        { "ScheduledHumanPerformersSequence", DC::ScheduledHumanPerformersSequence },
        { "ActualHumanPerformersSequence", DC::ActualHumanPerformersSequence },
        { "HumanPerformerOrganization", DC::HumanPerformerOrganization },
        { "HumanPerformerName", DC::HumanPerformerName },
        { "RawDataHandling", DC::RawDataHandling },
        { "InputReadinessState", DC::InputReadinessState },
        { "PerformedProcedureStepStartDateTime", DC::PerformedProcedureStepStartDateTime },
        { "PerformedProcedureStepEndDateTime", DC::PerformedProcedureStepEndDateTime },
        { "ProcedureStepCancellationDateTime", DC::ProcedureStepCancellationDateTime },
        { "OutputDestinationSequence", DC::OutputDestinationSequence },
        { "DICOMStorageSequence", DC::DICOMStorageSequence },
        { "STOWRSStorageSequence", DC::STOWRSStorageSequence },
        { "StorageURL", DC::StorageURL },
        { "XDSStorageSequence", DC::XDSStorageSequence },
        { "EntranceDoseInmGy", DC::EntranceDoseInmGy },
        { "EntranceDoseDerivation", DC::EntranceDoseDerivation },
        { "ParametricMapFrameTypeSequence", DC::ParametricMapFrameTypeSequence },
        { "ReferencedImageRealWorldValueMappingSequence", DC::ReferencedImageRealWorldValueMappingSequence },
        { "RealWorldValueMappingSequence", DC::RealWorldValueMappingSequence },
        { "PixelValueMappingCodeSequence", DC::PixelValueMappingCodeSequence },
        { "LUTLabel", DC::LUTLabel },
        { "RealWorldValueLastValueMapped", DC::RealWorldValueLastValueMapped },
        { "RealWorldValueLUTData", DC::RealWorldValueLUTData },
        { "DoubleFloatRealWorldValueLastValueMapped", DC::DoubleFloatRealWorldValueLastValueMapped },
        { "DoubleFloatRealWorldValueFirstValueMapped", DC::DoubleFloatRealWorldValueFirstValueMapped },
        { "RealWorldValueFirstValueMapped", DC::RealWorldValueFirstValueMapped },
        { "QuantityDefinitionSequence", DC::QuantityDefinitionSequence },
        { "RealWorldValueIntercept", DC::RealWorldValueIntercept },
        { "RealWorldValueSlope", DC::RealWorldValueSlope },
        { "FindingsFlagTrial", DC::FindingsFlagTrial },
        { "RelationshipType", DC::RelationshipType },
        { "FindingsSequenceTrial", DC::FindingsSequenceTrial },
        { "FindingsGroupUIDTrial", DC::FindingsGroupUIDTrial },
        { "ReferencedFindingsGroupUIDTrial", DC::ReferencedFindingsGroupUIDTrial },
        { "FindingsGroupRecordingDateTrial", DC::FindingsGroupRecordingDateTrial },
        { "FindingsGroupRecordingTimeTrial", DC::FindingsGroupRecordingTimeTrial },
        { "FindingsSourceCategoryCodeSequenceTrial", DC::FindingsSourceCategoryCodeSequenceTrial },
        { "VerifyingOrganization", DC::VerifyingOrganization },
        { "DocumentingOrganizationIdentifierCodeSequenceTrial", DC::DocumentingOrganizationIdentifierCodeSequenceTrial },
        { "VerificationDateTime", DC::VerificationDateTime },
        { "ObservationDateTime", DC::ObservationDateTime },
        { "ObservationStartDateTime", DC::ObservationStartDateTime },
        { "ValueType", DC::ValueType },
        { "ConceptNameCodeSequence", DC::ConceptNameCodeSequence },
        { "MeasurementPrecisionDescriptionTrial", DC::MeasurementPrecisionDescriptionTrial },
        { "ContinuityOfContent", DC::ContinuityOfContent },
        { "UrgencyOrPriorityAlertsTrial", DC::UrgencyOrPriorityAlertsTrial },
        { "SequencingIndicatorTrial", DC::SequencingIndicatorTrial },
        { "DocumentIdentifierCodeSequenceTrial", DC::DocumentIdentifierCodeSequenceTrial },
        { "DocumentAuthorTrial", DC::DocumentAuthorTrial },
        { "DocumentAuthorIdentifierCodeSequenceTrial", DC::DocumentAuthorIdentifierCodeSequenceTrial },
        { "IdentifierCodeSequenceTrial", DC::IdentifierCodeSequenceTrial },
        { "VerifyingObserverSequence", DC::VerifyingObserverSequence },
        { "ObjectBinaryIdentifierTrial", DC::ObjectBinaryIdentifierTrial },
        { "VerifyingObserverName", DC::VerifyingObserverName },
        { "DocumentingObserverIdentifierCodeSequenceTrial", DC::DocumentingObserverIdentifierCodeSequenceTrial },
        { "AuthorObserverSequence", DC::AuthorObserverSequence },
        { "ParticipantSequence", DC::ParticipantSequence },
        { "CustodialOrganizationSequence", DC::CustodialOrganizationSequence },
        { "ParticipationType", DC::ParticipationType },
        { "ParticipationDateTime", DC::ParticipationDateTime },
        { "ObserverType", DC::ObserverType },
        { "ProcedureIdentifierCodeSequenceTrial", DC::ProcedureIdentifierCodeSequenceTrial },
        { "VerifyingObserverIdentificationCodeSequence", DC::VerifyingObserverIdentificationCodeSequence },
        { "ObjectDirectoryBinaryIdentifierTrial", DC::ObjectDirectoryBinaryIdentifierTrial },
        { "EquivalentCDADocumentSequence", DC::EquivalentCDADocumentSequence },
        { "ReferencedWaveformChannels", DC::ReferencedWaveformChannels },
        { "DateOfDocumentOrVerbalTransactionTrial", DC::DateOfDocumentOrVerbalTransactionTrial },
        { "TimeOfDocumentCreationOrVerbalTransactionTrial", DC::TimeOfDocumentCreationOrVerbalTransactionTrial },
        { "DateTime", DC::DateTime },
        { "Date", DC::Date },
        { "Time", DC::Time },
        { "PersonName", DC::PersonName },
        { "UID", DC::UID },
        { "ReportStatusIDTrial", DC::ReportStatusIDTrial },
        { "TemporalRangeType", DC::TemporalRangeType },
        { "ReferencedSamplePositions", DC::ReferencedSamplePositions },
        { "ReferencedFrameNumbers", DC::ReferencedFrameNumbers },
        { "ReferencedTimeOffsets", DC::ReferencedTimeOffsets },
        { "ReferencedDateTime", DC::ReferencedDateTime },
        { "TextValue", DC::TextValue },
        { "FloatingPointValue", DC::FloatingPointValue },
        { "RationalNumeratorValue", DC::RationalNumeratorValue },
        { "RationalDenominatorValue", DC::RationalDenominatorValue },
        { "ObservationCategoryCodeSequenceTrial", DC::ObservationCategoryCodeSequenceTrial },
        { "ConceptCodeSequence", DC::ConceptCodeSequence },
        { "BibliographicCitationTrial", DC::BibliographicCitationTrial },
        { "PurposeOfReferenceCodeSequence", DC::PurposeOfReferenceCodeSequence },
        { "ObservationUID", DC::ObservationUID },
        { "ReferencedObservationUIDTrial", DC::ReferencedObservationUIDTrial },
        { "ReferencedObservationClassTrial", DC::ReferencedObservationClassTrial },
        { "ReferencedObjectObservationClassTrial", DC::ReferencedObjectObservationClassTrial },
        { "AnnotationGroupNumber", DC::AnnotationGroupNumber },
        { "ObservationDateTrial", DC::ObservationDateTrial },
        { "ObservationTimeTrial", DC::ObservationTimeTrial },
        { "MeasurementAutomationTrial", DC::MeasurementAutomationTrial },
        { "ModifierCodeSequence", DC::ModifierCodeSequence },
        { "IdentificationDescriptionTrial", DC::IdentificationDescriptionTrial },
        { "CoordinatesSetGeometricTypeTrial", DC::CoordinatesSetGeometricTypeTrial },
        { "AlgorithmCodeSequenceTrial", DC::AlgorithmCodeSequenceTrial },
        { "AlgorithmDescriptionTrial", DC::AlgorithmDescriptionTrial },
        { "PixelCoordinatesSetTrial", DC::PixelCoordinatesSetTrial },
        { "MeasuredValueSequence", DC::MeasuredValueSequence },
        { "NumericValueQualifierCodeSequence", DC::NumericValueQualifierCodeSequence },
        { "CurrentObserverTrial", DC::CurrentObserverTrial },
        { "NumericValue", DC::NumericValue },
        { "ReferencedAccessionSequenceTrial", DC::ReferencedAccessionSequenceTrial },
        { "ReportStatusCommentTrial", DC::ReportStatusCommentTrial },
        { "ProcedureContextSequenceTrial", DC::ProcedureContextSequenceTrial },
        { "VerbalSourceTrial", DC::VerbalSourceTrial },
        { "AddressTrial", DC::AddressTrial },
        { "TelephoneNumberTrial", DC::TelephoneNumberTrial },
        { "VerbalSourceIdentifierCodeSequenceTrial", DC::VerbalSourceIdentifierCodeSequenceTrial },
        { "PredecessorDocumentsSequence", DC::PredecessorDocumentsSequence },
        { "ReferencedRequestSequence", DC::ReferencedRequestSequence },
        { "PerformedProcedureCodeSequence", DC::PerformedProcedureCodeSequence },
        { "CurrentRequestedProcedureEvidenceSequence", DC::CurrentRequestedProcedureEvidenceSequence },
        { "ReportDetailSequenceTrial", DC::ReportDetailSequenceTrial },
        { "PertinentOtherEvidenceSequence", DC::PertinentOtherEvidenceSequence },
        { "HL7StructuredDocumentReferenceSequence", DC::HL7StructuredDocumentReferenceSequence },
        { "ObservationSubjectUIDTrial", DC::ObservationSubjectUIDTrial },
        { "ObservationSubjectClassTrial", DC::ObservationSubjectClassTrial },
        { "ObservationSubjectTypeCodeSequenceTrial", DC::ObservationSubjectTypeCodeSequenceTrial },
        { "CompletionFlag", DC::CompletionFlag },
        { "CompletionFlagDescription", DC::CompletionFlagDescription },
        { "VerificationFlag", DC::VerificationFlag },
        { "ArchiveRequested", DC::ArchiveRequested },
        { "PreliminaryFlag", DC::PreliminaryFlag },
        { "ContentTemplateSequence", DC::ContentTemplateSequence },
        { "IdenticalDocumentsSequence", DC::IdenticalDocumentsSequence },
        { "ObservationSubjectContextFlagTrial", DC::ObservationSubjectContextFlagTrial },
        { "ObserverContextFlagTrial", DC::ObserverContextFlagTrial },
        { "ProcedureContextFlagTrial", DC::ProcedureContextFlagTrial },
        { "ContentSequence", DC::ContentSequence },
        { "RelationshipSequenceTrial", DC::RelationshipSequenceTrial },
        { "RelationshipTypeCodeSequenceTrial", DC::RelationshipTypeCodeSequenceTrial },
        { "LanguageCodeSequenceTrial", DC::LanguageCodeSequenceTrial },
        { "TabulatedValuesSequence", DC::TabulatedValuesSequence },
        { "NumberOfTableRows", DC::NumberOfTableRows },
        { "NumberOfTableColumns", DC::NumberOfTableColumns },
        { "TableRowNumber", DC::TableRowNumber },
        { "TableColumnNumber", DC::TableColumnNumber },
        { "TableRowDefinitionSequence", DC::TableRowDefinitionSequence },
        { "TableColumnDefinitionSequence", DC::TableColumnDefinitionSequence },
        { "CellValuesSequence", DC::CellValuesSequence },
        { "UniformResourceLocatorTrial", DC::UniformResourceLocatorTrial },
        { "WaveformAnnotationSequence", DC::WaveformAnnotationSequence },
        { "TemplateIdentifier", DC::TemplateIdentifier },
        { "TemplateVersion", DC::TemplateVersion },
        { "TemplateLocalVersion", DC::TemplateLocalVersion },
        { "TemplateExtensionFlag", DC::TemplateExtensionFlag },
        { "TemplateExtensionOrganizationUID", DC::TemplateExtensionOrganizationUID },
        { "TemplateExtensionCreatorUID", DC::TemplateExtensionCreatorUID },
        { "ReferencedContentItemIdentifier", DC::ReferencedContentItemIdentifier },
        { "HL7InstanceIdentifier", DC::HL7InstanceIdentifier },
        { "HL7DocumentEffectiveTime", DC::HL7DocumentEffectiveTime },
        { "HL7DocumentTypeCodeSequence", DC::HL7DocumentTypeCodeSequence },
        { "DocumentClassCodeSequence", DC::DocumentClassCodeSequence },
        { "RetrieveURI", DC::RetrieveURI },
        { "RetrieveLocationUID", DC::RetrieveLocationUID },
        { "TypeOfInstances", DC::TypeOfInstances },
        { "DICOMRetrievalSequence", DC::DICOMRetrievalSequence },
        { "DICOMMediaRetrievalSequence", DC::DICOMMediaRetrievalSequence },
        { "WADORetrievalSequence", DC::WADORetrievalSequence },
        { "XDSRetrievalSequence", DC::XDSRetrievalSequence },
        { "WADORSRetrievalSequence", DC::WADORSRetrievalSequence },
        { "RepositoryUniqueID", DC::RepositoryUniqueID },
        { "HomeCommunityID", DC::HomeCommunityID },
        { "DocumentTitle", DC::DocumentTitle },
        { "EncapsulatedDocument", DC::EncapsulatedDocument },
        { "MIMETypeOfEncapsulatedDocument", DC::MIMETypeOfEncapsulatedDocument },
        { "SourceInstanceSequence", DC::SourceInstanceSequence },
        { "ListOfMIMETypes", DC::ListOfMIMETypes },
        { "EncapsulatedDocumentLength", DC::EncapsulatedDocumentLength },
        { "ProductPackageIdentifier", DC::ProductPackageIdentifier },
        { "SubstanceAdministrationApproval", DC::SubstanceAdministrationApproval },
        { "ApprovalStatusFurtherDescription", DC::ApprovalStatusFurtherDescription },
        { "ApprovalStatusDateTime", DC::ApprovalStatusDateTime },
        { "ProductTypeCodeSequence", DC::ProductTypeCodeSequence },
        { "ProductName", DC::ProductName },
        { "ProductDescription", DC::ProductDescription },
        { "ProductLotIdentifier", DC::ProductLotIdentifier },
        { "ProductExpirationDateTime", DC::ProductExpirationDateTime },
        { "SubstanceAdministrationDateTime", DC::SubstanceAdministrationDateTime },
        { "SubstanceAdministrationNotes", DC::SubstanceAdministrationNotes },
        { "SubstanceAdministrationDeviceID", DC::SubstanceAdministrationDeviceID },
        { "ProductParameterSequence", DC::ProductParameterSequence },
        { "SubstanceAdministrationParameterSequence", DC::SubstanceAdministrationParameterSequence },
        { "ApprovalSequence", DC::ApprovalSequence },
        { "AssertionCodeSequence", DC::AssertionCodeSequence },
        { "AssertionUID", DC::AssertionUID },
        { "AsserterIdentificationSequence", DC::AsserterIdentificationSequence },
        { "AssertionDateTime", DC::AssertionDateTime },
        { "AssertionExpirationDateTime", DC::AssertionExpirationDateTime },
        { "AssertionComments", DC::AssertionComments },
        { "RelatedAssertionSequence", DC::RelatedAssertionSequence },
        { "ReferencedAssertionUID", DC::ReferencedAssertionUID },
        { "ApprovalSubjectSequence", DC::ApprovalSubjectSequence },
        { "OrganizationalRoleCodeSequence", DC::OrganizationalRoleCodeSequence },
        { "LensDescription", DC::LensDescription },
        { "RightLensSequence", DC::RightLensSequence },
        { "LeftLensSequence", DC::LeftLensSequence },
        { "UnspecifiedLateralityLensSequence", DC::UnspecifiedLateralityLensSequence },
        { "CylinderSequence", DC::CylinderSequence },
        { "PrismSequence", DC::PrismSequence },
        { "HorizontalPrismPower", DC::HorizontalPrismPower },
        { "HorizontalPrismBase", DC::HorizontalPrismBase },
        { "VerticalPrismPower", DC::VerticalPrismPower },
        { "VerticalPrismBase", DC::VerticalPrismBase },
        { "LensSegmentType", DC::LensSegmentType },
        { "OpticalTransmittance", DC::OpticalTransmittance },
        { "ChannelWidth", DC::ChannelWidth },
        { "PupilSize", DC::PupilSize },
        { "CornealSize", DC::CornealSize },
        { "CornealSizeSequence", DC::CornealSizeSequence },
        { "AutorefractionRightEyeSequence", DC::AutorefractionRightEyeSequence },
        { "AutorefractionLeftEyeSequence", DC::AutorefractionLeftEyeSequence },
        { "DistancePupillaryDistance", DC::DistancePupillaryDistance },
        { "NearPupillaryDistance", DC::NearPupillaryDistance },
        { "IntermediatePupillaryDistance", DC::IntermediatePupillaryDistance },
        { "OtherPupillaryDistance", DC::OtherPupillaryDistance },
        { "KeratometryRightEyeSequence", DC::KeratometryRightEyeSequence },
        { "KeratometryLeftEyeSequence", DC::KeratometryLeftEyeSequence },
        { "SteepKeratometricAxisSequence", DC::SteepKeratometricAxisSequence },
        { "RadiusOfCurvature", DC::RadiusOfCurvature },
        { "KeratometricPower", DC::KeratometricPower },
        { "KeratometricAxis", DC::KeratometricAxis },
        { "FlatKeratometricAxisSequence", DC::FlatKeratometricAxisSequence },
        { "BackgroundColor", DC::BackgroundColor },
        { "Optotype", DC::Optotype },
        { "OptotypePresentation", DC::OptotypePresentation },
        { "SubjectiveRefractionRightEyeSequence", DC::SubjectiveRefractionRightEyeSequence },
        { "SubjectiveRefractionLeftEyeSequence", DC::SubjectiveRefractionLeftEyeSequence },
        { "AddNearSequence", DC::AddNearSequence },
        { "AddIntermediateSequence", DC::AddIntermediateSequence },
        { "AddOtherSequence", DC::AddOtherSequence },
        { "AddPower", DC::AddPower },
        { "ViewingDistance", DC::ViewingDistance },
        { "CorneaMeasurementsSequence", DC::CorneaMeasurementsSequence },
        { "SourceOfCorneaMeasurementDataCodeSequence", DC::SourceOfCorneaMeasurementDataCodeSequence },
        { "SteepCornealAxisSequence", DC::SteepCornealAxisSequence },
        { "FlatCornealAxisSequence", DC::FlatCornealAxisSequence },
        { "CornealPower", DC::CornealPower },
        { "CornealAxis", DC::CornealAxis },
        { "CorneaMeasurementMethodCodeSequence", DC::CorneaMeasurementMethodCodeSequence },
        { "RefractiveIndexOfCornea", DC::RefractiveIndexOfCornea },
        { "RefractiveIndexOfAqueousHumor", DC::RefractiveIndexOfAqueousHumor },
        { "VisualAcuityTypeCodeSequence", DC::VisualAcuityTypeCodeSequence },
        { "VisualAcuityRightEyeSequence", DC::VisualAcuityRightEyeSequence },
        { "VisualAcuityLeftEyeSequence", DC::VisualAcuityLeftEyeSequence },
        { "VisualAcuityBothEyesOpenSequence", DC::VisualAcuityBothEyesOpenSequence },
        { "ViewingDistanceType", DC::ViewingDistanceType },
        { "VisualAcuityModifiers", DC::VisualAcuityModifiers },
        { "DecimalVisualAcuity", DC::DecimalVisualAcuity },
        { "OptotypeDetailedDefinition", DC::OptotypeDetailedDefinition },
        { "ReferencedRefractiveMeasurementsSequence", DC::ReferencedRefractiveMeasurementsSequence },
        { "SpherePower", DC::SpherePower },
        { "CylinderPower", DC::CylinderPower },
        { "CornealTopographySurface", DC::CornealTopographySurface },
        { "CornealVertexLocation", DC::CornealVertexLocation },
        { "PupilCentroidXCoordinate", DC::PupilCentroidXCoordinate },
        { "PupilCentroidYCoordinate", DC::PupilCentroidYCoordinate },
        { "EquivalentPupilRadius", DC::EquivalentPupilRadius },
        { "CornealTopographyMapTypeCodeSequence", DC::CornealTopographyMapTypeCodeSequence },
        { "VerticesOfTheOutlineOfPupil", DC::VerticesOfTheOutlineOfPupil },
        { "CornealTopographyMappingNormalsSequence", DC::CornealTopographyMappingNormalsSequence },
        { "MaximumCornealCurvatureSequence", DC::MaximumCornealCurvatureSequence },
        { "MaximumCornealCurvature", DC::MaximumCornealCurvature },
        { "MaximumCornealCurvatureLocation", DC::MaximumCornealCurvatureLocation },
        { "MinimumKeratometricSequence", DC::MinimumKeratometricSequence },
        { "SimulatedKeratometricCylinderSequence", DC::SimulatedKeratometricCylinderSequence },
        { "AverageCornealPower", DC::AverageCornealPower },
        { "CornealISValue", DC::CornealISValue },
        { "AnalyzedArea", DC::AnalyzedArea },
        { "SurfaceRegularityIndex", DC::SurfaceRegularityIndex },
        { "SurfaceAsymmetryIndex", DC::SurfaceAsymmetryIndex },
        { "CornealEccentricityIndex", DC::CornealEccentricityIndex },
        { "KeratoconusPredictionIndex", DC::KeratoconusPredictionIndex },
        { "DecimalPotentialVisualAcuity", DC::DecimalPotentialVisualAcuity },
        { "CornealTopographyMapQualityEvaluation", DC::CornealTopographyMapQualityEvaluation },
        { "SourceImageCornealProcessedDataSequence", DC::SourceImageCornealProcessedDataSequence },
        { "CornealPointLocation", DC::CornealPointLocation },
        { "CornealPointEstimated", DC::CornealPointEstimated },
        { "AxialPower", DC::AxialPower },
        { "TangentialPower", DC::TangentialPower },
        { "RefractivePower", DC::RefractivePower },
        { "RelativeElevation", DC::RelativeElevation },
        { "CornealWavefront", DC::CornealWavefront },
        { "ImagedVolumeWidth", DC::ImagedVolumeWidth },
        { "ImagedVolumeHeight", DC::ImagedVolumeHeight },
        { "ImagedVolumeDepth", DC::ImagedVolumeDepth },
        { "TotalPixelMatrixColumns", DC::TotalPixelMatrixColumns },
        { "TotalPixelMatrixRows", DC::TotalPixelMatrixRows },
        { "TotalPixelMatrixOriginSequence", DC::TotalPixelMatrixOriginSequence },
        { "SpecimenLabelInImage", DC::SpecimenLabelInImage },
        { "FocusMethod", DC::FocusMethod },
        { "ExtendedDepthOfField", DC::ExtendedDepthOfField },
        { "NumberOfFocalPlanes", DC::NumberOfFocalPlanes },
        { "DistanceBetweenFocalPlanes", DC::DistanceBetweenFocalPlanes },
        { "RecommendedAbsentPixelCIELabValue", DC::RecommendedAbsentPixelCIELabValue },
        { "IlluminatorTypeCodeSequence", DC::IlluminatorTypeCodeSequence },
        { "ImageOrientationSlide", DC::ImageOrientationSlide },
        { "OpticalPathSequence", DC::OpticalPathSequence },
        { "OpticalPathIdentifier", DC::OpticalPathIdentifier },
        { "OpticalPathDescription", DC::OpticalPathDescription },
        { "IlluminationColorCodeSequence", DC::IlluminationColorCodeSequence },
        { "SpecimenReferenceSequence", DC::SpecimenReferenceSequence },
        { "CondenserLensPower", DC::CondenserLensPower },
        { "ObjectiveLensPower", DC::ObjectiveLensPower },
        { "ObjectiveLensNumericalAperture", DC::ObjectiveLensNumericalAperture },
        { "PaletteColorLookupTableSequence", DC::PaletteColorLookupTableSequence },
        { "ReferencedImageNavigationSequence", DC::ReferencedImageNavigationSequence },
        { "TopLeftHandCornerOfLocalizerArea", DC::TopLeftHandCornerOfLocalizerArea },
        { "BottomRightHandCornerOfLocalizerArea", DC::BottomRightHandCornerOfLocalizerArea },
        { "OpticalPathIdentificationSequence", DC::OpticalPathIdentificationSequence },
        { "PlanePositionSlideSequence", DC::PlanePositionSlideSequence },
        { "ColumnPositionInTotalImagePixelMatrix", DC::ColumnPositionInTotalImagePixelMatrix },
        { "RowPositionInTotalImagePixelMatrix", DC::RowPositionInTotalImagePixelMatrix },
        { "PixelOriginInterpretation", DC::PixelOriginInterpretation },
        { "NumberOfOpticalPaths", DC::NumberOfOpticalPaths },
        { "TotalPixelMatrixFocalPlanes", DC::TotalPixelMatrixFocalPlanes },
        { "CalibrationImage", DC::CalibrationImage },
        { "DeviceSequence", DC::DeviceSequence },
        { "ContainerComponentTypeCodeSequence", DC::ContainerComponentTypeCodeSequence },
        { "ContainerComponentThickness", DC::ContainerComponentThickness },
        { "DeviceLength", DC::DeviceLength },
        { "ContainerComponentWidth", DC::ContainerComponentWidth },
        { "DeviceDiameter", DC::DeviceDiameter },
        { "DeviceDiameterUnits", DC::DeviceDiameterUnits },
        { "DeviceVolume", DC::DeviceVolume },
        { "InterMarkerDistance", DC::InterMarkerDistance },
        { "ContainerComponentMaterial", DC::ContainerComponentMaterial },
        { "ContainerComponentID", DC::ContainerComponentID },
        { "ContainerComponentLength", DC::ContainerComponentLength },
        { "ContainerComponentDiameter", DC::ContainerComponentDiameter },
        { "ContainerComponentDescription", DC::ContainerComponentDescription },
        { "DeviceDescription", DC::DeviceDescription },
        { "LongDeviceDescription", DC::LongDeviceDescription },
        { "ContrastBolusIngredientPercentByVolume", DC::ContrastBolusIngredientPercentByVolume },
        { "OCTFocalDistance", DC::OCTFocalDistance },
        { "BeamSpotSize", DC::BeamSpotSize },
        { "EffectiveRefractiveIndex", DC::EffectiveRefractiveIndex },
        { "OCTAcquisitionDomain", DC::OCTAcquisitionDomain },
        { "OCTOpticalCenterWavelength", DC::OCTOpticalCenterWavelength },
        { "AxialResolution", DC::AxialResolution },
        { "RangingDepth", DC::RangingDepth },
        { "ALineRate", DC::ALineRate },
        { "ALinesPerFrame", DC::ALinesPerFrame },
        { "CatheterRotationalRate", DC::CatheterRotationalRate },
        { "ALinePixelSpacing", DC::ALinePixelSpacing },
        { "ModeOfPercutaneousAccessSequence", DC::ModeOfPercutaneousAccessSequence },
        { "IntravascularOCTFrameTypeSequence", DC::IntravascularOCTFrameTypeSequence },
        { "OCTZOffsetApplied", DC::OCTZOffsetApplied },
        { "IntravascularFrameContentSequence", DC::IntravascularFrameContentSequence },
        { "IntravascularLongitudinalDistance", DC::IntravascularLongitudinalDistance },
        { "IntravascularOCTFrameContentSequence", DC::IntravascularOCTFrameContentSequence },
        { "OCTZOffsetCorrection", DC::OCTZOffsetCorrection },
        { "CatheterDirectionOfRotation", DC::CatheterDirectionOfRotation },
        { "SeamLineLocation", DC::SeamLineLocation },
        { "FirstALineLocation", DC::FirstALineLocation },
        { "SeamLineIndex", DC::SeamLineIndex },
        { "NumberOfPaddedALines", DC::NumberOfPaddedALines },
        { "InterpolationType", DC::InterpolationType },
        { "RefractiveIndexApplied", DC::RefractiveIndexApplied },
        { "EnergyWindowVector", DC::EnergyWindowVector },
        { "NumberOfEnergyWindows", DC::NumberOfEnergyWindows },
        { "EnergyWindowInformationSequence", DC::EnergyWindowInformationSequence },
        { "EnergyWindowRangeSequence", DC::EnergyWindowRangeSequence },
        { "EnergyWindowLowerLimit", DC::EnergyWindowLowerLimit },
        { "EnergyWindowUpperLimit", DC::EnergyWindowUpperLimit },
        { "RadiopharmaceuticalInformationSequence", DC::RadiopharmaceuticalInformationSequence },
        { "ResidualSyringeCounts", DC::ResidualSyringeCounts },
        { "EnergyWindowName", DC::EnergyWindowName },
        { "DetectorVector", DC::DetectorVector },
        { "NumberOfDetectors", DC::NumberOfDetectors },
        { "DetectorInformationSequence", DC::DetectorInformationSequence },
        { "PhaseVector", DC::PhaseVector },
        { "NumberOfPhases", DC::NumberOfPhases },
        { "PhaseInformationSequence", DC::PhaseInformationSequence },
        { "NumberOfFramesInPhase", DC::NumberOfFramesInPhase },
        { "PhaseDelay", DC::PhaseDelay },
        { "PauseBetweenFrames", DC::PauseBetweenFrames },
        { "PhaseDescription", DC::PhaseDescription },
        { "RotationVector", DC::RotationVector },
        { "NumberOfRotations", DC::NumberOfRotations },
        { "RotationInformationSequence", DC::RotationInformationSequence },
        { "NumberOfFramesInRotation", DC::NumberOfFramesInRotation },
        { "RRIntervalVector", DC::RRIntervalVector },
        { "NumberOfRRIntervals", DC::NumberOfRRIntervals },
        { "GatedInformationSequence", DC::GatedInformationSequence },
        { "DataInformationSequence", DC::DataInformationSequence },
        { "TimeSlotVector", DC::TimeSlotVector },
        { "NumberOfTimeSlots", DC::NumberOfTimeSlots },
        { "TimeSlotInformationSequence", DC::TimeSlotInformationSequence },
        { "TimeSlotTime", DC::TimeSlotTime },
        { "SliceVector", DC::SliceVector },
        { "NumberOfSlices", DC::NumberOfSlices },
        { "AngularViewVector", DC::AngularViewVector },
        { "TimeSliceVector", DC::TimeSliceVector },
        { "NumberOfTimeSlices", DC::NumberOfTimeSlices },
        { "StartAngle", DC::StartAngle },
        { "TypeOfDetectorMotion", DC::TypeOfDetectorMotion },
        { "TriggerVector", DC::TriggerVector },
        { "NumberOfTriggersInPhase", DC::NumberOfTriggersInPhase },
        { "ViewCodeSequence", DC::ViewCodeSequence },
        { "ViewModifierCodeSequence", DC::ViewModifierCodeSequence },
        { "RadionuclideCodeSequence", DC::RadionuclideCodeSequence },
        { "AdministrationRouteCodeSequence", DC::AdministrationRouteCodeSequence },
        { "RadiopharmaceuticalCodeSequence", DC::RadiopharmaceuticalCodeSequence },
        { "CalibrationDataSequence", DC::CalibrationDataSequence },
        { "EnergyWindowNumber", DC::EnergyWindowNumber },
        { "ImageID", DC::ImageID },
        { "PatientOrientationCodeSequence", DC::PatientOrientationCodeSequence },
        { "PatientOrientationModifierCodeSequence", DC::PatientOrientationModifierCodeSequence },
        { "PatientGantryRelationshipCodeSequence", DC::PatientGantryRelationshipCodeSequence },
        { "SliceProgressionDirection", DC::SliceProgressionDirection },
        { "ScanProgressionDirection", DC::ScanProgressionDirection },
        { "SeriesType", DC::SeriesType },
        { "Units", DC::Units },
        { "CountsSource", DC::CountsSource },
        { "ReprojectionMethod", DC::ReprojectionMethod },
        { "SUVType", DC::SUVType },
        { "RandomsCorrectionMethod", DC::RandomsCorrectionMethod },
        { "AttenuationCorrectionMethod", DC::AttenuationCorrectionMethod },
        { "DecayCorrection", DC::DecayCorrection },
        { "ReconstructionMethod", DC::ReconstructionMethod },
        { "DetectorLinesOfResponseUsed", DC::DetectorLinesOfResponseUsed },
        { "ScatterCorrectionMethod", DC::ScatterCorrectionMethod },
        { "AxialAcceptance", DC::AxialAcceptance },
        { "AxialMash", DC::AxialMash },
        { "TransverseMash", DC::TransverseMash },
        { "DetectorElementSize", DC::DetectorElementSize },
        { "CoincidenceWindowWidth", DC::CoincidenceWindowWidth },
        { "SecondaryCountsType", DC::SecondaryCountsType },
        { "FrameReferenceTime", DC::FrameReferenceTime },
        { "PrimaryPromptsCountsAccumulated", DC::PrimaryPromptsCountsAccumulated },
        { "SecondaryCountsAccumulated", DC::SecondaryCountsAccumulated },
        { "SliceSensitivityFactor", DC::SliceSensitivityFactor },
        { "DecayFactor", DC::DecayFactor },
        { "DoseCalibrationFactor", DC::DoseCalibrationFactor },
        { "ScatterFractionFactor", DC::ScatterFractionFactor },
        { "DeadTimeFactor", DC::DeadTimeFactor },
        { "ImageIndex", DC::ImageIndex },
        { "CountsIncluded", DC::CountsIncluded },
        { "DeadTimeCorrectionFlag", DC::DeadTimeCorrectionFlag },
        { "HistogramSequence", DC::HistogramSequence },
        { "HistogramNumberOfBins", DC::HistogramNumberOfBins },
        { "HistogramFirstBinValue", DC::HistogramFirstBinValue },
        { "HistogramLastBinValue", DC::HistogramLastBinValue },
        { "HistogramBinWidth", DC::HistogramBinWidth },
        { "HistogramExplanation", DC::HistogramExplanation },
        { "HistogramData", DC::HistogramData },
        { "SegmentationType", DC::SegmentationType },
        { "SegmentSequence", DC::SegmentSequence },
        { "SegmentedPropertyCategoryCodeSequence", DC::SegmentedPropertyCategoryCodeSequence },
        { "SegmentNumber", DC::SegmentNumber },
        { "SegmentLabel", DC::SegmentLabel },
        { "SegmentDescription", DC::SegmentDescription },
        { "SegmentationAlgorithmIdentificationSequence", DC::SegmentationAlgorithmIdentificationSequence },
        { "SegmentAlgorithmType", DC::SegmentAlgorithmType },
        { "SegmentAlgorithmName", DC::SegmentAlgorithmName },
        { "SegmentIdentificationSequence", DC::SegmentIdentificationSequence },
        { "ReferencedSegmentNumber", DC::ReferencedSegmentNumber },
        { "RecommendedDisplayGrayscaleValue", DC::RecommendedDisplayGrayscaleValue },
        { "RecommendedDisplayCIELabValue", DC::RecommendedDisplayCIELabValue },
        { "MaximumFractionalValue", DC::MaximumFractionalValue },
        { "SegmentedPropertyTypeCodeSequence", DC::SegmentedPropertyTypeCodeSequence },
        { "SegmentationFractionalType", DC::SegmentationFractionalType },
        { "SegmentedPropertyTypeModifierCodeSequence", DC::SegmentedPropertyTypeModifierCodeSequence },
        { "UsedSegmentsSequence", DC::UsedSegmentsSequence },
        { "SegmentsOverlap", DC::SegmentsOverlap },
        { "TrackingID", DC::TrackingID },
        { "TrackingUID", DC::TrackingUID },
        { "DeformableRegistrationSequence", DC::DeformableRegistrationSequence },
        { "SourceFrameOfReferenceUID", DC::SourceFrameOfReferenceUID },
        { "DeformableRegistrationGridSequence", DC::DeformableRegistrationGridSequence },
        { "GridDimensions", DC::GridDimensions },
        { "GridResolution", DC::GridResolution },
        { "VectorGridData", DC::VectorGridData },
        { "PreDeformationMatrixRegistrationSequence", DC::PreDeformationMatrixRegistrationSequence },
        { "PostDeformationMatrixRegistrationSequence", DC::PostDeformationMatrixRegistrationSequence },
        { "NumberOfSurfaces", DC::NumberOfSurfaces },
        { "SurfaceSequence", DC::SurfaceSequence },
        { "SurfaceNumber", DC::SurfaceNumber },
        { "SurfaceComments", DC::SurfaceComments },
        { "SurfaceProcessing", DC::SurfaceProcessing },
        { "SurfaceProcessingRatio", DC::SurfaceProcessingRatio },
        { "SurfaceProcessingDescription", DC::SurfaceProcessingDescription },
        { "RecommendedPresentationOpacity", DC::RecommendedPresentationOpacity },
        { "RecommendedPresentationType", DC::RecommendedPresentationType },
        { "FiniteVolume", DC::FiniteVolume },
        { "Manifold", DC::Manifold },
        { "SurfacePointsSequence", DC::SurfacePointsSequence },
        { "SurfacePointsNormalsSequence", DC::SurfacePointsNormalsSequence },
        { "SurfaceMeshPrimitivesSequence", DC::SurfaceMeshPrimitivesSequence },
        { "NumberOfSurfacePoints", DC::NumberOfSurfacePoints },
        { "PointCoordinatesData", DC::PointCoordinatesData },
        { "PointPositionAccuracy", DC::PointPositionAccuracy },
        { "MeanPointDistance", DC::MeanPointDistance },
        { "MaximumPointDistance", DC::MaximumPointDistance },
        { "PointsBoundingBoxCoordinates", DC::PointsBoundingBoxCoordinates },
        { "AxisOfRotation", DC::AxisOfRotation },
        { "CenterOfRotation", DC::CenterOfRotation },
        { "NumberOfVectors", DC::NumberOfVectors },
        { "VectorDimensionality", DC::VectorDimensionality },
        { "VectorAccuracy", DC::VectorAccuracy },
        { "VectorCoordinateData", DC::VectorCoordinateData },
        { "DoublePointCoordinatesData", DC::DoublePointCoordinatesData },
        { "TrianglePointIndexList", DC::TrianglePointIndexList },
        { "EdgePointIndexList", DC::EdgePointIndexList },
        { "VertexPointIndexList", DC::VertexPointIndexList },
        { "TriangleStripSequence", DC::TriangleStripSequence },
        { "TriangleFanSequence", DC::TriangleFanSequence },
        { "LineSequence", DC::LineSequence },
        { "PrimitivePointIndexList", DC::PrimitivePointIndexList },
        { "SurfaceCount", DC::SurfaceCount },
        { "ReferencedSurfaceSequence", DC::ReferencedSurfaceSequence },
        { "ReferencedSurfaceNumber", DC::ReferencedSurfaceNumber },
        { "SegmentSurfaceGenerationAlgorithmIdentificationSequence", DC::SegmentSurfaceGenerationAlgorithmIdentificationSequence },
        { "SegmentSurfaceSourceInstanceSequence", DC::SegmentSurfaceSourceInstanceSequence },
        { "AlgorithmFamilyCodeSequence", DC::AlgorithmFamilyCodeSequence },
        { "AlgorithmNameCodeSequence", DC::AlgorithmNameCodeSequence },
        { "AlgorithmVersion", DC::AlgorithmVersion },
        { "AlgorithmParameters", DC::AlgorithmParameters },
        { "FacetSequence", DC::FacetSequence },
        { "SurfaceProcessingAlgorithmIdentificationSequence", DC::SurfaceProcessingAlgorithmIdentificationSequence },
        { "AlgorithmName", DC::AlgorithmName },
        { "RecommendedPointRadius", DC::RecommendedPointRadius },
        { "RecommendedLineThickness", DC::RecommendedLineThickness },
        { "LongPrimitivePointIndexList", DC::LongPrimitivePointIndexList },
        { "LongTrianglePointIndexList", DC::LongTrianglePointIndexList },
        { "LongEdgePointIndexList", DC::LongEdgePointIndexList },
        { "LongVertexPointIndexList", DC::LongVertexPointIndexList },
        { "TrackSetSequence", DC::TrackSetSequence },
        { "TrackSequence", DC::TrackSequence },
        { "RecommendedDisplayCIELabValueList", DC::RecommendedDisplayCIELabValueList },
        { "TrackingAlgorithmIdentificationSequence", DC::TrackingAlgorithmIdentificationSequence },
        { "TrackSetNumber", DC::TrackSetNumber },
        { "TrackSetLabel", DC::TrackSetLabel },
        { "TrackSetDescription", DC::TrackSetDescription },
        { "TrackSetAnatomicalTypeCodeSequence", DC::TrackSetAnatomicalTypeCodeSequence },
        { "MeasurementsSequence", DC::MeasurementsSequence },
        { "TrackSetStatisticsSequence", DC::TrackSetStatisticsSequence },
        { "FloatingPointValues", DC::FloatingPointValues },
        { "TrackPointIndexList", DC::TrackPointIndexList },
        { "TrackStatisticsSequence", DC::TrackStatisticsSequence },
        { "MeasurementValuesSequence", DC::MeasurementValuesSequence },
        { "DiffusionAcquisitionCodeSequence", DC::DiffusionAcquisitionCodeSequence },
        { "DiffusionModelCodeSequence", DC::DiffusionModelCodeSequence },
        { "ImplantSize", DC::ImplantSize },
        { "ImplantTemplateVersion", DC::ImplantTemplateVersion },
        { "ReplacedImplantTemplateSequence", DC::ReplacedImplantTemplateSequence },
        { "ImplantType", DC::ImplantType },
        { "DerivationImplantTemplateSequence", DC::DerivationImplantTemplateSequence },
        { "OriginalImplantTemplateSequence", DC::OriginalImplantTemplateSequence },
        { "EffectiveDateTime", DC::EffectiveDateTime },
        { "ImplantTargetAnatomySequence", DC::ImplantTargetAnatomySequence },
        { "InformationFromManufacturerSequence", DC::InformationFromManufacturerSequence },
        { "NotificationFromManufacturerSequence", DC::NotificationFromManufacturerSequence },
        { "InformationIssueDateTime", DC::InformationIssueDateTime },
        { "InformationSummary", DC::InformationSummary },
        { "ImplantRegulatoryDisapprovalCodeSequence", DC::ImplantRegulatoryDisapprovalCodeSequence },
        { "OverallTemplateSpatialTolerance", DC::OverallTemplateSpatialTolerance },
        { "HPGLDocumentSequence", DC::HPGLDocumentSequence },
        { "HPGLDocumentID", DC::HPGLDocumentID },
        { "HPGLDocumentLabel", DC::HPGLDocumentLabel },
        { "ViewOrientationCodeSequence", DC::ViewOrientationCodeSequence },
        { "ViewOrientationModifierCodeSequence", DC::ViewOrientationModifierCodeSequence },
        { "HPGLDocumentScaling", DC::HPGLDocumentScaling },
        { "HPGLDocument", DC::HPGLDocument },
        { "HPGLContourPenNumber", DC::HPGLContourPenNumber },
        { "HPGLPenSequence", DC::HPGLPenSequence },
        { "HPGLPenNumber", DC::HPGLPenNumber },
        { "HPGLPenLabel", DC::HPGLPenLabel },
        { "HPGLPenDescription", DC::HPGLPenDescription },
        { "RecommendedRotationPoint", DC::RecommendedRotationPoint },
        { "BoundingRectangle", DC::BoundingRectangle },
        { "ImplantTemplate3DModelSurfaceNumber", DC::ImplantTemplate3DModelSurfaceNumber },
        { "SurfaceModelDescriptionSequence", DC::SurfaceModelDescriptionSequence },
        { "SurfaceModelLabel", DC::SurfaceModelLabel },
        { "SurfaceModelScalingFactor", DC::SurfaceModelScalingFactor },
        { "MaterialsCodeSequence", DC::MaterialsCodeSequence },
        { "CoatingMaterialsCodeSequence", DC::CoatingMaterialsCodeSequence },
        { "ImplantTypeCodeSequence", DC::ImplantTypeCodeSequence },
        { "FixationMethodCodeSequence", DC::FixationMethodCodeSequence },
        { "MatingFeatureSetsSequence", DC::MatingFeatureSetsSequence },
        { "MatingFeatureSetID", DC::MatingFeatureSetID },
        { "MatingFeatureSetLabel", DC::MatingFeatureSetLabel },
        { "MatingFeatureSequence", DC::MatingFeatureSequence },
        { "MatingFeatureID", DC::MatingFeatureID },
        { "MatingFeatureDegreeOfFreedomSequence", DC::MatingFeatureDegreeOfFreedomSequence },
        { "DegreeOfFreedomID", DC::DegreeOfFreedomID },
        { "DegreeOfFreedomType", DC::DegreeOfFreedomType },
        { "TwoDMatingFeatureCoordinatesSequence", DC::TwoDMatingFeatureCoordinatesSequence },
        { "ReferencedHPGLDocumentID", DC::ReferencedHPGLDocumentID },
        { "TwoDMatingPoint", DC::TwoDMatingPoint },
        { "TwoDMatingAxes", DC::TwoDMatingAxes },
        { "TwoDDegreeOfFreedomSequence", DC::TwoDDegreeOfFreedomSequence },
        { "ThreeDDegreeOfFreedomAxis", DC::ThreeDDegreeOfFreedomAxis },
        { "RangeOfFreedom", DC::RangeOfFreedom },
        { "ThreeDMatingPoint", DC::ThreeDMatingPoint },
        { "ThreeDMatingAxes", DC::ThreeDMatingAxes },
        { "TwoDDegreeOfFreedomAxis", DC::TwoDDegreeOfFreedomAxis },
        { "PlanningLandmarkPointSequence", DC::PlanningLandmarkPointSequence },
        { "PlanningLandmarkLineSequence", DC::PlanningLandmarkLineSequence },
        { "PlanningLandmarkPlaneSequence", DC::PlanningLandmarkPlaneSequence },
        { "PlanningLandmarkID", DC::PlanningLandmarkID },
        { "PlanningLandmarkDescription", DC::PlanningLandmarkDescription },
        { "PlanningLandmarkIdentificationCodeSequence", DC::PlanningLandmarkIdentificationCodeSequence },
        { "TwoDPointCoordinatesSequence", DC::TwoDPointCoordinatesSequence },
        { "TwoDPointCoordinates", DC::TwoDPointCoordinates },
        { "ThreeDPointCoordinates", DC::ThreeDPointCoordinates },
        { "TwoDLineCoordinatesSequence", DC::TwoDLineCoordinatesSequence },
        { "TwoDLineCoordinates", DC::TwoDLineCoordinates },
        { "ThreeDLineCoordinates", DC::ThreeDLineCoordinates },
        { "TwoDPlaneCoordinatesSequence", DC::TwoDPlaneCoordinatesSequence },
        { "TwoDPlaneIntersection", DC::TwoDPlaneIntersection },
        { "ThreeDPlaneOrigin", DC::ThreeDPlaneOrigin },
        { "ThreeDPlaneNormal", DC::ThreeDPlaneNormal },
        { "ModelModification", DC::ModelModification },
        { "ModelMirroring", DC::ModelMirroring },
        { "ModelUsageCodeSequence", DC::ModelUsageCodeSequence },
        { "ModelGroupUID", DC::ModelGroupUID },
        { "RelativeURIReferenceWithinEncapsulatedDocument", DC::RelativeURIReferenceWithinEncapsulatedDocument },
        { "AnnotationCoordinateType", DC::AnnotationCoordinateType },
        { "AnnotationGroupSequence", DC::AnnotationGroupSequence },
        { "AnnotationGroupUID", DC::AnnotationGroupUID },
        { "AnnotationGroupLabel", DC::AnnotationGroupLabel },
        { "AnnotationGroupDescription", DC::AnnotationGroupDescription },
        { "AnnotationGroupGenerationType", DC::AnnotationGroupGenerationType },
        { "AnnotationGroupAlgorithmIdentificationSequence", DC::AnnotationGroupAlgorithmIdentificationSequence },
        { "AnnotationPropertyCategoryCodeSequence", DC::AnnotationPropertyCategoryCodeSequence },
        { "AnnotationPropertyTypeCodeSequence", DC::AnnotationPropertyTypeCodeSequence },
        { "AnnotationPropertyTypeModifierCodeSequence", DC::AnnotationPropertyTypeModifierCodeSequence },
        { "NumberOfAnnotations", DC::NumberOfAnnotations },
        { "AnnotationAppliesToAllOpticalPaths", DC::AnnotationAppliesToAllOpticalPaths },
        { "ReferencedOpticalPathIdentifier", DC::ReferencedOpticalPathIdentifier },
        { "AnnotationAppliesToAllZPlanes", DC::AnnotationAppliesToAllZPlanes },
        { "CommonZCoordinateValue", DC::CommonZCoordinateValue },
        { "AnnotationIndexList", DC::AnnotationIndexList },
        { "GraphicAnnotationSequence", DC::GraphicAnnotationSequence },
        { "GraphicLayer", DC::GraphicLayer },
        { "BoundingBoxAnnotationUnits", DC::BoundingBoxAnnotationUnits },
        { "AnchorPointAnnotationUnits", DC::AnchorPointAnnotationUnits },
        { "GraphicAnnotationUnits", DC::GraphicAnnotationUnits },
        { "UnformattedTextValue", DC::UnformattedTextValue },
        { "TextObjectSequence", DC::TextObjectSequence },
        { "GraphicObjectSequence", DC::GraphicObjectSequence },
        { "BoundingBoxTopLeftHandCorner", DC::BoundingBoxTopLeftHandCorner },
        { "BoundingBoxBottomRightHandCorner", DC::BoundingBoxBottomRightHandCorner },
        { "BoundingBoxTextHorizontalJustification", DC::BoundingBoxTextHorizontalJustification },
        { "AnchorPoint", DC::AnchorPoint },
        { "AnchorPointVisibility", DC::AnchorPointVisibility },
        { "GraphicDimensions", DC::GraphicDimensions },
        { "NumberOfGraphicPoints", DC::NumberOfGraphicPoints },
        { "GraphicData", DC::GraphicData },
        { "GraphicType", DC::GraphicType },
        { "GraphicFilled", DC::GraphicFilled },
        { "ImageRotationRetired", DC::ImageRotationRetired },
        { "ImageHorizontalFlip", DC::ImageHorizontalFlip },
        { "ImageRotation", DC::ImageRotation },
        { "DisplayedAreaTopLeftHandCornerTrial", DC::DisplayedAreaTopLeftHandCornerTrial },
        { "DisplayedAreaBottomRightHandCornerTrial", DC::DisplayedAreaBottomRightHandCornerTrial },
        { "DisplayedAreaTopLeftHandCorner", DC::DisplayedAreaTopLeftHandCorner },
        { "DisplayedAreaBottomRightHandCorner", DC::DisplayedAreaBottomRightHandCorner },
        { "DisplayedAreaSelectionSequence", DC::DisplayedAreaSelectionSequence },
        { "GraphicLayerSequence", DC::GraphicLayerSequence },
        { "GraphicLayerOrder", DC::GraphicLayerOrder },
        { "GraphicLayerRecommendedDisplayGrayscaleValue", DC::GraphicLayerRecommendedDisplayGrayscaleValue },
        { "GraphicLayerRecommendedDisplayRGBValue", DC::GraphicLayerRecommendedDisplayRGBValue },
        { "GraphicLayerDescription", DC::GraphicLayerDescription },
        { "ContentLabel", DC::ContentLabel },
        { "ContentDescription", DC::ContentDescription },
        { "PresentationCreationDate", DC::PresentationCreationDate },
        { "PresentationCreationTime", DC::PresentationCreationTime },
        { "ContentCreatorName", DC::ContentCreatorName },
        { "ContentCreatorIdentificationCodeSequence", DC::ContentCreatorIdentificationCodeSequence },
        { "AlternateContentDescriptionSequence", DC::AlternateContentDescriptionSequence },
        { "PresentationSizeMode", DC::PresentationSizeMode },
        { "PresentationPixelSpacing", DC::PresentationPixelSpacing },
        { "PresentationPixelAspectRatio", DC::PresentationPixelAspectRatio },
        { "PresentationPixelMagnificationRatio", DC::PresentationPixelMagnificationRatio },
        { "GraphicGroupLabel", DC::GraphicGroupLabel },
        { "GraphicGroupDescription", DC::GraphicGroupDescription },
        { "CompoundGraphicSequence", DC::CompoundGraphicSequence },
        { "CompoundGraphicInstanceID", DC::CompoundGraphicInstanceID },
        { "FontName", DC::FontName },
        { "FontNameType", DC::FontNameType },
        { "CSSFontName", DC::CSSFontName },
        { "RotationAngle", DC::RotationAngle },
        { "TextStyleSequence", DC::TextStyleSequence },
        { "LineStyleSequence", DC::LineStyleSequence },
        { "FillStyleSequence", DC::FillStyleSequence },
        { "GraphicGroupSequence", DC::GraphicGroupSequence },
        { "TextColorCIELabValue", DC::TextColorCIELabValue },
        { "HorizontalAlignment", DC::HorizontalAlignment },
        { "VerticalAlignment", DC::VerticalAlignment },
        { "ShadowStyle", DC::ShadowStyle },
        { "ShadowOffsetX", DC::ShadowOffsetX },
        { "ShadowOffsetY", DC::ShadowOffsetY },
        { "ShadowColorCIELabValue", DC::ShadowColorCIELabValue },
        { "Underlined", DC::Underlined },
        { "Bold", DC::Bold },
        { "Italic", DC::Italic },
        { "PatternOnColorCIELabValue", DC::PatternOnColorCIELabValue },
        { "PatternOffColorCIELabValue", DC::PatternOffColorCIELabValue },
        { "LineThickness", DC::LineThickness },
        { "LineDashingStyle", DC::LineDashingStyle },
        { "LinePattern", DC::LinePattern },
        { "FillPattern", DC::FillPattern },
        { "FillMode", DC::FillMode },
        { "ShadowOpacity", DC::ShadowOpacity },
        { "GapLength", DC::GapLength },
        { "DiameterOfVisibility", DC::DiameterOfVisibility },
        { "RotationPoint", DC::RotationPoint },
        { "TickAlignment", DC::TickAlignment },
        { "ShowTickLabel", DC::ShowTickLabel },
        { "TickLabelAlignment", DC::TickLabelAlignment },
        { "CompoundGraphicUnits", DC::CompoundGraphicUnits },
        { "PatternOnOpacity", DC::PatternOnOpacity },
        { "PatternOffOpacity", DC::PatternOffOpacity },
        { "MajorTicksSequence", DC::MajorTicksSequence },
        { "TickPosition", DC::TickPosition },
        { "TickLabel", DC::TickLabel },
        { "CompoundGraphicType", DC::CompoundGraphicType },
        { "GraphicGroupID", DC::GraphicGroupID },
        { "ShapeType", DC::ShapeType },
        { "RegistrationSequence", DC::RegistrationSequence },
        { "MatrixRegistrationSequence", DC::MatrixRegistrationSequence },
        { "MatrixSequence", DC::MatrixSequence },
        { "FrameOfReferenceToDisplayedCoordinateSystemTransformationMatrix", DC::FrameOfReferenceToDisplayedCoordinateSystemTransformationMatrix },
        { "FrameOfReferenceTransformationMatrixType", DC::FrameOfReferenceTransformationMatrixType },
        { "RegistrationTypeCodeSequence", DC::RegistrationTypeCodeSequence },
        { "FiducialDescription", DC::FiducialDescription },
        { "FiducialIdentifier", DC::FiducialIdentifier },
        { "FiducialIdentifierCodeSequence", DC::FiducialIdentifierCodeSequence },
        { "ContourUncertaintyRadius", DC::ContourUncertaintyRadius },
        { "UsedFiducialsSequence", DC::UsedFiducialsSequence },
        { "UsedRTStructureSetROISequence", DC::UsedRTStructureSetROISequence },
        { "GraphicCoordinatesDataSequence", DC::GraphicCoordinatesDataSequence },
        { "FiducialUID", DC::FiducialUID },
        { "ReferencedFiducialUID", DC::ReferencedFiducialUID },
        { "FiducialSetSequence", DC::FiducialSetSequence },
        { "FiducialSequence", DC::FiducialSequence },
        { "FiducialsPropertyCategoryCodeSequence", DC::FiducialsPropertyCategoryCodeSequence },
        { "GraphicLayerRecommendedDisplayCIELabValue", DC::GraphicLayerRecommendedDisplayCIELabValue },
        { "BlendingSequence", DC::BlendingSequence },
        { "RelativeOpacity", DC::RelativeOpacity },
        { "ReferencedSpatialRegistrationSequence", DC::ReferencedSpatialRegistrationSequence },
        { "BlendingPosition", DC::BlendingPosition },
        { "PresentationDisplayCollectionUID", DC::PresentationDisplayCollectionUID },
        { "PresentationSequenceCollectionUID", DC::PresentationSequenceCollectionUID },
        { "PresentationSequencePositionIndex", DC::PresentationSequencePositionIndex },
        { "RenderedImageReferenceSequence", DC::RenderedImageReferenceSequence },
        { "VolumetricPresentationStateInputSequence", DC::VolumetricPresentationStateInputSequence },
        { "PresentationInputType", DC::PresentationInputType },
        { "InputSequencePositionIndex", DC::InputSequencePositionIndex },
        { "Crop", DC::Crop },
        { "CroppingSpecificationIndex", DC::CroppingSpecificationIndex },
        { "CompositingMethod", DC::CompositingMethod },
        { "VolumetricPresentationInputNumber", DC::VolumetricPresentationInputNumber },
        { "ImageVolumeGeometry", DC::ImageVolumeGeometry },
        { "VolumetricPresentationInputSetUID", DC::VolumetricPresentationInputSetUID },
        { "VolumetricPresentationInputSetSequence", DC::VolumetricPresentationInputSetSequence },
        { "GlobalCrop", DC::GlobalCrop },
        { "GlobalCroppingSpecificationIndex", DC::GlobalCroppingSpecificationIndex },
        { "RenderingMethod", DC::RenderingMethod },
        { "VolumeCroppingSequence", DC::VolumeCroppingSequence },
        { "VolumeCroppingMethod", DC::VolumeCroppingMethod },
        { "BoundingBoxCrop", DC::BoundingBoxCrop },
        { "ObliqueCroppingPlaneSequence", DC::ObliqueCroppingPlaneSequence },
        { "Plane", DC::Plane },
        { "PlaneNormal", DC::PlaneNormal },
        { "CroppingSpecificationNumber", DC::CroppingSpecificationNumber },
        { "MultiPlanarReconstructionStyle", DC::MultiPlanarReconstructionStyle },
        { "MPRThicknessType", DC::MPRThicknessType },
        { "MPRSlabThickness", DC::MPRSlabThickness },
        { "MPRTopLeftHandCorner", DC::MPRTopLeftHandCorner },
        { "MPRViewWidthDirection", DC::MPRViewWidthDirection },
        { "MPRViewWidth", DC::MPRViewWidth },
        { "NumberOfVolumetricCurvePoints", DC::NumberOfVolumetricCurvePoints },
        { "VolumetricCurvePoints", DC::VolumetricCurvePoints },
        { "MPRViewHeightDirection", DC::MPRViewHeightDirection },
        { "MPRViewHeight", DC::MPRViewHeight },
        { "RenderProjection", DC::RenderProjection },
        { "ViewpointPosition", DC::ViewpointPosition },
        { "ViewpointLookAtPoint", DC::ViewpointLookAtPoint },
        { "ViewpointUpDirection", DC::ViewpointUpDirection },
        { "RenderFieldOfView", DC::RenderFieldOfView },
        { "SamplingStepSize", DC::SamplingStepSize },
        { "ShadingStyle", DC::ShadingStyle },
        { "AmbientReflectionIntensity", DC::AmbientReflectionIntensity },
        { "LightDirection", DC::LightDirection },
        { "DiffuseReflectionIntensity", DC::DiffuseReflectionIntensity },
        { "SpecularReflectionIntensity", DC::SpecularReflectionIntensity },
        { "Shininess", DC::Shininess },
        { "PresentationStateClassificationComponentSequence", DC::PresentationStateClassificationComponentSequence },
        { "ComponentType", DC::ComponentType },
        { "ComponentInputSequence", DC::ComponentInputSequence },
        { "VolumetricPresentationInputIndex", DC::VolumetricPresentationInputIndex },
        { "PresentationStateCompositorComponentSequence", DC::PresentationStateCompositorComponentSequence },
        { "WeightingTransferFunctionSequence", DC::WeightingTransferFunctionSequence },
        { "WeightingLookupTableDescriptor", DC::WeightingLookupTableDescriptor },
        { "WeightingLookupTableData", DC::WeightingLookupTableData },
        { "VolumetricAnnotationSequence", DC::VolumetricAnnotationSequence },
        { "ReferencedStructuredContextSequence", DC::ReferencedStructuredContextSequence },
        { "ReferencedContentItem", DC::ReferencedContentItem },
        { "VolumetricPresentationInputAnnotationSequence", DC::VolumetricPresentationInputAnnotationSequence },
        { "AnnotationClipping", DC::AnnotationClipping },
        { "PresentationAnimationStyle", DC::PresentationAnimationStyle },
        { "RecommendedAnimationRate", DC::RecommendedAnimationRate },
        { "AnimationCurveSequence", DC::AnimationCurveSequence },
        { "AnimationStepSize", DC::AnimationStepSize },
        { "SwivelRange", DC::SwivelRange },
        { "VolumetricCurveUpDirections", DC::VolumetricCurveUpDirections },
        { "VolumeStreamSequence", DC::VolumeStreamSequence },
        { "RGBATransferFunctionDescription", DC::RGBATransferFunctionDescription },
        { "AdvancedBlendingSequence", DC::AdvancedBlendingSequence },
        { "BlendingInputNumber", DC::BlendingInputNumber },
        { "BlendingDisplayInputSequence", DC::BlendingDisplayInputSequence },
        { "BlendingDisplaySequence", DC::BlendingDisplaySequence },
        { "BlendingMode", DC::BlendingMode },
        { "TimeSeriesBlending", DC::TimeSeriesBlending },
        { "GeometryForDisplay", DC::GeometryForDisplay },
        { "ThresholdSequence", DC::ThresholdSequence },
        { "ThresholdValueSequence", DC::ThresholdValueSequence },
        { "ThresholdType", DC::ThresholdType },
        { "ThresholdValue", DC::ThresholdValue },
        { "HangingProtocolName", DC::HangingProtocolName },
        { "HangingProtocolDescription", DC::HangingProtocolDescription },
        { "HangingProtocolLevel", DC::HangingProtocolLevel },
        { "HangingProtocolCreator", DC::HangingProtocolCreator },
        { "HangingProtocolCreationDateTime", DC::HangingProtocolCreationDateTime },
        { "HangingProtocolDefinitionSequence", DC::HangingProtocolDefinitionSequence },
        { "HangingProtocolUserIdentificationCodeSequence", DC::HangingProtocolUserIdentificationCodeSequence },
        { "HangingProtocolUserGroupName", DC::HangingProtocolUserGroupName },
        { "SourceHangingProtocolSequence", DC::SourceHangingProtocolSequence },
        { "NumberOfPriorsReferenced", DC::NumberOfPriorsReferenced },
        { "ImageSetsSequence", DC::ImageSetsSequence },
        { "ImageSetSelectorSequence", DC::ImageSetSelectorSequence },
        { "ImageSetSelectorUsageFlag", DC::ImageSetSelectorUsageFlag },
        { "SelectorAttribute", DC::SelectorAttribute },
        { "SelectorValueNumber", DC::SelectorValueNumber },
        { "TimeBasedImageSetsSequence", DC::TimeBasedImageSetsSequence },
        { "ImageSetNumber", DC::ImageSetNumber },
        { "ImageSetSelectorCategory", DC::ImageSetSelectorCategory },
        { "RelativeTime", DC::RelativeTime },
        { "RelativeTimeUnits", DC::RelativeTimeUnits },
        { "AbstractPriorValue", DC::AbstractPriorValue },
        { "AbstractPriorCodeSequence", DC::AbstractPriorCodeSequence },
        { "ImageSetLabel", DC::ImageSetLabel },
        { "SelectorAttributeVR", DC::SelectorAttributeVR },
        { "SelectorSequencePointer", DC::SelectorSequencePointer },
        { "SelectorSequencePointerPrivateCreator", DC::SelectorSequencePointerPrivateCreator },
        { "SelectorAttributePrivateCreator", DC::SelectorAttributePrivateCreator },
        { "SelectorAEValue", DC::SelectorAEValue },
        { "SelectorASValue", DC::SelectorASValue },
        { "SelectorATValue", DC::SelectorATValue },
        { "SelectorDAValue", DC::SelectorDAValue },
        { "SelectorCSValue", DC::SelectorCSValue },
        { "SelectorDTValue", DC::SelectorDTValue },
        { "SelectorISValue", DC::SelectorISValue },
        { "SelectorOBValue", DC::SelectorOBValue },
        { "SelectorLOValue", DC::SelectorLOValue },
        { "SelectorOFValue", DC::SelectorOFValue },
        { "SelectorLTValue", DC::SelectorLTValue },
        { "SelectorOWValue", DC::SelectorOWValue },
        { "SelectorPNValue", DC::SelectorPNValue },
        { "SelectorTMValue", DC::SelectorTMValue },
        { "SelectorSHValue", DC::SelectorSHValue },
        { "SelectorUNValue", DC::SelectorUNValue },
        { "SelectorSTValue", DC::SelectorSTValue },
        { "SelectorUCValue", DC::SelectorUCValue },
        { "SelectorUTValue", DC::SelectorUTValue },
        { "SelectorURValue", DC::SelectorURValue },
        { "SelectorDSValue", DC::SelectorDSValue },
        { "SelectorODValue", DC::SelectorODValue },
        { "SelectorFDValue", DC::SelectorFDValue },
        { "SelectorOLValue", DC::SelectorOLValue },
        { "SelectorFLValue", DC::SelectorFLValue },
        { "SelectorULValue", DC::SelectorULValue },
        { "SelectorUSValue", DC::SelectorUSValue },
        { "SelectorSLValue", DC::SelectorSLValue },
        { "SelectorSSValue", DC::SelectorSSValue },
        { "SelectorUIValue", DC::SelectorUIValue },
        { "SelectorCodeSequenceValue", DC::SelectorCodeSequenceValue },
        { "SelectorOVValue", DC::SelectorOVValue },
        { "SelectorSVValue", DC::SelectorSVValue },
        { "SelectorUVValue", DC::SelectorUVValue },
        { "NumberOfScreens", DC::NumberOfScreens },
        { "NominalScreenDefinitionSequence", DC::NominalScreenDefinitionSequence },
        { "NumberOfVerticalPixels", DC::NumberOfVerticalPixels },
        { "NumberOfHorizontalPixels", DC::NumberOfHorizontalPixels },
        { "DisplayEnvironmentSpatialPosition", DC::DisplayEnvironmentSpatialPosition },
        { "ScreenMinimumGrayscaleBitDepth", DC::ScreenMinimumGrayscaleBitDepth },
        { "ScreenMinimumColorBitDepth", DC::ScreenMinimumColorBitDepth },
        { "ApplicationMaximumRepaintTime", DC::ApplicationMaximumRepaintTime },
        { "DisplaySetsSequence", DC::DisplaySetsSequence },
        { "DisplaySetNumber", DC::DisplaySetNumber },
        { "DisplaySetLabel", DC::DisplaySetLabel },
        { "DisplaySetPresentationGroup", DC::DisplaySetPresentationGroup },
        { "DisplaySetPresentationGroupDescription", DC::DisplaySetPresentationGroupDescription },
        { "PartialDataDisplayHandling", DC::PartialDataDisplayHandling },
        { "SynchronizedScrollingSequence", DC::SynchronizedScrollingSequence },
        { "DisplaySetScrollingGroup", DC::DisplaySetScrollingGroup },
        { "NavigationIndicatorSequence", DC::NavigationIndicatorSequence },
        { "NavigationDisplaySet", DC::NavigationDisplaySet },
        { "ReferenceDisplaySets", DC::ReferenceDisplaySets },
        { "ImageBoxesSequence", DC::ImageBoxesSequence },
        { "ImageBoxNumber", DC::ImageBoxNumber },
        { "ImageBoxLayoutType", DC::ImageBoxLayoutType },
        { "ImageBoxTileHorizontalDimension", DC::ImageBoxTileHorizontalDimension },
        { "ImageBoxTileVerticalDimension", DC::ImageBoxTileVerticalDimension },
        { "ImageBoxScrollDirection", DC::ImageBoxScrollDirection },
        { "ImageBoxSmallScrollType", DC::ImageBoxSmallScrollType },
        { "ImageBoxSmallScrollAmount", DC::ImageBoxSmallScrollAmount },
        { "ImageBoxLargeScrollType", DC::ImageBoxLargeScrollType },
        { "ImageBoxLargeScrollAmount", DC::ImageBoxLargeScrollAmount },
        { "ImageBoxOverlapPriority", DC::ImageBoxOverlapPriority },
        { "CineRelativeToRealTime", DC::CineRelativeToRealTime },
        { "FilterOperationsSequence", DC::FilterOperationsSequence },
        { "FilterByCategory", DC::FilterByCategory },
        { "FilterByAttributePresence", DC::FilterByAttributePresence },
        { "FilterByOperator", DC::FilterByOperator },
        { "StructuredDisplayBackgroundCIELabValue", DC::StructuredDisplayBackgroundCIELabValue },
        { "EmptyImageBoxCIELabValue", DC::EmptyImageBoxCIELabValue },
        { "StructuredDisplayImageBoxSequence", DC::StructuredDisplayImageBoxSequence },
        { "StructuredDisplayTextBoxSequence", DC::StructuredDisplayTextBoxSequence },
        { "ReferencedFirstFrameSequence", DC::ReferencedFirstFrameSequence },
        { "ImageBoxSynchronizationSequence", DC::ImageBoxSynchronizationSequence },
        { "SynchronizedImageBoxList", DC::SynchronizedImageBoxList },
        { "TypeOfSynchronization", DC::TypeOfSynchronization },
        { "BlendingOperationType", DC::BlendingOperationType },
        { "ReformattingOperationType", DC::ReformattingOperationType },
        { "ReformattingThickness", DC::ReformattingThickness },
        { "ReformattingInterval", DC::ReformattingInterval },
        { "ReformattingOperationInitialViewDirection", DC::ReformattingOperationInitialViewDirection },
        { "ThreeDRenderingType", DC::ThreeDRenderingType },
        { "SortingOperationsSequence", DC::SortingOperationsSequence },
        { "SortByCategory", DC::SortByCategory },
        { "SortingDirection", DC::SortingDirection },
        { "DisplaySetPatientOrientation", DC::DisplaySetPatientOrientation },
        { "VOIType", DC::VOIType },
        { "PseudoColorType", DC::PseudoColorType },
        { "PseudoColorPaletteInstanceReferenceSequence", DC::PseudoColorPaletteInstanceReferenceSequence },
        { "ShowGrayscaleInverted", DC::ShowGrayscaleInverted },
        { "ShowImageTrueSizeFlag", DC::ShowImageTrueSizeFlag },
        { "ShowGraphicAnnotationFlag", DC::ShowGraphicAnnotationFlag },
        { "ShowPatientDemographicsFlag", DC::ShowPatientDemographicsFlag },
        { "ShowAcquisitionTechniquesFlag", DC::ShowAcquisitionTechniquesFlag },
        { "DisplaySetHorizontalJustification", DC::DisplaySetHorizontalJustification },
        { "DisplaySetVerticalJustification", DC::DisplaySetVerticalJustification },
        { "ContinuationStartMeterset", DC::ContinuationStartMeterset },
        { "ContinuationEndMeterset", DC::ContinuationEndMeterset },
        { "ProcedureStepState", DC::ProcedureStepState },
        { "ProcedureStepProgressInformationSequence", DC::ProcedureStepProgressInformationSequence },
        { "ProcedureStepProgress", DC::ProcedureStepProgress },
        { "ProcedureStepProgressDescription", DC::ProcedureStepProgressDescription },
        { "ProcedureStepProgressParametersSequence", DC::ProcedureStepProgressParametersSequence },
        { "ProcedureStepCommunicationsURISequence", DC::ProcedureStepCommunicationsURISequence },
        { "ContactURI", DC::ContactURI },
        { "ContactDisplayName", DC::ContactDisplayName },
        { "ProcedureStepDiscontinuationReasonCodeSequence", DC::ProcedureStepDiscontinuationReasonCodeSequence },
        { "BeamTaskSequence", DC::BeamTaskSequence },
        { "BeamTaskType", DC::BeamTaskType },
        { "BeamOrderIndexTrial", DC::BeamOrderIndexTrial },
        { "AutosequenceFlag", DC::AutosequenceFlag },
        { "TableTopVerticalAdjustedPosition", DC::TableTopVerticalAdjustedPosition },
        { "TableTopLongitudinalAdjustedPosition", DC::TableTopLongitudinalAdjustedPosition },
        { "TableTopLateralAdjustedPosition", DC::TableTopLateralAdjustedPosition },
        { "PatientSupportAdjustedAngle", DC::PatientSupportAdjustedAngle },
        { "TableTopEccentricAdjustedAngle", DC::TableTopEccentricAdjustedAngle },
        { "TableTopPitchAdjustedAngle", DC::TableTopPitchAdjustedAngle },
        { "TableTopRollAdjustedAngle", DC::TableTopRollAdjustedAngle },
        { "DeliveryVerificationImageSequence", DC::DeliveryVerificationImageSequence },
        { "VerificationImageTiming", DC::VerificationImageTiming },
        { "DoubleExposureFlag", DC::DoubleExposureFlag },
        { "DoubleExposureOrdering", DC::DoubleExposureOrdering },
        { "DoubleExposureMetersetTrial", DC::DoubleExposureMetersetTrial },
        { "DoubleExposureFieldDeltaTrial", DC::DoubleExposureFieldDeltaTrial },
        { "RelatedReferenceRTImageSequence", DC::RelatedReferenceRTImageSequence },
        { "GeneralMachineVerificationSequence", DC::GeneralMachineVerificationSequence },
        { "ConventionalMachineVerificationSequence", DC::ConventionalMachineVerificationSequence },
        { "IonMachineVerificationSequence", DC::IonMachineVerificationSequence },
        { "FailedAttributesSequence", DC::FailedAttributesSequence },
        { "OverriddenAttributesSequence", DC::OverriddenAttributesSequence },
        { "ConventionalControlPointVerificationSequence", DC::ConventionalControlPointVerificationSequence },
        { "IonControlPointVerificationSequence", DC::IonControlPointVerificationSequence },
        { "AttributeOccurrenceSequence", DC::AttributeOccurrenceSequence },
        { "AttributeOccurrencePointer", DC::AttributeOccurrencePointer },
        { "AttributeItemSelector", DC::AttributeItemSelector },
        { "AttributeOccurrencePrivateCreator", DC::AttributeOccurrencePrivateCreator },
        { "SelectorSequencePointerItems", DC::SelectorSequencePointerItems },
        { "ScheduledProcedureStepPriority", DC::ScheduledProcedureStepPriority },
        { "WorklistLabel", DC::WorklistLabel },
        { "ProcedureStepLabel", DC::ProcedureStepLabel },
        { "ScheduledProcessingParametersSequence", DC::ScheduledProcessingParametersSequence },
        { "PerformedProcessingParametersSequence", DC::PerformedProcessingParametersSequence },
        { "UnifiedProcedureStepPerformedProcedureSequence", DC::UnifiedProcedureStepPerformedProcedureSequence },
        { "RelatedProcedureStepSequence", DC::RelatedProcedureStepSequence },
        { "ProcedureStepRelationshipType", DC::ProcedureStepRelationshipType },
        { "ReplacedProcedureStepSequence", DC::ReplacedProcedureStepSequence },
        { "DeletionLock", DC::DeletionLock },
        { "ReceivingAE", DC::ReceivingAE },
        { "RequestingAE", DC::RequestingAE },
        { "ReasonForCancellation", DC::ReasonForCancellation },
        { "SCPStatus", DC::SCPStatus },
        { "SubscriptionListStatus", DC::SubscriptionListStatus },
        { "UnifiedProcedureStepListStatus", DC::UnifiedProcedureStepListStatus },
        { "BeamOrderIndex", DC::BeamOrderIndex },
        { "DoubleExposureMeterset", DC::DoubleExposureMeterset },
        { "DoubleExposureFieldDelta", DC::DoubleExposureFieldDelta },
        { "BrachyTaskSequence", DC::BrachyTaskSequence },
        { "ContinuationStartTotalReferenceAirKerma", DC::ContinuationStartTotalReferenceAirKerma },
        { "ContinuationEndTotalReferenceAirKerma", DC::ContinuationEndTotalReferenceAirKerma },
        { "ContinuationPulseNumber", DC::ContinuationPulseNumber },
        { "ChannelDeliveryOrderSequence", DC::ChannelDeliveryOrderSequence },
        { "ReferencedChannelNumber", DC::ReferencedChannelNumber },
        { "StartCumulativeTimeWeight", DC::StartCumulativeTimeWeight },
        { "EndCumulativeTimeWeight", DC::EndCumulativeTimeWeight },
        { "OmittedChannelSequence", DC::OmittedChannelSequence },
        { "ReasonForChannelOmission", DC::ReasonForChannelOmission },
        { "ReasonForChannelOmissionDescription", DC::ReasonForChannelOmissionDescription },
        { "ChannelDeliveryOrderIndex", DC::ChannelDeliveryOrderIndex },
        { "ChannelDeliveryContinuationSequence", DC::ChannelDeliveryContinuationSequence },
        { "OmittedApplicationSetupSequence", DC::OmittedApplicationSetupSequence },
        { "ImplantAssemblyTemplateName", DC::ImplantAssemblyTemplateName },
        { "ImplantAssemblyTemplateIssuer", DC::ImplantAssemblyTemplateIssuer },
        { "ImplantAssemblyTemplateVersion", DC::ImplantAssemblyTemplateVersion },
        { "ReplacedImplantAssemblyTemplateSequence", DC::ReplacedImplantAssemblyTemplateSequence },
        { "ImplantAssemblyTemplateType", DC::ImplantAssemblyTemplateType },
        { "OriginalImplantAssemblyTemplateSequence", DC::OriginalImplantAssemblyTemplateSequence },
        { "DerivationImplantAssemblyTemplateSequence", DC::DerivationImplantAssemblyTemplateSequence },
        { "ImplantAssemblyTemplateTargetAnatomySequence", DC::ImplantAssemblyTemplateTargetAnatomySequence },
        { "ProcedureTypeCodeSequence", DC::ProcedureTypeCodeSequence },
        { "SurgicalTechnique", DC::SurgicalTechnique },
        { "ComponentTypesSequence", DC::ComponentTypesSequence },
        { "ComponentTypeCodeSequence", DC::ComponentTypeCodeSequence },
        { "ExclusiveComponentType", DC::ExclusiveComponentType },
        { "MandatoryComponentType", DC::MandatoryComponentType },
        { "ComponentSequence", DC::ComponentSequence },
        { "ComponentID", DC::ComponentID },
        { "ComponentAssemblySequence", DC::ComponentAssemblySequence },
        { "Component1ReferencedID", DC::Component1ReferencedID },
        { "Component1ReferencedMatingFeatureSetID", DC::Component1ReferencedMatingFeatureSetID },
        { "Component1ReferencedMatingFeatureID", DC::Component1ReferencedMatingFeatureID },
        { "Component2ReferencedID", DC::Component2ReferencedID },
        { "Component2ReferencedMatingFeatureSetID", DC::Component2ReferencedMatingFeatureSetID },
        { "Component2ReferencedMatingFeatureID", DC::Component2ReferencedMatingFeatureID },
        { "ImplantTemplateGroupName", DC::ImplantTemplateGroupName },
        { "ImplantTemplateGroupDescription", DC::ImplantTemplateGroupDescription },
        { "ImplantTemplateGroupIssuer", DC::ImplantTemplateGroupIssuer },
        { "ImplantTemplateGroupVersion", DC::ImplantTemplateGroupVersion },
        { "ReplacedImplantTemplateGroupSequence", DC::ReplacedImplantTemplateGroupSequence },
        { "ImplantTemplateGroupTargetAnatomySequence", DC::ImplantTemplateGroupTargetAnatomySequence },
        { "ImplantTemplateGroupMembersSequence", DC::ImplantTemplateGroupMembersSequence },
        { "ImplantTemplateGroupMemberID", DC::ImplantTemplateGroupMemberID },
        { "ThreeDImplantTemplateGroupMemberMatchingPoint", DC::ThreeDImplantTemplateGroupMemberMatchingPoint },
        { "ThreeDImplantTemplateGroupMemberMatchingAxes", DC::ThreeDImplantTemplateGroupMemberMatchingAxes },
        { "ImplantTemplateGroupMemberMatching2DCoordinatesSequence", DC::ImplantTemplateGroupMemberMatching2DCoordinatesSequence },
        { "TwoDImplantTemplateGroupMemberMatchingPoint", DC::TwoDImplantTemplateGroupMemberMatchingPoint },
        { "TwoDImplantTemplateGroupMemberMatchingAxes", DC::TwoDImplantTemplateGroupMemberMatchingAxes },
        { "ImplantTemplateGroupVariationDimensionSequence", DC::ImplantTemplateGroupVariationDimensionSequence },
        { "ImplantTemplateGroupVariationDimensionName", DC::ImplantTemplateGroupVariationDimensionName },
        { "ImplantTemplateGroupVariationDimensionRankSequence", DC::ImplantTemplateGroupVariationDimensionRankSequence },
        { "ReferencedImplantTemplateGroupMemberID", DC::ReferencedImplantTemplateGroupMemberID },
        { "ImplantTemplateGroupVariationDimensionRank", DC::ImplantTemplateGroupVariationDimensionRank },
        { "SurfaceScanAcquisitionTypeCodeSequence", DC::SurfaceScanAcquisitionTypeCodeSequence },
        { "SurfaceScanModeCodeSequence", DC::SurfaceScanModeCodeSequence },
        { "RegistrationMethodCodeSequence", DC::RegistrationMethodCodeSequence },
        { "ShotDurationTime", DC::ShotDurationTime },
        { "ShotOffsetTime", DC::ShotOffsetTime },
        { "SurfacePointPresentationValueData", DC::SurfacePointPresentationValueData },
        { "SurfacePointColorCIELabValueData", DC::SurfacePointColorCIELabValueData },
        { "UVMappingSequence", DC::UVMappingSequence },
        { "TextureLabel", DC::TextureLabel },
        { "UValueData", DC::UValueData },
        { "VValueData", DC::VValueData },
        { "ReferencedTextureSequence", DC::ReferencedTextureSequence },
        { "ReferencedSurfaceDataSequence", DC::ReferencedSurfaceDataSequence },
        { "AssessmentSummary", DC::AssessmentSummary },
        { "AssessmentSummaryDescription", DC::AssessmentSummaryDescription },
        { "AssessedSOPInstanceSequence", DC::AssessedSOPInstanceSequence },
        { "ReferencedComparisonSOPInstanceSequence", DC::ReferencedComparisonSOPInstanceSequence },
        { "NumberOfAssessmentObservations", DC::NumberOfAssessmentObservations },
        { "AssessmentObservationsSequence", DC::AssessmentObservationsSequence },
        { "ObservationSignificance", DC::ObservationSignificance },
        { "ObservationDescription", DC::ObservationDescription },
        { "StructuredConstraintObservationSequence", DC::StructuredConstraintObservationSequence },
        { "AssessedAttributeValueSequence", DC::AssessedAttributeValueSequence },
        { "AssessmentSetID", DC::AssessmentSetID },
        { "AssessmentRequesterSequence", DC::AssessmentRequesterSequence },
        { "SelectorAttributeName", DC::SelectorAttributeName },
        { "SelectorAttributeKeyword", DC::SelectorAttributeKeyword },
        { "AssessmentTypeCodeSequence", DC::AssessmentTypeCodeSequence },
        { "ObservationBasisCodeSequence", DC::ObservationBasisCodeSequence },
        { "AssessmentLabel", DC::AssessmentLabel },
        { "ConstraintType", DC::ConstraintType },
        { "SpecificationSelectionGuidance", DC::SpecificationSelectionGuidance },
        { "ConstraintValueSequence", DC::ConstraintValueSequence },
        { "RecommendedDefaultValueSequence", DC::RecommendedDefaultValueSequence },
        { "ConstraintViolationSignificance", DC::ConstraintViolationSignificance },
        { "ConstraintViolationCondition", DC::ConstraintViolationCondition },
        { "ModifiableConstraintFlag", DC::ModifiableConstraintFlag },
        { "StorageMediaFileSetID", DC::StorageMediaFileSetID },
        { "StorageMediaFileSetUID", DC::StorageMediaFileSetUID },
        { "IconImageSequence", DC::IconImageSequence },
        { "TopicTitle", DC::TopicTitle },
        { "TopicSubject", DC::TopicSubject },
        { "TopicAuthor", DC::TopicAuthor },
        { "TopicKeywords", DC::TopicKeywords },
        { "SOPInstanceStatus", DC::SOPInstanceStatus },
        { "SOPAuthorizationDateTime", DC::SOPAuthorizationDateTime },
        { "SOPAuthorizationComment", DC::SOPAuthorizationComment },
        { "AuthorizationEquipmentCertificationNumber", DC::AuthorizationEquipmentCertificationNumber },
        { "MACIDNumber", DC::MACIDNumber },
        { "MACCalculationTransferSyntaxUID", DC::MACCalculationTransferSyntaxUID },
        { "MACAlgorithm", DC::MACAlgorithm },
        { "DataElementsSigned", DC::DataElementsSigned },
        { "DigitalSignatureUID", DC::DigitalSignatureUID },
        { "DigitalSignatureDateTime", DC::DigitalSignatureDateTime },
        { "CertificateType", DC::CertificateType },
        { "CertificateOfSigner", DC::CertificateOfSigner },
        { "Signature", DC::Signature },
        { "CertifiedTimestampType", DC::CertifiedTimestampType },
        { "CertifiedTimestamp", DC::CertifiedTimestamp },
        { "DigitalSignaturePurposeCodeSequence", DC::DigitalSignaturePurposeCodeSequence },
        { "ReferencedDigitalSignatureSequence", DC::ReferencedDigitalSignatureSequence },
        { "ReferencedSOPInstanceMACSequence", DC::ReferencedSOPInstanceMACSequence },
        { "MAC", DC::MAC },
        { "EncryptedAttributesSequence", DC::EncryptedAttributesSequence },
        { "EncryptedContentTransferSyntaxUID", DC::EncryptedContentTransferSyntaxUID },
        { "EncryptedContent", DC::EncryptedContent },
        { "ModifiedAttributesSequence", DC::ModifiedAttributesSequence },
        { "NonconformingModifiedAttributesSequence", DC::NonconformingModifiedAttributesSequence },
        { "NonconformingDataElementValue", DC::NonconformingDataElementValue },
        { "OriginalAttributesSequence", DC::OriginalAttributesSequence },
        { "AttributeModificationDateTime", DC::AttributeModificationDateTime },
        { "ModifyingSystem", DC::ModifyingSystem },
        { "SourceOfPreviousValues", DC::SourceOfPreviousValues },
        { "ReasonForTheAttributeModification", DC::ReasonForTheAttributeModification },
        { "InstanceOriginStatus", DC::InstanceOriginStatus },
        { "EscapeTriplet", DC::EscapeTriplet },
        { "RunLengthTriplet", DC::RunLengthTriplet },
        { "HuffmanTableSize", DC::HuffmanTableSize },
        { "HuffmanTableTriplet", DC::HuffmanTableTriplet },
        { "ShiftTableSize", DC::ShiftTableSize },
        { "ShiftTableTriplet", DC::ShiftTableTriplet },
        { "ZonalMap", DC::ZonalMap },
        { "NumberOfCopies", DC::NumberOfCopies },
        { "PrinterConfigurationSequence", DC::PrinterConfigurationSequence },
        { "PrintPriority", DC::PrintPriority },
        { "MediumType", DC::MediumType },
        { "FilmDestination", DC::FilmDestination },
        { "FilmSessionLabel", DC::FilmSessionLabel },
        { "MemoryAllocation", DC::MemoryAllocation },
        { "MaximumMemoryAllocation", DC::MaximumMemoryAllocation },
        { "ColorImagePrintingFlag", DC::ColorImagePrintingFlag },
        { "CollationFlag", DC::CollationFlag },
        { "AnnotationFlag", DC::AnnotationFlag },
        { "ImageOverlayFlag", DC::ImageOverlayFlag },
        { "PresentationLUTFlag", DC::PresentationLUTFlag },
        { "ImageBoxPresentationLUTFlag", DC::ImageBoxPresentationLUTFlag },
        { "MemoryBitDepth", DC::MemoryBitDepth },
        { "PrintingBitDepth", DC::PrintingBitDepth },
        { "MediaInstalledSequence", DC::MediaInstalledSequence },
        { "OtherMediaAvailableSequence", DC::OtherMediaAvailableSequence },
        { "SupportedImageDisplayFormatsSequence", DC::SupportedImageDisplayFormatsSequence },
        { "ReferencedFilmBoxSequence", DC::ReferencedFilmBoxSequence },
        { "ReferencedStoredPrintSequence", DC::ReferencedStoredPrintSequence },
        { "ImageDisplayFormat", DC::ImageDisplayFormat },
        { "AnnotationDisplayFormatID", DC::AnnotationDisplayFormatID },
        { "FilmOrientation", DC::FilmOrientation },
        { "FilmSizeID", DC::FilmSizeID },
        { "PrinterResolutionID", DC::PrinterResolutionID },
        { "DefaultPrinterResolutionID", DC::DefaultPrinterResolutionID },
        { "MagnificationType", DC::MagnificationType },
        { "SmoothingType", DC::SmoothingType },
        { "DefaultMagnificationType", DC::DefaultMagnificationType },
        { "OtherMagnificationTypesAvailable", DC::OtherMagnificationTypesAvailable },
        { "DefaultSmoothingType", DC::DefaultSmoothingType },
        { "OtherSmoothingTypesAvailable", DC::OtherSmoothingTypesAvailable },
        { "BorderDensity", DC::BorderDensity },
        { "EmptyImageDensity", DC::EmptyImageDensity },
        { "MinDensity", DC::MinDensity },
        { "MaxDensity", DC::MaxDensity },
        { "Trim", DC::Trim },
        { "ConfigurationInformation", DC::ConfigurationInformation },
        { "ConfigurationInformationDescription", DC::ConfigurationInformationDescription },
        { "MaximumCollatedFilms", DC::MaximumCollatedFilms },
        { "Illumination", DC::Illumination },
        { "ReflectedAmbientLight", DC::ReflectedAmbientLight },
        { "PrinterPixelSpacing", DC::PrinterPixelSpacing },
        { "ReferencedFilmSessionSequence", DC::ReferencedFilmSessionSequence },
        { "ReferencedImageBoxSequence", DC::ReferencedImageBoxSequence },
        { "ReferencedBasicAnnotationBoxSequence", DC::ReferencedBasicAnnotationBoxSequence },
        { "ImageBoxPosition", DC::ImageBoxPosition },
        { "Polarity", DC::Polarity },
        { "RequestedImageSize", DC::RequestedImageSize },
        { "RequestedDecimateCropBehavior", DC::RequestedDecimateCropBehavior },
        { "RequestedResolutionID", DC::RequestedResolutionID },
        { "RequestedImageSizeFlag", DC::RequestedImageSizeFlag },
        { "DecimateCropResult", DC::DecimateCropResult },
        { "BasicGrayscaleImageSequence", DC::BasicGrayscaleImageSequence },
        { "BasicColorImageSequence", DC::BasicColorImageSequence },
        { "ReferencedImageOverlayBoxSequence", DC::ReferencedImageOverlayBoxSequence },
        { "ReferencedVOILUTBoxSequence", DC::ReferencedVOILUTBoxSequence },
        { "AnnotationPosition", DC::AnnotationPosition },
        { "TextString", DC::TextString },
        { "ReferencedOverlayPlaneSequence", DC::ReferencedOverlayPlaneSequence },
        { "ReferencedOverlayPlaneGroups", DC::ReferencedOverlayPlaneGroups },
        { "OverlayPixelDataSequence", DC::OverlayPixelDataSequence },
        { "OverlayMagnificationType", DC::OverlayMagnificationType },
        { "OverlaySmoothingType", DC::OverlaySmoothingType },
        { "OverlayOrImageMagnification", DC::OverlayOrImageMagnification },
        { "MagnifyToNumberOfColumns", DC::MagnifyToNumberOfColumns },
        { "OverlayForegroundDensity", DC::OverlayForegroundDensity },
        { "OverlayBackgroundDensity", DC::OverlayBackgroundDensity },
        { "OverlayMode", DC::OverlayMode },
        { "ThresholdDensity", DC::ThresholdDensity },
        { "ReferencedImageBoxSequenceRetired", DC::ReferencedImageBoxSequenceRetired },
        { "PresentationLUTSequence", DC::PresentationLUTSequence },
        { "PresentationLUTShape", DC::PresentationLUTShape },
        { "ReferencedPresentationLUTSequence", DC::ReferencedPresentationLUTSequence },
        { "PrintJobID", DC::PrintJobID },
        { "ExecutionStatus", DC::ExecutionStatus },
        { "ExecutionStatusInfo", DC::ExecutionStatusInfo },
        { "CreationDate", DC::CreationDate },
        { "CreationTime", DC::CreationTime },
        { "Originator", DC::Originator },
        { "DestinationAE", DC::DestinationAE },
        { "OwnerID", DC::OwnerID },
        { "NumberOfFilms", DC::NumberOfFilms },
        { "ReferencedPrintJobSequencePullStoredPrint", DC::ReferencedPrintJobSequencePullStoredPrint },
        { "PrinterStatus", DC::PrinterStatus },
        { "PrinterStatusInfo", DC::PrinterStatusInfo },
        { "PrinterName", DC::PrinterName },
        { "PrintQueueID", DC::PrintQueueID },
        { "QueueStatus", DC::QueueStatus },
        { "PrintJobDescriptionSequence", DC::PrintJobDescriptionSequence },
        { "ReferencedPrintJobSequence", DC::ReferencedPrintJobSequence },
        { "PrintManagementCapabilitiesSequence", DC::PrintManagementCapabilitiesSequence },
        { "PrinterCharacteristicsSequence", DC::PrinterCharacteristicsSequence },
        { "FilmBoxContentSequence", DC::FilmBoxContentSequence },
        { "ImageBoxContentSequence", DC::ImageBoxContentSequence },
        { "AnnotationContentSequence", DC::AnnotationContentSequence },
        { "ImageOverlayBoxContentSequence", DC::ImageOverlayBoxContentSequence },
        { "PresentationLUTContentSequence", DC::PresentationLUTContentSequence },
        { "ProposedStudySequence", DC::ProposedStudySequence },
        { "OriginalImageSequence", DC::OriginalImageSequence },
        { "LabelUsingInformationExtractedFromInstances", DC::LabelUsingInformationExtractedFromInstances },
        { "LabelText", DC::LabelText },
        { "LabelStyleSelection", DC::LabelStyleSelection },
        { "MediaDisposition", DC::MediaDisposition },
        { "BarcodeValue", DC::BarcodeValue },
        { "BarcodeSymbology", DC::BarcodeSymbology },
        { "AllowMediaSplitting", DC::AllowMediaSplitting },
        { "IncludeNonDICOMObjects", DC::IncludeNonDICOMObjects },
        { "IncludeDisplayApplication", DC::IncludeDisplayApplication },
        { "PreserveCompositeInstancesAfterMediaCreation", DC::PreserveCompositeInstancesAfterMediaCreation },
        { "TotalNumberOfPiecesOfMediaCreated", DC::TotalNumberOfPiecesOfMediaCreated },
        { "RequestedMediaApplicationProfile", DC::RequestedMediaApplicationProfile },
        { "ReferencedStorageMediaSequence", DC::ReferencedStorageMediaSequence },
        { "FailureAttributes", DC::FailureAttributes },
        { "AllowLossyCompression", DC::AllowLossyCompression },
        { "RequestPriority", DC::RequestPriority },
        { "RTImageLabel", DC::RTImageLabel },
        { "RTImageName", DC::RTImageName },
        { "RTImageDescription", DC::RTImageDescription },
        { "ReportedValuesOrigin", DC::ReportedValuesOrigin },
        { "RTImagePlane", DC::RTImagePlane },
        { "XRayImageReceptorTranslation", DC::XRayImageReceptorTranslation },
        { "XRayImageReceptorAngle", DC::XRayImageReceptorAngle },
        { "RTImageOrientation", DC::RTImageOrientation },
        { "ImagePlanePixelSpacing", DC::ImagePlanePixelSpacing },
        { "RTImagePosition", DC::RTImagePosition },
        { "RadiationMachineName", DC::RadiationMachineName },
        { "RadiationMachineSAD", DC::RadiationMachineSAD },
        { "RadiationMachineSSD", DC::RadiationMachineSSD },
        { "RTImageSID", DC::RTImageSID },
        { "SourceToReferenceObjectDistance", DC::SourceToReferenceObjectDistance },
        { "FractionNumber", DC::FractionNumber },
        { "ExposureSequence", DC::ExposureSequence },
        { "MetersetExposure", DC::MetersetExposure },
        { "DiaphragmPosition", DC::DiaphragmPosition },
        { "FluenceMapSequence", DC::FluenceMapSequence },
        { "FluenceDataSource", DC::FluenceDataSource },
        { "FluenceDataScale", DC::FluenceDataScale },
        { "PrimaryFluenceModeSequence", DC::PrimaryFluenceModeSequence },
        { "FluenceMode", DC::FluenceMode },
        { "FluenceModeID", DC::FluenceModeID },
        { "SelectedFrameNumber", DC::SelectedFrameNumber },
        { "SelectedFrameFunctionalGroupsSequence", DC::SelectedFrameFunctionalGroupsSequence },
        { "RTImageFrameGeneralContentSequence", DC::RTImageFrameGeneralContentSequence },
        { "RTImageFrameContextSequence", DC::RTImageFrameContextSequence },
        { "RTImageScopeSequence", DC::RTImageScopeSequence },
        { "BeamModifierCoordinatesPresenceFlag", DC::BeamModifierCoordinatesPresenceFlag },
        { "StartCumulativeMeterset", DC::StartCumulativeMeterset },
        { "StopCumulativeMeterset", DC::StopCumulativeMeterset },
        { "RTAcquisitionPatientPositionSequence", DC::RTAcquisitionPatientPositionSequence },
        { "RTImageFrameImagingDevicePositionSequence", DC::RTImageFrameImagingDevicePositionSequence },
        { "RTImageFramekVRadiationAcquisitionSequence", DC::RTImageFramekVRadiationAcquisitionSequence },
        { "RTImageFrameMVRadiationAcquisitionSequence", DC::RTImageFrameMVRadiationAcquisitionSequence },
        { "RTImageFrameRadiationAcquisitionSequence", DC::RTImageFrameRadiationAcquisitionSequence },
        { "ImagingSourcePositionSequence", DC::ImagingSourcePositionSequence },
        { "ImageReceptorPositionSequence", DC::ImageReceptorPositionSequence },
        { "DevicePositionToEquipmentMappingMatrix", DC::DevicePositionToEquipmentMappingMatrix },
        { "DevicePositionParameterSequence", DC::DevicePositionParameterSequence },
        { "ImagingSourceLocationSpecificationType", DC::ImagingSourceLocationSpecificationType },
        { "ImagingDeviceLocationMatrixSequence", DC::ImagingDeviceLocationMatrixSequence },
        { "ImagingDeviceLocationParameterSequence", DC::ImagingDeviceLocationParameterSequence },
        { "ImagingApertureSequence", DC::ImagingApertureSequence },
        { "ImagingApertureSpecificationType", DC::ImagingApertureSpecificationType },
        { "NumberOfAcquisitionDevices", DC::NumberOfAcquisitionDevices },
        { "AcquisitionDeviceSequence", DC::AcquisitionDeviceSequence },
        { "AcquisitionTaskSequence", DC::AcquisitionTaskSequence },
        { "AcquisitionTaskWorkitemCodeSequence", DC::AcquisitionTaskWorkitemCodeSequence },
        { "AcquisitionSubtaskSequence", DC::AcquisitionSubtaskSequence },
        { "SubtaskWorkitemCodeSequence", DC::SubtaskWorkitemCodeSequence },
        { "AcquisitionTaskIndex", DC::AcquisitionTaskIndex },
        { "AcquisitionSubtaskIndex", DC::AcquisitionSubtaskIndex },
        { "ReferencedBaselineParametersRTRadiationInstanceSequence", DC::ReferencedBaselineParametersRTRadiationInstanceSequence },
        { "PositionAcquisitionTemplateIdentificationSequence", DC::PositionAcquisitionTemplateIdentificationSequence },
        { "PositionAcquisitionTemplateID", DC::PositionAcquisitionTemplateID },
        { "PositionAcquisitionTemplateName", DC::PositionAcquisitionTemplateName },
        { "PositionAcquisitionTemplateCodeSequence", DC::PositionAcquisitionTemplateCodeSequence },
        { "PositionAcquisitionTemplateDescription", DC::PositionAcquisitionTemplateDescription },
        { "AcquisitionTaskApplicabilitySequence", DC::AcquisitionTaskApplicabilitySequence },
        { "ProjectionImagingAcquisitionParameterSequence", DC::ProjectionImagingAcquisitionParameterSequence },
        { "CTImagingAcquisitionParameterSequence", DC::CTImagingAcquisitionParameterSequence },
        { "KVImagingGenerationParametersSequence", DC::KVImagingGenerationParametersSequence },
        { "MVImagingGenerationParametersSequence", DC::MVImagingGenerationParametersSequence },
        { "AcquisitionSignalType", DC::AcquisitionSignalType },
        { "AcquisitionMethod", DC::AcquisitionMethod },
        { "ScanStartPositionSequence", DC::ScanStartPositionSequence },
        { "ScanStopPositionSequence", DC::ScanStopPositionSequence },
        { "ImagingSourceToBeamModifierDefinitionPlaneDistance", DC::ImagingSourceToBeamModifierDefinitionPlaneDistance },
        { "ScanArcType", DC::ScanArcType },
        { "DetectorPositioningType", DC::DetectorPositioningType },
        { "AdditionalRTAccessoryDeviceSequence", DC::AdditionalRTAccessoryDeviceSequence },
        { "DeviceSpecificAcquisitionParameterSequence", DC::DeviceSpecificAcquisitionParameterSequence },
        { "ReferencedPositionReferenceInstanceSequence", DC::ReferencedPositionReferenceInstanceSequence },
        { "EnergyDerivationCodeSequence", DC::EnergyDerivationCodeSequence },
        { "MaximumCumulativeMetersetExposure", DC::MaximumCumulativeMetersetExposure },
        { "AcquisitionInitiationSequence", DC::AcquisitionInitiationSequence },
        { "DVHType", DC::DVHType },
        { "DoseUnits", DC::DoseUnits },
        { "DoseType", DC::DoseType },
        { "SpatialTransformOfDose", DC::SpatialTransformOfDose },
        { "DoseComment", DC::DoseComment },
        { "NormalizationPoint", DC::NormalizationPoint },
        { "DoseSummationType", DC::DoseSummationType },
        { "GridFrameOffsetVector", DC::GridFrameOffsetVector },
        { "DoseGridScaling", DC::DoseGridScaling },
        { "RTDoseROISequence", DC::RTDoseROISequence },
        { "DoseValue", DC::DoseValue },
        { "TissueHeterogeneityCorrection", DC::TissueHeterogeneityCorrection },
        { "DVHNormalizationPoint", DC::DVHNormalizationPoint },
        { "DVHNormalizationDoseValue", DC::DVHNormalizationDoseValue },
        { "DVHSequence", DC::DVHSequence },
        { "DVHDoseScaling", DC::DVHDoseScaling },
        { "DVHVolumeUnits", DC::DVHVolumeUnits },
        { "DVHNumberOfBins", DC::DVHNumberOfBins },
        { "DVHData", DC::DVHData },
        { "DVHReferencedROISequence", DC::DVHReferencedROISequence },
        { "DVHROIContributionType", DC::DVHROIContributionType },
        { "DVHMinimumDose", DC::DVHMinimumDose },
        { "DVHMaximumDose", DC::DVHMaximumDose },
        { "DVHMeanDose", DC::DVHMeanDose },
        { "StructureSetLabel", DC::StructureSetLabel },
        { "StructureSetName", DC::StructureSetName },
        { "StructureSetDescription", DC::StructureSetDescription },
        { "StructureSetDate", DC::StructureSetDate },
        { "StructureSetTime", DC::StructureSetTime },
        { "ReferencedFrameOfReferenceSequence", DC::ReferencedFrameOfReferenceSequence },
        { "RTReferencedStudySequence", DC::RTReferencedStudySequence },
        { "RTReferencedSeriesSequence", DC::RTReferencedSeriesSequence },
        { "ContourImageSequence", DC::ContourImageSequence },
        { "PredecessorStructureSetSequence", DC::PredecessorStructureSetSequence },
        { "StructureSetROISequence", DC::StructureSetROISequence },
        { "ROINumber", DC::ROINumber },
        { "ReferencedFrameOfReferenceUID", DC::ReferencedFrameOfReferenceUID },
        { "ROIName", DC::ROIName },
        { "ROIDescription", DC::ROIDescription },
        { "ROIDisplayColor", DC::ROIDisplayColor },
        { "ROIVolume", DC::ROIVolume },
        { "RTRelatedROISequence", DC::RTRelatedROISequence },
        { "RTROIRelationship", DC::RTROIRelationship },
        { "ROIGenerationAlgorithm", DC::ROIGenerationAlgorithm },
        { "ROIDerivationAlgorithmIdentificationSequence", DC::ROIDerivationAlgorithmIdentificationSequence },
        { "ROIGenerationDescription", DC::ROIGenerationDescription },
        { "ROIContourSequence", DC::ROIContourSequence },
        { "ContourSequence", DC::ContourSequence },
        { "ContourGeometricType", DC::ContourGeometricType },
        { "ContourSlabThickness", DC::ContourSlabThickness },
        { "ContourOffsetVector", DC::ContourOffsetVector },
        { "NumberOfContourPoints", DC::NumberOfContourPoints },
        { "ContourNumber", DC::ContourNumber },
        { "AttachedContours", DC::AttachedContours },
        { "SourcePixelPlanesCharacteristicsSequence", DC::SourcePixelPlanesCharacteristicsSequence },
        { "ContourData", DC::ContourData },
        { "RTROIObservationsSequence", DC::RTROIObservationsSequence },
        { "ObservationNumber", DC::ObservationNumber },
        { "ReferencedROINumber", DC::ReferencedROINumber },
        { "ROIObservationLabel", DC::ROIObservationLabel },
        { "RTROIIdentificationCodeSequence", DC::RTROIIdentificationCodeSequence },
        { "ROIObservationDescription", DC::ROIObservationDescription },
        { "RelatedRTROIObservationsSequence", DC::RelatedRTROIObservationsSequence },
        { "RTROIInterpretedType", DC::RTROIInterpretedType },
        { "ROIInterpreter", DC::ROIInterpreter },
        { "ROIPhysicalPropertiesSequence", DC::ROIPhysicalPropertiesSequence },
        { "ROIPhysicalProperty", DC::ROIPhysicalProperty },
        { "ROIPhysicalPropertyValue", DC::ROIPhysicalPropertyValue },
        { "ROIElementalCompositionSequence", DC::ROIElementalCompositionSequence },
        { "ROIElementalCompositionAtomicNumber", DC::ROIElementalCompositionAtomicNumber },
        { "ROIElementalCompositionAtomicMassFraction", DC::ROIElementalCompositionAtomicMassFraction },
        { "AdditionalRTROIIdentificationCodeSequence", DC::AdditionalRTROIIdentificationCodeSequence },
        { "FrameOfReferenceRelationshipSequence", DC::FrameOfReferenceRelationshipSequence },
        { "RelatedFrameOfReferenceUID", DC::RelatedFrameOfReferenceUID },
        { "FrameOfReferenceTransformationType", DC::FrameOfReferenceTransformationType },
        { "FrameOfReferenceTransformationMatrix", DC::FrameOfReferenceTransformationMatrix },
        { "FrameOfReferenceTransformationComment", DC::FrameOfReferenceTransformationComment },
        { "PatientLocationCoordinatesSequence", DC::PatientLocationCoordinatesSequence },
        { "PatientLocationCoordinatesCodeSequence", DC::PatientLocationCoordinatesCodeSequence },
        { "PatientSupportPositionSequence", DC::PatientSupportPositionSequence },
        { "MeasuredDoseReferenceSequence", DC::MeasuredDoseReferenceSequence },
        { "MeasuredDoseDescription", DC::MeasuredDoseDescription },
        { "MeasuredDoseType", DC::MeasuredDoseType },
        { "MeasuredDoseValue", DC::MeasuredDoseValue },
        { "TreatmentSessionBeamSequence", DC::TreatmentSessionBeamSequence },
        { "TreatmentSessionIonBeamSequence", DC::TreatmentSessionIonBeamSequence },
        { "CurrentFractionNumber", DC::CurrentFractionNumber },
        { "TreatmentControlPointDate", DC::TreatmentControlPointDate },
        { "TreatmentControlPointTime", DC::TreatmentControlPointTime },
        { "TreatmentTerminationStatus", DC::TreatmentTerminationStatus },
        { "TreatmentTerminationCode", DC::TreatmentTerminationCode },
        { "TreatmentVerificationStatus", DC::TreatmentVerificationStatus },
        { "ReferencedTreatmentRecordSequence", DC::ReferencedTreatmentRecordSequence },
        { "SpecifiedPrimaryMeterset", DC::SpecifiedPrimaryMeterset },
        { "SpecifiedSecondaryMeterset", DC::SpecifiedSecondaryMeterset },
        { "DeliveredPrimaryMeterset", DC::DeliveredPrimaryMeterset },
        { "DeliveredSecondaryMeterset", DC::DeliveredSecondaryMeterset },
        { "SpecifiedTreatmentTime", DC::SpecifiedTreatmentTime },
        { "DeliveredTreatmentTime", DC::DeliveredTreatmentTime },
        { "ControlPointDeliverySequence", DC::ControlPointDeliverySequence },
        { "IonControlPointDeliverySequence", DC::IonControlPointDeliverySequence },
        { "SpecifiedMeterset", DC::SpecifiedMeterset },
        { "DeliveredMeterset", DC::DeliveredMeterset },
        { "MetersetRateSet", DC::MetersetRateSet },
        { "MetersetRateDelivered", DC::MetersetRateDelivered },
        { "ScanSpotMetersetsDelivered", DC::ScanSpotMetersetsDelivered },
        { "DoseRateDelivered", DC::DoseRateDelivered },
        { "TreatmentSummaryCalculatedDoseReferenceSequence", DC::TreatmentSummaryCalculatedDoseReferenceSequence },
        { "CumulativeDoseToDoseReference", DC::CumulativeDoseToDoseReference },
        { "FirstTreatmentDate", DC::FirstTreatmentDate },
        { "MostRecentTreatmentDate", DC::MostRecentTreatmentDate },
        { "NumberOfFractionsDelivered", DC::NumberOfFractionsDelivered },
        { "OverrideSequence", DC::OverrideSequence },
        { "ParameterSequencePointer", DC::ParameterSequencePointer },
        { "OverrideParameterPointer", DC::OverrideParameterPointer },
        { "ParameterItemIndex", DC::ParameterItemIndex },
        { "MeasuredDoseReferenceNumber", DC::MeasuredDoseReferenceNumber },
        { "ParameterPointer", DC::ParameterPointer },
        { "OverrideReason", DC::OverrideReason },
        { "ParameterValueNumber", DC::ParameterValueNumber },
        { "CorrectedParameterSequence", DC::CorrectedParameterSequence },
        { "CorrectionValue", DC::CorrectionValue },
        { "CalculatedDoseReferenceSequence", DC::CalculatedDoseReferenceSequence },
        { "CalculatedDoseReferenceNumber", DC::CalculatedDoseReferenceNumber },
        { "CalculatedDoseReferenceDescription", DC::CalculatedDoseReferenceDescription },
        { "CalculatedDoseReferenceDoseValue", DC::CalculatedDoseReferenceDoseValue },
        { "StartMeterset", DC::StartMeterset },
        { "EndMeterset", DC::EndMeterset },
        { "ReferencedMeasuredDoseReferenceSequence", DC::ReferencedMeasuredDoseReferenceSequence },
        { "ReferencedMeasuredDoseReferenceNumber", DC::ReferencedMeasuredDoseReferenceNumber },
        { "ReferencedCalculatedDoseReferenceSequence", DC::ReferencedCalculatedDoseReferenceSequence },
        { "ReferencedCalculatedDoseReferenceNumber", DC::ReferencedCalculatedDoseReferenceNumber },
        { "BeamLimitingDeviceLeafPairsSequence", DC::BeamLimitingDeviceLeafPairsSequence },
        { "EnhancedRTBeamLimitingDeviceSequence", DC::EnhancedRTBeamLimitingDeviceSequence },
        { "EnhancedRTBeamLimitingOpeningSequence", DC::EnhancedRTBeamLimitingOpeningSequence },
        { "EnhancedRTBeamLimitingDeviceDefinitionFlag", DC::EnhancedRTBeamLimitingDeviceDefinitionFlag },
        { "ParallelRTBeamDelimiterOpeningExtents", DC::ParallelRTBeamDelimiterOpeningExtents },
        { "RecordedWedgeSequence", DC::RecordedWedgeSequence },
        { "RecordedCompensatorSequence", DC::RecordedCompensatorSequence },
        { "RecordedBlockSequence", DC::RecordedBlockSequence },
        { "RecordedBlockSlabSequence", DC::RecordedBlockSlabSequence },
        { "TreatmentSummaryMeasuredDoseReferenceSequence", DC::TreatmentSummaryMeasuredDoseReferenceSequence },
        { "RecordedSnoutSequence", DC::RecordedSnoutSequence },
        { "RecordedRangeShifterSequence", DC::RecordedRangeShifterSequence },
        { "RecordedLateralSpreadingDeviceSequence", DC::RecordedLateralSpreadingDeviceSequence },
        { "RecordedRangeModulatorSequence", DC::RecordedRangeModulatorSequence },
        { "RecordedSourceSequence", DC::RecordedSourceSequence },
        { "SourceSerialNumber", DC::SourceSerialNumber },
        { "TreatmentSessionApplicationSetupSequence", DC::TreatmentSessionApplicationSetupSequence },
        { "ApplicationSetupCheck", DC::ApplicationSetupCheck },
        { "RecordedBrachyAccessoryDeviceSequence", DC::RecordedBrachyAccessoryDeviceSequence },
        { "ReferencedBrachyAccessoryDeviceNumber", DC::ReferencedBrachyAccessoryDeviceNumber },
        { "RecordedChannelSequence", DC::RecordedChannelSequence },
        { "SpecifiedChannelTotalTime", DC::SpecifiedChannelTotalTime },
        { "DeliveredChannelTotalTime", DC::DeliveredChannelTotalTime },
        { "SpecifiedNumberOfPulses", DC::SpecifiedNumberOfPulses },
        { "DeliveredNumberOfPulses", DC::DeliveredNumberOfPulses },
        { "SpecifiedPulseRepetitionInterval", DC::SpecifiedPulseRepetitionInterval },
        { "DeliveredPulseRepetitionInterval", DC::DeliveredPulseRepetitionInterval },
        { "RecordedSourceApplicatorSequence", DC::RecordedSourceApplicatorSequence },
        { "ReferencedSourceApplicatorNumber", DC::ReferencedSourceApplicatorNumber },
        { "RecordedChannelShieldSequence", DC::RecordedChannelShieldSequence },
        { "ReferencedChannelShieldNumber", DC::ReferencedChannelShieldNumber },
        { "BrachyControlPointDeliveredSequence", DC::BrachyControlPointDeliveredSequence },
        { "SafePositionExitDate", DC::SafePositionExitDate },
        { "SafePositionExitTime", DC::SafePositionExitTime },
        { "SafePositionReturnDate", DC::SafePositionReturnDate },
        { "SafePositionReturnTime", DC::SafePositionReturnTime },
        { "PulseSpecificBrachyControlPointDeliveredSequence", DC::PulseSpecificBrachyControlPointDeliveredSequence },
        { "PulseNumber", DC::PulseNumber },
        { "BrachyPulseControlPointDeliveredSequence", DC::BrachyPulseControlPointDeliveredSequence },
        { "CurrentTreatmentStatus", DC::CurrentTreatmentStatus },
        { "TreatmentStatusComment", DC::TreatmentStatusComment },
        { "FractionGroupSummarySequence", DC::FractionGroupSummarySequence },
        { "ReferencedFractionNumber", DC::ReferencedFractionNumber },
        { "FractionGroupType", DC::FractionGroupType },
        { "BeamStopperPosition", DC::BeamStopperPosition },
        { "FractionStatusSummarySequence", DC::FractionStatusSummarySequence },
        { "TreatmentDate", DC::TreatmentDate },
        { "TreatmentTime", DC::TreatmentTime },
        { "RTPlanLabel", DC::RTPlanLabel },
        { "RTPlanName", DC::RTPlanName },
        { "RTPlanDescription", DC::RTPlanDescription },
        { "RTPlanDate", DC::RTPlanDate },
        { "RTPlanTime", DC::RTPlanTime },
        { "TreatmentProtocols", DC::TreatmentProtocols },
        { "PlanIntent", DC::PlanIntent },
        { "TreatmentSites", DC::TreatmentSites },
        { "RTPlanGeometry", DC::RTPlanGeometry },
        { "PrescriptionDescription", DC::PrescriptionDescription },
        { "DoseReferenceSequence", DC::DoseReferenceSequence },
        { "DoseReferenceNumber", DC::DoseReferenceNumber },
        { "DoseReferenceUID", DC::DoseReferenceUID },
        { "DoseReferenceStructureType", DC::DoseReferenceStructureType },
        { "NominalBeamEnergyUnit", DC::NominalBeamEnergyUnit },
        { "DoseReferenceDescription", DC::DoseReferenceDescription },
        { "DoseReferencePointCoordinates", DC::DoseReferencePointCoordinates },
        { "NominalPriorDose", DC::NominalPriorDose },
        { "DoseReferenceType", DC::DoseReferenceType },
        { "ConstraintWeight", DC::ConstraintWeight },
        { "DeliveryWarningDose", DC::DeliveryWarningDose },
        { "DeliveryMaximumDose", DC::DeliveryMaximumDose },
        { "TargetMinimumDose", DC::TargetMinimumDose },
        { "TargetPrescriptionDose", DC::TargetPrescriptionDose },
        { "TargetMaximumDose", DC::TargetMaximumDose },
        { "TargetUnderdoseVolumeFraction", DC::TargetUnderdoseVolumeFraction },
        { "OrganAtRiskFullVolumeDose", DC::OrganAtRiskFullVolumeDose },
        { "OrganAtRiskLimitDose", DC::OrganAtRiskLimitDose },
        { "OrganAtRiskMaximumDose", DC::OrganAtRiskMaximumDose },
        { "OrganAtRiskOverdoseVolumeFraction", DC::OrganAtRiskOverdoseVolumeFraction },
        { "ToleranceTableSequence", DC::ToleranceTableSequence },
        { "ToleranceTableNumber", DC::ToleranceTableNumber },
        { "ToleranceTableLabel", DC::ToleranceTableLabel },
        { "GantryAngleTolerance", DC::GantryAngleTolerance },
        { "BeamLimitingDeviceAngleTolerance", DC::BeamLimitingDeviceAngleTolerance },
        { "BeamLimitingDeviceToleranceSequence", DC::BeamLimitingDeviceToleranceSequence },
        { "BeamLimitingDevicePositionTolerance", DC::BeamLimitingDevicePositionTolerance },
        { "SnoutPositionTolerance", DC::SnoutPositionTolerance },
        { "PatientSupportAngleTolerance", DC::PatientSupportAngleTolerance },
        { "TableTopEccentricAngleTolerance", DC::TableTopEccentricAngleTolerance },
        { "TableTopPitchAngleTolerance", DC::TableTopPitchAngleTolerance },
        { "TableTopRollAngleTolerance", DC::TableTopRollAngleTolerance },
        { "TableTopVerticalPositionTolerance", DC::TableTopVerticalPositionTolerance },
        { "TableTopLongitudinalPositionTolerance", DC::TableTopLongitudinalPositionTolerance },
        { "TableTopLateralPositionTolerance", DC::TableTopLateralPositionTolerance },
        { "RTPlanRelationship", DC::RTPlanRelationship },
        { "FractionGroupSequence", DC::FractionGroupSequence },
        { "FractionGroupNumber", DC::FractionGroupNumber },
        { "FractionGroupDescription", DC::FractionGroupDescription },
        { "NumberOfFractionsPlanned", DC::NumberOfFractionsPlanned },
        { "NumberOfFractionPatternDigitsPerDay", DC::NumberOfFractionPatternDigitsPerDay },
        { "RepeatFractionCycleLength", DC::RepeatFractionCycleLength },
        { "FractionPattern", DC::FractionPattern },
        { "NumberOfBeams", DC::NumberOfBeams },
        { "BeamDoseSpecificationPoint", DC::BeamDoseSpecificationPoint },
        { "ReferencedDoseReferenceUID", DC::ReferencedDoseReferenceUID },
        { "BeamDose", DC::BeamDose },
        { "BeamMeterset", DC::BeamMeterset },
        { "BeamDosePointDepth", DC::BeamDosePointDepth },
        { "BeamDosePointEquivalentDepth", DC::BeamDosePointEquivalentDepth },
        { "BeamDosePointSSD", DC::BeamDosePointSSD },
        { "BeamDoseMeaning", DC::BeamDoseMeaning },
        { "BeamDoseVerificationControlPointSequence", DC::BeamDoseVerificationControlPointSequence },
        { "AverageBeamDosePointDepth", DC::AverageBeamDosePointDepth },
        { "AverageBeamDosePointEquivalentDepth", DC::AverageBeamDosePointEquivalentDepth },
        { "AverageBeamDosePointSSD", DC::AverageBeamDosePointSSD },
        { "BeamDoseType", DC::BeamDoseType },
        { "AlternateBeamDose", DC::AlternateBeamDose },
        { "AlternateBeamDoseType", DC::AlternateBeamDoseType },
        { "DepthValueAveragingFlag", DC::DepthValueAveragingFlag },
        { "BeamDosePointSourceToExternalContourDistance", DC::BeamDosePointSourceToExternalContourDistance },
        { "NumberOfBrachyApplicationSetups", DC::NumberOfBrachyApplicationSetups },
        { "BrachyApplicationSetupDoseSpecificationPoint", DC::BrachyApplicationSetupDoseSpecificationPoint },
        { "BrachyApplicationSetupDose", DC::BrachyApplicationSetupDose },
        { "BeamSequence", DC::BeamSequence },
        { "TreatmentMachineName", DC::TreatmentMachineName },
        { "PrimaryDosimeterUnit", DC::PrimaryDosimeterUnit },
        { "SourceAxisDistance", DC::SourceAxisDistance },
        { "BeamLimitingDeviceSequence", DC::BeamLimitingDeviceSequence },
        { "RTBeamLimitingDeviceType", DC::RTBeamLimitingDeviceType },
        { "SourceToBeamLimitingDeviceDistance", DC::SourceToBeamLimitingDeviceDistance },
        { "IsocenterToBeamLimitingDeviceDistance", DC::IsocenterToBeamLimitingDeviceDistance },
        { "NumberOfLeafJawPairs", DC::NumberOfLeafJawPairs },
        { "LeafPositionBoundaries", DC::LeafPositionBoundaries },
        { "BeamNumber", DC::BeamNumber },
        { "BeamName", DC::BeamName },
        { "BeamDescription", DC::BeamDescription },
        { "BeamType", DC::BeamType },
        { "BeamDeliveryDurationLimit", DC::BeamDeliveryDurationLimit },
        { "RadiationType", DC::RadiationType },
        { "HighDoseTechniqueType", DC::HighDoseTechniqueType },
        { "ReferenceImageNumber", DC::ReferenceImageNumber },
        { "PlannedVerificationImageSequence", DC::PlannedVerificationImageSequence },
        { "ImagingDeviceSpecificAcquisitionParameters", DC::ImagingDeviceSpecificAcquisitionParameters },
        { "TreatmentDeliveryType", DC::TreatmentDeliveryType },
        { "NumberOfWedges", DC::NumberOfWedges },
        { "WedgeSequence", DC::WedgeSequence },
        { "WedgeNumber", DC::WedgeNumber },
        { "WedgeType", DC::WedgeType },
        { "WedgeID", DC::WedgeID },
        { "WedgeAngle", DC::WedgeAngle },
        { "WedgeFactor", DC::WedgeFactor },
        { "TotalWedgeTrayWaterEquivalentThickness", DC::TotalWedgeTrayWaterEquivalentThickness },
        { "WedgeOrientation", DC::WedgeOrientation },
        { "IsocenterToWedgeTrayDistance", DC::IsocenterToWedgeTrayDistance },
        { "SourceToWedgeTrayDistance", DC::SourceToWedgeTrayDistance },
        { "WedgeThinEdgePosition", DC::WedgeThinEdgePosition },
        { "BolusID", DC::BolusID },
        { "BolusDescription", DC::BolusDescription },
        { "EffectiveWedgeAngle", DC::EffectiveWedgeAngle },
        { "NumberOfCompensators", DC::NumberOfCompensators },
        { "MaterialID", DC::MaterialID },
        { "TotalCompensatorTrayFactor", DC::TotalCompensatorTrayFactor },
        { "CompensatorSequence", DC::CompensatorSequence },
        { "CompensatorNumber", DC::CompensatorNumber },
        { "CompensatorID", DC::CompensatorID },
        { "SourceToCompensatorTrayDistance", DC::SourceToCompensatorTrayDistance },
        { "CompensatorRows", DC::CompensatorRows },
        { "CompensatorColumns", DC::CompensatorColumns },
        { "CompensatorPixelSpacing", DC::CompensatorPixelSpacing },
        { "CompensatorPosition", DC::CompensatorPosition },
        { "CompensatorTransmissionData", DC::CompensatorTransmissionData },
        { "CompensatorThicknessData", DC::CompensatorThicknessData },
        { "NumberOfBoli", DC::NumberOfBoli },
        { "CompensatorType", DC::CompensatorType },
        { "CompensatorTrayID", DC::CompensatorTrayID },
        { "NumberOfBlocks", DC::NumberOfBlocks },
        { "TotalBlockTrayFactor", DC::TotalBlockTrayFactor },
        { "TotalBlockTrayWaterEquivalentThickness", DC::TotalBlockTrayWaterEquivalentThickness },
        { "BlockSequence", DC::BlockSequence },
        { "BlockTrayID", DC::BlockTrayID },
        { "SourceToBlockTrayDistance", DC::SourceToBlockTrayDistance },
        { "IsocenterToBlockTrayDistance", DC::IsocenterToBlockTrayDistance },
        { "BlockType", DC::BlockType },
        { "AccessoryCode", DC::AccessoryCode },
        { "BlockDivergence", DC::BlockDivergence },
        { "BlockMountingPosition", DC::BlockMountingPosition },
        { "BlockNumber", DC::BlockNumber },
        { "BlockName", DC::BlockName },
        { "BlockThickness", DC::BlockThickness },
        { "BlockTransmission", DC::BlockTransmission },
        { "BlockNumberOfPoints", DC::BlockNumberOfPoints },
        { "BlockData", DC::BlockData },
        { "ApplicatorSequence", DC::ApplicatorSequence },
        { "ApplicatorID", DC::ApplicatorID },
        { "ApplicatorType", DC::ApplicatorType },
        { "ApplicatorDescription", DC::ApplicatorDescription },
        { "CumulativeDoseReferenceCoefficient", DC::CumulativeDoseReferenceCoefficient },
        { "FinalCumulativeMetersetWeight", DC::FinalCumulativeMetersetWeight },
        { "NumberOfControlPoints", DC::NumberOfControlPoints },
        { "ControlPointSequence", DC::ControlPointSequence },
        { "ControlPointIndex", DC::ControlPointIndex },
        { "NominalBeamEnergy", DC::NominalBeamEnergy },
        { "DoseRateSet", DC::DoseRateSet },
        { "WedgePositionSequence", DC::WedgePositionSequence },
        { "WedgePosition", DC::WedgePosition },
        { "BeamLimitingDevicePositionSequence", DC::BeamLimitingDevicePositionSequence },
        { "LeafJawPositions", DC::LeafJawPositions },
        { "GantryAngle", DC::GantryAngle },
        { "GantryRotationDirection", DC::GantryRotationDirection },
        { "BeamLimitingDeviceAngle", DC::BeamLimitingDeviceAngle },
        { "BeamLimitingDeviceRotationDirection", DC::BeamLimitingDeviceRotationDirection },
        { "PatientSupportAngle", DC::PatientSupportAngle },
        { "PatientSupportRotationDirection", DC::PatientSupportRotationDirection },
        { "TableTopEccentricAxisDistance", DC::TableTopEccentricAxisDistance },
        { "TableTopEccentricAngle", DC::TableTopEccentricAngle },
        { "TableTopEccentricRotationDirection", DC::TableTopEccentricRotationDirection },
        { "TableTopVerticalPosition", DC::TableTopVerticalPosition },
        { "TableTopLongitudinalPosition", DC::TableTopLongitudinalPosition },
        { "TableTopLateralPosition", DC::TableTopLateralPosition },
        { "IsocenterPosition", DC::IsocenterPosition },
        { "SurfaceEntryPoint", DC::SurfaceEntryPoint },
        { "SourceToSurfaceDistance", DC::SourceToSurfaceDistance },
        { "AverageBeamDosePointSourceToExternalContourDistance", DC::AverageBeamDosePointSourceToExternalContourDistance },
        { "SourceToExternalContourDistance", DC::SourceToExternalContourDistance },
        { "ExternalContourEntryPoint", DC::ExternalContourEntryPoint },
        { "CumulativeMetersetWeight", DC::CumulativeMetersetWeight },
        { "TableTopPitchAngle", DC::TableTopPitchAngle },
        { "TableTopPitchRotationDirection", DC::TableTopPitchRotationDirection },
        { "TableTopRollAngle", DC::TableTopRollAngle },
        { "TableTopRollRotationDirection", DC::TableTopRollRotationDirection },
        { "HeadFixationAngle", DC::HeadFixationAngle },
        { "GantryPitchAngle", DC::GantryPitchAngle },
        { "GantryPitchRotationDirection", DC::GantryPitchRotationDirection },
        { "GantryPitchAngleTolerance", DC::GantryPitchAngleTolerance },
        { "FixationEye", DC::FixationEye },
        { "ChairHeadFramePosition", DC::ChairHeadFramePosition },
        { "HeadFixationAngleTolerance", DC::HeadFixationAngleTolerance },
        { "ChairHeadFramePositionTolerance", DC::ChairHeadFramePositionTolerance },
        { "FixationLightAzimuthalAngleTolerance", DC::FixationLightAzimuthalAngleTolerance },
        { "FixationLightPolarAngleTolerance", DC::FixationLightPolarAngleTolerance },
        { "PatientSetupSequence", DC::PatientSetupSequence },
        { "PatientSetupNumber", DC::PatientSetupNumber },
        { "PatientSetupLabel", DC::PatientSetupLabel },
        { "PatientAdditionalPosition", DC::PatientAdditionalPosition },
        { "FixationDeviceSequence", DC::FixationDeviceSequence },
        { "FixationDeviceType", DC::FixationDeviceType },
        { "FixationDeviceLabel", DC::FixationDeviceLabel },
        { "FixationDeviceDescription", DC::FixationDeviceDescription },
        { "FixationDevicePosition", DC::FixationDevicePosition },
        { "FixationDevicePitchAngle", DC::FixationDevicePitchAngle },
        { "FixationDeviceRollAngle", DC::FixationDeviceRollAngle },
        { "ShieldingDeviceSequence", DC::ShieldingDeviceSequence },
        { "ShieldingDeviceType", DC::ShieldingDeviceType },
        { "ShieldingDeviceLabel", DC::ShieldingDeviceLabel },
        { "ShieldingDeviceDescription", DC::ShieldingDeviceDescription },
        { "ShieldingDevicePosition", DC::ShieldingDevicePosition },
        { "SetupTechnique", DC::SetupTechnique },
        { "SetupTechniqueDescription", DC::SetupTechniqueDescription },
        { "SetupDeviceSequence", DC::SetupDeviceSequence },
        { "SetupDeviceType", DC::SetupDeviceType },
        { "SetupDeviceLabel", DC::SetupDeviceLabel },
        { "SetupDeviceDescription", DC::SetupDeviceDescription },
        { "SetupDeviceParameter", DC::SetupDeviceParameter },
        { "SetupReferenceDescription", DC::SetupReferenceDescription },
        { "TableTopVerticalSetupDisplacement", DC::TableTopVerticalSetupDisplacement },
        { "TableTopLongitudinalSetupDisplacement", DC::TableTopLongitudinalSetupDisplacement },
        { "TableTopLateralSetupDisplacement", DC::TableTopLateralSetupDisplacement },
        { "BrachyTreatmentTechnique", DC::BrachyTreatmentTechnique },
        { "BrachyTreatmentType", DC::BrachyTreatmentType },
        { "TreatmentMachineSequence", DC::TreatmentMachineSequence },
        { "SourceSequence", DC::SourceSequence },
        { "SourceNumber", DC::SourceNumber },
        { "SourceType", DC::SourceType },
        { "SourceManufacturer", DC::SourceManufacturer },
        { "ActiveSourceDiameter", DC::ActiveSourceDiameter },
        { "ActiveSourceLength", DC::ActiveSourceLength },
        { "SourceModelID", DC::SourceModelID },
        { "SourceDescription", DC::SourceDescription },
        { "SourceEncapsulationNominalThickness", DC::SourceEncapsulationNominalThickness },
        { "SourceEncapsulationNominalTransmission", DC::SourceEncapsulationNominalTransmission },
        { "SourceIsotopeName", DC::SourceIsotopeName },
        { "SourceIsotopeHalfLife", DC::SourceIsotopeHalfLife },
        { "SourceStrengthUnits", DC::SourceStrengthUnits },
        { "ReferenceAirKermaRate", DC::ReferenceAirKermaRate },
        { "SourceStrength", DC::SourceStrength },
        { "SourceStrengthReferenceDate", DC::SourceStrengthReferenceDate },
        { "SourceStrengthReferenceTime", DC::SourceStrengthReferenceTime },
        { "ApplicationSetupSequence", DC::ApplicationSetupSequence },
        { "ApplicationSetupType", DC::ApplicationSetupType },
        { "ApplicationSetupNumber", DC::ApplicationSetupNumber },
        { "ApplicationSetupName", DC::ApplicationSetupName },
        { "ApplicationSetupManufacturer", DC::ApplicationSetupManufacturer },
        { "TemplateNumber", DC::TemplateNumber },
        { "TemplateType", DC::TemplateType },
        { "TemplateName", DC::TemplateName },
        { "TotalReferenceAirKerma", DC::TotalReferenceAirKerma },
        { "BrachyAccessoryDeviceSequence", DC::BrachyAccessoryDeviceSequence },
        { "BrachyAccessoryDeviceNumber", DC::BrachyAccessoryDeviceNumber },
        { "BrachyAccessoryDeviceID", DC::BrachyAccessoryDeviceID },
        { "BrachyAccessoryDeviceType", DC::BrachyAccessoryDeviceType },
        { "BrachyAccessoryDeviceName", DC::BrachyAccessoryDeviceName },
        { "BrachyAccessoryDeviceNominalThickness", DC::BrachyAccessoryDeviceNominalThickness },
        { "BrachyAccessoryDeviceNominalTransmission", DC::BrachyAccessoryDeviceNominalTransmission },
        { "ChannelEffectiveLength", DC::ChannelEffectiveLength },
        { "ChannelInnerLength", DC::ChannelInnerLength },
        { "AfterloaderChannelID", DC::AfterloaderChannelID },
        { "SourceApplicatorTipLength", DC::SourceApplicatorTipLength },
        { "ChannelSequence", DC::ChannelSequence },
        { "ChannelNumber", DC::ChannelNumber },
        { "ChannelLength", DC::ChannelLength },
        { "ChannelTotalTime", DC::ChannelTotalTime },
        { "SourceMovementType", DC::SourceMovementType },
        { "NumberOfPulses", DC::NumberOfPulses },
        { "PulseRepetitionInterval", DC::PulseRepetitionInterval },
        { "SourceApplicatorNumber", DC::SourceApplicatorNumber },
        { "SourceApplicatorID", DC::SourceApplicatorID },
        { "SourceApplicatorType", DC::SourceApplicatorType },
        { "SourceApplicatorName", DC::SourceApplicatorName },
        { "SourceApplicatorLength", DC::SourceApplicatorLength },
        { "SourceApplicatorManufacturer", DC::SourceApplicatorManufacturer },
        { "SourceApplicatorWallNominalThickness", DC::SourceApplicatorWallNominalThickness },
        { "SourceApplicatorWallNominalTransmission", DC::SourceApplicatorWallNominalTransmission },
        { "SourceApplicatorStepSize", DC::SourceApplicatorStepSize },
        { "ApplicatorShapeReferencedROINumber", DC::ApplicatorShapeReferencedROINumber },
        { "TransferTubeNumber", DC::TransferTubeNumber },
        { "TransferTubeLength", DC::TransferTubeLength },
        { "ChannelShieldSequence", DC::ChannelShieldSequence },
        { "ChannelShieldNumber", DC::ChannelShieldNumber },
        { "ChannelShieldID", DC::ChannelShieldID },
        { "ChannelShieldName", DC::ChannelShieldName },
        { "ChannelShieldNominalThickness", DC::ChannelShieldNominalThickness },
        { "ChannelShieldNominalTransmission", DC::ChannelShieldNominalTransmission },
        { "FinalCumulativeTimeWeight", DC::FinalCumulativeTimeWeight },
        { "BrachyControlPointSequence", DC::BrachyControlPointSequence },
        { "ControlPointRelativePosition", DC::ControlPointRelativePosition },
        { "ControlPoint3DPosition", DC::ControlPoint3DPosition },
        { "CumulativeTimeWeight", DC::CumulativeTimeWeight },
        { "CompensatorDivergence", DC::CompensatorDivergence },
        { "CompensatorMountingPosition", DC::CompensatorMountingPosition },
        { "SourceToCompensatorDistance", DC::SourceToCompensatorDistance },
        { "TotalCompensatorTrayWaterEquivalentThickness", DC::TotalCompensatorTrayWaterEquivalentThickness },
        { "IsocenterToCompensatorTrayDistance", DC::IsocenterToCompensatorTrayDistance },
        { "CompensatorColumnOffset", DC::CompensatorColumnOffset },
        { "IsocenterToCompensatorDistances", DC::IsocenterToCompensatorDistances },
        { "CompensatorRelativeStoppingPowerRatio", DC::CompensatorRelativeStoppingPowerRatio },
        { "CompensatorMillingToolDiameter", DC::CompensatorMillingToolDiameter },
        { "IonRangeCompensatorSequence", DC::IonRangeCompensatorSequence },
        { "CompensatorDescription", DC::CompensatorDescription },
        { "RadiationMassNumber", DC::RadiationMassNumber },
        { "RadiationAtomicNumber", DC::RadiationAtomicNumber },
        { "RadiationChargeState", DC::RadiationChargeState },
        { "ScanMode", DC::ScanMode },
        { "ModulatedScanModeType", DC::ModulatedScanModeType },
        { "VirtualSourceAxisDistances", DC::VirtualSourceAxisDistances },
        { "SnoutSequence", DC::SnoutSequence },
        { "SnoutPosition", DC::SnoutPosition },
        { "SnoutID", DC::SnoutID },
        { "NumberOfRangeShifters", DC::NumberOfRangeShifters },
        { "RangeShifterSequence", DC::RangeShifterSequence },
        { "RangeShifterNumber", DC::RangeShifterNumber },
        { "RangeShifterID", DC::RangeShifterID },
        { "RangeShifterType", DC::RangeShifterType },
        { "RangeShifterDescription", DC::RangeShifterDescription },
        { "NumberOfLateralSpreadingDevices", DC::NumberOfLateralSpreadingDevices },
        { "LateralSpreadingDeviceSequence", DC::LateralSpreadingDeviceSequence },
        { "LateralSpreadingDeviceNumber", DC::LateralSpreadingDeviceNumber },
        { "LateralSpreadingDeviceID", DC::LateralSpreadingDeviceID },
        { "LateralSpreadingDeviceType", DC::LateralSpreadingDeviceType },
        { "LateralSpreadingDeviceDescription", DC::LateralSpreadingDeviceDescription },
        { "LateralSpreadingDeviceWaterEquivalentThickness", DC::LateralSpreadingDeviceWaterEquivalentThickness },
        { "NumberOfRangeModulators", DC::NumberOfRangeModulators },
        { "RangeModulatorSequence", DC::RangeModulatorSequence },
        { "RangeModulatorNumber", DC::RangeModulatorNumber },
        { "RangeModulatorID", DC::RangeModulatorID },
        { "RangeModulatorType", DC::RangeModulatorType },
        { "RangeModulatorDescription", DC::RangeModulatorDescription },
        { "BeamCurrentModulationID", DC::BeamCurrentModulationID },
        { "PatientSupportType", DC::PatientSupportType },
        { "PatientSupportID", DC::PatientSupportID },
        { "PatientSupportAccessoryCode", DC::PatientSupportAccessoryCode },
        { "TrayAccessoryCode", DC::TrayAccessoryCode },
        { "FixationLightAzimuthalAngle", DC::FixationLightAzimuthalAngle },
        { "FixationLightPolarAngle", DC::FixationLightPolarAngle },
        { "MetersetRate", DC::MetersetRate },
        { "RangeShifterSettingsSequence", DC::RangeShifterSettingsSequence },
        { "RangeShifterSetting", DC::RangeShifterSetting },
        { "IsocenterToRangeShifterDistance", DC::IsocenterToRangeShifterDistance },
        { "RangeShifterWaterEquivalentThickness", DC::RangeShifterWaterEquivalentThickness },
        { "LateralSpreadingDeviceSettingsSequence", DC::LateralSpreadingDeviceSettingsSequence },
        { "LateralSpreadingDeviceSetting", DC::LateralSpreadingDeviceSetting },
        { "IsocenterToLateralSpreadingDeviceDistance", DC::IsocenterToLateralSpreadingDeviceDistance },
        { "RangeModulatorSettingsSequence", DC::RangeModulatorSettingsSequence },
        { "RangeModulatorGatingStartValue", DC::RangeModulatorGatingStartValue },
        { "RangeModulatorGatingStopValue", DC::RangeModulatorGatingStopValue },
        { "RangeModulatorGatingStartWaterEquivalentThickness", DC::RangeModulatorGatingStartWaterEquivalentThickness },
        { "RangeModulatorGatingStopWaterEquivalentThickness", DC::RangeModulatorGatingStopWaterEquivalentThickness },
        { "IsocenterToRangeModulatorDistance", DC::IsocenterToRangeModulatorDistance },
        { "ScanSpotTimeOffset", DC::ScanSpotTimeOffset },
        { "ScanSpotTuneID", DC::ScanSpotTuneID },
        { "ScanSpotPrescribedIndices", DC::ScanSpotPrescribedIndices },
        { "NumberOfScanSpotPositions", DC::NumberOfScanSpotPositions },
        { "ScanSpotReordered", DC::ScanSpotReordered },
        { "ScanSpotPositionMap", DC::ScanSpotPositionMap },
        { "ScanSpotReorderingAllowed", DC::ScanSpotReorderingAllowed },
        { "ScanSpotMetersetWeights", DC::ScanSpotMetersetWeights },
        { "ScanningSpotSize", DC::ScanningSpotSize },
        { "ScanSpotSizesDelivered", DC::ScanSpotSizesDelivered },
        { "NumberOfPaintings", DC::NumberOfPaintings },
        { "IonToleranceTableSequence", DC::IonToleranceTableSequence },
        { "IonBeamSequence", DC::IonBeamSequence },
        { "IonBeamLimitingDeviceSequence", DC::IonBeamLimitingDeviceSequence },
        { "IonBlockSequence", DC::IonBlockSequence },
        { "IonControlPointSequence", DC::IonControlPointSequence },
        { "IonWedgeSequence", DC::IonWedgeSequence },
        { "IonWedgePositionSequence", DC::IonWedgePositionSequence },
        { "ReferencedSetupImageSequence", DC::ReferencedSetupImageSequence },
        { "SetupImageComment", DC::SetupImageComment },
        { "MotionSynchronizationSequence", DC::MotionSynchronizationSequence },
        { "ControlPointOrientation", DC::ControlPointOrientation },
        { "GeneralAccessorySequence", DC::GeneralAccessorySequence },
        { "GeneralAccessoryID", DC::GeneralAccessoryID },
        { "GeneralAccessoryDescription", DC::GeneralAccessoryDescription },
        { "GeneralAccessoryType", DC::GeneralAccessoryType },
        { "GeneralAccessoryNumber", DC::GeneralAccessoryNumber },
        { "SourceToGeneralAccessoryDistance", DC::SourceToGeneralAccessoryDistance },
        { "IsocenterToGeneralAccessoryDistance", DC::IsocenterToGeneralAccessoryDistance },
        { "ApplicatorGeometrySequence", DC::ApplicatorGeometrySequence },
        { "ApplicatorApertureShape", DC::ApplicatorApertureShape },
        { "ApplicatorOpening", DC::ApplicatorOpening },
        { "ApplicatorOpeningX", DC::ApplicatorOpeningX },
        { "ApplicatorOpeningY", DC::ApplicatorOpeningY },
        { "SourceToApplicatorMountingPositionDistance", DC::SourceToApplicatorMountingPositionDistance },
        { "NumberOfBlockSlabItems", DC::NumberOfBlockSlabItems },
        { "BlockSlabSequence", DC::BlockSlabSequence },
        { "BlockSlabThickness", DC::BlockSlabThickness },
        { "BlockSlabNumber", DC::BlockSlabNumber },
        { "DeviceMotionControlSequence", DC::DeviceMotionControlSequence },
        { "DeviceMotionExecutionMode", DC::DeviceMotionExecutionMode },
        { "DeviceMotionObservationMode", DC::DeviceMotionObservationMode },
        { "DeviceMotionParameterCodeSequence", DC::DeviceMotionParameterCodeSequence },
        { "DistalDepthFraction", DC::DistalDepthFraction },
        { "DistalDepth", DC::DistalDepth },
        { "NominalRangeModulationFractions", DC::NominalRangeModulationFractions },
        { "NominalRangeModulatedRegionDepths", DC::NominalRangeModulatedRegionDepths },
        { "DepthDoseParametersSequence", DC::DepthDoseParametersSequence },
        { "DeliveredDepthDoseParametersSequence", DC::DeliveredDepthDoseParametersSequence },
        { "DeliveredDistalDepthFraction", DC::DeliveredDistalDepthFraction },
        { "DeliveredDistalDepth", DC::DeliveredDistalDepth },
        { "DeliveredNominalRangeModulationFractions", DC::DeliveredNominalRangeModulationFractions },
        { "DeliveredNominalRangeModulatedRegionDepths", DC::DeliveredNominalRangeModulatedRegionDepths },
        { "DeliveredReferenceDoseDefinition", DC::DeliveredReferenceDoseDefinition },
        { "ReferenceDoseDefinition", DC::ReferenceDoseDefinition },
        { "RTControlPointIndex", DC::RTControlPointIndex },
        { "RadiationGenerationModeIndex", DC::RadiationGenerationModeIndex },
        { "ReferencedDefinedDeviceIndex", DC::ReferencedDefinedDeviceIndex },
        { "RadiationDoseIdentificationIndex", DC::RadiationDoseIdentificationIndex },
        { "NumberOfRTControlPoints", DC::NumberOfRTControlPoints },
        { "ReferencedRadiationGenerationModeIndex", DC::ReferencedRadiationGenerationModeIndex },
        { "TreatmentPositionIndex", DC::TreatmentPositionIndex },
        { "ReferencedDeviceIndex", DC::ReferencedDeviceIndex },
        { "TreatmentPositionGroupLabel", DC::TreatmentPositionGroupLabel },
        { "TreatmentPositionGroupUID", DC::TreatmentPositionGroupUID },
        { "TreatmentPositionGroupSequence", DC::TreatmentPositionGroupSequence },
        { "ReferencedTreatmentPositionIndex", DC::ReferencedTreatmentPositionIndex },
        { "ReferencedRadiationDoseIdentificationIndex", DC::ReferencedRadiationDoseIdentificationIndex },
        { "RTAccessoryHolderWaterEquivalentThickness", DC::RTAccessoryHolderWaterEquivalentThickness },
        { "ReferencedRTAccessoryHolderDeviceIndex", DC::ReferencedRTAccessoryHolderDeviceIndex },
        { "RTAccessoryHolderSlotExistenceFlag", DC::RTAccessoryHolderSlotExistenceFlag },
        { "RTAccessoryHolderSlotSequence", DC::RTAccessoryHolderSlotSequence },
        { "RTAccessoryHolderSlotID", DC::RTAccessoryHolderSlotID },
        { "RTAccessoryHolderSlotDistance", DC::RTAccessoryHolderSlotDistance },
        { "RTAccessorySlotDistance", DC::RTAccessorySlotDistance },
        { "RTAccessoryHolderDefinitionSequence", DC::RTAccessoryHolderDefinitionSequence },
        { "RTAccessoryDeviceSlotID", DC::RTAccessoryDeviceSlotID },
        { "RTRadiationSequence", DC::RTRadiationSequence },
        { "RadiationDoseSequence", DC::RadiationDoseSequence },
        { "RadiationDoseIdentificationSequence", DC::RadiationDoseIdentificationSequence },
        { "RadiationDoseIdentificationLabel", DC::RadiationDoseIdentificationLabel },
        { "ReferenceDoseType", DC::ReferenceDoseType },
        { "PrimaryDoseValueIndicator", DC::PrimaryDoseValueIndicator },
        { "DoseValuesSequence", DC::DoseValuesSequence },
        { "DoseValuePurpose", DC::DoseValuePurpose },
        { "ReferenceDosePointCoordinates", DC::ReferenceDosePointCoordinates },
        { "RadiationDoseValuesParametersSequence", DC::RadiationDoseValuesParametersSequence },
        { "MetersetToDoseMappingSequence", DC::MetersetToDoseMappingSequence },
        { "ExpectedInVivoMeasurementValuesSequence", DC::ExpectedInVivoMeasurementValuesSequence },
        { "ExpectedInVivoMeasurementValueIndex", DC::ExpectedInVivoMeasurementValueIndex },
        { "RadiationDoseInVivoMeasurementLabel", DC::RadiationDoseInVivoMeasurementLabel },
        { "RadiationDoseCentralAxisDisplacement", DC::RadiationDoseCentralAxisDisplacement },
        { "RadiationDoseValue", DC::RadiationDoseValue },
        { "RadiationDoseSourceToSkinDistance", DC::RadiationDoseSourceToSkinDistance },
        { "RadiationDoseMeasurementPointCoordinates", DC::RadiationDoseMeasurementPointCoordinates },
        { "RadiationDoseSourceToExternalContourDistance", DC::RadiationDoseSourceToExternalContourDistance },
        { "RTToleranceSetSequence", DC::RTToleranceSetSequence },
        { "RTToleranceSetLabel", DC::RTToleranceSetLabel },
        { "AttributeToleranceValuesSequence", DC::AttributeToleranceValuesSequence },
        { "ToleranceValue", DC::ToleranceValue },
        { "PatientSupportPositionToleranceSequence", DC::PatientSupportPositionToleranceSequence },
        { "TreatmentTimeLimit", DC::TreatmentTimeLimit },
        { "CArmPhotonElectronControlPointSequence", DC::CArmPhotonElectronControlPointSequence },
        { "ReferencedRTRadiationSequence", DC::ReferencedRTRadiationSequence },
        { "ReferencedRTInstanceSequence", DC::ReferencedRTInstanceSequence },
        { "ReferencedRTPatientSetupSequence", DC::ReferencedRTPatientSetupSequence },
        { "SourceToPatientSurfaceDistance", DC::SourceToPatientSurfaceDistance },
        { "TreatmentMachineSpecialModeCodeSequence", DC::TreatmentMachineSpecialModeCodeSequence },
        { "IntendedNumberOfFractions", DC::IntendedNumberOfFractions },
        { "RTRadiationSetIntent", DC::RTRadiationSetIntent },
        { "RTRadiationPhysicalAndGeometricContentDetailFlag", DC::RTRadiationPhysicalAndGeometricContentDetailFlag },
        { "RTRecordFlag", DC::RTRecordFlag },
        { "TreatmentDeviceIdentificationSequence", DC::TreatmentDeviceIdentificationSequence },
        { "ReferencedRTPhysicianIntentSequence", DC::ReferencedRTPhysicianIntentSequence },
        { "CumulativeMeterset", DC::CumulativeMeterset },
        { "DeliveryRate", DC::DeliveryRate },
        { "DeliveryRateUnitSequence", DC::DeliveryRateUnitSequence },
        { "TreatmentPositionSequence", DC::TreatmentPositionSequence },
        { "RadiationSourceAxisDistance", DC::RadiationSourceAxisDistance },
        { "NumberOfRTBeamLimitingDevices", DC::NumberOfRTBeamLimitingDevices },
        { "RTBeamLimitingDeviceProximalDistance", DC::RTBeamLimitingDeviceProximalDistance },
        { "RTBeamLimitingDeviceDistalDistance", DC::RTBeamLimitingDeviceDistalDistance },
        { "ParallelRTBeamDelimiterDeviceOrientationLabelCodeSequence", DC::ParallelRTBeamDelimiterDeviceOrientationLabelCodeSequence },
        { "BeamModifierOrientationAngle", DC::BeamModifierOrientationAngle },
        { "FixedRTBeamDelimiterDeviceSequence", DC::FixedRTBeamDelimiterDeviceSequence },
        { "ParallelRTBeamDelimiterDeviceSequence", DC::ParallelRTBeamDelimiterDeviceSequence },
        { "NumberOfParallelRTBeamDelimiters", DC::NumberOfParallelRTBeamDelimiters },
        { "ParallelRTBeamDelimiterBoundaries", DC::ParallelRTBeamDelimiterBoundaries },
        { "ParallelRTBeamDelimiterPositions", DC::ParallelRTBeamDelimiterPositions },
        { "RTBeamLimitingDeviceOffset", DC::RTBeamLimitingDeviceOffset },
        { "RTBeamDelimiterGeometrySequence", DC::RTBeamDelimiterGeometrySequence },
        { "RTBeamLimitingDeviceDefinitionSequence", DC::RTBeamLimitingDeviceDefinitionSequence },
        { "ParallelRTBeamDelimiterOpeningMode", DC::ParallelRTBeamDelimiterOpeningMode },
        { "ParallelRTBeamDelimiterLeafMountingSide", DC::ParallelRTBeamDelimiterLeafMountingSide },
        { "PatientSetupUID", DC::PatientSetupUID },
        { "WedgeDefinitionSequence", DC::WedgeDefinitionSequence },
        { "RadiationBeamWedgeAngle", DC::RadiationBeamWedgeAngle },
        { "RadiationBeamWedgeThinEdgeDistance", DC::RadiationBeamWedgeThinEdgeDistance },
        { "RadiationBeamEffectiveWedgeAngle", DC::RadiationBeamEffectiveWedgeAngle },
        { "NumberOfWedgePositions", DC::NumberOfWedgePositions },
        { "RTBeamLimitingDeviceOpeningSequence", DC::RTBeamLimitingDeviceOpeningSequence },
        { "NumberOfRTBeamLimitingDeviceOpenings", DC::NumberOfRTBeamLimitingDeviceOpenings },
        { "RadiationDosimeterUnitSequence", DC::RadiationDosimeterUnitSequence },
        { "RTDeviceDistanceReferenceLocationCodeSequence", DC::RTDeviceDistanceReferenceLocationCodeSequence },
        { "RadiationDeviceConfigurationAndCommissioningKeySequence", DC::RadiationDeviceConfigurationAndCommissioningKeySequence },
        { "PatientSupportPositionParameterSequence", DC::PatientSupportPositionParameterSequence },
        { "PatientSupportPositionSpecificationMethod", DC::PatientSupportPositionSpecificationMethod },
        { "PatientSupportPositionDeviceParameterSequence", DC::PatientSupportPositionDeviceParameterSequence },
        { "DeviceOrderIndex", DC::DeviceOrderIndex },
        { "PatientSupportPositionParameterOrderIndex", DC::PatientSupportPositionParameterOrderIndex },
        { "PatientSupportPositionDeviceToleranceSequence", DC::PatientSupportPositionDeviceToleranceSequence },
        { "PatientSupportPositionToleranceOrderIndex", DC::PatientSupportPositionToleranceOrderIndex },
        { "CompensatorDefinitionSequence", DC::CompensatorDefinitionSequence },
        { "CompensatorMapOrientation", DC::CompensatorMapOrientation },
        { "CompensatorProximalThicknessMap", DC::CompensatorProximalThicknessMap },
        { "CompensatorDistalThicknessMap", DC::CompensatorDistalThicknessMap },
        { "CompensatorBasePlaneOffset", DC::CompensatorBasePlaneOffset },
        { "CompensatorShapeFabricationCodeSequence", DC::CompensatorShapeFabricationCodeSequence },
        { "CompensatorShapeSequence", DC::CompensatorShapeSequence },
        { "RadiationBeamCompensatorMillingToolDiameter", DC::RadiationBeamCompensatorMillingToolDiameter },
        { "BlockDefinitionSequence", DC::BlockDefinitionSequence },
        { "BlockEdgeData", DC::BlockEdgeData },
        { "BlockOrientation", DC::BlockOrientation },
        { "RadiationBeamBlockThickness", DC::RadiationBeamBlockThickness },
        { "RadiationBeamBlockSlabThickness", DC::RadiationBeamBlockSlabThickness },
        { "BlockEdgeDataSequence", DC::BlockEdgeDataSequence },
        { "NumberOfRTAccessoryHolders", DC::NumberOfRTAccessoryHolders },
        { "GeneralAccessoryDefinitionSequence", DC::GeneralAccessoryDefinitionSequence },
        { "NumberOfGeneralAccessories", DC::NumberOfGeneralAccessories },
        { "BolusDefinitionSequence", DC::BolusDefinitionSequence },
        { "NumberOfBoluses", DC::NumberOfBoluses },
        { "EquipmentFrameOfReferenceUID", DC::EquipmentFrameOfReferenceUID },
        { "EquipmentFrameOfReferenceDescription", DC::EquipmentFrameOfReferenceDescription },
        { "EquipmentReferencePointCoordinatesSequence", DC::EquipmentReferencePointCoordinatesSequence },
        { "EquipmentReferencePointCodeSequence", DC::EquipmentReferencePointCodeSequence },
        { "RTBeamLimitingDeviceAngle", DC::RTBeamLimitingDeviceAngle },
        { "SourceRollAngle", DC::SourceRollAngle },
        { "RadiationGenerationModeSequence", DC::RadiationGenerationModeSequence },
        { "RadiationGenerationModeLabel", DC::RadiationGenerationModeLabel },
        { "RadiationGenerationModeDescription", DC::RadiationGenerationModeDescription },
        { "RadiationGenerationModeMachineCodeSequence", DC::RadiationGenerationModeMachineCodeSequence },
        { "RadiationTypeCodeSequence", DC::RadiationTypeCodeSequence },
        { "NominalEnergy", DC::NominalEnergy },
        { "MinimumNominalEnergy", DC::MinimumNominalEnergy },
        { "MaximumNominalEnergy", DC::MaximumNominalEnergy },
        { "RadiationFluenceModifierCodeSequence", DC::RadiationFluenceModifierCodeSequence },
        { "EnergyUnitCodeSequence", DC::EnergyUnitCodeSequence },
        { "NumberOfRadiationGenerationModes", DC::NumberOfRadiationGenerationModes },
        { "PatientSupportDevicesSequence", DC::PatientSupportDevicesSequence },
        { "NumberOfPatientSupportDevices", DC::NumberOfPatientSupportDevices },
        { "RTBeamModifierDefinitionDistance", DC::RTBeamModifierDefinitionDistance },
        { "BeamAreaLimitSequence", DC::BeamAreaLimitSequence },
        { "ReferencedRTPrescriptionSequence", DC::ReferencedRTPrescriptionSequence },
        { "TreatmentSessionUID", DC::TreatmentSessionUID },
        { "RTRadiationUsage", DC::RTRadiationUsage },
        { "ReferencedRTRadiationSetSequence", DC::ReferencedRTRadiationSetSequence },
        { "ReferencedRTRadiationRecordSequence", DC::ReferencedRTRadiationRecordSequence },
        { "RTRadiationSetDeliveryNumber", DC::RTRadiationSetDeliveryNumber },
        { "ClinicalFractionNumber", DC::ClinicalFractionNumber },
        { "RTTreatmentFractionCompletionStatus", DC::RTTreatmentFractionCompletionStatus },
        { "RTRadiationSetUsage", DC::RTRadiationSetUsage },
        { "TreatmentDeliveryContinuationFlag", DC::TreatmentDeliveryContinuationFlag },
        { "TreatmentRecordContentOrigin", DC::TreatmentRecordContentOrigin },
        { "RTTreatmentTerminationStatus", DC::RTTreatmentTerminationStatus },
        { "RTTreatmentTerminationReasonCodeSequence", DC::RTTreatmentTerminationReasonCodeSequence },
        { "MachineSpecificTreatmentTerminationCodeSequence", DC::MachineSpecificTreatmentTerminationCodeSequence },
        { "RTRadiationSalvageRecordControlPointSequence", DC::RTRadiationSalvageRecordControlPointSequence },
        { "StartingMetersetValueKnownFlag", DC::StartingMetersetValueKnownFlag },
        { "TreatmentTerminationDescription", DC::TreatmentTerminationDescription },
        { "TreatmentToleranceViolationSequence", DC::TreatmentToleranceViolationSequence },
        { "TreatmentToleranceViolationCategory", DC::TreatmentToleranceViolationCategory },
        { "TreatmentToleranceViolationAttributeSequence", DC::TreatmentToleranceViolationAttributeSequence },
        { "TreatmentToleranceViolationDescription", DC::TreatmentToleranceViolationDescription },
        { "TreatmentToleranceViolationIdentification", DC::TreatmentToleranceViolationIdentification },
        { "TreatmentToleranceViolationDateTime", DC::TreatmentToleranceViolationDateTime },
        { "RecordedRTControlPointDateTime", DC::RecordedRTControlPointDateTime },
        { "ReferencedRadiationRTControlPointIndex", DC::ReferencedRadiationRTControlPointIndex },
        { "AlternateValueSequence", DC::AlternateValueSequence },
        { "ConfirmationSequence", DC::ConfirmationSequence },
        { "InterlockSequence", DC::InterlockSequence },
        { "InterlockDateTime", DC::InterlockDateTime },
        { "InterlockDescription", DC::InterlockDescription },
        { "InterlockOriginatingDeviceSequence", DC::InterlockOriginatingDeviceSequence },
        { "InterlockCodeSequence", DC::InterlockCodeSequence },
        { "InterlockResolutionCodeSequence", DC::InterlockResolutionCodeSequence },
        { "InterlockResolutionUserSequence", DC::InterlockResolutionUserSequence },
        { "OverrideDateTime", DC::OverrideDateTime },
        { "TreatmentToleranceViolationTypeCodeSequence", DC::TreatmentToleranceViolationTypeCodeSequence },
        { "TreatmentToleranceViolationCauseCodeSequence", DC::TreatmentToleranceViolationCauseCodeSequence },
        { "MeasuredMetersetToDoseMappingSequence", DC::MeasuredMetersetToDoseMappingSequence },
        { "ReferencedExpectedInVivoMeasurementValueIndex", DC::ReferencedExpectedInVivoMeasurementValueIndex },
        { "DoseMeasurementDeviceCodeSequence", DC::DoseMeasurementDeviceCodeSequence },
        { "AdditionalParameterRecordingInstanceSequence", DC::AdditionalParameterRecordingInstanceSequence },
        { "InterlockOriginDescription", DC::InterlockOriginDescription },
        { "RTPatientPositionScopeSequence", DC::RTPatientPositionScopeSequence },
        { "ReferencedTreatmentPositionGroupUID", DC::ReferencedTreatmentPositionGroupUID },
        { "RadiationOrderIndex", DC::RadiationOrderIndex },
        { "OmittedRadiationSequence", DC::OmittedRadiationSequence },
        { "ReasonForOmissionCodeSequence", DC::ReasonForOmissionCodeSequence },
        { "RTDeliveryStartPatientPositionSequence", DC::RTDeliveryStartPatientPositionSequence },
        { "RTTreatmentPreparationPatientPositionSequence", DC::RTTreatmentPreparationPatientPositionSequence },
        { "ReferencedRTTreatmentPreparationSequence", DC::ReferencedRTTreatmentPreparationSequence },
        { "ReferencedPatientSetupPhotoSequence", DC::ReferencedPatientSetupPhotoSequence },
        { "PatientTreatmentPreparationMethodCodeSequence", DC::PatientTreatmentPreparationMethodCodeSequence },
        { "PatientTreatmentPreparationProcedureParameterDescription", DC::PatientTreatmentPreparationProcedureParameterDescription },
        { "PatientTreatmentPreparationDeviceSequence", DC::PatientTreatmentPreparationDeviceSequence },
        { "PatientTreatmentPreparationProcedureSequence", DC::PatientTreatmentPreparationProcedureSequence },
        { "PatientTreatmentPreparationProcedureCodeSequence", DC::PatientTreatmentPreparationProcedureCodeSequence },
        { "PatientTreatmentPreparationMethodDescription", DC::PatientTreatmentPreparationMethodDescription },
        { "PatientTreatmentPreparationProcedureParameterSequence", DC::PatientTreatmentPreparationProcedureParameterSequence },
        { "PatientSetupPhotoDescription", DC::PatientSetupPhotoDescription },
        { "PatientTreatmentPreparationProcedureIndex", DC::PatientTreatmentPreparationProcedureIndex },
        { "ReferencedPatientSetupProcedureIndex", DC::ReferencedPatientSetupProcedureIndex },
        { "RTRadiationTaskSequence", DC::RTRadiationTaskSequence },
        { "RTPatientPositionDisplacementSequence", DC::RTPatientPositionDisplacementSequence },
        { "RTPatientPositionSequence", DC::RTPatientPositionSequence },
        { "DisplacementReferenceLabel", DC::DisplacementReferenceLabel },
        { "DisplacementMatrix", DC::DisplacementMatrix },
        { "PatientSupportDisplacementSequence", DC::PatientSupportDisplacementSequence },
        { "DisplacementReferenceLocationCodeSequence", DC::DisplacementReferenceLocationCodeSequence },
        { "RTRadiationSetDeliveryUsage", DC::RTRadiationSetDeliveryUsage },
        { "ReferencedRTPlanSequence", DC::ReferencedRTPlanSequence },
        { "ReferencedBeamSequence", DC::ReferencedBeamSequence },
        { "ReferencedBeamNumber", DC::ReferencedBeamNumber },
        { "ReferencedReferenceImageNumber", DC::ReferencedReferenceImageNumber },
        { "StartCumulativeMetersetWeight", DC::StartCumulativeMetersetWeight },
        { "EndCumulativeMetersetWeight", DC::EndCumulativeMetersetWeight },
        { "ReferencedBrachyApplicationSetupSequence", DC::ReferencedBrachyApplicationSetupSequence },
        { "ReferencedBrachyApplicationSetupNumber", DC::ReferencedBrachyApplicationSetupNumber },
        { "ReferencedSourceNumber", DC::ReferencedSourceNumber },
        { "ReferencedFractionGroupSequence", DC::ReferencedFractionGroupSequence },
        { "ReferencedFractionGroupNumber", DC::ReferencedFractionGroupNumber },
        { "ReferencedVerificationImageSequence", DC::ReferencedVerificationImageSequence },
        { "ReferencedReferenceImageSequence", DC::ReferencedReferenceImageSequence },
        { "ReferencedDoseReferenceSequence", DC::ReferencedDoseReferenceSequence },
        { "ReferencedDoseReferenceNumber", DC::ReferencedDoseReferenceNumber },
        { "BrachyReferencedDoseReferenceSequence", DC::BrachyReferencedDoseReferenceSequence },
        { "ReferencedStructureSetSequence", DC::ReferencedStructureSetSequence },
        { "ReferencedPatientSetupNumber", DC::ReferencedPatientSetupNumber },
        { "ReferencedDoseSequence", DC::ReferencedDoseSequence },
        { "ReferencedToleranceTableNumber", DC::ReferencedToleranceTableNumber },
        { "ReferencedBolusSequence", DC::ReferencedBolusSequence },
        { "ReferencedWedgeNumber", DC::ReferencedWedgeNumber },
        { "ReferencedCompensatorNumber", DC::ReferencedCompensatorNumber },
        { "ReferencedBlockNumber", DC::ReferencedBlockNumber },
        { "ReferencedControlPointIndex", DC::ReferencedControlPointIndex },
        { "ReferencedControlPointSequence", DC::ReferencedControlPointSequence },
        { "ReferencedStartControlPointIndex", DC::ReferencedStartControlPointIndex },
        { "ReferencedStopControlPointIndex", DC::ReferencedStopControlPointIndex },
        { "ReferencedRangeShifterNumber", DC::ReferencedRangeShifterNumber },
        { "ReferencedLateralSpreadingDeviceNumber", DC::ReferencedLateralSpreadingDeviceNumber },
        { "ReferencedRangeModulatorNumber", DC::ReferencedRangeModulatorNumber },
        { "OmittedBeamTaskSequence", DC::OmittedBeamTaskSequence },
        { "ReasonForOmission", DC::ReasonForOmission },
        { "ReasonForOmissionDescription", DC::ReasonForOmissionDescription },
        { "PrescriptionOverviewSequence", DC::PrescriptionOverviewSequence },
        { "TotalPrescriptionDose", DC::TotalPrescriptionDose },
        { "PlanOverviewSequence", DC::PlanOverviewSequence },
        { "PlanOverviewIndex", DC::PlanOverviewIndex },
        { "ReferencedPlanOverviewIndex", DC::ReferencedPlanOverviewIndex },
        { "NumberOfFractionsIncluded", DC::NumberOfFractionsIncluded },
        { "DoseCalibrationConditionsSequence", DC::DoseCalibrationConditionsSequence },
        { "AbsorbedDoseToMetersetRatio", DC::AbsorbedDoseToMetersetRatio },
        { "DelineatedRadiationFieldSize", DC::DelineatedRadiationFieldSize },
        { "DoseCalibrationConditionsVerifiedFlag", DC::DoseCalibrationConditionsVerifiedFlag },
        { "CalibrationReferencePointDepth", DC::CalibrationReferencePointDepth },
        { "GatingBeamHoldTransitionSequence", DC::GatingBeamHoldTransitionSequence },
        { "BeamHoldTransition", DC::BeamHoldTransition },
        { "BeamHoldTransitionDateTime", DC::BeamHoldTransitionDateTime },
        { "BeamHoldOriginatingDeviceSequence", DC::BeamHoldOriginatingDeviceSequence },
        { "ApprovalStatus", DC::ApprovalStatus },
        { "ReviewDate", DC::ReviewDate },
        { "ReviewTime", DC::ReviewTime },
        { "ReviewerName", DC::ReviewerName },
        { "RadiobiologicalDoseEffectSequence", DC::RadiobiologicalDoseEffectSequence },
        { "RadiobiologicalDoseEffectFlag", DC::RadiobiologicalDoseEffectFlag },
        { "EffectiveDoseCalculationMethodCategoryCodeSequence", DC::EffectiveDoseCalculationMethodCategoryCodeSequence },
        { "EffectiveDoseCalculationMethodCodeSequence", DC::EffectiveDoseCalculationMethodCodeSequence },
        { "EffectiveDoseCalculationMethodDescription", DC::EffectiveDoseCalculationMethodDescription },
        { "ConceptualVolumeUID", DC::ConceptualVolumeUID },
        { "OriginatingSOPInstanceReferenceSequence", DC::OriginatingSOPInstanceReferenceSequence },
        { "ConceptualVolumeConstituentSequence", DC::ConceptualVolumeConstituentSequence },
        { "EquivalentConceptualVolumeInstanceReferenceSequence", DC::EquivalentConceptualVolumeInstanceReferenceSequence },
        { "EquivalentConceptualVolumesSequence", DC::EquivalentConceptualVolumesSequence },
        { "ReferencedConceptualVolumeUID", DC::ReferencedConceptualVolumeUID },
        { "ConceptualVolumeCombinationExpression", DC::ConceptualVolumeCombinationExpression },
        { "ConceptualVolumeConstituentIndex", DC::ConceptualVolumeConstituentIndex },
        { "ConceptualVolumeCombinationFlag", DC::ConceptualVolumeCombinationFlag },
        { "ConceptualVolumeCombinationDescription", DC::ConceptualVolumeCombinationDescription },
        { "ConceptualVolumeSegmentationDefinedFlag", DC::ConceptualVolumeSegmentationDefinedFlag },
        { "ConceptualVolumeSegmentationReferenceSequence", DC::ConceptualVolumeSegmentationReferenceSequence },
        { "ConceptualVolumeConstituentSegmentationReferenceSequence", DC::ConceptualVolumeConstituentSegmentationReferenceSequence },
        { "ConstituentConceptualVolumeUID", DC::ConstituentConceptualVolumeUID },
        { "DerivationConceptualVolumeSequence", DC::DerivationConceptualVolumeSequence },
        { "SourceConceptualVolumeUID", DC::SourceConceptualVolumeUID },
        { "ConceptualVolumeDerivationAlgorithmSequence", DC::ConceptualVolumeDerivationAlgorithmSequence },
        { "ConceptualVolumeDescription", DC::ConceptualVolumeDescription },
        { "SourceConceptualVolumeSequence", DC::SourceConceptualVolumeSequence },
        { "AuthorIdentificationSequence", DC::AuthorIdentificationSequence },
        { "ManufacturerModelVersion", DC::ManufacturerModelVersion },
        { "DeviceAlternateIdentifier", DC::DeviceAlternateIdentifier },
        { "DeviceAlternateIdentifierType", DC::DeviceAlternateIdentifierType },
        { "DeviceAlternateIdentifierFormat", DC::DeviceAlternateIdentifierFormat },
        { "SegmentationCreationTemplateLabel", DC::SegmentationCreationTemplateLabel },
        { "SegmentationTemplateUID", DC::SegmentationTemplateUID },
        { "ReferencedSegmentReferenceIndex", DC::ReferencedSegmentReferenceIndex },
        { "SegmentReferenceSequence", DC::SegmentReferenceSequence },
        { "SegmentReferenceIndex", DC::SegmentReferenceIndex },
        { "DirectSegmentReferenceSequence", DC::DirectSegmentReferenceSequence },
        { "CombinationSegmentReferenceSequence", DC::CombinationSegmentReferenceSequence },
        { "ConceptualVolumeSequence", DC::ConceptualVolumeSequence },
        { "SegmentedRTAccessoryDeviceSequence", DC::SegmentedRTAccessoryDeviceSequence },
        { "SegmentCharacteristicsSequence", DC::SegmentCharacteristicsSequence },
        { "RelatedSegmentCharacteristicsSequence", DC::RelatedSegmentCharacteristicsSequence },
        { "SegmentCharacteristicsPrecedence", DC::SegmentCharacteristicsPrecedence },
        { "RTSegmentAnnotationSequence", DC::RTSegmentAnnotationSequence },
        { "SegmentAnnotationCategoryCodeSequence", DC::SegmentAnnotationCategoryCodeSequence },
        { "SegmentAnnotationTypeCodeSequence", DC::SegmentAnnotationTypeCodeSequence },
        { "DeviceLabel", DC::DeviceLabel },
        { "DeviceTypeCodeSequence", DC::DeviceTypeCodeSequence },
        { "SegmentAnnotationTypeModifierCodeSequence", DC::SegmentAnnotationTypeModifierCodeSequence },
        { "PatientEquipmentRelationshipCodeSequence", DC::PatientEquipmentRelationshipCodeSequence },
        { "ReferencedFiducialsUID", DC::ReferencedFiducialsUID },
        { "PatientTreatmentOrientationSequence", DC::PatientTreatmentOrientationSequence },
        { "UserContentLabel", DC::UserContentLabel },
        { "UserContentLongLabel", DC::UserContentLongLabel },
        { "EntityLabel", DC::EntityLabel },
        { "EntityName", DC::EntityName },
        { "EntityDescription", DC::EntityDescription },
        { "EntityLongLabel", DC::EntityLongLabel },
        { "DeviceIndex", DC::DeviceIndex },
        { "RTTreatmentPhaseIndex", DC::RTTreatmentPhaseIndex },
        { "RTTreatmentPhaseUID", DC::RTTreatmentPhaseUID },
        { "RTPrescriptionIndex", DC::RTPrescriptionIndex },
        { "RTSegmentAnnotationIndex", DC::RTSegmentAnnotationIndex },
        { "BasisRTTreatmentPhaseIndex", DC::BasisRTTreatmentPhaseIndex },
        { "RelatedRTTreatmentPhaseIndex", DC::RelatedRTTreatmentPhaseIndex },
        { "ReferencedRTTreatmentPhaseIndex", DC::ReferencedRTTreatmentPhaseIndex },
        { "ReferencedRTPrescriptionIndex", DC::ReferencedRTPrescriptionIndex },
        { "ReferencedParentRTPrescriptionIndex", DC::ReferencedParentRTPrescriptionIndex },
        { "ManufacturerDeviceIdentifier", DC::ManufacturerDeviceIdentifier },
        { "InstanceLevelReferencedPerformedProcedureStepSequence", DC::InstanceLevelReferencedPerformedProcedureStepSequence },
        { "RTTreatmentPhaseIntentPresenceFlag", DC::RTTreatmentPhaseIntentPresenceFlag },
        { "RadiotherapyTreatmentType", DC::RadiotherapyTreatmentType },
        { "TeletherapyRadiationType", DC::TeletherapyRadiationType },
        { "BrachytherapySourceType", DC::BrachytherapySourceType },
        { "ReferencedRTTreatmentPhaseSequence", DC::ReferencedRTTreatmentPhaseSequence },
        { "ReferencedDirectSegmentInstanceSequence", DC::ReferencedDirectSegmentInstanceSequence },
        { "IntendedRTTreatmentPhaseSequence", DC::IntendedRTTreatmentPhaseSequence },
        { "IntendedPhaseStartDate", DC::IntendedPhaseStartDate },
        { "IntendedPhaseEndDate", DC::IntendedPhaseEndDate },
        { "RTTreatmentPhaseIntervalSequence", DC::RTTreatmentPhaseIntervalSequence },
        { "TemporalRelationshipIntervalAnchor", DC::TemporalRelationshipIntervalAnchor },
        { "MinimumNumberOfIntervalDays", DC::MinimumNumberOfIntervalDays },
        { "MaximumNumberOfIntervalDays", DC::MaximumNumberOfIntervalDays },
        { "PertinentSOPClassesInStudy", DC::PertinentSOPClassesInStudy },
        { "PertinentSOPClassesInSeries", DC::PertinentSOPClassesInSeries },
        { "RTPrescriptionLabel", DC::RTPrescriptionLabel },
        { "RTPhysicianIntentPredecessorSequence", DC::RTPhysicianIntentPredecessorSequence },
        { "RTTreatmentApproachLabel", DC::RTTreatmentApproachLabel },
        { "RTPhysicianIntentSequence", DC::RTPhysicianIntentSequence },
        { "RTPhysicianIntentIndex", DC::RTPhysicianIntentIndex },
        { "RTTreatmentIntentType", DC::RTTreatmentIntentType },
        { "RTPhysicianIntentNarrative", DC::RTPhysicianIntentNarrative },
        { "RTProtocolCodeSequence", DC::RTProtocolCodeSequence },
        { "ReasonForSuperseding", DC::ReasonForSuperseding },
        { "RTDiagnosisCodeSequence", DC::RTDiagnosisCodeSequence },
        { "ReferencedRTPhysicianIntentIndex", DC::ReferencedRTPhysicianIntentIndex },
        { "RTPhysicianIntentInputInstanceSequence", DC::RTPhysicianIntentInputInstanceSequence },
        { "RTAnatomicPrescriptionSequence", DC::RTAnatomicPrescriptionSequence },
        { "PriorTreatmentDoseDescription", DC::PriorTreatmentDoseDescription },
        { "PriorTreatmentReferenceSequence", DC::PriorTreatmentReferenceSequence },
        { "DosimetricObjectiveEvaluationScope", DC::DosimetricObjectiveEvaluationScope },
        { "TherapeuticRoleCategoryCodeSequence", DC::TherapeuticRoleCategoryCodeSequence },
        { "TherapeuticRoleTypeCodeSequence", DC::TherapeuticRoleTypeCodeSequence },
        { "ConceptualVolumeOptimizationPrecedence", DC::ConceptualVolumeOptimizationPrecedence },
        { "ConceptualVolumeCategoryCodeSequence", DC::ConceptualVolumeCategoryCodeSequence },
        { "ConceptualVolumeBlockingConstraint", DC::ConceptualVolumeBlockingConstraint },
        { "ConceptualVolumeTypeCodeSequence", DC::ConceptualVolumeTypeCodeSequence },
        { "ConceptualVolumeTypeModifierCodeSequence", DC::ConceptualVolumeTypeModifierCodeSequence },
        { "RTPrescriptionSequence", DC::RTPrescriptionSequence },
        { "DosimetricObjectiveSequence", DC::DosimetricObjectiveSequence },
        { "DosimetricObjectiveTypeCodeSequence", DC::DosimetricObjectiveTypeCodeSequence },
        { "DosimetricObjectiveUID", DC::DosimetricObjectiveUID },
        { "ReferencedDosimetricObjectiveUID", DC::ReferencedDosimetricObjectiveUID },
        { "DosimetricObjectiveParameterSequence", DC::DosimetricObjectiveParameterSequence },
        { "ReferencedDosimetricObjectivesSequence", DC::ReferencedDosimetricObjectivesSequence },
        { "AbsoluteDosimetricObjectiveFlag", DC::AbsoluteDosimetricObjectiveFlag },
        { "DosimetricObjectiveWeight", DC::DosimetricObjectiveWeight },
        { "DosimetricObjectivePurpose", DC::DosimetricObjectivePurpose },
        { "PlanningInputInformationSequence", DC::PlanningInputInformationSequence },
        { "TreatmentSite", DC::TreatmentSite },
        { "TreatmentSiteCodeSequence", DC::TreatmentSiteCodeSequence },
        { "FractionPatternSequence", DC::FractionPatternSequence },
        { "TreatmentTechniqueNotes", DC::TreatmentTechniqueNotes },
        { "PrescriptionNotes", DC::PrescriptionNotes },
        { "NumberOfIntervalFractions", DC::NumberOfIntervalFractions },
        { "NumberOfFractions", DC::NumberOfFractions },
        { "IntendedDeliveryDuration", DC::IntendedDeliveryDuration },
        { "FractionationNotes", DC::FractionationNotes },
        { "RTTreatmentTechniqueCodeSequence", DC::RTTreatmentTechniqueCodeSequence },
        { "PrescriptionNotesSequence", DC::PrescriptionNotesSequence },
        { "FractionBasedRelationshipSequence", DC::FractionBasedRelationshipSequence },
        { "FractionBasedRelationshipIntervalAnchor", DC::FractionBasedRelationshipIntervalAnchor },
        { "MinimumHoursBetweenFractions", DC::MinimumHoursBetweenFractions },
        { "IntendedFractionStartTime", DC::IntendedFractionStartTime },
        { "IntendedStartDayOfWeek", DC::IntendedStartDayOfWeek },
        { "WeekdayFractionPatternSequence", DC::WeekdayFractionPatternSequence },
        { "DeliveryTimeStructureCodeSequence", DC::DeliveryTimeStructureCodeSequence },
        { "TreatmentSiteModifierCodeSequence", DC::TreatmentSiteModifierCodeSequence },
        { "RoboticBaseLocationIndicator", DC::RoboticBaseLocationIndicator },
        { "RoboticPathNodeSetCodeSequence", DC::RoboticPathNodeSetCodeSequence },
        { "RoboticNodeIdentifier", DC::RoboticNodeIdentifier },
        { "RTTreatmentSourceCoordinates", DC::RTTreatmentSourceCoordinates },
        { "RadiationSourceCoordinateSystemYawAngle", DC::RadiationSourceCoordinateSystemYawAngle },
        { "RadiationSourceCoordinateSystemRollAngle", DC::RadiationSourceCoordinateSystemRollAngle },
        { "RadiationSourceCoordinateSystemPitchAngle", DC::RadiationSourceCoordinateSystemPitchAngle },
        { "RoboticPathControlPointSequence", DC::RoboticPathControlPointSequence },
        { "TomotherapeuticControlPointSequence", DC::TomotherapeuticControlPointSequence },
        { "TomotherapeuticLeafOpenDurations", DC::TomotherapeuticLeafOpenDurations },
        { "TomotherapeuticLeafInitialClosedDurations", DC::TomotherapeuticLeafInitialClosedDurations },
        { "ConceptualVolumeIdentificationSequence", DC::ConceptualVolumeIdentificationSequence },
        { "Arbitrary", DC::Arbitrary },
        { "TextComments", DC::TextComments },
        { "ResultsID", DC::ResultsID },
        { "ResultsIDIssuer", DC::ResultsIDIssuer },
        { "ReferencedInterpretationSequence", DC::ReferencedInterpretationSequence },
        { "ReportProductionStatusTrial", DC::ReportProductionStatusTrial },
        { "InterpretationRecordedDate", DC::InterpretationRecordedDate },
        { "InterpretationRecordedTime", DC::InterpretationRecordedTime },
        { "InterpretationRecorder", DC::InterpretationRecorder },
        { "ReferenceToRecordedSound", DC::ReferenceToRecordedSound },
        { "InterpretationTranscriptionDate", DC::InterpretationTranscriptionDate },
        { "InterpretationTranscriptionTime", DC::InterpretationTranscriptionTime },
        { "InterpretationTranscriber", DC::InterpretationTranscriber },
        { "InterpretationText", DC::InterpretationText },
        { "InterpretationAuthor", DC::InterpretationAuthor },
        { "InterpretationApproverSequence", DC::InterpretationApproverSequence },
        { "InterpretationApprovalDate", DC::InterpretationApprovalDate },
        { "InterpretationApprovalTime", DC::InterpretationApprovalTime },
        { "PhysicianApprovingInterpretation", DC::PhysicianApprovingInterpretation },
        { "InterpretationDiagnosisDescription", DC::InterpretationDiagnosisDescription },
        { "InterpretationDiagnosisCodeSequence", DC::InterpretationDiagnosisCodeSequence },
        { "ResultsDistributionListSequence", DC::ResultsDistributionListSequence },
        { "DistributionName", DC::DistributionName },
        { "DistributionAddress", DC::DistributionAddress },
        { "InterpretationID", DC::InterpretationID },
        { "InterpretationIDIssuer", DC::InterpretationIDIssuer },
        { "InterpretationTypeID", DC::InterpretationTypeID },
        { "InterpretationStatusID", DC::InterpretationStatusID },
        { "Impressions", DC::Impressions },
        { "ResultsComments", DC::ResultsComments },
        { "LowEnergyDetectors", DC::LowEnergyDetectors },
        { "HighEnergyDetectors", DC::HighEnergyDetectors },
        { "DetectorGeometrySequence", DC::DetectorGeometrySequence },
        { "ThreatROIVoxelSequence", DC::ThreatROIVoxelSequence },
        { "ThreatROIBase", DC::ThreatROIBase },
        { "ThreatROIExtents", DC::ThreatROIExtents },
        { "ThreatROIBitmap", DC::ThreatROIBitmap },
        { "RouteSegmentID", DC::RouteSegmentID },
        { "GantryType", DC::GantryType },
        { "OOIOwnerType", DC::OOIOwnerType },
        { "RouteSegmentSequence", DC::RouteSegmentSequence },
        { "PotentialThreatObjectID", DC::PotentialThreatObjectID },
        { "ThreatSequence", DC::ThreatSequence },
        { "ThreatCategory", DC::ThreatCategory },
        { "ThreatCategoryDescription", DC::ThreatCategoryDescription },
        { "ATDAbilityAssessment", DC::ATDAbilityAssessment },
        { "ATDAssessmentFlag", DC::ATDAssessmentFlag },
        { "ATDAssessmentProbability", DC::ATDAssessmentProbability },
        { "Mass", DC::Mass },
        { "Density", DC::Density },
        { "ZEffective", DC::ZEffective },
        { "BoardingPassID", DC::BoardingPassID },
        { "CenterOfMass", DC::CenterOfMass },
        { "CenterOfPTO", DC::CenterOfPTO },
        { "BoundingPolygon", DC::BoundingPolygon },
        { "RouteSegmentStartLocationID", DC::RouteSegmentStartLocationID },
        { "RouteSegmentEndLocationID", DC::RouteSegmentEndLocationID },
        { "RouteSegmentLocationIDType", DC::RouteSegmentLocationIDType },
        { "AbortReason", DC::AbortReason },
        { "VolumeOfPTO", DC::VolumeOfPTO },
        { "AbortFlag", DC::AbortFlag },
        { "RouteSegmentStartTime", DC::RouteSegmentStartTime },
        { "RouteSegmentEndTime", DC::RouteSegmentEndTime },
        { "TDRType", DC::TDRType },
        { "InternationalRouteSegment", DC::InternationalRouteSegment },
        { "ThreatDetectionAlgorithmAndVersion", DC::ThreatDetectionAlgorithmAndVersion },
        { "AssignedLocation", DC::AssignedLocation },
        { "AlarmDecisionTime", DC::AlarmDecisionTime },
        { "AlarmDecision", DC::AlarmDecision },
        { "NumberOfTotalObjects", DC::NumberOfTotalObjects },
        { "NumberOfAlarmObjects", DC::NumberOfAlarmObjects },
        { "PTORepresentationSequence", DC::PTORepresentationSequence },
        { "ATDAssessmentSequence", DC::ATDAssessmentSequence },
        { "TIPType", DC::TIPType },
        { "DICOSVersion", DC::DICOSVersion },
        { "OOIOwnerCreationTime", DC::OOIOwnerCreationTime },
        { "OOIType", DC::OOIType },
        { "OOISize", DC::OOISize },
        { "AcquisitionStatus", DC::AcquisitionStatus },
        { "BasisMaterialsCodeSequence", DC::BasisMaterialsCodeSequence },
        { "PhantomType", DC::PhantomType },
        { "OOIOwnerSequence", DC::OOIOwnerSequence },
        { "ScanType", DC::ScanType },
        { "ItineraryID", DC::ItineraryID },
        { "ItineraryIDType", DC::ItineraryIDType },
        { "ItineraryIDAssigningAuthority", DC::ItineraryIDAssigningAuthority },
        { "RouteID", DC::RouteID },
        { "RouteIDAssigningAuthority", DC::RouteIDAssigningAuthority },
        { "InboundArrivalType", DC::InboundArrivalType },
        { "CarrierID", DC::CarrierID },
        { "CarrierIDAssigningAuthority", DC::CarrierIDAssigningAuthority },
        { "SourceOrientation", DC::SourceOrientation },
        { "SourcePosition", DC::SourcePosition },
        { "BeltHeight", DC::BeltHeight },
        { "AlgorithmRoutingCodeSequence", DC::AlgorithmRoutingCodeSequence },
        { "TransportClassification", DC::TransportClassification },
        { "OOITypeDescriptor", DC::OOITypeDescriptor },
        { "TotalProcessingTime", DC::TotalProcessingTime },
        { "DetectorCalibrationData", DC::DetectorCalibrationData },
        { "AdditionalScreeningPerformed", DC::AdditionalScreeningPerformed },
        { "AdditionalInspectionSelectionCriteria", DC::AdditionalInspectionSelectionCriteria },
        { "AdditionalInspectionMethodSequence", DC::AdditionalInspectionMethodSequence },
        { "AITDeviceType", DC::AITDeviceType },
        { "QRMeasurementsSequence", DC::QRMeasurementsSequence },
        { "TargetMaterialSequence", DC::TargetMaterialSequence },
        { "SNRThreshold", DC::SNRThreshold },
        { "ImageScaleRepresentation", DC::ImageScaleRepresentation },
        { "ReferencedPTOSequence", DC::ReferencedPTOSequence },
        { "ReferencedTDRInstanceSequence", DC::ReferencedTDRInstanceSequence },
        { "PTOLocationDescription", DC::PTOLocationDescription },
        { "AnomalyLocatorIndicatorSequence", DC::AnomalyLocatorIndicatorSequence },
        { "AnomalyLocatorIndicator", DC::AnomalyLocatorIndicator },
        { "PTORegionSequence", DC::PTORegionSequence },
        { "InspectionSelectionCriteria", DC::InspectionSelectionCriteria },
        { "SecondaryInspectionMethodSequence", DC::SecondaryInspectionMethodSequence },
        { "PRCSToRCSOrientation", DC::PRCSToRCSOrientation },
        { "MACParametersSequence", DC::MACParametersSequence },
        { "CurveDimensions", DC::CurveDimensions },
        { "NumberOfPoints", DC::NumberOfPoints },
        { "TypeOfData", DC::TypeOfData },
        { "CurveDescription", DC::CurveDescription },
        { "AxisUnits", DC::AxisUnits },
        { "AxisLabels", DC::AxisLabels },
        { "DataValueRepresentation", DC::DataValueRepresentation },
        { "MinimumCoordinateValue", DC::MinimumCoordinateValue },
        { "MaximumCoordinateValue", DC::MaximumCoordinateValue },
        { "CurveRange", DC::CurveRange },
        { "CurveDataDescriptor", DC::CurveDataDescriptor },
        { "CoordinateStartValue", DC::CoordinateStartValue },
        { "CoordinateStepValue", DC::CoordinateStepValue },
        { "CurveActivationLayer", DC::CurveActivationLayer },
        { "AudioType", DC::AudioType },
        { "AudioSampleFormat", DC::AudioSampleFormat },
        { "NumberOfChannels", DC::NumberOfChannels },
        { "NumberOfSamples", DC::NumberOfSamples },
        { "SampleRate", DC::SampleRate },
        { "TotalTime", DC::TotalTime },
        { "AudioSampleData", DC::AudioSampleData },
        { "AudioComments", DC::AudioComments },
        { "CurveLabel", DC::CurveLabel },
        { "CurveReferencedOverlaySequence", DC::CurveReferencedOverlaySequence },
        { "CurveReferencedOverlayGroup", DC::CurveReferencedOverlayGroup },
        { "CurveData", DC::CurveData },
        { "CurveDimensions2", DC::CurveDimensions2 },
        { "NumberOfPoints2", DC::NumberOfPoints2 },
        { "TypeOfData2", DC::TypeOfData2 },
        { "CurveDescription2", DC::CurveDescription2 },
        { "AxisUnits2", DC::AxisUnits2 },
        { "AxisLabels2", DC::AxisLabels2 },
        { "DataValueRepresentation2", DC::DataValueRepresentation2 },
        { "MinimumCoordinateValue2", DC::MinimumCoordinateValue2 },
        { "MaximumCoordinateValue2", DC::MaximumCoordinateValue2 },
        { "CurveRange2", DC::CurveRange2 },
        { "CurveDataDescriptor2", DC::CurveDataDescriptor2 },
        { "CoordinateStartValue2", DC::CoordinateStartValue2 },
        { "CoordinateStepValue2", DC::CoordinateStepValue2 },
        { "CurveActivationLayer2", DC::CurveActivationLayer2 },
        { "AudioType2", DC::AudioType2 },
        { "AudioSampleFormat2", DC::AudioSampleFormat2 },
        { "NumberOfChannels2", DC::NumberOfChannels2 },
        { "NumberOfSamples2", DC::NumberOfSamples2 },
        { "SampleRate2", DC::SampleRate2 },
        { "TotalTime2", DC::TotalTime2 },
        { "AudioSampleData2", DC::AudioSampleData2 },
        { "AudioComments2", DC::AudioComments2 },
        { "CurveLabel2", DC::CurveLabel2 },
        { "CurveReferencedOverlaySequence2", DC::CurveReferencedOverlaySequence2 },
        { "CurveReferencedOverlayGroup2", DC::CurveReferencedOverlayGroup2 },
        { "CurveData2", DC::CurveData2 },
        { "CurveDimensions3", DC::CurveDimensions3 },
        { "NumberOfPoints3", DC::NumberOfPoints3 },
        { "TypeOfData3", DC::TypeOfData3 },
        { "CurveDescription3", DC::CurveDescription3 },
        { "AxisUnits3", DC::AxisUnits3 },
        { "AxisLabels3", DC::AxisLabels3 },
        { "DataValueRepresentation3", DC::DataValueRepresentation3 },
        { "MinimumCoordinateValue3", DC::MinimumCoordinateValue3 },
        { "MaximumCoordinateValue3", DC::MaximumCoordinateValue3 },
        { "CurveRange3", DC::CurveRange3 },
        { "CurveDataDescriptor3", DC::CurveDataDescriptor3 },
        { "CoordinateStartValue3", DC::CoordinateStartValue3 },
        { "CoordinateStepValue3", DC::CoordinateStepValue3 },
        { "CurveActivationLayer3", DC::CurveActivationLayer3 },
        { "AudioType3", DC::AudioType3 },
        { "AudioSampleFormat3", DC::AudioSampleFormat3 },
        { "NumberOfChannels3", DC::NumberOfChannels3 },
        { "NumberOfSamples3", DC::NumberOfSamples3 },
        { "SampleRate3", DC::SampleRate3 },
        { "TotalTime3", DC::TotalTime3 },
        { "AudioSampleData3", DC::AudioSampleData3 },
        { "AudioComments3", DC::AudioComments3 },
        { "CurveLabel3", DC::CurveLabel3 },
        { "CurveReferencedOverlaySequence3", DC::CurveReferencedOverlaySequence3 },
        { "CurveReferencedOverlayGroup3", DC::CurveReferencedOverlayGroup3 },
        { "CurveData3", DC::CurveData3 },
        { "CurveDimensions4", DC::CurveDimensions4 },
        { "NumberOfPoints4", DC::NumberOfPoints4 },
        { "TypeOfData4", DC::TypeOfData4 },
        { "CurveDescription4", DC::CurveDescription4 },
        { "AxisUnits4", DC::AxisUnits4 },
        { "AxisLabels4", DC::AxisLabels4 },
        { "DataValueRepresentation4", DC::DataValueRepresentation4 },
        { "MinimumCoordinateValue4", DC::MinimumCoordinateValue4 },
        { "MaximumCoordinateValue4", DC::MaximumCoordinateValue4 },
        { "CurveRange4", DC::CurveRange4 },
        { "CurveDataDescriptor4", DC::CurveDataDescriptor4 },
        { "CoordinateStartValue4", DC::CoordinateStartValue4 },
        { "CoordinateStepValue4", DC::CoordinateStepValue4 },
        { "CurveActivationLayer4", DC::CurveActivationLayer4 },
        { "AudioType4", DC::AudioType4 },
        { "AudioSampleFormat4", DC::AudioSampleFormat4 },
        { "NumberOfChannels4", DC::NumberOfChannels4 },
        { "NumberOfSamples4", DC::NumberOfSamples4 },
        { "SampleRate4", DC::SampleRate4 },
        { "TotalTime4", DC::TotalTime4 },
        { "AudioSampleData4", DC::AudioSampleData4 },
        { "AudioComments4", DC::AudioComments4 },
        { "CurveLabel4", DC::CurveLabel4 },
        { "CurveReferencedOverlaySequence4", DC::CurveReferencedOverlaySequence4 },
        { "CurveReferencedOverlayGroup4", DC::CurveReferencedOverlayGroup4 },
        { "CurveData4", DC::CurveData4 },
        { "CurveDimensions5", DC::CurveDimensions5 },
        { "NumberOfPoints5", DC::NumberOfPoints5 },
        { "TypeOfData5", DC::TypeOfData5 },
        { "CurveDescription5", DC::CurveDescription5 },
        { "AxisUnits5", DC::AxisUnits5 },
        { "AxisLabels5", DC::AxisLabels5 },
        { "DataValueRepresentation5", DC::DataValueRepresentation5 },
        { "MinimumCoordinateValue5", DC::MinimumCoordinateValue5 },
        { "MaximumCoordinateValue5", DC::MaximumCoordinateValue5 },
        { "CurveRange5", DC::CurveRange5 },
        { "CurveDataDescriptor5", DC::CurveDataDescriptor5 },
        { "CoordinateStartValue5", DC::CoordinateStartValue5 },
        { "CoordinateStepValue5", DC::CoordinateStepValue5 },
        { "CurveActivationLayer5", DC::CurveActivationLayer5 },
        { "AudioType5", DC::AudioType5 },
        { "AudioSampleFormat5", DC::AudioSampleFormat5 },
        { "NumberOfChannels5", DC::NumberOfChannels5 },
        { "NumberOfSamples5", DC::NumberOfSamples5 },
        { "SampleRate5", DC::SampleRate5 },
        { "TotalTime5", DC::TotalTime5 },
        { "AudioSampleData5", DC::AudioSampleData5 },
        { "AudioComments5", DC::AudioComments5 },
        { "CurveLabel5", DC::CurveLabel5 },
        { "CurveReferencedOverlaySequence5", DC::CurveReferencedOverlaySequence5 },
        { "CurveReferencedOverlayGroup5", DC::CurveReferencedOverlayGroup5 },
        { "CurveData5", DC::CurveData5 },
        { "CurveDimensions6", DC::CurveDimensions6 },
        { "NumberOfPoints6", DC::NumberOfPoints6 },
        { "TypeOfData6", DC::TypeOfData6 },
        { "CurveDescription6", DC::CurveDescription6 },
        { "AxisUnits6", DC::AxisUnits6 },
        { "AxisLabels6", DC::AxisLabels6 },
        { "DataValueRepresentation6", DC::DataValueRepresentation6 },
        { "MinimumCoordinateValue6", DC::MinimumCoordinateValue6 },
        { "MaximumCoordinateValue6", DC::MaximumCoordinateValue6 },
        { "CurveRange6", DC::CurveRange6 },
        { "CurveDataDescriptor6", DC::CurveDataDescriptor6 },
        { "CoordinateStartValue6", DC::CoordinateStartValue6 },
        { "CoordinateStepValue6", DC::CoordinateStepValue6 },
        { "CurveActivationLayer6", DC::CurveActivationLayer6 },
        { "AudioType6", DC::AudioType6 },
        { "AudioSampleFormat6", DC::AudioSampleFormat6 },
        { "NumberOfChannels6", DC::NumberOfChannels6 },
        { "NumberOfSamples6", DC::NumberOfSamples6 },
        { "SampleRate6", DC::SampleRate6 },
        { "TotalTime6", DC::TotalTime6 },
        { "AudioSampleData6", DC::AudioSampleData6 },
        { "AudioComments6", DC::AudioComments6 },
        { "CurveLabel6", DC::CurveLabel6 },
        { "CurveReferencedOverlaySequence6", DC::CurveReferencedOverlaySequence6 },
        { "CurveReferencedOverlayGroup6", DC::CurveReferencedOverlayGroup6 },
        { "CurveData6", DC::CurveData6 },
        { "CurveDimensions7", DC::CurveDimensions7 },
        { "NumberOfPoints7", DC::NumberOfPoints7 },
        { "TypeOfData7", DC::TypeOfData7 },
        { "CurveDescription7", DC::CurveDescription7 },
        { "AxisUnits7", DC::AxisUnits7 },
        { "AxisLabels7", DC::AxisLabels7 },
        { "DataValueRepresentation7", DC::DataValueRepresentation7 },
        { "MinimumCoordinateValue7", DC::MinimumCoordinateValue7 },
        { "MaximumCoordinateValue7", DC::MaximumCoordinateValue7 },
        { "CurveRange7", DC::CurveRange7 },
        { "CurveDataDescriptor7", DC::CurveDataDescriptor7 },
        { "CoordinateStartValue7", DC::CoordinateStartValue7 },
        { "CoordinateStepValue7", DC::CoordinateStepValue7 },
        { "CurveActivationLayer7", DC::CurveActivationLayer7 },
        { "AudioType7", DC::AudioType7 },
        { "AudioSampleFormat7", DC::AudioSampleFormat7 },
        { "NumberOfChannels7", DC::NumberOfChannels7 },
        { "NumberOfSamples7", DC::NumberOfSamples7 },
        { "SampleRate7", DC::SampleRate7 },
        { "TotalTime7", DC::TotalTime7 },
        { "AudioSampleData7", DC::AudioSampleData7 },
        { "AudioComments7", DC::AudioComments7 },
        { "CurveLabel7", DC::CurveLabel7 },
        { "CurveReferencedOverlaySequence7", DC::CurveReferencedOverlaySequence7 },
        { "CurveReferencedOverlayGroup7", DC::CurveReferencedOverlayGroup7 },
        { "CurveData7", DC::CurveData7 },
        { "CurveDimensions8", DC::CurveDimensions8 },
        { "NumberOfPoints8", DC::NumberOfPoints8 },
        { "TypeOfData8", DC::TypeOfData8 },
        { "CurveDescription8", DC::CurveDescription8 },
        { "AxisUnits8", DC::AxisUnits8 },
        { "AxisLabels8", DC::AxisLabels8 },
        { "DataValueRepresentation8", DC::DataValueRepresentation8 },
        { "MinimumCoordinateValue8", DC::MinimumCoordinateValue8 },
        { "MaximumCoordinateValue8", DC::MaximumCoordinateValue8 },
        { "CurveRange8", DC::CurveRange8 },
        { "CurveDataDescriptor8", DC::CurveDataDescriptor8 },
        { "CoordinateStartValue8", DC::CoordinateStartValue8 },
        { "CoordinateStepValue8", DC::CoordinateStepValue8 },
        { "CurveActivationLayer8", DC::CurveActivationLayer8 },
        { "AudioType8", DC::AudioType8 },
        { "AudioSampleFormat8", DC::AudioSampleFormat8 },
        { "NumberOfChannels8", DC::NumberOfChannels8 },
        { "NumberOfSamples8", DC::NumberOfSamples8 },
        { "SampleRate8", DC::SampleRate8 },
        { "TotalTime8", DC::TotalTime8 },
        { "AudioSampleData8", DC::AudioSampleData8 },
        { "AudioComments8", DC::AudioComments8 },
        { "CurveLabel8", DC::CurveLabel8 },
        { "CurveReferencedOverlaySequence8", DC::CurveReferencedOverlaySequence8 },
        { "CurveReferencedOverlayGroup8", DC::CurveReferencedOverlayGroup8 },
        { "CurveData8", DC::CurveData8 },
        { "CurveDimensions9", DC::CurveDimensions9 },
        { "NumberOfPoints9", DC::NumberOfPoints9 },
        { "TypeOfData9", DC::TypeOfData9 },
        { "CurveDescription9", DC::CurveDescription9 },
        { "AxisUnits9", DC::AxisUnits9 },
        { "AxisLabels9", DC::AxisLabels9 },
        { "DataValueRepresentation9", DC::DataValueRepresentation9 },
        { "MinimumCoordinateValue9", DC::MinimumCoordinateValue9 },
        { "MaximumCoordinateValue9", DC::MaximumCoordinateValue9 },
        { "CurveRange9", DC::CurveRange9 },
        { "CurveDataDescriptor9", DC::CurveDataDescriptor9 },
        { "CoordinateStartValue9", DC::CoordinateStartValue9 },
        { "CoordinateStepValue9", DC::CoordinateStepValue9 },
        { "CurveActivationLayer9", DC::CurveActivationLayer9 },
        { "AudioType9", DC::AudioType9 },
        { "AudioSampleFormat9", DC::AudioSampleFormat9 },
        { "NumberOfChannels9", DC::NumberOfChannels9 },
        { "NumberOfSamples9", DC::NumberOfSamples9 },
        { "SampleRate9", DC::SampleRate9 },
        { "TotalTime9", DC::TotalTime9 },
        { "AudioSampleData9", DC::AudioSampleData9 },
        { "AudioComments9", DC::AudioComments9 },
        { "CurveLabel9", DC::CurveLabel9 },
        { "CurveReferencedOverlaySequence9", DC::CurveReferencedOverlaySequence9 },
        { "CurveReferencedOverlayGroup9", DC::CurveReferencedOverlayGroup9 },
        { "CurveData9", DC::CurveData9 },
        { "CurveDimensions10", DC::CurveDimensions10 },
        { "NumberOfPoints10", DC::NumberOfPoints10 },
        { "TypeOfData10", DC::TypeOfData10 },
        { "CurveDescription10", DC::CurveDescription10 },
        { "AxisUnits10", DC::AxisUnits10 },
        { "AxisLabels10", DC::AxisLabels10 },
        { "DataValueRepresentation10", DC::DataValueRepresentation10 },
        { "MinimumCoordinateValue10", DC::MinimumCoordinateValue10 },
        { "MaximumCoordinateValue10", DC::MaximumCoordinateValue10 },
        { "CurveRange10", DC::CurveRange10 },
        { "CurveDataDescriptor10", DC::CurveDataDescriptor10 },
        { "CoordinateStartValue10", DC::CoordinateStartValue10 },
        { "CoordinateStepValue10", DC::CoordinateStepValue10 },
        { "CurveActivationLayer10", DC::CurveActivationLayer10 },
        { "AudioType10", DC::AudioType10 },
        { "AudioSampleFormat10", DC::AudioSampleFormat10 },
        { "NumberOfChannels10", DC::NumberOfChannels10 },
        { "NumberOfSamples10", DC::NumberOfSamples10 },
        { "SampleRate10", DC::SampleRate10 },
        { "TotalTime10", DC::TotalTime10 },
        { "AudioSampleData10", DC::AudioSampleData10 },
        { "AudioComments10", DC::AudioComments10 },
        { "CurveLabel10", DC::CurveLabel10 },
        { "CurveReferencedOverlaySequence10", DC::CurveReferencedOverlaySequence10 },
        { "CurveReferencedOverlayGroup10", DC::CurveReferencedOverlayGroup10 },
        { "CurveData10", DC::CurveData10 },
        { "CurveDimensions11", DC::CurveDimensions11 },
        { "NumberOfPoints11", DC::NumberOfPoints11 },
        { "TypeOfData11", DC::TypeOfData11 },
        { "CurveDescription11", DC::CurveDescription11 },
        { "AxisUnits11", DC::AxisUnits11 },
        { "AxisLabels11", DC::AxisLabels11 },
        { "DataValueRepresentation11", DC::DataValueRepresentation11 },
        { "MinimumCoordinateValue11", DC::MinimumCoordinateValue11 },
        { "MaximumCoordinateValue11", DC::MaximumCoordinateValue11 },
        { "CurveRange11", DC::CurveRange11 },
        { "CurveDataDescriptor11", DC::CurveDataDescriptor11 },
        { "CoordinateStartValue11", DC::CoordinateStartValue11 },
        { "CoordinateStepValue11", DC::CoordinateStepValue11 },
        { "CurveActivationLayer11", DC::CurveActivationLayer11 },
        { "AudioType11", DC::AudioType11 },
        { "AudioSampleFormat11", DC::AudioSampleFormat11 },
        { "NumberOfChannels11", DC::NumberOfChannels11 },
        { "NumberOfSamples11", DC::NumberOfSamples11 },
        { "SampleRate11", DC::SampleRate11 },
        { "TotalTime11", DC::TotalTime11 },
        { "AudioSampleData11", DC::AudioSampleData11 },
        { "AudioComments11", DC::AudioComments11 },
        { "CurveLabel11", DC::CurveLabel11 },
        { "CurveReferencedOverlaySequence11", DC::CurveReferencedOverlaySequence11 },
        { "CurveReferencedOverlayGroup11", DC::CurveReferencedOverlayGroup11 },
        { "CurveData11", DC::CurveData11 },
        { "CurveDimensions12", DC::CurveDimensions12 },
        { "NumberOfPoints12", DC::NumberOfPoints12 },
        { "TypeOfData12", DC::TypeOfData12 },
        { "CurveDescription12", DC::CurveDescription12 },
        { "AxisUnits12", DC::AxisUnits12 },
        { "AxisLabels12", DC::AxisLabels12 },
        { "DataValueRepresentation12", DC::DataValueRepresentation12 },
        { "MinimumCoordinateValue12", DC::MinimumCoordinateValue12 },
        { "MaximumCoordinateValue12", DC::MaximumCoordinateValue12 },
        { "CurveRange12", DC::CurveRange12 },
        { "CurveDataDescriptor12", DC::CurveDataDescriptor12 },
        { "CoordinateStartValue12", DC::CoordinateStartValue12 },
        { "CoordinateStepValue12", DC::CoordinateStepValue12 },
        { "CurveActivationLayer12", DC::CurveActivationLayer12 },
        { "AudioType12", DC::AudioType12 },
        { "AudioSampleFormat12", DC::AudioSampleFormat12 },
        { "NumberOfChannels12", DC::NumberOfChannels12 },
        { "NumberOfSamples12", DC::NumberOfSamples12 },
        { "SampleRate12", DC::SampleRate12 },
        { "TotalTime12", DC::TotalTime12 },
        { "AudioSampleData12", DC::AudioSampleData12 },
        { "AudioComments12", DC::AudioComments12 },
        { "CurveLabel12", DC::CurveLabel12 },
        { "CurveReferencedOverlaySequence12", DC::CurveReferencedOverlaySequence12 },
        { "CurveReferencedOverlayGroup12", DC::CurveReferencedOverlayGroup12 },
        { "CurveData12", DC::CurveData12 },
        { "CurveDimensions13", DC::CurveDimensions13 },
        { "NumberOfPoints13", DC::NumberOfPoints13 },
        { "TypeOfData13", DC::TypeOfData13 },
        { "CurveDescription13", DC::CurveDescription13 },
        { "AxisUnits13", DC::AxisUnits13 },
        { "AxisLabels13", DC::AxisLabels13 },
        { "DataValueRepresentation13", DC::DataValueRepresentation13 },
        { "MinimumCoordinateValue13", DC::MinimumCoordinateValue13 },
        { "MaximumCoordinateValue13", DC::MaximumCoordinateValue13 },
        { "CurveRange13", DC::CurveRange13 },
        { "CurveDataDescriptor13", DC::CurveDataDescriptor13 },
        { "CoordinateStartValue13", DC::CoordinateStartValue13 },
        { "CoordinateStepValue13", DC::CoordinateStepValue13 },
        { "CurveActivationLayer13", DC::CurveActivationLayer13 },
        { "AudioType13", DC::AudioType13 },
        { "AudioSampleFormat13", DC::AudioSampleFormat13 },
        { "NumberOfChannels13", DC::NumberOfChannels13 },
        { "NumberOfSamples13", DC::NumberOfSamples13 },
        { "SampleRate13", DC::SampleRate13 },
        { "TotalTime13", DC::TotalTime13 },
        { "AudioSampleData13", DC::AudioSampleData13 },
        { "AudioComments13", DC::AudioComments13 },
        { "CurveLabel13", DC::CurveLabel13 },
        { "CurveReferencedOverlaySequence13", DC::CurveReferencedOverlaySequence13 },
        { "CurveReferencedOverlayGroup13", DC::CurveReferencedOverlayGroup13 },
        { "CurveData13", DC::CurveData13 },
        { "CurveDimensions14", DC::CurveDimensions14 },
        { "NumberOfPoints14", DC::NumberOfPoints14 },
        { "TypeOfData14", DC::TypeOfData14 },
        { "CurveDescription14", DC::CurveDescription14 },
        { "AxisUnits14", DC::AxisUnits14 },
        { "AxisLabels14", DC::AxisLabels14 },
        { "DataValueRepresentation14", DC::DataValueRepresentation14 },
        { "MinimumCoordinateValue14", DC::MinimumCoordinateValue14 },
        { "MaximumCoordinateValue14", DC::MaximumCoordinateValue14 },
        { "CurveRange14", DC::CurveRange14 },
        { "CurveDataDescriptor14", DC::CurveDataDescriptor14 },
        { "CoordinateStartValue14", DC::CoordinateStartValue14 },
        { "CoordinateStepValue14", DC::CoordinateStepValue14 },
        { "CurveActivationLayer14", DC::CurveActivationLayer14 },
        { "AudioType14", DC::AudioType14 },
        { "AudioSampleFormat14", DC::AudioSampleFormat14 },
        { "NumberOfChannels14", DC::NumberOfChannels14 },
        { "NumberOfSamples14", DC::NumberOfSamples14 },
        { "SampleRate14", DC::SampleRate14 },
        { "TotalTime14", DC::TotalTime14 },
        { "AudioSampleData14", DC::AudioSampleData14 },
        { "AudioComments14", DC::AudioComments14 },
        { "CurveLabel14", DC::CurveLabel14 },
        { "CurveReferencedOverlaySequence14", DC::CurveReferencedOverlaySequence14 },
        { "CurveReferencedOverlayGroup14", DC::CurveReferencedOverlayGroup14 },
        { "CurveData14", DC::CurveData14 },
        { "CurveDimensions15", DC::CurveDimensions15 },
        { "NumberOfPoints15", DC::NumberOfPoints15 },
        { "TypeOfData15", DC::TypeOfData15 },
        { "CurveDescription15", DC::CurveDescription15 },
        { "AxisUnits15", DC::AxisUnits15 },
        { "AxisLabels15", DC::AxisLabels15 },
        { "DataValueRepresentation15", DC::DataValueRepresentation15 },
        { "MinimumCoordinateValue15", DC::MinimumCoordinateValue15 },
        { "MaximumCoordinateValue15", DC::MaximumCoordinateValue15 },
        { "CurveRange15", DC::CurveRange15 },
        { "CurveDataDescriptor15", DC::CurveDataDescriptor15 },
        { "CoordinateStartValue15", DC::CoordinateStartValue15 },
        { "CoordinateStepValue15", DC::CoordinateStepValue15 },
        { "CurveActivationLayer15", DC::CurveActivationLayer15 },
        { "AudioType15", DC::AudioType15 },
        { "AudioSampleFormat15", DC::AudioSampleFormat15 },
        { "NumberOfChannels15", DC::NumberOfChannels15 },
        { "NumberOfSamples15", DC::NumberOfSamples15 },
        { "SampleRate15", DC::SampleRate15 },
        { "TotalTime15", DC::TotalTime15 },
        { "AudioSampleData15", DC::AudioSampleData15 },
        { "AudioComments15", DC::AudioComments15 },
        { "CurveLabel15", DC::CurveLabel15 },
        { "CurveReferencedOverlaySequence15", DC::CurveReferencedOverlaySequence15 },
        { "CurveReferencedOverlayGroup15", DC::CurveReferencedOverlayGroup15 },
        { "CurveData15", DC::CurveData15 },
        { "CurveDimensions16", DC::CurveDimensions16 },
        { "NumberOfPoints16", DC::NumberOfPoints16 },
        { "TypeOfData16", DC::TypeOfData16 },
        { "CurveDescription16", DC::CurveDescription16 },
        { "AxisUnits16", DC::AxisUnits16 },
        { "AxisLabels16", DC::AxisLabels16 },
        { "DataValueRepresentation16", DC::DataValueRepresentation16 },
        { "MinimumCoordinateValue16", DC::MinimumCoordinateValue16 },
        { "MaximumCoordinateValue16", DC::MaximumCoordinateValue16 },
        { "CurveRange16", DC::CurveRange16 },
        { "CurveDataDescriptor16", DC::CurveDataDescriptor16 },
        { "CoordinateStartValue16", DC::CoordinateStartValue16 },
        { "CoordinateStepValue16", DC::CoordinateStepValue16 },
        { "CurveActivationLayer16", DC::CurveActivationLayer16 },
        { "AudioType16", DC::AudioType16 },
        { "AudioSampleFormat16", DC::AudioSampleFormat16 },
        { "NumberOfChannels16", DC::NumberOfChannels16 },
        { "NumberOfSamples16", DC::NumberOfSamples16 },
        { "SampleRate16", DC::SampleRate16 },
        { "TotalTime16", DC::TotalTime16 },
        { "AudioSampleData16", DC::AudioSampleData16 },
        { "AudioComments16", DC::AudioComments16 },
        { "CurveLabel16", DC::CurveLabel16 },
        { "CurveReferencedOverlaySequence16", DC::CurveReferencedOverlaySequence16 },
        { "CurveReferencedOverlayGroup16", DC::CurveReferencedOverlayGroup16 },
        { "CurveData16", DC::CurveData16 },
        { "SharedFunctionalGroupsSequence", DC::SharedFunctionalGroupsSequence },
        { "PerFrameFunctionalGroupsSequence", DC::PerFrameFunctionalGroupsSequence },
        { "WaveformSequence", DC::WaveformSequence },
        { "ChannelMinimumValue", DC::ChannelMinimumValue },
        { "ChannelMaximumValue", DC::ChannelMaximumValue },
        { "WaveformBitsAllocated", DC::WaveformBitsAllocated },
        { "WaveformSampleInterpretation", DC::WaveformSampleInterpretation },
        { "WaveformPaddingValue", DC::WaveformPaddingValue },
        { "WaveformData", DC::WaveformData },
        { "FirstOrderPhaseCorrectionAngle", DC::FirstOrderPhaseCorrectionAngle },
        { "SpectroscopyData", DC::SpectroscopyData },
        { "OverlayRows", DC::OverlayRows },
        { "OverlayColumns", DC::OverlayColumns },
        { "OverlayPlanes", DC::OverlayPlanes },
        { "NumberOfFramesInOverlay", DC::NumberOfFramesInOverlay },
        { "OverlayDescription", DC::OverlayDescription },
        { "OverlayType", DC::OverlayType },
        { "OverlaySubtype", DC::OverlaySubtype },
        { "OverlayOrigin", DC::OverlayOrigin },
        { "ImageFrameOrigin", DC::ImageFrameOrigin },
        { "OverlayPlaneOrigin", DC::OverlayPlaneOrigin },
        { "OverlayCompressionCode", DC::OverlayCompressionCode },
        { "OverlayCompressionOriginator", DC::OverlayCompressionOriginator },
        { "OverlayCompressionLabel", DC::OverlayCompressionLabel },
        { "OverlayCompressionDescription", DC::OverlayCompressionDescription },
        { "OverlayCompressionStepPointers", DC::OverlayCompressionStepPointers },
        { "OverlayRepeatInterval", DC::OverlayRepeatInterval },
        { "OverlayBitsGrouped", DC::OverlayBitsGrouped },
        { "OverlayBitsAllocated", DC::OverlayBitsAllocated },
        { "OverlayBitPosition", DC::OverlayBitPosition },
        { "OverlayFormat", DC::OverlayFormat },
        { "OverlayLocation", DC::OverlayLocation },
        { "OverlayCodeLabel", DC::OverlayCodeLabel },
        { "OverlayNumberOfTables", DC::OverlayNumberOfTables },
        { "OverlayCodeTableLocation", DC::OverlayCodeTableLocation },
        { "OverlayBitsForCodeWord", DC::OverlayBitsForCodeWord },
        { "OverlayActivationLayer", DC::OverlayActivationLayer },
        { "OverlayDescriptorGray", DC::OverlayDescriptorGray },
        { "OverlayDescriptorRed", DC::OverlayDescriptorRed },
        { "OverlayDescriptorGreen", DC::OverlayDescriptorGreen },
        { "OverlayDescriptorBlue", DC::OverlayDescriptorBlue },
        { "OverlaysGray", DC::OverlaysGray },
        { "OverlaysRed", DC::OverlaysRed },
        { "OverlaysGreen", DC::OverlaysGreen },
        { "OverlaysBlue", DC::OverlaysBlue },
        { "ROIArea", DC::ROIArea },
        { "ROIMean", DC::ROIMean },
        { "ROIStandardDeviation", DC::ROIStandardDeviation },
        { "OverlayLabel", DC::OverlayLabel },
        { "OverlayData", DC::OverlayData },
        { "OverlayComments", DC::OverlayComments },
        { "OverlayRows2", DC::OverlayRows2 },
        { "OverlayColumns2", DC::OverlayColumns2 },
        { "OverlayPlanes2", DC::OverlayPlanes2 },
        { "NumberOfFramesInOverlay2", DC::NumberOfFramesInOverlay2 },
        { "OverlayDescription2", DC::OverlayDescription2 },
        { "OverlayType2", DC::OverlayType2 },
        { "OverlaySubtype2", DC::OverlaySubtype2 },
        { "OverlayOrigin2", DC::OverlayOrigin2 },
        { "ImageFrameOrigin2", DC::ImageFrameOrigin2 },
        { "OverlayPlaneOrigin2", DC::OverlayPlaneOrigin2 },
        { "OverlayCompressionCode2", DC::OverlayCompressionCode2 },
        { "OverlayCompressionOriginator2", DC::OverlayCompressionOriginator2 },
        { "OverlayCompressionLabel2", DC::OverlayCompressionLabel2 },
        { "OverlayCompressionDescription2", DC::OverlayCompressionDescription2 },
        { "OverlayCompressionStepPointers2", DC::OverlayCompressionStepPointers2 },
        { "OverlayRepeatInterval2", DC::OverlayRepeatInterval2 },
        { "OverlayBitsGrouped2", DC::OverlayBitsGrouped2 },
        { "OverlayBitsAllocated2", DC::OverlayBitsAllocated2 },
        { "OverlayBitPosition2", DC::OverlayBitPosition2 },
        { "OverlayFormat2", DC::OverlayFormat2 },
        { "OverlayLocation2", DC::OverlayLocation2 },
        { "OverlayCodeLabel2", DC::OverlayCodeLabel2 },
        { "OverlayNumberOfTables2", DC::OverlayNumberOfTables2 },
        { "OverlayCodeTableLocation2", DC::OverlayCodeTableLocation2 },
        { "OverlayBitsForCodeWord2", DC::OverlayBitsForCodeWord2 },
        { "OverlayActivationLayer2", DC::OverlayActivationLayer2 },
        { "OverlayDescriptorGray2", DC::OverlayDescriptorGray2 },
        { "OverlayDescriptorRed2", DC::OverlayDescriptorRed2 },
        { "OverlayDescriptorGreen2", DC::OverlayDescriptorGreen2 },
        { "OverlayDescriptorBlue2", DC::OverlayDescriptorBlue2 },
        { "OverlaysGray2", DC::OverlaysGray2 },
        { "OverlaysRed2", DC::OverlaysRed2 },
        { "OverlaysGreen2", DC::OverlaysGreen2 },
        { "OverlaysBlue2", DC::OverlaysBlue2 },
        { "ROIArea2", DC::ROIArea2 },
        { "ROIMean2", DC::ROIMean2 },
        { "ROIStandardDeviation2", DC::ROIStandardDeviation2 },
        { "OverlayLabel2", DC::OverlayLabel2 },
        { "OverlayData2", DC::OverlayData2 },
        { "OverlayComments2", DC::OverlayComments2 },
        { "OverlayRows3", DC::OverlayRows3 },
        { "OverlayColumns3", DC::OverlayColumns3 },
        { "OverlayPlanes3", DC::OverlayPlanes3 },
        { "NumberOfFramesInOverlay3", DC::NumberOfFramesInOverlay3 },
        { "OverlayDescription3", DC::OverlayDescription3 },
        { "OverlayType3", DC::OverlayType3 },
        { "OverlaySubtype3", DC::OverlaySubtype3 },
        { "OverlayOrigin3", DC::OverlayOrigin3 },
        { "ImageFrameOrigin3", DC::ImageFrameOrigin3 },
        { "OverlayPlaneOrigin3", DC::OverlayPlaneOrigin3 },
        { "OverlayCompressionCode3", DC::OverlayCompressionCode3 },
        { "OverlayCompressionOriginator3", DC::OverlayCompressionOriginator3 },
        { "OverlayCompressionLabel3", DC::OverlayCompressionLabel3 },
        { "OverlayCompressionDescription3", DC::OverlayCompressionDescription3 },
        { "OverlayCompressionStepPointers3", DC::OverlayCompressionStepPointers3 },
        { "OverlayRepeatInterval3", DC::OverlayRepeatInterval3 },
        { "OverlayBitsGrouped3", DC::OverlayBitsGrouped3 },
        { "OverlayBitsAllocated3", DC::OverlayBitsAllocated3 },
        { "OverlayBitPosition3", DC::OverlayBitPosition3 },
        { "OverlayFormat3", DC::OverlayFormat3 },
        { "OverlayLocation3", DC::OverlayLocation3 },
        { "OverlayCodeLabel3", DC::OverlayCodeLabel3 },
        { "OverlayNumberOfTables3", DC::OverlayNumberOfTables3 },
        { "OverlayCodeTableLocation3", DC::OverlayCodeTableLocation3 },
        { "OverlayBitsForCodeWord3", DC::OverlayBitsForCodeWord3 },
        { "OverlayActivationLayer3", DC::OverlayActivationLayer3 },
        { "OverlayDescriptorGray3", DC::OverlayDescriptorGray3 },
        { "OverlayDescriptorRed3", DC::OverlayDescriptorRed3 },
        { "OverlayDescriptorGreen3", DC::OverlayDescriptorGreen3 },
        { "OverlayDescriptorBlue3", DC::OverlayDescriptorBlue3 },
        { "OverlaysGray3", DC::OverlaysGray3 },
        { "OverlaysRed3", DC::OverlaysRed3 },
        { "OverlaysGreen3", DC::OverlaysGreen3 },
        { "OverlaysBlue3", DC::OverlaysBlue3 },
        { "ROIArea3", DC::ROIArea3 },
        { "ROIMean3", DC::ROIMean3 },
        { "ROIStandardDeviation3", DC::ROIStandardDeviation3 },
        { "OverlayLabel3", DC::OverlayLabel3 },
        { "OverlayData3", DC::OverlayData3 },
        { "OverlayComments3", DC::OverlayComments3 },
        { "OverlayRows4", DC::OverlayRows4 },
        { "OverlayColumns4", DC::OverlayColumns4 },
        { "OverlayPlanes4", DC::OverlayPlanes4 },
        { "NumberOfFramesInOverlay4", DC::NumberOfFramesInOverlay4 },
        { "OverlayDescription4", DC::OverlayDescription4 },
        { "OverlayType4", DC::OverlayType4 },
        { "OverlaySubtype4", DC::OverlaySubtype4 },
        { "OverlayOrigin4", DC::OverlayOrigin4 },
        { "ImageFrameOrigin4", DC::ImageFrameOrigin4 },
        { "OverlayPlaneOrigin4", DC::OverlayPlaneOrigin4 },
        { "OverlayCompressionCode4", DC::OverlayCompressionCode4 },
        { "OverlayCompressionOriginator4", DC::OverlayCompressionOriginator4 },
        { "OverlayCompressionLabel4", DC::OverlayCompressionLabel4 },
        { "OverlayCompressionDescription4", DC::OverlayCompressionDescription4 },
        { "OverlayCompressionStepPointers4", DC::OverlayCompressionStepPointers4 },
        { "OverlayRepeatInterval4", DC::OverlayRepeatInterval4 },
        { "OverlayBitsGrouped4", DC::OverlayBitsGrouped4 },
        { "OverlayBitsAllocated4", DC::OverlayBitsAllocated4 },
        { "OverlayBitPosition4", DC::OverlayBitPosition4 },
        { "OverlayFormat4", DC::OverlayFormat4 },
        { "OverlayLocation4", DC::OverlayLocation4 },
        { "OverlayCodeLabel4", DC::OverlayCodeLabel4 },
        { "OverlayNumberOfTables4", DC::OverlayNumberOfTables4 },
        { "OverlayCodeTableLocation4", DC::OverlayCodeTableLocation4 },
        { "OverlayBitsForCodeWord4", DC::OverlayBitsForCodeWord4 },
        { "OverlayActivationLayer4", DC::OverlayActivationLayer4 },
        { "OverlayDescriptorGray4", DC::OverlayDescriptorGray4 },
        { "OverlayDescriptorRed4", DC::OverlayDescriptorRed4 },
        { "OverlayDescriptorGreen4", DC::OverlayDescriptorGreen4 },
        { "OverlayDescriptorBlue4", DC::OverlayDescriptorBlue4 },
        { "OverlaysGray4", DC::OverlaysGray4 },
        { "OverlaysRed4", DC::OverlaysRed4 },
        { "OverlaysGreen4", DC::OverlaysGreen4 },
        { "OverlaysBlue4", DC::OverlaysBlue4 },
        { "ROIArea4", DC::ROIArea4 },
        { "ROIMean4", DC::ROIMean4 },
        { "ROIStandardDeviation4", DC::ROIStandardDeviation4 },
        { "OverlayLabel4", DC::OverlayLabel4 },
        { "OverlayData4", DC::OverlayData4 },
        { "OverlayComments4", DC::OverlayComments4 },
        { "OverlayRows5", DC::OverlayRows5 },
        { "OverlayColumns5", DC::OverlayColumns5 },
        { "OverlayPlanes5", DC::OverlayPlanes5 },
        { "NumberOfFramesInOverlay5", DC::NumberOfFramesInOverlay5 },
        { "OverlayDescription5", DC::OverlayDescription5 },
        { "OverlayType5", DC::OverlayType5 },
        { "OverlaySubtype5", DC::OverlaySubtype5 },
        { "OverlayOrigin5", DC::OverlayOrigin5 },
        { "ImageFrameOrigin5", DC::ImageFrameOrigin5 },
        { "OverlayPlaneOrigin5", DC::OverlayPlaneOrigin5 },
        { "OverlayCompressionCode5", DC::OverlayCompressionCode5 },
        { "OverlayCompressionOriginator5", DC::OverlayCompressionOriginator5 },
        { "OverlayCompressionLabel5", DC::OverlayCompressionLabel5 },
        { "OverlayCompressionDescription5", DC::OverlayCompressionDescription5 },
        { "OverlayCompressionStepPointers5", DC::OverlayCompressionStepPointers5 },
        { "OverlayRepeatInterval5", DC::OverlayRepeatInterval5 },
        { "OverlayBitsGrouped5", DC::OverlayBitsGrouped5 },
        { "OverlayBitsAllocated5", DC::OverlayBitsAllocated5 },
        { "OverlayBitPosition5", DC::OverlayBitPosition5 },
        { "OverlayFormat5", DC::OverlayFormat5 },
        { "OverlayLocation5", DC::OverlayLocation5 },
        { "OverlayCodeLabel5", DC::OverlayCodeLabel5 },
        { "OverlayNumberOfTables5", DC::OverlayNumberOfTables5 },
        { "OverlayCodeTableLocation5", DC::OverlayCodeTableLocation5 },
        { "OverlayBitsForCodeWord5", DC::OverlayBitsForCodeWord5 },
        { "OverlayActivationLayer5", DC::OverlayActivationLayer5 },
        { "OverlayDescriptorGray5", DC::OverlayDescriptorGray5 },
        { "OverlayDescriptorRed5", DC::OverlayDescriptorRed5 },
        { "OverlayDescriptorGreen5", DC::OverlayDescriptorGreen5 },
        { "OverlayDescriptorBlue5", DC::OverlayDescriptorBlue5 },
        { "OverlaysGray5", DC::OverlaysGray5 },
        { "OverlaysRed5", DC::OverlaysRed5 },
        { "OverlaysGreen5", DC::OverlaysGreen5 },
        { "OverlaysBlue5", DC::OverlaysBlue5 },
        { "ROIArea5", DC::ROIArea5 },
        { "ROIMean5", DC::ROIMean5 },
        { "ROIStandardDeviation5", DC::ROIStandardDeviation5 },
        { "OverlayLabel5", DC::OverlayLabel5 },
        { "OverlayData5", DC::OverlayData5 },
        { "OverlayComments5", DC::OverlayComments5 },
        { "OverlayRows6", DC::OverlayRows6 },
        { "OverlayColumns6", DC::OverlayColumns6 },
        { "OverlayPlanes6", DC::OverlayPlanes6 },
        { "NumberOfFramesInOverlay6", DC::NumberOfFramesInOverlay6 },
        { "OverlayDescription6", DC::OverlayDescription6 },
        { "OverlayType6", DC::OverlayType6 },
        { "OverlaySubtype6", DC::OverlaySubtype6 },
        { "OverlayOrigin6", DC::OverlayOrigin6 },
        { "ImageFrameOrigin6", DC::ImageFrameOrigin6 },
        { "OverlayPlaneOrigin6", DC::OverlayPlaneOrigin6 },
        { "OverlayCompressionCode6", DC::OverlayCompressionCode6 },
        { "OverlayCompressionOriginator6", DC::OverlayCompressionOriginator6 },
        { "OverlayCompressionLabel6", DC::OverlayCompressionLabel6 },
        { "OverlayCompressionDescription6", DC::OverlayCompressionDescription6 },
        { "OverlayCompressionStepPointers6", DC::OverlayCompressionStepPointers6 },
        { "OverlayRepeatInterval6", DC::OverlayRepeatInterval6 },
        { "OverlayBitsGrouped6", DC::OverlayBitsGrouped6 },
        { "OverlayBitsAllocated6", DC::OverlayBitsAllocated6 },
        { "OverlayBitPosition6", DC::OverlayBitPosition6 },
        { "OverlayFormat6", DC::OverlayFormat6 },
        { "OverlayLocation6", DC::OverlayLocation6 },
        { "OverlayCodeLabel6", DC::OverlayCodeLabel6 },
        { "OverlayNumberOfTables6", DC::OverlayNumberOfTables6 },
        { "OverlayCodeTableLocation6", DC::OverlayCodeTableLocation6 },
        { "OverlayBitsForCodeWord6", DC::OverlayBitsForCodeWord6 },
        { "OverlayActivationLayer6", DC::OverlayActivationLayer6 },
        { "OverlayDescriptorGray6", DC::OverlayDescriptorGray6 },
        { "OverlayDescriptorRed6", DC::OverlayDescriptorRed6 },
        { "OverlayDescriptorGreen6", DC::OverlayDescriptorGreen6 },
        { "OverlayDescriptorBlue6", DC::OverlayDescriptorBlue6 },
        { "OverlaysGray6", DC::OverlaysGray6 },
        { "OverlaysRed6", DC::OverlaysRed6 },
        { "OverlaysGreen6", DC::OverlaysGreen6 },
        { "OverlaysBlue6", DC::OverlaysBlue6 },
        { "ROIArea6", DC::ROIArea6 },
        { "ROIMean6", DC::ROIMean6 },
        { "ROIStandardDeviation6", DC::ROIStandardDeviation6 },
        { "OverlayLabel6", DC::OverlayLabel6 },
        { "OverlayData6", DC::OverlayData6 },
        { "OverlayComments6", DC::OverlayComments6 },
        { "OverlayRows7", DC::OverlayRows7 },
        { "OverlayColumns7", DC::OverlayColumns7 },
        { "OverlayPlanes7", DC::OverlayPlanes7 },
        { "NumberOfFramesInOverlay7", DC::NumberOfFramesInOverlay7 },
        { "OverlayDescription7", DC::OverlayDescription7 },
        { "OverlayType7", DC::OverlayType7 },
        { "OverlaySubtype7", DC::OverlaySubtype7 },
        { "OverlayOrigin7", DC::OverlayOrigin7 },
        { "ImageFrameOrigin7", DC::ImageFrameOrigin7 },
        { "OverlayPlaneOrigin7", DC::OverlayPlaneOrigin7 },
        { "OverlayCompressionCode7", DC::OverlayCompressionCode7 },
        { "OverlayCompressionOriginator7", DC::OverlayCompressionOriginator7 },
        { "OverlayCompressionLabel7", DC::OverlayCompressionLabel7 },
        { "OverlayCompressionDescription7", DC::OverlayCompressionDescription7 },
        { "OverlayCompressionStepPointers7", DC::OverlayCompressionStepPointers7 },
        { "OverlayRepeatInterval7", DC::OverlayRepeatInterval7 },
        { "OverlayBitsGrouped7", DC::OverlayBitsGrouped7 },
        { "OverlayBitsAllocated7", DC::OverlayBitsAllocated7 },
        { "OverlayBitPosition7", DC::OverlayBitPosition7 },
        { "OverlayFormat7", DC::OverlayFormat7 },
        { "OverlayLocation7", DC::OverlayLocation7 },
        { "OverlayCodeLabel7", DC::OverlayCodeLabel7 },
        { "OverlayNumberOfTables7", DC::OverlayNumberOfTables7 },
        { "OverlayCodeTableLocation7", DC::OverlayCodeTableLocation7 },
        { "OverlayBitsForCodeWord7", DC::OverlayBitsForCodeWord7 },
        { "OverlayActivationLayer7", DC::OverlayActivationLayer7 },
        { "OverlayDescriptorGray7", DC::OverlayDescriptorGray7 },
        { "OverlayDescriptorRed7", DC::OverlayDescriptorRed7 },
        { "OverlayDescriptorGreen7", DC::OverlayDescriptorGreen7 },
        { "OverlayDescriptorBlue7", DC::OverlayDescriptorBlue7 },
        { "OverlaysGray7", DC::OverlaysGray7 },
        { "OverlaysRed7", DC::OverlaysRed7 },
        { "OverlaysGreen7", DC::OverlaysGreen7 },
        { "OverlaysBlue7", DC::OverlaysBlue7 },
        { "ROIArea7", DC::ROIArea7 },
        { "ROIMean7", DC::ROIMean7 },
        { "ROIStandardDeviation7", DC::ROIStandardDeviation7 },
        { "OverlayLabel7", DC::OverlayLabel7 },
        { "OverlayData7", DC::OverlayData7 },
        { "OverlayComments7", DC::OverlayComments7 },
        { "OverlayRows8", DC::OverlayRows8 },
        { "OverlayColumns8", DC::OverlayColumns8 },
        { "OverlayPlanes8", DC::OverlayPlanes8 },
        { "NumberOfFramesInOverlay8", DC::NumberOfFramesInOverlay8 },
        { "OverlayDescription8", DC::OverlayDescription8 },
        { "OverlayType8", DC::OverlayType8 },
        { "OverlaySubtype8", DC::OverlaySubtype8 },
        { "OverlayOrigin8", DC::OverlayOrigin8 },
        { "ImageFrameOrigin8", DC::ImageFrameOrigin8 },
        { "OverlayPlaneOrigin8", DC::OverlayPlaneOrigin8 },
        { "OverlayCompressionCode8", DC::OverlayCompressionCode8 },
        { "OverlayCompressionOriginator8", DC::OverlayCompressionOriginator8 },
        { "OverlayCompressionLabel8", DC::OverlayCompressionLabel8 },
        { "OverlayCompressionDescription8", DC::OverlayCompressionDescription8 },
        { "OverlayCompressionStepPointers8", DC::OverlayCompressionStepPointers8 },
        { "OverlayRepeatInterval8", DC::OverlayRepeatInterval8 },
        { "OverlayBitsGrouped8", DC::OverlayBitsGrouped8 },
        { "OverlayBitsAllocated8", DC::OverlayBitsAllocated8 },
        { "OverlayBitPosition8", DC::OverlayBitPosition8 },
        { "OverlayFormat8", DC::OverlayFormat8 },
        { "OverlayLocation8", DC::OverlayLocation8 },
        { "OverlayCodeLabel8", DC::OverlayCodeLabel8 },
        { "OverlayNumberOfTables8", DC::OverlayNumberOfTables8 },
        { "OverlayCodeTableLocation8", DC::OverlayCodeTableLocation8 },
        { "OverlayBitsForCodeWord8", DC::OverlayBitsForCodeWord8 },
        { "OverlayActivationLayer8", DC::OverlayActivationLayer8 },
        { "OverlayDescriptorGray8", DC::OverlayDescriptorGray8 },
        { "OverlayDescriptorRed8", DC::OverlayDescriptorRed8 },
        { "OverlayDescriptorGreen8", DC::OverlayDescriptorGreen8 },
        { "OverlayDescriptorBlue8", DC::OverlayDescriptorBlue8 },
        { "OverlaysGray8", DC::OverlaysGray8 },
        { "OverlaysRed8", DC::OverlaysRed8 },
        { "OverlaysGreen8", DC::OverlaysGreen8 },
        { "OverlaysBlue8", DC::OverlaysBlue8 },
        { "ROIArea8", DC::ROIArea8 },
        { "ROIMean8", DC::ROIMean8 },
        { "ROIStandardDeviation8", DC::ROIStandardDeviation8 },
        { "OverlayLabel8", DC::OverlayLabel8 },
        { "OverlayData8", DC::OverlayData8 },
        { "OverlayComments8", DC::OverlayComments8 },
        { "OverlayRows9", DC::OverlayRows9 },
        { "OverlayColumns9", DC::OverlayColumns9 },
        { "OverlayPlanes9", DC::OverlayPlanes9 },
        { "NumberOfFramesInOverlay9", DC::NumberOfFramesInOverlay9 },
        { "OverlayDescription9", DC::OverlayDescription9 },
        { "OverlayType9", DC::OverlayType9 },
        { "OverlaySubtype9", DC::OverlaySubtype9 },
        { "OverlayOrigin9", DC::OverlayOrigin9 },
        { "ImageFrameOrigin9", DC::ImageFrameOrigin9 },
        { "OverlayPlaneOrigin9", DC::OverlayPlaneOrigin9 },
        { "OverlayCompressionCode9", DC::OverlayCompressionCode9 },
        { "OverlayCompressionOriginator9", DC::OverlayCompressionOriginator9 },
        { "OverlayCompressionLabel9", DC::OverlayCompressionLabel9 },
        { "OverlayCompressionDescription9", DC::OverlayCompressionDescription9 },
        { "OverlayCompressionStepPointers9", DC::OverlayCompressionStepPointers9 },
        { "OverlayRepeatInterval9", DC::OverlayRepeatInterval9 },
        { "OverlayBitsGrouped9", DC::OverlayBitsGrouped9 },
        { "OverlayBitsAllocated9", DC::OverlayBitsAllocated9 },
        { "OverlayBitPosition9", DC::OverlayBitPosition9 },
        { "OverlayFormat9", DC::OverlayFormat9 },
        { "OverlayLocation9", DC::OverlayLocation9 },
        { "OverlayCodeLabel9", DC::OverlayCodeLabel9 },
        { "OverlayNumberOfTables9", DC::OverlayNumberOfTables9 },
        { "OverlayCodeTableLocation9", DC::OverlayCodeTableLocation9 },
        { "OverlayBitsForCodeWord9", DC::OverlayBitsForCodeWord9 },
        { "OverlayActivationLayer9", DC::OverlayActivationLayer9 },
        { "OverlayDescriptorGray9", DC::OverlayDescriptorGray9 },
        { "OverlayDescriptorRed9", DC::OverlayDescriptorRed9 },
        { "OverlayDescriptorGreen9", DC::OverlayDescriptorGreen9 },
        { "OverlayDescriptorBlue9", DC::OverlayDescriptorBlue9 },
        { "OverlaysGray9", DC::OverlaysGray9 },
        { "OverlaysRed9", DC::OverlaysRed9 },
        { "OverlaysGreen9", DC::OverlaysGreen9 },
        { "OverlaysBlue9", DC::OverlaysBlue9 },
        { "ROIArea9", DC::ROIArea9 },
        { "ROIMean9", DC::ROIMean9 },
        { "ROIStandardDeviation9", DC::ROIStandardDeviation9 },
        { "OverlayLabel9", DC::OverlayLabel9 },
        { "OverlayData9", DC::OverlayData9 },
        { "OverlayComments9", DC::OverlayComments9 },
        { "OverlayRows10", DC::OverlayRows10 },
        { "OverlayColumns10", DC::OverlayColumns10 },
        { "OverlayPlanes10", DC::OverlayPlanes10 },
        { "NumberOfFramesInOverlay10", DC::NumberOfFramesInOverlay10 },
        { "OverlayDescription10", DC::OverlayDescription10 },
        { "OverlayType10", DC::OverlayType10 },
        { "OverlaySubtype10", DC::OverlaySubtype10 },
        { "OverlayOrigin10", DC::OverlayOrigin10 },
        { "ImageFrameOrigin10", DC::ImageFrameOrigin10 },
        { "OverlayPlaneOrigin10", DC::OverlayPlaneOrigin10 },
        { "OverlayCompressionCode10", DC::OverlayCompressionCode10 },
        { "OverlayCompressionOriginator10", DC::OverlayCompressionOriginator10 },
        { "OverlayCompressionLabel10", DC::OverlayCompressionLabel10 },
        { "OverlayCompressionDescription10", DC::OverlayCompressionDescription10 },
        { "OverlayCompressionStepPointers10", DC::OverlayCompressionStepPointers10 },
        { "OverlayRepeatInterval10", DC::OverlayRepeatInterval10 },
        { "OverlayBitsGrouped10", DC::OverlayBitsGrouped10 },
        { "OverlayBitsAllocated10", DC::OverlayBitsAllocated10 },
        { "OverlayBitPosition10", DC::OverlayBitPosition10 },
        { "OverlayFormat10", DC::OverlayFormat10 },
        { "OverlayLocation10", DC::OverlayLocation10 },
        { "OverlayCodeLabel10", DC::OverlayCodeLabel10 },
        { "OverlayNumberOfTables10", DC::OverlayNumberOfTables10 },
        { "OverlayCodeTableLocation10", DC::OverlayCodeTableLocation10 },
        { "OverlayBitsForCodeWord10", DC::OverlayBitsForCodeWord10 },
        { "OverlayActivationLayer10", DC::OverlayActivationLayer10 },
        { "OverlayDescriptorGray10", DC::OverlayDescriptorGray10 },
        { "OverlayDescriptorRed10", DC::OverlayDescriptorRed10 },
        { "OverlayDescriptorGreen10", DC::OverlayDescriptorGreen10 },
        { "OverlayDescriptorBlue10", DC::OverlayDescriptorBlue10 },
        { "OverlaysGray10", DC::OverlaysGray10 },
        { "OverlaysRed10", DC::OverlaysRed10 },
        { "OverlaysGreen10", DC::OverlaysGreen10 },
        { "OverlaysBlue10", DC::OverlaysBlue10 },
        { "ROIArea10", DC::ROIArea10 },
        { "ROIMean10", DC::ROIMean10 },
        { "ROIStandardDeviation10", DC::ROIStandardDeviation10 },
        { "OverlayLabel10", DC::OverlayLabel10 },
        { "OverlayData10", DC::OverlayData10 },
        { "OverlayComments10", DC::OverlayComments10 },
        { "OverlayRows11", DC::OverlayRows11 },
        { "OverlayColumns11", DC::OverlayColumns11 },
        { "OverlayPlanes11", DC::OverlayPlanes11 },
        { "NumberOfFramesInOverlay11", DC::NumberOfFramesInOverlay11 },
        { "OverlayDescription11", DC::OverlayDescription11 },
        { "OverlayType11", DC::OverlayType11 },
        { "OverlaySubtype11", DC::OverlaySubtype11 },
        { "OverlayOrigin11", DC::OverlayOrigin11 },
        { "ImageFrameOrigin11", DC::ImageFrameOrigin11 },
        { "OverlayPlaneOrigin11", DC::OverlayPlaneOrigin11 },
        { "OverlayCompressionCode11", DC::OverlayCompressionCode11 },
        { "OverlayCompressionOriginator11", DC::OverlayCompressionOriginator11 },
        { "OverlayCompressionLabel11", DC::OverlayCompressionLabel11 },
        { "OverlayCompressionDescription11", DC::OverlayCompressionDescription11 },
        { "OverlayCompressionStepPointers11", DC::OverlayCompressionStepPointers11 },
        { "OverlayRepeatInterval11", DC::OverlayRepeatInterval11 },
        { "OverlayBitsGrouped11", DC::OverlayBitsGrouped11 },
        { "OverlayBitsAllocated11", DC::OverlayBitsAllocated11 },
        { "OverlayBitPosition11", DC::OverlayBitPosition11 },
        { "OverlayFormat11", DC::OverlayFormat11 },
        { "OverlayLocation11", DC::OverlayLocation11 },
        { "OverlayCodeLabel11", DC::OverlayCodeLabel11 },
        { "OverlayNumberOfTables11", DC::OverlayNumberOfTables11 },
        { "OverlayCodeTableLocation11", DC::OverlayCodeTableLocation11 },
        { "OverlayBitsForCodeWord11", DC::OverlayBitsForCodeWord11 },
        { "OverlayActivationLayer11", DC::OverlayActivationLayer11 },
        { "OverlayDescriptorGray11", DC::OverlayDescriptorGray11 },
        { "OverlayDescriptorRed11", DC::OverlayDescriptorRed11 },
        { "OverlayDescriptorGreen11", DC::OverlayDescriptorGreen11 },
        { "OverlayDescriptorBlue11", DC::OverlayDescriptorBlue11 },
        { "OverlaysGray11", DC::OverlaysGray11 },
        { "OverlaysRed11", DC::OverlaysRed11 },
        { "OverlaysGreen11", DC::OverlaysGreen11 },
        { "OverlaysBlue11", DC::OverlaysBlue11 },
        { "ROIArea11", DC::ROIArea11 },
        { "ROIMean11", DC::ROIMean11 },
        { "ROIStandardDeviation11", DC::ROIStandardDeviation11 },
        { "OverlayLabel11", DC::OverlayLabel11 },
        { "OverlayData11", DC::OverlayData11 },
        { "OverlayComments11", DC::OverlayComments11 },
        { "OverlayRows12", DC::OverlayRows12 },
        { "OverlayColumns12", DC::OverlayColumns12 },
        { "OverlayPlanes12", DC::OverlayPlanes12 },
        { "NumberOfFramesInOverlay12", DC::NumberOfFramesInOverlay12 },
        { "OverlayDescription12", DC::OverlayDescription12 },
        { "OverlayType12", DC::OverlayType12 },
        { "OverlaySubtype12", DC::OverlaySubtype12 },
        { "OverlayOrigin12", DC::OverlayOrigin12 },
        { "ImageFrameOrigin12", DC::ImageFrameOrigin12 },
        { "OverlayPlaneOrigin12", DC::OverlayPlaneOrigin12 },
        { "OverlayCompressionCode12", DC::OverlayCompressionCode12 },
        { "OverlayCompressionOriginator12", DC::OverlayCompressionOriginator12 },
        { "OverlayCompressionLabel12", DC::OverlayCompressionLabel12 },
        { "OverlayCompressionDescription12", DC::OverlayCompressionDescription12 },
        { "OverlayCompressionStepPointers12", DC::OverlayCompressionStepPointers12 },
        { "OverlayRepeatInterval12", DC::OverlayRepeatInterval12 },
        { "OverlayBitsGrouped12", DC::OverlayBitsGrouped12 },
        { "OverlayBitsAllocated12", DC::OverlayBitsAllocated12 },
        { "OverlayBitPosition12", DC::OverlayBitPosition12 },
        { "OverlayFormat12", DC::OverlayFormat12 },
        { "OverlayLocation12", DC::OverlayLocation12 },
        { "OverlayCodeLabel12", DC::OverlayCodeLabel12 },
        { "OverlayNumberOfTables12", DC::OverlayNumberOfTables12 },
        { "OverlayCodeTableLocation12", DC::OverlayCodeTableLocation12 },
        { "OverlayBitsForCodeWord12", DC::OverlayBitsForCodeWord12 },
        { "OverlayActivationLayer12", DC::OverlayActivationLayer12 },
        { "OverlayDescriptorGray12", DC::OverlayDescriptorGray12 },
        { "OverlayDescriptorRed12", DC::OverlayDescriptorRed12 },
        { "OverlayDescriptorGreen12", DC::OverlayDescriptorGreen12 },
        { "OverlayDescriptorBlue12", DC::OverlayDescriptorBlue12 },
        { "OverlaysGray12", DC::OverlaysGray12 },
        { "OverlaysRed12", DC::OverlaysRed12 },
        { "OverlaysGreen12", DC::OverlaysGreen12 },
        { "OverlaysBlue12", DC::OverlaysBlue12 },
        { "ROIArea12", DC::ROIArea12 },
        { "ROIMean12", DC::ROIMean12 },
        { "ROIStandardDeviation12", DC::ROIStandardDeviation12 },
        { "OverlayLabel12", DC::OverlayLabel12 },
        { "OverlayData12", DC::OverlayData12 },
        { "OverlayComments12", DC::OverlayComments12 },
        { "OverlayRows13", DC::OverlayRows13 },
        { "OverlayColumns13", DC::OverlayColumns13 },
        { "OverlayPlanes13", DC::OverlayPlanes13 },
        { "NumberOfFramesInOverlay13", DC::NumberOfFramesInOverlay13 },
        { "OverlayDescription13", DC::OverlayDescription13 },
        { "OverlayType13", DC::OverlayType13 },
        { "OverlaySubtype13", DC::OverlaySubtype13 },
        { "OverlayOrigin13", DC::OverlayOrigin13 },
        { "ImageFrameOrigin13", DC::ImageFrameOrigin13 },
        { "OverlayPlaneOrigin13", DC::OverlayPlaneOrigin13 },
        { "OverlayCompressionCode13", DC::OverlayCompressionCode13 },
        { "OverlayCompressionOriginator13", DC::OverlayCompressionOriginator13 },
        { "OverlayCompressionLabel13", DC::OverlayCompressionLabel13 },
        { "OverlayCompressionDescription13", DC::OverlayCompressionDescription13 },
        { "OverlayCompressionStepPointers13", DC::OverlayCompressionStepPointers13 },
        { "OverlayRepeatInterval13", DC::OverlayRepeatInterval13 },
        { "OverlayBitsGrouped13", DC::OverlayBitsGrouped13 },
        { "OverlayBitsAllocated13", DC::OverlayBitsAllocated13 },
        { "OverlayBitPosition13", DC::OverlayBitPosition13 },
        { "OverlayFormat13", DC::OverlayFormat13 },
        { "OverlayLocation13", DC::OverlayLocation13 },
        { "OverlayCodeLabel13", DC::OverlayCodeLabel13 },
        { "OverlayNumberOfTables13", DC::OverlayNumberOfTables13 },
        { "OverlayCodeTableLocation13", DC::OverlayCodeTableLocation13 },
        { "OverlayBitsForCodeWord13", DC::OverlayBitsForCodeWord13 },
        { "OverlayActivationLayer13", DC::OverlayActivationLayer13 },
        { "OverlayDescriptorGray13", DC::OverlayDescriptorGray13 },
        { "OverlayDescriptorRed13", DC::OverlayDescriptorRed13 },
        { "OverlayDescriptorGreen13", DC::OverlayDescriptorGreen13 },
        { "OverlayDescriptorBlue13", DC::OverlayDescriptorBlue13 },
        { "OverlaysGray13", DC::OverlaysGray13 },
        { "OverlaysRed13", DC::OverlaysRed13 },
        { "OverlaysGreen13", DC::OverlaysGreen13 },
        { "OverlaysBlue13", DC::OverlaysBlue13 },
        { "ROIArea13", DC::ROIArea13 },
        { "ROIMean13", DC::ROIMean13 },
        { "ROIStandardDeviation13", DC::ROIStandardDeviation13 },
        { "OverlayLabel13", DC::OverlayLabel13 },
        { "OverlayData13", DC::OverlayData13 },
        { "OverlayComments13", DC::OverlayComments13 },
        { "OverlayRows14", DC::OverlayRows14 },
        { "OverlayColumns14", DC::OverlayColumns14 },
        { "OverlayPlanes14", DC::OverlayPlanes14 },
        { "NumberOfFramesInOverlay14", DC::NumberOfFramesInOverlay14 },
        { "OverlayDescription14", DC::OverlayDescription14 },
        { "OverlayType14", DC::OverlayType14 },
        { "OverlaySubtype14", DC::OverlaySubtype14 },
        { "OverlayOrigin14", DC::OverlayOrigin14 },
        { "ImageFrameOrigin14", DC::ImageFrameOrigin14 },
        { "OverlayPlaneOrigin14", DC::OverlayPlaneOrigin14 },
        { "OverlayCompressionCode14", DC::OverlayCompressionCode14 },
        { "OverlayCompressionOriginator14", DC::OverlayCompressionOriginator14 },
        { "OverlayCompressionLabel14", DC::OverlayCompressionLabel14 },
        { "OverlayCompressionDescription14", DC::OverlayCompressionDescription14 },
        { "OverlayCompressionStepPointers14", DC::OverlayCompressionStepPointers14 },
        { "OverlayRepeatInterval14", DC::OverlayRepeatInterval14 },
        { "OverlayBitsGrouped14", DC::OverlayBitsGrouped14 },
        { "OverlayBitsAllocated14", DC::OverlayBitsAllocated14 },
        { "OverlayBitPosition14", DC::OverlayBitPosition14 },
        { "OverlayFormat14", DC::OverlayFormat14 },
        { "OverlayLocation14", DC::OverlayLocation14 },
        { "OverlayCodeLabel14", DC::OverlayCodeLabel14 },
        { "OverlayNumberOfTables14", DC::OverlayNumberOfTables14 },
        { "OverlayCodeTableLocation14", DC::OverlayCodeTableLocation14 },
        { "OverlayBitsForCodeWord14", DC::OverlayBitsForCodeWord14 },
        { "OverlayActivationLayer14", DC::OverlayActivationLayer14 },
        { "OverlayDescriptorGray14", DC::OverlayDescriptorGray14 },
        { "OverlayDescriptorRed14", DC::OverlayDescriptorRed14 },
        { "OverlayDescriptorGreen14", DC::OverlayDescriptorGreen14 },
        { "OverlayDescriptorBlue14", DC::OverlayDescriptorBlue14 },
        { "OverlaysGray14", DC::OverlaysGray14 },
        { "OverlaysRed14", DC::OverlaysRed14 },
        { "OverlaysGreen14", DC::OverlaysGreen14 },
        { "OverlaysBlue14", DC::OverlaysBlue14 },
        { "ROIArea14", DC::ROIArea14 },
        { "ROIMean14", DC::ROIMean14 },
        { "ROIStandardDeviation14", DC::ROIStandardDeviation14 },
        { "OverlayLabel14", DC::OverlayLabel14 },
        { "OverlayData14", DC::OverlayData14 },
        { "OverlayComments14", DC::OverlayComments14 },
        { "OverlayRows15", DC::OverlayRows15 },
        { "OverlayColumns15", DC::OverlayColumns15 },
        { "OverlayPlanes15", DC::OverlayPlanes15 },
        { "NumberOfFramesInOverlay15", DC::NumberOfFramesInOverlay15 },
        { "OverlayDescription15", DC::OverlayDescription15 },
        { "OverlayType15", DC::OverlayType15 },
        { "OverlaySubtype15", DC::OverlaySubtype15 },
        { "OverlayOrigin15", DC::OverlayOrigin15 },
        { "ImageFrameOrigin15", DC::ImageFrameOrigin15 },
        { "OverlayPlaneOrigin15", DC::OverlayPlaneOrigin15 },
        { "OverlayCompressionCode15", DC::OverlayCompressionCode15 },
        { "OverlayCompressionOriginator15", DC::OverlayCompressionOriginator15 },
        { "OverlayCompressionLabel15", DC::OverlayCompressionLabel15 },
        { "OverlayCompressionDescription15", DC::OverlayCompressionDescription15 },
        { "OverlayCompressionStepPointers15", DC::OverlayCompressionStepPointers15 },
        { "OverlayRepeatInterval15", DC::OverlayRepeatInterval15 },
        { "OverlayBitsGrouped15", DC::OverlayBitsGrouped15 },
        { "OverlayBitsAllocated15", DC::OverlayBitsAllocated15 },
        { "OverlayBitPosition15", DC::OverlayBitPosition15 },
        { "OverlayFormat15", DC::OverlayFormat15 },
        { "OverlayLocation15", DC::OverlayLocation15 },
        { "OverlayCodeLabel15", DC::OverlayCodeLabel15 },
        { "OverlayNumberOfTables15", DC::OverlayNumberOfTables15 },
        { "OverlayCodeTableLocation15", DC::OverlayCodeTableLocation15 },
        { "OverlayBitsForCodeWord15", DC::OverlayBitsForCodeWord15 },
        { "OverlayActivationLayer15", DC::OverlayActivationLayer15 },
        { "OverlayDescriptorGray15", DC::OverlayDescriptorGray15 },
        { "OverlayDescriptorRed15", DC::OverlayDescriptorRed15 },
        { "OverlayDescriptorGreen15", DC::OverlayDescriptorGreen15 },
        { "OverlayDescriptorBlue15", DC::OverlayDescriptorBlue15 },
        { "OverlaysGray15", DC::OverlaysGray15 },
        { "OverlaysRed15", DC::OverlaysRed15 },
        { "OverlaysGreen15", DC::OverlaysGreen15 },
        { "OverlaysBlue15", DC::OverlaysBlue15 },
        { "ROIArea15", DC::ROIArea15 },
        { "ROIMean15", DC::ROIMean15 },
        { "ROIStandardDeviation15", DC::ROIStandardDeviation15 },
        { "OverlayLabel15", DC::OverlayLabel15 },
        { "OverlayData15", DC::OverlayData15 },
        { "OverlayComments15", DC::OverlayComments15 },
        { "OverlayRows16", DC::OverlayRows16 },
        { "OverlayColumns16", DC::OverlayColumns16 },
        { "OverlayPlanes16", DC::OverlayPlanes16 },
        { "NumberOfFramesInOverlay16", DC::NumberOfFramesInOverlay16 },
        { "OverlayDescription16", DC::OverlayDescription16 },
        { "OverlayType16", DC::OverlayType16 },
        { "OverlaySubtype16", DC::OverlaySubtype16 },
        { "OverlayOrigin16", DC::OverlayOrigin16 },
        { "ImageFrameOrigin16", DC::ImageFrameOrigin16 },
        { "OverlayPlaneOrigin16", DC::OverlayPlaneOrigin16 },
        { "OverlayCompressionCode16", DC::OverlayCompressionCode16 },
        { "OverlayCompressionOriginator16", DC::OverlayCompressionOriginator16 },
        { "OverlayCompressionLabel16", DC::OverlayCompressionLabel16 },
        { "OverlayCompressionDescription16", DC::OverlayCompressionDescription16 },
        { "OverlayCompressionStepPointers16", DC::OverlayCompressionStepPointers16 },
        { "OverlayRepeatInterval16", DC::OverlayRepeatInterval16 },
        { "OverlayBitsGrouped16", DC::OverlayBitsGrouped16 },
        { "OverlayBitsAllocated16", DC::OverlayBitsAllocated16 },
        { "OverlayBitPosition16", DC::OverlayBitPosition16 },
        { "OverlayFormat16", DC::OverlayFormat16 },
        { "OverlayLocation16", DC::OverlayLocation16 },
        { "OverlayCodeLabel16", DC::OverlayCodeLabel16 },
        { "OverlayNumberOfTables16", DC::OverlayNumberOfTables16 },
        { "OverlayCodeTableLocation16", DC::OverlayCodeTableLocation16 },
        { "OverlayBitsForCodeWord16", DC::OverlayBitsForCodeWord16 },
        { "OverlayActivationLayer16", DC::OverlayActivationLayer16 },
        { "OverlayDescriptorGray16", DC::OverlayDescriptorGray16 },
        { "OverlayDescriptorRed16", DC::OverlayDescriptorRed16 },
        { "OverlayDescriptorGreen16", DC::OverlayDescriptorGreen16 },
        { "OverlayDescriptorBlue16", DC::OverlayDescriptorBlue16 },
        { "OverlaysGray16", DC::OverlaysGray16 },
        { "OverlaysRed16", DC::OverlaysRed16 },
        { "OverlaysGreen16", DC::OverlaysGreen16 },
        { "OverlaysBlue16", DC::OverlaysBlue16 },
        { "ROIArea16", DC::ROIArea16 },
        { "ROIMean16", DC::ROIMean16 },
        { "ROIStandardDeviation16", DC::ROIStandardDeviation16 },
        { "OverlayLabel16", DC::OverlayLabel16 },
        { "OverlayData16", DC::OverlayData16 },
        { "OverlayComments16", DC::OverlayComments16 },
        { "ExtendedOffsetTable", DC::ExtendedOffsetTable },
        { "ExtendedOffsetTableLengths", DC::ExtendedOffsetTableLengths },
        { "EncapsulatedPixelDataValueTotalLength", DC::EncapsulatedPixelDataValueTotalLength },
        { "FloatPixelData", DC::FloatPixelData },
        { "DoubleFloatPixelData", DC::DoubleFloatPixelData },
        { "PixelData", DC::PixelData },
        { "CoefficientsSDVN", DC::CoefficientsSDVN },
        { "CoefficientsSDHN", DC::CoefficientsSDHN },
        { "CoefficientsSDDN", DC::CoefficientsSDDN },
        { "VariablePixelData", DC::VariablePixelData },
        { "VariableNextDataGroup", DC::VariableNextDataGroup },
        { "VariableCoefficientsSDVN", DC::VariableCoefficientsSDVN },
        { "VariableCoefficientsSDHN", DC::VariableCoefficientsSDHN },
        { "VariableCoefficientsSDDN", DC::VariableCoefficientsSDDN },
        { "DigitalSignaturesSequence", DC::DigitalSignaturesSequence },
        { "DataSetTrailingPadding", DC::DataSetTrailingPadding },
        { "Item", DC::Item },
        { "ItemDelimitationItem", DC::ItemDelimitationItem },
        { "SequenceDelimitationItem", DC::SequenceDelimitationItem },
      };

    o = PyDC_EnumType_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  return m;
}

void PyVTKAddFile_vtkDICOMDictHash(
  PyObject *dict)
{
  PyObject *o;
  o = PyVTKNamespace_DC();
  if (o && PyDict_SetItemString(dict, "DC", o) != 0)
  {
    Py_DECREF(o);
  }

}

